/*

  OpenLayers.js -- OpenLayers Map Viewer Library

  Copyright 2005-2011 OpenLayers Contributors, released under the FreeBSD
  license. Please see http://svn.openlayers.org/trunk/openlayers/license.txt
  for the full text of the license.

  Includes compressed code under the following licenses:

  (For uncompressed versions of the code used please see the
  OpenLayers SVN repository: <http://openlayers.org/>)

*/

/* Contains portions of Prototype.js:
 *
 * Prototype JavaScript framework, version 1.4.0
 *  (c) 2005 Sam Stephenson <sam@conio.net>
 *
 *  Prototype is freely distributable under the terms of an MIT-style license.
 *  For details, see the Prototype web site: http://prototype.conio.net/
 *
 *--------------------------------------------------------------------------*/

/**  
*  
*  Contains portions of Rico <http://openrico.org/>
* 
*  Copyright 2005 Sabre Airline Solutions  
*  
*  Licensed under the Apache License, Version 2.0 (the "License"); you
*  may not use this file except in compliance with the License. You
*  may obtain a copy of the License at
*  
*         http://www.apache.org/licenses/LICENSE-2.0  
*  
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
*  implied. See the License for the specific language governing
*  permissions and limitations under the License. 
*
**/

/**
 * Contains XMLHttpRequest.js <http://code.google.com/p/xmlhttprequest/>
 * Copyright 2007 Sergey Ilinsky (http://www.ilinsky.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 */

/**
 * Contains portions of Gears <http://code.google.com/apis/gears/>
 *
 * Copyright 2007, Google Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *  3. Neither the name of Google Inc. nor the names of its contributors may be
 *     used to endorse or promote products derived from this software without
 *     specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Sets up google.gears.*, which is *the only* supported way to access Gears.
 *
 * Circumvent this file at your own risk!
 *
 * In the future, Gears may automatically define google.gears.* without this
 * file. Gears may use these objects to transparently fix bugs and compatibility
 * issues. Applications that use the code below will continue to work seamlessly
 * when that happens.
 */

/**
 * OpenLayers.Util.pagePosition is based on Yahoo's getXY method, which is
 * Copyright (c) 2006, Yahoo! Inc.
 * All rights reserved.
 * 
 * Redistribution and use of this software in source and binary forms, with or
 * without modification, are permitted provided that the following conditions
 * are met:
 * 
 * * Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * 
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * 
 * * Neither the name of Yahoo! Inc. nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission of Yahoo! Inc.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 */(function(){if(window.google&&google.gears){return}var a=null;if(typeof GearsFactory!="undefined"){a=new GearsFactory()}else{try{a=new ActiveXObject("Gears.Factory");if(a.getBuildInfo().indexOf("ie_mobile")!=-1){a.privateSetGlobalObject(this)}}catch(b){if((typeof navigator.mimeTypes!="undefined")&&navigator.mimeTypes["application/x-googlegears"]){a=document.createElement("object");a.style.display="none";a.width=0;a.height=0;a.type="application/x-googlegears";document.documentElement.appendChild(a)}}}if(!a){return}if(!window.google){google={}}if(!google.gears){google.gears={factory:a}}})();var OpenLayers={VERSION_NUMBER:"Release 2.11",singleFile:true,_getScriptLocation:(function(){var f=new RegExp("(^|(.*?\\/))(OpenLayers.js)(\\?|$)"),e=document.getElementsByTagName("script"),g,b,c="";for(var d=0,a=e.length;d<a;d++){g=e[d].getAttribute("src");if(g){var b=g.match(f);if(b){c=b[1];break}}}return(function(){return c})})()};OpenLayers.Class=function(){var a=arguments.length;var d=arguments[0];var c=arguments[a-1];var e=typeof c.initialize=="function"?c.initialize:function(){d.prototype.initialize.apply(this,arguments)};if(a>1){var b=[e,d].concat(Array.prototype.slice.call(arguments).slice(1,a-1),c);OpenLayers.inherit.apply(null,b)}else{e.prototype=c}return e};OpenLayers.Class.isPrototype=function(){};OpenLayers.Class.create=function(){return function(){if(arguments&&arguments[0]!=OpenLayers.Class.isPrototype){this.initialize.apply(this,arguments)}}};OpenLayers.Class.inherit=function(b){var c=function(){b.call(this)};var a=[c].concat(Array.prototype.slice.call(arguments));OpenLayers.inherit.apply(null,a);return c.prototype};OpenLayers.inherit=function(f,d){var c=function(){};c.prototype=d.prototype;f.prototype=new c;var b,a,e;for(b=2,a=arguments.length;b<a;b++){e=arguments[b];if(typeof e==="function"){e=e.prototype}OpenLayers.Util.extend(f.prototype,e)}};OpenLayers.Util=OpenLayers.Util||{};OpenLayers.Util.extend=function(a,e){a=a||{};if(e){for(var d in e){var c=e[d];if(c!==undefined){a[d]=c}}var b=typeof window.Event=="function"&&e instanceof window.Event;if(!b&&e.hasOwnProperty&&e.hasOwnProperty("toString")){a.toString=e.toString}}return a};OpenLayers.Protocol=OpenLayers.Class({format:null,options:null,autoDestroy:true,defaultFilter:null,initialize:function(a){a=a||{};OpenLayers.Util.extend(this,a);this.options=a},mergeWithDefaultFilter:function(b){var a;if(b&&this.defaultFilter){a=new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.AND,filters:[this.defaultFilter,b]})}else{a=b||this.defaultFilter||undefined}return a},destroy:function(){this.options=null;this.format=null},read:function(a){a=a||{};a.filter=this.mergeWithDefaultFilter(a.filter)},create:function(){},update:function(){},"delete":function(){},commit:function(){},abort:function(a){},createCallback:function(c,a,b){return OpenLayers.Function.bind(function(){c.apply(this,[a,b])},this)},CLASS_NAME:"OpenLayers.Protocol"});OpenLayers.Protocol.Response=OpenLayers.Class({code:null,requestType:null,last:true,features:null,reqFeatures:null,priv:null,error:null,initialize:function(a){OpenLayers.Util.extend(this,a)},success:function(){return this.code>0},CLASS_NAME:"OpenLayers.Protocol.Response"});OpenLayers.Protocol.Response.SUCCESS=1;OpenLayers.Protocol.Response.FAILURE=0;OpenLayers.Protocol.SQL=OpenLayers.Class(OpenLayers.Protocol,{databaseName:"ol",tableName:"ol_vector_features",postReadFiltering:true,initialize:function(a){OpenLayers.Protocol.prototype.initialize.apply(this,[a])},destroy:function(){OpenLayers.Protocol.prototype.destroy.apply(this)},supported:function(){return false},evaluateFilter:function(a,b){return b&&this.postReadFiltering?b.evaluate(a):true},CLASS_NAME:"OpenLayers.Protocol.SQL"});OpenLayers.Console={log:function(){},debug:function(){},info:function(){},warn:function(){},error:function(){},userError:function(a){alert(a)},assert:function(){},dir:function(){},dirxml:function(){},trace:function(){},group:function(){},groupEnd:function(){},time:function(){},timeEnd:function(){},profile:function(){},profileEnd:function(){},count:function(){},CLASS_NAME:"OpenLayers.Console"};(function(){var b=document.getElementsByTagName("script");for(var c=0,a=b.length;c<a;++c){if(b[c].src.indexOf("firebug.js")!=-1){if(console){OpenLayers.Util.extend(OpenLayers.Console,console);break}}}})();OpenLayers.Lang={code:null,defaultCode:"en",getCode:function(){if(!OpenLayers.Lang.code){OpenLayers.Lang.setCode()}return OpenLayers.Lang.code},setCode:function(b){var d;if(!b){b=(OpenLayers.BROWSER_NAME=="msie")?navigator.userLanguage:navigator.language}var c=b.split("-");c[0]=c[0].toLowerCase();if(typeof OpenLayers.Lang[c[0]]=="object"){d=c[0]}if(c[1]){var a=c[0]+"-"+c[1].toUpperCase();if(typeof OpenLayers.Lang[a]=="object"){d=a}}if(!d){OpenLayers.Console.warn("Failed to find OpenLayers.Lang."+c.join("-")+" dictionary, falling back to default language");d=OpenLayers.Lang.defaultCode}OpenLayers.Lang.code=d},translate:function(b,a){var d=OpenLayers.Lang[OpenLayers.Lang.getCode()];var c=d&&d[b];if(!c){c=b}if(a){c=OpenLayers.String.format(c,a)}return c}};OpenLayers.i18n=OpenLayers.Lang.translate;OpenLayers.String={startsWith:function(b,a){return(b.indexOf(a)==0)},contains:function(b,a){return(b.indexOf(a)!=-1)},trim:function(a){return a.replace(/^\s\s*/,"").replace(/\s\s*$/,"")},camelize:function(f){var d=f.split("-");var b=d[0];for(var c=1,a=d.length;c<a;c++){var e=d[c];b+=e.charAt(0).toUpperCase()+e.substring(1)}return b},format:function(d,c,a){if(!c){c=window}var b=function(j,e){var h;var g=e.split(/\.+/);for(var f=0;f<g.length;f++){if(f==0){h=c}h=h[g[f]]}if(typeof h=="function"){h=a?h.apply(null,a):h()}if(typeof h=="undefined"){return"undefined"}else{return h}};return d.replace(OpenLayers.String.tokenRegEx,b)},tokenRegEx:/\$\{([\w.]+?)\}/g,numberRegEx:/^([+-]?)(?=\d|\.\d)\d*(\.\d*)?([Ee]([+-]?\d+))?$/,isNumeric:function(a){return OpenLayers.String.numberRegEx.test(a)},numericIf:function(a){return OpenLayers.String.isNumeric(a)?parseFloat(a):a}};if(!String.prototype.startsWith){String.prototype.startsWith=function(a){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.String.startsWith"}));return OpenLayers.String.startsWith(this,a)}}if(!String.prototype.contains){String.prototype.contains=function(a){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.String.contains"}));return OpenLayers.String.contains(this,a)}}if(!String.prototype.trim){String.prototype.trim=function(){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.String.trim"}));return OpenLayers.String.trim(this)}}if(!String.prototype.camelize){String.prototype.camelize=function(){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.String.camelize"}));return OpenLayers.String.camelize(this)}}OpenLayers.Number={decimalSeparator:".",thousandsSeparator:",",limitSigDigs:function(a,c){var b=0;if(c>0){b=parseFloat(a.toPrecision(c))}return b},format:function(c,a,g,i){a=(typeof a!="undefined")?a:0;g=(typeof g!="undefined")?g:OpenLayers.Number.thousandsSeparator;i=(typeof i!="undefined")?i:OpenLayers.Number.decimalSeparator;if(a!=null){c=parseFloat(c.toFixed(a))}var b=c.toString().split(".");if(b.length==1&&a==null){a=0}var d=b[0];if(g){var e=/(-?[0-9]+)([0-9]{3})/;while(e.test(d)){d=d.replace(e,"$1"+g+"$2")}}var f;if(a==0){f=d}else{var h=b.length>1?b[1]:"0";if(a!=null){h=h+new Array(a-h.length+1).join("0")}f=d+i+h}return f}};if(!Number.prototype.limitSigDigs){Number.prototype.limitSigDigs=function(a){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.Number.limitSigDigs"}));return OpenLayers.Number.limitSigDigs(this,a)}}OpenLayers.Function={bind:function(c,b){var a=Array.prototype.slice.apply(arguments,[2]);return function(){var d=a.concat(Array.prototype.slice.apply(arguments,[0]));return c.apply(b,d)}},bindAsEventListener:function(b,a){return function(c){return b.call(a,c||window.event)}},False:function(){return false},True:function(){return true},Void:function(){}};if(!Function.prototype.bind){Function.prototype.bind=function(){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.Function.bind"}));Array.prototype.unshift.apply(arguments,[this]);return OpenLayers.Function.bind.apply(null,arguments)}}if(!Function.prototype.bindAsEventListener){Function.prototype.bindAsEventListener=function(a){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.Function.bindAsEventListener"}));return OpenLayers.Function.bindAsEventListener(this,a)}}OpenLayers.Array={filter:function(g,f,b){var d=[];if(Array.prototype.filter){d=g.filter(f,b)}else{var a=g.length;if(typeof f!="function"){throw new TypeError()}for(var c=0;c<a;c++){if(c in g){var e=g[c];if(f.call(b,e,c,g)){d.push(e)}}}}return d}};OpenLayers.Bounds=OpenLayers.Class({left:null,bottom:null,right:null,top:null,centerLonLat:null,initialize:function(d,a,b,c){if(d!=null){this.left=OpenLayers.Util.toFloat(d)}if(a!=null){this.bottom=OpenLayers.Util.toFloat(a)}if(b!=null){this.right=OpenLayers.Util.toFloat(b)}if(c!=null){this.top=OpenLayers.Util.toFloat(c)}},clone:function(){return new OpenLayers.Bounds(this.left,this.bottom,this.right,this.top)},equals:function(b){var a=false;if(b!=null){a=((this.left==b.left)&&(this.right==b.right)&&(this.top==b.top)&&(this.bottom==b.bottom))}return a},toString:function(){return[this.left,this.bottom,this.right,this.top].join(",")},toArray:function(a){if(a===true){return[this.bottom,this.left,this.top,this.right]}else{return[this.left,this.bottom,this.right,this.top]}},toBBOX:function(b,e){if(b==null){b=6}var g=Math.pow(10,b);var f=Math.round(this.left*g)/g;var d=Math.round(this.bottom*g)/g;var c=Math.round(this.right*g)/g;var a=Math.round(this.top*g)/g;if(e===true){return d+","+f+","+a+","+c}else{return f+","+d+","+c+","+a}},toGeometry:function(){return new OpenLayers.Geometry.Polygon([new OpenLayers.Geometry.LinearRing([new OpenLayers.Geometry.Point(this.left,this.bottom),new OpenLayers.Geometry.Point(this.right,this.bottom),new OpenLayers.Geometry.Point(this.right,this.top),new OpenLayers.Geometry.Point(this.left,this.top)])])},getWidth:function(){return(this.right-this.left)},getHeight:function(){return(this.top-this.bottom)},getSize:function(){return new OpenLayers.Size(this.getWidth(),this.getHeight())},getCenterPixel:function(){return new OpenLayers.Pixel((this.left+this.right)/2,(this.bottom+this.top)/2)},getCenterLonLat:function(){if(!this.centerLonLat){this.centerLonLat=new OpenLayers.LonLat((this.left+this.right)/2,(this.bottom+this.top)/2)}return this.centerLonLat},scale:function(e,c){if(c==null){c=this.getCenterLonLat()}var a,h;if(c.CLASS_NAME=="OpenLayers.LonLat"){a=c.lon;h=c.lat}else{a=c.x;h=c.y}var g=(this.left-a)*e+a;var b=(this.bottom-h)*e+h;var d=(this.right-a)*e+a;var f=(this.top-h)*e+h;return new OpenLayers.Bounds(g,b,d,f)},add:function(a,c){if((a==null)||(c==null)){var b=OpenLayers.i18n("boundsAddError");OpenLayers.Console.error(b);return null}return new OpenLayers.Bounds(this.left+a,this.bottom+c,this.right+a,this.top+c)},extend:function(a){var b=null;if(a){switch(a.CLASS_NAME){case"OpenLayers.LonLat":b=new OpenLayers.Bounds(a.lon,a.lat,a.lon,a.lat);break;case"OpenLayers.Geometry.Point":b=new OpenLayers.Bounds(a.x,a.y,a.x,a.y);break;case"OpenLayers.Bounds":b=a;break}if(b){this.centerLonLat=null;if((this.left==null)||(b.left<this.left)){this.left=b.left}if((this.bottom==null)||(b.bottom<this.bottom)){this.bottom=b.bottom}if((this.right==null)||(b.right>this.right)){this.right=b.right}if((this.top==null)||(b.top>this.top)){this.top=b.top}}}},containsLonLat:function(b,a){return this.contains(b.lon,b.lat,a)},containsPixel:function(b,a){return this.contains(b.x,b.y,a)},contains:function(b,d,a){if(a==null){a=true}if(b==null||d==null){return false}b=OpenLayers.Util.toFloat(b);d=OpenLayers.Util.toFloat(d);var c=false;if(a){c=((b>=this.left)&&(b<=this.right)&&(d>=this.bottom)&&(d<=this.top))}else{c=((b>this.left)&&(b<this.right)&&(d>this.bottom)&&(d<this.top))}return c},intersectsBounds:function(e,b){if(b==null){b=true}var d=false;var h=(this.left==e.right||this.right==e.left||this.top==e.bottom||this.bottom==e.top);if(b||!h){var g=(((e.bottom>=this.bottom)&&(e.bottom<=this.top))||((this.bottom>=e.bottom)&&(this.bottom<=e.top)));var f=(((e.top>=this.bottom)&&(e.top<=this.top))||((this.top>e.bottom)&&(this.top<e.top)));var c=(((e.left>=this.left)&&(e.left<=this.right))||((this.left>=e.left)&&(this.left<=e.right)));var a=(((e.right>=this.left)&&(e.right<=this.right))||((this.right>=e.left)&&(this.right<=e.right)));d=((g||f)&&(c||a))}return d},containsBounds:function(g,b,a){if(b==null){b=false}if(a==null){a=true}var c=this.contains(g.left,g.bottom,a);var d=this.contains(g.right,g.bottom,a);var f=this.contains(g.left,g.top,a);var e=this.contains(g.right,g.top,a);return(b)?(c||d||f||e):(c&&d&&f&&e)},determineQuadrant:function(c){var b="";var a=this.getCenterLonLat();b+=(c.lat<a.lat)?"b":"t";b+=(c.lon<a.lon)?"l":"r";return b},transform:function(d,b){this.centerLonLat=null;var e=OpenLayers.Projection.transform({x:this.left,y:this.bottom},d,b);var a=OpenLayers.Projection.transform({x:this.right,y:this.bottom},d,b);var c=OpenLayers.Projection.transform({x:this.left,y:this.top},d,b);var f=OpenLayers.Projection.transform({x:this.right,y:this.top},d,b);this.left=Math.min(e.x,c.x);this.bottom=Math.min(e.y,a.y);this.right=Math.max(a.x,f.x);this.top=Math.max(c.y,f.y);return this},wrapDateLine:function(a,c){c=c||{};var d=c.leftTolerance||0;var b=c.rightTolerance||0;var e=this.clone();if(a){while(e.left<a.left&&(e.right-b)<=a.left){e=e.add(a.getWidth(),0)}while((e.left+d)>=a.right&&e.right>a.right){e=e.add(-a.getWidth(),0)}}return e},CLASS_NAME:"OpenLayers.Bounds"});OpenLayers.Bounds.fromString=function(c,b){var a=c.split(",");return OpenLayers.Bounds.fromArray(a,b)};OpenLayers.Bounds.fromArray=function(b,a){return a===true?new OpenLayers.Bounds(parseFloat(b[1]),parseFloat(b[0]),parseFloat(b[3]),parseFloat(b[2])):new OpenLayers.Bounds(parseFloat(b[0]),parseFloat(b[1]),parseFloat(b[2]),parseFloat(b[3]))};OpenLayers.Bounds.fromSize=function(a){return new OpenLayers.Bounds(0,a.h,a.w,0)};OpenLayers.Bounds.oppositeQuadrant=function(a){var b="";b+=(a.charAt(0)=="t")?"b":"t";b+=(a.charAt(1)=="l")?"r":"l";return b};OpenLayers.Element={visible:function(a){return OpenLayers.Util.getElement(a).style.display!="none"},toggle:function(){for(var c=0,a=arguments.length;c<a;c++){var b=OpenLayers.Util.getElement(arguments[c]);var d=OpenLayers.Element.visible(b)?"hide":"show";OpenLayers.Element[d](b)}},hide:function(){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"element.style.display = 'none';"}));for(var c=0,a=arguments.length;c<a;c++){var b=OpenLayers.Util.getElement(arguments[c]);if(b){b.style.display="none"}}},show:function(){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"element.style.display = '';"}));for(var c=0,a=arguments.length;c<a;c++){var b=OpenLayers.Util.getElement(arguments[c]);if(b){b.style.display=""}}},remove:function(a){a=OpenLayers.Util.getElement(a);a.parentNode.removeChild(a)},getHeight:function(a){a=OpenLayers.Util.getElement(a);return a.offsetHeight},getDimensions:function(c){c=OpenLayers.Util.getElement(c);if(OpenLayers.Element.getStyle(c,"display")!="none"){return{width:c.offsetWidth,height:c.offsetHeight}}var b=c.style;var f=b.visibility;var d=b.position;var a=b.display;b.visibility="hidden";b.position="absolute";b.display="";var g=c.clientWidth;var e=c.clientHeight;b.display=a;b.position=d;b.visibility=f;return{width:g,height:e}},hasClass:function(b,a){var c=b.className;return(!!c&&new RegExp("(^|\\s)"+a+"(\\s|$)").test(c))},addClass:function(b,a){if(!OpenLayers.Element.hasClass(b,a)){b.className+=(b.className?" ":"")+a}return b},removeClass:function(b,a){var c=b.className;if(c){b.className=OpenLayers.String.trim(c.replace(new RegExp("(^|\\s+)"+a+"(\\s+|$)")," "))}return b},toggleClass:function(b,a){if(OpenLayers.Element.hasClass(b,a)){OpenLayers.Element.removeClass(b,a)}else{OpenLayers.Element.addClass(b,a)}return b},getStyle:function(c,d){c=OpenLayers.Util.getElement(c);var e=null;if(c&&c.style){e=c.style[OpenLayers.String.camelize(d)];if(!e){if(document.defaultView&&document.defaultView.getComputedStyle){var b=document.defaultView.getComputedStyle(c,null);e=b?b.getPropertyValue(d):null}else{if(c.currentStyle){e=c.currentStyle[OpenLayers.String.camelize(d)]}}}var a=["left","top","right","bottom"];if(window.opera&&(OpenLayers.Util.indexOf(a,d)!=-1)&&(OpenLayers.Element.getStyle(c,"position")=="static")){e="auto"}}return e=="auto"?null:e}};OpenLayers.LonLat=OpenLayers.Class({lon:0,lat:0,initialize:function(b,a){this.lon=OpenLayers.Util.toFloat(b);this.lat=OpenLayers.Util.toFloat(a)},toString:function(){return("lon="+this.lon+",lat="+this.lat)},toShortString:function(){return(this.lon+", "+this.lat)},clone:function(){return new OpenLayers.LonLat(this.lon,this.lat)},add:function(c,a){if((c==null)||(a==null)){var b=OpenLayers.i18n("lonlatAddError");OpenLayers.Console.error(b);return null}return new OpenLayers.LonLat(this.lon+OpenLayers.Util.toFloat(c),this.lat+OpenLayers.Util.toFloat(a))},equals:function(b){var a=false;if(b!=null){a=((this.lon==b.lon&&this.lat==b.lat)||(isNaN(this.lon)&&isNaN(this.lat)&&isNaN(b.lon)&&isNaN(b.lat)))}return a},transform:function(c,b){var a=OpenLayers.Projection.transform({x:this.lon,y:this.lat},c,b);this.lon=a.x;this.lat=a.y;return this},wrapDateLine:function(a){var b=this.clone();if(a){while(b.lon<a.left){b.lon+=a.getWidth()}while(b.lon>a.right){b.lon-=a.getWidth()}}return b},CLASS_NAME:"OpenLayers.LonLat"});OpenLayers.LonLat.fromString=function(b){var a=b.split(",");return new OpenLayers.LonLat(a[0],a[1])};OpenLayers.LonLat.fromArray=function(a){var b=OpenLayers.Util.isArray(a),d=b&&a[0],c=b&&a[1];return new OpenLayers.LonLat(d,c)};OpenLayers.Pixel=OpenLayers.Class({x:0,y:0,initialize:function(a,b){this.x=parseFloat(a);this.y=parseFloat(b)},toString:function(){return("x="+this.x+",y="+this.y)},clone:function(){return new OpenLayers.Pixel(this.x,this.y)},equals:function(a){var b=false;if(a!=null){b=((this.x==a.x&&this.y==a.y)||(isNaN(this.x)&&isNaN(this.y)&&isNaN(a.x)&&isNaN(a.y)))}return b},distanceTo:function(a){return Math.sqrt(Math.pow(this.x-a.x,2)+Math.pow(this.y-a.y,2))},add:function(a,c){if((a==null)||(c==null)){var b=OpenLayers.i18n("pixelAddError");OpenLayers.Console.error(b);return null}return new OpenLayers.Pixel(this.x+a,this.y+c)},offset:function(a){var b=this.clone();if(a){b=this.add(a.x,a.y)}return b},CLASS_NAME:"OpenLayers.Pixel"});OpenLayers.Size=OpenLayers.Class({w:0,h:0,initialize:function(a,b){this.w=parseFloat(a);this.h=parseFloat(b)},toString:function(){return("w="+this.w+",h="+this.h)},clone:function(){return new OpenLayers.Size(this.w,this.h)},equals:function(b){var a=false;if(b!=null){a=((this.w==b.w&&this.h==b.h)||(isNaN(this.w)&&isNaN(this.h)&&isNaN(b.w)&&isNaN(b.h)))}return a},CLASS_NAME:"OpenLayers.Size"});OpenLayers.Util=OpenLayers.Util||{};OpenLayers.Util.getElement=function(){var d=[];for(var c=0,a=arguments.length;c<a;c++){var b=arguments[c];if(typeof b=="string"){b=document.getElementById(b)}if(arguments.length==1){return b}d.push(b)}return d};OpenLayers.Util.isElement=function(a){return !!(a&&a.nodeType===1)};OpenLayers.Util.isArray=function(b){return(Object.prototype.toString.call(b)==="[object Array]")};if(typeof window.$==="undefined"){window.$=OpenLayers.Util.getElement}OpenLayers.Util.removeItem=function(c,b){for(var a=c.length-1;a>=0;a--){if(c[a]==b){c.splice(a,1)}}return c};OpenLayers.Util.clearArray=function(a){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"array = []"}));a.length=0};OpenLayers.Util.indexOf=function(d,c){if(typeof d.indexOf=="function"){return d.indexOf(c)}else{for(var b=0,a=d.length;b<a;b++){if(d[b]==c){return b}}return -1}};OpenLayers.Util.modifyDOMElement=function(e,h,d,f,a,c,g,b){if(h){e.id=h}if(d){e.style.left=d.x+"px";e.style.top=d.y+"px"}if(f){e.style.width=f.w+"px";e.style.height=f.h+"px"}if(a){e.style.position=a}if(c){e.style.border=c}if(g){e.style.overflow=g}if(parseFloat(b)>=0&&parseFloat(b)<1){e.style.filter="alpha(opacity="+(b*100)+")";e.style.opacity=b}else{if(parseFloat(b)==1){e.style.filter="";e.style.opacity=""}}};OpenLayers.Util.createDiv=function(a,i,h,f,e,c,b,g){var d=document.createElement("div");if(f){d.style.backgroundImage="url("+f+")"}if(!a){a=OpenLayers.Util.createUniqueID("OpenLayersDiv")}if(!e){e="absolute"}OpenLayers.Util.modifyDOMElement(d,a,i,h,e,c,b,g);return d};OpenLayers.Util.createImage=function(a,h,g,e,d,c,f,i){var b=document.createElement("img");if(!a){a=OpenLayers.Util.createUniqueID("OpenLayersDiv")}if(!d){d="relative"}OpenLayers.Util.modifyDOMElement(b,a,h,g,d,c,null,f);if(i){b.style.display="none";OpenLayers.Event.observe(b,"load",OpenLayers.Function.bind(OpenLayers.Util.onImageLoad,b));OpenLayers.Event.observe(b,"error",OpenLayers.Function.bind(OpenLayers.Util.onImageLoadError,b))}b.style.alt=a;b.galleryImg="no";if(e){b.src=e}return b};OpenLayers.Util.setOpacity=function(b,a){OpenLayers.Util.modifyDOMElement(b,null,null,null,null,null,null,a)};OpenLayers.Util.onImageLoad=function(){if(!this.viewRequestID||(this.map&&this.viewRequestID==this.map.viewRequestID)){this.style.display=""}OpenLayers.Element.removeClass(this,"olImageLoadError")};OpenLayers.IMAGE_RELOAD_ATTEMPTS=0;OpenLayers.Util.onImageLoadError=function(){this._attempts=(this._attempts)?(this._attempts+1):1;if(this._attempts<=OpenLayers.IMAGE_RELOAD_ATTEMPTS){var d=this.urls;if(d&&OpenLayers.Util.isArray(d)&&d.length>1){var e=this.src.toString();var c,a;for(a=0;c=d[a];a++){if(e.indexOf(c)!=-1){break}}var f=Math.floor(d.length*Math.random());var b=d[f];a=0;while(b==c&&a++<4){f=Math.floor(d.length*Math.random());b=d[f]}this.src=e.replace(c,b)}else{this.src=this.src}}else{OpenLayers.Element.addClass(this,"olImageLoadError")}this.style.display=""};OpenLayers.Util.alphaHackNeeded=null;OpenLayers.Util.alphaHack=function(){if(OpenLayers.Util.alphaHackNeeded==null){var d=navigator.appVersion.split("MSIE");var a=parseFloat(d[1]);var b=false;try{b=!!(document.body.filters)}catch(c){}OpenLayers.Util.alphaHackNeeded=(b&&(a>=5.5)&&(a<7))}return OpenLayers.Util.alphaHackNeeded};OpenLayers.Util.modifyAlphaImageDiv=function(a,b,j,i,g,f,c,d,h){OpenLayers.Util.modifyDOMElement(a,b,j,i,f,null,null,h);var e=a.childNodes[0];if(g){e.src=g}OpenLayers.Util.modifyDOMElement(e,a.id+"_innerImage",null,i,"relative",c);if(OpenLayers.Util.alphaHack()){if(a.style.display!="none"){a.style.display="inline-block"}if(d==null){d="scale"}a.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+e.src+"', sizingMethod='"+d+"')";if(parseFloat(a.style.opacity)>=0&&parseFloat(a.style.opacity)<1){a.style.filter+=" alpha(opacity="+a.style.opacity*100+")"}e.style.filter="alpha(opacity=0)"}};OpenLayers.Util.createAlphaImageDiv=function(b,j,i,g,f,c,d,h,k){var a=OpenLayers.Util.createDiv();var e=OpenLayers.Util.createImage(null,null,null,null,null,null,null,false);a.appendChild(e);if(k){e.style.display="none";OpenLayers.Event.observe(e,"load",OpenLayers.Function.bind(OpenLayers.Util.onImageLoad,a));OpenLayers.Event.observe(e,"error",OpenLayers.Function.bind(OpenLayers.Util.onImageLoadError,a))}OpenLayers.Util.modifyAlphaImageDiv(a,b,j,i,g,f,c,d,h);return a};OpenLayers.Util.upperCaseObject=function(b){var a={};for(var c in b){a[c.toUpperCase()]=b[c]}return a};OpenLayers.Util.applyDefaults=function(d,c){d=d||{};var b=typeof window.Event=="function"&&c instanceof window.Event;for(var a in c){if(d[a]===undefined||(!b&&c.hasOwnProperty&&c.hasOwnProperty(a)&&!d.hasOwnProperty(a))){d[a]=c[a]}}if(!b&&c&&c.hasOwnProperty&&c.hasOwnProperty("toString")&&!d.hasOwnProperty("toString")){d.toString=c.toString}return d};OpenLayers.Util.getParameterString=function(c){var b=[];for(var h in c){var g=c[h];if((g!=null)&&(typeof g!="function")){var d;if(typeof g=="object"&&g.constructor==Array){var e=[];var i;for(var a=0,f=g.length;a<f;a++){i=g[a];e.push(encodeURIComponent((i===null||i===undefined)?"":i))}d=e.join(",")}else{d=encodeURIComponent(g)}b.push(encodeURIComponent(h)+"="+d)}}return b.join("&")};OpenLayers.Util.urlAppend=function(a,b){var d=a;if(b){var c=(a+" ").split(/[?&]/);d+=(c.pop()===" "?b:c.length?"&"+b:"?"+b)}return d};OpenLayers.ImgPath="";OpenLayers.Util.getImagesLocation=function(){return OpenLayers.ImgPath||(OpenLayers._getScriptLocation()+"img/")};OpenLayers.Util.Try=function(){var d=null;for(var c=0,a=arguments.length;c<a;c++){var b=arguments[c];try{d=b();break}catch(f){}}return d};OpenLayers.Util.getXmlNodeValue=function(a){var b=null;OpenLayers.Util.Try(function(){b=a.text;if(!b){b=a.textContent}if(!b){b=a.firstChild.nodeValue}},function(){b=a.textContent});return b};OpenLayers.Util.mouseLeft=function(a,c){var b=(a.relatedTarget)?a.relatedTarget:a.toElement;while(b!=c&&b!=null){b=b.parentNode}return(b!=c)};OpenLayers.Util.DEFAULT_PRECISION=14;OpenLayers.Util.toFloat=function(b,a){if(a==null){a=OpenLayers.Util.DEFAULT_PRECISION}if(typeof b!=="number"){b=parseFloat(b)}return a===0?b:parseFloat(b.toPrecision(a))};OpenLayers.Util.rad=function(a){return a*Math.PI/180};OpenLayers.Util.deg=function(a){return a*180/Math.PI};OpenLayers.Util.VincentyConstants={a:6378137,b:6356752.3142,f:1/298.257223563};OpenLayers.Util.distVincenty=function(g,e){var k=OpenLayers.Util.VincentyConstants;var M=k.a,K=k.b,G=k.f;var n=OpenLayers.Util.rad(e.lon-g.lon);var J=Math.atan((1-G)*Math.tan(OpenLayers.Util.rad(g.lat)));var I=Math.atan((1-G)*Math.tan(OpenLayers.Util.rad(e.lat)));var m=Math.sin(J),i=Math.cos(J);var l=Math.sin(I),h=Math.cos(I);var r=n,o=2*Math.PI;var q=20;while(Math.abs(r-o)>1e-12&&--q>0){var z=Math.sin(r),c=Math.cos(r);var N=Math.sqrt((h*z)*(h*z)+(i*l-m*h*c)*(i*l-m*h*c));if(N==0){return 0}var E=m*l+i*h*c;var y=Math.atan2(N,E);var j=Math.asin(i*h*z/N);var F=Math.cos(j)*Math.cos(j);var p=E-2*m*l/F;var v=G/16*F*(4+G*(4-3*F));o=r;r=n+(1-v)*G*Math.sin(j)*(y+v*N*(p+v*E*(-1+2*p*p)))}if(q==0){return NaN}var u=F*(M*M-K*K)/(K*K);var x=1+u/16384*(4096+u*(-768+u*(320-175*u)));var w=u/1024*(256+u*(-128+u*(74-47*u)));var D=w*N*(p+w/4*(E*(-1+2*p*p)-w/6*p*(-3+4*N*N)*(-3+4*p*p)));var t=K*x*(y-D);var H=t.toFixed(3)/1000;return H};OpenLayers.Util.destinationVincenty=function(l,P,E){var o=OpenLayers.Util;var i=o.VincentyConstants;var Q=i.a,O=i.b,J=i.f;var N=l.lon;var g=l.lat;var q=E;var D=o.rad(P);var G=Math.sin(D);var h=Math.cos(D);var F=(1-J)*Math.tan(o.rad(g));var c=1/Math.sqrt((1+F*F)),j=F*c;var p=Math.atan2(F,h);var y=c*G;var I=1-y*y;var t=I*(Q*Q-O*O)/(O*O);var x=1+t/16384*(4096+t*(-768+t*(320-175*t)));var v=t/1024*(256+t*(-128+t*(74-47*t)));var w=q/(O*x),K=2*Math.PI;while(Math.abs(w-K)>1e-12){var m=Math.cos(2*p+w);var R=Math.sin(w);var H=Math.cos(w);var z=v*R*(m+v/4*(H*(-1+2*m*m)-v/6*m*(-3+4*R*R)*(-3+4*m*m)));K=w;w=q/(O*x)+z}var M=j*R-c*H*h;var d=Math.atan2(j*H+c*R*h,(1-J)*Math.sqrt(y*y+M*M));var n=Math.atan2(R*G,c*H-j*R*h);var r=J/16*I*(4+J*(4-3*I));var k=n-(1-r)*J*y*(w+r*R*(m+r*H*(-1+2*m*m)));var e=Math.atan2(y,-M);return new OpenLayers.LonLat(N+o.deg(k),o.deg(d))};OpenLayers.Util.getParameters=function(b){b=(b===null||b===undefined)?window.location.href:b;var a="";if(OpenLayers.String.contains(b,"?")){var c=b.indexOf("?")+1;var f=OpenLayers.String.contains(b,"#")?b.indexOf("#"):b.length;a=b.substring(c,f)}var m={};var d=a.split(/[&;]/);for(var h=0,j=d.length;h<j;++h){var g=d[h].split("=");if(g[0]){var l=g[0];try{l=decodeURIComponent(l)}catch(e){l=unescape(l)}var k=(g[1]||"").replace(/\+/g," ");try{k=decodeURIComponent(k)}catch(e){k=unescape(k)}k=k.split(",");if(k.length==1){k=k[0]}m[l]=k}}return m};OpenLayers.Util.getArgs=function(a){OpenLayers.Console.warn(OpenLayers.i18n("methodDeprecated",{newMethod:"OpenLayers.Util.getParameters"}));return OpenLayers.Util.getParameters(a)};OpenLayers.Util.lastSeqID=0;OpenLayers.Util.createUniqueID=function(a){if(a==null){a="id_"}OpenLayers.Util.lastSeqID+=1;return a+OpenLayers.Util.lastSeqID};OpenLayers.INCHES_PER_UNIT={inches:1,ft:12,mi:63360,m:39.3701,km:39370.1,dd:4374754,yd:36};OpenLayers.INCHES_PER_UNIT["in"]=OpenLayers.INCHES_PER_UNIT.inches;OpenLayers.INCHES_PER_UNIT.degrees=OpenLayers.INCHES_PER_UNIT.dd;OpenLayers.INCHES_PER_UNIT.nmi=1852*OpenLayers.INCHES_PER_UNIT.m;OpenLayers.METERS_PER_INCH=0.0254000508001016;OpenLayers.Util.extend(OpenLayers.INCHES_PER_UNIT,{Inch:OpenLayers.INCHES_PER_UNIT.inches,Meter:1/OpenLayers.METERS_PER_INCH,Foot:0.3048006096012192/OpenLayers.METERS_PER_INCH,IFoot:0.3048/OpenLayers.METERS_PER_INCH,ClarkeFoot:0.3047972651151/OpenLayers.METERS_PER_INCH,SearsFoot:0.30479947153867626/OpenLayers.METERS_PER_INCH,GoldCoastFoot:0.3047997101815088/OpenLayers.METERS_PER_INCH,IInch:0.0254/OpenLayers.METERS_PER_INCH,MicroInch:0.0000254/OpenLayers.METERS_PER_INCH,Mil:2.54e-8/OpenLayers.METERS_PER_INCH,Centimeter:0.01/OpenLayers.METERS_PER_INCH,Kilometer:1000/OpenLayers.METERS_PER_INCH,Yard:0.9144018288036576/OpenLayers.METERS_PER_INCH,SearsYard:0.914398414616029/OpenLayers.METERS_PER_INCH,IndianYard:0.9143985307444408/OpenLayers.METERS_PER_INCH,IndianYd37:0.91439523/OpenLayers.METERS_PER_INCH,IndianYd62:0.9143988/OpenLayers.METERS_PER_INCH,IndianYd75:0.9143985/OpenLayers.METERS_PER_INCH,IndianFoot:0.30479951/OpenLayers.METERS_PER_INCH,IndianFt37:0.30479841/OpenLayers.METERS_PER_INCH,IndianFt62:0.3047996/OpenLayers.METERS_PER_INCH,IndianFt75:0.3047995/OpenLayers.METERS_PER_INCH,Mile:1609.3472186944373/OpenLayers.METERS_PER_INCH,IYard:0.9144/OpenLayers.METERS_PER_INCH,IMile:1609.344/OpenLayers.METERS_PER_INCH,NautM:1852/OpenLayers.METERS_PER_INCH,"Lat-66":110943.31648893273/OpenLayers.METERS_PER_INCH,"Lat-83":110946.25736872235/OpenLayers.METERS_PER_INCH,Decimeter:0.1/OpenLayers.METERS_PER_INCH,Millimeter:0.001/OpenLayers.METERS_PER_INCH,Dekameter:10/OpenLayers.METERS_PER_INCH,Decameter:10/OpenLayers.METERS_PER_INCH,Hectometer:100/OpenLayers.METERS_PER_INCH,GermanMeter:1.0000135965/OpenLayers.METERS_PER_INCH,CaGrid:0.999738/OpenLayers.METERS_PER_INCH,ClarkeChain:20.1166194976/OpenLayers.METERS_PER_INCH,GunterChain:20.11684023368047/OpenLayers.METERS_PER_INCH,BenoitChain:20.116782494375872/OpenLayers.METERS_PER_INCH,SearsChain:20.11676512155/OpenLayers.METERS_PER_INCH,ClarkeLink:0.201166194976/OpenLayers.METERS_PER_INCH,GunterLink:0.2011684023368047/OpenLayers.METERS_PER_INCH,BenoitLink:0.20116782494375873/OpenLayers.METERS_PER_INCH,SearsLink:0.2011676512155/OpenLayers.METERS_PER_INCH,Rod:5.02921005842012/OpenLayers.METERS_PER_INCH,IntnlChain:20.1168/OpenLayers.METERS_PER_INCH,IntnlLink:0.201168/OpenLayers.METERS_PER_INCH,Perch:5.02921005842012/OpenLayers.METERS_PER_INCH,Pole:5.02921005842012/OpenLayers.METERS_PER_INCH,Furlong:201.1684023368046/OpenLayers.METERS_PER_INCH,Rood:3.778266898/OpenLayers.METERS_PER_INCH,CapeFoot:0.3047972615/OpenLayers.METERS_PER_INCH,Brealey:375/OpenLayers.METERS_PER_INCH,ModAmFt:0.304812252984506/OpenLayers.METERS_PER_INCH,Fathom:1.8288/OpenLayers.METERS_PER_INCH,"NautM-UK":1853.184/OpenLayers.METERS_PER_INCH,"50kilometers":50000/OpenLayers.METERS_PER_INCH,"150kilometers":150000/OpenLayers.METERS_PER_INCH});OpenLayers.Util.extend(OpenLayers.INCHES_PER_UNIT,{mm:OpenLayers.INCHES_PER_UNIT.Meter/1000,cm:OpenLayers.INCHES_PER_UNIT.Meter/100,dm:OpenLayers.INCHES_PER_UNIT.Meter*100,km:OpenLayers.INCHES_PER_UNIT.Meter*1000,kmi:OpenLayers.INCHES_PER_UNIT.nmi,fath:OpenLayers.INCHES_PER_UNIT.Fathom,ch:OpenLayers.INCHES_PER_UNIT.IntnlChain,link:OpenLayers.INCHES_PER_UNIT.IntnlLink,"us-in":OpenLayers.INCHES_PER_UNIT.inches,"us-ft":OpenLayers.INCHES_PER_UNIT.Foot,"us-yd":OpenLayers.INCHES_PER_UNIT.Yard,"us-ch":OpenLayers.INCHES_PER_UNIT.GunterChain,"us-mi":OpenLayers.INCHES_PER_UNIT.Mile,"ind-yd":OpenLayers.INCHES_PER_UNIT.IndianYd37,"ind-ft":OpenLayers.INCHES_PER_UNIT.IndianFt37,"ind-ch":20.11669506/OpenLayers.METERS_PER_INCH});OpenLayers.DOTS_PER_INCH=72;OpenLayers.Util.normalizeScale=function(b){var a=(b>1)?(1/b):b;return a};OpenLayers.Util.getResolutionFromScale=function(d,a){var b;if(d){if(a==null){a="degrees"}var c=OpenLayers.Util.normalizeScale(d);b=1/(c*OpenLayers.INCHES_PER_UNIT[a]*OpenLayers.DOTS_PER_INCH)}return b};OpenLayers.Util.getScaleFromResolution=function(b,a){if(a==null){a="degrees"}var c=b*OpenLayers.INCHES_PER_UNIT[a]*OpenLayers.DOTS_PER_INCH;return c};OpenLayers.Util.safeStopPropagation=function(a){OpenLayers.Event.stop(a,true)};OpenLayers.Util.pagePosition=function(d){var i=[0,0];var h=OpenLayers.Util.getViewportElement();if(!d||d==window||d==h){return i}var f=OpenLayers.IS_GECKO&&document.getBoxObjectFor&&OpenLayers.Element.getStyle(d,"position")=="absolute"&&(d.style.top==""||d.style.left=="");var j=null;var g;if(d.getBoundingClientRect){g=d.getBoundingClientRect();var b=h.scrollTop;var c=h.scrollLeft;i[0]=g.left+c;i[1]=g.top+b}else{if(document.getBoxObjectFor&&!f){g=document.getBoxObjectFor(d);var a=document.getBoxObjectFor(h);i[0]=g.screenX-a.screenX;i[1]=g.screenY-a.screenY}else{i[0]=d.offsetLeft;i[1]=d.offsetTop;j=d.offsetParent;if(j!=d){while(j){i[0]+=j.offsetLeft;i[1]+=j.offsetTop;j=j.offsetParent}}var e=OpenLayers.BROWSER_NAME;if(e=="opera"||(e=="safari"&&OpenLayers.Element.getStyle(d,"position")=="absolute")){i[1]-=document.body.offsetTop}j=d.offsetParent;while(j&&j!=document.body){i[0]-=j.scrollLeft;if(e!="opera"||j.tagName!="TR"){i[1]-=j.scrollTop}j=j.offsetParent}}}return i};OpenLayers.Util.getViewportElement=function(){var a=arguments.callee.viewportElement;if(a==undefined){a=(OpenLayers.BROWSER_NAME=="msie"&&document.compatMode!="CSS1Compat")?document.body:document.documentElement;arguments.callee.viewportElement=a}return a};OpenLayers.Util.isEquivalentUrl=function(f,e,c){c=c||{};OpenLayers.Util.applyDefaults(c,{ignoreCase:true,ignorePort80:true,ignoreHash:true});var b=OpenLayers.Util.createUrlObject(f,c);var a=OpenLayers.Util.createUrlObject(e,c);for(var d in b){if(d!=="args"){if(b[d]!=a[d]){return false}}}for(var d in b.args){if(b.args[d]!=a.args[d]){return false}delete a.args[d]}for(var d in a.args){return false}return true};OpenLayers.Util.createUrlObject=function(c,k){k=k||{};if(!(/^\w+:\/\//).test(c)){var g=window.location;var e=g.port?":"+g.port:"";var h=g.protocol+"//"+g.host.split(":").shift()+e;if(c.indexOf("/")===0){c=h+c}else{var f=g.pathname.split("/");f.pop();c=h+f.join("/")+"/"+c}}if(k.ignoreCase){c=c.toLowerCase()}var i=document.createElement("a");i.href=c;var d={};d.host=i.host.split(":").shift();d.protocol=i.protocol;if(k.ignorePort80){d.port=(i.port=="80"||i.port=="0")?"":i.port}else{d.port=(i.port==""||i.port=="0")?"80":i.port}d.hash=(k.ignoreHash||i.hash==="#")?"":i.hash;var b=i.search;if(!b){var j=c.indexOf("?");b=(j!=-1)?c.substr(j):""}d.args=OpenLayers.Util.getParameters(b);d.pathname=(i.pathname.charAt(0)=="/")?i.pathname:"/"+i.pathname;return d};OpenLayers.Util.removeTail=function(b){var c=null;var a=b.indexOf("?");var d=b.indexOf("#");if(a==-1){c=(d!=-1)?b.substr(0,d):b}else{c=(d!=-1)?b.substr(0,Math.min(a,d)):b.substr(0,a)}return c};OpenLayers.IS_GECKO=(function(){var a=navigator.userAgent.toLowerCase();return a.indexOf("webkit")==-1&&a.indexOf("gecko")!=-1})();OpenLayers.BROWSER_NAME=(function(){var a="";var b=navigator.userAgent.toLowerCase();if(b.indexOf("opera")!=-1){a="opera"}else{if(b.indexOf("msie")!=-1){a="msie"}else{if(b.indexOf("safari")!=-1){a="safari"}else{if(b.indexOf("mozilla")!=-1){if(b.indexOf("firefox")!=-1){a="firefox"}else{a="mozilla"}}}}}return a})();OpenLayers.Util.getBrowserName=function(){return OpenLayers.BROWSER_NAME};OpenLayers.Util.getRenderedDimensions=function(b,o,p){var k,e;var a=document.createElement("div");a.style.visibility="hidden";var n=(p&&p.containerElement)?p.containerElement:document.body;if(o){if(o.w){k=o.w;a.style.width=k+"px"}else{if(o.h){e=o.h;a.style.height=e+"px"}}}if(p&&p.displayClass){a.className=p.displayClass}var f=document.createElement("div");f.innerHTML=b;f.style.overflow="visible";if(f.childNodes){for(var d=0,c=f.childNodes.length;d<c;d++){if(!f.childNodes[d].style){continue}f.childNodes[d].style.overflow="visible"}}a.appendChild(f);n.appendChild(a);var m=false;var j=a.parentNode;while(j&&j.tagName.toLowerCase()!="body"){var g=OpenLayers.Element.getStyle(j,"position");if(g=="absolute"){m=true;break}else{if(g&&g!="static"){break}}j=j.parentNode}if(!m){a.style.position="absolute"}if(!k){k=parseInt(f.scrollWidth);a.style.width=k+"px"}if(!e){e=parseInt(f.scrollHeight)}a.removeChild(f);n.removeChild(a);return new OpenLayers.Size(k,e)};OpenLayers.Util.getScrollbarWidth=function(){var c=OpenLayers.Util._scrollbarWidth;if(c==null){var e=null;var d=null;var a=0;var b=0;e=document.createElement("div");e.style.position="absolute";e.style.top="-1000px";e.style.left="-1000px";e.style.width="100px";e.style.height="50px";e.style.overflow="hidden";d=document.createElement("div");d.style.width="100%";d.style.height="200px";e.appendChild(d);document.body.appendChild(e);a=d.offsetWidth;e.style.overflow="scroll";b=d.offsetWidth;document.body.removeChild(document.body.lastChild);OpenLayers.Util._scrollbarWidth=(a-b);c=OpenLayers.Util._scrollbarWidth}return c};OpenLayers.Util.getFormattedLonLat=function(h,b,e){if(!e){e="dms"}h=(h+540)%360-180;var d=Math.abs(h);var i=Math.floor(d);var a=(d-i)/(1/60);var c=a;a=Math.floor(a);var g=(c-a)/(1/60);g=Math.round(g*10);g/=10;if(g>=60){g-=60;a+=1;if(a>=60){a-=60;i+=1}}if(i<10){i="0"+i}var f=i+"\u00B0";if(e.indexOf("dm")>=0){if(a<10){a="0"+a}f+=a+"'";if(e.indexOf("dms")>=0){if(g<10){g="0"+g}f+=g+'"'}}if(b=="lon"){f+=h<0?OpenLayers.i18n("W"):OpenLayers.i18n("E")}else{f+=h<0?OpenLayers.i18n("S"):OpenLayers.i18n("N")}return f};OpenLayers.Format=OpenLayers.Class({options:null,externalProjection:null,internalProjection:null,data:null,keepData:false,initialize:function(a){OpenLayers.Util.extend(this,a);this.options=a},destroy:function(){},read:function(a){OpenLayers.Console.userError(OpenLayers.i18n("readNotImplemented"))},write:function(a){OpenLayers.Console.userError(OpenLayers.i18n("writeNotImplemented"))},CLASS_NAME:"OpenLayers.Format"});OpenLayers.Format.JSON=OpenLayers.Class(OpenLayers.Format,{indent:"    ",space:" ",newline:"\n",level:0,pretty:false,nativeJSON:(function(){return !!(window.JSON&&typeof JSON.parse=="function"&&typeof JSON.stringify=="function")})(),read:function(json,filter){var object;if(this.nativeJSON){object=JSON.parse(json,filter)}else{try{if(/^[\],:{}\s]*$/.test(json.replace(/\\["\\\/bfnrtu]/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,""))){object=eval("("+json+")");if(typeof filter==="function"){function walk(k,v){if(v&&typeof v==="object"){for(var i in v){if(v.hasOwnProperty(i)){v[i]=walk(i,v[i])}}}return filter(k,v)}object=walk("",object)}}}catch(e){}}if(this.keepData){this.data=object}return object},write:function(e,c){this.pretty=!!c;var a=null;var b=typeof e;if(this.serialize[b]){try{a=(!this.pretty&&this.nativeJSON)?JSON.stringify(e):this.serialize[b].apply(this,[e])}catch(d){OpenLayers.Console.error("Trouble serializing: "+d)}}return a},writeIndent:function(){var b=[];if(this.pretty){for(var a=0;a<this.level;++a){b.push(this.indent)}}return b.join("")},writeNewline:function(){return(this.pretty)?this.newline:""},writeSpace:function(){return(this.pretty)?this.space:""},serialize:{object:function(c){if(c==null){return"null"}if(c.constructor==Date){return this.serialize.date.apply(this,[c])}if(c.constructor==Array){return this.serialize.array.apply(this,[c])}var f=["{"];this.level+=1;var d,b,e;var a=false;for(d in c){if(c.hasOwnProperty(d)){b=OpenLayers.Format.JSON.prototype.write.apply(this,[d,this.pretty]);e=OpenLayers.Format.JSON.prototype.write.apply(this,[c[d],this.pretty]);if(b!=null&&e!=null){if(a){f.push(",")}f.push(this.writeNewline(),this.writeIndent(),b,":",this.writeSpace(),e);a=true}}}this.level-=1;f.push(this.writeNewline(),this.writeIndent(),"}");return f.join("")},array:function(e){var c;var d=["["];this.level+=1;for(var b=0,a=e.length;b<a;++b){c=OpenLayers.Format.JSON.prototype.write.apply(this,[e[b],this.pretty]);if(c!=null){if(b>0){d.push(",")}d.push(this.writeNewline(),this.writeIndent(),c)}}this.level-=1;d.push(this.writeNewline(),this.writeIndent(),"]");return d.join("")},string:function(b){var a={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};if(/["\\\x00-\x1f]/.test(b)){return'"'+b.replace(/([\x00-\x1f\\"])/g,function(e,d){var f=a[d];if(f){return f}f=d.charCodeAt();return"\\u00"+Math.floor(f/16).toString(16)+(f%16).toString(16)})+'"'}return'"'+b+'"'},number:function(a){return isFinite(a)?String(a):"null"},"boolean":function(a){return String(a)},date:function(a){function b(c){return(c<10)?"0"+c:c}return'"'+a.getFullYear()+"-"+b(a.getMonth()+1)+"-"+b(a.getDate())+"T"+b(a.getHours())+":"+b(a.getMinutes())+":"+b(a.getSeconds())+'"'}},CLASS_NAME:"OpenLayers.Format.JSON"});OpenLayers.Feature=OpenLayers.Class({layer:null,id:null,lonlat:null,data:null,marker:null,popupClass:null,popup:null,initialize:function(a,c,b){this.layer=a;this.lonlat=c;this.data=(b!=null)?b:{};this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")},destroy:function(){if((this.layer!=null)&&(this.layer.map!=null)){if(this.popup!=null){this.layer.map.removePopup(this.popup)}}if(this.layer!=null&&this.marker!=null){this.layer.removeMarker(this.marker)}this.layer=null;this.id=null;this.lonlat=null;this.data=null;if(this.marker!=null){this.destroyMarker(this.marker);this.marker=null}if(this.popup!=null){this.destroyPopup(this.popup);this.popup=null}},onScreen:function(){var b=false;if((this.layer!=null)&&(this.layer.map!=null)){var a=this.layer.map.getExtent();b=a.containsLonLat(this.lonlat)}return b},createMarker:function(){if(this.lonlat!=null){this.marker=new OpenLayers.Marker(this.lonlat,this.data.icon)}return this.marker},destroyMarker:function(){this.marker.destroy()},createPopup:function(b){if(this.lonlat!=null){if(!this.popup){var a=(this.marker)?this.marker.icon:null;var c=this.popupClass?this.popupClass:OpenLayers.Popup.AnchoredBubble;this.popup=new c(this.id+"_popup",this.lonlat,this.data.popupSize,this.data.popupContentHTML,a,b)}if(this.data.overflow!=null){this.popup.contentDiv.style.overflow=this.data.overflow}this.popup.feature=this}return this.popup},destroyPopup:function(){if(this.popup){this.popup.feature=null;this.popup.destroy();this.popup=null}},CLASS_NAME:"OpenLayers.Feature"});OpenLayers.State={UNKNOWN:"Unknown",INSERT:"Insert",UPDATE:"Update",DELETE:"Delete"};OpenLayers.Feature.Vector=OpenLayers.Class(OpenLayers.Feature,{fid:null,geometry:null,attributes:null,bounds:null,state:null,style:null,url:null,renderIntent:"default",modified:null,initialize:function(c,a,b){OpenLayers.Feature.prototype.initialize.apply(this,[null,null,a]);this.lonlat=null;this.geometry=c?c:null;this.state=null;this.attributes={};if(a){this.attributes=OpenLayers.Util.extend(this.attributes,a)}this.style=b?b:null},destroy:function(){if(this.layer){this.layer.removeFeatures(this);this.layer=null}this.geometry=null;this.modified=null;OpenLayers.Feature.prototype.destroy.apply(this,arguments)},clone:function(){return new OpenLayers.Feature.Vector(this.geometry?this.geometry.clone():null,this.attributes,this.style)},onScreen:function(d){var c=false;if(this.layer&&this.layer.map){var a=this.layer.map.getExtent();if(d){var b=this.geometry.getBounds();c=a.intersectsBounds(b)}else{var e=a.toGeometry();c=e.intersects(this.geometry)}}return c},getVisibility:function(){return !(this.style&&this.style.display=="none"||!this.layer||this.layer&&this.layer.styleMap&&this.layer.styleMap.createSymbolizer(this,this.renderIntent).display=="none"||this.layer&&!this.layer.getVisibility())},createMarker:function(){return null},destroyMarker:function(){},createPopup:function(){return null},atPoint:function(b,d,c){var a=false;if(this.geometry){a=this.geometry.atPoint(b,d,c)}return a},destroyPopup:function(){},move:function(a){if(!this.layer||!this.geometry.move){return undefined}var b;if(a.CLASS_NAME=="OpenLayers.LonLat"){b=this.layer.getViewPortPxFromLonLat(a)}else{b=a}var d=this.layer.getViewPortPxFromLonLat(this.geometry.getBounds().getCenterLonLat());var c=this.layer.map.getResolution();this.geometry.move(c*(b.x-d.x),c*(d.y-b.y));this.layer.drawFeature(this);return d},toState:function(a){if(a==OpenLayers.State.UPDATE){switch(this.state){case OpenLayers.State.UNKNOWN:case OpenLayers.State.DELETE:this.state=a;break;case OpenLayers.State.UPDATE:case OpenLayers.State.INSERT:break}}else{if(a==OpenLayers.State.INSERT){switch(this.state){case OpenLayers.State.UNKNOWN:break;default:this.state=a;break}}else{if(a==OpenLayers.State.DELETE){switch(this.state){case OpenLayers.State.INSERT:break;case OpenLayers.State.DELETE:break;case OpenLayers.State.UNKNOWN:case OpenLayers.State.UPDATE:this.state=a;break}}else{if(a==OpenLayers.State.UNKNOWN){this.state=a}}}}},CLASS_NAME:"OpenLayers.Feature.Vector"});OpenLayers.Feature.Vector.style={"default":{fillColor:"#ee9900",fillOpacity:0.4,hoverFillColor:"white",hoverFillOpacity:0.8,strokeColor:"#ee9900",strokeOpacity:1,strokeWidth:1,strokeLinecap:"round",strokeDashstyle:"solid",hoverStrokeColor:"red",hoverStrokeOpacity:1,hoverStrokeWidth:0.2,pointRadius:6,hoverPointRadius:1,hoverPointUnit:"%",pointerEvents:"visiblePainted",cursor:"inherit"},select:{fillColor:"blue",fillOpacity:0.4,hoverFillColor:"white",hoverFillOpacity:0.8,strokeColor:"blue",strokeOpacity:1,strokeWidth:2,strokeLinecap:"round",strokeDashstyle:"solid",hoverStrokeColor:"red",hoverStrokeOpacity:1,hoverStrokeWidth:0.2,pointRadius:6,hoverPointRadius:1,hoverPointUnit:"%",pointerEvents:"visiblePainted",cursor:"pointer"},temporary:{fillColor:"#66cccc",fillOpacity:0.2,hoverFillColor:"white",hoverFillOpacity:0.8,strokeColor:"#66cccc",strokeOpacity:1,strokeLinecap:"round",strokeWidth:2,strokeDashstyle:"solid",hoverStrokeColor:"red",hoverStrokeOpacity:1,hoverStrokeWidth:0.2,pointRadius:6,hoverPointRadius:1,hoverPointUnit:"%",pointerEvents:"visiblePainted",cursor:"inherit"},"delete":{display:"none"}};OpenLayers.Format.WKT=OpenLayers.Class(OpenLayers.Format,{initialize:function(a){this.regExes={typeStr:/^\s*(\w+)\s*\(\s*(.*)\s*\)\s*$/,spaces:/\s+/,parenComma:/\)\s*,\s*\(/,doubleParenComma:/\)\s*\)\s*,\s*\(\s*\(/,trimParens:/^\s*\(?(.*?)\)?\s*$/};OpenLayers.Format.prototype.initialize.apply(this,[a])},read:function(f){var e,d,h;f=f.replace(/[\n\r]/g," ");var g=this.regExes.typeStr.exec(f);if(g){d=g[1].toLowerCase();h=g[2];if(this.parse[d]){e=this.parse[d].apply(this,[h])}if(this.internalProjection&&this.externalProjection){if(e&&e.CLASS_NAME=="OpenLayers.Feature.Vector"){e.geometry.transform(this.externalProjection,this.internalProjection)}else{if(e&&d!="geometrycollection"&&typeof e=="object"){for(var c=0,a=e.length;c<a;c++){var b=e[c];b.geometry.transform(this.externalProjection,this.internalProjection)}}}}}return e},write:function(a){var f,j,h,d,b;if(a.constructor==Array){f=a;b=true}else{f=[a];b=false}var c=[];if(b){c.push("GEOMETRYCOLLECTION(")}for(var e=0,g=f.length;e<g;++e){if(b&&e>0){c.push(",")}j=f[e].geometry;c.push(this.extractGeometry(j))}if(b){c.push(")")}return c.join("")},extractGeometry:function(d){var b=d.CLASS_NAME.split(".")[2].toLowerCase();if(!this.extract[b]){return null}if(this.internalProjection&&this.externalProjection){d=d.clone();d.transform(this.internalProjection,this.externalProjection)}var a=b=="collection"?"GEOMETRYCOLLECTION":b.toUpperCase();var c=a+"("+this.extract[b].apply(this,[d])+")";return c},extract:{point:function(a){return a.x+" "+a.y},multipoint:function(c){var d=[];for(var b=0,a=c.components.length;b<a;++b){d.push("("+this.extract.point.apply(this,[c.components[b]])+")")}return d.join(",")},linestring:function(b){var d=[];for(var c=0,a=b.components.length;c<a;++c){d.push(this.extract.point.apply(this,[b.components[c]]))}return d.join(",")},multilinestring:function(c){var d=[];for(var b=0,a=c.components.length;b<a;++b){d.push("("+this.extract.linestring.apply(this,[c.components[b]])+")")}return d.join(",")},polygon:function(c){var d=[];for(var b=0,a=c.components.length;b<a;++b){d.push("("+this.extract.linestring.apply(this,[c.components[b]])+")")}return d.join(",")},multipolygon:function(d){var c=[];for(var b=0,a=d.components.length;b<a;++b){c.push("("+this.extract.polygon.apply(this,[d.components[b]])+")")}return c.join(",")},collection:function(c){var d=[];for(var b=0,a=c.components.length;b<a;++b){d.push(this.extractGeometry.apply(this,[c.components[b]]))}return d.join(",")}},parse:{point:function(b){var a=OpenLayers.String.trim(b).split(this.regExes.spaces);return new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Point(a[0],a[1]))},multipoint:function(f){var b;var d=OpenLayers.String.trim(f).split(",");var e=[];for(var c=0,a=d.length;c<a;++c){b=d[c].replace(this.regExes.trimParens,"$1");e.push(this.parse.point.apply(this,[b]).geometry)}return new OpenLayers.Feature.Vector(new OpenLayers.Geometry.MultiPoint(e))},linestring:function(e){var c=OpenLayers.String.trim(e).split(",");var d=[];for(var b=0,a=c.length;b<a;++b){d.push(this.parse.point.apply(this,[c[b]]).geometry)}return new OpenLayers.Feature.Vector(new OpenLayers.Geometry.LineString(d))},multilinestring:function(f){var c;var b=OpenLayers.String.trim(f).split(this.regExes.parenComma);var e=[];for(var d=0,a=b.length;d<a;++d){c=b[d].replace(this.regExes.trimParens,"$1");e.push(this.parse.linestring.apply(this,[c]).geometry)}return new OpenLayers.Feature.Vector(new OpenLayers.Geometry.MultiLineString(e))},polygon:function(h){var c,b,f;var g=OpenLayers.String.trim(h).split(this.regExes.parenComma);var e=[];for(var d=0,a=g.length;d<a;++d){c=g[d].replace(this.regExes.trimParens,"$1");b=this.parse.linestring.apply(this,[c]).geometry;f=new OpenLayers.Geometry.LinearRing(b.components);e.push(f)}return new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Polygon(e))},multipolygon:function(f){var d;var b=OpenLayers.String.trim(f).split(this.regExes.doubleParenComma);var e=[];for(var c=0,a=b.length;c<a;++c){d=b[c].replace(this.regExes.trimParens,"$1");e.push(this.parse.polygon.apply(this,[d]).geometry)}return new OpenLayers.Feature.Vector(new OpenLayers.Geometry.MultiPolygon(e))},geometrycollection:function(e){e=e.replace(/,\s*([A-Za-z])/g,"|$1");var d=OpenLayers.String.trim(e).split("|");var c=[];for(var b=0,a=d.length;b<a;++b){c.push(OpenLayers.Format.WKT.prototype.read.apply(this,[d[b]]))}return c}},CLASS_NAME:"OpenLayers.Format.WKT"});OpenLayers.Protocol.SQL.Gears=OpenLayers.Class(OpenLayers.Protocol.SQL,{FID_PREFIX:"__gears_fid__",NULL_GEOMETRY:"__gears_null_geometry__",NULL_FEATURE_STATE:"__gears_null_feature_state__",jsonParser:null,wktParser:null,fidRegExp:null,saveFeatureState:true,typeOfFid:"string",db:null,initialize:function(a){if(!this.supported()){return}OpenLayers.Protocol.SQL.prototype.initialize.apply(this,[a]);this.jsonParser=new OpenLayers.Format.JSON();this.wktParser=new OpenLayers.Format.WKT();this.fidRegExp=new RegExp("^"+this.FID_PREFIX);this.initializeDatabase()},initializeDatabase:function(){this.db=google.gears.factory.create("beta.database");this.db.open(this.databaseName);this.db.execute("CREATE TABLE IF NOT EXISTS "+this.tableName+" (fid TEXT UNIQUE, geometry TEXT, properties TEXT,  state TEXT)")},destroy:function(){this.db.close();this.db=null;this.jsonParser=null;this.wktParser=null;OpenLayers.Protocol.SQL.prototype.destroy.apply(this)},supported:function(){return !!(window.google&&google.gears)},read:function(b){OpenLayers.Protocol.prototype.read.apply(this,arguments);b=OpenLayers.Util.applyDefaults(b,this.options);var c,d=[];var a=this.db.execute("SELECT * FROM "+this.tableName);while(a.isValidRow()){c=this.unfreezeFeature(a);if(this.evaluateFilter(c,b.filter)){if(!b.noFeatureStateReset){c.state=null}d.push(c)}a.next()}a.close();var e=new OpenLayers.Protocol.Response({code:OpenLayers.Protocol.Response.SUCCESS,requestType:"read",features:d});if(b&&b.callback){b.callback.call(b.scope,e)}return e},unfreezeFeature:function(d){var a;var b=d.fieldByName("geometry");if(b==this.NULL_GEOMETRY){a=new OpenLayers.Feature.Vector()}else{a=this.wktParser.read(b)}a.attributes=this.jsonParser.read(d.fieldByName("properties"));a.fid=this.extractFidFromField(d.fieldByName("fid"));var c=d.fieldByName("state");if(c==this.NULL_FEATURE_STATE){c=null}a.state=c;return a},extractFidFromField:function(a){if(!a.match(this.fidRegExp)&&this.typeOfFid=="number"){a=parseFloat(a)}return a},create:function(b,a){a=OpenLayers.Util.applyDefaults(a,this.options);var c=this.createOrUpdate(b);c.requestType="create";if(a&&a.callback){a.callback.call(a.scope,c)}return c},update:function(b,a){a=OpenLayers.Util.applyDefaults(a,this.options);var c=this.createOrUpdate(b);c.requestType="update";if(a&&a.callback){a.callback.call(a.scope,c)}return c},createOrUpdate:function(e){if(!(OpenLayers.Util.isArray(e))){e=[e]}var c,a=e.length,b;var d=new Array(a);for(c=0;c<a;c++){b=e[c];var f=this.freezeFeature(b);this.db.execute("REPLACE INTO "+this.tableName+" (fid, geometry, properties, state) VALUES (?, ?, ?, ?)",f);var g=b.clone();g.fid=this.extractFidFromField(f[0]);d[c]=g}return new OpenLayers.Protocol.Response({code:OpenLayers.Protocol.Response.SUCCESS,features:d,reqFeatures:e})},freezeFeature:function(b){b.fid=b.fid!=null?""+b.fid:OpenLayers.Util.createUniqueID(this.FID_PREFIX);var d=b.geometry!=null?b.geometry.toString():this.NULL_GEOMETRY;var a=this.jsonParser.write(b.attributes);var c=this.getFeatureStateForFreeze(b);return[b.fid,d,a,c]},getFeatureStateForFreeze:function(a){var b;if(!this.saveFeatureState){b=this.NULL_FEATURE_STATE}else{if(this.createdOffline(a)){b=OpenLayers.State.INSERT}else{b=a.state}}return b},"delete":function(f,c){if(!(OpenLayers.Util.isArray(f))){f=[f]}c=OpenLayers.Util.applyDefaults(c,this.options);var e,a,d;for(e=0,a=f.length;e<a;e++){d=f[e];if(this.saveFeatureState&&!this.createdOffline(d)){var b=d.clone();b.fid=d.fid;if(b.geometry){b.geometry.destroy();b.geometry=null}b.state=d.state;this.createOrUpdate(b)}else{this.db.execute("DELETE FROM "+this.tableName+" WHERE fid = ?",[d.fid])}}var g=new OpenLayers.Protocol.Response({code:OpenLayers.Protocol.Response.SUCCESS,requestType:"delete",reqFeatures:f});if(c&&c.callback){c.callback.call(c.scope,g)}return g},createdOffline:function(a){return(typeof a.fid=="string"&&!!(a.fid.match(this.fidRegExp)))},commit:function(c,m){var b,e=[],g=0,h=0;function k(i){if(++h<g){i.last=false}this.callUserCallback(m,i)}var l,j=[],a=[],d=[];for(var f=c.length-1;f>=0;f--){l=c[f];switch(l.state){case OpenLayers.State.INSERT:j.push(l);break;case OpenLayers.State.UPDATE:a.push(l);break;case OpenLayers.State.DELETE:d.push(l);break}}if(j.length>0){g++;b=OpenLayers.Util.applyDefaults({callback:k,scope:this},m.create);e.push(this.create(j,b))}if(a.length>0){g++;b=OpenLayers.Util.applyDefaults({callback:k,scope:this},m.update);e.push(this.update(a,b))}if(d.length>0){g++;b=OpenLayers.Util.applyDefaults({callback:k,scope:this},m["delete"]);e.push(this["delete"](d,b))}return e},clear:function(){this.db.execute("DELETE FROM "+this.tableName)},callUserCallback:function(a,c){var b=a[c.requestType];if(b&&b.callback){b.callback.call(b.scope,c)}if(c.last&&a.callback){a.callback.call(a.scope)}},CLASS_NAME:"OpenLayers.Protocol.SQL.Gears"});OpenLayers.Format.CSWGetRecords=function(b){b=OpenLayers.Util.applyDefaults(b,OpenLayers.Format.CSWGetRecords.DEFAULTS);var a=OpenLayers.Format.CSWGetRecords["v"+b.version.replace(/\./g,"_")];if(!a){throw"Unsupported CSWGetRecords version: "+b.version}return new a(b)};OpenLayers.Format.CSWGetRecords.DEFAULTS={version:"2.0.2"};OpenLayers.Format.XML=OpenLayers.Class(OpenLayers.Format,{namespaces:null,namespaceAlias:null,defaultPrefix:null,readers:{},writers:{},xmldom:null,initialize:function(a){if(window.ActiveXObject){this.xmldom=new ActiveXObject("Microsoft.XMLDOM")}OpenLayers.Format.prototype.initialize.apply(this,[a]);this.namespaces=OpenLayers.Util.extend({},this.namespaces);this.namespaceAlias={};for(var b in this.namespaces){this.namespaceAlias[this.namespaces[b]]=b}},destroy:function(){this.xmldom=null;OpenLayers.Format.prototype.destroy.apply(this,arguments)},setNamespace:function(a,b){this.namespaces[a]=b;this.namespaceAlias[b]=a},read:function(c){var a=c.indexOf("<");if(a>0){c=c.substring(a)}var b=OpenLayers.Util.Try(OpenLayers.Function.bind((function(){var d;if(window.ActiveXObject&&!this.xmldom){d=new ActiveXObject("Microsoft.XMLDOM")}else{d=this.xmldom}d.loadXML(c);return d}),this),function(){return new DOMParser().parseFromString(c,"text/xml")},function(){var d=new XMLHttpRequest();d.open("GET","data:text/xml;charset=utf-8,"+encodeURIComponent(c),false);if(d.overrideMimeType){d.overrideMimeType("text/xml")}d.send(null);return d.responseXML});if(this.keepData){this.data=b}return b},write:function(b){var c;if(this.xmldom){c=b.xml}else{var a=new XMLSerializer();if(b.nodeType==1){var d=document.implementation.createDocument("","",null);if(d.importNode){b=d.importNode(b,true)}d.appendChild(b);c=a.serializeToString(d)}else{c=a.serializeToString(b)}}return c},createElementNS:function(c,a){var b;if(this.xmldom){if(typeof c=="string"){b=this.xmldom.createNode(1,a,c)}else{b=this.xmldom.createNode(1,a,"")}}else{b=document.createElementNS(c,a)}return b},createTextNode:function(b){var a;if(typeof b!=="string"){b=String(b)}if(this.xmldom){a=this.xmldom.createTextNode(b)}else{a=document.createTextNode(b)}return a},getElementsByTagNameNS:function(e,d,c){var a=[];if(e.getElementsByTagNameNS){a=e.getElementsByTagNameNS(d,c)}else{var b=e.getElementsByTagName("*");var j,f;for(var g=0,h=b.length;g<h;++g){j=b[g];f=(j.prefix)?(j.prefix+":"+c):c;if((c=="*")||(f==j.nodeName)){if((d=="*")||(d==j.namespaceURI)){a.push(j)}}}}return a},getAttributeNodeNS:function(c,b,a){var j=null;if(c.getAttributeNodeNS){j=c.getAttributeNodeNS(b,a)}else{var e=c.attributes;var h,d;for(var f=0,g=e.length;f<g;++f){h=e[f];if(h.namespaceURI==b){d=(h.prefix)?(h.prefix+":"+a):a;if(d==h.nodeName){j=h;break}}}}return j},getAttributeNS:function(e,d,a){var b="";if(e.getAttributeNS){b=e.getAttributeNS(d,a)||""}else{var c=this.getAttributeNodeNS(e,d,a);if(c){b=c.nodeValue}}return b},getChildValue:function(a,c){var b=c||"";if(a){for(var d=a.firstChild;d;d=d.nextSibling){switch(d.nodeType){case 3:case 4:b+=d.nodeValue}}}return b},concatChildValues:function(b,d){var c="";var e=b.firstChild;var a;while(e){a=e.nodeValue;if(a){c+=a}e=e.nextSibling}if(c==""&&d!=undefined){c=d}return c},isSimpleContent:function(a){var c=true;for(var b=a.firstChild;b;b=b.nextSibling){if(b.nodeType===1){c=false;break}}return c},contentType:function(c){var e=false,b=false;var a=OpenLayers.Format.XML.CONTENT_TYPE.EMPTY;for(var d=c.firstChild;d;d=d.nextSibling){switch(d.nodeType){case 1:b=true;break;case 8:break;default:e=true}if(b&&e){break}}if(b&&e){a=OpenLayers.Format.XML.CONTENT_TYPE.MIXED}else{if(b){return OpenLayers.Format.XML.CONTENT_TYPE.COMPLEX}else{if(e){return OpenLayers.Format.XML.CONTENT_TYPE.SIMPLE}}}return a},hasAttributeNS:function(c,b,a){var d=false;if(c.hasAttributeNS){d=c.hasAttributeNS(b,a)}else{d=!!this.getAttributeNodeNS(c,b,a)}return d},setAttributeNS:function(d,c,a,e){if(d.setAttributeNS){d.setAttributeNS(c,a,e)}else{if(this.xmldom){if(c){var b=d.ownerDocument.createNode(2,a,c);b.nodeValue=e;d.setAttributeNode(b)}else{d.setAttribute(a,e)}}else{throw"setAttributeNS not implemented"}}},createElementNSPlus:function(b,a){a=a||{};var d=a.uri||this.namespaces[a.prefix];if(!d){var f=b.indexOf(":");d=this.namespaces[b.substring(0,f)]}if(!d){d=this.namespaces[this.defaultPrefix]}var c=this.createElementNS(d,b);if(a.attributes){this.setAttributes(c,a.attributes)}var e=a.value;if(e!=null){c.appendChild(this.createTextNode(e))}return c},setAttributes:function(c,e){var d,b;for(var a in e){if(e[a]!=null&&e[a].toString){d=e[a].toString();b=this.namespaces[a.substring(0,a.indexOf(":"))]||null;this.setAttributeNS(c,b,a,d)}}},readNode:function(c,e){if(!e){e={}}var d=this.readers[c.namespaceURI?this.namespaceAlias[c.namespaceURI]:this.defaultPrefix];if(d){var b=c.localName||c.nodeName.split(":").pop();var a=d[b]||d["*"];if(a){a.apply(this,[c,e])}}return e},readChildNodes:function(d,e){if(!e){e={}}var c=d.childNodes;var f;for(var b=0,a=c.length;b<a;++b){f=c[b];if(f.nodeType==1){this.readNode(f,e)}}return e},writeNode:function(a,f,d){var e,c;var b=a.indexOf(":");if(b>0){e=a.substring(0,b);c=a.substring(b+1)}else{if(d){e=this.namespaceAlias[d.namespaceURI]}else{e=this.defaultPrefix}c=a}var g=this.writers[e][c].apply(this,[f]);if(d){d.appendChild(g)}return g},getChildEl:function(c,a,b){return c&&this.getThisOrNextEl(c.firstChild,a,b)},getNextEl:function(c,a,b){return c&&this.getThisOrNextEl(c.nextSibling,a,b)},getThisOrNextEl:function(d,a,c){outer:for(var b=d;b;b=b.nextSibling){switch(b.nodeType){case 1:if((!a||a===(b.localName||b.nodeName.split(":").pop()))&&(!c||c===b.namespaceURI)){break outer}b=null;break outer;case 3:if(/^\s*$/.test(b.nodeValue)){break}case 4:case 6:case 12:case 10:case 11:b=null;break outer}}return b||null},lookupNamespaceURI:function(e,f){var d=null;if(e){if(e.lookupNamespaceURI){d=e.lookupNamespaceURI(f)}else{outer:switch(e.nodeType){case 1:if(e.namespaceURI!==null&&e.prefix===f){d=e.namespaceURI;break outer}var b=e.attributes.length;if(b){var a;for(var c=0;c<b;++c){a=e.attributes[c];if(a.prefix==="xmlns"&&a.name==="xmlns:"+f){d=a.value||null;break outer}else{if(a.name==="xmlns"&&f===null){d=a.value||null;break outer}}}}d=this.lookupNamespaceURI(e.parentNode,f);break outer;case 2:d=this.lookupNamespaceURI(e.ownerElement,f);break outer;case 9:d=this.lookupNamespaceURI(e.documentElement,f);break outer;case 6:case 12:case 10:case 11:break outer;default:d=this.lookupNamespaceURI(e.parentNode,f);break outer}}}return d},getXMLDoc:function(){if(!OpenLayers.Format.XML.document&&!this.xmldom){if(document.implementation&&document.implementation.createDocument){OpenLayers.Format.XML.document=document.implementation.createDocument("","",null)}else{if(!this.xmldom&&window.ActiveXObject){this.xmldom=new ActiveXObject("Microsoft.XMLDOM")}}}return OpenLayers.Format.XML.document||this.xmldom},CLASS_NAME:"OpenLayers.Format.XML"});OpenLayers.Format.XML.CONTENT_TYPE={EMPTY:0,SIMPLE:1,COMPLEX:2,MIXED:3};OpenLayers.Format.XML.lookupNamespaceURI=OpenLayers.Function.bind(OpenLayers.Format.XML.prototype.lookupNamespaceURI,OpenLayers.Format.XML.prototype);OpenLayers.Format.XML.document=null;OpenLayers.Format.OGCExceptionReport=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{ogc:"http://www.opengis.net/ogc"},regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},defaultPrefix:"ogc",read:function(c){var a;if(typeof c=="string"){c=OpenLayers.Format.XML.prototype.read.apply(this,[c])}var b=c.documentElement;var d={exceptionReport:null};if(b){this.readChildNodes(c,d);if(d.exceptionReport===null){d=new OpenLayers.Format.OWSCommon().read(c)}}return d},readers:{ogc:{ServiceExceptionReport:function(a,b){b.exceptionReport={exceptions:[]};this.readChildNodes(a,b.exceptionReport)},ServiceException:function(b,c){var a={code:b.getAttribute("code"),locator:b.getAttribute("locator"),text:this.getChildValue(b)};c.exceptions.push(a)}}},CLASS_NAME:"OpenLayers.Format.OGCExceptionReport"});OpenLayers.Format.XML.VersionedOGC=OpenLayers.Class(OpenLayers.Format.XML,{defaultVersion:null,version:null,profile:null,errorProperty:null,name:null,stringifyOutput:false,parser:null,initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a]);var b=this.CLASS_NAME;this.name=b.substring(b.lastIndexOf(".")+1)},getVersion:function(b,c){var a;if(b){a=this.version;if(!a){a=b.getAttribute("version");if(!a){a=this.defaultVersion}}}else{a=(c&&c.version)||this.version||this.defaultVersion}return a},getParser:function(a){a=a||this.defaultVersion;var b=this.profile?"_"+this.profile:"";if(!this.parser||this.parser.VERSION!=a){var c=OpenLayers.Format[this.name]["v"+a.replace(/\./g,"_")+b];if(!c){throw"Can't find a "+this.name+" parser for version "+a+b}this.parser=new c(this.options)}return this.parser},write:function(d,c){var b=this.getVersion(null,c);this.parser=this.getParser(b);var a=this.parser.write(d,c);if(this.stringifyOutput===false){return a}else{return OpenLayers.Format.XML.prototype.write.apply(this,[a])}},read:function(d,c){if(typeof d=="string"){d=OpenLayers.Format.XML.prototype.read.apply(this,[d])}var b=d.documentElement;var a=this.getVersion(b);this.parser=this.getParser(a);var f=this.parser.read(d,c);if(this.errorProperty!==null&&f[this.errorProperty]===undefined){var e=new OpenLayers.Format.OGCExceptionReport();f.error=e.read(d)}f.version=a;return f},CLASS_NAME:"OpenLayers.Format.XML.VersionedOGC"});OpenLayers.Format.WFSCapabilities=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.1.0",errorProperty:"service",CLASS_NAME:"OpenLayers.Format.WFSCapabilities"});OpenLayers.Format.WFSCapabilities.v1=OpenLayers.Class(OpenLayers.Format.WFSCapabilities,{initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a]);this.options=a},read:function(c){if(typeof c=="string"){c=OpenLayers.Format.XML.prototype.read.apply(this,[c])}var a={};var b=c.documentElement;this.runChildNodes(a,b);return a},runChildNodes:function(f,e){var c=e.childNodes;var b,d;for(var a=0;a<c.length;++a){b=c[a];if(b.nodeType==1){d=this["read_cap_"+b.nodeName];if(d){d.apply(this,[f,b])}}}},read_cap_FeatureTypeList:function(c,b){var a={featureTypes:[]};this.runChildNodes(a,b);c.featureTypeList=a},read_cap_FeatureType:function(a,d,b){var c={};this.runChildNodes(c,d);a.featureTypes.push(c)},read_cap_Name:function(d,b){var a=this.getChildValue(b);if(a){var c=a.split(":");d.name=c.pop();if(c.length>0){d.featureNS=this.lookupNamespaceURI(b,c[0])}}},read_cap_Title:function(b,a){var c=this.getChildValue(a);if(c){b.title=c}},read_cap_Abstract:function(c,b){var a=this.getChildValue(b);if(a){c["abstract"]=a}},CLASS_NAME:"OpenLayers.Format.WFSCapabilities.v1"});OpenLayers.Format.WFSCapabilities.v1_1_0=OpenLayers.Class(OpenLayers.Format.WFSCapabilities.v1,{initialize:function(a){OpenLayers.Format.WFSCapabilities.v1.prototype.initialize.apply(this,[a])},read_cap_DefaultSRS:function(c,b){var a=this.getChildValue(b);if(a){c.srs=a}},CLASS_NAME:"OpenLayers.Format.WFSCapabilities.v1_1_0"});OpenLayers.Geometry=OpenLayers.Class({id:null,parent:null,bounds:null,initialize:function(){this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")},destroy:function(){this.id=null;this.bounds=null},clone:function(){return new OpenLayers.Geometry()},setBounds:function(a){if(a){this.bounds=a.clone()}},clearBounds:function(){this.bounds=null;if(this.parent){this.parent.clearBounds()}},extendBounds:function(b){var a=this.getBounds();if(!a){this.setBounds(b)}else{this.bounds.extend(b)}},getBounds:function(){if(this.bounds==null){this.calculateBounds()}return this.bounds},calculateBounds:function(){},distanceTo:function(b,a){},getVertices:function(a){},atPoint:function(e,h,f){var c=false;var d=this.getBounds();if((d!=null)&&(e!=null)){var b=(h!=null)?h:0;var a=(f!=null)?f:0;var g=new OpenLayers.Bounds(this.bounds.left-b,this.bounds.bottom-a,this.bounds.right+b,this.bounds.top+a);c=g.containsLonLat(e)}return c},getLength:function(){return 0},getArea:function(){return 0},getCentroid:function(){return null},toString:function(){return OpenLayers.Format.WKT.prototype.write(new OpenLayers.Feature.Vector(this))},CLASS_NAME:"OpenLayers.Geometry"});OpenLayers.Geometry.fromWKT=function(f){var g=arguments.callee.format;if(!g){g=new OpenLayers.Format.WKT();arguments.callee.format=g}var d;var b=g.read(f);if(b instanceof OpenLayers.Feature.Vector){d=b.geometry}else{if(OpenLayers.Util.isArray(b)){var a=b.length;var e=new Array(a);for(var c=0;c<a;++c){e[c]=b[c].geometry}d=new OpenLayers.Geometry.Collection(e)}}return d};OpenLayers.Geometry.segmentsIntersect=function(a,H,b){var s=b&&b.point;var z=b&&b.tolerance;var f=false;var B=a.x1-H.x1;var F=a.y1-H.y1;var o=a.x2-a.x1;var w=a.y2-a.y1;var t=H.y2-H.y1;var l=H.x2-H.x1;var D=(t*o)-(l*w);var e=(l*F)-(t*B);var c=(o*F)-(w*B);if(D==0){if(e==0&&c==0){f=true}}else{var E=e/D;var C=c/D;if(E>=0&&E<=1&&C>=0&&C<=1){if(!s){f=true}else{var h=a.x1+(E*o);var g=a.y1+(E*w);f=new OpenLayers.Geometry.Point(h,g)}}}if(z){var r;if(f){if(s){var n=[a,H];var A,h,g;outer:for(var v=0;v<2;++v){A=n[v];for(var u=1;u<3;++u){h=A["x"+u];g=A["y"+u];r=Math.sqrt(Math.pow(h-f.x,2)+Math.pow(g-f.y,2));if(r<z){f.x=h;f.y=g;break outer}}}}}else{var n=[a,H];var q,G,h,g,m,k;outer:for(var v=0;v<2;++v){q=n[v];G=n[(v+1)%2];for(var u=1;u<3;++u){m={x:q["x"+u],y:q["y"+u]};k=OpenLayers.Geometry.distanceToSegment(m,G);if(k.distance<z){if(s){f=new OpenLayers.Geometry.Point(m.x,m.y)}else{f=true}break outer}}}}}return f};OpenLayers.Geometry.distanceToSegment=function(k,d){var c=k.x;var j=k.y;var b=d.x1;var i=d.y1;var a=d.x2;var f=d.y2;var m=a-b;var l=f-i;var h=((m*(c-b))+(l*(j-i)))/(Math.pow(m,2)+Math.pow(l,2));var g,e;if(h<=0){g=b;e=i}else{if(h>=1){g=a;e=f}else{g=b+h*m;e=i+h*l}}return{distance:Math.sqrt(Math.pow(g-c,2)+Math.pow(e-j,2)),x:g,y:e}};OpenLayers.Geometry.Point=OpenLayers.Class(OpenLayers.Geometry,{x:null,y:null,initialize:function(a,b){OpenLayers.Geometry.prototype.initialize.apply(this,arguments);this.x=parseFloat(a);this.y=parseFloat(b)},clone:function(a){if(a==null){a=new OpenLayers.Geometry.Point(this.x,this.y)}OpenLayers.Util.applyDefaults(a,this);return a},calculateBounds:function(){this.bounds=new OpenLayers.Bounds(this.x,this.y,this.x,this.y)},distanceTo:function(f,j){var d=!(j&&j.edge===false);var a=d&&j&&j.details;var b,e,h,c,g,i;if(f instanceof OpenLayers.Geometry.Point){e=this.x;h=this.y;c=f.x;g=f.y;b=Math.sqrt(Math.pow(e-c,2)+Math.pow(h-g,2));i=!a?b:{x0:e,y0:h,x1:c,y1:g,distance:b}}else{i=f.distanceTo(this,j);if(a){i={x0:i.x1,y0:i.y1,x1:i.x0,y1:i.y0,distance:i.distance}}}return i},equals:function(a){var b=false;if(a!=null){b=((this.x==a.x&&this.y==a.y)||(isNaN(this.x)&&isNaN(this.y)&&isNaN(a.x)&&isNaN(a.y)))}return b},toShortString:function(){return(this.x+", "+this.y)},move:function(a,b){this.x=this.x+a;this.y=this.y+b;this.clearBounds()},rotate:function(d,b){d*=Math.PI/180;var a=this.distanceTo(b);var c=d+Math.atan2(this.y-b.y,this.x-b.x);this.x=b.x+(a*Math.cos(c));this.y=b.y+(a*Math.sin(c));this.clearBounds()},getCentroid:function(){return new OpenLayers.Geometry.Point(this.x,this.y)},resize:function(c,a,b){b=(b==undefined)?1:b;this.x=a.x+(c*b*(this.x-a.x));this.y=a.y+(c*(this.y-a.y));this.clearBounds();return this},intersects:function(b){var a=false;if(b.CLASS_NAME=="OpenLayers.Geometry.Point"){a=this.equals(b)}else{a=b.intersects(this)}return a},transform:function(b,a){if((b&&a)){OpenLayers.Projection.transform(this,b,a);this.bounds=null}return this},getVertices:function(a){return[this]},CLASS_NAME:"OpenLayers.Geometry.Point"});OpenLayers.Geometry.Collection=OpenLayers.Class(OpenLayers.Geometry,{components:null,componentTypes:null,initialize:function(a){OpenLayers.Geometry.prototype.initialize.apply(this,arguments);this.components=[];if(a!=null){this.addComponents(a)}},destroy:function(){this.components.length=0;this.components=null;OpenLayers.Geometry.prototype.destroy.apply(this,arguments)},clone:function(){var geometry=eval("new "+this.CLASS_NAME+"()");for(var i=0,len=this.components.length;i<len;i++){geometry.addComponent(this.components[i].clone())}OpenLayers.Util.applyDefaults(geometry,this);return geometry},getComponentsString:function(){var b=[];for(var c=0,a=this.components.length;c<a;c++){b.push(this.components[c].toShortString())}return b.join(",")},calculateBounds:function(){this.bounds=null;var d=new OpenLayers.Bounds();var c=this.components;if(c){for(var b=0,a=c.length;b<a;b++){d.extend(c[b].getBounds())}}if(d.left!=null&&d.bottom!=null&&d.right!=null&&d.top!=null){this.setBounds(d)}},addComponents:function(c){if(!(OpenLayers.Util.isArray(c))){c=[c]}for(var b=0,a=c.length;b<a;b++){this.addComponent(c[b])}},addComponent:function(b,a){var d=false;if(b){if(this.componentTypes==null||(OpenLayers.Util.indexOf(this.componentTypes,b.CLASS_NAME)>-1)){if(a!=null&&(a<this.components.length)){var e=this.components.slice(0,a);var c=this.components.slice(a,this.components.length);e.push(b);this.components=e.concat(c)}else{this.components.push(b)}b.parent=this;this.clearBounds();d=true}}return d},removeComponents:function(b){var c=false;if(!(OpenLayers.Util.isArray(b))){b=[b]}for(var a=b.length-1;a>=0;--a){c=this.removeComponent(b[a])||c}return c},removeComponent:function(a){OpenLayers.Util.removeItem(this.components,a);this.clearBounds();return true},getLength:function(){var c=0;for(var b=0,a=this.components.length;b<a;b++){c+=this.components[b].getLength()}return c},getArea:function(){var c=0;for(var b=0,a=this.components.length;b<a;b++){c+=this.components[b].getArea()}return c},getGeodesicArea:function(b){var d=0;for(var c=0,a=this.components.length;c<a;c++){d+=this.components[c].getGeodesicArea(b)}return d},getCentroid:function(g){if(!g){return this.components.length&&this.components[0].getCentroid()}var l=this.components.length;if(!l){return false}var b=[];var c=[];var d=0;var h=Number.MAX_VALUE;var m;for(var k=0;k<l;++k){m=this.components[k];var e=m.getArea();var f=m.getCentroid(true);if(isNaN(e)||isNaN(f.x)||isNaN(f.y)){continue}b.push(e);d+=e;h=(e<h&&e>0)?e:h;c.push(f)}l=b.length;if(d===0){for(var k=0;k<l;++k){b[k]=1}d=b.length}else{for(var k=0;k<l;++k){b[k]/=h}d/=h}var j=0,a=0,f,e;for(var k=0;k<l;++k){f=c[k];e=b[k];j+=f.x*e;a+=f.y*e}return new OpenLayers.Geometry.Point(j/d,a/d)},getGeodesicLength:function(b){var d=0;for(var c=0,a=this.components.length;c<a;c++){d+=this.components[c].getGeodesicLength(b)}return d},move:function(b,d){for(var c=0,a=this.components.length;c<a;c++){this.components[c].move(b,d)}},rotate:function(d,b){for(var c=0,a=this.components.length;c<a;++c){this.components[c].rotate(d,b)}},resize:function(d,a,c){for(var b=0;b<this.components.length;++b){this.components[b].resize(d,a,c)}return this},distanceTo:function(h,j){var c=!(j&&j.edge===false);var a=c&&j&&j.details;var k,d,b;var e=Number.POSITIVE_INFINITY;for(var f=0,g=this.components.length;f<g;++f){k=this.components[f].distanceTo(h,j);b=a?k.distance:k;if(b<e){e=b;d=k;if(e==0){break}}}return d},equals:function(d){var b=true;if(!d||!d.CLASS_NAME||(this.CLASS_NAME!=d.CLASS_NAME)){b=false}else{if(!(OpenLayers.Util.isArray(d.components))||(d.components.length!=this.components.length)){b=false}else{for(var c=0,a=this.components.length;c<a;++c){if(!this.components[c].equals(d.components[c])){b=false;break}}}}return b},transform:function(e,c){if(e&&c){for(var d=0,a=this.components.length;d<a;d++){var b=this.components[d];b.transform(e,c)}this.bounds=null}return this},intersects:function(d){var b=false;for(var c=0,a=this.components.length;c<a;++c){b=d.intersects(this.components[c]);if(b){break}}return b},getVertices:function(b){var c=[];for(var d=0,a=this.components.length;d<a;++d){Array.prototype.push.apply(c,this.components[d].getVertices(b))}return c},CLASS_NAME:"OpenLayers.Geometry.Collection"});OpenLayers.Geometry.MultiPoint=OpenLayers.Class(OpenLayers.Geometry.Collection,{componentTypes:["OpenLayers.Geometry.Point"],initialize:function(a){OpenLayers.Geometry.Collection.prototype.initialize.apply(this,arguments)},addPoint:function(a,b){this.addComponent(a,b)},removePoint:function(a){this.removeComponent(a)},CLASS_NAME:"OpenLayers.Geometry.MultiPoint"});OpenLayers.Geometry.Curve=OpenLayers.Class(OpenLayers.Geometry.MultiPoint,{componentTypes:["OpenLayers.Geometry.Point"],initialize:function(a){OpenLayers.Geometry.MultiPoint.prototype.initialize.apply(this,arguments)},getLength:function(){var c=0;if(this.components&&(this.components.length>1)){for(var b=1,a=this.components.length;b<a;b++){c+=this.components[b-1].distanceTo(this.components[b])}}return c},getGeodesicLength:function(b){var e=this;if(b){var c=new OpenLayers.Projection("EPSG:4326");if(!c.equals(b)){e=this.clone().transform(b,c)}}var f=0;if(e.components&&(e.components.length>1)){var h,g;for(var d=1,a=e.components.length;d<a;d++){h=e.components[d-1];g=e.components[d];f+=OpenLayers.Util.distVincenty({lon:h.x,lat:h.y},{lon:g.x,lat:g.y})}}return f*1000},CLASS_NAME:"OpenLayers.Geometry.Curve"});OpenLayers.Geometry.LineString=OpenLayers.Class(OpenLayers.Geometry.Curve,{initialize:function(a){OpenLayers.Geometry.Curve.prototype.initialize.apply(this,arguments)},removeComponent:function(a){var b=this.components&&(this.components.length>2);if(b){OpenLayers.Geometry.Collection.prototype.removeComponent.apply(this,arguments)}return b},intersects:function(m){var c=false;var l=m.CLASS_NAME;if(l=="OpenLayers.Geometry.LineString"||l=="OpenLayers.Geometry.LinearRing"||l=="OpenLayers.Geometry.Point"){var p=this.getSortedSegments();var n;if(l=="OpenLayers.Geometry.Point"){n=[{x1:m.x,y1:m.y,x2:m.x,y2:m.y}]}else{n=m.getSortedSegments()}var s,g,e,a,r,q,d,b;outer:for(var h=0,k=p.length;h<k;++h){s=p[h];g=s.x1;e=s.x2;a=s.y1;r=s.y2;inner:for(var f=0,o=n.length;f<o;++f){q=n[f];if(q.x1>e){break}if(q.x2<g){continue}d=q.y1;b=q.y2;if(Math.min(d,b)>Math.max(a,r)){continue}if(Math.max(d,b)<Math.min(a,r)){continue}if(OpenLayers.Geometry.segmentsIntersect(s,q)){c=true;break outer}}}}else{c=m.intersects(this)}return c},getSortedSegments:function(){var a=this.components.length-1;var b=new Array(a),e,d;for(var c=0;c<a;++c){e=this.components[c];d=this.components[c+1];if(e.x<d.x){b[c]={x1:e.x,y1:e.y,x2:d.x,y2:d.y}}else{b[c]={x1:d.x,y1:d.y,x2:e.x,y2:e.y}}}function f(h,g){return h.x1-g.x1}return b.sort(f)},splitWithSegment:function(r,b){var c=!(b&&b.edge===false);var o=b&&b.tolerance;var a=[];var t=this.getVertices();var n=[];var v=[];var h=false;var e,d,l;var j,q,u;var f={point:true,tolerance:o};var g=null;for(var m=0,k=t.length-2;m<=k;++m){e=t[m];n.push(e.clone());d=t[m+1];u={x1:e.x,y1:e.y,x2:d.x,y2:d.y};l=OpenLayers.Geometry.segmentsIntersect(r,u,f);if(l instanceof OpenLayers.Geometry.Point){if((l.x===r.x1&&l.y===r.y1)||(l.x===r.x2&&l.y===r.y2)||l.equals(e)||l.equals(d)){q=true}else{q=false}if(q||c){if(!l.equals(v[v.length-1])){v.push(l.clone())}if(m===0){if(l.equals(e)){continue}}if(l.equals(d)){continue}h=true;if(!l.equals(e)){n.push(l)}a.push(new OpenLayers.Geometry.LineString(n));n=[l.clone()]}}}if(h){n.push(d.clone());a.push(new OpenLayers.Geometry.LineString(n))}if(v.length>0){var p=r.x1<r.x2?1:-1;var s=r.y1<r.y2?1:-1;g={lines:a,points:v.sort(function(w,i){return(p*w.x-p*i.x)||(s*w.y-s*i.y)})}}return g},split:function(x,b){var n=null;var d=b&&b.mutual;var l,e,m,c;if(x instanceof OpenLayers.Geometry.LineString){var w=this.getVertices();var g,f,v,h,a,p;var s=[];m=[];for(var t=0,o=w.length-2;t<=o;++t){g=w[t];f=w[t+1];v={x1:g.x,y1:g.y,x2:f.x,y2:f.y};c=c||[x];if(d){s.push(g.clone())}for(var r=0;r<c.length;++r){h=c[r].splitWithSegment(v,b);if(h){a=h.lines;if(a.length>0){a.unshift(r,1);Array.prototype.splice.apply(c,a);r+=a.length-2}if(d){for(var q=0,u=h.points.length;q<u;++q){p=h.points[q];if(!p.equals(g)){s.push(p);m.push(new OpenLayers.Geometry.LineString(s));if(p.equals(f)){s=[]}else{s=[p.clone()]}}}}}}}if(d&&m.length>0&&s.length>0){s.push(f.clone());m.push(new OpenLayers.Geometry.LineString(s))}}else{n=x.splitWith(this,b)}if(c&&c.length>1){e=true}else{c=[]}if(m&&m.length>1){l=true}else{m=[]}if(e||l){if(d){n=[m,c]}else{n=c}}return n},splitWith:function(b,a){return b.split(this,a)},getVertices:function(a){var b;if(a===true){b=[this.components[0],this.components[this.components.length-1]]}else{if(a===false){b=this.components.slice(1,this.components.length-1)}else{b=this.components.slice()}}return b},distanceTo:function(h,g){var k=!(g&&g.edge===false);var B=k&&g&&g.details;var q,e={};var t=Number.POSITIVE_INFINITY;if(h instanceof OpenLayers.Geometry.Point){var r=this.getSortedSegments();var p=h.x;var o=h.y;var z;for(var v=0,w=r.length;v<w;++v){z=r[v];q=OpenLayers.Geometry.distanceToSegment(h,z);if(q.distance<t){t=q.distance;e=q;if(t===0){break}}else{if(z.x2>p&&((o>z.y1&&o<z.y2)||(o<z.y1&&o>z.y2))){break}}}if(B){e={distance:e.distance,x0:e.x,y0:e.y,x1:p,y1:o}}else{e=e.distance}}else{if(h instanceof OpenLayers.Geometry.LineString){var d=this.getSortedSegments();var c=h.getSortedSegments();var b,a,n,A,f;var m=c.length;var l={point:true};outer:for(var v=0,w=d.length;v<w;++v){b=d[v];A=b.x1;f=b.y1;for(var u=0;u<m;++u){a=c[u];n=OpenLayers.Geometry.segmentsIntersect(b,a,l);if(n){t=0;e={distance:0,x0:n.x,y0:n.y,x1:n.x,y1:n.y};break outer}else{q=OpenLayers.Geometry.distanceToSegment({x:A,y:f},a);if(q.distance<t){t=q.distance;e={distance:t,x0:A,y0:f,x1:q.x,y1:q.y}}}}}if(!B){e=e.distance}if(t!==0){if(b){q=h.distanceTo(new OpenLayers.Geometry.Point(b.x2,b.y2),g);var s=B?q.distance:q;if(s<t){if(B){e={distance:t,x0:q.x1,y0:q.y1,x1:q.x0,y1:q.y0}}else{e=s}}}}}else{e=h.distanceTo(this,g);if(B){e={distance:e.distance,x0:e.x1,y0:e.y1,x1:e.x0,y1:e.y0}}}}return e},simplify:function(h){if(this&&this!==null){var j=this.getVertices();if(j.length<3){return this}var d=function(l,k){return(l-k)};var c=function(n,q,o,k){var p=0;var m=0;for(var l=q,r;l<o;l++){r=b(n[q],n[o],n[l]);if(r>p){p=r;m=l}}if(p>k&&m!=q){e.push(m);c(n,q,m,k);c(n,m,o,k)}};var b=function(o,n,l){var p=Math.abs(0.5*(o.x*n.y+n.x*l.y+l.x*o.y-n.x*o.y-l.x*n.y-o.x*l.y));var m=Math.sqrt(Math.pow(o.x-n.x,2)+Math.pow(o.y-n.y,2));var k=p/m*2;return k};var f=0;var i=j.length-1;var e=[];e.push(f);e.push(i);while(j[f].equals(j[i])){i--;e.push(i)}c(j,f,i,h);var a=[];e.sort(d);for(var g=0;g<e.length;g++){a.push(j[e[g]])}return new OpenLayers.Geometry.LineString(a)}else{return this}},CLASS_NAME:"OpenLayers.Geometry.LineString"});OpenLayers.Geometry.LinearRing=OpenLayers.Class(OpenLayers.Geometry.LineString,{componentTypes:["OpenLayers.Geometry.Point"],initialize:function(a){OpenLayers.Geometry.LineString.prototype.initialize.apply(this,arguments)},addComponent:function(a,b){var c=false;var d=this.components.pop();if(b!=null||!a.equals(d)){c=OpenLayers.Geometry.Collection.prototype.addComponent.apply(this,arguments)}var e=this.components[0];OpenLayers.Geometry.Collection.prototype.addComponent.apply(this,[e]);return c},removeComponent:function(a){var b=this.components&&(this.components.length>3);if(b){this.components.pop();OpenLayers.Geometry.Collection.prototype.removeComponent.apply(this,arguments);var c=this.components[0];OpenLayers.Geometry.Collection.prototype.addComponent.apply(this,[c])}return b},move:function(b,d){for(var c=0,a=this.components.length;c<a-1;c++){this.components[c].move(b,d)}},rotate:function(d,b){for(var c=0,a=this.components.length;c<a-1;++c){this.components[c].rotate(d,b)}},resize:function(e,b,d){for(var c=0,a=this.components.length;c<a-1;++c){this.components[c].resize(e,b,d)}return this},transform:function(e,c){if(e&&c){for(var d=0,a=this.components.length;d<a-1;d++){var b=this.components[d];b.transform(e,c)}this.bounds=null}return this},getCentroid:function(){if(this.components&&(this.components.length>2)){var h=0;var g=0;for(var e=0;e<this.components.length-1;e++){var d=this.components[e];var k=this.components[e+1];h+=(d.x+k.x)*(d.x*k.y-k.x*d.y);g+=(d.y+k.y)*(d.x*k.y-k.x*d.y)}var f=-1*this.getArea();var a=h/(6*f);var j=g/(6*f);return new OpenLayers.Geometry.Point(a,j)}else{return null}},getArea:function(){var g=0;if(this.components&&(this.components.length>2)){var f=0;for(var e=0,d=this.components.length;e<d-1;e++){var a=this.components[e];var h=this.components[e+1];f+=(a.x+h.x)*(h.y-a.y)}g=-f/2}return g},getGeodesicArea:function(b){var d=this;if(b){var c=new OpenLayers.Projection("EPSG:4326");if(!c.equals(b)){d=this.clone().transform(b,c)}}var f=0;var a=d.components&&d.components.length;if(a>2){var h,g;for(var e=0;e<a-1;e++){h=d.components[e];g=d.components[e+1];f+=OpenLayers.Util.rad(g.x-h.x)*(2+Math.sin(OpenLayers.Util.rad(h.y))+Math.sin(OpenLayers.Util.rad(g.y)))}f=f*6378137*6378137/2}return f},containsPoint:function(m){var s=OpenLayers.Number.limitSigDigs;var l=14;var k=s(m.x,l);var j=s(m.y,l);function r(w,t,v,i,u){return(((t-i)*w)+((i*v)-(t*u)))/(v-u)}var a=this.components.length-1;var g,f,q,d,o,b,e,c;var h=0;for(var n=0;n<a;++n){g=this.components[n];q=s(g.x,l);d=s(g.y,l);f=this.components[n+1];o=s(f.x,l);b=s(f.y,l);if(d==b){if(j==d){if(q<=o&&(k>=q&&k<=o)||q>=o&&(k<=q&&k>=o)){h=-1;break}}continue}e=s(r(j,q,d,o,b),l);if(e==k){if(d<b&&(j>=d&&j<=b)||d>b&&(j<=d&&j>=b)){h=-1;break}}if(e<=k){continue}if(q!=o&&(e<Math.min(q,o)||e>Math.max(q,o))){continue}if(d<b&&(j>=d&&j<b)||d>b&&(j<d&&j>=b)){++h}}var p=(h==-1)?1:!!(h&1);return p},intersects:function(d){var b=false;if(d.CLASS_NAME=="OpenLayers.Geometry.Point"){b=this.containsPoint(d)}else{if(d.CLASS_NAME=="OpenLayers.Geometry.LineString"){b=d.intersects(this)}else{if(d.CLASS_NAME=="OpenLayers.Geometry.LinearRing"){b=OpenLayers.Geometry.LineString.prototype.intersects.apply(this,[d])}else{for(var c=0,a=d.components.length;c<a;++c){b=d.components[c].intersects(this);if(b){break}}}}}return b},getVertices:function(a){return(a===true)?[]:this.components.slice(0,this.components.length-1)},CLASS_NAME:"OpenLayers.Geometry.LinearRing"});OpenLayers.Geometry.Polygon=OpenLayers.Class(OpenLayers.Geometry.Collection,{componentTypes:["OpenLayers.Geometry.LinearRing"],initialize:function(a){OpenLayers.Geometry.Collection.prototype.initialize.apply(this,arguments)},getArea:function(){var c=0;if(this.components&&(this.components.length>0)){c+=Math.abs(this.components[0].getArea());for(var b=1,a=this.components.length;b<a;b++){c-=Math.abs(this.components[b].getArea())}}return c},getGeodesicArea:function(b){var d=0;if(this.components&&(this.components.length>0)){d+=Math.abs(this.components[0].getGeodesicArea(b));for(var c=1,a=this.components.length;c<a;c++){d-=Math.abs(this.components[c].getGeodesicArea(b))}}return d},containsPoint:function(a){var e=this.components.length;var c=false;if(e>0){c=this.components[0].containsPoint(a);if(c!==1){if(c&&e>1){var d;for(var b=1;b<e;++b){d=this.components[b].containsPoint(a);if(d){if(d===1){c=1}else{c=false}break}}}}}return c},intersects:function(e){var b=false;var d,a;if(e.CLASS_NAME=="OpenLayers.Geometry.Point"){b=this.containsPoint(e)}else{if(e.CLASS_NAME=="OpenLayers.Geometry.LineString"||e.CLASS_NAME=="OpenLayers.Geometry.LinearRing"){for(d=0,a=this.components.length;d<a;++d){b=e.intersects(this.components[d]);if(b){break}}if(!b){for(d=0,a=e.components.length;d<a;++d){b=this.containsPoint(e.components[d]);if(b){break}}}}else{for(d=0,a=e.components.length;d<a;++d){b=this.intersects(e.components[d]);if(b){break}}}}if(!b&&e.CLASS_NAME=="OpenLayers.Geometry.Polygon"){var c=this.components[0];for(d=0,a=c.components.length;d<a;++d){b=e.containsPoint(c.components[d]);if(b){break}}}return b},distanceTo:function(d,b){var c=!(b&&b.edge===false);var a;if(!c&&this.intersects(d)){a=0}else{a=OpenLayers.Geometry.Collection.prototype.distanceTo.apply(this,[d,b])}return a},CLASS_NAME:"OpenLayers.Geometry.Polygon"});OpenLayers.Geometry.Polygon.createRegularPolygon=function(j,f,b,l){var c=Math.PI*((1/b)-(1/2));if(l){c+=(l/180)*Math.PI}var a,h,g;var k=[];for(var e=0;e<b;++e){a=c+(e*2*Math.PI/b);h=j.x+(f*Math.cos(a));g=j.y+(f*Math.sin(a));k.push(new OpenLayers.Geometry.Point(h,g))}var d=new OpenLayers.Geometry.LinearRing(k);return new OpenLayers.Geometry.Polygon([d])};OpenLayers.Format.GeoRSS=OpenLayers.Class(OpenLayers.Format.XML,{rssns:"http://backend.userland.com/rss2",featureNS:"http://mapserver.gis.umn.edu/mapserver",georssns:"http://www.georss.org/georss",geons:"http://www.w3.org/2003/01/geo/wgs84_pos#",featureTitle:"Untitled",featureDescription:"No Description",gmlParser:null,xy:false,createGeometryFromItem:function(n){var m=this.getElementsByTagNameNS(n,this.georssns,"point");var g=this.getElementsByTagNameNS(n,this.geons,"lat");var a=this.getElementsByTagNameNS(n,this.geons,"long");var p=this.getElementsByTagNameNS(n,this.georssns,"line");var k=this.getElementsByTagNameNS(n,this.georssns,"polygon");var c=this.getElementsByTagNameNS(n,this.georssns,"where");var d=this.getElementsByTagNameNS(n,this.georssns,"box");if(m.length>0||(g.length>0&&a.length>0)){var l;if(m.length>0){l=OpenLayers.String.trim(m[0].firstChild.nodeValue).split(/\s+/);if(l.length!=2){l=OpenLayers.String.trim(m[0].firstChild.nodeValue).split(/\s*,\s*/)}}else{l=[parseFloat(g[0].firstChild.nodeValue),parseFloat(a[0].firstChild.nodeValue)]}var h=new OpenLayers.Geometry.Point(parseFloat(l[1]),parseFloat(l[0]))}else{if(p.length>0){var j=OpenLayers.String.trim(this.concatChildValues(p[0])).split(/\s+/);var e=[];var m;for(var b=0,f=j.length;b<f;b+=2){m=new OpenLayers.Geometry.Point(parseFloat(j[b+1]),parseFloat(j[b]));e.push(m)}h=new OpenLayers.Geometry.LineString(e)}else{if(k.length>0){var j=OpenLayers.String.trim(this.concatChildValues(k[0])).split(/\s+/);var e=[];var m;for(var b=0,f=j.length;b<f;b+=2){m=new OpenLayers.Geometry.Point(parseFloat(j[b+1]),parseFloat(j[b]));e.push(m)}h=new OpenLayers.Geometry.Polygon([new OpenLayers.Geometry.LinearRing(e)])}else{if(c.length>0){if(!this.gmlParser){this.gmlParser=new OpenLayers.Format.GML({xy:this.xy})}var o=this.gmlParser.parseFeature(c[0]);h=o.geometry}else{if(d.length>0){var j=OpenLayers.String.trim(d[0].firstChild.nodeValue).split(/\s+/);var e=[];var m;if(j.length>3){m=new OpenLayers.Geometry.Point(parseFloat(j[1]),parseFloat(j[0]));e.push(m);m=new OpenLayers.Geometry.Point(parseFloat(j[1]),parseFloat(j[2]));e.push(m);m=new OpenLayers.Geometry.Point(parseFloat(j[3]),parseFloat(j[2]));e.push(m);m=new OpenLayers.Geometry.Point(parseFloat(j[3]),parseFloat(j[0]));e.push(m);m=new OpenLayers.Geometry.Point(parseFloat(j[1]),parseFloat(j[0]));e.push(m)}h=new OpenLayers.Geometry.Polygon([new OpenLayers.Geometry.LinearRing(e)])}}}}}if(h&&this.internalProjection&&this.externalProjection){h.transform(this.externalProjection,this.internalProjection)}return h},createFeatureFromItem:function(i){var d=this.createGeometryFromItem(i);var g=this.getChildValue(i,"*","title",this.featureTitle);var h=this.getChildValue(i,"*","description",this.getChildValue(i,"*","content",this.getChildValue(i,"*","summary",this.featureDescription)));var f=this.getChildValue(i,"*","link");if(!f){try{f=this.getElementsByTagNameNS(i,"*","link")[0].getAttribute("href")}catch(c){f=null}}var a=this.getChildValue(i,"*","id",null);var b={title:g,description:h,link:f};var j=new OpenLayers.Feature.Vector(d,b);j.fid=a;return j},getChildValue:function(d,b,c,f){var e;var a=this.getElementsByTagNameNS(d,b,c);if(a&&a[0]&&a[0].firstChild&&a[0].firstChild.nodeValue){e=OpenLayers.Format.XML.prototype.getChildValue(a[0])}else{e=(f==undefined)?"":f}return e},read:function(e){if(typeof e=="string"){e=OpenLayers.Format.XML.prototype.read.apply(this,[e])}var a=null;a=this.getElementsByTagNameNS(e,"*","item");if(a.length==0){a=this.getElementsByTagNameNS(e,"*","entry")}var c=a.length;var d=new Array(c);for(var b=0;b<c;b++){d[b]=this.createFeatureFromItem(a[b])}return d},write:function(c){var d;if(OpenLayers.Util.isArray(c)){d=this.createElementNS(this.rssns,"rss");for(var b=0,a=c.length;b<a;b++){d.appendChild(this.createFeatureXML(c[b]))}}else{d=this.createFeatureXML(c)}return OpenLayers.Format.XML.prototype.write.apply(this,[d])},createFeatureXML:function(j){var f=this.buildGeometryNode(j.geometry);var a=this.createElementNS(this.rssns,"item");var d=this.createElementNS(this.rssns,"title");d.appendChild(this.createTextNode(j.attributes.title?j.attributes.title:""));var b=this.createElementNS(this.rssns,"description");b.appendChild(this.createTextNode(j.attributes.description?j.attributes.description:""));a.appendChild(d);a.appendChild(b);if(j.attributes.link){var h=this.createElementNS(this.rssns,"link");h.appendChild(this.createTextNode(j.attributes.link));a.appendChild(h)}for(var i in j.attributes){if(i=="link"||i=="title"||i=="description"){continue}var g=this.createTextNode(j.attributes[i]);var e=i;if(i.search(":")!=-1){e=i.split(":")[1]}var c=this.createElementNS(this.featureNS,"feature:"+e);c.appendChild(g);a.appendChild(c)}a.appendChild(f);return a},buildGeometryNode:function(b){if(this.internalProjection&&this.externalProjection){b=b.clone();b.transform(this.internalProjection,this.externalProjection)}var a;if(b.CLASS_NAME=="OpenLayers.Geometry.Polygon"){a=this.createElementNS(this.georssns,"georss:polygon");a.appendChild(this.buildCoordinatesNode(b.components[0]))}else{if(b.CLASS_NAME=="OpenLayers.Geometry.LineString"){a=this.createElementNS(this.georssns,"georss:line");a.appendChild(this.buildCoordinatesNode(b))}else{if(b.CLASS_NAME=="OpenLayers.Geometry.Point"){a=this.createElementNS(this.georssns,"georss:point");a.appendChild(this.buildCoordinatesNode(b))}else{throw"Couldn't parse "+b.CLASS_NAME}}}return a},buildCoordinatesNode:function(f){var c=null;if(f.components){c=f.components}var e;if(c){var b=c.length;var d=new Array(b);for(var a=0;a<b;a++){d[a]=c[a].y+" "+c[a].x}e=d.join(" ")}else{e=f.y+" "+f.x}return this.createTextNode(e)},CLASS_NAME:"OpenLayers.Format.GeoRSS"});OpenLayers.Event={observers:false,KEY_BACKSPACE:8,KEY_TAB:9,KEY_RETURN:13,KEY_ESC:27,KEY_LEFT:37,KEY_UP:38,KEY_RIGHT:39,KEY_DOWN:40,KEY_DELETE:46,element:function(a){return a.target||a.srcElement},isSingleTouch:function(a){return a.touches&&a.touches.length==1},isMultiTouch:function(a){return a.touches&&a.touches.length>1},isLeftClick:function(a){return(((a.which)&&(a.which==1))||((a.button)&&(a.button==1)))},isRightClick:function(a){return(((a.which)&&(a.which==3))||((a.button)&&(a.button==2)))},stop:function(b,a){if(!a){if(b.preventDefault){b.preventDefault()}else{b.returnValue=false}}if(b.stopPropagation){b.stopPropagation()}else{b.cancelBubble=true}},findElement:function(c,b){var a=OpenLayers.Event.element(c);while(a.parentNode&&(!a.tagName||(a.tagName.toUpperCase()!=b.toUpperCase()))){a=a.parentNode}return a},observe:function(b,d,c,a){var e=OpenLayers.Util.getElement(b);a=a||false;if(d=="keypress"&&(navigator.appVersion.match(/Konqueror|Safari|KHTML/)||e.attachEvent)){d="keydown"}if(!this.observers){this.observers={}}if(!e._eventCacheID){var f="eventCacheID_";if(e.id){f=e.id+"_"+f}e._eventCacheID=OpenLayers.Util.createUniqueID(f)}var g=e._eventCacheID;if(!this.observers[g]){this.observers[g]=[]}this.observers[g].push({element:e,name:d,observer:c,useCapture:a});if(e.addEventListener){e.addEventListener(d,c,a)}else{if(e.attachEvent){e.attachEvent("on"+d,c)}}},stopObservingElement:function(a){var b=OpenLayers.Util.getElement(a);var c=b._eventCacheID;this._removeElementObservers(OpenLayers.Event.observers[c])},_removeElementObservers:function(e){if(e){for(var b=e.length-1;b>=0;b--){var c=e[b];var a=new Array(c.element,c.name,c.observer,c.useCapture);var d=OpenLayers.Event.stopObserving.apply(this,a)}}},stopObserving:function(h,a,g,b){b=b||false;var f=OpenLayers.Util.getElement(h);var d=f._eventCacheID;if(a=="keypress"){if(navigator.appVersion.match(/Konqueror|Safari|KHTML/)||f.detachEvent){a="keydown"}}var k=false;var c=OpenLayers.Event.observers[d];if(c){var e=0;while(!k&&e<c.length){var j=c[e];if((j.name==a)&&(j.observer==g)&&(j.useCapture==b)){c.splice(e,1);if(c.length==0){delete OpenLayers.Event.observers[d]}k=true;break}e++}}if(k){if(f.removeEventListener){f.removeEventListener(a,g,b)}else{if(f&&f.detachEvent){f.detachEvent("on"+a,g)}}}return k},unloadCache:function(){if(OpenLayers.Event&&OpenLayers.Event.observers){for(var a in OpenLayers.Event.observers){var b=OpenLayers.Event.observers[a];OpenLayers.Event._removeElementObservers.apply(this,[b])}OpenLayers.Event.observers=false}},CLASS_NAME:"OpenLayers.Event"};OpenLayers.Event.observe(window,"unload",OpenLayers.Event.unloadCache,false);if(window.Event){OpenLayers.Util.applyDefaults(window.Event,OpenLayers.Event)}else{var Event=OpenLayers.Event}OpenLayers.Events=OpenLayers.Class({BROWSER_EVENTS:["mouseover","mouseout","mousedown","mouseup","mousemove","click","dblclick","rightclick","dblrightclick","resize","focus","blur","touchstart","touchmove","touchend"],listeners:null,object:null,element:null,eventTypes:null,eventHandler:null,fallThrough:null,includeXY:false,clearMouseListener:null,initialize:function(c,e,g,f,b){OpenLayers.Util.extend(this,b);this.object=c;this.fallThrough=f;this.listeners={};this.eventHandler=OpenLayers.Function.bindAsEventListener(this.handleBrowserEvent,this);this.clearMouseListener=OpenLayers.Function.bind(this.clearMouseCache,this);this.eventTypes=[];if(g!=null){for(var d=0,a=g.length;d<a;d++){this.addEventType(g[d])}}if(e!=null){this.attachToElement(e)}},destroy:function(){if(this.element){OpenLayers.Event.stopObservingElement(this.element);if(this.element.hasScrollEvent){OpenLayers.Event.stopObserving(window,"scroll",this.clearMouseListener)}}this.element=null;this.listeners=null;this.object=null;this.eventTypes=null;this.fallThrough=null;this.eventHandler=null},addEventType:function(a){if(!this.listeners[a]){this.eventTypes.push(a);this.listeners[a]=[]}},attachToElement:function(d){if(this.element){OpenLayers.Event.stopObservingElement(this.element)}this.element=d;for(var c=0,a=this.BROWSER_EVENTS.length;c<a;c++){var b=this.BROWSER_EVENTS[c];this.addEventType(b);OpenLayers.Event.observe(d,b,this.eventHandler)}OpenLayers.Event.observe(d,"dragstart",OpenLayers.Event.stop)},on:function(a){for(var b in a){if(b!="scope"){this.register(b,a.scope,a[b])}}},register:function(b,d,c){if((c!=null)&&(OpenLayers.Util.indexOf(this.eventTypes,b)!=-1)){if(d==null){d=this.object}var a=this.listeners[b];a.push({obj:d,func:c})}},registerPriority:function(b,d,c){if(c!=null){if(d==null){d=this.object}var a=this.listeners[b];if(a!=null){a.unshift({obj:d,func:c})}}},un:function(a){for(var b in a){if(b!="scope"){this.unregister(b,a.scope,a[b])}}},unregister:function(d,f,e){if(f==null){f=this.object}var c=this.listeners[d];if(c!=null){for(var b=0,a=c.length;b<a;b++){if(c[b].obj==f&&c[b].func==e){c.splice(b,1);break}}}},remove:function(a){if(this.listeners[a]!=null){this.listeners[a]=[]}},triggerEvent:function(e,b){var d=this.listeners[e];if(!d||d.length==0){return undefined}if(b==null){b={}}b.object=this.object;b.element=this.element;if(!b.type){b.type=e}d=d.slice();var f;for(var c=0,a=d.length;c<a;c++){var g=d[c];f=g.func.apply(g.obj,[b]);if((f!=undefined)&&(f==false)){break}}if(!this.fallThrough){OpenLayers.Event.stop(b,true)}return f},handleBrowserEvent:function(j){var e=j.type,f=this.listeners[e];if(!f||f.length==0){return}var c=j.touches;if(c&&c[0]){var h=0;var g=0;var d=c.length;var b;for(var a=0;a<d;++a){b=c[a];h+=b.clientX;g+=b.clientY}j.clientX=h/d;j.clientY=g/d}if(this.includeXY){j.xy=this.getMousePosition(j)}this.triggerEvent(e,j)},clearMouseCache:function(){this.element.scrolls=null;this.element.lefttop=null;var a=document.body;if(a&&!((a.scrollTop!=0||a.scrollLeft!=0)&&navigator.userAgent.match(/iPhone/i))){this.element.offsets=null}},getMousePosition:function(a){if(!this.includeXY){this.clearMouseCache()}else{if(!this.element.hasScrollEvent){OpenLayers.Event.observe(window,"scroll",this.clearMouseListener);this.element.hasScrollEvent=true}}if(!this.element.scrolls){var b=OpenLayers.Util.getViewportElement();this.element.scrolls=[b.scrollLeft,b.scrollTop]}if(!this.element.lefttop){this.element.lefttop=[(document.documentElement.clientLeft||0),(document.documentElement.clientTop||0)]}if(!this.element.offsets){this.element.offsets=OpenLayers.Util.pagePosition(this.element)}return new OpenLayers.Pixel((a.clientX+this.element.scrolls[0])-this.element.offsets[0]-this.element.lefttop[0],(a.clientY+this.element.scrolls[1])-this.element.offsets[1]-this.element.lefttop[1])},CLASS_NAME:"OpenLayers.Events"});OpenLayers.Tween=OpenLayers.Class({INTERVAL:10,easing:null,begin:null,finish:null,duration:null,callbacks:null,time:null,interval:null,playing:false,initialize:function(a){this.easing=(a)?a:OpenLayers.Easing.Expo.easeOut},start:function(c,b,d,a){this.playing=true;this.begin=c;this.finish=b;this.duration=d;this.callbacks=a.callbacks;this.time=0;if(this.interval){window.clearInterval(this.interval);this.interval=null}if(this.callbacks&&this.callbacks.start){this.callbacks.start.call(this,this.begin)}this.interval=window.setInterval(OpenLayers.Function.bind(this.play,this),this.INTERVAL)},stop:function(){if(!this.playing){return}if(this.callbacks&&this.callbacks.done){this.callbacks.done.call(this,this.finish)}window.clearInterval(this.interval);this.interval=null;this.playing=false},play:function(){var g={};for(var d in this.begin){var a=this.begin[d];var e=this.finish[d];if(a==null||e==null||isNaN(a)||isNaN(e)){OpenLayers.Console.error("invalid value for Tween")}var h=e-a;g[d]=this.easing.apply(this,[this.time,a,h,this.duration])}this.time++;if(this.callbacks&&this.callbacks.eachStep){this.callbacks.eachStep.call(this,g)}if(this.time>this.duration){this.stop()}},CLASS_NAME:"OpenLayers.Tween"});OpenLayers.Easing={CLASS_NAME:"OpenLayers.Easing"};OpenLayers.Easing.Linear={easeIn:function(e,a,g,f){return g*e/f+a},easeOut:function(e,a,g,f){return g*e/f+a},easeInOut:function(e,a,g,f){return g*e/f+a},CLASS_NAME:"OpenLayers.Easing.Linear"};OpenLayers.Easing.Expo={easeIn:function(e,a,g,f){return(e==0)?a:g*Math.pow(2,10*(e/f-1))+a},easeOut:function(e,a,g,f){return(e==f)?a+g:g*(-Math.pow(2,-10*e/f)+1)+a},easeInOut:function(e,a,g,f){if(e==0){return a}if(e==f){return a+g}if((e/=f/2)<1){return g/2*Math.pow(2,10*(e-1))+a}return g/2*(-Math.pow(2,-10*--e)+2)+a},CLASS_NAME:"OpenLayers.Easing.Expo"};OpenLayers.Easing.Quad={easeIn:function(e,a,g,f){return g*(e/=f)*e+a},easeOut:function(e,a,g,f){return -g*(e/=f)*(e-2)+a},easeInOut:function(e,a,g,f){if((e/=f/2)<1){return g/2*e*e+a}return -g/2*((--e)*(e-2)-1)+a},CLASS_NAME:"OpenLayers.Easing.Quad"};OpenLayers.Map=OpenLayers.Class({Z_INDEX_BASE:{BaseLayer:100,Overlay:325,Feature:725,Popup:750,Control:1000},EVENT_TYPES:["preaddlayer","addlayer","preremovelayer","removelayer","changelayer","movestart","move","moveend","zoomend","popupopen","popupclose","addmarker","removemarker","clearmarkers","mouseover","mouseout","mousemove","dragstart","drag","dragend","changebaselayer"],id:null,fractionalZoom:false,events:null,allOverlays:false,div:null,dragging:false,size:null,viewPortDiv:null,layerContainerOrigin:null,layerContainerDiv:null,layers:null,controls:null,popups:null,baseLayer:null,center:null,resolution:null,zoom:0,panRatio:1.5,viewRequestID:0,tileSize:null,projection:"EPSG:4326",units:"degrees",resolutions:null,maxResolution:1.40625,minResolution:null,maxScale:null,minScale:null,maxExtent:null,minExtent:null,restrictedExtent:null,numZoomLevels:16,theme:null,displayProjection:null,fallThrough:true,panTween:null,eventListeners:null,panMethod:OpenLayers.Easing.Expo.easeOut,panDuration:50,paddingForPopups:null,minPx:null,maxPx:null,initialize:function(a,j){if(arguments.length===1&&typeof a==="object"){j=a;a=j&&j.div}this.tileSize=new OpenLayers.Size(OpenLayers.Map.TILE_WIDTH,OpenLayers.Map.TILE_HEIGHT);this.maxExtent=new OpenLayers.Bounds(-180,-90,180,90);this.paddingForPopups=new OpenLayers.Bounds(15,15,15,15);this.theme=OpenLayers._getScriptLocation()+"theme/default/style.css";OpenLayers.Util.extend(this,j);this.layers=[];this.id=OpenLayers.Util.createUniqueID("OpenLayers.Map_");this.div=OpenLayers.Util.getElement(a);if(!this.div){this.div=document.createElement("div");this.div.style.height="1px";this.div.style.width="1px"}OpenLayers.Element.addClass(this.div,"olMap");var c=this.id+"_OpenLayers_ViewPort";this.viewPortDiv=OpenLayers.Util.createDiv(c,null,null,null,"relative",null,"hidden");this.viewPortDiv.style.width="100%";this.viewPortDiv.style.height="100%";this.viewPortDiv.className="olMapViewport";this.div.appendChild(this.viewPortDiv);var e=document.createElement("div");e.id=this.id+"_events";e.style.position="absolute";e.style.width="100%";e.style.height="100%";e.style.zIndex=this.Z_INDEX_BASE.Control-1;this.viewPortDiv.appendChild(e);this.eventsDiv=e;this.events=new OpenLayers.Events(this,this.eventsDiv,this.EVENT_TYPES,this.fallThrough,{includeXY:true});c=this.id+"_OpenLayers_Container";this.layerContainerDiv=OpenLayers.Util.createDiv(c);this.layerContainerDiv.style.zIndex=this.Z_INDEX_BASE.Popup-1;this.eventsDiv.appendChild(this.layerContainerDiv);this.updateSize();if(this.eventListeners instanceof Object){this.events.on(this.eventListeners)}this.events.register("movestart",this,this.updateSize);if(OpenLayers.String.contains(navigator.appName,"Microsoft")){this.events.register("resize",this,this.updateSize)}else{this.updateSizeDestroy=OpenLayers.Function.bind(this.updateSize,this);OpenLayers.Event.observe(window,"resize",this.updateSizeDestroy)}if(this.theme){var d=true;var b=document.getElementsByTagName("link");for(var f=0,g=b.length;f<g;++f){if(OpenLayers.Util.isEquivalentUrl(b.item(f).href,this.theme)){d=false;break}}if(d){var h=document.createElement("link");h.setAttribute("rel","stylesheet");h.setAttribute("type","text/css");h.setAttribute("href",this.theme);document.getElementsByTagName("head")[0].appendChild(h)}}if(this.controls==null){if(OpenLayers.Control!=null){this.controls=[new OpenLayers.Control.Navigation(),new OpenLayers.Control.PanZoom(),new OpenLayers.Control.ArgParser(),new OpenLayers.Control.Attribution()]}else{this.controls=[]}}for(var f=0,g=this.controls.length;f<g;f++){this.addControlToMap(this.controls[f])}this.popups=[];this.unloadDestroy=OpenLayers.Function.bind(this.destroy,this);OpenLayers.Event.observe(window,"unload",this.unloadDestroy);if(j&&j.layers){delete this.center;this.addLayers(j.layers);if(j.center){this.setCenter(j.center,j.zoom)}}},render:function(a){this.div=OpenLayers.Util.getElement(a);OpenLayers.Element.addClass(this.div,"olMap");this.viewPortDiv.parentNode.removeChild(this.viewPortDiv);this.div.appendChild(this.viewPortDiv);this.updateSize()},unloadDestroy:null,updateSizeDestroy:null,destroy:function(){if(!this.unloadDestroy){return false}if(this.panTween){this.panTween.stop();this.panTween=null}OpenLayers.Event.stopObserving(window,"unload",this.unloadDestroy);this.unloadDestroy=null;if(this.updateSizeDestroy){OpenLayers.Event.stopObserving(window,"resize",this.updateSizeDestroy)}else{this.events.unregister("resize",this,this.updateSize)}this.paddingForPopups=null;if(this.controls!=null){for(var a=this.controls.length-1;a>=0;--a){this.controls[a].destroy()}this.controls=null}if(this.layers!=null){for(var a=this.layers.length-1;a>=0;--a){this.layers[a].destroy(false)}this.layers=null}if(this.viewPortDiv){this.div.removeChild(this.viewPortDiv)}this.viewPortDiv=null;if(this.eventListeners){this.events.un(this.eventListeners);this.eventListeners=null}this.events.destroy();this.events=null},setOptions:function(a){var b=this.minPx&&a.restrictedExtent!=this.restrictedExtent;OpenLayers.Util.extend(this,a);b&&this.moveTo(this.getCachedCenter(),this.zoom,{forceZoomChange:true})},getTileSize:function(){return this.tileSize},getBy:function(e,c,a){var d=(typeof a.test=="function");var b=OpenLayers.Array.filter(this[e],function(f){return f[c]==a||(d&&a.test(f[c]))});return b},getLayersBy:function(b,a){return this.getBy("layers",b,a)},getLayersByName:function(a){return this.getLayersBy("name",a)},getLayersByClass:function(a){return this.getLayersBy("CLASS_NAME",a)},getControlsBy:function(b,a){return this.getBy("controls",b,a)},getControlsByClass:function(a){return this.getControlsBy("CLASS_NAME",a)},getLayer:function(e){var b=null;for(var d=0,a=this.layers.length;d<a;d++){var c=this.layers[d];if(c.id==e){b=c;break}}return b},setLayerZIndex:function(b,a){b.setZIndex(this.Z_INDEX_BASE[b.isBaseLayer?"BaseLayer":"Overlay"]+a*5)},resetLayersZIndex:function(){for(var c=0,a=this.layers.length;c<a;c++){var b=this.layers[c];this.setLayerZIndex(b,c)}},addLayer:function(c){for(var b=0,a=this.layers.length;b<a;b++){if(this.layers[b]==c){var d=OpenLayers.i18n("layerAlreadyAdded",{layerName:c.name});OpenLayers.Console.warn(d);return false}}if(this.events.triggerEvent("preaddlayer",{layer:c})===false){return}if(this.allOverlays){c.isBaseLayer=false}c.div.className="olLayerDiv";c.div.style.overflow="";this.setLayerZIndex(c,this.layers.length);if(c.isFixed){this.viewPortDiv.appendChild(c.div)}else{this.layerContainerDiv.appendChild(c.div)}this.layers.push(c);c.setMap(this);if(c.isBaseLayer||(this.allOverlays&&!this.baseLayer)){if(this.baseLayer==null){this.setBaseLayer(c)}else{c.setVisibility(false)}}else{c.redraw()}this.events.triggerEvent("addlayer",{layer:c});c.events.triggerEvent("added",{map:this,layer:c});c.afterAdd()},addLayers:function(c){for(var b=0,a=c.length;b<a;b++){this.addLayer(c[b])}},removeLayer:function(c,e){if(this.events.triggerEvent("preremovelayer",{layer:c})===false){return}if(e==null){e=true}if(c.isFixed){this.viewPortDiv.removeChild(c.div)}else{this.layerContainerDiv.removeChild(c.div)}OpenLayers.Util.removeItem(this.layers,c);c.removeMap(this);c.map=null;if(this.baseLayer==c){this.baseLayer=null;if(e){for(var b=0,a=this.layers.length;b<a;b++){var d=this.layers[b];if(d.isBaseLayer||this.allOverlays){this.setBaseLayer(d);break}}}}this.resetLayersZIndex();this.events.triggerEvent("removelayer",{layer:c});c.events.triggerEvent("removed",{map:this,layer:c})},getNumLayers:function(){return this.layers.length},getLayerIndex:function(a){return OpenLayers.Util.indexOf(this.layers,a)},setLayerIndex:function(d,b){var e=this.getLayerIndex(d);if(b<0){b=0}else{if(b>this.layers.length){b=this.layers.length}}if(e!=b){this.layers.splice(e,1);this.layers.splice(b,0,d);for(var c=0,a=this.layers.length;c<a;c++){this.setLayerZIndex(this.layers[c],c)}this.events.triggerEvent("changelayer",{layer:d,property:"order"});if(this.allOverlays){if(b===0){this.setBaseLayer(d)}else{if(this.baseLayer!==this.layers[0]){this.setBaseLayer(this.layers[0])}}}}},raiseLayer:function(b,c){var a=this.getLayerIndex(b)+c;this.setLayerIndex(b,a)},setBaseLayer:function(c){if(c!=this.baseLayer){if(OpenLayers.Util.indexOf(this.layers,c)!=-1){var a=this.getCachedCenter();var d=OpenLayers.Util.getResolutionFromScale(this.getScale(),c.units);if(this.baseLayer!=null&&!this.allOverlays){this.baseLayer.setVisibility(false)}this.baseLayer=c;this.viewRequestID++;if(!this.allOverlays||this.baseLayer.visibility){this.baseLayer.setVisibility(true)}if(a!=null){var b=this.getZoomForResolution(d||this.resolution,true);this.setCenter(a,b,false,true)}this.events.triggerEvent("changebaselayer",{layer:this.baseLayer})}}},addControl:function(b,a){this.controls.push(b);this.addControlToMap(b,a)},addControls:function(b,g){var e=(arguments.length===1)?[]:g;for(var d=0,a=b.length;d<a;d++){var f=b[d];var c=(e[d])?e[d]:null;this.addControl(f,c)}},addControlToMap:function(b,a){b.outsideViewport=(b.div!=null);if(this.displayProjection&&!b.displayProjection){b.displayProjection=this.displayProjection}b.setMap(this);var c=b.draw(a);if(c){if(!b.outsideViewport){c.style.zIndex=this.Z_INDEX_BASE.Control+this.controls.length;this.viewPortDiv.appendChild(c)}}if(b.autoActivate){b.activate()}},getControl:function(e){var b=null;for(var c=0,a=this.controls.length;c<a;c++){var d=this.controls[c];if(d.id==e){b=d;break}}return b},removeControl:function(a){if((a)&&(a==this.getControl(a.id))){if(a.div&&(a.div.parentNode==this.viewPortDiv)){this.viewPortDiv.removeChild(a.div)}OpenLayers.Util.removeItem(this.controls,a)}},addPopup:function(a,d){if(d){for(var b=this.popups.length-1;b>=0;--b){this.removePopup(this.popups[b])}}a.map=this;this.popups.push(a);var c=a.draw();if(c){c.style.zIndex=this.Z_INDEX_BASE.Popup+this.popups.length;this.layerContainerDiv.appendChild(c)}},removePopup:function(a){OpenLayers.Util.removeItem(this.popups,a);if(a.div){try{this.layerContainerDiv.removeChild(a.div)}catch(b){}}a.map=null},getSize:function(){var a=null;if(this.size!=null){a=this.size.clone()}return a},updateSize:function(){var c=this.getCurrentSize();if(c&&!isNaN(c.h)&&!isNaN(c.w)){this.events.clearMouseCache();var f=this.getSize();if(f==null){this.size=f=c}if(!c.equals(f)){this.size=c;for(var d=0,b=this.layers.length;d<b;d++){this.layers[d].onMapResize()}var a=this.getCachedCenter();if(this.baseLayer!=null&&a!=null){var e=this.getZoom();this.zoom=null;this.setCenter(a,e)}}}},getCurrentSize:function(){var a=new OpenLayers.Size(this.div.clientWidth,this.div.clientHeight);if(a.w==0&&a.h==0||isNaN(a.w)&&isNaN(a.h)){a.w=this.div.offsetWidth;a.h=this.div.offsetHeight}if(a.w==0&&a.h==0||isNaN(a.w)&&isNaN(a.h)){a.w=parseInt(this.div.style.width);a.h=parseInt(this.div.style.height)}return a},calculateBounds:function(a,b){var e=null;if(a==null){a=this.getCachedCenter()}if(b==null){b=this.getResolution()}if((a!=null)&&(b!=null)){var d=this.getSize();var f=d.w*b;var c=d.h*b;e=new OpenLayers.Bounds(a.lon-f/2,a.lat-c/2,a.lon+f/2,a.lat+c/2)}return e},getCenter:function(){var a=null;var b=this.getCachedCenter();if(b){a=b.clone()}return a},getCachedCenter:function(){if(!this.center&&this.size){this.center=this.getLonLatFromViewPortPx(new OpenLayers.Pixel(this.size.w/2,this.size.h/2))}return this.center},getZoom:function(){return this.zoom},pan:function(d,c,e){e=OpenLayers.Util.applyDefaults(e,{animate:true,dragging:false});if(e.dragging){if(d!=0||c!=0){this.moveByPx(d,c)}}else{var f=this.getViewPortPxFromLonLat(this.getCachedCenter());var b=f.add(d,c);if(this.dragging||!b.equals(f)){var a=this.getLonLatFromViewPortPx(b);if(e.animate){this.panTo(a)}else{this.moveTo(a);this.dragging=false;this.events.triggerEvent("moveend")}}}},panTo:function(d){if(this.panMethod&&this.getExtent().scale(this.panRatio).containsLonLat(d)){if(!this.panTween){this.panTween=new OpenLayers.Tween(this.panMethod)}var a=this.getCachedCenter();if(d.equals(a)){return}var f=this.getPixelFromLonLat(a);var e=this.getPixelFromLonLat(d);var b={x:e.x-f.x,y:e.y-f.y};var c={x:0,y:0};this.panTween.start({x:0,y:0},b,this.panDuration,{callbacks:{eachStep:OpenLayers.Function.bind(function(h){var g=h.x-c.x,i=h.y-c.y;this.moveByPx(g,i);c.x=Math.round(h.x);c.y=Math.round(h.y)},this),done:OpenLayers.Function.bind(function(g){this.moveTo(d);this.dragging=false;this.events.triggerEvent("moveend")},this)}})}else{this.setCenter(d)}},setCenter:function(c,a,b,d){this.panTween&&this.panTween.stop();this.moveTo(c,a,{dragging:b,forceZoomChange:d})},moveByPx:function(o,n){var h=this.size.w/2;var c=this.size.h/2;var l=h+o;var k=c+n;var d=this.baseLayer.wrapDateLine;var m=0;var j=0;if(this.restrictedExtent){m=h;j=c;d=false}o=d||l<=this.maxPx.x-m&&l>=this.minPx.x+m?Math.round(o):0;n=k<=this.maxPx.y-j&&k>=this.minPx.y+j?Math.round(n):0;var b=this.minPx.x,a=this.maxPx.x;if(o||n){if(!this.dragging){this.dragging=true;this.events.triggerEvent("movestart")}this.center=null;if(o){this.layerContainerDiv.style.left=parseInt(this.layerContainerDiv.style.left)-o+"px";this.minPx.x-=o;this.maxPx.x-=o;if(d){if(this.maxPx.x>a){this.maxPx.x-=(a-b)}if(this.minPx.x<b){this.minPx.x+=(a-b)}}}if(n){this.layerContainerDiv.style.top=parseInt(this.layerContainerDiv.style.top)-n+"px";this.minPx.y-=n;this.maxPx.y-=n}var f,e,g;for(e=0,g=this.layers.length;e<g;++e){f=this.layers[e];if(f.visibility&&(f===this.baseLayer||f.inRange)){f.moveByPx(o,n);f.events.triggerEvent("move")}}this.events.triggerEvent("move")}},moveTo:function(j,b,e){if(!e){e={}}if(b!=null){b=parseFloat(b);if(!this.fractionalZoom){b=Math.round(b)}}var q=e.dragging||this.dragging;var l=e.forceZoomChange;if(!this.getCachedCenter()&&!this.isValidLonLat(j)){j=this.maxExtent.getCenterLonLat();this.center=j.clone()}if(this.restrictedExtent!=null){if(j==null){j=this.center}if(b==null){b=this.getZoom()}var r=this.getResolutionForZoom(b);var n=this.calculateBounds(j,r);if(!this.restrictedExtent.containsBounds(n)){var x=this.restrictedExtent.getCenterLonLat();if(n.getWidth()>this.restrictedExtent.getWidth()){j=new OpenLayers.LonLat(x.lon,j.lat)}else{if(n.left<this.restrictedExtent.left){j=j.add(this.restrictedExtent.left-n.left,0)}else{if(n.right>this.restrictedExtent.right){j=j.add(this.restrictedExtent.right-n.right,0)}}}if(n.getHeight()>this.restrictedExtent.getHeight()){j=new OpenLayers.LonLat(j.lon,x.lat)}else{if(n.bottom<this.restrictedExtent.bottom){j=j.add(0,this.restrictedExtent.bottom-n.bottom)}else{if(n.top>this.restrictedExtent.top){j=j.add(0,this.restrictedExtent.top-n.top)}}}}}var m=l||((this.isValidZoomLevel(b))&&(b!=this.getZoom()));var h=(this.isValidLonLat(j))&&(!j.equals(this.center));if(m||h||q){q||this.events.triggerEvent("movestart");if(h){if(!m&&this.center){this.centerLayerContainer(j)}this.center=j.clone()}var y=m?this.getResolutionForZoom(b):this.getResolution();if(m||this.layerContainerOrigin==null){this.layerContainerOrigin=this.getCachedCenter();this.layerContainerDiv.style.left="0px";this.layerContainerDiv.style.top="0px";var p=this.getMaxExtent({restricted:true});var d=p.getCenterLonLat();var k=this.center.lon-d.lon;var c=d.lat-this.center.lat;var v=Math.round(p.getWidth()/y);var u=Math.round(p.getHeight()/y);var f=(this.size.w-v)/2-k/y;var o=(this.size.h-u)/2-c/y;this.minPx=new OpenLayers.Pixel(f,o);this.maxPx=new OpenLayers.Pixel(f+v,o+u)}if(m){this.zoom=b;this.resolution=y;this.viewRequestID++}var g=this.getExtent();if(this.baseLayer.visibility){this.baseLayer.moveTo(g,m,e.dragging);e.dragging||this.baseLayer.events.triggerEvent("moveend",{zoomChanged:m})}g=this.baseLayer.getExtent();for(var s=this.layers.length-1;s>=0;--s){var w=this.layers[s];if(w!==this.baseLayer&&!w.isBaseLayer){var a=w.calculateInRange();if(w.inRange!=a){w.inRange=a;if(!a){w.display(false)}this.events.triggerEvent("changelayer",{layer:w,property:"visibility"})}if(a&&w.visibility){w.moveTo(g,m,e.dragging);e.dragging||w.events.triggerEvent("moveend",{zoomChanged:m})}}}this.events.triggerEvent("move");q||this.events.triggerEvent("moveend");if(m){for(var s=0,t=this.popups.length;s<t;s++){this.popups[s].updatePosition()}this.events.triggerEvent("zoomend")}}},centerLayerContainer:function(c){var d=this.getViewPortPxFromLonLat(this.layerContainerOrigin);var g=this.getViewPortPxFromLonLat(c);if((d!=null)&&(g!=null)){var a=parseInt(this.layerContainerDiv.style.left);var b=parseInt(this.layerContainerDiv.style.top);var f=Math.round(d.x-g.x);var e=Math.round(d.y-g.y);this.layerContainerDiv.style.left=f+"px";this.layerContainerDiv.style.top=e+"px";var i=a-f;var h=b-e;this.minPx.x-=i;this.maxPx.x-=i;this.minPx.y-=h;this.maxPx.y-=h}},isValidZoomLevel:function(a){return((a!=null)&&(a>=0)&&(a<this.getNumZoomLevels()))},isValidLonLat:function(c){var b=false;if(c!=null){var a=this.getMaxExtent();b=a.containsLonLat(c)}return b},getProjection:function(){var a=this.getProjectionObject();return a?a.getCode():null},getProjectionObject:function(){var a=null;if(this.baseLayer!=null){a=this.baseLayer.projection}return a},getMaxResolution:function(){var a=null;if(this.baseLayer!=null){a=this.baseLayer.maxResolution}return a},getMaxExtent:function(b){var a=null;if(b&&b.restricted&&this.restrictedExtent){a=this.restrictedExtent}else{if(this.baseLayer!=null){a=this.baseLayer.maxExtent}}return a},getNumZoomLevels:function(){var a=null;if(this.baseLayer!=null){a=this.baseLayer.numZoomLevels}return a},getExtent:function(){var a=null;if(this.baseLayer!=null){a=this.baseLayer.getExtent()}return a},getResolution:function(){var a=null;if(this.baseLayer!=null){a=this.baseLayer.getResolution()}else{if(this.allOverlays===true&&this.layers.length>0){a=this.layers[0].getResolution()}}return a},getUnits:function(){var a=null;if(this.baseLayer!=null){a=this.baseLayer.units}return a},getScale:function(){var c=null;if(this.baseLayer!=null){var b=this.getResolution();var a=this.baseLayer.units;c=OpenLayers.Util.getScaleFromResolution(b,a)}return c},getZoomForExtent:function(c,b){var a=null;if(this.baseLayer!=null){a=this.baseLayer.getZoomForExtent(c,b)}return a},getResolutionForZoom:function(b){var a=null;if(this.baseLayer){a=this.baseLayer.getResolutionForZoom(b)}return a},getZoomForResolution:function(a,c){var b=null;if(this.baseLayer!=null){b=this.baseLayer.getZoomForResolution(a,c)}return b},zoomTo:function(a){if(this.isValidZoomLevel(a)){this.setCenter(null,a)}},zoomIn:function(){this.zoomTo(this.getZoom()+1)},zoomOut:function(){this.zoomTo(this.getZoom()-1)},zoomToExtent:function(d,c){var b=d.getCenterLonLat();if(this.baseLayer.wrapDateLine){var a=this.getMaxExtent();d=d.clone();while(d.right<d.left){d.right+=a.getWidth()}b=d.getCenterLonLat().wrapDateLine(a)}this.setCenter(b,this.getZoomForExtent(d,c))},zoomToMaxExtent:function(c){var b=(c)?c.restricted:true;var a=this.getMaxExtent({restricted:b});this.zoomToExtent(a)},zoomToScale:function(h,g){var d=OpenLayers.Util.getResolutionFromScale(h,this.baseLayer.units);var c=this.getSize();var f=c.w*d;var b=c.h*d;var a=this.getCachedCenter();var e=new OpenLayers.Bounds(a.lon-f/2,a.lat-b/2,a.lon+f/2,a.lat+b/2);this.zoomToExtent(e,g)},getLonLatFromViewPortPx:function(a){var b=null;if(this.baseLayer!=null){b=this.baseLayer.getLonLatFromViewPortPx(a)}return b},getViewPortPxFromLonLat:function(b){var a=null;if(this.baseLayer!=null){a=this.baseLayer.getViewPortPxFromLonLat(b)}return a},getLonLatFromPixel:function(a){return this.getLonLatFromViewPortPx(a)},getPixelFromLonLat:function(b){var a=this.getViewPortPxFromLonLat(b);a.x=Math.round(a.x);a.y=Math.round(a.y);return a},getGeodesicPixelSize:function(g){var d=g?this.getLonLatFromPixel(g):(this.getCachedCenter()||new OpenLayers.LonLat(0,0));var e=this.getResolution();var c=d.add(-e/2,0);var i=d.add(e/2,0);var b=d.add(0,-e/2);var f=d.add(0,e/2);var h=new OpenLayers.Projection("EPSG:4326");var a=this.getProjectionObject()||h;if(!a.equals(h)){c.transform(a,h);i.transform(a,h);b.transform(a,h);f.transform(a,h)}return new OpenLayers.Size(OpenLayers.Util.distVincenty(c,i),OpenLayers.Util.distVincenty(b,f))},getViewPortPxFromLayerPx:function(d){var c=null;if(d!=null){var b=parseInt(this.layerContainerDiv.style.left);var a=parseInt(this.layerContainerDiv.style.top);c=d.add(b,a)}return c},getLayerPxFromViewPortPx:function(c){var d=null;if(c!=null){var b=-parseInt(this.layerContainerDiv.style.left);var a=-parseInt(this.layerContainerDiv.style.top);d=c.add(b,a);if(isNaN(d.x)||isNaN(d.y)){d=null}}return d},getLonLatFromLayerPx:function(a){a=this.getViewPortPxFromLayerPx(a);return this.getLonLatFromViewPortPx(a)},getLayerPxFromLonLat:function(b){var a=this.getPixelFromLonLat(b);return this.getLayerPxFromViewPortPx(a)},CLASS_NAME:"OpenLayers.Map"});OpenLayers.Map.TILE_WIDTH=256;OpenLayers.Map.TILE_HEIGHT=256;OpenLayers.Projection=OpenLayers.Class({proj:null,projCode:null,titleRegEx:/\+title=[^\+]*/,initialize:function(b,a){OpenLayers.Util.extend(this,a);this.projCode=b;if(window.Proj4js){this.proj=new Proj4js.Proj(b)}},getCode:function(){return this.proj?this.proj.srsCode:this.projCode},getUnits:function(){return this.proj?this.proj.units:null},toString:function(){return this.getCode()},equals:function(a){var e=a,b=false;if(e){if(window.Proj4js&&this.proj.defData&&e.proj.defData){b=this.proj.defData.replace(this.titleRegEx,"")==e.proj.defData.replace(this.titleRegEx,"")}else{if(e.getCode){var c=this.getCode(),d=e.getCode();b=c==d||!!OpenLayers.Projection.transforms[c]&&OpenLayers.Projection.transforms[c][d]===OpenLayers.Projection.nullTransform}}}return b},destroy:function(){delete this.proj;delete this.projCode},CLASS_NAME:"OpenLayers.Projection"});OpenLayers.Projection.transforms={};OpenLayers.Projection.addTransform=function(c,b,a){if(!OpenLayers.Projection.transforms[c]){OpenLayers.Projection.transforms[c]={}}OpenLayers.Projection.transforms[c][b]=a};OpenLayers.Projection.transform=function(a,c,b){if(c.proj&&b.proj){a=Proj4js.transform(c.proj,b.proj,a)}else{if(c&&b&&OpenLayers.Projection.transforms[c.getCode()]&&OpenLayers.Projection.transforms[c.getCode()][b.getCode()]){OpenLayers.Projection.transforms[c.getCode()][b.getCode()](a)}}return a};OpenLayers.Projection.nullTransform=function(a){return a};OpenLayers.Layer=OpenLayers.Class({id:null,name:null,div:null,opacity:null,alwaysInRange:null,EVENT_TYPES:["loadstart","loadend","loadcancel","visibilitychanged","move","moveend","added","removed"],RESOLUTION_PROPERTIES:["scales","resolutions","maxScale","minScale","maxResolution","minResolution","numZoomLevels","maxZoomLevel"],events:null,map:null,isBaseLayer:false,alpha:false,displayInLayerSwitcher:true,visibility:true,attribution:null,inRange:false,imageSize:null,imageOffset:null,options:null,eventListeners:null,gutter:0,projection:null,units:null,scales:null,resolutions:null,maxExtent:null,minExtent:null,maxResolution:null,minResolution:null,numZoomLevels:null,minScale:null,maxScale:null,displayOutsideMaxExtent:false,wrapDateLine:false,transitionEffect:null,SUPPORTED_TRANSITIONS:["resize"],metadata:{},initialize:function(b,a){this.addOptions(a);this.name=b;if(this.id==null){this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_");this.div=OpenLayers.Util.createDiv(this.id);this.div.style.width="100%";this.div.style.height="100%";this.div.dir="ltr";this.events=new OpenLayers.Events(this,this.div,this.EVENT_TYPES);if(this.eventListeners instanceof Object){this.events.on(this.eventListeners)}}if(this.wrapDateLine){this.displayOutsideMaxExtent=true}},destroy:function(a){if(a==null){a=true}if(this.map!=null){this.map.removeLayer(this,a)}this.projection=null;this.map=null;this.name=null;this.div=null;this.options=null;if(this.events){if(this.eventListeners){this.events.un(this.eventListeners)}this.events.destroy()}this.eventListeners=null;this.events=null},clone:function(a){if(a==null){a=new OpenLayers.Layer(this.name,this.getOptions())}OpenLayers.Util.applyDefaults(a,this);a.map=null;return a},getOptions:function(){var a={};for(var b in this.options){a[b]=this[b]}return a},setName:function(a){if(a!=this.name){this.name=a;if(this.map!=null){this.map.events.triggerEvent("changelayer",{layer:this,property:"name"})}}},addOptions:function(e,a){if(this.options==null){this.options={}}OpenLayers.Util.extend(this.options,e);OpenLayers.Util.extend(this,e);if(typeof this.projection=="string"){this.projection=new OpenLayers.Projection(this.projection)}if(this.projection&&this.projection.getUnits()){this.units=this.projection.getUnits()}if(this.map){var b=this.map.getResolution();var c=this.RESOLUTION_PROPERTIES.concat(["projection","units","minExtent","maxExtent"]);for(var d in e){if(e.hasOwnProperty(d)&&OpenLayers.Util.indexOf(c,d)>=0){this.initResolutions();if(a&&this.map.baseLayer===this){this.map.setCenter(this.map.getCenter(),this.map.getZoomForResolution(b),false,true);this.map.events.triggerEvent("changebaselayer",{layer:this})}break}}}},onMapResize:function(){},redraw:function(){var b=false;if(this.map){this.inRange=this.calculateInRange();var c=this.getExtent();if(c&&this.inRange&&this.visibility){var a=true;this.moveTo(c,a,false);this.events.triggerEvent("moveend",{zoomChanged:a});b=true}}return b},moveTo:function(b,a,c){var d=this.visibility;if(!this.isBaseLayer){d=d&&this.inRange}this.display(d)},moveByPx:function(b,a){},setMap:function(b){if(this.map==null){this.map=b;this.maxExtent=this.maxExtent||this.map.maxExtent;this.minExtent=this.minExtent||this.map.minExtent;this.projection=this.projection||this.map.projection;if(typeof this.projection=="string"){this.projection=new OpenLayers.Projection(this.projection)}this.units=this.projection.getUnits()||this.units||this.map.units;this.initResolutions();if(!this.isBaseLayer){this.inRange=this.calculateInRange();var a=((this.visibility)&&(this.inRange));this.div.style.display=a?"":"none"}this.setTileSize()}},afterAdd:function(){},removeMap:function(a){},getImageSize:function(a){return(this.imageSize||this.tileSize)},setTileSize:function(a){var b=(a)?a:((this.tileSize)?this.tileSize:this.map.getTileSize());this.tileSize=b;if(this.gutter){this.imageOffset=new OpenLayers.Pixel(-this.gutter,-this.gutter);this.imageSize=new OpenLayers.Size(b.w+(2*this.gutter),b.h+(2*this.gutter))}},getVisibility:function(){return this.visibility},setVisibility:function(a){if(a!=this.visibility){this.visibility=a;this.display(a);this.redraw();if(this.map!=null){this.map.events.triggerEvent("changelayer",{layer:this,property:"visibility"})}this.events.triggerEvent("visibilitychanged")}},display:function(a){if(a!=(this.div.style.display!="none")){this.div.style.display=(a&&this.calculateInRange())?"block":"none"}},calculateInRange:function(){var b=false;if(this.alwaysInRange){b=true}else{if(this.map){var a=this.map.getResolution();b=((a>=this.minResolution)&&(a<=this.maxResolution))}}return b},setIsBaseLayer:function(a){if(a!=this.isBaseLayer){this.isBaseLayer=a;if(this.map!=null){this.map.events.triggerEvent("changebaselayer",{layer:this})}}},initResolutions:function(){var e,a,h;var f={},d=true;for(e=0,a=this.RESOLUTION_PROPERTIES.length;e<a;e++){h=this.RESOLUTION_PROPERTIES[e];f[h]=this.options[h];if(d&&this.options[h]){d=false}}if(this.alwaysInRange==null){this.alwaysInRange=d}if(f.resolutions==null){f.resolutions=this.resolutionsFromScales(f.scales)}if(f.resolutions==null){f.resolutions=this.calculateResolutions(f)}if(f.resolutions==null){for(e=0,a=this.RESOLUTION_PROPERTIES.length;e<a;e++){h=this.RESOLUTION_PROPERTIES[e];f[h]=this.options[h]!=null?this.options[h]:this.map[h]}if(f.resolutions==null){f.resolutions=this.resolutionsFromScales(f.scales)}if(f.resolutions==null){f.resolutions=this.calculateResolutions(f)}}var c;if(this.options.maxResolution&&this.options.maxResolution!=="auto"){c=this.options.maxResolution}if(this.options.minScale){c=OpenLayers.Util.getResolutionFromScale(this.options.minScale,this.units)}var b;if(this.options.minResolution&&this.options.minResolution!=="auto"){b=this.options.minResolution}if(this.options.maxScale){b=OpenLayers.Util.getResolutionFromScale(this.options.maxScale,this.units)}if(f.resolutions){f.resolutions.sort(function(j,i){return(i-j)});if(!c){c=f.resolutions[0]}if(!b){var g=f.resolutions.length-1;b=f.resolutions[g]}}this.resolutions=f.resolutions;if(this.resolutions){a=this.resolutions.length;this.scales=new Array(a);for(e=0;e<a;e++){this.scales[e]=OpenLayers.Util.getScaleFromResolution(this.resolutions[e],this.units)}this.numZoomLevels=a}this.minResolution=b;if(b){this.maxScale=OpenLayers.Util.getScaleFromResolution(b,this.units)}this.maxResolution=c;if(c){this.minScale=OpenLayers.Util.getScaleFromResolution(c,this.units)}},resolutionsFromScales:function(d){if(d==null){return}var b,c,a;a=d.length;b=new Array(a);for(c=0;c<a;c++){b[c]=OpenLayers.Util.getResolutionFromScale(d[c],this.units)}return b},calculateResolutions:function(k){var l,j,g;var m=k.maxResolution;if(k.minScale!=null){m=OpenLayers.Util.getResolutionFromScale(k.minScale,this.units)}else{if(m=="auto"&&this.maxExtent!=null){l=this.map.getSize();j=this.maxExtent.getWidth()/l.w;g=this.maxExtent.getHeight()/l.h;m=Math.max(j,g)}}var f=k.minResolution;if(k.maxScale!=null){f=OpenLayers.Util.getResolutionFromScale(k.maxScale,this.units)}else{if(k.minResolution=="auto"&&this.minExtent!=null){l=this.map.getSize();j=this.minExtent.getWidth()/l.w;g=this.minExtent.getHeight()/l.h;f=Math.max(j,g)}}var a=k.maxZoomLevel;var b=k.numZoomLevels;if(typeof f==="number"&&typeof m==="number"&&b===undefined){var h=m/f;b=Math.floor(Math.log(h)/Math.log(2))+1}else{if(b===undefined&&a!=null){b=a+1}}if(typeof b!=="number"||b<=0||(typeof m!=="number"&&typeof f!=="number")){return}var d=new Array(b);var c=2;if(typeof f=="number"&&typeof m=="number"){c=Math.pow((m/f),(1/(b-1)))}var e;if(typeof m==="number"){for(e=0;e<b;e++){d[e]=m/Math.pow(c,e)}}else{for(e=0;e<b;e++){d[b-1-e]=f*Math.pow(c,e)}}return d},getResolution:function(){var a=this.map.getZoom();return this.getResolutionForZoom(a)},getExtent:function(){return this.map.calculateBounds()},getZoomForExtent:function(b,c){var d=this.map.getSize();var a=Math.max(b.getWidth()/d.w,b.getHeight()/d.h);return this.getZoomForResolution(a,c)},getDataExtent:function(){},getResolutionForZoom:function(c){c=Math.max(0,Math.min(c,this.resolutions.length-1));var b;if(this.map.fractionalZoom){var a=Math.floor(c);var d=Math.ceil(c);b=this.resolutions[a]-((c-a)*(this.resolutions[a]-this.resolutions[d]))}else{b=this.resolutions[Math.round(c)]}return b},getZoomForResolution:function(e,b){var n,f,g;if(this.map.fractionalZoom){var k=0;var c=this.resolutions.length-1;var d=this.resolutions[k];var a=this.resolutions[c];var j;for(f=0,g=this.resolutions.length;f<g;++f){j=this.resolutions[f];if(j>=e){d=j;k=f}if(j<=e){a=j;c=f;break}}var h=d-a;if(h>0){n=k+((d-e)/h)}else{n=k}}else{var l;var m=Number.POSITIVE_INFINITY;for(f=0,g=this.resolutions.length;f<g;f++){if(b){l=Math.abs(this.resolutions[f]-e);if(l>m){break}m=l}else{if(this.resolutions[f]<e){break}}}n=Math.max(0,f-1)}return n},getLonLatFromViewPortPx:function(b){var d=null;var f=this.map;if(b!=null&&f.minPx){var c=f.getResolution();var a=f.getMaxExtent({restricted:true});var g=(b.x-f.minPx.x)*c+a.left;var e=(f.minPx.y-b.y)*c+a.top;d=new OpenLayers.LonLat(g,e);if(this.wrapDateLine){d=d.wrapDateLine(this.maxExtent)}}return d},getViewPortPxFromLonLat:function(d){var b=null;if(d!=null){var a=this.map.getResolution();var c=this.map.getExtent();b=new OpenLayers.Pixel((1/a*(d.lon-c.left)),(1/a*(c.top-d.lat)))}return b},setOpacity:function(b){if(b!=this.opacity){this.opacity=b;for(var d=0,a=this.div.childNodes.length;d<a;++d){var c=this.div.childNodes[d].firstChild;OpenLayers.Util.modifyDOMElement(c,null,null,null,null,null,null,b)}if(this.map!=null){this.map.events.triggerEvent("changelayer",{layer:this,property:"opacity"})}}},getZIndex:function(){return this.div.style.zIndex},setZIndex:function(a){this.div.style.zIndex=a},adjustBounds:function(b){if(this.gutter){var a=this.gutter*this.map.getResolution();b=new OpenLayers.Bounds(b.left-a,b.bottom-a,b.right+a,b.top+a)}if(this.wrapDateLine){var c={rightTolerance:this.getResolution(),leftTolerance:this.getResolution()};b=b.wrapDateLine(this.maxExtent,c)}return b},CLASS_NAME:"OpenLayers.Layer"});OpenLayers.Layer.SphericalMercator={getExtent:function(){var a=null;if(this.sphericalMercator){a=this.map.calculateBounds()}else{a=OpenLayers.Layer.FixedZoomLevels.prototype.getExtent.apply(this)}return a},getLonLatFromViewPortPx:function(a){return OpenLayers.Layer.prototype.getLonLatFromViewPortPx.apply(this,arguments)},getViewPortPxFromLonLat:function(a){return OpenLayers.Layer.prototype.getViewPortPxFromLonLat.apply(this,arguments)},initMercatorParameters:function(){this.RESOLUTIONS=[];var a=156543.03390625;for(var b=0;b<=this.MAX_ZOOM_LEVEL;++b){this.RESOLUTIONS[b]=a/Math.pow(2,b)}this.units="m";this.projection=this.projection||"EPSG:900913"},forwardMercator:function(c,b){var a=c*20037508.34/180;var d=Math.log(Math.tan((90+b)*Math.PI/360))/(Math.PI/180);d=d*20037508.34/180;return new OpenLayers.LonLat(a,d)},inverseMercator:function(a,d){var c=(a/20037508.34)*180;var b=(d/20037508.34)*180;b=180/Math.PI*(2*Math.atan(Math.exp(b*Math.PI/180))-Math.PI/2);return new OpenLayers.LonLat(c,b)},projectForward:function(a){var b=OpenLayers.Layer.SphericalMercator.forwardMercator(a.x,a.y);a.x=b.lon;a.y=b.lat;return a},projectInverse:function(a){var b=OpenLayers.Layer.SphericalMercator.inverseMercator(a.x,a.y);a.x=b.lon;a.y=b.lat;return a}};(function(){var a=["EPSG:900913","EPSG:3857","EPSG:102113","EPSG:102100"];var k=OpenLayers.Projection.addTransform;var e=OpenLayers.Layer.SphericalMercator;var h=OpenLayers.Projection.nullTransform;var d,f,b,g,c;for(d=0,f=a.length;d<f;++d){b=a[d];k("EPSG:4326",b,e.projectForward);k(b,"EPSG:4326",e.projectInverse);for(c=d+1;c<f;++c){g=a[c];k(b,g,h);k(g,b,h)}}})();OpenLayers.Layer.EventPane=OpenLayers.Class(OpenLayers.Layer,{smoothDragPan:true,isBaseLayer:true,isFixed:true,pane:null,mapObject:null,initialize:function(b,a){OpenLayers.Layer.prototype.initialize.apply(this,arguments);if(this.pane==null){this.pane=OpenLayers.Util.createDiv(this.div.id+"_EventPane")}},destroy:function(){this.mapObject=null;this.pane=null;OpenLayers.Layer.prototype.destroy.apply(this,arguments)},setMap:function(a){OpenLayers.Layer.prototype.setMap.apply(this,arguments);this.pane.style.zIndex=parseInt(this.div.style.zIndex)+1;this.pane.style.display=this.div.style.display;this.pane.style.width="100%";this.pane.style.height="100%";if(OpenLayers.BROWSER_NAME=="msie"){this.pane.style.background="url("+OpenLayers.Util.getImagesLocation()+"blank.gif)"}if(this.isFixed){this.map.eventsDiv.appendChild(this.pane)}else{this.map.layerContainerDiv.appendChild(this.pane)}this.loadMapObject();if(this.mapObject==null){this.loadWarningMessage()}},removeMap:function(a){if(this.pane&&this.pane.parentNode){this.pane.parentNode.removeChild(this.pane)}OpenLayers.Layer.prototype.removeMap.apply(this,arguments)},loadWarningMessage:function(){this.div.style.backgroundColor="darkblue";var g=this.map.getSize();var a=Math.min(g.w,300);var e=Math.min(g.h,200);var b=new OpenLayers.Size(a,e);var d=new OpenLayers.Pixel(g.w/2,g.h/2);var c=d.add(-b.w/2,-b.h/2);var f=OpenLayers.Util.createDiv(this.name+"_warning",c,b,null,null,null,"auto");f.style.padding="7px";f.style.backgroundColor="yellow";f.innerHTML=this.getWarningHTML();this.div.appendChild(f)},getWarningHTML:function(){return""},display:function(a){OpenLayers.Layer.prototype.display.apply(this,arguments);this.pane.style.display=this.div.style.display},setZIndex:function(a){OpenLayers.Layer.prototype.setZIndex.apply(this,arguments);this.pane.style.zIndex=parseInt(this.div.style.zIndex)+1},moveByPx:function(b,a){OpenLayers.Layer.prototype.moveByPx.apply(this,arguments);if(this.dragPanMapObject){this.dragPanMapObject(b,-a)}else{this.moveTo(this.map.getCachedCenter())}},moveTo:function(c,d,j){OpenLayers.Layer.prototype.moveTo.apply(this,arguments);if(this.mapObject!=null){var e=this.map.getCenter();var g=this.map.getZoom();if(e!=null){var f=this.getMapObjectCenter();var b=this.getOLLonLatFromMapObjectLonLat(f);var h=this.getMapObjectZoom();var m=this.getOLZoomFromMapObjectZoom(h);if(!(e.equals(b))||!(g==m)){if(!d&&b&&this.dragPanMapObject&&this.smoothDragPan){var i=this.map.getViewPortPxFromLonLat(b);var k=this.map.getViewPortPxFromLonLat(e);this.dragPanMapObject(k.x-i.x,i.y-k.y)}else{var a=this.getMapObjectLonLatFromOLLonLat(e);var l=this.getMapObjectZoomFromOLZoom(g);this.setMapObjectCenter(a,l,j)}}}}},getLonLatFromViewPortPx:function(a){var b=null;if((this.mapObject!=null)&&(this.getMapObjectCenter()!=null)){var d=this.getMapObjectPixelFromOLPixel(a);var c=this.getMapObjectLonLatFromMapObjectPixel(d);b=this.getOLLonLatFromMapObjectLonLat(c)}return b},getViewPortPxFromLonLat:function(b){var a=null;if((this.mapObject!=null)&&(this.getMapObjectCenter()!=null)){var d=this.getMapObjectLonLatFromOLLonLat(b);var c=this.getMapObjectPixelFromMapObjectLonLat(d);a=this.getOLPixelFromMapObjectPixel(c)}return a},getOLLonLatFromMapObjectLonLat:function(d){var a=null;if(d!=null){var c=this.getLongitudeFromMapObjectLonLat(d);var b=this.getLatitudeFromMapObjectLonLat(d);a=new OpenLayers.LonLat(c,b)}return a},getMapObjectLonLatFromOLLonLat:function(a){var b=null;if(a!=null){b=this.getMapObjectLonLatFromLonLat(a.lon,a.lat)}return b},getOLPixelFromMapObjectPixel:function(d){var b=null;if(d!=null){var a=this.getXFromMapObjectPixel(d);var c=this.getYFromMapObjectPixel(d);b=new OpenLayers.Pixel(a,c)}return b},getMapObjectPixelFromOLPixel:function(a){var b=null;if(a!=null){b=this.getMapObjectPixelFromXY(a.x,a.y)}return b},CLASS_NAME:"OpenLayers.Layer.EventPane"});OpenLayers.Layer.FixedZoomLevels=OpenLayers.Class({initialize:function(){},initResolutions:function(){var c=new Array("minZoomLevel","maxZoomLevel","numZoomLevels");for(var b=0,a=c.length;b<a;b++){var f=c[b];this[f]=(this.options[f]!=null)?this.options[f]:this.map[f]}if((this.minZoomLevel==null)||(this.minZoomLevel<this.MIN_ZOOM_LEVEL)){this.minZoomLevel=this.MIN_ZOOM_LEVEL}var g;var e=this.MAX_ZOOM_LEVEL-this.minZoomLevel+1;if(((this.options.numZoomLevels==null)&&(this.options.maxZoomLevel!=null))||((this.numZoomLevels==null)&&(this.maxZoomLevel!=null))){g=this.maxZoomLevel-this.minZoomLevel+1}else{g=this.numZoomLevels}if(g!=null){this.numZoomLevels=Math.min(g,e)}else{this.numZoomLevels=e}this.maxZoomLevel=this.minZoomLevel+this.numZoomLevels-1;if(this.RESOLUTIONS!=null){var d=0;this.resolutions=[];for(var b=this.minZoomLevel;b<=this.maxZoomLevel;b++){this.resolutions[d++]=this.RESOLUTIONS[b]}this.maxResolution=this.resolutions[0];this.minResolution=this.resolutions[this.resolutions.length-1]}},getResolution:function(){if(this.resolutions!=null){return OpenLayers.Layer.prototype.getResolution.apply(this,arguments)}else{var a=null;var c=this.map.getSize();var b=this.getExtent();if((c!=null)&&(b!=null)){a=Math.max(b.getWidth()/c.w,b.getHeight()/c.h)}return a}},getExtent:function(){var c=null;var b=this.map.getSize();var e=new OpenLayers.Pixel(0,0);var f=this.getLonLatFromViewPortPx(e);var a=new OpenLayers.Pixel(b.w,b.h);var d=this.getLonLatFromViewPortPx(a);if((f!=null)&&(d!=null)){c=new OpenLayers.Bounds(f.lon,d.lat,d.lon,f.lat)}return c},getZoomForResolution:function(a){if(this.resolutions!=null){return OpenLayers.Layer.prototype.getZoomForResolution.apply(this,arguments)}else{var b=OpenLayers.Layer.prototype.getExtent.apply(this,[]);return this.getZoomForExtent(b)}},getOLZoomFromMapObjectZoom:function(a){var b=null;if(a!=null){b=a-this.minZoomLevel;if(this.map.baseLayer!==this){b=this.map.baseLayer.getZoomForResolution(this.getResolutionForZoom(b))}}return b},getMapObjectZoomFromOLZoom:function(a){var b=null;if(a!=null){b=a+this.minZoomLevel;if(this.map.baseLayer!==this){b=this.getZoomForResolution(this.map.baseLayer.getResolutionForZoom(b))}}return b},CLASS_NAME:"OpenLayers.Layer.FixedZoomLevels"});OpenLayers.Layer.Google=OpenLayers.Class(OpenLayers.Layer.EventPane,OpenLayers.Layer.FixedZoomLevels,{MIN_ZOOM_LEVEL:0,MAX_ZOOM_LEVEL:21,RESOLUTIONS:[1.40625,0.703125,0.3515625,0.17578125,0.087890625,0.0439453125,0.02197265625,0.010986328125,0.0054931640625,0.00274658203125,0.001373291015625,0.0006866455078125,0.00034332275390625,0.000171661376953125,0.0000858306884765625,0.00004291534423828125,0.00002145767211914062,0.00001072883605957031,0.00000536441802978515,0.00000268220901489257,0.000001341104507446289,6.705522537231445e-7],type:null,wrapDateLine:true,sphericalMercator:false,version:null,initialize:function(c,b){b=b||{};if(!b.version){b.version=typeof GMap2==="function"?"2":"3"}var a=OpenLayers.Layer.Google["v"+b.version.replace(/\./g,"_")];if(a){OpenLayers.Util.applyDefaults(b,a)}else{throw"Unsupported Google Maps API version: "+b.version}OpenLayers.Util.applyDefaults(b,a.DEFAULTS);if(b.maxExtent){b.maxExtent=b.maxExtent.clone()}OpenLayers.Layer.EventPane.prototype.initialize.apply(this,[c,b]);OpenLayers.Layer.FixedZoomLevels.prototype.initialize.apply(this,[c,b]);if(this.sphericalMercator){OpenLayers.Util.extend(this,OpenLayers.Layer.SphericalMercator);this.initMercatorParameters()}},clone:function(){return new OpenLayers.Layer.Google(this.name,this.getOptions())},setVisibility:function(b){var a=this.opacity==null?1:this.opacity;OpenLayers.Layer.EventPane.prototype.setVisibility.apply(this,arguments);this.setOpacity(a)},display:function(a){if(!this._dragging){this.setGMapVisibility(a)}OpenLayers.Layer.EventPane.prototype.display.apply(this,arguments)},moveTo:function(b,a,c){this._dragging=c;OpenLayers.Layer.EventPane.prototype.moveTo.apply(this,arguments);delete this._dragging},setOpacity:function(b){if(b!==this.opacity){if(this.map!=null){this.map.events.triggerEvent("changelayer",{layer:this,property:"opacity"})}this.opacity=b}if(this.getVisibility()){var a=this.getMapContainer();OpenLayers.Util.modifyDOMElement(a,null,null,null,null,null,null,b)}},destroy:function(){if(this.map){this.setGMapVisibility(false);var a=OpenLayers.Layer.Google.cache[this.map.id];if(a&&a.count<=1){this.removeGMapElements()}}OpenLayers.Layer.EventPane.prototype.destroy.apply(this,arguments)},removeGMapElements:function(){var d=OpenLayers.Layer.Google.cache[this.map.id];if(d){var b=this.mapObject&&this.getMapContainer();if(b&&b.parentNode){b.parentNode.removeChild(b)}var c=d.termsOfUse;if(c&&c.parentNode){c.parentNode.removeChild(c)}var a=d.poweredBy;if(a&&a.parentNode){a.parentNode.removeChild(a)}}},removeMap:function(b){if(this.visibility&&this.mapObject){this.setGMapVisibility(false)}var a=OpenLayers.Layer.Google.cache[b.id];if(a){if(a.count<=1){this.removeGMapElements();delete OpenLayers.Layer.Google.cache[b.id]}else{--a.count}}delete this.termsOfUse;delete this.poweredBy;delete this.mapObject;delete this.dragObject;OpenLayers.Layer.EventPane.prototype.removeMap.apply(this,arguments)},getOLBoundsFromMapObjectBounds:function(b){var c=null;if(b!=null){var a=b.getSouthWest();var d=b.getNorthEast();if(this.sphericalMercator){a=this.forwardMercator(a.lng(),a.lat());d=this.forwardMercator(d.lng(),d.lat())}else{a=new OpenLayers.LonLat(a.lng(),a.lat());d=new OpenLayers.LonLat(d.lng(),d.lat())}c=new OpenLayers.Bounds(a.lon,a.lat,d.lon,d.lat)}return c},getWarningHTML:function(){return OpenLayers.i18n("googleWarning")},getMapObjectCenter:function(){return this.mapObject.getCenter()},getMapObjectZoom:function(){return this.mapObject.getZoom()},getLongitudeFromMapObjectLonLat:function(a){return this.sphericalMercator?this.forwardMercator(a.lng(),a.lat()).lon:a.lng()},getLatitudeFromMapObjectLonLat:function(b){var a=this.sphericalMercator?this.forwardMercator(b.lng(),b.lat()).lat:b.lat();return a},getXFromMapObjectPixel:function(a){return a.x},getYFromMapObjectPixel:function(a){return a.y},CLASS_NAME:"OpenLayers.Layer.Google"});OpenLayers.Layer.Google.cache={};OpenLayers.Layer.Google.v2={termsOfUse:null,poweredBy:null,dragObject:null,loadMapObject:function(){if(!this.type){this.type=G_NORMAL_MAP}var g,d,a;var c=OpenLayers.Layer.Google.cache[this.map.id];if(c){g=c.mapObject;d=c.termsOfUse;a=c.poweredBy;++c.count}else{var b=this.map.viewPortDiv;var h=document.createElement("div");h.id=this.map.id+"_GMap2Container";h.style.position="absolute";h.style.width="100%";h.style.height="100%";b.appendChild(h);try{g=new GMap2(h);d=h.lastChild;b.appendChild(d);d.style.zIndex="1100";d.style.right="";d.style.bottom="";d.className="olLayerGoogleCopyright";a=h.lastChild;b.appendChild(a);a.style.zIndex="1100";a.style.right="";a.style.bottom="";a.className="olLayerGooglePoweredBy gmnoprint"}catch(f){throw (f)}OpenLayers.Layer.Google.cache[this.map.id]={mapObject:g,termsOfUse:d,poweredBy:a,count:1}}this.mapObject=g;this.termsOfUse=d;this.poweredBy=a;if(OpenLayers.Util.indexOf(this.mapObject.getMapTypes(),this.type)===-1){this.mapObject.addMapType(this.type)}if(typeof g.getDragObject=="function"){this.dragObject=g.getDragObject()}else{this.dragPanMapObject=null}if(this.isBaseLayer===false){this.setGMapVisibility(this.div.style.display!=="none")}},onMapResize:function(){if(this.visibility&&this.mapObject.isLoaded()){this.mapObject.checkResize()}else{if(!this._resized){var a=this;var b=GEvent.addListener(this.mapObject,"load",function(){GEvent.removeListener(b);delete a._resized;a.mapObject.checkResize();a.moveTo(a.map.getCenter(),a.map.getZoom())})}this._resized=true}},setGMapVisibility:function(c){var b=OpenLayers.Layer.Google.cache[this.map.id];if(b){var a=this.mapObject.getContainer();if(c===true){this.mapObject.setMapType(this.type);a.style.display="";this.termsOfUse.style.left="";this.termsOfUse.style.display="";this.poweredBy.style.display="";b.displayed=this.id}else{if(b.displayed===this.id){delete b.displayed}if(!b.displayed){a.style.display="none";this.termsOfUse.style.display="none";this.termsOfUse.style.left="-9999px";this.poweredBy.style.display="none"}}}},getMapContainer:function(){return this.mapObject.getContainer()},getMapObjectBoundsFromOLBounds:function(c){var b=null;if(c!=null){var a=this.sphericalMercator?this.inverseMercator(c.bottom,c.left):new OpenLayers.LonLat(c.bottom,c.left);var d=this.sphericalMercator?this.inverseMercator(c.top,c.right):new OpenLayers.LonLat(c.top,c.right);b=new GLatLngBounds(new GLatLng(a.lat,a.lon),new GLatLng(d.lat,d.lon))}return b},setMapObjectCenter:function(a,b){this.mapObject.setCenter(a,b)},dragPanMapObject:function(b,a){this.dragObject.moveBy(new GSize(-b,a))},getMapObjectLonLatFromMapObjectPixel:function(a){return this.mapObject.fromContainerPixelToLatLng(a)},getMapObjectPixelFromMapObjectLonLat:function(a){return this.mapObject.fromLatLngToContainerPixel(a)},getMapObjectZoomFromMapObjectBounds:function(a){return this.mapObject.getBoundsZoomLevel(a)},getMapObjectLonLatFromLonLat:function(d,b){var c;if(this.sphericalMercator){var a=this.inverseMercator(d,b);c=new GLatLng(a.lat,a.lon)}else{c=new GLatLng(b,d)}return c},getMapObjectPixelFromXY:function(a,b){return new GPoint(a,b)}};OpenLayers.Style=OpenLayers.Class({id:null,name:null,title:null,description:null,layerName:null,isDefault:false,rules:null,context:null,defaultStyle:null,defaultsPerSymbolizer:false,propertyStyles:null,initialize:function(b,a){OpenLayers.Util.extend(this,a);this.rules=[];if(a&&a.rules){this.addRules(a.rules)}this.setDefaultStyle(b||OpenLayers.Feature.Vector.style["default"]);this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")},destroy:function(){for(var b=0,a=this.rules.length;b<a;b++){this.rules[b].destroy();this.rules[b]=null}this.rules=null;this.defaultStyle=null},createSymbolizer:function(k){var a=this.defaultsPerSymbolizer?{}:this.createLiterals(OpenLayers.Util.extend({},this.defaultStyle),k);var j=this.rules;var h,b;var c=[];var f=false;for(var d=0,e=j.length;d<e;d++){h=j[d];var g=h.evaluate(k);if(g){if(h instanceof OpenLayers.Rule&&h.elseFilter){c.push(h)}else{f=true;this.applySymbolizer(h,a,k)}}}if(f==false&&c.length>0){f=true;for(var d=0,e=c.length;d<e;d++){this.applySymbolizer(c[d],a,k)}}if(j.length>0&&f==false){a.display="none"}if(a.label&&typeof a.label!=="string"){a.label=String(a.label)}return a},applySymbolizer:function(f,d,b){var a=b.geometry?this.getSymbolizerPrefix(b.geometry):OpenLayers.Style.SYMBOLIZER_PREFIXES[0];var c=f.symbolizer[a]||f.symbolizer;if(this.defaultsPerSymbolizer===true){var e=this.defaultStyle;OpenLayers.Util.applyDefaults(c,{pointRadius:e.pointRadius});if(c.stroke===true||c.graphic===true){OpenLayers.Util.applyDefaults(c,{strokeWidth:e.strokeWidth,strokeColor:e.strokeColor,strokeOpacity:e.strokeOpacity,strokeDashstyle:e.strokeDashstyle,strokeLinecap:e.strokeLinecap})}if(c.fill===true||c.graphic===true){OpenLayers.Util.applyDefaults(c,{fillColor:e.fillColor,fillOpacity:e.fillOpacity})}if(c.graphic===true){OpenLayers.Util.applyDefaults(c,{pointRadius:this.defaultStyle.pointRadius,externalGraphic:this.defaultStyle.externalGraphic,graphicName:this.defaultStyle.graphicName,graphicOpacity:this.defaultStyle.graphicOpacity,graphicWidth:this.defaultStyle.graphicWidth,graphicHeight:this.defaultStyle.graphicHeight,graphicXOffset:this.defaultStyle.graphicXOffset,graphicYOffset:this.defaultStyle.graphicYOffset})}}return this.createLiterals(OpenLayers.Util.extend(d,c),b)},createLiterals:function(d,c){var b=OpenLayers.Util.extend({},c.attributes||c.data);OpenLayers.Util.extend(b,this.context);for(var a in this.propertyStyles){d[a]=OpenLayers.Style.createLiteral(d[a],b,c,a)}return d},findPropertyStyles:function(){var d={};var f=this.defaultStyle;this.addPropertyStyles(d,f);var h=this.rules;var e,g;for(var c=0,a=h.length;c<a;c++){e=h[c].symbolizer;for(var b in e){g=e[b];if(typeof g=="object"){this.addPropertyStyles(d,g)}else{this.addPropertyStyles(d,e);break}}}return d},addPropertyStyles:function(b,c){var d;for(var a in c){d=c[a];if(typeof d=="string"&&d.match(/\$\{\w+\}/)){b[a]=true}}return b},addRules:function(a){Array.prototype.push.apply(this.rules,a);this.propertyStyles=this.findPropertyStyles()},setDefaultStyle:function(a){this.defaultStyle=a;this.propertyStyles=this.findPropertyStyles()},getSymbolizerPrefix:function(d){var c=OpenLayers.Style.SYMBOLIZER_PREFIXES;for(var b=0,a=c.length;b<a;b++){if(d.CLASS_NAME.indexOf(c[b])!=-1){return c[b]}}},clone:function(){var b=OpenLayers.Util.extend({},this);if(this.rules){b.rules=[];for(var c=0,a=this.rules.length;c<a;++c){b.rules.push(this.rules[c].clone())}}b.context=this.context&&OpenLayers.Util.extend({},this.context);var d=OpenLayers.Util.extend({},this.defaultStyle);return new OpenLayers.Style(d,b)},CLASS_NAME:"OpenLayers.Style"});OpenLayers.Style.createLiteral=function(d,b,a,c){if(typeof d=="string"&&d.indexOf("${")!=-1){d=OpenLayers.String.format(d,b,[a,c]);d=(isNaN(d)||!d)?d:parseFloat(d)}return d};OpenLayers.Style.SYMBOLIZER_PREFIXES=["Point","Line","Polygon","Text","Raster"];OpenLayers.Symbolizer=OpenLayers.Class({zIndex:0,initialize:function(a){OpenLayers.Util.extend(this,a)},clone:function(){var Type=eval(this.CLASS_NAME);return new Type(OpenLayers.Util.extend({},this))},CLASS_NAME:"OpenLayers.Symbolizer"});OpenLayers.Symbolizer.Point=OpenLayers.Class(OpenLayers.Symbolizer,{initialize:function(a){OpenLayers.Symbolizer.prototype.initialize.apply(this,arguments)},CLASS_NAME:"OpenLayers.Symbolizer.Point"});OpenLayers.Symbolizer.Line=OpenLayers.Class(OpenLayers.Symbolizer,{initialize:function(a){OpenLayers.Symbolizer.prototype.initialize.apply(this,arguments)},CLASS_NAME:"OpenLayers.Symbolizer.Line"});OpenLayers.Symbolizer.Polygon=OpenLayers.Class(OpenLayers.Symbolizer,{initialize:function(a){OpenLayers.Symbolizer.prototype.initialize.apply(this,arguments)},CLASS_NAME:"OpenLayers.Symbolizer.Polygon"});OpenLayers.Symbolizer.Text=OpenLayers.Class(OpenLayers.Symbolizer,{initialize:function(a){OpenLayers.Symbolizer.prototype.initialize.apply(this,arguments)},CLASS_NAME:"OpenLayers.Symbolizer.Text"});OpenLayers.Symbolizer.Raster=OpenLayers.Class(OpenLayers.Symbolizer,{initialize:function(a){OpenLayers.Symbolizer.prototype.initialize.apply(this,arguments)},CLASS_NAME:"OpenLayers.Symbolizer.Raster"});OpenLayers.Rule=OpenLayers.Class({id:null,name:null,title:null,description:null,context:null,filter:null,elseFilter:false,symbolizer:null,symbolizers:null,minScaleDenominator:null,maxScaleDenominator:null,initialize:function(a){this.symbolizer={};OpenLayers.Util.extend(this,a);if(this.symbolizers){delete this.symbolizer}this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")},destroy:function(){for(var a in this.symbolizer){this.symbolizer[a]=null}this.symbolizer=null;delete this.symbolizers},evaluate:function(c){var b=this.getContext(c);var a=true;if(this.minScaleDenominator||this.maxScaleDenominator){var d=c.layer.map.getScale()}if(this.minScaleDenominator){a=d>=OpenLayers.Style.createLiteral(this.minScaleDenominator,b)}if(a&&this.maxScaleDenominator){a=d<OpenLayers.Style.createLiteral(this.maxScaleDenominator,b)}if(a&&this.filter){if(this.filter.CLASS_NAME=="OpenLayers.Filter.FeatureId"){a=this.filter.evaluate(c)}else{a=this.filter.evaluate(b)}}return a},getContext:function(b){var a=this.context;if(!a){a=b.attributes||b.data}if(typeof this.context=="function"){a=this.context(b)}return a},clone:function(){var b=OpenLayers.Util.extend({},this);if(this.symbolizers){var a=this.symbolizers.length;b.symbolizers=new Array(a);for(var d=0;d<a;++d){b.symbolizers[d]=this.symbolizers[d].clone()}}else{b.symbolizer={};var f,e;for(var c in this.symbolizer){f=this.symbolizer[c];e=typeof f;if(e==="object"){b.symbolizer[c]=OpenLayers.Util.extend({},f)}else{if(e==="string"){b.symbolizer[c]=f}}}}b.filter=this.filter&&this.filter.clone();b.context=this.context&&OpenLayers.Util.extend({},this.context);return new OpenLayers.Rule(b)},CLASS_NAME:"OpenLayers.Rule"});OpenLayers.Filter=OpenLayers.Class({initialize:function(a){OpenLayers.Util.extend(this,a)},destroy:function(){},evaluate:function(a){return true},clone:function(){return null},CLASS_NAME:"OpenLayers.Filter"});OpenLayers.Filter.FeatureId=OpenLayers.Class(OpenLayers.Filter,{fids:null,type:"FID",initialize:function(a){this.fids=[];OpenLayers.Filter.prototype.initialize.apply(this,[a])},evaluate:function(c){for(var b=0,a=this.fids.length;b<a;b++){var d=c.fid||c.id;if(d==this.fids[b]){return true}}return false},clone:function(){var a=new OpenLayers.Filter.FeatureId();OpenLayers.Util.extend(a,this);a.fids=this.fids.slice();return a},CLASS_NAME:"OpenLayers.Filter.FeatureId"});OpenLayers.Filter.Logical=OpenLayers.Class(OpenLayers.Filter,{filters:null,type:null,initialize:function(a){this.filters=[];OpenLayers.Filter.prototype.initialize.apply(this,[a])},destroy:function(){this.filters=null;OpenLayers.Filter.prototype.destroy.apply(this)},evaluate:function(c){var b,a;switch(this.type){case OpenLayers.Filter.Logical.AND:for(b=0,a=this.filters.length;b<a;b++){if(this.filters[b].evaluate(c)==false){return false}}return true;case OpenLayers.Filter.Logical.OR:for(b=0,a=this.filters.length;b<a;b++){if(this.filters[b].evaluate(c)==true){return true}}return false;case OpenLayers.Filter.Logical.NOT:return(!this.filters[0].evaluate(c))}return undefined},clone:function(){var c=[];for(var b=0,a=this.filters.length;b<a;++b){c.push(this.filters[b].clone())}return new OpenLayers.Filter.Logical({type:this.type,filters:c})},CLASS_NAME:"OpenLayers.Filter.Logical"});OpenLayers.Filter.Logical.AND="&&";OpenLayers.Filter.Logical.OR="||";OpenLayers.Filter.Logical.NOT="!";OpenLayers.Filter.Comparison=OpenLayers.Class(OpenLayers.Filter,{type:null,property:null,value:null,matchCase:true,lowerBoundary:null,upperBoundary:null,initialize:function(a){OpenLayers.Filter.prototype.initialize.apply(this,[a]);if(this.type===OpenLayers.Filter.Comparison.LIKE&&a.matchCase===undefined){this.matchCase=null}},evaluate:function(c){if(c instanceof OpenLayers.Feature.Vector){c=c.attributes}var a=false;var b=c[this.property];var e;switch(this.type){case OpenLayers.Filter.Comparison.EQUAL_TO:e=this.value;if(!this.matchCase&&typeof b=="string"&&typeof e=="string"){a=(b.toUpperCase()==e.toUpperCase())}else{a=(b==e)}break;case OpenLayers.Filter.Comparison.NOT_EQUAL_TO:e=this.value;if(!this.matchCase&&typeof b=="string"&&typeof e=="string"){a=(b.toUpperCase()!=e.toUpperCase())}else{a=(b!=e)}break;case OpenLayers.Filter.Comparison.LESS_THAN:a=b<this.value;break;case OpenLayers.Filter.Comparison.GREATER_THAN:a=b>this.value;break;case OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO:a=b<=this.value;break;case OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO:a=b>=this.value;break;case OpenLayers.Filter.Comparison.BETWEEN:a=(b>=this.lowerBoundary)&&(b<=this.upperBoundary);break;case OpenLayers.Filter.Comparison.LIKE:var d=new RegExp(this.value,"gi");a=d.test(b);break}return a},value2regex:function(d,b,a){if(d=="."){var c="'.' is an unsupported wildCard character for OpenLayers.Filter.Comparison";OpenLayers.Console.error(c);return null}d=d?d:"*";b=b?b:".";a=a?a:"!";this.value=this.value.replace(new RegExp("\\"+a+"(.|$)","g"),"\\$1");this.value=this.value.replace(new RegExp("\\"+b,"g"),".");this.value=this.value.replace(new RegExp("\\"+d,"g"),".*");this.value=this.value.replace(new RegExp("\\\\.\\*","g"),"\\"+d);this.value=this.value.replace(new RegExp("\\\\\\.","g"),"\\"+b);return this.value},regex2value:function(){var a=this.value;a=a.replace(/!/g,"!!");a=a.replace(/(\\)?\\\./g,function(c,b){return b?c:"!."});a=a.replace(/(\\)?\\\*/g,function(c,b){return b?c:"!*"});a=a.replace(/\\\\/g,"\\");a=a.replace(/\.\*/g,"*");return a},clone:function(){return OpenLayers.Util.extend(new OpenLayers.Filter.Comparison(),this)},CLASS_NAME:"OpenLayers.Filter.Comparison"});OpenLayers.Filter.Comparison.EQUAL_TO="==";OpenLayers.Filter.Comparison.NOT_EQUAL_TO="!=";OpenLayers.Filter.Comparison.LESS_THAN="<";OpenLayers.Filter.Comparison.GREATER_THAN=">";OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO="<=";OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO=">=";OpenLayers.Filter.Comparison.BETWEEN="..";OpenLayers.Filter.Comparison.LIKE="~";OpenLayers.Filter.Spatial=OpenLayers.Class(OpenLayers.Filter,{type:null,property:null,value:null,distance:null,distanceUnits:null,initialize:function(a){OpenLayers.Filter.prototype.initialize.apply(this,[a])},evaluate:function(c){var a=false;switch(this.type){case OpenLayers.Filter.Spatial.BBOX:case OpenLayers.Filter.Spatial.INTERSECTS:if(c.geometry){var b=this.value;if(this.value.CLASS_NAME=="OpenLayers.Bounds"){b=this.value.toGeometry()}if(c.geometry.intersects(b)){a=true}}break;default:OpenLayers.Console.error(OpenLayers.i18n("filterEvaluateNotImplemented"));break}return a},clone:function(){var a=OpenLayers.Util.applyDefaults({value:this.value&&this.value.clone&&this.value.clone()},this);return new OpenLayers.Filter.Spatial(a)},CLASS_NAME:"OpenLayers.Filter.Spatial"});OpenLayers.Filter.Spatial.BBOX="BBOX";OpenLayers.Filter.Spatial.INTERSECTS="INTERSECTS";OpenLayers.Filter.Spatial.DWITHIN="DWITHIN";OpenLayers.Filter.Spatial.WITHIN="WITHIN";OpenLayers.Filter.Spatial.CONTAINS="CONTAINS";OpenLayers.Format.SLD=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.0.0",stringifyOutput:true,namedLayersAsArray:false,CLASS_NAME:"OpenLayers.Format.SLD"});OpenLayers.Geometry.MultiLineString=OpenLayers.Class(OpenLayers.Geometry.Collection,{componentTypes:["OpenLayers.Geometry.LineString"],initialize:function(a){OpenLayers.Geometry.Collection.prototype.initialize.apply(this,arguments)},split:function(n,s){var g=null;var r=s&&s.mutual;var o,a,q,m,b;var e=[];var p=[n];for(var f=0,h=this.components.length;f<h;++f){a=this.components[f];m=false;for(var d=0;d<p.length;++d){o=a.split(p[d],s);if(o){if(r){q=o[0];for(var c=0,l=q.length;c<l;++c){if(c===0&&e.length){e[e.length-1].addComponent(q[c])}else{e.push(new OpenLayers.Geometry.MultiLineString([q[c]]))}}m=true;o=o[1]}if(o.length){o.unshift(d,1);Array.prototype.splice.apply(p,o);break}}}if(!m){if(e.length){e[e.length-1].addComponent(a.clone())}else{e=[new OpenLayers.Geometry.MultiLineString(a.clone())]}}}if(e&&e.length>1){m=true}else{e=[]}if(p&&p.length>1){b=true}else{p=[]}if(m||b){if(r){g=[e,p]}else{g=p}}return g},splitWith:function(n,s){var g=null;var r=s&&s.mutual;var o,c,q,m,a,e,p;if(n instanceof OpenLayers.Geometry.LineString){p=[];e=[n];for(var f=0,h=this.components.length;f<h;++f){a=false;c=this.components[f];for(var d=0;d<e.length;++d){o=e[d].split(c,s);if(o){if(r){q=o[0];if(q.length){q.unshift(d,1);Array.prototype.splice.apply(e,q);d+=q.length-2}o=o[1];if(o.length===0){o=[c.clone()]}}for(var b=0,l=o.length;b<l;++b){if(b===0&&p.length){p[p.length-1].addComponent(o[b])}else{p.push(new OpenLayers.Geometry.MultiLineString([o[b]]))}}a=true}}if(!a){if(p.length){p[p.length-1].addComponent(c.clone())}else{p=[new OpenLayers.Geometry.MultiLineString([c.clone()])]}}}}else{g=n.split(this)}if(e&&e.length>1){m=true}else{e=[]}if(p&&p.length>1){a=true}else{p=[]}if(m||a){if(r){g=[e,p]}else{g=p}}return g},CLASS_NAME:"OpenLayers.Geometry.MultiLineString"});OpenLayers.Geometry.MultiPolygon=OpenLayers.Class(OpenLayers.Geometry.Collection,{componentTypes:["OpenLayers.Geometry.Polygon"],initialize:function(a){OpenLayers.Geometry.Collection.prototype.initialize.apply(this,arguments)},CLASS_NAME:"OpenLayers.Geometry.MultiPolygon"});OpenLayers.Format.GML=OpenLayers.Class(OpenLayers.Format.XML,{featureNS:"http://mapserver.gis.umn.edu/mapserver",featurePrefix:"feature",featureName:"featureMember",layerName:"features",geometryName:"geometry",collectionName:"FeatureCollection",gmlns:"http://www.opengis.net/gml",extractAttributes:true,xy:true,initialize:function(a){this.regExes={trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)};OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(d){if(typeof d=="string"){d=OpenLayers.Format.XML.prototype.read.apply(this,[d])}var e=this.getElementsByTagNameNS(d.documentElement,this.gmlns,this.featureName);var c=[];for(var b=0;b<e.length;b++){var a=this.parseFeature(e[b]);if(a){c.push(a)}}return c},parseFeature:function(d){var e=["MultiPolygon","Polygon","MultiLineString","LineString","MultiPoint","Point","Envelope"];var p,h,q,c;for(var l=0;l<e.length;++l){p=e[l];h=this.getElementsByTagNameNS(d,this.gmlns,p);if(h.length>0){c=this.parseGeometry[p.toLowerCase()];if(c){q=c.apply(this,[h[0]]);if(this.internalProjection&&this.externalProjection){q.transform(this.externalProjection,this.internalProjection)}}else{OpenLayers.Console.error(OpenLayers.i18n("unsupportedGeometryType",{geomType:p}))}break}}var b;var k=this.getElementsByTagNameNS(d,this.gmlns,"Box");for(l=0;l<k.length;++l){var o=k[l];var n=this.parseGeometry.box.apply(this,[o]);var m=o.parentNode;var g=m.localName||m.nodeName.split(":").pop();if(g==="boundedBy"){b=n}else{q=n.toGeometry()}}var j;if(this.extractAttributes){j=this.parseAttributes(d)}var r=new OpenLayers.Feature.Vector(q,j);r.bounds=b;r.gml={featureType:d.firstChild.nodeName.split(":")[1],featureNS:d.firstChild.namespaceURI,featureNSPrefix:d.firstChild.prefix};var a=d.firstChild;var f;while(a){if(a.nodeType==1){f=a.getAttribute("fid")||a.getAttribute("id");if(f){break}}a=a.nextSibling}r.fid=f;return r},parseGeometry:{point:function(d){var b,a;var e=[];var b=this.getElementsByTagNameNS(d,this.gmlns,"pos");if(b.length>0){a=b[0].firstChild.nodeValue;a=a.replace(this.regExes.trimSpace,"");e=a.split(this.regExes.splitSpace)}if(e.length==0){b=this.getElementsByTagNameNS(d,this.gmlns,"coordinates");if(b.length>0){a=b[0].firstChild.nodeValue;a=a.replace(this.regExes.removeSpace,"");e=a.split(",")}}if(e.length==0){b=this.getElementsByTagNameNS(d,this.gmlns,"coord");if(b.length>0){var f=this.getElementsByTagNameNS(b[0],this.gmlns,"X");var c=this.getElementsByTagNameNS(b[0],this.gmlns,"Y");if(f.length>0&&c.length>0){e=[f[0].firstChild.nodeValue,c[0].firstChild.nodeValue]}}}if(e.length==2){e[2]=null}if(this.xy){return new OpenLayers.Geometry.Point(e[0],e[1],e[2])}else{return new OpenLayers.Geometry.Point(e[1],e[0],e[2])}},multipoint:function(e){var b=this.getElementsByTagNameNS(e,this.gmlns,"Point");var d=[];if(b.length>0){var a;for(var c=0;c<b.length;++c){a=this.parseGeometry.point.apply(this,[b[c]]);if(a){d.push(a)}}}return new OpenLayers.Geometry.MultiPoint(d)},linestring:function(c,e){var d,b;var n=[];var o=[];d=this.getElementsByTagNameNS(c,this.gmlns,"posList");if(d.length>0){b=this.getChildValue(d[0]);b=b.replace(this.regExes.trimSpace,"");n=b.split(this.regExes.splitSpace);var h=parseInt(d[0].getAttribute("dimension"));var f,m,l,k;for(var g=0;g<n.length/h;++g){f=g*h;m=n[f];l=n[f+1];k=(h==2)?null:n[f+2];if(this.xy){o.push(new OpenLayers.Geometry.Point(m,l,k))}else{o.push(new OpenLayers.Geometry.Point(l,m,k))}}}if(n.length==0){d=this.getElementsByTagNameNS(c,this.gmlns,"coordinates");if(d.length>0){b=this.getChildValue(d[0]);b=b.replace(this.regExes.trimSpace,"");b=b.replace(this.regExes.trimComma,",");var a=b.split(this.regExes.splitSpace);for(var g=0;g<a.length;++g){n=a[g].split(",");if(n.length==2){n[2]=null}if(this.xy){o.push(new OpenLayers.Geometry.Point(n[0],n[1],n[2]))}else{o.push(new OpenLayers.Geometry.Point(n[1],n[0],n[2]))}}}}var p=null;if(o.length!=0){if(e){p=new OpenLayers.Geometry.LinearRing(o)}else{p=new OpenLayers.Geometry.LineString(o)}}return p},multilinestring:function(e){var b=this.getElementsByTagNameNS(e,this.gmlns,"LineString");var d=[];if(b.length>0){var a;for(var c=0;c<b.length;++c){a=this.parseGeometry.linestring.apply(this,[b[c]]);if(a){d.push(a)}}}return new OpenLayers.Geometry.MultiLineString(d)},polygon:function(e){var b=this.getElementsByTagNameNS(e,this.gmlns,"LinearRing");var d=[];if(b.length>0){var a;for(var c=0;c<b.length;++c){a=this.parseGeometry.linestring.apply(this,[b[c],true]);if(a){d.push(a)}}}return new OpenLayers.Geometry.Polygon(d)},multipolygon:function(e){var a=this.getElementsByTagNameNS(e,this.gmlns,"Polygon");var d=[];if(a.length>0){var c;for(var b=0;b<a.length;++b){c=this.parseGeometry.polygon.apply(this,[a[b]]);if(c){d.push(c)}}}return new OpenLayers.Geometry.MultiPolygon(d)},envelope:function(b){var e=[];var a;var f;var j=this.getElementsByTagNameNS(b,this.gmlns,"lowerCorner");if(j.length>0){var h=[];if(j.length>0){a=j[0].firstChild.nodeValue;a=a.replace(this.regExes.trimSpace,"");h=a.split(this.regExes.splitSpace)}if(h.length==2){h[2]=null}if(this.xy){var d=new OpenLayers.Geometry.Point(h[0],h[1],h[2])}else{var d=new OpenLayers.Geometry.Point(h[1],h[0],h[2])}}var g=this.getElementsByTagNameNS(b,this.gmlns,"upperCorner");if(g.length>0){var h=[];if(g.length>0){a=g[0].firstChild.nodeValue;a=a.replace(this.regExes.trimSpace,"");h=a.split(this.regExes.splitSpace)}if(h.length==2){h[2]=null}if(this.xy){var i=new OpenLayers.Geometry.Point(h[0],h[1],h[2])}else{var i=new OpenLayers.Geometry.Point(h[1],h[0],h[2])}}if(d&&i){e.push(new OpenLayers.Geometry.Point(d.x,d.y));e.push(new OpenLayers.Geometry.Point(i.x,d.y));e.push(new OpenLayers.Geometry.Point(i.x,i.y));e.push(new OpenLayers.Geometry.Point(d.x,i.y));e.push(new OpenLayers.Geometry.Point(d.x,d.y));var c=new OpenLayers.Geometry.LinearRing(e);f=new OpenLayers.Geometry.Polygon([c])}return f},box:function(e){var c=this.getElementsByTagNameNS(e,this.gmlns,"coordinates");var b;var f,a=null,d=null;if(c.length>0){b=c[0].firstChild.nodeValue;f=b.split(" ");if(f.length==2){a=f[0].split(",");d=f[1].split(",")}}if(a!==null&&d!==null){return new OpenLayers.Bounds(parseFloat(a[0]),parseFloat(a[1]),parseFloat(d[0]),parseFloat(d[1]))}}},parseAttributes:function(e){var f={};var a=e.firstChild;var d,g,c,k,j,b,h;while(a){if(a.nodeType==1){d=a.childNodes;for(g=0;g<d.length;++g){c=d[g];if(c.nodeType==1){k=c.childNodes;if(k.length==1){j=k[0];if(j.nodeType==3||j.nodeType==4){b=(c.prefix)?c.nodeName.split(":")[1]:c.nodeName;h=j.nodeValue.replace(this.regExes.trimSpace,"");f[b]=h}}else{f[c.nodeName.split(":").pop()]=null}}}break}a=a.nextSibling}return f},write:function(c){if(!(OpenLayers.Util.isArray(c))){c=[c]}var b=this.createElementNS("http://www.opengis.net/wfs","wfs:"+this.collectionName);for(var a=0;a<c.length;a++){b.appendChild(this.createFeatureXML(c[a]))}return OpenLayers.Format.XML.prototype.write.apply(this,[b])},createFeatureXML:function(j){var h=j.geometry;var e=this.buildGeometryNode(h);var i=this.createElementNS(this.featureNS,this.featurePrefix+":"+this.geometryName);i.appendChild(e);var a=this.createElementNS(this.gmlns,"gml:"+this.featureName);var k=this.createElementNS(this.featureNS,this.featurePrefix+":"+this.layerName);var c=j.fid||j.id;k.setAttribute("fid",c);k.appendChild(i);for(var g in j.attributes){var f=this.createTextNode(j.attributes[g]);var d=g.substring(g.lastIndexOf(":")+1);var b=this.createElementNS(this.featureNS,this.featurePrefix+":"+d);b.appendChild(f);k.appendChild(b)}a.appendChild(k);return a},buildGeometryNode:function(d){if(this.externalProjection&&this.internalProjection){d=d.clone();d.transform(this.internalProjection,this.externalProjection)}var c=d.CLASS_NAME;var b=c.substring(c.lastIndexOf(".")+1);var a=this.buildGeometry[b.toLowerCase()];return a.apply(this,[d])},buildGeometry:{point:function(b){var a=this.createElementNS(this.gmlns,"gml:Point");a.appendChild(this.buildCoordinatesNode(b));return a},multipoint:function(f){var d=this.createElementNS(this.gmlns,"gml:MultiPoint");var c=f.components;var b,e;for(var a=0;a<c.length;a++){b=this.createElementNS(this.gmlns,"gml:pointMember");e=this.buildGeometry.point.apply(this,[c[a]]);b.appendChild(e);d.appendChild(b)}return d},linestring:function(b){var a=this.createElementNS(this.gmlns,"gml:LineString");a.appendChild(this.buildCoordinatesNode(b));return a},multilinestring:function(f){var d=this.createElementNS(this.gmlns,"gml:MultiLineString");var a=f.components;var c,e;for(var b=0;b<a.length;++b){c=this.createElementNS(this.gmlns,"gml:lineStringMember");e=this.buildGeometry.linestring.apply(this,[a[b]]);c.appendChild(e);d.appendChild(c)}return d},linearring:function(b){var a=this.createElementNS(this.gmlns,"gml:LinearRing");a.appendChild(this.buildCoordinatesNode(b));return a},polygon:function(g){var d=this.createElementNS(this.gmlns,"gml:Polygon");var f=g.components;var c,e,b;for(var a=0;a<f.length;++a){b=(a==0)?"outerBoundaryIs":"innerBoundaryIs";c=this.createElementNS(this.gmlns,"gml:"+b);e=this.buildGeometry.linearring.apply(this,[f[a]]);c.appendChild(e);d.appendChild(c)}return d},multipolygon:function(f){var d=this.createElementNS(this.gmlns,"gml:MultiPolygon");var a=f.components;var e,b;for(var c=0;c<a.length;++c){e=this.createElementNS(this.gmlns,"gml:polygonMember");b=this.buildGeometry.polygon.apply(this,[a[c]]);e.appendChild(b);d.appendChild(e)}return d},bounds:function(b){var a=this.createElementNS(this.gmlns,"gml:Box");a.appendChild(this.buildCoordinatesNode(b));return a}},buildCoordinatesNode:function(f){var a=this.createElementNS(this.gmlns,"gml:coordinates");a.setAttribute("decimal",".");a.setAttribute("cs",",");a.setAttribute("ts"," ");var e=[];if(f instanceof OpenLayers.Bounds){e.push(f.left+","+f.bottom);e.push(f.right+","+f.top)}else{var c=(f.components)?f.components:[f];for(var b=0;b<c.length;b++){e.push(c[b].x+","+c[b].y)}}var d=this.createTextNode(e.join(" "));a.appendChild(d);return a},CLASS_NAME:"OpenLayers.Format.GML"});if(!OpenLayers.Format.GML){OpenLayers.Format.GML={}}OpenLayers.Format.GML.Base=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{gml:"http://www.opengis.net/gml",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance",wfs:"http://www.opengis.net/wfs"},defaultPrefix:"gml",schemaLocation:null,featureType:null,featureNS:null,geometryName:"geometry",extractAttributes:true,srsName:null,xy:true,geometryTypes:null,singleFeatureType:null,regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g),featureMember:(/^(.*:)?featureMembers?$/)},initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a]);this.setGeometryTypes();if(a&&a.featureNS){this.setNamespace("feature",a.featureNS)}this.singleFeatureType=!a||(typeof a.featureType==="string")},read:function(e){if(typeof e=="string"){e=OpenLayers.Format.XML.prototype.read.apply(this,[e])}if(e&&e.nodeType==9){e=e.documentElement}var c=[];this.readNode(e,{features:c},true);if(c.length==0){var d=this.getElementsByTagNameNS(e,this.namespaces.gml,"featureMember");if(d.length){for(var b=0,a=d.length;b<a;++b){this.readNode(d[b],{features:c},true)}}else{var d=this.getElementsByTagNameNS(e,this.namespaces.gml,"featureMembers");if(d.length){this.readNode(d[0],{features:c},true)}}}return c},readNode:function(a,b,c){if(c===true&&this.autoConfig===true){this.featureType=null;delete this.namespaceAlias[this.featureNS];delete this.namespaces.feature;this.featureNS=null}if(!this.featureNS&&(!(a.prefix in this.namespaces)&&a.parentNode.namespaceURI==this.namespaces.gml&&this.regExes.featureMember.test(a.parentNode.nodeName))){this.featureType=a.nodeName.split(":").pop();this.setNamespace("feature",a.namespaceURI);this.featureNS=a.namespaceURI;this.autoConfig=true}return OpenLayers.Format.XML.prototype.readNode.apply(this,[a,b])},readers:{gml:{featureMember:function(a,b){this.readChildNodes(a,b)},featureMembers:function(a,b){this.readChildNodes(a,b)},name:function(a,b){b.name=this.getChildValue(a)},boundedBy:function(b,c){var a={};this.readChildNodes(b,a);if(a.components&&a.components.length>0){c.bounds=a.components[0]}},Point:function(b,a){var c={points:[]};this.readChildNodes(b,c);if(!a.components){a.components=[]}a.components.push(c.points[0])},coordinates:function(e,g){var h=this.getChildValue(e).replace(this.regExes.trimSpace,"");h=h.replace(this.regExes.trimComma,",");var a=h.split(this.regExes.splitSpace);var f;var d=a.length;var c=new Array(d);for(var b=0;b<d;++b){f=a[b].split(",");if(this.xy){c[b]=new OpenLayers.Geometry.Point(f[0],f[1],f[2])}else{c[b]=new OpenLayers.Geometry.Point(f[1],f[0],f[2])}}g.points=c},coord:function(a,b){var c={};this.readChildNodes(a,c);if(!b.points){b.points=[]}b.points.push(new OpenLayers.Geometry.Point(c.x,c.y,c.z))},X:function(a,b){b.x=this.getChildValue(a)},Y:function(a,b){b.y=this.getChildValue(a)},Z:function(a,b){b.z=this.getChildValue(a)},MultiPoint:function(b,a){var c={components:[]};this.readChildNodes(b,c);a.components=[new OpenLayers.Geometry.MultiPoint(c.components)]},pointMember:function(a,b){this.readChildNodes(a,b)},LineString:function(b,a){var c={};this.readChildNodes(b,c);if(!a.components){a.components=[]}a.components.push(new OpenLayers.Geometry.LineString(c.points))},MultiLineString:function(b,a){var c={components:[]};this.readChildNodes(b,c);a.components=[new OpenLayers.Geometry.MultiLineString(c.components)]},lineStringMember:function(a,b){this.readChildNodes(a,b)},Polygon:function(b,a){var c={outer:null,inner:[]};this.readChildNodes(b,c);c.inner.unshift(c.outer);if(!a.components){a.components=[]}a.components.push(new OpenLayers.Geometry.Polygon(c.inner))},LinearRing:function(b,c){var a={};this.readChildNodes(b,a);c.components=[new OpenLayers.Geometry.LinearRing(a.points)]},MultiPolygon:function(b,a){var c={components:[]};this.readChildNodes(b,c);a.components=[new OpenLayers.Geometry.MultiPolygon(c.components)]},polygonMember:function(a,b){this.readChildNodes(a,b)},GeometryCollection:function(b,a){var c={components:[]};this.readChildNodes(b,c);a.components=[new OpenLayers.Geometry.Collection(c.components)]},geometryMember:function(a,b){this.readChildNodes(a,b)}},feature:{"*":function(c,d){var a;var b=c.localName||c.nodeName.split(":").pop();if(d.features){if(!this.singleFeatureType&&(OpenLayers.Util.indexOf(this.featureType,b)!==-1)){a="_typeName"}else{if(b===this.featureType){a="_typeName"}}}else{if(c.childNodes.length==0||(c.childNodes.length==1&&c.firstChild.nodeType==3)){if(this.extractAttributes){a="_attribute"}}else{a="_geometry"}}if(a){this.readers.feature[a].apply(this,[c,d])}},_typeName:function(c,d){var a={components:[],attributes:{}};this.readChildNodes(c,a);if(a.name){a.attributes.name=a.name}var b=new OpenLayers.Feature.Vector(a.components[0],a.attributes);if(!this.singleFeatureType){b.type=c.nodeName.split(":").pop();b.namespace=c.namespaceURI}var e=c.getAttribute("fid")||this.getAttributeNS(c,this.namespaces.gml,"id");if(e){b.fid=e}if(this.internalProjection&&this.externalProjection&&b.geometry){b.geometry.transform(this.externalProjection,this.internalProjection)}if(a.bounds){b.bounds=a.bounds}d.features.push(b)},_geometry:function(a,b){if(!this.geometryName){this.geometryName=a.nodeName.split(":").pop()}this.readChildNodes(a,b)},_attribute:function(b,d){var a=b.localName||b.nodeName.split(":").pop();var c=this.getChildValue(b);d.attributes[a]=c}},wfs:{FeatureCollection:function(a,b){this.readChildNodes(a,b)}}},write:function(c){var b;if(OpenLayers.Util.isArray(c)){b="featureMembers"}else{b="featureMember"}var a=this.writeNode("gml:"+b,c);this.setAttributeNS(a,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);return OpenLayers.Format.XML.prototype.write.apply(this,[a])},writers:{gml:{featureMember:function(a){var b=this.createElementNSPlus("gml:featureMember");this.writeNode("feature:_typeName",a,b);return b},MultiPoint:function(e){var d=this.createElementNSPlus("gml:MultiPoint");var c=e.components||[e];for(var a=0,b=c.length;a<b;++a){this.writeNode("pointMember",c[a],d)}return d},pointMember:function(b){var a=this.createElementNSPlus("gml:pointMember");this.writeNode("Point",b,a);return a},MultiLineString:function(e){var d=this.createElementNSPlus("gml:MultiLineString");var c=e.components||[e];for(var a=0,b=c.length;a<b;++a){this.writeNode("lineStringMember",c[a],d)}return d},lineStringMember:function(b){var a=this.createElementNSPlus("gml:lineStringMember");this.writeNode("LineString",b,a);return a},MultiPolygon:function(e){var d=this.createElementNSPlus("gml:MultiPolygon");var c=e.components||[e];for(var a=0,b=c.length;a<b;++a){this.writeNode("polygonMember",c[a],d)}return d},polygonMember:function(b){var a=this.createElementNSPlus("gml:polygonMember");this.writeNode("Polygon",b,a);return a},GeometryCollection:function(d){var c=this.createElementNSPlus("gml:GeometryCollection");for(var b=0,a=d.components.length;b<a;++b){this.writeNode("geometryMember",d.components[b],c)}return c},geometryMember:function(b){var a=this.createElementNSPlus("gml:geometryMember");var c=this.writeNode("feature:_geometry",b);a.appendChild(c.firstChild);return a}},feature:{_typeName:function(b){var c=this.createElementNSPlus("feature:"+this.featureType,{attributes:{fid:b.fid}});if(b.geometry){this.writeNode("feature:_geometry",b.geometry,c)}for(var a in b.attributes){var d=b.attributes[a];if(d!=null){this.writeNode("feature:_attribute",{name:a,value:d},c)}}return c},_geometry:function(c){if(this.externalProjection&&this.internalProjection){c=c.clone().transform(this.internalProjection,this.externalProjection)}var b=this.createElementNSPlus("feature:"+this.geometryName);var a=this.geometryTypes[c.CLASS_NAME];var d=this.writeNode("gml:"+a,c,b);if(this.srsName){d.setAttribute("srsName",this.srsName)}return b},_attribute:function(a){return this.createElementNSPlus("feature:"+a.name,{value:a.value})}},wfs:{FeatureCollection:function(c){var d=this.createElementNSPlus("wfs:FeatureCollection");for(var b=0,a=c.length;b<a;++b){this.writeNode("gml:featureMember",c[b],d)}return d}}},setGeometryTypes:function(){this.geometryTypes={"OpenLayers.Geometry.Point":"Point","OpenLayers.Geometry.MultiPoint":"MultiPoint","OpenLayers.Geometry.LineString":"LineString","OpenLayers.Geometry.MultiLineString":"MultiLineString","OpenLayers.Geometry.Polygon":"Polygon","OpenLayers.Geometry.MultiPolygon":"MultiPolygon","OpenLayers.Geometry.Collection":"GeometryCollection"}},CLASS_NAME:"OpenLayers.Format.GML.Base"});OpenLayers.Format.GML.v2=OpenLayers.Class(OpenLayers.Format.GML.Base,{schemaLocation:"http://www.opengis.net/gml http://schemas.opengis.net/gml/2.1.2/feature.xsd",initialize:function(a){OpenLayers.Format.GML.Base.prototype.initialize.apply(this,[a])},readers:{gml:OpenLayers.Util.applyDefaults({outerBoundaryIs:function(b,a){var c={};this.readChildNodes(b,c);a.outer=c.components[0]},innerBoundaryIs:function(b,a){var c={};this.readChildNodes(b,c);a.inner.push(c.components[0])},Box:function(d,b){var e={};this.readChildNodes(d,e);if(!b.components){b.components=[]}var c=e.points[0];var a=e.points[1];b.components.push(new OpenLayers.Bounds(c.x,c.y,a.x,a.y))}},OpenLayers.Format.GML.Base.prototype.readers.gml),feature:OpenLayers.Format.GML.Base.prototype.readers.feature,wfs:OpenLayers.Format.GML.Base.prototype.readers.wfs},write:function(c){var b;if(OpenLayers.Util.isArray(c)){b="wfs:FeatureCollection"}else{b="gml:featureMember"}var a=this.writeNode(b,c);this.setAttributeNS(a,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);return OpenLayers.Format.XML.prototype.write.apply(this,[a])},writers:{gml:OpenLayers.Util.applyDefaults({Point:function(b){var a=this.createElementNSPlus("gml:Point");this.writeNode("coordinates",[b],a);return a},coordinates:function(d){var c=d.length;var e=new Array(c);var a;for(var b=0;b<c;++b){a=d[b];if(this.xy){e[b]=a.x+","+a.y}else{e[b]=a.y+","+a.x}if(a.z!=undefined){e[b]+=","+a.z}}return this.createElementNSPlus("gml:coordinates",{attributes:{decimal:".",cs:",",ts:" "},value:(c==1)?e[0]:e.join(" ")})},LineString:function(b){var a=this.createElementNSPlus("gml:LineString");this.writeNode("coordinates",b.components,a);return a},Polygon:function(c){var b=this.createElementNSPlus("gml:Polygon");this.writeNode("outerBoundaryIs",c.components[0],b);for(var a=1;a<c.components.length;++a){this.writeNode("innerBoundaryIs",c.components[a],b)}return b},outerBoundaryIs:function(a){var b=this.createElementNSPlus("gml:outerBoundaryIs");this.writeNode("LinearRing",a,b);return b},innerBoundaryIs:function(a){var b=this.createElementNSPlus("gml:innerBoundaryIs");this.writeNode("LinearRing",a,b);return b},LinearRing:function(a){var b=this.createElementNSPlus("gml:LinearRing");this.writeNode("coordinates",a.components,b);return b},Box:function(b){var a=this.createElementNSPlus("gml:Box");this.writeNode("coordinates",[{x:b.left,y:b.bottom},{x:b.right,y:b.top}],a);if(this.srsName){a.setAttribute("srsName",this.srsName)}return a}},OpenLayers.Format.GML.Base.prototype.writers.gml),feature:OpenLayers.Format.GML.Base.prototype.writers.feature,wfs:OpenLayers.Format.GML.Base.prototype.writers.wfs},CLASS_NAME:"OpenLayers.Format.GML.v2"});OpenLayers.Format.Filter=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.0.0",CLASS_NAME:"OpenLayers.Format.Filter"});OpenLayers.Filter.Function=OpenLayers.Class(OpenLayers.Filter,{name:null,params:null,initialize:function(a){OpenLayers.Filter.prototype.initialize.apply(this,[a])},CLASS_NAME:"OpenLayers.Filter.Function"});OpenLayers.Format.Filter.v1=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{ogc:"http://www.opengis.net/ogc",gml:"http://www.opengis.net/gml",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},defaultPrefix:"ogc",schemaLocation:null,initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(a){var b={};this.readers.ogc.Filter.apply(this,[a,b]);return b.filter},readers:{ogc:{Filter:function(b,a){var c={fids:[],filters:[]};this.readChildNodes(b,c);if(c.fids.length>0){a.filter=new OpenLayers.Filter.FeatureId({fids:c.fids})}else{if(c.filters.length>0){a.filter=c.filters[0]}}},FeatureId:function(a,b){var c=a.getAttribute("fid");if(c){b.fids.push(c)}},And:function(b,c){var a=new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.AND});this.readChildNodes(b,a);c.filters.push(a)},Or:function(b,c){var a=new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.OR});this.readChildNodes(b,a);c.filters.push(a)},Not:function(b,c){var a=new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.NOT});this.readChildNodes(b,a);c.filters.push(a)},PropertyIsLessThan:function(b,c){var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.LESS_THAN});this.readChildNodes(b,a);c.filters.push(a)},PropertyIsGreaterThan:function(b,c){var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.GREATER_THAN});this.readChildNodes(b,a);c.filters.push(a)},PropertyIsLessThanOrEqualTo:function(b,c){var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO});this.readChildNodes(b,a);c.filters.push(a)},PropertyIsGreaterThanOrEqualTo:function(b,c){var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO});this.readChildNodes(b,a);c.filters.push(a)},PropertyIsBetween:function(b,c){var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.BETWEEN});this.readChildNodes(b,a);c.filters.push(a)},Literal:function(a,b){b.value=OpenLayers.String.numericIf(this.getChildValue(a))},PropertyName:function(b,a){a.property=this.getChildValue(b)},LowerBoundary:function(b,a){a.lowerBoundary=OpenLayers.String.numericIf(this.readOgcExpression(b))},UpperBoundary:function(b,a){a.upperBoundary=OpenLayers.String.numericIf(this.readOgcExpression(b))},Intersects:function(a,b){this.readSpatial(a,b,OpenLayers.Filter.Spatial.INTERSECTS)},Within:function(a,b){this.readSpatial(a,b,OpenLayers.Filter.Spatial.WITHIN)},Contains:function(a,b){this.readSpatial(a,b,OpenLayers.Filter.Spatial.CONTAINS)},DWithin:function(a,b){this.readSpatial(a,b,OpenLayers.Filter.Spatial.DWITHIN)},Distance:function(a,b){b.distance=parseInt(this.getChildValue(a));b.distanceUnits=a.getAttribute("units")},Function:function(a,b){return}}},readSpatial:function(c,d,b){var a=new OpenLayers.Filter.Spatial({type:b});this.readChildNodes(c,a);a.value=a.components[0];delete a.components;d.filters.push(a)},readOgcExpression:function(a){var c={};this.readChildNodes(a,c);var b=c.value;if(b===undefined){b=this.getChildValue(a)}return b},writeOgcExpression:function(b,a){if(b instanceof OpenLayers.Filter.Function){var c=this.writeNode("Function",b,a);a.appendChild(c)}else{this.writeNode("Literal",b,a)}return a},write:function(a){return this.writers.ogc.Filter.apply(this,[a])},writeFeatureIdNodes:function(c,d){for(var a=0,b=c.fids.length;a<b;++a){this.writeNode("FeatureId",c.fids[a],d)}},writers:{ogc:{Filter:function(a){var b=this.createElementNSPlus("ogc:Filter");if(a.type==="FID"){this.writeFeatureIdNodes(a,b)}else{this.writeNode(this.getFilterType(a),a,b)}return b},FeatureId:function(a){return this.createElementNSPlus("ogc:FeatureId",{attributes:{fid:a}})},And:function(d){var e=this.createElementNSPlus("ogc:And");var c;for(var a=0,b=d.filters.length;a<b;++a){c=d.filters[a];if(c.type==="FID"){this.writeFeatureIdNodes(c,e)}else{this.writeNode(this.getFilterType(c),c,e)}}return e},Or:function(d){var e=this.createElementNSPlus("ogc:Or");var c;for(var a=0,b=d.filters.length;a<b;++a){c=d.filters[a];if(c.type==="FID"){this.writeFeatureIdNodes(c,e)}else{this.writeNode(this.getFilterType(c),c,e)}}return e},Not:function(b){var c=this.createElementNSPlus("ogc:Not");var a=b.filters[0];if(a.type==="FID"){this.writeFeatureIdNodes(a,c)}else{this.writeNode(this.getFilterType(a),a,c)}return c},PropertyIsLessThan:function(a){var b=this.createElementNSPlus("ogc:PropertyIsLessThan");this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsGreaterThan:function(a){var b=this.createElementNSPlus("ogc:PropertyIsGreaterThan");this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsLessThanOrEqualTo:function(a){var b=this.createElementNSPlus("ogc:PropertyIsLessThanOrEqualTo");this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsGreaterThanOrEqualTo:function(a){var b=this.createElementNSPlus("ogc:PropertyIsGreaterThanOrEqualTo");this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsBetween:function(a){var b=this.createElementNSPlus("ogc:PropertyIsBetween");this.writeNode("PropertyName",a,b);this.writeNode("LowerBoundary",a,b);this.writeNode("UpperBoundary",a,b);return b},PropertyName:function(a){return this.createElementNSPlus("ogc:PropertyName",{value:a.property})},Literal:function(a){return this.createElementNSPlus("ogc:Literal",{value:a})},LowerBoundary:function(a){var b=this.createElementNSPlus("ogc:LowerBoundary");this.writeOgcExpression(a.lowerBoundary,b);return b},UpperBoundary:function(a){var b=this.createElementNSPlus("ogc:UpperBoundary");this.writeNode("Literal",a.upperBoundary,b);return b},INTERSECTS:function(a){return this.writeSpatial(a,"Intersects")},WITHIN:function(a){return this.writeSpatial(a,"Within")},CONTAINS:function(a){return this.writeSpatial(a,"Contains")},DWITHIN:function(a){var b=this.writeSpatial(a,"DWithin");this.writeNode("Distance",a,b);return b},Distance:function(a){return this.createElementNSPlus("ogc:Distance",{attributes:{units:a.distanceUnits},value:a.distance})},Function:function(c){var d=this.createElementNSPlus("ogc:Function",{attributes:{name:c.name}});var e=c.params;for(var b=0,a=e.length;b<a;b++){this.writeOgcExpression(e[b],d)}return d}}},getFilterType:function(a){var b=this.filterMap[a.type];if(!b){throw"Filter writing not supported for rule type: "+a.type}return b},filterMap:{"&&":"And","||":"Or","!":"Not","==":"PropertyIsEqualTo","!=":"PropertyIsNotEqualTo","<":"PropertyIsLessThan",">":"PropertyIsGreaterThan","<=":"PropertyIsLessThanOrEqualTo",">=":"PropertyIsGreaterThanOrEqualTo","..":"PropertyIsBetween","~":"PropertyIsLike",BBOX:"BBOX",DWITHIN:"DWITHIN",WITHIN:"WITHIN",CONTAINS:"CONTAINS",INTERSECTS:"INTERSECTS",FID:"FeatureId"},CLASS_NAME:"OpenLayers.Format.Filter.v1"});OpenLayers.Format.Filter.v1_0_0=OpenLayers.Class(OpenLayers.Format.GML.v2,OpenLayers.Format.Filter.v1,{VERSION:"1.0.0",schemaLocation:"http://www.opengis.net/ogc/filter/1.0.0/filter.xsd",initialize:function(a){OpenLayers.Format.GML.v2.prototype.initialize.apply(this,[a])},readers:{ogc:OpenLayers.Util.applyDefaults({PropertyIsEqualTo:function(b,c){var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.EQUAL_TO});this.readChildNodes(b,a);c.filters.push(a)},PropertyIsNotEqualTo:function(b,c){var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.NOT_EQUAL_TO});this.readChildNodes(b,a);c.filters.push(a)},PropertyIsLike:function(d,e){var c=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.LIKE});this.readChildNodes(d,c);var f=d.getAttribute("wildCard");var b=d.getAttribute("singleChar");var a=d.getAttribute("escape");c.value2regex(f,b,a);e.filters.push(c)}},OpenLayers.Format.Filter.v1.prototype.readers.ogc),gml:OpenLayers.Format.GML.v2.prototype.readers.gml,feature:OpenLayers.Format.GML.v2.prototype.readers.feature},writers:{ogc:OpenLayers.Util.applyDefaults({PropertyIsEqualTo:function(a){var b=this.createElementNSPlus("ogc:PropertyIsEqualTo");this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsNotEqualTo:function(a){var b=this.createElementNSPlus("ogc:PropertyIsNotEqualTo");this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsLike:function(a){var b=this.createElementNSPlus("ogc:PropertyIsLike",{attributes:{wildCard:"*",singleChar:".",escape:"!"}});this.writeNode("PropertyName",a,b);this.writeNode("Literal",a.regex2value(),b);return b},BBOX:function(a){var c=this.createElementNSPlus("ogc:BBOX");a.property&&this.writeNode("PropertyName",a,c);var b=this.writeNode("gml:Box",a.value,c);if(a.projection){b.setAttribute("srsName",a.projection)}return c}},OpenLayers.Format.Filter.v1.prototype.writers.ogc),gml:OpenLayers.Format.GML.v2.prototype.writers.gml,feature:OpenLayers.Format.GML.v2.prototype.writers.feature},writeSpatial:function(b,a){var c=this.createElementNSPlus("ogc:"+a);this.writeNode("PropertyName",b,c);if(b.value instanceof OpenLayers.Filter.Function){this.writeNode("Function",b.value,c)}else{var d;if(b.value instanceof OpenLayers.Geometry){d=this.writeNode("feature:_geometry",b.value).firstChild}else{d=this.writeNode("gml:Box",b.value)}if(b.projection){d.setAttribute("srsName",b.projection)}c.appendChild(d)}return c},CLASS_NAME:"OpenLayers.Format.Filter.v1_0_0"});OpenLayers.Format.SLD.v1=OpenLayers.Class(OpenLayers.Format.Filter.v1_0_0,{namespaces:{sld:"http://www.opengis.net/sld",ogc:"http://www.opengis.net/ogc",gml:"http://www.opengis.net/gml",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},defaultPrefix:"sld",schemaLocation:null,multipleSymbolizers:false,featureTypeCounter:null,defaultSymbolizer:{fillColor:"#808080",fillOpacity:1,strokeColor:"#000000",strokeOpacity:1,strokeWidth:1,strokeDashstyle:"solid",pointRadius:3,graphicName:"square"},initialize:function(a){OpenLayers.Format.Filter.v1_0_0.prototype.initialize.apply(this,[a])},read:function(c,a){a=OpenLayers.Util.applyDefaults(a,this.options);var b={namedLayers:a.namedLayersAsArray===true?[]:{}};this.readChildNodes(c,b);return b},readers:OpenLayers.Util.applyDefaults({sld:{StyledLayerDescriptor:function(a,b){b.version=a.getAttribute("version");this.readChildNodes(a,b)},Name:function(a,b){b.name=this.getChildValue(a)},Title:function(a,b){b.title=this.getChildValue(a)},Abstract:function(a,b){b.description=this.getChildValue(a)},NamedLayer:function(d,e){var c={userStyles:[],namedStyles:[]};this.readChildNodes(d,c);for(var b=0,a=c.userStyles.length;b<a;++b){c.userStyles[b].layerName=c.name}if(OpenLayers.Util.isArray(e.namedLayers)){e.namedLayers.push(c)}else{e.namedLayers[c.name]=c}},NamedStyle:function(b,a){a.namedStyles.push(this.getChildName(b.firstChild))},UserStyle:function(c,a){var d={defaultsPerSymbolizer:true,rules:[]};this.featureTypeCounter=-1;this.readChildNodes(c,d);var b;if(this.multipleSymbolizers){delete d.defaultsPerSymbolizer;b=new OpenLayers.Style2(d)}else{b=new OpenLayers.Style(this.defaultSymbolizer,d)}a.userStyles.push(b)},IsDefault:function(b,a){if(this.getChildValue(b)=="1"){a.isDefault=true}},FeatureTypeStyle:function(b,a){++this.featureTypeCounter;var c={rules:this.multipleSymbolizers?a.rules:[]};this.readChildNodes(b,c);if(!this.multipleSymbolizers){a.rules=c.rules}},Rule:function(b,d){var a;if(this.multipleSymbolizers){a={symbolizers:[]}}var c=new OpenLayers.Rule(a);this.readChildNodes(b,c);d.rules.push(c)},ElseFilter:function(a,b){b.elseFilter=true},MinScaleDenominator:function(a,b){b.minScaleDenominator=parseFloat(this.getChildValue(a))},MaxScaleDenominator:function(a,b){b.maxScaleDenominator=parseFloat(this.getChildValue(a))},TextSymbolizer:function(b,c){var a={};this.readChildNodes(b,a);if(this.multipleSymbolizers){a.zIndex=this.featureTypeCounter;c.symbolizers.push(new OpenLayers.Symbolizer.Text(a))}else{c.symbolizer.Text=OpenLayers.Util.applyDefaults(a,c.symbolizer.Text)}},Label:function(b,a){var d={};this.readChildNodes(b,d);if(d.property){a.label="${"+d.property+"}"}else{var c=this.readOgcExpression(b);if(c){a.label=c}}},Font:function(b,a){this.readChildNodes(b,a)},Halo:function(b,a){var c={};this.readChildNodes(b,c);a.haloRadius=c.haloRadius;a.haloColor=c.fillColor;a.haloOpacity=c.fillOpacity},Radius:function(c,b){var a=this.readOgcExpression(c);if(a!=null){b.haloRadius=a}},RasterSymbolizer:function(b,c){var a={};this.readChildNodes(b,a);if(this.multipleSymbolizers){a.zIndex=this.featureTypeCounter;c.symbolizers.push(new OpenLayers.Symbolizer.Raster(a))}else{c.symbolizer.Raster=OpenLayers.Util.applyDefaults(a,c.symbolizer.Raster)}},Geometry:function(a,b){b.geometry={};this.readChildNodes(a,b.geometry)},ColorMap:function(b,a){a.colorMap=[];this.readChildNodes(b,a.colorMap)},ColorMapEntry:function(b,a){var c=b.getAttribute("quantity");var d=b.getAttribute("opacity");a.push({color:b.getAttribute("color"),quantity:c!==null?parseFloat(c):undefined,label:b.getAttribute("label")||undefined,opacity:d!==null?parseFloat(d):undefined})},LineSymbolizer:function(b,c){var a={};this.readChildNodes(b,a);if(this.multipleSymbolizers){a.zIndex=this.featureTypeCounter;c.symbolizers.push(new OpenLayers.Symbolizer.Line(a))}else{c.symbolizer.Line=OpenLayers.Util.applyDefaults(a,c.symbolizer.Line)}},PolygonSymbolizer:function(b,c){var a={fill:false,stroke:false};if(!this.multipleSymbolizers){a=c.symbolizer.Polygon||a}this.readChildNodes(b,a);if(this.multipleSymbolizers){a.zIndex=this.featureTypeCounter;c.symbolizers.push(new OpenLayers.Symbolizer.Polygon(a))}else{c.symbolizer.Polygon=a}},PointSymbolizer:function(b,c){var a={fill:false,stroke:false,graphic:false};if(!this.multipleSymbolizers){a=c.symbolizer.Point||a}this.readChildNodes(b,a);if(this.multipleSymbolizers){a.zIndex=this.featureTypeCounter;c.symbolizers.push(new OpenLayers.Symbolizer.Point(a))}else{c.symbolizer.Point=a}},Stroke:function(b,a){a.stroke=true;this.readChildNodes(b,a)},Fill:function(b,a){a.fill=true;this.readChildNodes(b,a)},CssParameter:function(c,b){var a=c.getAttribute("name");var e=this.cssMap[a];if(e){var d=this.readOgcExpression(c);if(d){b[e]=d}}},Graphic:function(e,d){d.graphic=true;var h={};this.readChildNodes(e,h);var c=["stroke","strokeColor","strokeWidth","strokeOpacity","strokeLinecap","fill","fillColor","fillOpacity","graphicName","rotation","graphicFormat"];var g,f;for(var b=0,a=c.length;b<a;++b){g=c[b];f=h[g];if(f!=undefined){d[g]=f}}if(h.opacity!=undefined){d.graphicOpacity=h.opacity}if(h.size!=undefined){d.pointRadius=h.size/2}if(h.href!=undefined){d.externalGraphic=h.href}if(h.rotation!=undefined){d.rotation=h.rotation}},ExternalGraphic:function(a,b){this.readChildNodes(a,b)},Mark:function(a,b){this.readChildNodes(a,b)},WellKnownName:function(a,b){b.graphicName=this.getChildValue(a)},Opacity:function(b,c){var a=this.readOgcExpression(b);if(a){c.opacity=a}},Size:function(b,c){var a=this.readOgcExpression(b);if(a){c.size=a}},Rotation:function(b,c){var a=this.readOgcExpression(b);if(a){c.rotation=a}},OnlineResource:function(a,b){b.href=this.getAttributeNS(a,this.namespaces.xlink,"href")},Format:function(a,b){b.graphicFormat=this.getChildValue(a)}}},OpenLayers.Format.Filter.v1_0_0.prototype.readers),cssMap:{stroke:"strokeColor","stroke-opacity":"strokeOpacity","stroke-width":"strokeWidth","stroke-linecap":"strokeLinecap","stroke-dasharray":"strokeDashstyle",fill:"fillColor","fill-opacity":"fillOpacity","font-family":"fontFamily","font-size":"fontSize","font-weight":"fontWeight","font-style":"fontStyle"},getCssProperty:function(a){var b=null;for(var c in this.cssMap){if(this.cssMap[c]==a){b=c;break}}return b},getGraphicFormat:function(a){var d,c;for(var b in this.graphicFormats){if(this.graphicFormats[b].test(a)){d=b;break}}return d||this.defautlGraphicFormat},defaultGraphicFormat:"image/png",graphicFormats:{"image/jpeg":/\.jpe?g$/i,"image/gif":/\.gif$/i,"image/png":/\.png$/i},write:function(a){return this.writers.sld.StyledLayerDescriptor.apply(this,[a])},writers:OpenLayers.Util.applyDefaults({sld:{StyledLayerDescriptor:function(e){var b=this.createElementNSPlus("sld:StyledLayerDescriptor",{attributes:{version:this.VERSION,"xsi:schemaLocation":this.schemaLocation}});b.setAttribute("xmlns:ogc",this.namespaces.ogc);b.setAttribute("xmlns:gml",this.namespaces.gml);if(e.name){this.writeNode("Name",e.name,b)}if(e.title){this.writeNode("Title",e.title,b)}if(e.description){this.writeNode("Abstract",e.description,b)}if(OpenLayers.Util.isArray(e.namedLayers)){for(var d=0,a=e.namedLayers.length;d<a;++d){this.writeNode("NamedLayer",e.namedLayers[d],b)}}else{for(var c in e.namedLayers){this.writeNode("NamedLayer",e.namedLayers[c],b)}}return b},Name:function(a){return this.createElementNSPlus("sld:Name",{value:a})},Title:function(a){return this.createElementNSPlus("sld:Title",{value:a})},Abstract:function(a){return this.createElementNSPlus("sld:Abstract",{value:a})},NamedLayer:function(c){var d=this.createElementNSPlus("sld:NamedLayer");this.writeNode("Name",c.name,d);if(c.namedStyles){for(var b=0,a=c.namedStyles.length;b<a;++b){this.writeNode("NamedStyle",c.namedStyles[b],d)}}if(c.userStyles){for(var b=0,a=c.userStyles.length;b<a;++b){this.writeNode("UserStyle",c.userStyles[b],d)}}return d},NamedStyle:function(a){var b=this.createElementNSPlus("sld:NamedStyle");this.writeNode("Name",a,b);return b},UserStyle:function(b){var d=this.createElementNSPlus("sld:UserStyle");if(b.name){this.writeNode("Name",b.name,d)}if(b.title){this.writeNode("Title",b.title,d)}if(b.description){this.writeNode("Abstract",b.description,d)}if(b.isDefault){this.writeNode("IsDefault",b.isDefault,d)}if(this.multipleSymbolizers&&b.rules){var m={0:[]};var c=[0];var l,a,p,k,h;for(var f=0,o=b.rules.length;f<o;++f){l=b.rules[f];if(l.symbolizers){a={};for(var e=0,g=l.symbolizers.length;e<g;++e){p=l.symbolizers[e];k=p.zIndex;if(!(k in a)){h=l.clone();h.symbolizers=[];a[k]=h}a[k].symbolizers.push(p.clone())}for(k in a){if(!(k in m)){c.push(k);m[k]=[]}m[k].push(a[k])}}else{m[0].push(l.clone())}}c.sort();var n;for(var f=0,o=c.length;f<o;++f){n=m[c[f]];if(n.length>0){h=b.clone();h.rules=m[c[f]];this.writeNode("FeatureTypeStyle",h,d)}}}else{this.writeNode("FeatureTypeStyle",b,d)}return d},IsDefault:function(a){return this.createElementNSPlus("sld:IsDefault",{value:(a)?"1":"0"})},FeatureTypeStyle:function(c){var d=this.createElementNSPlus("sld:FeatureTypeStyle");for(var b=0,a=c.rules.length;b<a;++b){this.writeNode("Rule",c.rules[b],d)}return d},Rule:function(h){var g=this.createElementNSPlus("sld:Rule");if(h.name){this.writeNode("Name",h.name,g)}if(h.title){this.writeNode("Title",h.title,g)}if(h.description){this.writeNode("Abstract",h.description,g)}if(h.elseFilter){this.writeNode("ElseFilter",null,g)}else{if(h.filter){this.writeNode("ogc:Filter",h.filter,g)}}if(h.minScaleDenominator!=undefined){this.writeNode("MinScaleDenominator",h.minScaleDenominator,g)}if(h.maxScaleDenominator!=undefined){this.writeNode("MaxScaleDenominator",h.maxScaleDenominator,g)}var f,e;if(this.multipleSymbolizers&&h.symbolizers){var e;for(var c=0,d=h.symbolizers.length;c<d;++c){e=h.symbolizers[c];f=e.CLASS_NAME.split(".").pop();this.writeNode(f+"Symbolizer",e,g)}}else{var b=OpenLayers.Style.SYMBOLIZER_PREFIXES;for(var c=0,a=b.length;c<a;++c){f=b[c];e=h.symbolizer[f];if(e){this.writeNode(f+"Symbolizer",e,g)}}}return g},ElseFilter:function(){return this.createElementNSPlus("sld:ElseFilter")},MinScaleDenominator:function(a){return this.createElementNSPlus("sld:MinScaleDenominator",{value:a})},MaxScaleDenominator:function(a){return this.createElementNSPlus("sld:MaxScaleDenominator",{value:a})},LineSymbolizer:function(a){var b=this.createElementNSPlus("sld:LineSymbolizer");this.writeNode("Stroke",a,b);return b},Stroke:function(a){var b=this.createElementNSPlus("sld:Stroke");if(a.strokeColor!=undefined){this.writeNode("CssParameter",{symbolizer:a,key:"strokeColor"},b)}if(a.strokeOpacity!=undefined){this.writeNode("CssParameter",{symbolizer:a,key:"strokeOpacity"},b)}if(a.strokeWidth!=undefined){this.writeNode("CssParameter",{symbolizer:a,key:"strokeWidth"},b)}if(a.strokeDashstyle!=undefined&&a.strokeDashstyle!=="solid"){this.writeNode("CssParameter",{symbolizer:a,key:"strokeDashstyle"},b)}if(a.strokeLinecap!=undefined){this.writeNode("CssParameter",{symbolizer:a,key:"strokeLinecap"},b)}return b},CssParameter:function(a){return this.createElementNSPlus("sld:CssParameter",{attributes:{name:this.getCssProperty(a.key)},value:a.symbolizer[a.key]})},TextSymbolizer:function(a){var b=this.createElementNSPlus("sld:TextSymbolizer");if(a.label!=null){this.writeNode("Label",a.label,b)}if(a.fontFamily!=null||a.fontSize!=null||a.fontWeight!=null||a.fontStyle!=null){this.writeNode("Font",a,b)}if(a.haloRadius!=null||a.haloColor!=null||a.haloOpacity!=null){this.writeNode("Halo",a,b)}if(a.fillColor!=null||a.fillOpacity!=null){this.writeNode("Fill",a,b)}return b},Font:function(a){var b=this.createElementNSPlus("sld:Font");if(a.fontFamily){this.writeNode("CssParameter",{symbolizer:a,key:"fontFamily"},b)}if(a.fontSize){this.writeNode("CssParameter",{symbolizer:a,key:"fontSize"},b)}if(a.fontWeight){this.writeNode("CssParameter",{symbolizer:a,key:"fontWeight"},b)}if(a.fontStyle){this.writeNode("CssParameter",{symbolizer:a,key:"fontStyle"},b)}return b},Label:function(b){var f=this.createElementNSPlus("sld:Label");var g=b.split("${");f.appendChild(this.createTextNode(g[0]));var e,d;for(var c=1,a=g.length;c<a;c++){e=g[c];d=e.indexOf("}");if(d>0){this.writeNode("ogc:PropertyName",{property:e.substring(0,d)},f);f.appendChild(this.createTextNode(e.substring(++d)))}else{f.appendChild(this.createTextNode("${"+e))}}return f},Halo:function(a){var b=this.createElementNSPlus("sld:Halo");if(a.haloRadius){this.writeNode("Radius",a.haloRadius,b)}if(a.haloColor||a.haloOpacity){this.writeNode("Fill",{fillColor:a.haloColor,fillOpacity:a.haloOpacity},b)}return b},Radius:function(a){return this.createElementNSPlus("sld:Radius",{value:a})},RasterSymbolizer:function(a){var b=this.createElementNSPlus("sld:RasterSymbolizer");if(a.geometry){this.writeNode("Geometry",a.geometry,b)}if(a.opacity){this.writeNode("Opacity",a.opacity,b)}if(a.colorMap){this.writeNode("ColorMap",a.colorMap,b)}return b},Geometry:function(b){var a=this.createElementNSPlus("sld:Geometry");if(b.property){this.writeNode("ogc:PropertyName",b,a)}return a},ColorMap:function(b){var d=this.createElementNSPlus("sld:ColorMap");for(var c=0,a=b.length;c<a;++c){this.writeNode("ColorMapEntry",b[c],d)}return d},ColorMapEntry:function(c){var d=this.createElementNSPlus("sld:ColorMapEntry");var b=c;d.setAttribute("color",b.color);b.opacity!==undefined&&d.setAttribute("opacity",parseFloat(b.opacity));b.quantity!==undefined&&d.setAttribute("quantity",parseFloat(b.quantity));b.label!==undefined&&d.setAttribute("label",b.label);return d},PolygonSymbolizer:function(a){var b=this.createElementNSPlus("sld:PolygonSymbolizer");if(a.fill!==false){this.writeNode("Fill",a,b)}if(a.stroke!==false){this.writeNode("Stroke",a,b)}return b},Fill:function(a){var b=this.createElementNSPlus("sld:Fill");if(a.fillColor){this.writeNode("CssParameter",{symbolizer:a,key:"fillColor"},b)}if(a.fillOpacity!=null){this.writeNode("CssParameter",{symbolizer:a,key:"fillOpacity"},b)}return b},PointSymbolizer:function(a){var b=this.createElementNSPlus("sld:PointSymbolizer");this.writeNode("Graphic",a,b);return b},Graphic:function(a){var b=this.createElementNSPlus("sld:Graphic");if(a.externalGraphic!=undefined){this.writeNode("ExternalGraphic",a,b)}else{this.writeNode("Mark",a,b)}if(a.graphicOpacity!=undefined){this.writeNode("Opacity",a.graphicOpacity,b)}if(a.pointRadius!=undefined){this.writeNode("Size",a.pointRadius*2,b)}if(a.rotation!=undefined){this.writeNode("Rotation",a.rotation,b)}return b},ExternalGraphic:function(a){var b=this.createElementNSPlus("sld:ExternalGraphic");this.writeNode("OnlineResource",a.externalGraphic,b);var c=a.graphicFormat||this.getGraphicFormat(a.externalGraphic);this.writeNode("Format",c,b);return b},Mark:function(a){var b=this.createElementNSPlus("sld:Mark");if(a.graphicName){this.writeNode("WellKnownName",a.graphicName,b)}if(a.fill!==false){this.writeNode("Fill",a,b)}if(a.stroke!==false){this.writeNode("Stroke",a,b)}return b},WellKnownName:function(a){return this.createElementNSPlus("sld:WellKnownName",{value:a})},Opacity:function(a){return this.createElementNSPlus("sld:Opacity",{value:a})},Size:function(a){return this.createElementNSPlus("sld:Size",{value:a})},Rotation:function(a){return this.createElementNSPlus("sld:Rotation",{value:a})},OnlineResource:function(a){return this.createElementNSPlus("sld:OnlineResource",{attributes:{"xlink:type":"simple","xlink:href":a}})},Format:function(a){return this.createElementNSPlus("sld:Format",{value:a})}}},OpenLayers.Format.Filter.v1_0_0.prototype.writers),CLASS_NAME:"OpenLayers.Format.SLD.v1"});OpenLayers.Format.WFST=function(b){b=OpenLayers.Util.applyDefaults(b,OpenLayers.Format.WFST.DEFAULTS);var a=OpenLayers.Format.WFST["v"+b.version.replace(/\./g,"_")];if(!a){throw"Unsupported WFST version: "+b.version}return new a(b)};OpenLayers.Format.WFST.DEFAULTS={version:"1.0.0"};OpenLayers.Format.WFST.v1=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance",wfs:"http://www.opengis.net/wfs",gml:"http://www.opengis.net/gml",ogc:"http://www.opengis.net/ogc",ows:"http://www.opengis.net/ows"},defaultPrefix:"wfs",version:null,schemaLocations:null,srsName:null,extractAttributes:true,xy:true,stateName:null,initialize:function(a){this.stateName={};this.stateName[OpenLayers.State.INSERT]="wfs:Insert";this.stateName[OpenLayers.State.UPDATE]="wfs:Update";this.stateName[OpenLayers.State.DELETE]="wfs:Delete";OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},getSrsName:function(c,b){var a=b&&b.srsName;if(!a){if(c&&c.layer){a=c.layer.projection.getCode()}else{a=this.srsName}}return a},read:function(b,a){a=a||{};OpenLayers.Util.applyDefaults(a,{output:"features"});if(typeof b=="string"){b=OpenLayers.Format.XML.prototype.read.apply(this,[b])}if(b&&b.nodeType==9){b=b.documentElement}var c={};if(b){this.readNode(b,c,true)}if(c.features&&a.output==="features"){c=c.features}return c},readers:{wfs:{FeatureCollection:function(a,b){b.features=[];this.readChildNodes(a,b)}}},write:function(b,a){var c=this.writeNode("wfs:Transaction",{features:b,options:a});var d=this.schemaLocationAttr();if(d){this.setAttributeNS(c,this.namespaces.xsi,"xsi:schemaLocation",d)}return OpenLayers.Format.XML.prototype.write.apply(this,[c])},writers:{wfs:{GetFeature:function(b){var d=this.createElementNSPlus("wfs:GetFeature",{attributes:{service:"WFS",version:this.version,handle:b&&b.handle,outputFormat:b&&b.outputFormat,maxFeatures:b&&b.maxFeatures,"xsi:schemaLocation":this.schemaLocationAttr(b)}});if(typeof this.featureType=="string"){this.writeNode("Query",b,d)}else{for(var c=0,a=this.featureType.length;c<a;c++){b.featureType=this.featureType[c];this.writeNode("Query",b,d)}}return d},Transaction:function(h){h=h||{};var c=h.options||{};var g=this.createElementNSPlus("wfs:Transaction",{attributes:{service:"WFS",version:this.version,handle:c.handle}});var e,a;var f=h.features;if(f){if(c.multi===true){OpenLayers.Util.extend(this.geometryTypes,{"OpenLayers.Geometry.Point":"MultiPoint","OpenLayers.Geometry.LineString":(this.multiCurve===true)?"MultiCurve":"MultiLineString","OpenLayers.Geometry.Polygon":(this.multiSurface===true)?"MultiSurface":"MultiPolygon"})}var b,d;for(e=0,a=f.length;e<a;++e){d=f[e];b=this.stateName[d.state];if(b){this.writeNode(b,{feature:d,options:c},g)}}if(c.multi===true){this.setGeometryTypes()}}if(c.nativeElements){for(e=0,a=c.nativeElements.length;e<a;++e){this.writeNode("wfs:Native",c.nativeElements[e],g)}}return g},Native:function(b){var a=this.createElementNSPlus("wfs:Native",{attributes:{vendorId:b.vendorId,safeToIgnore:b.safeToIgnore},value:b.value});return a},Insert:function(d){var b=d.feature;var a=d.options;var c=this.createElementNSPlus("wfs:Insert",{attributes:{handle:a&&a.handle}});this.srsName=this.getSrsName(b);this.writeNode("feature:_typeName",b,c);return c},Update:function(f){var d=f.feature;var b=f.options;var e=this.createElementNSPlus("wfs:Update",{attributes:{handle:b&&b.handle,typeName:(this.featureNS?this.featurePrefix+":":"")+this.featureType}});if(this.featureNS){e.setAttribute("xmlns:"+this.featurePrefix,this.featureNS)}var a=d.modified;if(this.geometryName!==null&&(!a||a.geometry!==undefined)){this.srsName=this.getSrsName(d);this.writeNode("Property",{name:this.geometryName,value:d.geometry},e)}for(var c in d.attributes){if(d.attributes[c]!==undefined&&(!a||!a.attributes||(a.attributes&&a.attributes[c]!==undefined))){this.writeNode("Property",{name:c,value:d.attributes[c]},e)}}this.writeNode("ogc:Filter",new OpenLayers.Filter.FeatureId({fids:[d.fid]}),e);return e},Property:function(b){var a=this.createElementNSPlus("wfs:Property");this.writeNode("Name",b.name,a);if(b.value!==null){this.writeNode("Value",b.value,a)}return a},Name:function(a){return this.createElementNSPlus("wfs:Name",{value:a})},Value:function(c){var b;if(c instanceof OpenLayers.Geometry){b=this.createElementNSPlus("wfs:Value");var a=this.writeNode("feature:_geometry",c).firstChild;b.appendChild(a)}else{b=this.createElementNSPlus("wfs:Value",{value:c})}return b},Delete:function(d){var b=d.feature;var a=d.options;var c=this.createElementNSPlus("wfs:Delete",{attributes:{handle:a&&a.handle,typeName:(this.featureNS?this.featurePrefix+":":"")+this.featureType}});if(this.featureNS){c.setAttribute("xmlns:"+this.featurePrefix,this.featureNS)}this.writeNode("ogc:Filter",new OpenLayers.Filter.FeatureId({fids:[b.fid]}),c);return c}}},schemaLocationAttr:function(a){a=OpenLayers.Util.extend({featurePrefix:this.featurePrefix,schema:this.schema},a);var f=OpenLayers.Util.extend({},this.schemaLocations);if(a.schema){f[a.featurePrefix]=a.schema}var e=[];var c;for(var b in f){c=this.namespaces[b];if(c){e.push(c+" "+f[b])}}var d=e.join(" ")||undefined;return d},setFilterProperty:function(c){if(c.filters){for(var b=0,a=c.filters.length;b<a;++b){this.setFilterProperty(c.filters[b])}}else{if(c instanceof OpenLayers.Filter.Spatial){c.property=this.geometryName}}},CLASS_NAME:"OpenLayers.Format.WFST.v1"});OpenLayers.Format.GML.v3=OpenLayers.Class(OpenLayers.Format.GML.Base,{schemaLocation:"http://www.opengis.net/gml http://schemas.opengis.net/gml/3.1.1/profiles/gmlsfProfile/1.0.0/gmlsf.xsd",curve:false,multiCurve:true,surface:false,multiSurface:true,initialize:function(a){OpenLayers.Format.GML.Base.prototype.initialize.apply(this,[a])},readers:{gml:OpenLayers.Util.applyDefaults({featureMembers:function(a,b){this.readChildNodes(a,b)},Curve:function(b,a){var c={points:[]};this.readChildNodes(b,c);if(!a.components){a.components=[]}a.components.push(new OpenLayers.Geometry.LineString(c.points))},segments:function(a,b){this.readChildNodes(a,b)},LineStringSegment:function(b,a){var c={};this.readChildNodes(b,c);if(c.points){Array.prototype.push.apply(a.points,c.points)}},pos:function(b,d){var e=this.getChildValue(b).replace(this.regExes.trimSpace,"");var c=e.split(this.regExes.splitSpace);var a;if(this.xy){a=new OpenLayers.Geometry.Point(c[0],c[1],c[2])}else{a=new OpenLayers.Geometry.Point(c[1],c[0],c[2])}d.points=[a]},posList:function(a,d){var h=this.getChildValue(a).replace(this.regExes.trimSpace,"");var m=h.split(this.regExes.splitSpace);var e=parseInt(a.getAttribute("dimension"))||2;var b,n,l,g;var k=m.length/e;var o=new Array(k);for(var c=0,f=m.length;c<f;c+=e){n=m[c];l=m[c+1];g=(e==2)?undefined:m[c+2];if(this.xy){o[c/e]=new OpenLayers.Geometry.Point(n,l,g)}else{o[c/e]=new OpenLayers.Geometry.Point(l,n,g)}}d.points=o},Surface:function(a,b){this.readChildNodes(a,b)},patches:function(a,b){this.readChildNodes(a,b)},PolygonPatch:function(a,b){this.readers.gml.Polygon.apply(this,[a,b])},exterior:function(b,a){var c={};this.readChildNodes(b,c);a.outer=c.components[0]},interior:function(b,a){var c={};this.readChildNodes(b,c);a.inner.push(c.components[0])},MultiCurve:function(b,a){var c={components:[]};this.readChildNodes(b,c);if(c.components.length>0){a.components=[new OpenLayers.Geometry.MultiLineString(c.components)]}},curveMember:function(a,b){this.readChildNodes(a,b)},MultiSurface:function(b,a){var c={components:[]};this.readChildNodes(b,c);if(c.components.length>0){a.components=[new OpenLayers.Geometry.MultiPolygon(c.components)]}},surfaceMember:function(a,b){this.readChildNodes(a,b)},surfaceMembers:function(a,b){this.readChildNodes(a,b)},pointMembers:function(a,b){this.readChildNodes(a,b)},lineStringMembers:function(a,b){this.readChildNodes(a,b)},polygonMembers:function(a,b){this.readChildNodes(a,b)},geometryMembers:function(a,b){this.readChildNodes(a,b)},Envelope:function(d,b){var e={points:new Array(2)};this.readChildNodes(d,e);if(!b.components){b.components=[]}var c=e.points[0];var a=e.points[1];b.components.push(new OpenLayers.Bounds(c.x,c.y,a.x,a.y))},lowerCorner:function(b,a){var c={};this.readers.gml.pos.apply(this,[b,c]);a.points[0]=c.points[0]},upperCorner:function(b,a){var c={};this.readers.gml.pos.apply(this,[b,c]);a.points[1]=c.points[0]}},OpenLayers.Format.GML.Base.prototype.readers.gml),feature:OpenLayers.Format.GML.Base.prototype.readers.feature,wfs:OpenLayers.Format.GML.Base.prototype.readers.wfs},write:function(c){var b;if(OpenLayers.Util.isArray(c)){b="featureMembers"}else{b="featureMember"}var a=this.writeNode("gml:"+b,c);this.setAttributeNS(a,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);return OpenLayers.Format.XML.prototype.write.apply(this,[a])},writers:{gml:OpenLayers.Util.applyDefaults({featureMembers:function(c){var d=this.createElementNSPlus("gml:featureMembers");for(var b=0,a=c.length;b<a;++b){this.writeNode("feature:_typeName",c[b],d)}return d},Point:function(b){var a=this.createElementNSPlus("gml:Point");this.writeNode("pos",b,a);return a},pos:function(a){var b=(this.xy)?(a.x+" "+a.y):(a.y+" "+a.x);return this.createElementNSPlus("gml:pos",{value:b})},LineString:function(b){var a=this.createElementNSPlus("gml:LineString");this.writeNode("posList",b.components,a);return a},Curve:function(b){var a=this.createElementNSPlus("gml:Curve");this.writeNode("segments",b,a);return a},segments:function(b){var a=this.createElementNSPlus("gml:segments");this.writeNode("LineStringSegment",b,a);return a},LineStringSegment:function(b){var a=this.createElementNSPlus("gml:LineStringSegment");this.writeNode("posList",b.components,a);return a},posList:function(d){var b=d.length;var e=new Array(b);var a;for(var c=0;c<b;++c){a=d[c];if(this.xy){e[c]=a.x+" "+a.y}else{e[c]=a.y+" "+a.x}}return this.createElementNSPlus("gml:posList",{value:e.join(" ")})},Surface:function(b){var a=this.createElementNSPlus("gml:Surface");this.writeNode("patches",b,a);return a},patches:function(b){var a=this.createElementNSPlus("gml:patches");this.writeNode("PolygonPatch",b,a);return a},PolygonPatch:function(d){var c=this.createElementNSPlus("gml:PolygonPatch",{attributes:{interpolation:"planar"}});this.writeNode("exterior",d.components[0],c);for(var b=1,a=d.components.length;b<a;++b){this.writeNode("interior",d.components[b],c)}return c},Polygon:function(d){var c=this.createElementNSPlus("gml:Polygon");this.writeNode("exterior",d.components[0],c);for(var b=1,a=d.components.length;b<a;++b){this.writeNode("interior",d.components[b],c)}return c},exterior:function(a){var b=this.createElementNSPlus("gml:exterior");this.writeNode("LinearRing",a,b);return b},interior:function(a){var b=this.createElementNSPlus("gml:interior");this.writeNode("LinearRing",a,b);return b},LinearRing:function(a){var b=this.createElementNSPlus("gml:LinearRing");this.writeNode("posList",a.components,b);return b},MultiCurve:function(e){var d=this.createElementNSPlus("gml:MultiCurve");var c=e.components||[e];for(var b=0,a=c.length;b<a;++b){this.writeNode("curveMember",c[b],d)}return d},curveMember:function(b){var a=this.createElementNSPlus("gml:curveMember");if(this.curve){this.writeNode("Curve",b,a)}else{this.writeNode("LineString",b,a)}return a},MultiSurface:function(e){var d=this.createElementNSPlus("gml:MultiSurface");var c=e.components||[e];for(var b=0,a=c.length;b<a;++b){this.writeNode("surfaceMember",c[b],d)}return d},surfaceMember:function(a){var b=this.createElementNSPlus("gml:surfaceMember");if(this.surface){this.writeNode("Surface",a,b)}else{this.writeNode("Polygon",a,b)}return b},Envelope:function(b){var a=this.createElementNSPlus("gml:Envelope");this.writeNode("lowerCorner",b,a);this.writeNode("upperCorner",b,a);if(this.srsName){a.setAttribute("srsName",this.srsName)}return a},lowerCorner:function(a){var b=(this.xy)?(a.left+" "+a.bottom):(a.bottom+" "+a.left);return this.createElementNSPlus("gml:lowerCorner",{value:b})},upperCorner:function(a){var b=(this.xy)?(a.right+" "+a.top):(a.top+" "+a.right);return this.createElementNSPlus("gml:upperCorner",{value:b})}},OpenLayers.Format.GML.Base.prototype.writers.gml),feature:OpenLayers.Format.GML.Base.prototype.writers.feature,wfs:OpenLayers.Format.GML.Base.prototype.writers.wfs},setGeometryTypes:function(){this.geometryTypes={"OpenLayers.Geometry.Point":"Point","OpenLayers.Geometry.MultiPoint":"MultiPoint","OpenLayers.Geometry.LineString":(this.curve===true)?"Curve":"LineString","OpenLayers.Geometry.MultiLineString":(this.multiCurve===false)?"MultiLineString":"MultiCurve","OpenLayers.Geometry.Polygon":(this.surface===true)?"Surface":"Polygon","OpenLayers.Geometry.MultiPolygon":(this.multiSurface===false)?"MultiPolygon":"MultiSurface","OpenLayers.Geometry.Collection":"GeometryCollection"}},CLASS_NAME:"OpenLayers.Format.GML.v3"});OpenLayers.Format.Filter.v1_1_0=OpenLayers.Class(OpenLayers.Format.GML.v3,OpenLayers.Format.Filter.v1,{VERSION:"1.1.0",schemaLocation:"http://www.opengis.net/ogc/filter/1.1.0/filter.xsd",initialize:function(a){OpenLayers.Format.GML.v3.prototype.initialize.apply(this,[a])},readers:{ogc:OpenLayers.Util.applyDefaults({PropertyIsEqualTo:function(b,d){var c=b.getAttribute("matchCase");var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.EQUAL_TO,matchCase:!(c==="false"||c==="0")});this.readChildNodes(b,a);d.filters.push(a)},PropertyIsNotEqualTo:function(b,d){var c=b.getAttribute("matchCase");var a=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.NOT_EQUAL_TO,matchCase:!(c==="false"||c==="0")});this.readChildNodes(b,a);d.filters.push(a)},PropertyIsLike:function(d,e){var c=new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.LIKE});this.readChildNodes(d,c);var f=d.getAttribute("wildCard");var b=d.getAttribute("singleChar");var a=d.getAttribute("escapeChar");c.value2regex(f,b,a);e.filters.push(c)}},OpenLayers.Format.Filter.v1.prototype.readers.ogc),gml:OpenLayers.Format.GML.v3.prototype.readers.gml,feature:OpenLayers.Format.GML.v3.prototype.readers.feature},writers:{ogc:OpenLayers.Util.applyDefaults({PropertyIsEqualTo:function(a){var b=this.createElementNSPlus("ogc:PropertyIsEqualTo",{attributes:{matchCase:a.matchCase}});this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsNotEqualTo:function(a){var b=this.createElementNSPlus("ogc:PropertyIsNotEqualTo",{attributes:{matchCase:a.matchCase}});this.writeNode("PropertyName",a,b);this.writeOgcExpression(a.value,b);return b},PropertyIsLike:function(a){var b=this.createElementNSPlus("ogc:PropertyIsLike",{attributes:{matchCase:a.matchCase,wildCard:"*",singleChar:".",escapeChar:"!"}});this.writeNode("PropertyName",a,b);this.writeNode("Literal",a.regex2value(),b);return b},BBOX:function(a){var c=this.createElementNSPlus("ogc:BBOX");a.property&&this.writeNode("PropertyName",a,c);var b=this.writeNode("gml:Envelope",a.value);if(a.projection){b.setAttribute("srsName",a.projection)}c.appendChild(b);return c},SortBy:function(d){var c=this.createElementNSPlus("ogc:SortBy");for(var b=0,a=d.length;b<a;b++){this.writeNode("ogc:SortProperty",d[b],c)}return c},SortProperty:function(b){var a=this.createElementNSPlus("ogc:SortProperty");this.writeNode("ogc:PropertyName",b,a);this.writeNode("ogc:SortOrder",(b.order=="DESC")?"DESC":"ASC",a);return a},SortOrder:function(b){var a=this.createElementNSPlus("ogc:SortOrder",{value:b});return a}},OpenLayers.Format.Filter.v1.prototype.writers.ogc),gml:OpenLayers.Format.GML.v3.prototype.writers.gml,feature:OpenLayers.Format.GML.v3.prototype.writers.feature},writeSpatial:function(b,a){var c=this.createElementNSPlus("ogc:"+a);this.writeNode("PropertyName",b,c);if(b.value instanceof OpenLayers.Filter.Function){this.writeNode("Function",b.value,c)}else{var d;if(b.value instanceof OpenLayers.Geometry){d=this.writeNode("feature:_geometry",b.value).firstChild}else{d=this.writeNode("gml:Envelope",b.value)}if(b.projection){d.setAttribute("srsName",b.projection)}c.appendChild(d)}return c},CLASS_NAME:"OpenLayers.Format.Filter.v1_1_0"});OpenLayers.Format.OWSCommon=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.0.0",getVersion:function(b,c){var a=this.version;if(!a){var d=b.getAttribute("xmlns:ows");if(d&&d.substring(d.lastIndexOf("/")+1)==="1.1"){a="1.1.0"}if(!a){a=this.defaultVersion}}return a},CLASS_NAME:"OpenLayers.Format.OWSCommon"});OpenLayers.Format.OWSCommon.v1=OpenLayers.Class(OpenLayers.Format.XML,{regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},read:function(b,a){a=OpenLayers.Util.applyDefaults(a,this.options);var c={};this.readChildNodes(b,c);return c},readers:{ows:{Exception:function(b,c){var a={code:b.getAttribute("exceptionCode"),locator:b.getAttribute("locator"),texts:[]};c.exceptions.push(a);this.readChildNodes(b,a)},ExceptionText:function(b,a){var c=this.getChildValue(b);a.texts.push(c)},ServiceIdentification:function(a,b){b.serviceIdentification={};this.readChildNodes(a,b.serviceIdentification)},Title:function(a,b){b.title=this.getChildValue(a)},Abstract:function(a,b){b["abstract"]=this.getChildValue(a)},Keywords:function(a,b){b.keywords={};this.readChildNodes(a,b.keywords)},Keyword:function(b,a){a[this.getChildValue(b)]=true},ServiceType:function(a,b){b.serviceType={codeSpace:a.getAttribute("codeSpace"),value:this.getChildValue(a)}},ServiceTypeVersion:function(a,b){b.serviceTypeVersion=this.getChildValue(a)},Fees:function(a,b){b.fees=this.getChildValue(a)},AccessConstraints:function(a,b){b.accessConstraints=this.getChildValue(a)},ServiceProvider:function(a,b){b.serviceProvider={};this.readChildNodes(a,b.serviceProvider)},ProviderName:function(a,b){b.providerName=this.getChildValue(a)},ProviderSite:function(a,b){b.providerSite=this.getAttributeNS(a,this.namespaces.xlink,"href")},ServiceContact:function(a,b){b.serviceContact={};this.readChildNodes(a,b.serviceContact)},IndividualName:function(b,a){a.individualName=this.getChildValue(b)},PositionName:function(b,a){a.positionName=this.getChildValue(b)},ContactInfo:function(b,a){a.contactInfo={};this.readChildNodes(b,a.contactInfo)},Phone:function(b,a){a.phone={};this.readChildNodes(b,a.phone)},Voice:function(b,a){a.voice=this.getChildValue(b)},Address:function(b,a){a.address={};this.readChildNodes(b,a.address)},DeliveryPoint:function(b,a){a.deliveryPoint=this.getChildValue(b)},City:function(b,a){a.city=this.getChildValue(b)},AdministrativeArea:function(b,a){a.administrativeArea=this.getChildValue(b)},PostalCode:function(b,a){a.postalCode=this.getChildValue(b)},Country:function(b,a){a.country=this.getChildValue(b)},ElectronicMailAddress:function(b,a){a.electronicMailAddress=this.getChildValue(b)},Role:function(b,a){a.role=this.getChildValue(b)},OperationsMetadata:function(a,b){b.operationsMetadata={};this.readChildNodes(a,b.operationsMetadata)},Operation:function(c,b){var a=c.getAttribute("name");b[a]={};this.readChildNodes(c,b[a])},DCP:function(b,a){a.dcp={};this.readChildNodes(b,a.dcp)},HTTP:function(b,a){a.http={};this.readChildNodes(b,a.http)},Get:function(b,a){a.get=this.getAttributeNS(b,this.namespaces.xlink,"href")},Post:function(b,a){a.post=this.getAttributeNS(b,this.namespaces.xlink,"href")},Parameter:function(c,a){if(!a.parameters){a.parameters={}}var b=c.getAttribute("name");a.parameters[b]={};this.readChildNodes(c,a.parameters[b])},Value:function(a,b){b[this.getChildValue(a)]=true},OutputFormat:function(a,b){b.formats.push({value:this.getChildValue(a)});this.readChildNodes(a,b)},WGS84BoundingBox:function(b,c){var a={};a.crs=b.getAttribute("crs");if(c.BoundingBox){c.BoundingBox.push(a)}else{c.projection=a.crs;a=c}this.readChildNodes(b,a)},BoundingBox:function(a,b){this.readers.ows["WGS84BoundingBox"].apply(this,[a,b])},LowerCorner:function(b,c){var d=this.getChildValue(b).replace(this.regExes.trimSpace,"");d=d.replace(this.regExes.trimComma,",");var a=d.split(this.regExes.splitSpace);c.left=a[0];c.bottom=a[1]},UpperCorner:function(b,c){var d=this.getChildValue(b).replace(this.regExes.trimSpace,"");d=d.replace(this.regExes.trimComma,",");var a=d.split(this.regExes.splitSpace);c.right=a[0];c.top=a[1];c.bounds=new OpenLayers.Bounds(c.left,c.bottom,c.right,c.top);delete c.left;delete c.bottom;delete c.right;delete c.top},Language:function(a,b){b.language=this.getChildValue(a)}}},writers:{ows:{BoundingBox:function(a){var b=this.createElementNSPlus("ows:BoundingBox",{attributes:{crs:a.projection}});this.writeNode("ows:LowerCorner",a,b);this.writeNode("ows:UpperCorner",a,b);return b},LowerCorner:function(a){var b=this.createElementNSPlus("ows:LowerCorner",{value:a.bounds.left+" "+a.bounds.bottom});return b},UpperCorner:function(a){var b=this.createElementNSPlus("ows:UpperCorner",{value:a.bounds.right+" "+a.bounds.top});return b},Identifier:function(a){var b=this.createElementNSPlus("ows:Identifier",{value:a});return b},Title:function(b){var a=this.createElementNSPlus("ows:Title",{value:b});return a},Abstract:function(a){var b=this.createElementNSPlus("ows:Abstract",{value:a});return b},OutputFormat:function(b){var a=this.createElementNSPlus("ows:OutputFormat",{value:b});return a}}},CLASS_NAME:"OpenLayers.Format.OWSCommon.v1"});OpenLayers.Format.OWSCommon.v1_0_0=OpenLayers.Class(OpenLayers.Format.OWSCommon.v1,{namespaces:{ows:"http://www.opengis.net/ows",xlink:"http://www.w3.org/1999/xlink"},readers:{ows:OpenLayers.Util.applyDefaults({ExceptionReport:function(a,b){b.success=false;b.exceptionReport={version:a.getAttribute("version"),language:a.getAttribute("language"),exceptions:[]};this.readChildNodes(a,b.exceptionReport)}},OpenLayers.Format.OWSCommon.v1.prototype.readers.ows)},writers:{ows:OpenLayers.Format.OWSCommon.v1.prototype.writers.ows},CLASS_NAME:"OpenLayers.Format.OWSCommon.v1_0_0"});OpenLayers.Format.WFST.v1_1_0=OpenLayers.Class(OpenLayers.Format.Filter.v1_1_0,OpenLayers.Format.WFST.v1,{version:"1.1.0",schemaLocations:{wfs:"http://schemas.opengis.net/wfs/1.1.0/wfs.xsd"},initialize:function(a){OpenLayers.Format.Filter.v1_1_0.prototype.initialize.apply(this,[a]);OpenLayers.Format.WFST.v1.prototype.initialize.apply(this,[a])},readNode:function(a,b,c){return OpenLayers.Format.GML.v3.prototype.readNode.apply(this,[a,b])},readers:{wfs:OpenLayers.Util.applyDefaults({FeatureCollection:function(a,b){b.numberOfFeatures=parseInt(a.getAttribute("numberOfFeatures"));OpenLayers.Format.WFST.v1.prototype.readers.wfs["FeatureCollection"].apply(this,arguments)},TransactionResponse:function(a,b){b.insertIds=[];b.success=false;this.readChildNodes(a,b)},TransactionSummary:function(a,b){b.success=true},InsertResults:function(a,b){this.readChildNodes(a,b)},Feature:function(b,a){var c={fids:[]};this.readChildNodes(b,c);a.insertIds.push(c.fids[0])}},OpenLayers.Format.WFST.v1.prototype.readers.wfs),gml:OpenLayers.Format.GML.v3.prototype.readers.gml,feature:OpenLayers.Format.GML.v3.prototype.readers.feature,ogc:OpenLayers.Format.Filter.v1_1_0.prototype.readers.ogc,ows:OpenLayers.Format.OWSCommon.v1_0_0.prototype.readers.ows},writers:{wfs:OpenLayers.Util.applyDefaults({GetFeature:function(a){var b=OpenLayers.Format.WFST.v1.prototype.writers.wfs["GetFeature"].apply(this,arguments);a&&this.setAttributes(b,{resultType:a.resultType,startIndex:a.startIndex,count:a.count});return b},Query:function(b){b=OpenLayers.Util.extend({featureNS:this.featureNS,featurePrefix:this.featurePrefix,featureType:this.featureType,srsName:this.srsName},b);var e=b.featurePrefix;var d=this.createElementNSPlus("wfs:Query",{attributes:{typeName:(e?e+":":"")+b.featureType,srsName:b.srsName}});if(b.featureNS){d.setAttribute("xmlns:"+e,b.featureNS)}if(b.propertyNames){for(var c=0,a=b.propertyNames.length;c<a;c++){this.writeNode("wfs:PropertyName",{property:b.propertyNames[c]},d)}}if(b.filter){this.setFilterProperty(b.filter);this.writeNode("ogc:Filter",b.filter,d)}return d},PropertyName:function(a){return this.createElementNSPlus("wfs:PropertyName",{value:a.property})}},OpenLayers.Format.WFST.v1.prototype.writers.wfs),gml:OpenLayers.Format.GML.v3.prototype.writers.gml,feature:OpenLayers.Format.GML.v3.prototype.writers.feature,ogc:OpenLayers.Format.Filter.v1_1_0.prototype.writers.ogc},CLASS_NAME:"OpenLayers.Format.WFST.v1_1_0"});OpenLayers.Layer.VirtualEarth=OpenLayers.Class(OpenLayers.Layer.EventPane,OpenLayers.Layer.FixedZoomLevels,{MIN_ZOOM_LEVEL:1,MAX_ZOOM_LEVEL:19,RESOLUTIONS:[1.40625,0.703125,0.3515625,0.17578125,0.087890625,0.0439453125,0.02197265625,0.010986328125,0.0054931640625,0.00274658203125,0.001373291015625,0.0006866455078125,0.00034332275390625,0.000171661376953125,0.0000858306884765625,0.00004291534423828125,0.00002145767211914062,0.00001072883605957031,0.00000536441802978515],type:null,wrapDateLine:true,sphericalMercator:false,animationEnabled:true,initialize:function(b,a){OpenLayers.Layer.EventPane.prototype.initialize.apply(this,arguments);OpenLayers.Layer.FixedZoomLevels.prototype.initialize.apply(this,arguments);if(this.sphericalMercator){OpenLayers.Util.extend(this,OpenLayers.Layer.SphericalMercator);this.initMercatorParameters()}},loadMapObject:function(){var a=OpenLayers.Util.createDiv(this.name);var c=this.map.getSize();a.style.width=c.w+"px";a.style.height=c.h+"px";this.div.appendChild(a);try{this.mapObject=new VEMap(this.name)}catch(b){}if(this.mapObject!=null){try{this.mapObject.LoadMap(null,null,this.type,true);this.mapObject.AttachEvent("onmousedown",OpenLayers.Function.True)}catch(b){}this.mapObject.HideDashboard();if(typeof this.mapObject.SetAnimationEnabled=="function"){this.mapObject.SetAnimationEnabled(this.animationEnabled)}}if(!this.mapObject||!this.mapObject.vemapcontrol||!this.mapObject.vemapcontrol.PanMap||(typeof this.mapObject.vemapcontrol.PanMap!="function")){this.dragPanMapObject=null}},onMapResize:function(){this.mapObject.Resize(this.map.size.w,this.map.size.h)},getWarningHTML:function(){return OpenLayers.i18n("getLayerWarning",{layerType:"VE",layerLib:"VirtualEarth"})},setMapObjectCenter:function(a,b){this.mapObject.SetCenterAndZoom(a,b)},getMapObjectCenter:function(){return this.mapObject.GetCenter()},dragPanMapObject:function(b,a){this.mapObject.vemapcontrol.PanMap(b,-a)},getMapObjectZoom:function(){return this.mapObject.GetZoomLevel()},getMapObjectLonLatFromMapObjectPixel:function(a){return(typeof VEPixel!="undefined")?this.mapObject.PixelToLatLong(a):this.mapObject.PixelToLatLong(a.x,a.y)},getMapObjectPixelFromMapObjectLonLat:function(a){return this.mapObject.LatLongToPixel(a)},getLongitudeFromMapObjectLonLat:function(a){return this.sphericalMercator?this.forwardMercator(a.Longitude,a.Latitude).lon:a.Longitude},getLatitudeFromMapObjectLonLat:function(a){return this.sphericalMercator?this.forwardMercator(a.Longitude,a.Latitude).lat:a.Latitude},getMapObjectLonLatFromLonLat:function(d,b){var c;if(this.sphericalMercator){var a=this.inverseMercator(d,b);c=new VELatLong(a.lat,a.lon)}else{c=new VELatLong(b,d)}return c},getXFromMapObjectPixel:function(a){return a.x},getYFromMapObjectPixel:function(a){return a.y},getMapObjectPixelFromXY:function(a,b){return(typeof VEPixel!="undefined")?new VEPixel(a,b):new Msn.VE.Pixel(a,b)},CLASS_NAME:"OpenLayers.Layer.VirtualEarth"});OpenLayers.Control=OpenLayers.Class({id:null,map:null,div:null,type:null,allowSelection:false,displayClass:"",title:"",autoActivate:false,active:null,handler:null,eventListeners:null,events:null,EVENT_TYPES:["activate","deactivate"],initialize:function(a){this.displayClass=this.CLASS_NAME.replace("OpenLayers.","ol").replace(/\./g,"");OpenLayers.Util.extend(this,a);this.events=new OpenLayers.Events(this,null,this.EVENT_TYPES);if(this.eventListeners instanceof Object){this.events.on(this.eventListeners)}if(this.id==null){this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")}},destroy:function(){if(this.events){if(this.eventListeners){this.events.un(this.eventListeners)}this.events.destroy();this.events=null}this.eventListeners=null;if(this.handler){this.handler.destroy();this.handler=null}if(this.handlers){for(var a in this.handlers){if(this.handlers.hasOwnProperty(a)&&typeof this.handlers[a].destroy=="function"){this.handlers[a].destroy()}}this.handlers=null}if(this.map){this.map.removeControl(this);this.map=null}this.div=null},setMap:function(a){this.map=a;if(this.handler){this.handler.setMap(a)}},draw:function(a){if(this.div==null){this.div=OpenLayers.Util.createDiv(this.id);this.div.className=this.displayClass;if(!this.allowSelection){this.div.className+=" olControlNoSelect";this.div.setAttribute("unselectable","on",0);this.div.onselectstart=OpenLayers.Function.False}if(this.title!=""){this.div.title=this.title}}if(a!=null){this.position=a.clone()}this.moveTo(this.position);return this.div},moveTo:function(a){if((a!=null)&&(this.div!=null)){this.div.style.left=a.x+"px";this.div.style.top=a.y+"px"}},activate:function(){if(this.active){return false}if(this.handler){this.handler.activate()}this.active=true;if(this.map){OpenLayers.Element.addClass(this.map.viewPortDiv,this.displayClass.replace(/ /g,"")+"Active")}this.events.triggerEvent("activate");return true},deactivate:function(){if(this.active){if(this.handler){this.handler.deactivate()}this.active=false;if(this.map){OpenLayers.Element.removeClass(this.map.viewPortDiv,this.displayClass.replace(/ /g,"")+"Active")}this.events.triggerEvent("deactivate");return true}return false},CLASS_NAME:"OpenLayers.Control"});OpenLayers.Control.TYPE_BUTTON=1;OpenLayers.Control.TYPE_TOGGLE=2;OpenLayers.Control.TYPE_TOOL=3;OpenLayers.Control.Panel=OpenLayers.Class(OpenLayers.Control,{controls:null,autoActivate:true,defaultControl:null,saveState:false,allowDepress:false,activeState:null,initialize:function(a){OpenLayers.Control.prototype.initialize.apply(this,[a]);this.controls=[];this.activeState={}},destroy:function(){OpenLayers.Control.prototype.destroy.apply(this,arguments);for(var a,b=this.controls.length-1;b>=0;b--){a=this.controls[b];if(a.events){a.events.un({activate:this.iconOn,deactivate:this.iconOff})}OpenLayers.Event.stopObservingElement(a.panel_div);a.panel_div=null}this.activeState=null},activate:function(){if(OpenLayers.Control.prototype.activate.apply(this,arguments)){var c;for(var b=0,a=this.controls.length;b<a;b++){c=this.controls[b];if(c===this.defaultControl||(this.saveState&&this.activeState[c.id])){c.activate()}}if(this.saveState===true){this.defaultControl=null}this.redraw();return true}else{return false}},deactivate:function(){if(OpenLayers.Control.prototype.deactivate.apply(this,arguments)){var c;for(var b=0,a=this.controls.length;b<a;b++){c=this.controls[b];this.activeState[c.id]=c.deactivate()}this.redraw();return true}else{return false}},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);this.addControlsToMap(this.controls);return this.div},redraw:function(){for(var b=this.div.childNodes.length,c=b-1;c>=0;c--){this.div.removeChild(this.div.childNodes[c])}this.div.innerHTML="";if(this.active){for(var c=0,a=this.controls.length;c<a;c++){this.div.appendChild(this.controls[c].panel_div)}}},activateControl:function(d){if(!this.active){return false}if(d.type==OpenLayers.Control.TYPE_BUTTON){d.trigger();return}if(d.type==OpenLayers.Control.TYPE_TOGGLE){if(d.active){d.deactivate()}else{d.activate()}return}if(this.allowDepress&&d.active){d.deactivate()}else{var e;for(var b=0,a=this.controls.length;b<a;b++){e=this.controls[b];if(e!=d&&(e.type===OpenLayers.Control.TYPE_TOOL||e.type==null)){e.deactivate()}}d.activate()}},addControls:function(b){if(!(OpenLayers.Util.isArray(b))){b=[b]}this.controls=this.controls.concat(b);for(var d=0,a=b.length;d<a;d++){var c=document.createElement("div");c.className=b[d].displayClass+"ItemInactive";b[d].panel_div=c;if(b[d].title!=""){b[d].panel_div.title=b[d].title}OpenLayers.Event.observe(b[d].panel_div,"click",OpenLayers.Function.bind(this.onClick,this,b[d]));OpenLayers.Event.observe(b[d].panel_div,"dblclick",OpenLayers.Function.bind(this.onDoubleClick,this,b[d]));OpenLayers.Event.observe(b[d].panel_div,"mousedown",OpenLayers.Function.bindAsEventListener(OpenLayers.Event.stop))}if(this.map){this.addControlsToMap(b);this.redraw()}},addControlsToMap:function(b){var d;for(var c=0,a=b.length;c<a;c++){d=b[c];if(d.autoActivate===true){d.autoActivate=false;this.map.addControl(d);d.autoActivate=true}else{this.map.addControl(d);d.deactivate()}d.events.on({activate:this.iconOn,deactivate:this.iconOff})}},iconOn:function(){var a=this.panel_div;a.className=a.className.replace(/ItemInactive$/,"ItemActive")},iconOff:function(){var a=this.panel_div;a.className=a.className.replace(/ItemActive$/,"ItemInactive")},onClick:function(b,a){OpenLayers.Event.stop(a?a:window.event);this.activateControl(b)},onDoubleClick:function(b,a){OpenLayers.Event.stop(a?a:window.event)},getControlsBy:function(c,a){var d=(typeof a.test=="function");var b=OpenLayers.Array.filter(this.controls,function(e){return e[c]==a||(d&&a.test(e[c]))});return b},getControlsByName:function(a){return this.getControlsBy("name",a)},getControlsByClass:function(a){return this.getControlsBy("CLASS_NAME",a)},CLASS_NAME:"OpenLayers.Control.Panel"});OpenLayers.Control.ZoomIn=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_BUTTON,trigger:function(){this.map.zoomIn()},CLASS_NAME:"OpenLayers.Control.ZoomIn"});OpenLayers.Control.ZoomOut=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_BUTTON,trigger:function(){this.map.zoomOut()},CLASS_NAME:"OpenLayers.Control.ZoomOut"});OpenLayers.Control.ZoomToMaxExtent=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_BUTTON,trigger:function(){if(this.map){this.map.zoomToMaxExtent()}},CLASS_NAME:"OpenLayers.Control.ZoomToMaxExtent"});OpenLayers.Control.ZoomPanel=OpenLayers.Class(OpenLayers.Control.Panel,{initialize:function(a){OpenLayers.Control.Panel.prototype.initialize.apply(this,[a]);this.addControls([new OpenLayers.Control.ZoomIn(),new OpenLayers.Control.ZoomToMaxExtent(),new OpenLayers.Control.ZoomOut()])},CLASS_NAME:"OpenLayers.Control.ZoomPanel"});OpenLayers.Layer.HTTPRequest=OpenLayers.Class(OpenLayers.Layer,{URL_HASH_FACTOR:(Math.sqrt(5)-1)/2,url:null,params:null,reproject:false,initialize:function(c,b,d,a){OpenLayers.Layer.prototype.initialize.apply(this,[c,a]);this.url=b;this.params=OpenLayers.Util.extend({},d)},destroy:function(){this.url=null;this.params=null;OpenLayers.Layer.prototype.destroy.apply(this,arguments)},clone:function(a){if(a==null){a=new OpenLayers.Layer.HTTPRequest(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.prototype.clone.apply(this,[a]);return a},setUrl:function(a){this.url=a},mergeNewParams:function(b){this.params=OpenLayers.Util.extend(this.params,b);var a=this.redraw();if(this.map!=null){this.map.events.triggerEvent("changelayer",{layer:this,property:"params"})}return a},redraw:function(a){if(a){return this.mergeNewParams({_olSalt:Math.random()})}else{return OpenLayers.Layer.prototype.redraw.apply(this,[])}},selectUrl:function(e,d){var c=1;for(var b=0,a=e.length;b<a;b++){c*=e.charCodeAt(b)*this.URL_HASH_FACTOR;c-=Math.floor(c)}return d[Math.floor(c*d.length)]},getFullRequestString:function(g,d){var b=d||this.url;var f=OpenLayers.Util.extend({},this.params);f=OpenLayers.Util.extend(f,g);var e=OpenLayers.Util.getParameterString(f);if(OpenLayers.Util.isArray(b)){b=this.selectUrl(e,b)}var a=OpenLayers.Util.upperCaseObject(OpenLayers.Util.getParameters(b));for(var c in f){if(c.toUpperCase() in a){delete f[c]}}e=OpenLayers.Util.getParameterString(f);return OpenLayers.Util.urlAppend(b,e)},CLASS_NAME:"OpenLayers.Layer.HTTPRequest"});OpenLayers.Layer.Grid=OpenLayers.Class(OpenLayers.Layer.HTTPRequest,{tileSize:null,tileOriginCorner:"bl",tileOrigin:null,tileOptions:null,grid:null,singleTile:false,ratio:1.5,buffer:0,numLoadingTiles:0,tileLoadingDelay:100,timerId:null,initialize:function(c,b,d,a){OpenLayers.Layer.HTTPRequest.prototype.initialize.apply(this,arguments);this.events.addEventType("tileloaded");this.grid=[];this._moveGriddedTiles=OpenLayers.Function.bind(this.moveGriddedTiles,this)},removeMap:function(a){if(this.timerId!=null){window.clearTimeout(this.timerId);this.timerId=null}},destroy:function(){this.clearGrid();this.grid=null;this.tileSize=null;OpenLayers.Layer.HTTPRequest.prototype.destroy.apply(this,arguments)},clearGrid:function(){if(this.grid){for(var f=0,b=this.grid.length;f<b;f++){var e=this.grid[f];for(var c=0,a=e.length;c<a;c++){var d=e[c];this.removeTileMonitoringHooks(d);d.destroy()}}this.grid=[]}},clone:function(a){if(a==null){a=new OpenLayers.Layer.Grid(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.HTTPRequest.prototype.clone.apply(this,[a]);if(this.tileSize!=null){a.tileSize=this.tileSize.clone()}a.grid=[];return a},moveTo:function(d,a,e){OpenLayers.Layer.HTTPRequest.prototype.moveTo.apply(this,arguments);d=d||this.map.getExtent();if(d!=null){var c=!this.grid.length||a;var b=this.getTilesBounds();if(this.singleTile){if(c||(!e&&!b.containsBounds(d))){this.initSingleTile(d)}}else{if(c||!b.containsBounds(d,true)){this.initGriddedTiles(d)}else{this.scheduleMoveGriddedTiles()}}}},moveByPx:function(b,a){if(!this.singleTile){this.scheduleMoveGriddedTiles()}},scheduleMoveGriddedTiles:function(){if(this.timerId!=null){window.clearTimeout(this.timerId)}this.timerId=window.setTimeout(this._moveGriddedTiles,this.tileLoadingDelay)},setTileSize:function(a){if(this.singleTile){a=this.map.getSize();a.h=parseInt(a.h*this.ratio);a.w=parseInt(a.w*this.ratio)}OpenLayers.Layer.HTTPRequest.prototype.setTileSize.apply(this,[a])},getGridBounds:function(){var a="The getGridBounds() function is deprecated. It will be removed in 3.0. Please use getTilesBounds() instead.";OpenLayers.Console.warn(a);return this.getTilesBounds()},getTilesBounds:function(){var e=null;if(this.grid.length){var a=this.grid.length-1;var d=this.grid[a][0];var b=this.grid[0].length-1;var c=this.grid[0][b];e=new OpenLayers.Bounds(d.bounds.left,d.bounds.bottom,c.bounds.right,c.bounds.top)}return e},initSingleTile:function(f){var a=f.getCenterLonLat();var h=f.getWidth()*this.ratio;var b=f.getHeight()*this.ratio;var g=new OpenLayers.Bounds(a.lon-(h/2),a.lat-(b/2),a.lon+(h/2),a.lat+(b/2));var d=new OpenLayers.LonLat(g.left,g.top);var c=this.map.getLayerPxFromLonLat(d);if(!this.grid.length){this.grid[0]=[]}var e=this.grid[0][0];if(!e){e=this.addTile(g,c);this.addTileMonitoringHooks(e);e.draw();this.grid[0][0]=e}else{e.moveTo(g,c)}this.removeExcessTiles(1,1)},calculateGridLayout:function(a,n,e){var k=e*this.tileSize.w;var c=e*this.tileSize.h;var i=a.left-n.lon;var l=Math.floor(i/k)-this.buffer;var j=i/k-l;var f=-j*this.tileSize.w;var m=n.lon+l*k;var b=a.top-(n.lat+c);var h=Math.ceil(b/c)+this.buffer;var o=h-b/c;var d=-o*this.tileSize.h;var g=n.lat+h*c;return{tilelon:k,tilelat:c,tileoffsetlon:m,tileoffsetlat:g,tileoffsetx:f,tileoffsety:d}},getTileOrigin:function(){var b=this.tileOrigin;if(!b){var c=this.getMaxExtent();var a=({tl:["left","top"],tr:["right","top"],bl:["left","bottom"],br:["right","bottom"]})[this.tileOriginCorner];b=new OpenLayers.LonLat(c[a[0]],c[a[1]])}return b},initGriddedTiles:function(i){var g=this.map.getSize();var u=Math.ceil(g.h/this.tileSize.h)+Math.max(1,2*this.buffer);var w=Math.ceil(g.w/this.tileSize.w)+Math.max(1,2*this.buffer);var A=this.getTileOrigin();var q=this.map.getResolution();var p=this.calculateGridLayout(i,A,q);var f=Math.round(p.tileoffsetx);var c=Math.round(p.tileoffsety);var k=p.tileoffsetlon;var n=p.tileoffsetlat;var e=p.tilelon;var j=p.tilelat;this.origin=new OpenLayers.Pixel(f,c);var t=f;var v=k;var s=0;var a=parseInt(this.map.layerContainerDiv.style.left);var r=parseInt(this.map.layerContainerDiv.style.top);do{var h=this.grid[s++];if(!h){h=[];this.grid.push(h)}k=v;f=t;var d=0;do{var b=new OpenLayers.Bounds(k,n,k+e,n+j);var m=f;m-=a;var l=c;l-=r;var o=new OpenLayers.Pixel(m,l);var z=h[d++];if(!z){z=this.addTile(b,o);this.addTileMonitoringHooks(z);h.push(z)}else{z.moveTo(b,o,false)}k+=e;f+=this.tileSize.w}while((k<=i.right+e*this.buffer)||d<w);n-=j;c+=this.tileSize.h}while((n>=i.bottom-j*this.buffer)||s<u);this.removeExcessTiles(s,d);this.spiralTileLoad()},getMaxExtent:function(){return this.maxExtent},spiralTileLoad:function(){var b=[];var h=["right","down","left","up"];var g=0;var a=-1;var k=OpenLayers.Util.indexOf(h,"right");var l=0;while(l<h.length){var j=g;var c=a;switch(h[k]){case"right":c++;break;case"down":j++;break;case"left":c--;break;case"up":j--;break}var f=null;if((j<this.grid.length)&&(j>=0)&&(c<this.grid[0].length)&&(c>=0)){f=this.grid[j][c]}if((f!=null)&&(!f.queued)){b.unshift(f);f.queued=true;l=0;g=j;a=c}else{k=(k+1)%4;l++}}for(var d=0,e=b.length;d<e;d++){var f=b[d];f.draw();f.queued=false}},addTile:function(b,a){return new OpenLayers.Tile.Image(this,a,b,null,this.tileSize,this.tileOptions)},addTileMonitoringHooks:function(a){a.onLoadStart=function(){if(this.numLoadingTiles==0){this.events.triggerEvent("loadstart")}this.numLoadingTiles++};a.events.register("loadstart",this,a.onLoadStart);a.onLoadEnd=function(){this.numLoadingTiles--;this.events.triggerEvent("tileloaded");if(this.numLoadingTiles==0){this.events.triggerEvent("loadend")}};a.events.register("loadend",this,a.onLoadEnd);a.events.register("unload",this,a.onLoadEnd)},removeTileMonitoringHooks:function(a){a.unload();a.events.un({loadstart:a.onLoadStart,loadend:a.onLoadEnd,unload:a.onLoadEnd,scope:this})},moveGriddedTiles:function(){var d=true;var c=this.buffer||1;var b=this.grid[0][0].position;var a=parseInt(this.map.layerContainerDiv.style.left);var f=parseInt(this.map.layerContainerDiv.style.top);var e=b.add(a,f);if(e.x>-this.tileSize.w*(c-1)){this.shiftColumn(true)}else{if(e.x<-this.tileSize.w*c){this.shiftColumn(false)}else{if(e.y>-this.tileSize.h*(c-1)){this.shiftRow(true)}else{if(e.y<-this.tileSize.h*c){this.shiftRow(false)}else{d=false}}}}if(d){this.timerId=window.setTimeout(this._moveGriddedTiles,0)}},shiftRow:function(n){var c=(n)?0:(this.grid.length-1);var b=this.grid;var f=b[c];var e=this.map.getResolution();var h=(n)?-this.tileSize.h:this.tileSize.h;var g=e*-h;var m=(n)?b.pop():b.shift();for(var j=0,l=f.length;j<l;j++){var d=f[j];var a=d.bounds.clone();var k=d.position.clone();a.bottom=a.bottom+g;a.top=a.top+g;k.y=k.y+h;m[j].moveTo(a,k)}if(n){b.unshift(m)}else{b.push(m)}},shiftColumn:function(m){var d=(m)?-this.tileSize.w:this.tileSize.w;var c=this.map.getResolution();var k=c*d;for(var e=0,g=this.grid.length;e<g;e++){var l=this.grid[e];var j=(m)?0:(l.length-1);var b=l[j];var a=b.bounds.clone();var f=b.position.clone();a.left=a.left+k;a.right=a.right+k;f.x=f.x+d;var h=m?this.grid[e].pop():this.grid[e].shift();h.moveTo(a,f);if(m){l.unshift(h)}else{l.push(h)}}},removeExcessTiles:function(e,c){while(this.grid.length>e){var f=this.grid.pop();for(var b=0,a=f.length;b<a;b++){var d=f[b];this.removeTileMonitoringHooks(d);d.destroy()}}while(this.grid[0].length>c){for(var b=0,a=this.grid.length;b<a;b++){var f=this.grid[b];var d=f.pop();this.removeTileMonitoringHooks(d);d.destroy()}}},onMapResize:function(){if(this.singleTile){this.clearGrid();this.setTileSize()}},getTileBounds:function(d){var c=this.maxExtent;var f=this.getResolution();var e=f*this.tileSize.w;var b=f*this.tileSize.h;var h=this.getLonLatFromViewPortPx(d);var a=c.left+(e*Math.floor((h.lon-c.left)/e));var g=c.bottom+(b*Math.floor((h.lat-c.bottom)/b));return new OpenLayers.Bounds(a,g,a+e,g+b)},CLASS_NAME:"OpenLayers.Layer.Grid"});OpenLayers.Tile=OpenLayers.Class({EVENT_TYPES:["loadstart","loadend","reload","unload"],events:null,id:null,layer:null,url:null,bounds:null,size:null,position:null,isLoading:false,initialize:function(e,a,f,c,d,b){this.layer=e;this.position=a.clone();this.bounds=f.clone();this.url=c;if(d){this.size=d.clone()}this.id=OpenLayers.Util.createUniqueID("Tile_");this.events=new OpenLayers.Events(this,null,this.EVENT_TYPES);OpenLayers.Util.extend(this,b)},unload:function(){if(this.isLoading){this.isLoading=false;this.events.triggerEvent("unload")}},destroy:function(){this.layer=null;this.bounds=null;this.size=null;this.position=null;this.events.destroy();this.events=null},clone:function(a){if(a==null){a=new OpenLayers.Tile(this.layer,this.position,this.bounds,this.url,this.size)}OpenLayers.Util.applyDefaults(a,this);return a},draw:function(){var a=this.layer.maxExtent;var b=(a&&this.bounds.intersectsBounds(a,false));this.shouldDraw=(b||this.layer.displayOutsideMaxExtent);this.clear();return this.shouldDraw},moveTo:function(b,a,c){if(c==null){c=true}this.bounds=b.clone();this.position=a.clone();if(c){this.draw()}},clear:function(){},getBoundsFromBaseLayer:function(a){var f=OpenLayers.i18n("reprojectDeprecated",{layerName:this.layer.name});OpenLayers.Console.warn(f);var d=this.layer.map.getLonLatFromLayerPx(a);var c=a.clone();c.x+=this.size.w;c.y+=this.size.h;var b=this.layer.map.getLonLatFromLayerPx(c);if(d.lon>b.lon){if(d.lon<0){d.lon=-180-(d.lon+180)}else{b.lon=180+b.lon+180}}var e=new OpenLayers.Bounds(d.lon,b.lat,b.lon,d.lat);return e},showTile:function(){if(this.shouldDraw){this.show()}},show:function(){},hide:function(){},CLASS_NAME:"OpenLayers.Tile"});OpenLayers.Tile.Image=OpenLayers.Class(OpenLayers.Tile,{url:null,imgDiv:null,frame:null,layerAlphaHack:null,isBackBuffer:false,isFirstDraw:true,backBufferTile:null,maxGetUrlLength:null,initialize:function(e,a,f,c,d,b){OpenLayers.Tile.prototype.initialize.apply(this,arguments);if(this.maxGetUrlLength!=null){OpenLayers.Util.extend(this,OpenLayers.Tile.Image.IFrame)}this.url=c;this.frame=document.createElement("div");this.frame.style.overflow="hidden";this.frame.style.position="absolute";this.layerAlphaHack=this.layer.alpha&&OpenLayers.Util.alphaHack()},destroy:function(){if(this.imgDiv!=null){this.removeImgDiv()}this.imgDiv=null;if((this.frame!=null)&&(this.frame.parentNode==this.layer.div)){this.layer.div.removeChild(this.frame)}this.frame=null;if(this.backBufferTile){this.backBufferTile.destroy();this.backBufferTile=null}this.layer.events.unregister("loadend",this,this.resetBackBuffer);OpenLayers.Tile.prototype.destroy.apply(this,arguments)},clone:function(a){if(a==null){a=new OpenLayers.Tile.Image(this.layer,this.position,this.bounds,this.url,this.size)}a=OpenLayers.Tile.prototype.clone.apply(this,[a]);a.imgDiv=null;return a},draw:function(){if(this.layer!=this.layer.map.baseLayer&&this.layer.reproject){this.bounds=this.getBoundsFromBaseLayer(this.position)}var a=OpenLayers.Tile.prototype.draw.apply(this,arguments);if((OpenLayers.Util.indexOf(this.layer.SUPPORTED_TRANSITIONS,this.layer.transitionEffect)!=-1)||this.layer.singleTile){if(a){if(!this.backBufferTile){this.backBufferTile=this.clone();this.backBufferTile.hide();this.backBufferTile.isBackBuffer=true;this.events.register("loadend",this,this.resetBackBuffer);this.layer.events.register("loadend",this,this.resetBackBuffer)}this.startTransition()}else{if(this.backBufferTile){this.backBufferTile.clear()}}}else{if(a&&this.isFirstDraw){this.events.register("loadend",this,this.showTile);this.isFirstDraw=false}}if(!a){return false}if(this.isLoading){this.events.triggerEvent("reload")}else{this.isLoading=true;this.events.triggerEvent("loadstart")}return this.renderTile()},resetBackBuffer:function(){this.showTile();if(this.backBufferTile&&(this.isFirstDraw||!this.layer.numLoadingTiles)){this.isFirstDraw=false;var a=this.layer.maxExtent;var b=(a&&this.bounds.intersectsBounds(a,false));if(b){this.backBufferTile.position=this.position;this.backBufferTile.bounds=this.bounds;this.backBufferTile.size=this.size;this.backBufferTile.imageSize=this.layer.getImageSize(this.bounds)||this.size;this.backBufferTile.imageOffset=this.layer.imageOffset;this.backBufferTile.resolution=this.layer.getResolution();this.backBufferTile.renderTile()}this.backBufferTile.hide()}},renderTile:function(){if(this.layer.async){this.initImgDiv();this.layer.getURLasync(this.bounds,this,"url",this.positionImage)}else{this.url=this.layer.getURL(this.bounds);this.initImgDiv();this.positionImage()}return true},positionImage:function(){if(this.layer===null){return}OpenLayers.Util.modifyDOMElement(this.frame,null,this.position,this.size);var a=this.layer.getImageSize(this.bounds);if(this.layerAlphaHack){OpenLayers.Util.modifyAlphaImageDiv(this.imgDiv,null,null,a,this.url)}else{OpenLayers.Util.modifyDOMElement(this.imgDiv,null,null,a);this.imgDiv.src=this.url}},clear:function(){if(this.imgDiv){this.hide();if(OpenLayers.Tile.Image.useBlankTile){this.imgDiv.src=OpenLayers.Util.getImagesLocation()+"blank.gif"}}},initImgDiv:function(){if(this.imgDiv==null){var d=this.layer.imageOffset;var b=this.layer.getImageSize(this.bounds);if(this.layerAlphaHack){this.imgDiv=OpenLayers.Util.createAlphaImageDiv(null,d,b,null,"relative",null,null,null,true)}else{this.imgDiv=OpenLayers.Util.createImage(null,d,b,null,"relative",null,null,true)}if(OpenLayers.Util.isArray(this.layer.url)){this.imgDiv.urls=this.layer.url.slice()}this.imgDiv.className="olTileImage";this.frame.style.zIndex=this.isBackBuffer?0:1;this.frame.appendChild(this.imgDiv);this.layer.div.appendChild(this.frame);if(this.layer.opacity!=null){OpenLayers.Util.modifyDOMElement(this.imgDiv,null,null,null,null,null,null,this.layer.opacity)}this.imgDiv.map=this.layer.map;var c=function(){if(this.isLoading){this.isLoading=false;this.events.triggerEvent("loadend")}};if(this.layerAlphaHack){OpenLayers.Event.observe(this.imgDiv.childNodes[0],"load",OpenLayers.Function.bind(c,this))}else{OpenLayers.Event.observe(this.imgDiv,"load",OpenLayers.Function.bind(c,this))}var a=function(){if(this.imgDiv._attempts>OpenLayers.IMAGE_RELOAD_ATTEMPTS){c.call(this)}};OpenLayers.Event.observe(this.imgDiv,"error",OpenLayers.Function.bind(a,this))}this.imgDiv.viewRequestID=this.layer.map.viewRequestID},removeImgDiv:function(){OpenLayers.Event.stopObservingElement(this.imgDiv);if(this.imgDiv.parentNode==this.frame){this.frame.removeChild(this.imgDiv);this.imgDiv.map=null}this.imgDiv.urls=null;var a=this.imgDiv.firstChild;if(a){OpenLayers.Event.stopObservingElement(a);this.imgDiv.removeChild(a);delete a}else{this.imgDiv.src=OpenLayers.Util.getImagesLocation()+"blank.gif"}},checkImgURL:function(){if(this.layer){var a=this.layerAlphaHack?this.imgDiv.firstChild.src:this.imgDiv.src;if(!OpenLayers.Util.isEquivalentUrl(a,this.url)){this.hide()}}},startTransition:function(){if(!this.backBufferTile||!this.backBufferTile.imgDiv){return}var d=1;if(this.backBufferTile.resolution){d=this.backBufferTile.resolution/this.layer.getResolution()}if(d!=1){if(this.layer.transitionEffect=="resize"){var c=new OpenLayers.LonLat(this.backBufferTile.bounds.left,this.backBufferTile.bounds.top);var b=new OpenLayers.Size(this.backBufferTile.size.w*d,this.backBufferTile.size.h*d);var a=this.layer.map.getLayerPxFromLonLat(c);OpenLayers.Util.modifyDOMElement(this.backBufferTile.frame,null,a,b);var e=this.backBufferTile.imageSize;e=new OpenLayers.Size(e.w*d,e.h*d);var f=this.backBufferTile.imageOffset;if(f){f=new OpenLayers.Pixel(f.x*d,f.y*d)}OpenLayers.Util.modifyDOMElement(this.backBufferTile.imgDiv,null,f,e);this.backBufferTile.show()}}else{if(this.layer.singleTile){this.backBufferTile.show()}else{this.backBufferTile.hide()}}},show:function(){this.frame.style.display="";if(OpenLayers.Util.indexOf(this.layer.SUPPORTED_TRANSITIONS,this.layer.transitionEffect)!=-1){if(OpenLayers.IS_GECKO===true){this.frame.scrollLeft=this.frame.scrollLeft}}},hide:function(){this.frame.style.display="none"},CLASS_NAME:"OpenLayers.Tile.Image"});OpenLayers.Tile.Image.useBlankTile=(OpenLayers.BROWSER_NAME=="safari"||OpenLayers.BROWSER_NAME=="opera");OpenLayers.Format.ArcXML=OpenLayers.Class(OpenLayers.Format.XML,{fontStyleKeys:["antialiasing","blockout","font","fontcolor","fontsize","fontstyle","glowing","interval","outline","printmode","shadow","transparency"],request:null,response:null,initialize:function(a){this.request=new OpenLayers.Format.ArcXML.Request();this.response=new OpenLayers.Format.ArcXML.Response();if(a){if(a.requesttype=="feature"){this.request.get_image=null;var c=this.request.get_feature.query;this.addCoordSys(c.featurecoordsys,a.featureCoordSys);this.addCoordSys(c.filtercoordsys,a.filterCoordSys);if(a.polygon){c.isspatial=true;c.spatialfilter.polygon=a.polygon}else{if(a.envelope){c.isspatial=true;c.spatialfilter.envelope={minx:0,miny:0,maxx:0,maxy:0};this.parseEnvelope(c.spatialfilter.envelope,a.envelope)}}}else{if(a.requesttype=="image"){this.request.get_feature=null;var b=this.request.get_image.properties;this.parseEnvelope(b.envelope,a.envelope);this.addLayers(b.layerlist,a.layers);this.addImageSize(b.imagesize,a.tileSize);this.addCoordSys(b.featurecoordsys,a.featureCoordSys);this.addCoordSys(b.filtercoordsys,a.filterCoordSys)}else{this.request=null}}}OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},parseEnvelope:function(b,a){if(a&&a.length==4){b.minx=a[0];b.miny=a[1];b.maxx=a[2];b.maxy=a[3]}},addLayers:function(d,c){for(var b=0,a=c.length;b<a;b++){d.push(c[b])}},addImageSize:function(b,a){if(a!==null){b.width=a.w;b.height=a.h;b.printwidth=a.w;b.printheight=a.h}},addCoordSys:function(a,b){if(typeof b=="string"){a.id=parseInt(b);a.string=b}else{if(typeof b=="object"&&b.proj!==null){a.id=b.proj.srsProjNumber;a.string=b.proj.srsCode}else{a=b}}},iserror:function(c){var a=null;if(!c){a=(this.response.error!=="")}else{c=OpenLayers.Format.XML.prototype.read.apply(this,[c]);var b=c.documentElement.getElementsByTagName("ERROR");a=(b!==null&&b.length>0)}return a},read:function(f){if(typeof f=="string"){f=OpenLayers.Format.XML.prototype.read.apply(this,[f])}var a=null;if(f&&f.documentElement){if(f.documentElement.nodeName=="ARCXML"){a=f.documentElement}else{a=f.documentElement.getElementsByTagName("ARCXML")[0]}}if(!a||a.firstChild.nodeName==="parsererror"){var c,e;try{c=f.firstChild.nodeValue;e=f.firstChild.childNodes[1].firstChild.nodeValue}catch(d){}throw {message:"Error parsing the ArcXML request",error:c,source:e}}var b=this.parseResponse(a);return b},write:function(c){if(!c){c=this.request}var q=this.createElementNS("","ARCXML");q.setAttribute("version","1.1");var h=this.createElementNS("","REQUEST");if(c.get_image!=null){var k=this.createElementNS("","GET_IMAGE");h.appendChild(k);var j=this.createElementNS("","PROPERTIES");k.appendChild(j);var b=c.get_image.properties;if(b.featurecoordsys!=null){var o=this.createElementNS("","FEATURECOORDSYS");j.appendChild(o);if(b.featurecoordsys.id===0){o.setAttribute("string",b.featurecoordsys.string)}else{o.setAttribute("id",b.featurecoordsys.id)}}if(b.filtercoordsys!=null){var m=this.createElementNS("","FILTERCOORDSYS");j.appendChild(m);if(b.filtercoordsys.id===0){m.setAttribute("string",b.filtercoordsys.string)}else{m.setAttribute("id",b.filtercoordsys.id)}}if(b.envelope!=null){var u=this.createElementNS("","ENVELOPE");j.appendChild(u);u.setAttribute("minx",b.envelope.minx);u.setAttribute("miny",b.envelope.miny);u.setAttribute("maxx",b.envelope.maxx);u.setAttribute("maxy",b.envelope.maxy)}var s=this.createElementNS("","IMAGESIZE");j.appendChild(s);s.setAttribute("height",b.imagesize.height);s.setAttribute("width",b.imagesize.width);if(b.imagesize.height!=b.imagesize.printheight||b.imagesize.width!=b.imagesize.printwidth){s.setAttribute("printheight",b.imagesize.printheight);s.setArrtibute("printwidth",b.imagesize.printwidth)}if(b.background!=null){var a=this.createElementNS("","BACKGROUND");j.appendChild(a);a.setAttribute("color",b.background.color.r+","+b.background.color.g+","+b.background.color.b);if(b.background.transcolor!==null){a.setAttribute("transcolor",b.background.transcolor.r+","+b.background.transcolor.g+","+b.background.transcolor.b)}}if(b.layerlist!=null&&b.layerlist.length>0){var g=this.createElementNS("","LAYERLIST");j.appendChild(g);for(var p=0;p<b.layerlist.length;p++){var n=this.createElementNS("","LAYERDEF");g.appendChild(n);n.setAttribute("id",b.layerlist[p].id);n.setAttribute("visible",b.layerlist[p].visible);if(typeof b.layerlist[p].query=="object"){var f=b.layerlist[p].query;if(f.where.length<0){continue}var x=null;if(typeof f.spatialfilter=="boolean"&&f.spatialfilter){x=this.createElementNS("","SPATIALQUERY")}else{x=this.createElementNS("","QUERY")}x.setAttribute("where",f.where);if(typeof f.accuracy=="number"&&f.accuracy>0){x.setAttribute("accuracy",f.accuracy)}if(typeof f.featurelimit=="number"&&f.featurelimit<2000){x.setAttribute("featurelimit",f.featurelimit)}if(typeof f.subfields=="string"&&f.subfields!="#ALL#"){x.setAttribute("subfields",f.subfields)}if(typeof f.joinexpression=="string"&&f.joinexpression.length>0){x.setAttribute("joinexpression",f.joinexpression)}if(typeof f.jointables=="string"&&f.jointables.length>0){x.setAttribute("jointables",f.jointables)}n.appendChild(x)}if(typeof b.layerlist[p].renderer=="object"){this.addRenderer(n,b.layerlist[p].renderer)}}}}else{if(c.get_feature!=null){var k=this.createElementNS("","GET_FEATURES");k.setAttribute("outputmode","newxml");k.setAttribute("checkesc","true");if(c.get_feature.geometry){k.setAttribute("geometry",c.get_feature.geometry)}else{k.setAttribute("geometry","false")}if(c.get_feature.compact){k.setAttribute("compact",c.get_feature.compact)}if(c.get_feature.featurelimit=="number"){k.setAttribute("featurelimit",c.get_feature.featurelimit)}k.setAttribute("globalenvelope","true");h.appendChild(k);if(c.get_feature.layer!=null&&c.get_feature.layer.length>0){var v=this.createElementNS("","LAYER");v.setAttribute("id",c.get_feature.layer);k.appendChild(v)}var r=c.get_feature.query;if(r!=null){var t=null;if(r.isspatial){t=this.createElementNS("","SPATIALQUERY")}else{t=this.createElementNS("","QUERY")}k.appendChild(t);if(typeof r.accuracy=="number"){t.setAttribute("accuracy",r.accuracy)}if(r.featurecoordsys!=null){var e=this.createElementNS("","FEATURECOORDSYS");if(r.featurecoordsys.id==0){e.setAttribute("string",r.featurecoordsys.string)}else{e.setAttribute("id",r.featurecoordsys.id)}t.appendChild(e)}if(r.filtercoordsys!=null){var d=this.createElementNS("","FILTERCOORDSYS");if(r.filtercoordsys.id===0){d.setAttribute("string",r.filtercoordsys.string)}else{d.setAttribute("id",r.filtercoordsys.id)}t.appendChild(d)}if(r.buffer>0){var l=this.createElementNS("","BUFFER");l.setAttribute("distance",r.buffer);t.appendChild(l)}if(r.isspatial){var i=this.createElementNS("","SPATIALFILTER");i.setAttribute("relation",r.spatialfilter.relation);t.appendChild(i);if(r.spatialfilter.envelope){var w=this.createElementNS("","ENVELOPE");w.setAttribute("minx",r.spatialfilter.envelope.minx);w.setAttribute("miny",r.spatialfilter.envelope.miny);w.setAttribute("maxx",r.spatialfilter.envelope.maxx);w.setAttribute("maxy",r.spatialfilter.envelope.maxy);i.appendChild(w)}else{if(typeof r.spatialfilter.polygon=="object"){i.appendChild(this.writePolygonGeometry(r.spatialfilter.polygon))}}}if(r.where!=null&&r.where.length>0){t.setAttribute("where",r.where)}}}}q.appendChild(h);return OpenLayers.Format.XML.prototype.write.apply(this,[q])},addGroupRenderer:function(b,a){var e=this.createElementNS("","GROUPRENDERER");b.appendChild(e);for(var c=0;c<a.length;c++){var d=a[c];this.addRenderer(e,d)}},addRenderer:function(c,b){if(OpenLayers.Util.isArray(b)){this.addGroupRenderer(c,b)}else{var a=this.createElementNS("",b.type.toUpperCase()+"RENDERER");c.appendChild(a);if(a.tagName=="VALUEMAPRENDERER"){this.addValueMapRenderer(a,b)}else{if(a.tagName=="VALUEMAPLABELRENDERER"){this.addValueMapLabelRenderer(a,b)}else{if(a.tagName=="SIMPLELABELRENDERER"){this.addSimpleLabelRenderer(a,b)}else{if(a.tagName=="SCALEDEPENDENTRENDERER"){this.addScaleDependentRenderer(a,b)}}}}}},addScaleDependentRenderer:function(a,b){if(typeof b.lower=="string"||typeof b.lower=="number"){a.setAttribute("lower",b.lower)}if(typeof b.upper=="string"||typeof b.upper=="number"){a.setAttribute("upper",b.upper)}this.addRenderer(a,b.renderer)},addValueMapLabelRenderer:function(h,g){h.setAttribute("lookupfield",g.lookupfield);h.setAttribute("labelfield",g.labelfield);if(typeof g.exacts=="object"){for(var a=0,k=g.exacts.length;a<k;a++){var e=g.exacts[a];var d=this.createElementNS("","EXACT");if(typeof e.value=="string"){d.setAttribute("value",e.value)}if(typeof e.label=="string"){d.setAttribute("label",e.label)}if(typeof e.method=="string"){d.setAttribute("method",e.method)}h.appendChild(d);if(typeof e.symbol=="object"){var b=null;if(e.symbol.type=="text"){b=this.createElementNS("","TEXTSYMBOL")}if(b!=null){var l=this.fontStyleKeys;for(var c=0,f=l.length;c<f;c++){var j=l[c];if(e.symbol[j]){b.setAttribute(j,e.symbol[j])}}d.appendChild(b)}}}}},addValueMapRenderer:function(j,i){j.setAttribute("lookupfield",i.lookupfield);if(typeof i.ranges=="object"){for(var a=0,b=i.ranges.length;a<b;a++){var g=i.ranges[a];var e=this.createElementNS("","RANGE");e.setAttribute("lower",g.lower);e.setAttribute("upper",g.upper);j.appendChild(e);if(typeof g.symbol=="object"){var d=null;if(g.symbol.type=="simplepolygon"){d=this.createElementNS("","SIMPLEPOLYGONSYMBOL")}if(d!=null){if(typeof g.symbol.boundarycolor=="string"){d.setAttribute("boundarycolor",g.symbol.boundarycolor)}if(typeof g.symbol.fillcolor=="string"){d.setAttribute("fillcolor",g.symbol.fillcolor)}if(typeof g.symbol.filltransparency=="number"){d.setAttribute("filltransparency",g.symbol.filltransparency)}e.appendChild(d)}}}}else{if(typeof i.exacts=="object"){for(var c=0,k=i.exacts.length;c<k;c++){var h=i.exacts[c];var f=this.createElementNS("","EXACT");if(typeof h.value=="string"){f.setAttribute("value",h.value)}if(typeof h.label=="string"){f.setAttribute("label",h.label)}if(typeof h.method=="string"){f.setAttribute("method",h.method)}j.appendChild(f);if(typeof h.symbol=="object"){var d=null;if(h.symbol.type=="simplemarker"){d=this.createElementNS("","SIMPLEMARKERSYMBOL")}if(d!=null){if(typeof h.symbol.antialiasing=="string"){d.setAttribute("antialiasing",h.symbol.antialiasing)}if(typeof h.symbol.color=="string"){d.setAttribute("color",h.symbol.color)}if(typeof h.symbol.outline=="string"){d.setAttribute("outline",h.symbol.outline)}if(typeof h.symbol.overlap=="string"){d.setAttribute("overlap",h.symbol.overlap)}if(typeof h.symbol.shadow=="string"){d.setAttribute("shadow",h.symbol.shadow)}if(typeof h.symbol.transparency=="number"){d.setAttribute("transparency",h.symbol.transparency)}if(typeof h.symbol.usecentroid=="string"){d.setAttribute("usecentroid",h.symbol.usecentroid)}if(typeof h.symbol.width=="number"){d.setAttribute("width",h.symbol.width)}f.appendChild(d)}}}}}},addSimpleLabelRenderer:function(f,h){f.setAttribute("field",h.field);var e=["featureweight","howmanylabels","labelbufferratio","labelpriorities","labelweight","linelabelposition","rotationalangles"];for(var d=0,a=e.length;d<a;d++){var c=e[d];if(h[c]){f.setAttribute(c,h[c])}}if(h.symbol.type=="text"){var g=h.symbol;var b=this.createElementNS("","TEXTSYMBOL");f.appendChild(b);var e=this.fontStyleKeys;for(var d=0,a=e.length;d<a;d++){var c=e[d];if(g[c]){b.setAttribute(c,h[c])}}}},writePolygonGeometry:function(g){if(!(g instanceof OpenLayers.Geometry.Polygon)){throw {message:"Cannot write polygon geometry to ArcXML with an "+g.CLASS_NAME+" object.",geometry:g}}var b=this.createElementNS("","POLYGON");for(var e=0,c=g.components.length;e<c;e++){var a=g.components[e];var i=this.createElementNS("","RING");for(var d=0,j=a.components.length;d<j;d++){var h=a.components[d];var f=this.createElementNS("","POINT");f.setAttribute("x",h.x);f.setAttribute("y",h.y);i.appendChild(f)}b.appendChild(i)}return b},parseResponse:function(z){if(typeof z=="string"){var n=new OpenLayers.Format.XML();z=n.read(z)}var a=new OpenLayers.Format.ArcXML.Response();var A=z.getElementsByTagName("ERROR");if(A!=null&&A.length>0){a.error=this.getChildValue(A,"Unknown error.")}else{var r=z.getElementsByTagName("RESPONSE");if(r==null||r.length==0){a.error="No RESPONSE tag found in ArcXML response.";return a}var q=r[0].firstChild.nodeName;if(q=="#text"){q=r[0].firstChild.nextSibling.nodeName}if(q=="IMAGE"){var c=z.getElementsByTagName("ENVELOPE");var w=z.getElementsByTagName("OUTPUT");if(c==null||c.length==0){a.error="No ENVELOPE tag found in ArcXML response."}else{if(w==null||w.length==0){a.error="No OUTPUT tag found in ArcXML response."}else{var u=this.parseAttributes(c[0]);var v=this.parseAttributes(w[0]);if(typeof v.type=="string"){a.image={envelope:u,output:{type:v.type,data:this.getChildValue(w[0])}}}else{a.image={envelope:u,output:v}}}}}else{if(q=="FEATURES"){var i=r[0].getElementsByTagName("FEATURES");var p=i[0].getElementsByTagName("FEATURECOUNT");a.features.featurecount=p[0].getAttribute("count");if(a.features.featurecount>0){var d=i[0].getElementsByTagName("ENVELOPE");a.features.envelope=this.parseAttributes(d[0],typeof(0));var x=i[0].getElementsByTagName("FEATURE");for(var m=0;m<x.length;m++){var h=new OpenLayers.Feature.Vector();var s=x[m].getElementsByTagName("FIELD");for(var f=0;f<s.length;f++){var g=s[f].getAttribute("name");var k=s[f].getAttribute("value");h.attributes[g]=k}var t=x[m].getElementsByTagName("POLYGON");if(t.length>0){var j=t[0].getElementsByTagName("RING");var e=[];for(var o=0;o<j.length;o++){var y=[];y.push(this.parsePointGeometry(j[o]));var l=j[o].getElementsByTagName("HOLE");for(var b=0;b<l.length;b++){y.push(this.parsePointGeometry(l[b]))}l=null;e.push(new OpenLayers.Geometry.Polygon(y));y=null}j=null;if(e.length==1){h.geometry=e[0]}else{h.geometry=new OpenLayers.Geometry.MultiPolygon(e)}}a.features.feature.push(h)}}}else{a.error="Unidentified response type."}}}return a},parseAttributes:function(d,c){var b={};for(var a=0;a<d.attributes.length;a++){if(c=="number"){b[d.attributes[a].nodeName]=parseFloat(d.attributes[a].nodeValue)}else{b[d.attributes[a].nodeName]=d.attributes[a].nodeValue}}return b},parsePointGeometry:function(d){var b=[];var e=d.getElementsByTagName("COORDS");if(e.length>0){var f=this.getChildValue(e[0]);f=f.split(/;/);for(var h=0;h<f.length;h++){var g=f[h].split(/ /);b.push(new OpenLayers.Geometry.Point(parseFloat(g[0]),parseFloat(g[1])))}e=null}else{var a=d.getElementsByTagName("POINT");if(a.length>0){for(var c=0;c<a.length;c++){b.push(new OpenLayers.Geometry.Point(parseFloat(a[c].getAttribute("x")),parseFloat(a[c].getAttribute("y"))))}}a=null}return new OpenLayers.Geometry.LinearRing(b)},CLASS_NAME:"OpenLayers.Format.ArcXML"});OpenLayers.Format.ArcXML.Request=OpenLayers.Class({initialize:function(b){var a={get_image:{properties:{background:null,draw:true,envelope:{minx:0,miny:0,maxx:0,maxy:0},featurecoordsys:{id:0,string:"",datumtransformid:0,datumtransformstring:""},filtercoordsys:{id:0,string:"",datumtransformid:0,datumtransformstring:""},imagesize:{height:0,width:0,dpi:96,printheight:0,printwidth:0,scalesymbols:false},layerlist:[],output:{baseurl:"",legendbaseurl:"",legendname:"",legendpath:"",legendurl:"",name:"",path:"",type:"jpg",url:""}}},get_feature:{layer:"",query:{isspatial:false,featurecoordsys:{id:0,string:"",datumtransformid:0,datumtransformstring:""},filtercoordsys:{id:0,string:"",datumtransformid:0,datumtransformstring:""},buffer:0,where:"",spatialfilter:{relation:"envelope_intersection",envelope:null}}},environment:{separators:{cs:" ",ts:";"}},layer:[],workspaces:[]};return OpenLayers.Util.extend(this,a)},CLASS_NAME:"OpenLayers.Format.ArcXML.Request"});OpenLayers.Format.ArcXML.Response=OpenLayers.Class({initialize:function(b){var a={image:{envelope:null,output:""},features:{featurecount:0,envelope:null,feature:[]},error:""};return OpenLayers.Util.extend(this,a)},CLASS_NAME:"OpenLayers.Format.ArcXML.Response"});OpenLayers.Request={DEFAULT_CONFIG:{method:"GET",url:window.location.href,async:true,user:undefined,password:undefined,params:null,proxy:OpenLayers.ProxyHost,headers:{},data:null,callback:function(){},success:null,failure:null,scope:null},URL_SPLIT_REGEX:/([^:]*:)\/\/([^:]*:?[^@]*@)?([^:\/\?]*):?([^\/\?]*)/,events:new OpenLayers.Events(this,null,["complete","success","failure"]),issue:function(d){var g=OpenLayers.Util.extend(this.DEFAULT_CONFIG,{proxy:OpenLayers.ProxyHost});d=OpenLayers.Util.applyDefaults(d,g);var f=new OpenLayers.Request.XMLHttpRequest();var a=OpenLayers.Util.urlAppend(d.url,OpenLayers.Util.getParameterString(d.params||{}));var i=!(a.indexOf("http")==0);var b=!i&&a.match(this.URL_SPLIT_REGEX);if(b){var j=window.location;i=b[1]==j.protocol&&b[3]==j.hostname;var e=b[4],c=j.port;if(e!=80&&e!=""||c!="80"&&c!=""){i=i&&e==c}}if(!i){if(d.proxy){if(typeof d.proxy=="function"){a=d.proxy(a)}else{a=d.proxy+encodeURIComponent(a)}}else{OpenLayers.Console.warn(OpenLayers.i18n("proxyNeeded"),{url:a})}}f.open(d.method,a,d.async,d.user,d.password);for(var h in d.headers){f.setRequestHeader(h,d.headers[h])}var l=this.events;var k=this;f.onreadystatechange=function(){if(f.readyState==OpenLayers.Request.XMLHttpRequest.DONE){var m=l.triggerEvent("complete",{request:f,config:d,requestUrl:a});if(m!==false){k.runCallbacks({request:f,config:d,requestUrl:a})}}};if(d.async===false){f.send(d.data)}else{window.setTimeout(function(){if(f.readyState!==0){f.send(d.data)}},0)}return f},runCallbacks:function(d){var e=d.request;var c=d.config;var a=(c.scope)?OpenLayers.Function.bind(c.callback,c.scope):c.callback;var f;if(c.success){f=(c.scope)?OpenLayers.Function.bind(c.success,c.scope):c.success}var b;if(c.failure){b=(c.scope)?OpenLayers.Function.bind(c.failure,c.scope):c.failure}if(OpenLayers.Util.createUrlObject(c.url).protocol=="file:"&&e.responseText){e.status=200}a(e);if(!e.status||(e.status>=200&&e.status<300)){this.events.triggerEvent("success",d);if(f){f(e)}}if(e.status&&(e.status<200||e.status>=300)){this.events.triggerEvent("failure",d);if(b){b(e)}}},GET:function(a){a=OpenLayers.Util.extend(a,{method:"GET"});return OpenLayers.Request.issue(a)},POST:function(a){a=OpenLayers.Util.extend(a,{method:"POST"});a.headers=a.headers?a.headers:{};if(!("CONTENT-TYPE" in OpenLayers.Util.upperCaseObject(a.headers))){a.headers["Content-Type"]="application/xml"}return OpenLayers.Request.issue(a)},PUT:function(a){a=OpenLayers.Util.extend(a,{method:"PUT"});a.headers=a.headers?a.headers:{};if(!("CONTENT-TYPE" in OpenLayers.Util.upperCaseObject(a.headers))){a.headers["Content-Type"]="application/xml"}return OpenLayers.Request.issue(a)},DELETE:function(a){a=OpenLayers.Util.extend(a,{method:"DELETE"});return OpenLayers.Request.issue(a)},HEAD:function(a){a=OpenLayers.Util.extend(a,{method:"HEAD"});return OpenLayers.Request.issue(a)},OPTIONS:function(a){a=OpenLayers.Util.extend(a,{method:"OPTIONS"});return OpenLayers.Request.issue(a)}};OpenLayers.Layer.ArcIMS=OpenLayers.Class(OpenLayers.Layer.Grid,{DEFAULT_PARAMS:{ClientVersion:"9.2",ServiceName:""},tileSize:null,featureCoordSys:"4326",filterCoordSys:"4326",layers:null,async:true,name:"ArcIMS",isBaseLayer:true,DEFAULT_OPTIONS:{tileSize:new OpenLayers.Size(512,512),featureCoordSys:"4326",filterCoordSys:"4326",layers:null,isBaseLayer:true,async:true,name:"ArcIMS"},initialize:function(c,b,a){this.tileSize=new OpenLayers.Size(512,512);this.params=OpenLayers.Util.applyDefaults({ServiceName:a.serviceName},this.DEFAULT_PARAMS);this.options=OpenLayers.Util.applyDefaults(a,this.DEFAULT_OPTIONS);OpenLayers.Layer.Grid.prototype.initialize.apply(this,[c,b,this.params,a]);if(this.transparent){if(!this.isBaseLayer){this.isBaseLayer=false}if(this.format=="image/jpeg"){this.format=OpenLayers.Util.alphaHack()?"image/gif":"image/png"}}if(this.options.layers===null){this.options.layers=[]}},destroy:function(){OpenLayers.Layer.Grid.prototype.destroy.apply(this,arguments)},getURL:function(d){var a="";d=this.adjustBounds(d);var c=new OpenLayers.Format.ArcXML(OpenLayers.Util.extend(this.options,{requesttype:"image",envelope:d.toArray(),tileSize:this.tileSize}));var b=new OpenLayers.Request.POST({url:this.getFullRequestString(),data:c.write(),async:false});if(b!=null){var f=b.responseXML;if(!f||!f.documentElement){f=b.responseText}var e=new OpenLayers.Format.ArcXML();var g=e.read(f);a=this.getUrlOrImage(g.image.output)}return a},getURLasync:function(c,a,e,d){c=this.adjustBounds(c);var b=new OpenLayers.Format.ArcXML(OpenLayers.Util.extend(this.options,{requesttype:"image",envelope:c.toArray(),tileSize:this.tileSize}));OpenLayers.Request.POST({url:this.getFullRequestString(),async:true,data:b.write(),callback:function(f){var h=f.responseXML;if(!h||!h.documentElement){h=f.responseText}var g=new OpenLayers.Format.ArcXML();var i=g.read(h);a[e]=this.getUrlOrImage(i.image.output);d.apply(a)},scope:this})},getUrlOrImage:function(a){var b="";if(a.url){b=a.url}else{if(a.data){b="data:image/"+a.type+";base64,"+a.data}}return b},setLayerQuery:function(c,a){for(var b=0;b<this.options.layers.length;b++){if(c==this.options.layers[b].id){this.options.layers[b].query=a;return}}this.options.layers.push({id:c,visible:true,query:a})},getFeatureInfo:function(h,f,k){var b=k.buffer||1;var i=k.callback||function(){};var j=k.scope||window;var a={};OpenLayers.Util.extend(a,this.options);a.requesttype="feature";if(h instanceof OpenLayers.LonLat){a.polygon=null;a.envelope=[h.lon-b,h.lat-b,h.lon+b,h.lat+b]}else{if(h instanceof OpenLayers.Geometry.Polygon){a.envelope=null;a.polygon=h}}var e=new OpenLayers.Format.ArcXML(a);OpenLayers.Util.extend(e.request.get_feature,k);e.request.get_feature.layer=f.id;if(typeof f.query.accuracy=="number"){e.request.get_feature.query.accuracy=f.query.accuracy}else{var g=this.map.getCenter();var d=this.map.getViewPortPxFromLonLat(g);d.x++;var c=this.map.getLonLatFromPixel(d);e.request.get_feature.query.accuracy=c.lon-g.lon}e.request.get_feature.query.where=f.query.where;e.request.get_feature.query.spatialfilter.relation="area_intersection";OpenLayers.Request.POST({url:this.getFullRequestString({CustomService:"Query"}),data:e.write(),callback:function(m){var l=e.parseResponse(m.responseText);if(!e.iserror()){i.call(j,l.features)}else{i.call(j,null)}}})},clone:function(a){if(a==null){a=new OpenLayers.Layer.ArcIMS(this.name,this.url,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},CLASS_NAME:"OpenLayers.Layer.ArcIMS"});OpenLayers.Format.WMSGetFeatureInfo=OpenLayers.Class(OpenLayers.Format.XML,{layerIdentifier:"_layer",featureIdentifier:"_feature",regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},gmlFormat:null,read:function(e){var a;if(typeof e=="string"){e=OpenLayers.Format.XML.prototype.read.apply(this,[e])}var b=e.documentElement;if(b){var c=this;var d=this["read_"+b.nodeName];if(d){a=d.call(this,b)}else{a=new OpenLayers.Format.GML((this.options?this.options:{})).read(e)}}else{a=e}return a},read_msGMLOutput:function(h){var e=[];var b=this.getSiblingNodesByTagCriteria(h,this.layerIdentifier);if(b){for(var k=0,n=b.length;k<n;++k){var c=b[k];var l=c.nodeName;if(c.prefix){l=l.split(":")[1]}var l=l.replace(this.layerIdentifier,"");var m=this.getSiblingNodesByTagCriteria(c,this.featureIdentifier);if(m){for(var g=0;g<m.length;g++){var a=m[g];var d=this.parseGeometry(a);var f=this.parseAttributes(a);var o=new OpenLayers.Feature.Vector(d.geometry,f,null);o.bounds=d.bounds;o.type=l;e.push(o)}}}}return e},read_FeatureInfoResponse:function(h){var e=[];var l=this.getElementsByTagNameNS(h,"*","FIELDS");for(var k=0,m=l.length;k<m;k++){var b=l[k];var n=null;var g={};var f;var o=b.attributes.length;if(o>0){for(f=0;f<o;f++){var c=b.attributes[f];g[c.nodeName]=c.nodeValue}}else{var a=b.childNodes;for(f=0,o=a.length;f<o;++f){var d=a[f];if(d.nodeType!=3){g[d.getAttribute("name")]=d.getAttribute("value")}}}e.push(new OpenLayers.Feature.Vector(n,g,null))}return e},getSiblingNodesByTagCriteria:function(f,i){var a=[];var c,e,d,g,b;if(f&&f.hasChildNodes()){c=f.childNodes;d=c.length;for(var h=0;h<d;h++){b=c[h];while(b&&b.nodeType!=1){b=b.nextSibling;h++}e=(b?b.nodeName:"");if(e.length>0&&e.indexOf(i)>-1){a.push(b)}else{g=this.getSiblingNodesByTagCriteria(b,i);if(g.length>0){(a.length==0)?a=g:a.push(g)}}}}return a},parseAttributes:function(e){var f={};if(e.nodeType==1){var c=e.childNodes;var d=c.length;for(var g=0;g<d;++g){var b=c[g];if(b.nodeType==1){var k=b.childNodes;var a=(b.prefix)?b.nodeName.split(":")[1]:b.nodeName;if(k.length==0){f[a]=null}else{if(k.length==1){var j=k[0];if(j.nodeType==3||j.nodeType==4){var h=j.nodeValue.replace(this.regExes.trimSpace,"");f[a]=h}}}}}}return f},parseGeometry:function(c){if(!this.gmlFormat){this.gmlFormat=new OpenLayers.Format.GML()}var a=this.gmlFormat.parseFeature(c);var d,b=null;if(a){d=a.geometry&&a.geometry.clone();b=a.bounds&&a.bounds.clone();a.destroy()}return{geometry:d,bounds:b}},CLASS_NAME:"OpenLayers.Format.WMSGetFeatureInfo"});OpenLayers.Format.OWSCommon.v1_1_0=OpenLayers.Class(OpenLayers.Format.OWSCommon.v1,{namespaces:{ows:"http://www.opengis.net/ows/1.1",xlink:"http://www.w3.org/1999/xlink"},readers:{ows:OpenLayers.Util.applyDefaults({ExceptionReport:function(a,b){b.exceptionReport={version:a.getAttribute("version"),language:a.getAttribute("xml:lang"),exceptions:[]};this.readChildNodes(a,b.exceptionReport)},AllowedValues:function(a,b){b.allowedValues={};this.readChildNodes(a,b.allowedValues)},AnyValue:function(a,b){b.anyValue=true},DataType:function(a,b){b.dataType=this.getChildValue(a)},Range:function(a,b){b.range={};this.readChildNodes(a,b.range)},MinimumValue:function(b,a){a.minValue=this.getChildValue(b)},MaximumValue:function(b,a){a.maxValue=this.getChildValue(b)},Identifier:function(a,b){b.identifier=this.getChildValue(a)},SupportedCRS:function(a,b){b.supportedCRS=this.getChildValue(a)}},OpenLayers.Format.OWSCommon.v1.prototype.readers.ows)},writers:{ows:OpenLayers.Util.applyDefaults({Range:function(a){var b=this.createElementNSPlus("ows:Range",{attributes:{"ows:rangeClosure":a.closure}});this.writeNode("ows:MinimumValue",a.minValue,b);this.writeNode("ows:MaximumValue",a.maxValue,b);return b},MinimumValue:function(b){var a=this.createElementNSPlus("ows:MinimumValue",{value:b});return a},MaximumValue:function(b){var a=this.createElementNSPlus("ows:MaximumValue",{value:b});return a},Value:function(b){var a=this.createElementNSPlus("ows:Value",{value:b});return a}},OpenLayers.Format.OWSCommon.v1.prototype.writers.ows)},CLASS_NAME:"OpenLayers.Format.OWSCommon.v1_1_0"});OpenLayers.Format.WCSGetCoverage=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{ows:"http://www.opengis.net/ows/1.1",wcs:"http://www.opengis.net/wcs/1.1",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},VERSION:"1.1.2",schemaLocation:"http://www.opengis.net/wcs/1.1 http://schemas.opengis.net/wcs/1.1/wcsGetCoverage.xsd",write:function(a){var b=this.writeNode("wcs:GetCoverage",a);this.setAttributeNS(b,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);return OpenLayers.Format.XML.prototype.write.apply(this,[b])},writers:{wcs:{GetCoverage:function(a){var b=this.createElementNSPlus("wcs:GetCoverage",{attributes:{version:a.version||this.VERSION,service:"WCS"}});this.writeNode("ows:Identifier",a.identifier,b);this.writeNode("wcs:DomainSubset",a.domainSubset,b);this.writeNode("wcs:Output",a.output,b);return b},DomainSubset:function(a){var b=this.createElementNSPlus("wcs:DomainSubset",{});this.writeNode("ows:BoundingBox",a.boundingBox,b);if(a.temporalSubset){this.writeNode("wcs:TemporalSubset",a.temporalSubset,b)}return b},TemporalSubset:function(d){var c=this.createElementNSPlus("wcs:TemporalSubset",{});for(var b=0,a=d.timePeriods.length;b<a;++b){this.writeNode("wcs:TimePeriod",d.timePeriods[b],c)}return c},TimePeriod:function(a){var b=this.createElementNSPlus("wcs:TimePeriod",{});this.writeNode("wcs:BeginPosition",a.begin,b);this.writeNode("wcs:EndPosition",a.end,b);if(a.resolution){this.writeNode("wcs:TimeResolution",a.resolution,b)}return b},BeginPosition:function(a){var b=this.createElementNSPlus("wcs:BeginPosition",{value:a});return b},EndPosition:function(a){var b=this.createElementNSPlus("wcs:EndPosition",{value:a});return b},TimeResolution:function(a){var b=this.createElementNSPlus("wcs:TimeResolution",{value:a});return b},Output:function(a){var b=this.createElementNSPlus("wcs:Output",{attributes:{format:a.format,store:a.store}});if(a.gridCRS){this.writeNode("wcs:GridCRS",a.gridCRS,b)}return b},GridCRS:function(a){var b=this.createElementNSPlus("wcs:GridCRS",{});this.writeNode("wcs:GridBaseCRS",a.baseCRS,b);if(a.type){this.writeNode("wcs:GridType",a.type,b)}if(a.origin){this.writeNode("wcs:GridOrigin",a.origin,b)}this.writeNode("wcs:GridOffsets",a.offsets,b);if(a.CS){this.writeNode("wcs:GridCS",a.CS,b)}return b},GridBaseCRS:function(a){return this.createElementNSPlus("wcs:GridBaseCRS",{value:a})},GridOrigin:function(a){return this.createElementNSPlus("wcs:GridOrigin",{value:a})},GridType:function(a){return this.createElementNSPlus("wcs:GridType",{value:a})},GridOffsets:function(a){return this.createElementNSPlus("wcs:GridOffsets",{value:a})},GridCS:function(a){return this.createElementNSPlus("wcs:GridCS",{value:a})}},ows:OpenLayers.Format.OWSCommon.v1_1_0.prototype.writers.ows},CLASS_NAME:"OpenLayers.Format.WCSGetCoverage"});OpenLayers.Format.WPSExecute=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{ows:"http://www.opengis.net/ows/1.1",gml:"http://www.opengis.net/gml",wps:"http://www.opengis.net/wps/1.0.0",wfs:"http://www.opengis.net/wfs",ogc:"http://www.opengis.net/ogc",wcs:"http://www.opengis.net/wcs",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},VERSION:"1.0.0",schemaLocation:"http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsAll.xsd",schemaLocationAttr:function(a){return undefined},write:function(a){var c;if(window.ActiveXObject){c=new ActiveXObject("Microsoft.XMLDOM");this.xmldom=c}else{c=document.implementation.createDocument("","",null)}var b=this.writeNode("wps:Execute",a,c);this.setAttributeNS(b,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);return OpenLayers.Format.XML.prototype.write.apply(this,[b])},writers:{wps:{Execute:function(a){var b=this.createElementNSPlus("wps:Execute",{attributes:{version:this.VERSION,service:"WPS"}});this.writeNode("ows:Identifier",a.identifier,b);this.writeNode("wps:DataInputs",a.dataInputs,b);this.writeNode("wps:ResponseForm",a.responseForm,b);return b},ResponseForm:function(a){var b=this.createElementNSPlus("wps:ResponseForm",{});if(a.rawDataOutput){this.writeNode("wps:RawDataOutput",a.rawDataOutput,b)}if(a.responseDocument){this.writeNode("wps:ResponseDocument",a.responseDocument,b)}return b},ResponseDocument:function(a){var b=this.createElementNSPlus("wps:ResponseDocument",{attributes:{storeExecuteResponse:a.storeExecuteResponse,lineage:a.lineage,status:a.status}});if(a.output){this.writeNode("wps:Output",a.output,b)}return b},Output:function(a){var b=this.createElementNSPlus("wps:Output",{attributes:{asReference:a.asReference}});this.writeNode("ows:Identifier",a.identifier,b);this.writeNode("ows:Title",a.title,b);this.writeNode("ows:Abstract",a["abstract"],b);return b},RawDataOutput:function(a){var b=this.createElementNSPlus("wps:RawDataOutput",{attributes:{mimeType:a.mimeType}});this.writeNode("ows:Identifier",a.identifier,b);return b},DataInputs:function(a){var d=this.createElementNSPlus("wps:DataInputs",{});for(var b=0,c=a.length;b<c;++b){this.writeNode("wps:Input",a[b],d)}return d},Input:function(a){var b=this.createElementNSPlus("wps:Input",{});this.writeNode("ows:Identifier",a.identifier,b);if(a.title){this.writeNode("ows:Title",a.title,b)}if(a.data){this.writeNode("wps:Data",a.data,b)}if(a.reference){this.writeNode("wps:Reference",a.reference,b)}return b},Data:function(b){var a=this.createElementNSPlus("wps:Data",{});if(b.literalData){this.writeNode("wps:LiteralData",b.literalData,a)}else{if(b.complexData){this.writeNode("wps:ComplexData",b.complexData,a)}}return a},LiteralData:function(b){var a=this.createElementNSPlus("wps:LiteralData",{attributes:{uom:b.uom},value:b.value});return a},ComplexData:function(a){var b=this.createElementNSPlus("wps:ComplexData",{attributes:{mimeType:a.mimeType,encoding:a.encoding,schema:a.schema}});b.appendChild(this.getXMLDoc().createCDATASection(a.value));return b},Reference:function(a){var b=this.createElementNSPlus("wps:Reference",{attributes:{mimeType:a.mimeType,"xlink:href":a.href,method:a.method,encoding:a.encoding,schema:a.schema}});if(a.body){this.writeNode("wps:Body",a.body,b)}return b},Body:function(a){var b=this.createElementNSPlus("wps:Body",{});if(a.wcs){this.writeNode("wcs:GetCoverage",a.wcs,b)}else{if(a.wfs){this.featureType=a.wfs.featureType;this.version=a.wfs.version;this.writeNode("wfs:GetFeature",a.wfs,b)}else{this.writeNode("wps:Execute",a,b)}}return b}},wcs:OpenLayers.Format.WCSGetCoverage.prototype.writers.wcs,wfs:OpenLayers.Format.WFST.v1_1_0.prototype.writers.wfs,ows:OpenLayers.Format.OWSCommon.v1_1_0.prototype.writers.ows},CLASS_NAME:"OpenLayers.Format.WPSExecute"});OpenLayers.Strategy=OpenLayers.Class({layer:null,options:null,active:null,autoActivate:true,autoDestroy:true,initialize:function(a){OpenLayers.Util.extend(this,a);this.options=a;this.active=false},destroy:function(){this.deactivate();this.layer=null;this.options=null},setLayer:function(a){this.layer=a},activate:function(){if(!this.active){this.active=true;return true}return false},deactivate:function(){if(this.active){this.active=false;return true}return false},CLASS_NAME:"OpenLayers.Strategy"});OpenLayers.Strategy.Filter=OpenLayers.Class(OpenLayers.Strategy,{filter:null,cache:null,caching:false,activate:function(){var a=OpenLayers.Strategy.prototype.activate.apply(this,arguments);if(a){this.cache=[];this.layer.events.on({beforefeaturesadded:this.handleAdd,beforefeaturesremoved:this.handleRemove,scope:this})}return a},deactivate:function(){this.cache=null;if(this.layer&&this.layer.events){this.layer.events.un({beforefeaturesadded:this.handleAdd,beforefeaturesremoved:this.handleRemove,scope:this})}return OpenLayers.Strategy.prototype.deactivate.apply(this,arguments)},handleAdd:function(e){if(!this.caching&&this.filter){var d=e.features;e.features=[];var b;for(var a=0,c=d.length;a<c;++a){b=d[a];if(this.filter.evaluate(b)){e.features.push(b)}else{this.cache.push(b)}}}},handleRemove:function(a){if(!this.caching){this.cache=[]}},setFilter:function(a){this.filter=a;var c=this.cache;this.cache=[];this.handleAdd({features:this.layer.features});if(this.cache.length>0){this.caching=true;this.layer.removeFeatures(this.cache.slice());this.caching=false}if(c.length>0){var b={features:c};this.handleAdd(b);if(b.features.length>0){this.caching=true;this.layer.addFeatures(b.features);this.caching=false}}},CLASS_NAME:"OpenLayers.Strategy.Filter"});OpenLayers.Format.XLS=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.1.0",stringifyOutput:true,CLASS_NAME:"OpenLayers.Format.XLS"});OpenLayers.Format.XLS.v1=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{xls:"http://www.opengis.net/xls",gml:"http://www.opengis.net/gml",xsi:"http://www.w3.org/2001/XMLSchema-instance"},regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},xy:true,defaultPrefix:"xls",schemaLocation:null,initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(c,a){a=OpenLayers.Util.applyDefaults(a,this.options);var b={};this.readChildNodes(c,b);return b},readers:{xls:{XLS:function(b,a){a.version=b.getAttribute("version");this.readChildNodes(b,a)},Response:function(b,a){this.readChildNodes(b,a)},GeocodeResponse:function(b,a){a.responseLists=[];this.readChildNodes(b,a)},GeocodeResponseList:function(c,b){var a={features:[],numberOfGeocodedAddresses:parseInt(c.getAttribute("numberOfGeocodedAddresses"))};b.responseLists.push(a);this.readChildNodes(c,a)},GeocodedAddress:function(c,b){var a=new OpenLayers.Feature.Vector();b.features.push(a);this.readChildNodes(c,a);a.geometry=a.components[0]},GeocodeMatchCode:function(b,a){a.attributes.matchCode={accuracy:parseFloat(b.getAttribute("accuracy")),matchType:b.getAttribute("matchType")}},Address:function(c,b){var a={countryCode:c.getAttribute("countryCode"),addressee:c.getAttribute("addressee"),street:[],place:[]};b.attributes.address=a;this.readChildNodes(c,a)},freeFormAddress:function(b,a){a.freeFormAddress=this.getChildValue(b)},StreetAddress:function(b,a){this.readChildNodes(b,a)},Building:function(b,a){a.building={number:b.getAttribute("number"),subdivision:b.getAttribute("subdivision"),buildingName:b.getAttribute("buildingName")}},Street:function(b,a){a.street.push(this.getChildValue(b))},Place:function(b,a){a.place[b.getAttribute("type")]=this.getChildValue(b)},PostalCode:function(b,a){a.postalCode=this.getChildValue(b)}},gml:OpenLayers.Format.GML.v3.prototype.readers.gml},write:function(a){return this.writers.xls.XLS.apply(this,[a])},writers:{xls:{XLS:function(b){var a=this.createElementNSPlus("xls:XLS",{attributes:{version:this.VERSION,"xsi:schemaLocation":this.schemaLocation}});this.writeNode("RequestHeader",b.header,a);this.writeNode("Request",b,a);return a},RequestHeader:function(a){return this.createElementNSPlus("xls:RequestHeader")},Request:function(b){var a=this.createElementNSPlus("xls:Request",{attributes:{methodName:"GeocodeRequest",requestID:b.requestID||"",version:this.VERSION}});this.writeNode("GeocodeRequest",b.addresses,a);return a},GeocodeRequest:function(d){var c=this.createElementNSPlus("xls:GeocodeRequest");for(var b=0,a=d.length;b<a;b++){this.writeNode("Address",d[b],c)}return c},Address:function(a){var b=this.createElementNSPlus("xls:Address",{attributes:{countryCode:a.countryCode}});if(a.freeFormAddress){this.writeNode("freeFormAddess",a.freeFormAddress,b)}else{if(a.street){this.writeNode("StreetAddress",a,b)}if(a.municipality){this.writeNode("Municipality",a.municipality,b)}if(a.countrySubdivision){this.writeNode("CountrySubdivision",a.countrySubdivision,b)}if(a.postalCode){this.writeNode("PostalCode",a.postalCode,b)}}return b},freeFormAddress:function(a){return this.createElementNSPlus("freeFormAddress",{value:a})},StreetAddress:function(b){var d=this.createElementNSPlus("xls:StreetAddress");if(b.building){this.writeNode(d,"Building",b.building)}var e=b.street;if(!(OpenLayers.Util.isArray(e))){e=[e]}for(var c=0,a=e.length;c<a;c++){this.writeNode("Street",e[c],d)}return d},Building:function(a){return this.createElementNSPlus("xls:Building",{attributes:{number:a.number,subdivision:a.subdivision,buildingName:a.buildingName}})},Street:function(a){return this.createElementNSPlus("xls:Street",{value:a})},Municipality:function(a){return this.createElementNSPlus("xls:Place",{attributes:{type:"Municipality"},value:a})},CountrySubdivision:function(a){return this.createElementNSPlus("xls:Place",{attributes:{type:"CountrySubdivision"},value:a})},PostalCode:function(a){return this.createElementNSPlus("xls:PostalCode",{value:a})}}},CLASS_NAME:"OpenLayers.Format.XLS.v1"});OpenLayers.Format.XLS.v1_1_0=OpenLayers.Class(OpenLayers.Format.XLS.v1,{VERSION:"1.1",schemaLocation:"http://www.opengis.net/xls http://schemas.opengis.net/ols/1.1.0/LocationUtilityService.xsd",initialize:function(a){OpenLayers.Format.XLS.v1.prototype.initialize.apply(this,[a])},CLASS_NAME:"OpenLayers.Format.XLS.v1_1_0"});OpenLayers.Format.XLS.v1_1=OpenLayers.Format.XLS.v1_1_0;OpenLayers.Layer.Image=OpenLayers.Class(OpenLayers.Layer,{isBaseLayer:true,url:null,extent:null,size:null,tile:null,aspectRatio:null,initialize:function(c,b,e,d,a){this.url=b;this.extent=e;this.maxExtent=e;this.size=d;OpenLayers.Layer.prototype.initialize.apply(this,[c,a]);this.aspectRatio=(this.extent.getHeight()/this.size.h)/(this.extent.getWidth()/this.size.w)},destroy:function(){if(this.tile){this.removeTileMonitoringHooks(this.tile);this.tile.destroy();this.tile=null}OpenLayers.Layer.prototype.destroy.apply(this,arguments)},clone:function(a){if(a==null){a=new OpenLayers.Layer.Image(this.name,this.url,this.extent,this.size,this.getOptions())}a=OpenLayers.Layer.prototype.clone.apply(this,[a]);return a},setMap:function(a){if(this.options.maxResolution==null){this.options.maxResolution=this.aspectRatio*this.extent.getWidth()/this.size.w}OpenLayers.Layer.prototype.setMap.apply(this,arguments)},moveTo:function(e,a,f){OpenLayers.Layer.prototype.moveTo.apply(this,arguments);var b=(this.tile==null);if(a||b){this.setTileSize();var d=new OpenLayers.LonLat(this.extent.left,this.extent.top);var c=this.map.getLayerPxFromLonLat(d);if(b){this.tile=new OpenLayers.Tile.Image(this,c,this.extent,null,this.tileSize);this.addTileMonitoringHooks(this.tile)}else{this.tile.size=this.tileSize.clone();this.tile.position=c.clone()}this.tile.draw()}},setTileSize:function(){var b=this.extent.getWidth()/this.map.getResolution();var a=this.extent.getHeight()/this.map.getResolution();this.tileSize=new OpenLayers.Size(b,a)},addTileMonitoringHooks:function(a){a.onLoadStart=function(){this.events.triggerEvent("loadstart")};a.events.register("loadstart",this,a.onLoadStart);a.onLoadEnd=function(){this.events.triggerEvent("loadend")};a.events.register("loadend",this,a.onLoadEnd);a.events.register("unload",this,a.onLoadEnd)},removeTileMonitoringHooks:function(a){a.unload();a.events.un({loadstart:a.onLoadStart,loadend:a.onLoadEnd,unload:a.onLoadEnd,scope:this})},setUrl:function(a){this.url=a;this.tile.draw()},getURL:function(a){return this.url},CLASS_NAME:"OpenLayers.Layer.Image"});OpenLayers.Strategy.Save=OpenLayers.Class(OpenLayers.Strategy,{EVENT_TYPES:["start","success","fail"],events:null,auto:false,timer:null,initialize:function(a){OpenLayers.Strategy.prototype.initialize.apply(this,[a]);this.events=new OpenLayers.Events(this,null,this.EVENT_TYPES)},activate:function(){var a=OpenLayers.Strategy.prototype.activate.call(this);if(a){if(this.auto){if(typeof this.auto==="number"){this.timer=window.setInterval(OpenLayers.Function.bind(this.save,this),this.auto*1000)}else{this.layer.events.on({featureadded:this.triggerSave,afterfeaturemodified:this.triggerSave,scope:this})}}}return a},deactivate:function(){var a=OpenLayers.Strategy.prototype.deactivate.call(this);if(a){if(this.auto){if(typeof this.auto==="number"){window.clearInterval(this.timer)}else{this.layer.events.un({featureadded:this.triggerSave,afterfeaturemodified:this.triggerSave,scope:this})}}}return a},triggerSave:function(b){var a=b.feature;if(a.state===OpenLayers.State.INSERT||a.state===OpenLayers.State.UPDATE||a.state===OpenLayers.State.DELETE){this.save([b.feature])}},save:function(d){if(!d){d=this.layer.features}this.events.triggerEvent("start",{features:d});var f=this.layer.projection;var c=this.layer.map.getProjectionObject();if(!c.equals(f)){var a=d.length;var e=new Array(a);var h,g;for(var b=0;b<a;++b){h=d[b];g=h.clone();g.fid=h.fid;g.state=h.state;if(h.url){g.url=h.url}g._original=h;g.geometry.transform(c,f);e[b]=g}d=e}this.layer.protocol.commit(d,{callback:this.onCommit,scope:this})},onCommit:function(d){var k={response:d};if(d.success()){var b=d.reqFeatures;var a,l;var c=[];var h=d.insertIds||[];var e=0;for(var f=0,g=b.length;f<g;++f){l=b[f];l=l._original||l;a=l.state;if(a){if(a==OpenLayers.State.DELETE){c.push(l)}else{if(a==OpenLayers.State.INSERT){l.fid=h[e];++e}}l.state=null}}if(c.length>0){this.layer.destroyFeatures(c)}this.events.triggerEvent("success",k)}else{this.events.triggerEvent("fail",k)}},CLASS_NAME:"OpenLayers.Strategy.Save"});OpenLayers.Format.GPX=OpenLayers.Class(OpenLayers.Format.XML,{extractWaypoints:true,extractTracks:true,extractRoutes:true,extractAttributes:true,initialize:function(a){this.externalProjection=new OpenLayers.Projection("EPSG:4326");OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(x){if(typeof x=="string"){x=OpenLayers.Format.XML.prototype.read.apply(this,[x])}var c=[];if(this.extractTracks){var t=x.getElementsByTagName("trk");for(var s=0,u=t.length;s<u;s++){var n={};if(this.extractAttributes){n=this.parseAttributes(t[s])}var h=this.getElementsByTagNameNS(t[s],t[s].namespaceURI,"trkseg");for(var r=0,f=h.length;r<f;r++){var m=this.extractSegment(h[r],"trkpt");c.push(new OpenLayers.Feature.Vector(m,n))}}}if(this.extractRoutes){var a=x.getElementsByTagName("rte");for(var q=0,p=a.length;q<p;q++){var n={};if(this.extractAttributes){n=this.parseAttributes(a[q])}var w=this.extractSegment(a[q],"rtept");c.push(new OpenLayers.Feature.Vector(w,n))}}if(this.extractWaypoints){var b=x.getElementsByTagName("wpt");for(var o=0,u=b.length;o<u;o++){var n={};if(this.extractAttributes){n=this.parseAttributes(b[o])}var e=new OpenLayers.Geometry.Point(b[o].getAttribute("lon"),b[o].getAttribute("lat"));c.push(new OpenLayers.Feature.Vector(e,n))}}if(this.internalProjection&&this.externalProjection){for(var v=0,d=c.length;v<d;v++){c[v].geometry.transform(this.externalProjection,this.internalProjection)}}return c},extractSegment:function(e,f){var d=this.getElementsByTagNameNS(e,e.namespaceURI,f);var b=[];for(var c=0,a=d.length;c<a;c++){b.push(new OpenLayers.Geometry.Point(d[c].getAttribute("lon"),d[c].getAttribute("lat")))}return new OpenLayers.Geometry.LineString(b)},parseAttributes:function(c){var a={};var e=c.firstChild,d,b;while(e){if(e.nodeType==1){d=e.firstChild;if(d.nodeType==3||d.nodeType==4){b=(e.prefix)?e.nodeName.split(":")[1]:e.nodeName;if(b!="trkseg"&&b!="rtept"){a[b]=d.nodeValue}}}e=e.nextSibling}return a},CLASS_NAME:"OpenLayers.Format.GPX"});OpenLayers.Format.WMSDescribeLayer=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.1.1",getVersion:function(b,c){var a=OpenLayers.Format.XML.VersionedOGC.prototype.getVersion.apply(this,arguments);if(a=="1.1.1"||a=="1.1.0"){a="1.1"}return a},CLASS_NAME:"OpenLayers.Format.WMSDescribeLayer"});OpenLayers.Format.WMSDescribeLayer.v1_1=OpenLayers.Class(OpenLayers.Format.WMSDescribeLayer,{initialize:function(a){OpenLayers.Format.WMSDescribeLayer.prototype.initialize.apply(this,[a])},read:function(d){if(typeof d=="string"){d=OpenLayers.Format.XML.prototype.read.apply(this,[d])}var j=d.documentElement;var b=j.childNodes;var f=[];var a,m;for(var e=0;e<b.length;++e){a=b[e];m=a.nodeName;if(m=="LayerDescription"){var g=a.getAttribute("name");var l="";var c="";var k="";if(a.getAttribute("owsType")){l=a.getAttribute("owsType");c=a.getAttribute("owsURL")}else{if(a.getAttribute("wfs")!=""){l="WFS";c=a.getAttribute("wfs")}else{if(a.getAttribute("wcs")!=""){l="WCS";c=a.getAttribute("wcs")}}}var h=a.getElementsByTagName("Query");if(h.length>0){k=h[0].getAttribute("typeName");if(!k){k=h[0].getAttribute("typename")}}f.push({layerName:g,owsType:l,owsURL:c,typeName:k})}}return f},CLASS_NAME:"OpenLayers.Format.WMSDescribeLayer.v1_1"});OpenLayers.Format.WFSDescribeFeatureType=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{xsd:"http://www.w3.org/2001/XMLSchema"},readers:{xsd:{schema:function(d,j){var e=[];var b={};var f={complexTypes:e,customTypes:b};this.readChildNodes(d,f);var g=d.attributes;var l,a;for(var h=0,k=g.length;h<k;++h){l=g[h];a=l.name;if(a.indexOf("xmlns")==0){this.setNamespace(a.split(":")[1]||"",l.value)}else{j[a]=l.value}}j.featureTypes=e;j.targetPrefix=this.namespaceAlias[j.targetNamespace];var m,c;for(var h=0,k=e.length;h<k;++h){m=e[h];c=b[m.typeName];if(b[m.typeName]){m.typeName=c.name}}},complexType:function(b,c){var a={typeName:b.getAttribute("name")};this.readChildNodes(b,a);c.complexTypes.push(a)},complexContent:function(a,b){this.readChildNodes(a,b)},extension:function(a,b){this.readChildNodes(a,b)},sequence:function(a,b){var c={elements:[]};this.readChildNodes(a,c);b.properties=c.elements},element:function(a,c){if(c.elements){var d={};var b=a.attributes;var g;for(var e=0,f=b.length;e<f;++e){g=b[e];d[g.name]=g.value}var h=d.type;if(!h){h={};this.readChildNodes(a,h);d.restriction=h;d.type=h.base}var k=h.base||h;d.localType=k.split(":").pop();c.elements.push(d)}if(c.complexTypes){var h=a.getAttribute("type");var j=h.split(":").pop();c.customTypes[j]={name:a.getAttribute("name"),type:h}}},simpleType:function(a,b){this.readChildNodes(a,b)},restriction:function(a,b){b.base=a.getAttribute("base");this.readRestriction(a,b)}}},readRestriction:function(d,f){var c=d.childNodes;var h,g,e;for(var b=0,a=c.length;b<a;++b){h=c[b];if(h.nodeType==1){g=h.nodeName.split(":").pop();e=h.getAttribute("value");if(!f[g]){f[g]=e}else{if(typeof f[g]=="string"){f[g]=[f[g]]}f[g].push(e)}}}},read:function(b){if(typeof b=="string"){b=OpenLayers.Format.XML.prototype.read.apply(this,[b])}if(b&&b.nodeType==9){b=b.documentElement}var a={};this.readNode(b,a);return a},CLASS_NAME:"OpenLayers.Format.WFSDescribeFeatureType"});OpenLayers.Renderer=OpenLayers.Class({container:null,root:null,extent:null,locked:false,size:null,resolution:null,map:null,initialize:function(a,b){this.container=OpenLayers.Util.getElement(a);OpenLayers.Util.extend(this,b)},destroy:function(){this.container=null;this.extent=null;this.size=null;this.resolution=null;this.map=null},supported:function(){return false},setExtent:function(a,b){this.extent=a.clone();if(b){this.resolution=null}},setSize:function(a){this.size=a.clone();this.resolution=null},getResolution:function(){this.resolution=this.resolution||this.map.getResolution();return this.resolution},drawFeature:function(c,e){if(e==null){e=c.style}if(c.geometry){var f=c.geometry.getBounds();if(f){if(!f.intersectsBounds(this.extent)){e={display:"none"}}var h=this.drawGeometry(c.geometry,e,c.id);if(e.display!="none"&&e.label&&h!==false){var a=c.geometry.getCentroid();if(e.labelXOffset||e.labelYOffset){var d=isNaN(e.labelXOffset)?0:e.labelXOffset;var g=isNaN(e.labelYOffset)?0:e.labelYOffset;var b=this.getResolution();a.move(d*b,g*b)}this.drawText(c.id,e,a)}else{this.removeText(c.id)}return h}}},drawGeometry:function(c,a,b){},drawText:function(c,b,a){},removeText:function(a){},clear:function(){},getFeatureIdFromEvent:function(a){},eraseFeatures:function(d){if(!(OpenLayers.Util.isArray(d))){d=[d]}for(var c=0,a=d.length;c<a;++c){var b=d[c];this.eraseGeometry(b.geometry,b.id);this.removeText(b.id)}},eraseGeometry:function(b,a){},moveRoot:function(a){},getRenderLayerId:function(){return this.container.id},applyDefaultSymbolizer:function(b){var a=OpenLayers.Util.extend({},OpenLayers.Renderer.defaultSymbolizer);if(b.stroke===false){delete a.strokeWidth;delete a.strokeColor}if(b.fill===false){delete a.fillColor}OpenLayers.Util.extend(a,b);return a},CLASS_NAME:"OpenLayers.Renderer"});OpenLayers.Renderer.defaultSymbolizer={fillColor:"#000000",strokeColor:"#000000",strokeWidth:2,fillOpacity:1,strokeOpacity:1,pointRadius:0};OpenLayers.Renderer.Canvas=OpenLayers.Class(OpenLayers.Renderer,{hitDetection:true,hitOverflow:0,canvas:null,features:null,pendingRedraw:false,initialize:function(a,b){OpenLayers.Renderer.prototype.initialize.apply(this,arguments);this.root=document.createElement("canvas");this.container.appendChild(this.root);this.canvas=this.root.getContext("2d");this.features={};if(this.hitDetection){this.hitCanvas=document.createElement("canvas");this.hitContext=this.hitCanvas.getContext("2d")}},eraseGeometry:function(b,a){this.eraseFeatures(this.features[a][0])},supported:function(){var a=document.createElement("canvas");return !!a.getContext},setSize:function(b){this.size=b.clone();var a=this.root;a.style.width=b.w+"px";a.style.height=b.h+"px";a.width=b.w;a.height=b.h;this.resolution=null;if(this.hitDetection){var c=this.hitCanvas;c.style.width=b.w+"px";c.style.height=b.h+"px";c.width=b.w;c.height=b.h}},drawFeature:function(a,b){var d;if(a.geometry){b=this.applyDefaultSymbolizer(b||a.style);var c=a.geometry.getBounds();d=(b.display!=="none")&&!!c&&c.intersectsBounds(this.extent);if(d){this.features[a.id]=[a,b]}else{delete (this.features[a.id])}this.pendingRedraw=true}if(this.pendingRedraw&&!this.locked){this.redraw();this.pendingRedraw=false}return d},drawGeometry:function(e,c,d){var b=e.CLASS_NAME;if((b=="OpenLayers.Geometry.Collection")||(b=="OpenLayers.Geometry.MultiPoint")||(b=="OpenLayers.Geometry.MultiLineString")||(b=="OpenLayers.Geometry.MultiPolygon")){for(var a=0;a<e.components.length;a++){this.drawGeometry(e.components[a],c,d)}return}switch(e.CLASS_NAME){case"OpenLayers.Geometry.Point":this.drawPoint(e,c,d);break;case"OpenLayers.Geometry.LineString":this.drawLineString(e,c,d);break;case"OpenLayers.Geometry.LinearRing":this.drawLinearRing(e,c,d);break;case"OpenLayers.Geometry.Polygon":this.drawPolygon(e,c,d);break;default:break}},drawExternalGraphic:function(i,a,d){var e=new Image();if(a.graphicTitle){e.title=a.graphicTitle}var b=a.graphicWidth||a.graphicHeight;var j=a.graphicHeight||a.graphicWidth;b=b?b:a.pointRadius*2;j=j?j:a.pointRadius*2;var g=(a.graphicXOffset!=undefined)?a.graphicXOffset:-(0.5*b);var c=(a.graphicYOffset!=undefined)?a.graphicYOffset:-(0.5*j);var f=a.graphicOpacity||a.fillOpacity;var h=function(){if(!this.features[d]){return}var n=this.getLocalXY(i);var q=n[0];var o=n[1];if(!isNaN(q)&&!isNaN(o)){var k=(q+g)|0;var p=(o+c)|0;var l=this.canvas;l.globalAlpha=f;var m=OpenLayers.Renderer.Canvas.drawImageScaleFactor||(OpenLayers.Renderer.Canvas.drawImageScaleFactor=/android 2.1/.test(navigator.userAgent.toLowerCase())?320/window.screen.width:1);l.drawImage(e,k*m,p*m,b*m,j*m);if(this.hitDetection){this.setHitContextStyle("fill",d);this.hitContext.fillRect(k,p,b,j)}}};e.onload=OpenLayers.Function.bind(h,this);e.src=a.externalGraphic},setCanvasStyle:function(b,a){if(b==="fill"){this.canvas.globalAlpha=a.fillOpacity;this.canvas.fillStyle=a.fillColor}else{if(b==="stroke"){this.canvas.globalAlpha=a.strokeOpacity;this.canvas.strokeStyle=a.strokeColor;this.canvas.lineWidth=a.strokeWidth}else{this.canvas.globalAlpha=0;this.canvas.lineWidth=1}}},featureIdToHex:function(c){var d=Number(c.split("_").pop())+1;if(d>=16777216){this.hitOverflow=d-16777215;d=d%16777216+1}var b="000000"+d.toString(16);var a=b.length;b="#"+b.substring(a-6,a);return b},setHitContextStyle:function(b,d,a){var c=this.featureIdToHex(d);if(b=="fill"){this.hitContext.globalAlpha=1;this.hitContext.fillStyle=c}else{if(b=="stroke"){this.hitContext.globalAlpha=1;this.hitContext.strokeStyle=c;this.hitContext.lineWidth=a.strokeWidth+2}else{this.hitContext.globalAlpha=0;this.hitContext.lineWidth=1}}},drawPoint:function(g,c,f){if(c.graphic!==false){if(c.externalGraphic){this.drawExternalGraphic(g,c,f)}else{var d=this.getLocalXY(g);var h=d[0];var e=d[1];if(!isNaN(h)&&!isNaN(e)){var b=Math.PI*2;var a=c.pointRadius;if(c.fill!==false){this.setCanvasStyle("fill",c);this.canvas.beginPath();this.canvas.arc(h,e,a,0,b,true);this.canvas.fill();if(this.hitDetection){this.setHitContextStyle("fill",f,c);this.hitContext.beginPath();this.hitContext.arc(h,e,a,0,b,true);this.hitContext.fill()}}if(c.stroke!==false){this.setCanvasStyle("stroke",c);this.canvas.beginPath();this.canvas.arc(h,e,a,0,b,true);this.canvas.stroke();if(this.hitDetection){this.setHitContextStyle("stroke",f,c);this.hitContext.beginPath();this.hitContext.arc(h,e,a,0,b,true);this.hitContext.stroke()}this.setCanvasStyle("reset")}}}}},drawLineString:function(c,a,b){a=OpenLayers.Util.applyDefaults({fill:false},a);this.drawLinearRing(c,a,b)},drawLinearRing:function(c,a,b){if(a.fill!==false){this.setCanvasStyle("fill",a);this.renderPath(this.canvas,c,a,b,"fill");if(this.hitDetection){this.setHitContextStyle("fill",b,a);this.renderPath(this.hitContext,c,a,b,"fill")}}if(a.stroke!==false){this.setCanvasStyle("stroke",a);this.renderPath(this.canvas,c,a,b,"stroke");if(this.hitDetection){this.setHitContextStyle("stroke",b,a);this.renderPath(this.hitContext,c,a,b,"stroke")}}this.setCanvasStyle("reset")},renderPath:function(c,k,a,e,h){var f=k.components;var g=f.length;c.beginPath();var b=this.getLocalXY(f[0]);var l=b[0];var j=b[1];if(!isNaN(l)&&!isNaN(j)){c.moveTo(b[0],b[1]);for(var d=1;d<g;++d){var m=this.getLocalXY(f[d]);c.lineTo(m[0],m[1])}if(h==="fill"){c.fill()}else{c.stroke()}}},drawPolygon:function(f,c,e){var d=f.components;var a=d.length;this.drawLinearRing(d[0],c,e);for(var b=1;b<a;++b){this.canvas.globalCompositeOperation="destination-out";if(this.hitDetection){this.hitContext.globalCompositeOperation="destination-out"}this.drawLinearRing(d[b],OpenLayers.Util.applyDefaults({stroke:false,fillOpacity:1},c),e);this.canvas.globalCompositeOperation="source-over";if(this.hitDetection){this.hitContext.globalCompositeOperation="source-over"}this.drawLinearRing(d[b],OpenLayers.Util.applyDefaults({fill:false},c),e)}},drawText:function(l,a){a=OpenLayers.Util.extend({fontColor:"#000000",labelAlign:"cm"},a);var m=this.getLocalXY(l);this.setCanvasStyle("reset");this.canvas.fillStyle=a.fontColor;this.canvas.globalAlpha=a.fontOpacity||1;var d=[a.fontStyle?a.fontStyle:"normal","normal",a.fontWeight?a.fontWeight:"normal",a.fontSize?a.fontSize:"1em",a.fontFamily?a.fontFamily:"sans-serif"].join(" ");var c=a.label.split("\n");var f=c.length;if(this.canvas.fillText){this.canvas.font=d;this.canvas.textAlign=OpenLayers.Renderer.Canvas.LABEL_ALIGN[a.labelAlign[0]]||"center";this.canvas.textBaseline=OpenLayers.Renderer.Canvas.LABEL_ALIGN[a.labelAlign[1]]||"middle";var j=OpenLayers.Renderer.Canvas.LABEL_FACTOR[a.labelAlign[1]];if(j==null){j=-0.5}var k=this.canvas.measureText("Mg").height||this.canvas.measureText("xx").width;m[1]+=k*j*(f-1);for(var e=0;e<f;e++){this.canvas.fillText(c[e],m[0],m[1]+(k*e))}}else{if(this.canvas.mozDrawText){this.canvas.mozTextStyle=d;var b=OpenLayers.Renderer.Canvas.LABEL_FACTOR[a.labelAlign[0]];if(b==null){b=-0.5}var j=OpenLayers.Renderer.Canvas.LABEL_FACTOR[a.labelAlign[1]];if(j==null){j=-0.5}var k=this.canvas.mozMeasureText("xx");m[1]+=k*(1+(j*f));for(var e=0;e<f;e++){var h=m[0]+(b*this.canvas.mozMeasureText(c[e]));var g=m[1]+(e*k);this.canvas.translate(h,g);this.canvas.mozDrawText(c[e]);this.canvas.translate(-h,-g)}}}this.setCanvasStyle("reset")},getLocalXY:function(b){var c=this.getResolution();var d=this.extent;var a=(b.x/c+(-d.left/c));var e=((d.top/c)-b.y/c);return[a,e]},clear:function(){var a=this.root.height;var b=this.root.width;this.canvas.clearRect(0,0,b,a);this.features={};if(this.hitDetection){this.hitContext.clearRect(0,0,b,a)}},getFeatureIdFromEvent:function(b){var c=null;if(this.hitDetection){if(!this.map.dragging){var e=b.xy;var a=e.x|0;var g=e.y|0;var d=this.hitContext.getImageData(a,g,1,1).data;if(d[3]===255){var f=d[2]+(256*(d[1]+(256*d[0])));if(f){c=this.features["OpenLayers.Feature.Vector_"+(f-1+this.hitOverflow)][0]}}}}return c},eraseFeatures:function(b){if(!(OpenLayers.Util.isArray(b))){b=[b]}for(var a=0;a<b.length;++a){delete this.features[b[a].id]}this.redraw()},redraw:function(){if(!this.locked){var g=this.root.height;var c=this.root.width;this.canvas.clearRect(0,0,c,g);if(this.hitDetection){this.hitContext.clearRect(0,0,c,g)}var f=[];var j,a;for(var b in this.features){if(!this.features.hasOwnProperty(b)){continue}j=this.features[b][0];a=this.features[b][1];this.drawGeometry(j.geometry,a,j.id);if(a.label){f.push([j,a])}}var h;for(var d=0,e=f.length;d<e;++d){h=f[d];this.drawText(h[0].geometry.getCentroid(),h[1])}}},CLASS_NAME:"OpenLayers.Renderer.Canvas"});OpenLayers.Renderer.Canvas.LABEL_ALIGN={l:"left",r:"right",t:"top",b:"bottom"};OpenLayers.Renderer.Canvas.LABEL_FACTOR={l:0,r:-1,t:0,b:-1};OpenLayers.Renderer.Canvas.drawImageScaleFactor=null;OpenLayers.Format.OSM=OpenLayers.Class(OpenLayers.Format.XML,{checkTags:false,interestingTagsExclude:null,areaTags:null,initialize:function(a){var d={interestingTagsExclude:["source","source_ref","source:ref","history","attribution","created_by"],areaTags:["area","building","leisure","tourism","ruins","historic","landuse","military","natural","sport"]};d=OpenLayers.Util.extend(d,a);var e={};for(var b=0;b<d.interestingTagsExclude.length;b++){e[d.interestingTagsExclude[b]]=true}d.interestingTagsExclude=e;var c={};for(var b=0;b<d.areaTags.length;b++){c[d.areaTags[b]]=true}d.areaTags=c;this.externalProjection=new OpenLayers.Projection("EPSG:4326");OpenLayers.Format.XML.prototype.initialize.apply(this,[d])},read:function(n){if(typeof n=="string"){n=OpenLayers.Format.XML.prototype.read.apply(this,[n])}var b=this.getNodes(n);var o=this.getWays(n);var g=new Array(o.length);for(var f=0;f<o.length;f++){var l=new Array(o[f].nodes.length);var a=this.isWayArea(o[f])?1:0;for(var e=0;e<o[f].nodes.length;e++){var c=b[o[f].nodes[e]];var m=new OpenLayers.Geometry.Point(c.lon,c.lat);m.osm_id=parseInt(o[f].nodes[e]);l[e]=m;c.used=true}var k=null;if(a){k=new OpenLayers.Geometry.Polygon(new OpenLayers.Geometry.LinearRing(l))}else{k=new OpenLayers.Geometry.LineString(l)}if(this.internalProjection&&this.externalProjection){k.transform(this.externalProjection,this.internalProjection)}var h=new OpenLayers.Feature.Vector(k,o[f].tags);h.osm_id=parseInt(o[f].id);h.fid="way."+h.osm_id;g[f]=h}for(var d in b){var c=b[d];if(!c.used||this.checkTags){var q=null;if(this.checkTags){var p=this.getTags(c.node,true);if(c.used&&!p[1]){continue}q=p[0]}else{q=this.getTags(c.node)}var h=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Point(c.lon,c.lat),q);if(this.internalProjection&&this.externalProjection){h.geometry.transform(this.externalProjection,this.internalProjection)}h.osm_id=parseInt(d);h.fid="node."+h.osm_id;g.push(h)}c.node=null}return g},getNodes:function(e){var d=e.getElementsByTagName("node");var a={};for(var b=0;b<d.length;b++){var c=d[b];var f=c.getAttribute("id");a[f]={lat:c.getAttribute("lat"),lon:c.getAttribute("lon"),node:c}}return a},getWays:function(g){var f=g.getElementsByTagName("way");var h=[];for(var d=0;d<f.length;d++){var b=f[d];var c={id:b.getAttribute("id")};c.tags=this.getTags(b);var e=b.getElementsByTagName("nd");c.nodes=new Array(e.length);for(var a=0;a<e.length;a++){c.nodes[a]=e[a].getAttribute("ref")}h.push(c)}return h},getTags:function(e,g){var a=e.getElementsByTagName("tag");var c={};var f=false;for(var b=0;b<a.length;b++){var d=a[b].getAttribute("k");c[d]=a[b].getAttribute("v");if(g){if(!this.interestingTagsExclude[d]){f=true}}}return g?[c,f]:c},isWayArea:function(b){var a=false;var d=false;if(b.nodes[0]==b.nodes[b.nodes.length-1]){a=true}if(this.checkTags){for(var c in b.tags){if(this.areaTags[c]){d=true;break}}}return a&&(this.checkTags?d:true)},write:function(d){if(!(OpenLayers.Util.isArray(d))){d=[d]}this.osm_id=1;this.created_nodes={};var e=this.createElementNS(null,"osm");e.setAttribute("version","0.5");e.setAttribute("generator","OpenLayers "+OpenLayers.VERSION_NUMBER);for(var c=d.length-1;c>=0;c--){var a=this.createFeatureNodes(d[c]);for(var b=0;b<a.length;b++){e.appendChild(a[b])}}return OpenLayers.Format.XML.prototype.write.apply(this,[e])},createFeatureNodes:function(c){var b=[];var e=c.geometry.CLASS_NAME;var d=e.substring(e.lastIndexOf(".")+1);d=d.toLowerCase();var a=this.createXML[d];if(a){b=a.apply(this,[c])}return b},createXML:{point:function(a){var e=null;var c=a.geometry?a.geometry:a;if(this.internalProjection&&this.externalProjection){c=c.clone();c.transform(this.internalProjection,this.externalProjection)}var d=false;if(a.osm_id){e=a.osm_id;if(this.created_nodes[e]){d=true}}else{e=-this.osm_id;this.osm_id++}if(d){b=this.created_nodes[e]}else{var b=this.createElementNS(null,"node")}this.created_nodes[e]=b;b.setAttribute("id",e);b.setAttribute("lon",c.x);b.setAttribute("lat",c.y);if(a.attributes){this.serializeTags(a,b)}this.setState(a,b);return d?[]:[b]},linestring:function(j){var b;var a=[];var f=j.geometry;if(j.osm_id){b=j.osm_id}else{b=-this.osm_id;this.osm_id++}var h=this.createElementNS(null,"way");h.setAttribute("id",b);for(var d=0;d<f.components.length;d++){var c=this.createXML.point.apply(this,[f.components[d]]);if(c.length){c=c[0];var g=c.getAttribute("id");a.push(c)}else{g=f.components[d].osm_id;c=this.created_nodes[g]}this.setState(j,c);var e=this.createElementNS(null,"nd");e.setAttribute("ref",g);h.appendChild(e)}this.serializeTags(j,h);a.push(h);return a},polygon:function(b){var a=OpenLayers.Util.extend({area:"yes"},b.attributes);var c=new OpenLayers.Feature.Vector(b.geometry.components[0],a);c.osm_id=b.osm_id;return this.createXML.linestring.apply(this,[c])}},serializeTags:function(c,d){for(var b in c.attributes){var a=this.createElementNS(null,"tag");a.setAttribute("k",b);a.setAttribute("v",c.attributes[b]);d.appendChild(a)}},setState:function(a,b){if(a.state){var c=null;switch(a.state){case OpenLayers.State.UPDATE:c="modify";case OpenLayers.State.DELETE:c="delete"}if(c){b.setAttribute("action",c)}}},CLASS_NAME:"OpenLayers.Format.OSM"});OpenLayers.Handler=OpenLayers.Class({id:null,control:null,map:null,keyMask:null,active:false,evt:null,initialize:function(d,b,a){OpenLayers.Util.extend(this,a);this.control=d;this.callbacks=b;var c=this.map||d.map;if(c){this.setMap(c)}this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")},setMap:function(a){this.map=a},checkModifiers:function(a){if(this.keyMask==null){return true}var b=(a.shiftKey?OpenLayers.Handler.MOD_SHIFT:0)|(a.ctrlKey?OpenLayers.Handler.MOD_CTRL:0)|(a.altKey?OpenLayers.Handler.MOD_ALT:0);return(b==this.keyMask)},activate:function(){if(this.active){return false}var c=OpenLayers.Events.prototype.BROWSER_EVENTS;for(var b=0,a=c.length;b<a;b++){if(this[c[b]]){this.register(c[b],this[c[b]])}}this.active=true;return true},deactivate:function(){if(!this.active){return false}var c=OpenLayers.Events.prototype.BROWSER_EVENTS;for(var b=0,a=c.length;b<a;b++){if(this[c[b]]){this.unregister(c[b],this[c[b]])}}this.active=false;return true},callback:function(b,a){if(b&&this.callbacks[b]){this.callbacks[b].apply(this.control,a)}},register:function(a,b){this.map.events.registerPriority(a,this,b);this.map.events.registerPriority(a,this,this.setEvent)},unregister:function(a,b){this.map.events.unregister(a,this,b);this.map.events.unregister(a,this,this.setEvent)},setEvent:function(a){this.evt=a;return true},destroy:function(){this.deactivate();this.control=this.map=null},CLASS_NAME:"OpenLayers.Handler"});OpenLayers.Handler.MOD_NONE=0;OpenLayers.Handler.MOD_SHIFT=1;OpenLayers.Handler.MOD_CTRL=2;OpenLayers.Handler.MOD_ALT=4;OpenLayers.Handler.Click=OpenLayers.Class(OpenLayers.Handler,{delay:300,single:true,"double":false,pixelTolerance:0,dblclickTolerance:13,stopSingle:false,stopDouble:false,timerId:null,touch:false,down:null,last:null,first:null,rightclickTimerId:null,initialize:function(c,b,a){OpenLayers.Handler.prototype.initialize.apply(this,arguments)},touchstart:function(a){if(!this.touch){this.unregisterMouseListeners();this.touch=true}this.down=this.getEventInfo(a);this.last=this.getEventInfo(a);return true},touchmove:function(a){this.last=this.getEventInfo(a);return true},touchend:function(a){if(this.down){a.xy=this.last.xy;a.lastTouches=this.last.touches;this.handleSingle(a);this.down=null}return true},unregisterMouseListeners:function(){this.map.events.un({mousedown:this.mousedown,mouseup:this.mouseup,click:this.click,dblclick:this.dblclick,scope:this})},mousedown:function(a){this.down=this.getEventInfo(a);this.last=this.getEventInfo(a);return true},mouseup:function(b){var a=true;if(this.checkModifiers(b)&&this.control.handleRightClicks&&OpenLayers.Event.isRightClick(b)){a=this.rightclick(b)}return a},rightclick:function(b){if(this.passesTolerance(b)){if(this.rightclickTimerId!=null){this.clearTimer();this.callback("dblrightclick",[b]);return !this.stopDouble}else{var a=this["double"]?OpenLayers.Util.extend({},b):this.callback("rightclick",[b]);var c=OpenLayers.Function.bind(this.delayedRightCall,this,a);this.rightclickTimerId=window.setTimeout(c,this.delay)}}return !this.stopSingle},delayedRightCall:function(a){this.rightclickTimerId=null;if(a){this.callback("rightclick",[a])}},click:function(a){if(!this.last){this.last=this.getEventInfo(a)}this.handleSingle(a);return !this.stopSingle},dblclick:function(a){this.handleDouble(a);return !this.stopDouble},handleDouble:function(a){if(this["double"]&&this.passesDblclickTolerance(a)){this.callback("dblclick",[a])}},handleSingle:function(b){if(this.passesTolerance(b)){if(this.timerId!=null){if(this.last.touches&&this.last.touches.length===1){if(this["double"]){OpenLayers.Event.stop(b)}this.handleDouble(b)}if(!this.last.touches||this.last.touches.length!==2){this.clearTimer()}}else{this.first=this.getEventInfo(b);var a=this.single?OpenLayers.Util.extend({},b):null;this.queuePotentialClick(a)}}},queuePotentialClick:function(a){this.timerId=window.setTimeout(OpenLayers.Function.bind(this.delayedCall,this,a),this.delay)},passesTolerance:function(a){var d=true;if(this.pixelTolerance!=null&&this.down&&this.down.xy){d=this.pixelTolerance>=this.down.xy.distanceTo(a.xy);if(d&&this.touch&&this.down.touches.length===this.last.touches.length){for(var b=0,c=this.down.touches.length;b<c;++b){if(this.getTouchDistance(this.down.touches[b],this.last.touches[b])>this.pixelTolerance){d=false;break}}}}return d},getTouchDistance:function(b,a){return Math.sqrt(Math.pow(b.clientX-a.clientX,2)+Math.pow(b.clientY-a.clientY,2))},passesDblclickTolerance:function(a){var b=true;if(this.down&&this.first){b=this.down.xy.distanceTo(this.first.xy)<=this.dblclickTolerance}return b},clearTimer:function(){if(this.timerId!=null){window.clearTimeout(this.timerId);this.timerId=null}if(this.rightclickTimerId!=null){window.clearTimeout(this.rightclickTimerId);this.rightclickTimerId=null}},delayedCall:function(a){this.timerId=null;if(a){this.callback("click",[a])}},getEventInfo:function(b){var d;if(b.touches){var a=b.touches.length;d=new Array(a);var e;for(var c=0;c<a;c++){e=b.touches[c];d[c]={clientX:e.clientX,clientY:e.clientY}}}return{xy:b.xy,touches:d}},deactivate:function(){var a=false;if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){this.clearTimer();this.down=null;this.first=null;this.last=null;this.touch=false;a=true}return a},CLASS_NAME:"OpenLayers.Handler.Click"});OpenLayers.Handler.Hover=OpenLayers.Class(OpenLayers.Handler,{delay:500,pixelTolerance:null,stopMove:false,px:null,timerId:null,initialize:function(c,b,a){OpenLayers.Handler.prototype.initialize.apply(this,arguments)},mousemove:function(a){if(this.passesTolerance(a.xy)){this.clearTimer();this.callback("move",[a]);this.px=a.xy;a=OpenLayers.Util.extend({},a);this.timerId=window.setTimeout(OpenLayers.Function.bind(this.delayedCall,this,a),this.delay)}return !this.stopMove},mouseout:function(a){if(OpenLayers.Util.mouseLeft(a,this.map.eventsDiv)){this.clearTimer();this.callback("move",[a])}return true},passesTolerance:function(b){var c=true;if(this.pixelTolerance&&this.px){var a=Math.sqrt(Math.pow(this.px.x-b.x,2)+Math.pow(this.px.y-b.y,2));if(a<this.pixelTolerance){c=false}}return c},clearTimer:function(){if(this.timerId!=null){window.clearTimeout(this.timerId);this.timerId=null}},delayedCall:function(a){this.callback("pause",[a])},deactivate:function(){var a=false;if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){this.clearTimer();a=true}return a},CLASS_NAME:"OpenLayers.Handler.Hover"});OpenLayers.Control.WMSGetFeatureInfo=OpenLayers.Class(OpenLayers.Control,{hover:false,drillDown:false,maxFeatures:10,clickCallback:"click",output:"features",layers:null,queryVisible:false,url:null,layerUrls:null,infoFormat:"text/html",vendorParams:{},format:null,formatOptions:null,handlerOptions:null,handler:null,hoverRequest:null,EVENT_TYPES:["beforegetfeatureinfo","nogetfeatureinfo","getfeatureinfo"],initialize:function(a){this.EVENT_TYPES=OpenLayers.Control.WMSGetFeatureInfo.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);a=a||{};a.handlerOptions=a.handlerOptions||{};OpenLayers.Control.prototype.initialize.apply(this,[a]);if(!this.format){this.format=new OpenLayers.Format.WMSGetFeatureInfo(a.formatOptions)}if(this.drillDown===true){this.hover=false}if(this.hover){this.handler=new OpenLayers.Handler.Hover(this,{move:this.cancelHover,pause:this.getInfoForHover},OpenLayers.Util.extend(this.handlerOptions.hover||{},{delay:250}))}else{var b={};b[this.clickCallback]=this.getInfoForClick;this.handler=new OpenLayers.Handler.Click(this,b,this.handlerOptions.click||{})}},activate:function(){if(!this.active){this.handler.activate()}return OpenLayers.Control.prototype.activate.apply(this,arguments)},deactivate:function(){return OpenLayers.Control.prototype.deactivate.apply(this,arguments)},getInfoForClick:function(a){this.events.triggerEvent("beforegetfeatureinfo",{xy:a.xy});OpenLayers.Element.addClass(this.map.viewPortDiv,"olCursorWait");this.request(a.xy,{})},getInfoForHover:function(a){this.events.triggerEvent("beforegetfeatureinfo",{xy:a.xy});this.request(a.xy,{hover:true})},cancelHover:function(){if(this.hoverRequest){this.hoverRequest.abort();this.hoverRequest=null}},findLayers:function(){var e=this.layers||this.map.layers;var f=[];var d,b;for(var c=0,a=e.length;c<a;++c){d=e[c];if(d instanceof OpenLayers.Layer.WMS&&(!this.queryVisible||d.getVisibility())){b=OpenLayers.Util.isArray(d.url)?d.url[0]:d.url;if(this.drillDown===false&&!this.url){this.url=b}if(this.drillDown===true||this.urlMatches(b)){f.push(d)}}}return f},urlMatches:function(b){var d=OpenLayers.Util.isEquivalentUrl(this.url,b);if(!d&&this.layerUrls){for(var c=0,a=this.layerUrls.length;c<a;++c){if(OpenLayers.Util.isEquivalentUrl(this.layerUrls[c],b)){d=true;break}}}return d},buildWMSOptions:function(b,e,c,l){var j=[],m=[];for(var f=0,h=e.length;f<h;f++){j=j.concat(e[f].params.LAYERS);m=m.concat(this.getStyleNames(e[f]))}var a=e[0];var g=this.map.getProjection();var k=a.projection;if(k&&k.equals(this.map.getProjectionObject())){g=k.getCode()}var d=OpenLayers.Util.extend({service:"WMS",version:a.params.VERSION,request:"GetFeatureInfo",layers:j,query_layers:j,styles:m,bbox:this.map.getExtent().toBBOX(null,a.reverseAxisOrder()),feature_count:this.maxFeatures,height:this.map.getSize().h,width:this.map.getSize().w,format:l,info_format:a.params.INFO_FORMAT||this.infoFormat},(parseFloat(a.params.VERSION)>=1.3)?{crs:g,i:parseInt(c.x),j:parseInt(c.y)}:{srs:g,x:parseInt(c.x),y:parseInt(c.y)});OpenLayers.Util.applyDefaults(d,this.vendorParams);return{url:b,params:OpenLayers.Util.upperCaseObject(d),callback:function(i){this.handleResponse(c,i,b)},scope:this}},getStyleNames:function(b){var a;if(b.params.STYLES){a=b.params.STYLES}else{if(OpenLayers.Util.isArray(b.params.LAYERS)){a=new Array(b.params.LAYERS.length)}else{a=b.params.LAYERS.replace(/[^,]/g,"")}}return a},request:function(b,m){var d=this.findLayers();if(d.length==0){this.events.triggerEvent("nogetfeatureinfo");OpenLayers.Element.removeClass(this.map.viewPortDiv,"olCursorWait");return}m=m||{};if(this.drillDown===false){var k=this.buildWMSOptions(this.url,d,b,d[0].params.FORMAT);var c=OpenLayers.Request.GET(k);if(m.hover===true){this.hoverRequest=c}}else{this._requestCount=0;this._numRequests=0;this.features=[];var j={},a;for(var e=0,h=d.length;e<h;e++){var f=d[e];var g,l=false;a=OpenLayers.Util.isArray(f.url)?f.url[0]:f.url;if(a in j){j[a].push(f)}else{this._numRequests++;j[a]=[f]}}var d;for(var a in j){d=j[a];var k=this.buildWMSOptions(a,d,b,d[0].params.FORMAT);OpenLayers.Request.GET(k)}}},triggerGetFeatureInfo:function(b,c,a){this.events.triggerEvent("getfeatureinfo",{text:b.responseText,features:a,request:b,xy:c});OpenLayers.Element.removeClass(this.map.viewPortDiv,"olCursorWait")},handleResponse:function(e,c,a){var d=c.responseXML;if(!d||!d.documentElement){d=c.responseText}var b=this.format.read(d);if(this.drillDown===false){this.triggerGetFeatureInfo(c,e,b)}else{this._requestCount++;if(this.output==="object"){this._features=(this._features||[]).concat({url:a,features:b})}else{this._features=(this._features||[]).concat(b)}if(this._requestCount===this._numRequests){this.triggerGetFeatureInfo(c,e,this._features.concat());delete this._features;delete this._requestCount;delete this._numRequests}}},CLASS_NAME:"OpenLayers.Control.WMSGetFeatureInfo"});OpenLayers.Format.Context=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{layerOptions:null,layerParams:null,read:function(d,b){var c=OpenLayers.Format.XML.VersionedOGC.prototype.read.apply(this,arguments);var e;if(b&&b.map){this.context=c;if(b.map instanceof OpenLayers.Map){e=this.mergeContextToMap(c,b.map)}else{var a=b.map;if(OpenLayers.Util.isElement(a)||typeof a=="string"){a={div:a}}e=this.contextToMap(c,a)}}else{e=c}return e},getLayerFromContext:function(g){var c,f;var j={queryable:g.queryable,visibility:g.visibility,maxExtent:g.maxExtent,metadata:OpenLayers.Util.applyDefaults(g.metadata,{styles:g.styles,formats:g.formats,"abstract":g["abstract"],dataURL:g.dataURL}),numZoomLevels:g.numZoomLevels,units:g.units,isBaseLayer:g.isBaseLayer,opacity:g.opacity,displayInLayerSwitcher:g.displayInLayerSwitcher,singleTile:g.singleTile,tileSize:(g.tileSize)?new OpenLayers.Size(g.tileSize.width,g.tileSize.height):undefined,minScale:g.minScale||g.maxScaleDenominator,maxScale:g.maxScale||g.minScaleDenominator,srs:g.srs,dimensions:g.dimensions,metadataURL:g.metadataURL};if(this.layerOptions){OpenLayers.Util.applyDefaults(j,this.layerOptions)}var b={layers:g.name,transparent:g.transparent,version:g.version};if(g.formats&&g.formats.length>0){b.format=g.formats[0].value;for(c=0,f=g.formats.length;c<f;c++){var h=g.formats[c];if(h.current==true){b.format=h.value;break}}}if(g.styles&&g.styles.length>0){for(c=0,f=g.styles.length;c<f;c++){var a=g.styles[c];if(a.current==true){if(a.href){b.sld=a.href}else{if(a.body){b.sld_body=a.body}else{b.styles=a.name}}break}}}if(this.layerParams){OpenLayers.Util.applyDefaults(b,this.layerParams)}var d=null;var e=g.service;if(e==OpenLayers.Format.Context.serviceTypes.WFS){j.strategies=[new OpenLayers.Strategy.BBOX()];j.protocol=new OpenLayers.Protocol.WFS({url:g.url,featurePrefix:g.name.split(":")[0],featureType:g.name.split(":").pop()});d=new OpenLayers.Layer.Vector(g.title||g.name,j)}else{if(e==OpenLayers.Format.Context.serviceTypes.KML){j.strategies=[new OpenLayers.Strategy.Fixed()];j.protocol=new OpenLayers.Protocol.HTTP({url:g.url,format:new OpenLayers.Format.KML()});d=new OpenLayers.Layer.Vector(g.title||g.name,j)}else{if(e==OpenLayers.Format.Context.serviceTypes.GML){j.strategies=[new OpenLayers.Strategy.Fixed()];j.protocol=new OpenLayers.Protocol.HTTP({url:g.url,format:new OpenLayers.Format.GML()});d=new OpenLayers.Layer.Vector(g.title||g.name,j)}else{if(g.features){d=new OpenLayers.Layer.Vector(g.title||g.name,j);d.addFeatures(g.features)}else{if(g.categoryLayer!==true){d=new OpenLayers.Layer.WMS(g.title||g.name,g.url,b,j)}}}}}return d},getLayersFromContext:function(d){var e=[];for(var c=0,a=d.length;c<a;c++){var b=this.getLayerFromContext(d[c]);if(b!==null){e.push(b)}}return e},contextToMap:function(c,a){a=OpenLayers.Util.applyDefaults({maxExtent:c.maxExtent,projection:c.projection,units:c.units},a);if(a.maxExtent){a.maxResolution=a.maxExtent.getWidth()/OpenLayers.Map.TILE_WIDTH}var b={contactInformation:c.contactInformation,"abstract":c["abstract"],keywords:c.keywords,logo:c.logo,descriptionURL:c.descriptionURL};a.metadata=b;var d=new OpenLayers.Map(a);d.addLayers(this.getLayersFromContext(c.layersContext));d.setCenter(c.bounds.getCenterLonLat(),d.getZoomForExtent(c.bounds,true));return d},mergeContextToMap:function(a,b){b.addLayers(this.getLayersFromContext(a.layersContext));return b},write:function(b,a){b=this.toContext(b);return OpenLayers.Format.XML.VersionedOGC.prototype.write.apply(this,arguments)},CLASS_NAME:"OpenLayers.Format.Context"});OpenLayers.Format.Context.serviceTypes={WMS:"urn:ogc:serviceType:WMS",WFS:"urn:ogc:serviceType:WFS",WCS:"urn:ogc:serviceType:WCS",GML:"urn:ogc:serviceType:GML",SLD:"urn:ogc:serviceType:SLD",FES:"urn:ogc:serviceType:FES",KML:"urn:ogc:serviceType:KML"};OpenLayers.Layer.XYZ=OpenLayers.Class(OpenLayers.Layer.Grid,{isBaseLayer:true,sphericalMercator:false,zoomOffset:0,serverResolutions:null,initialize:function(d,c,b){if(b&&b.sphericalMercator||this.sphericalMercator){b=OpenLayers.Util.extend({maxExtent:new OpenLayers.Bounds(-128*156543.03390625,-128*156543.03390625,128*156543.03390625,128*156543.03390625),maxResolution:156543.03390625,numZoomLevels:19,units:"m",projection:"EPSG:900913"},b)}c=c||this.url;d=d||this.name;var a=[d,c,{},b];OpenLayers.Layer.Grid.prototype.initialize.apply(this,a)},clone:function(a){if(a==null){a=new OpenLayers.Layer.XYZ(this.name,this.url,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(d){var a=this.getXYZ(d);var b=this.url;if(OpenLayers.Util.isArray(b)){var c=""+a.x+a.y+a.z;b=this.selectUrl(c,b)}return OpenLayers.String.format(b,a)},getXYZ:function(d){var c=this.map.getResolution();var a=Math.round((d.left-this.maxExtent.left)/(c*this.tileSize.w));var f=Math.round((this.maxExtent.top-d.top)/(c*this.tileSize.h));var e=this.serverResolutions!=null?OpenLayers.Util.indexOf(this.serverResolutions,c):this.map.getZoom()+this.zoomOffset;var b=Math.pow(2,e);if(this.wrapDateLine){a=((a%b)+b)%b}return{x:a,y:f,z:e}},setMap:function(a){OpenLayers.Layer.Grid.prototype.setMap.apply(this,arguments);if(!this.tileOrigin){this.tileOrigin=new OpenLayers.LonLat(this.maxExtent.left,this.maxExtent.bottom)}},CLASS_NAME:"OpenLayers.Layer.XYZ"});OpenLayers.Layer.OSM=OpenLayers.Class(OpenLayers.Layer.XYZ,{name:"OpenStreetMap",attribution:"Data CC-By-SA by <a href='http://openstreetmap.org/'>OpenStreetMap</a>",sphericalMercator:true,url:"http://tile.openstreetmap.org/${z}/${x}/${y}.png",clone:function(a){if(a==null){a=new OpenLayers.Layer.OSM(this.name,this.url,this.getOptions())}a=OpenLayers.Layer.XYZ.prototype.clone.apply(this,[a]);return a},wrapDateLine:true,CLASS_NAME:"OpenLayers.Layer.OSM"});OpenLayers.Layer.Bing=OpenLayers.Class(OpenLayers.Layer.XYZ,{serverResolutions:[156543.03390625,78271.516953125,39135.7584765625,19567.87923828125,9783.939619140625,4891.9698095703125,2445.9849047851562,1222.9924523925781,611.4962261962891,305.74811309814453,152.87405654907226,76.43702827453613,38.218514137268066,19.109257068634033,9.554628534317017,4.777314267158508,2.388657133579254,1.194328566789627,0.5971642833948135,0.29858214169740677,0.14929107084870338,0.07464553542435169],attributionTemplate:'<span class="olBingAttribution ${type}"><div><a target="_blank" href="http://www.bing.com/maps/"><img src="${logo}" /></a></div>${copyrights}<a style="white-space: nowrap" target="_blank" href="http://www.microsoft.com/maps/product/terms.html">Terms of Use</a></span>',metadata:null,type:"Road",metadataParams:null,initialize:function(c){c=OpenLayers.Util.applyDefaults({sphericalMercator:true},c);var b=c.name||"Bing "+(c.type||this.type);var a=[b,null,c];OpenLayers.Layer.XYZ.prototype.initialize.apply(this,a);this.loadMetadata()},loadMetadata:function(){this._callbackId="_callback_"+this.id.replace(/\./g,"_");window[this._callbackId]=OpenLayers.Function.bind(OpenLayers.Layer.Bing.processMetadata,this);var c=OpenLayers.Util.applyDefaults({key:this.key,jsonp:this._callbackId,include:"ImageryProviders"},this.metadataParams);var b="http://dev.virtualearth.net/REST/v1/Imagery/Metadata/"+this.type+"?"+OpenLayers.Util.getParameterString(c);var a=document.createElement("script");a.type="text/javascript";a.src=b;a.id=this._callbackId;document.getElementsByTagName("head")[0].appendChild(a)},initLayer:function(){var c=this.metadata.resourceSets[0].resources[0];var a=c.imageUrl.replace("{quadkey}","${quadkey}");this.url=[];for(var b=0;b<c.imageUrlSubdomains.length;++b){this.url.push(a.replace("{subdomain}",c.imageUrlSubdomains[b]))}this.addOptions({maxResolution:Math.min(this.serverResolutions[c.zoomMin],this.maxResolution),zoomOffset:c.zoomMin,numZoomLevels:Math.min(c.zoomMax+1-c.zoomMin,this.numZoomLevels)},true)},getURL:function(a){if(!this.url){return OpenLayers.Util.getImagesLocation()+"blank.gif"}var g=this.getXYZ(a),k=g.x,h=g.y,f=g.z;var c=[];for(var d=f;d>0;--d){var j="0";var l=1<<(d-1);if((k&l)!=0){j++}if((h&l)!=0){j++;j++}c.push(j)}var e=c.join("");var b=this.selectUrl(""+k+h+f,this.url);return OpenLayers.String.format(b,{quadkey:e})},updateAttribution:function(){var g=this.metadata;if(!g||!this.map||!this.map.center){return}var f=g.resourceSets[0].resources[0];var o=this.map.getExtent().transform(this.map.getProjectionObject(),new OpenLayers.Projection("EPSG:4326"));var c=f.imageryProviders,n=this.map.getZoom()+1,a="",h,d,m,b,e,l,k;for(d=0,m=c.length;d<m;++d){h=c[d];for(b=0,e=h.coverageAreas.length;b<e;++b){k=h.coverageAreas[b];l=OpenLayers.Bounds.fromArray(k.bbox);if(o.intersectsBounds(l)&&n<=k.zoomMax&&n>=k.zoomMin){a+=h.attribution+" "}}}this.attribution=OpenLayers.String.format(this.attributionTemplate,{type:this.type.toLowerCase(),logo:g.brandLogoUri,copyrights:a});this.map&&this.map.events.triggerEvent("changelayer",{layer:this,property:"attribution"})},setMap:function(){OpenLayers.Layer.XYZ.prototype.setMap.apply(this,arguments);this.updateAttribution();this.map.events.register("moveend",this,this.updateAttribution)},clone:function(a){if(a==null){a=new OpenLayers.Layer.Bing(this.options)}a=OpenLayers.Layer.XYZ.prototype.clone.apply(this,[a]);return a},destroy:function(){this.map&&this.map.events.unregister("moveend",this,this.updateAttribution);OpenLayers.Layer.XYZ.prototype.destroy.apply(this,arguments)},CLASS_NAME:"OpenLayers.Layer.Bing"});OpenLayers.Layer.Bing.processMetadata=function(b){this.metadata=b;this.initLayer();var a=document.getElementById(this._callbackId);a.parentNode.removeChild(a);window[this._callbackId]=undefined;delete this._callbackId};OpenLayers.Format.SOSGetFeatureOfInterest=OpenLayers.Class(OpenLayers.Format.XML,{VERSION:"1.0.0",namespaces:{sos:"http://www.opengis.net/sos/1.0",gml:"http://www.opengis.net/gml",sa:"http://www.opengis.net/sampling/1.0",xsi:"http://www.w3.org/2001/XMLSchema-instance"},schemaLocation:"http://www.opengis.net/sos/1.0 http://schemas.opengis.net/sos/1.0.0/sosAll.xsd",defaultPrefix:"sos",regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},read:function(f){if(typeof f=="string"){f=OpenLayers.Format.XML.prototype.read.apply(this,[f])}if(f&&f.nodeType==9){f=f.documentElement}var g={features:[]};this.readNode(f,g);var e=[];for(var d=0,a=g.features.length;d<a;d++){var b=g.features[d];if(this.internalProjection&&this.externalProjection&&b.components[0]){b.components[0].transform(this.externalProjection,this.internalProjection)}var c=new OpenLayers.Feature.Vector(b.components[0],b.attributes);e.push(c)}return e},readers:{sa:{SamplingPoint:function(b,c){if(!c.attributes){var a={attributes:{}};c.features.push(a);c=a}c.attributes.id=this.getAttributeNS(b,this.namespaces.gml,"id");this.readChildNodes(b,c)},position:function(a,b){this.readChildNodes(a,b)}},gml:OpenLayers.Util.applyDefaults({FeatureCollection:function(a,b){this.readChildNodes(a,b)},featureMember:function(b,c){var a={attributes:{}};c.features.push(a);this.readChildNodes(b,a)},name:function(a,b){b.attributes.name=this.getChildValue(a)},pos:function(a,b){if(!this.externalProjection){this.externalProjection=new OpenLayers.Projection(a.getAttribute("srsName"))}OpenLayers.Format.GML.v3.prototype.readers.gml.pos.apply(this,[a,b])}},OpenLayers.Format.GML.v3.prototype.readers.gml)},writers:{sos:{GetFeatureOfInterest:function(b){var d=this.createElementNSPlus("GetFeatureOfInterest",{attributes:{version:this.VERSION,service:"SOS","xsi:schemaLocation":this.schemaLocation}});for(var c=0,a=b.fois.length;c<a;c++){this.writeNode("FeatureOfInterestId",{foi:b.fois[c]},d)}return d},FeatureOfInterestId:function(a){var b=this.createElementNSPlus("FeatureOfInterestId",{value:a.foi});return b}}},CLASS_NAME:"OpenLayers.Format.SOSGetFeatureOfInterest"});OpenLayers.Format.SOSGetObservation=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{ows:"http://www.opengis.net/ows",gml:"http://www.opengis.net/gml",sos:"http://www.opengis.net/sos/1.0",ogc:"http://www.opengis.net/ogc",om:"http://www.opengis.net/om/1.0",sa:"http://www.opengis.net/sampling/1.0",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},VERSION:"1.0.0",schemaLocation:"http://www.opengis.net/sos/1.0 http://schemas.opengis.net/sos/1.0.0/sosGetObservation.xsd",defaultPrefix:"sos",read:function(a){if(typeof a=="string"){a=OpenLayers.Format.XML.prototype.read.apply(this,[a])}if(a&&a.nodeType==9){a=a.documentElement}var b={measurements:[],observations:[]};this.readNode(a,b);return b},write:function(a){var b=this.writeNode("sos:GetObservation",a);b.setAttribute("xmlns:om",this.namespaces.om);b.setAttribute("xmlns:ogc",this.namespaces.ogc);this.setAttributeNS(b,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);return OpenLayers.Format.XML.prototype.write.apply(this,[b])},readers:{om:{ObservationCollection:function(a,b){b.id=this.getAttributeNS(a,this.namespaces.gml,"id");this.readChildNodes(a,b)},member:function(a,b){this.readChildNodes(a,b)},Measurement:function(b,c){var a={};c.measurements.push(a);this.readChildNodes(b,a)},Observation:function(b,c){var a={};c.observations.push(a);this.readChildNodes(b,a)},samplingTime:function(b,a){var c={};a.samplingTime=c;this.readChildNodes(b,c)},observedProperty:function(b,a){a.observedProperty=this.getAttributeNS(b,this.namespaces.xlink,"href");this.readChildNodes(b,a)},procedure:function(b,a){a.procedure=this.getAttributeNS(b,this.namespaces.xlink,"href");this.readChildNodes(b,a)},featureOfInterest:function(g,b){var f={features:[]};b.fois=[];b.fois.push(f);this.readChildNodes(g,f);var e=[];for(var d=0,a=f.features.length;d<a;d++){var c=f.features[d];e.push(new OpenLayers.Feature.Vector(c.components[0],c.attributes))}f.features=e},result:function(c,b){var a={};b.result=a;if(this.getChildValue(c)!==""){a.value=this.getChildValue(c);a.uom=c.getAttribute("uom")}else{this.readChildNodes(c,a)}}},sa:OpenLayers.Format.SOSGetFeatureOfInterest.prototype.readers.sa,gml:OpenLayers.Util.applyDefaults({TimeInstant:function(a,b){var c={};b.timeInstant=c;this.readChildNodes(a,c)},timePosition:function(a,b){b.timePosition=this.getChildValue(a)}},OpenLayers.Format.SOSGetFeatureOfInterest.prototype.readers.gml)},writers:{sos:{GetObservation:function(b){var d=this.createElementNSPlus("GetObservation",{attributes:{version:this.VERSION,service:"SOS"}});this.writeNode("offering",b,d);if(b.eventTime){this.writeNode("eventTime",b,d)}for(var c in b.procedures){this.writeNode("procedure",b.procedures[c],d)}for(var a in b.observedProperties){this.writeNode("observedProperty",b.observedProperties[a],d)}if(b.foi){this.writeNode("featureOfInterest",b.foi,d)}this.writeNode("responseFormat",b,d);if(b.resultModel){this.writeNode("resultModel",b,d)}if(b.responseMode){this.writeNode("responseMode",b,d)}return d},featureOfInterest:function(a){var b=this.createElementNSPlus("featureOfInterest");this.writeNode("ObjectID",a.objectId,b);return b},ObjectID:function(a){return this.createElementNSPlus("ObjectID",{value:a})},responseFormat:function(a){return this.createElementNSPlus("responseFormat",{value:a.responseFormat})},procedure:function(a){return this.createElementNSPlus("procedure",{value:a})},offering:function(a){return this.createElementNSPlus("offering",{value:a.offering})},observedProperty:function(a){return this.createElementNSPlus("observedProperty",{value:a})},eventTime:function(a){var b=this.createElementNSPlus("eventTime");if(a.eventTime==="latest"){this.writeNode("ogc:TM_Equals",a,b)}return b},resultModel:function(a){return this.createElementNSPlus("resultModel",{value:a.resultModel})},responseMode:function(a){return this.createElementNSPlus("responseMode",{value:a.responseMode})}},ogc:{TM_Equals:function(a){var b=this.createElementNSPlus("ogc:TM_Equals");this.writeNode("ogc:PropertyName",{property:"urn:ogc:data:time:iso8601"},b);if(a.eventTime==="latest"){this.writeNode("gml:TimeInstant",{value:"latest"},b)}return b},PropertyName:function(a){return this.createElementNSPlus("ogc:PropertyName",{value:a.property})}},gml:{TimeInstant:function(a){var b=this.createElementNSPlus("gml:TimeInstant");this.writeNode("gml:timePosition",a,b);return b},timePosition:function(a){var b=this.createElementNSPlus("gml:timePosition",{value:a.value});return b}}},CLASS_NAME:"OpenLayers.Format.SOSGetObservation"});OpenLayers.Handler.MouseWheel=OpenLayers.Class(OpenLayers.Handler,{wheelListener:null,mousePosition:null,interval:0,delta:0,cumulative:true,initialize:function(c,b,a){OpenLayers.Handler.prototype.initialize.apply(this,arguments);this.wheelListener=OpenLayers.Function.bindAsEventListener(this.onWheelEvent,this)},destroy:function(){OpenLayers.Handler.prototype.destroy.apply(this,arguments);this.wheelListener=null},onWheelEvent:function(k){if(!this.map||!this.checkModifiers(k)){return}var g=false;var m=false;var f=false;var b=OpenLayers.Event.element(k);while((b!=null)&&!f&&!g){if(!g){try{if(b.currentStyle){c=b.currentStyle.overflow}else{var a=document.defaultView.getComputedStyle(b,null);var c=a.getPropertyValue("overflow")}g=(c&&(c=="auto")||(c=="scroll"))}catch(d){}}if(!m){for(var h=0,j=this.map.layers.length;h<j;h++){if(b==this.map.layers[h].div||b==this.map.layers[h].pane){m=true;break}}}f=(b==this.map.div);b=b.parentNode}if(!g&&f){if(m){var l=0;if(!k){k=window.event}if(k.wheelDelta){l=k.wheelDelta/120;if(window.opera&&window.opera.version()<9.2){l=-l}}else{if(k.detail){l=-k.detail/3}}this.delta=this.delta+l;if(this.interval){window.clearTimeout(this._timeoutId);this._timeoutId=window.setTimeout(OpenLayers.Function.bind(function(){this.wheelZoom(k)},this),this.interval)}else{this.wheelZoom(k)}}OpenLayers.Event.stop(k)}},wheelZoom:function(a){var b=this.delta;this.delta=0;if(b){if(this.mousePosition){a.xy=this.mousePosition}if(!a.xy){a.xy=this.map.getPixelFromLonLat(this.map.getCenter())}if(b<0){this.callback("down",[a,this.cumulative?b:-1])}else{this.callback("up",[a,this.cumulative?b:1])}}},mousemove:function(a){this.mousePosition=a.xy},activate:function(a){if(OpenLayers.Handler.prototype.activate.apply(this,arguments)){var b=this.wheelListener;OpenLayers.Event.observe(window,"DOMMouseScroll",b);OpenLayers.Event.observe(window,"mousewheel",b);OpenLayers.Event.observe(document,"mousewheel",b);return true}else{return false}},deactivate:function(a){if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){var b=this.wheelListener;OpenLayers.Event.stopObserving(window,"DOMMouseScroll",b);OpenLayers.Event.stopObserving(window,"mousewheel",b);OpenLayers.Event.stopObserving(document,"mousewheel",b);return true}else{return false}},CLASS_NAME:"OpenLayers.Handler.MouseWheel"});OpenLayers.Format.WFST.v1_0_0=OpenLayers.Class(OpenLayers.Format.Filter.v1_0_0,OpenLayers.Format.WFST.v1,{version:"1.0.0",srsNameInQuery:false,schemaLocations:{wfs:"http://schemas.opengis.net/wfs/1.0.0/WFS-transaction.xsd"},initialize:function(a){OpenLayers.Format.Filter.v1_0_0.prototype.initialize.apply(this,[a]);OpenLayers.Format.WFST.v1.prototype.initialize.apply(this,[a])},readNode:function(a,b,c){return OpenLayers.Format.GML.v2.prototype.readNode.apply(this,[a,b])},readers:{wfs:OpenLayers.Util.applyDefaults({WFS_TransactionResponse:function(a,b){b.insertIds=[];b.success=false;this.readChildNodes(a,b)},InsertResult:function(b,a){var c={fids:[]};this.readChildNodes(b,c);a.insertIds.push(c.fids[0])},TransactionResult:function(a,b){this.readChildNodes(a,b)},Status:function(a,b){this.readChildNodes(a,b)},SUCCESS:function(a,b){b.success=true}},OpenLayers.Format.WFST.v1.prototype.readers.wfs),gml:OpenLayers.Format.GML.v2.prototype.readers.gml,feature:OpenLayers.Format.GML.v2.prototype.readers.feature,ogc:OpenLayers.Format.Filter.v1_0_0.prototype.readers.ogc},writers:{wfs:OpenLayers.Util.applyDefaults({Query:function(b){b=OpenLayers.Util.extend({featureNS:this.featureNS,featurePrefix:this.featurePrefix,featureType:this.featureType,srsName:this.srsName,srsNameInQuery:this.srsNameInQuery},b);var e=b.featurePrefix;var d=this.createElementNSPlus("wfs:Query",{attributes:{typeName:(e?e+":":"")+b.featureType}});if(b.srsNameInQuery&&b.srsName){d.setAttribute("srsName",b.srsName)}if(b.featureNS){d.setAttribute("xmlns:"+e,b.featureNS)}if(b.propertyNames){for(var c=0,a=b.propertyNames.length;c<a;c++){this.writeNode("ogc:PropertyName",{property:b.propertyNames[c]},d)}}if(b.filter){this.setFilterProperty(b.filter);this.writeNode("ogc:Filter",b.filter,d)}return d}},OpenLayers.Format.WFST.v1.prototype.writers.wfs),gml:OpenLayers.Format.GML.v2.prototype.writers.gml,feature:OpenLayers.Format.GML.v2.prototype.writers.feature,ogc:OpenLayers.Format.Filter.v1_0_0.prototype.writers.ogc},CLASS_NAME:"OpenLayers.Format.WFST.v1_0_0"});OpenLayers.ElementsIndexer=OpenLayers.Class({maxZIndex:null,order:null,indices:null,compare:null,initialize:function(a){this.compare=a?OpenLayers.ElementsIndexer.IndexingMethods.Z_ORDER_Y_ORDER:OpenLayers.ElementsIndexer.IndexingMethods.Z_ORDER_DRAWING_ORDER;this.clear()},insert:function(c){if(this.exists(c)){this.remove(c)}var f=c.id;this.determineZIndex(c);var d=-1;var e=this.order.length;var a;while(e-d>1){a=parseInt((d+e)/2);var b=this.compare(this,c,OpenLayers.Util.getElement(this.order[a]));if(b>0){d=a}else{e=a}}this.order.splice(e,0,f);this.indices[f]=this.getZIndex(c);return this.getNextElement(e)},remove:function(b){var d=b.id;var a=OpenLayers.Util.indexOf(this.order,d);if(a>=0){this.order.splice(a,1);delete this.indices[d];if(this.order.length>0){var c=this.order[this.order.length-1];this.maxZIndex=this.indices[c]}else{this.maxZIndex=0}}},clear:function(){this.order=[];this.indices={};this.maxZIndex=0},exists:function(a){return(this.indices[a.id]!=null)},getZIndex:function(a){return a._style.graphicZIndex},determineZIndex:function(a){var b=a._style.graphicZIndex;if(b==null){b=this.maxZIndex;a._style.graphicZIndex=b}else{if(b>this.maxZIndex){this.maxZIndex=b}}},getNextElement:function(b){var a=b+1;if(a<this.order.length){var c=OpenLayers.Util.getElement(this.order[a]);if(c==undefined){c=this.getNextElement(a)}return c}else{return null}},CLASS_NAME:"OpenLayers.ElementsIndexer"});OpenLayers.ElementsIndexer.IndexingMethods={Z_ORDER:function(e,d,b){var a=e.getZIndex(d);var f=0;if(b){var c=e.getZIndex(b);f=a-c}return f},Z_ORDER_DRAWING_ORDER:function(c,b,a){var d=OpenLayers.ElementsIndexer.IndexingMethods.Z_ORDER(c,b,a);if(a&&d==0){d=1}return d},Z_ORDER_Y_ORDER:function(d,c,b){var e=OpenLayers.ElementsIndexer.IndexingMethods.Z_ORDER(d,c,b);if(b&&e===0){var a=b._boundsBottom-c._boundsBottom;e=(a===0)?1:a}return e}};OpenLayers.Renderer.Elements=OpenLayers.Class(OpenLayers.Renderer,{rendererRoot:null,root:null,vectorRoot:null,textRoot:null,xmlns:null,indexer:null,BACKGROUND_ID_SUFFIX:"_background",LABEL_ID_SUFFIX:"_label",initialize:function(a,b){OpenLayers.Renderer.prototype.initialize.apply(this,arguments);this.rendererRoot=this.createRenderRoot();this.root=this.createRoot("_root");this.vectorRoot=this.createRoot("_vroot");this.textRoot=this.createRoot("_troot");this.root.appendChild(this.vectorRoot);this.root.appendChild(this.textRoot);this.rendererRoot.appendChild(this.root);this.container.appendChild(this.rendererRoot);if(b&&(b.zIndexing||b.yOrdering)){this.indexer=new OpenLayers.ElementsIndexer(b.yOrdering)}},destroy:function(){this.clear();this.rendererRoot=null;this.root=null;this.xmlns=null;OpenLayers.Renderer.prototype.destroy.apply(this,arguments)},clear:function(){var b;var a=this.vectorRoot;if(a){while(b=a.firstChild){a.removeChild(b)}}a=this.textRoot;if(a){while(b=a.firstChild){a.removeChild(b)}}if(this.indexer){this.indexer.clear()}},getNodeType:function(b,a){},drawGeometry:function(j,a,d){var h=j.CLASS_NAME;var c=true;if((h=="OpenLayers.Geometry.Collection")||(h=="OpenLayers.Geometry.MultiPoint")||(h=="OpenLayers.Geometry.MultiLineString")||(h=="OpenLayers.Geometry.MultiPolygon")){for(var f=0,g=j.components.length;f<g;f++){c=this.drawGeometry(j.components[f],a,d)&&c}return c}c=false;var e=false;if(a.display!="none"){if(a.backgroundGraphic){this.redrawBackgroundNode(j.id,j,a,d)}else{e=true}c=this.redrawNode(j.id,j,a,d)}if(c==false){var b=document.getElementById(j.id);if(b){if(b._style.backgroundGraphic){e=true}b.parentNode.removeChild(b)}}if(e){var b=document.getElementById(j.id+this.BACKGROUND_ID_SUFFIX);if(b){b.parentNode.removeChild(b)}}return c},redrawNode:function(g,f,b,e){b=this.applyDefaultSymbolizer(b);var c=this.nodeFactory(g,this.getNodeType(f,b));c._featureId=e;c._boundsBottom=f.getBounds().bottom;c._geometryClass=f.CLASS_NAME;c._style=b;var a=this.drawGeometryNode(c,f,b);if(a===false){return false}c=a.node;if(this.indexer){var d=this.indexer.insert(c);if(d){this.vectorRoot.insertBefore(c,d)}else{this.vectorRoot.appendChild(c)}}else{if(c.parentNode!==this.vectorRoot){this.vectorRoot.appendChild(c)}}this.postDraw(c);return a.complete},redrawBackgroundNode:function(e,d,b,c){var a=OpenLayers.Util.extend({},b);a.externalGraphic=a.backgroundGraphic;a.graphicXOffset=a.backgroundXOffset;a.graphicYOffset=a.backgroundYOffset;a.graphicZIndex=a.backgroundGraphicZIndex;a.graphicWidth=a.backgroundWidth||a.graphicWidth;a.graphicHeight=a.backgroundHeight||a.graphicHeight;a.backgroundGraphic=null;a.backgroundXOffset=null;a.backgroundYOffset=null;a.backgroundGraphicZIndex=null;return this.redrawNode(e+this.BACKGROUND_ID_SUFFIX,d,a,null)},drawGeometryNode:function(c,e,b){b=b||c._style;var a={isFilled:b.fill===undefined?true:b.fill,isStroked:b.stroke===undefined?!!b.strokeWidth:b.stroke};var d;switch(e.CLASS_NAME){case"OpenLayers.Geometry.Point":if(b.graphic===false){a.isFilled=false;a.isStroked=false}d=this.drawPoint(c,e);break;case"OpenLayers.Geometry.LineString":a.isFilled=false;d=this.drawLineString(c,e);break;case"OpenLayers.Geometry.LinearRing":d=this.drawLinearRing(c,e);break;case"OpenLayers.Geometry.Polygon":d=this.drawPolygon(c,e);break;case"OpenLayers.Geometry.Surface":d=this.drawSurface(c,e);break;case"OpenLayers.Geometry.Rectangle":d=this.drawRectangle(c,e);break;default:break}c._options=a;if(d!=false){return{node:this.setStyle(c,b,a,e),complete:d}}else{return false}},postDraw:function(a){},drawPoint:function(a,b){},drawLineString:function(a,b){},drawLinearRing:function(a,b){},drawPolygon:function(a,b){},drawRectangle:function(a,b){},drawCircle:function(a,b){},drawSurface:function(a,b){},removeText:function(b){var a=document.getElementById(b+this.LABEL_ID_SUFFIX);if(a){this.textRoot.removeChild(a)}},getFeatureIdFromEvent:function(a){var d=a.target;var b=d&&d.correspondingUseElement;var c=b?b:(d||a.srcElement);var e=c._featureId;return e},eraseGeometry:function(g,f){if((g.CLASS_NAME=="OpenLayers.Geometry.MultiPoint")||(g.CLASS_NAME=="OpenLayers.Geometry.MultiLineString")||(g.CLASS_NAME=="OpenLayers.Geometry.MultiPolygon")||(g.CLASS_NAME=="OpenLayers.Geometry.Collection")){for(var d=0,a=g.components.length;d<a;d++){this.eraseGeometry(g.components[d],f)}}else{var c=OpenLayers.Util.getElement(g.id);if(c&&c.parentNode){if(c.geometry){c.geometry.destroy();c.geometry=null}c.parentNode.removeChild(c);if(this.indexer){this.indexer.remove(c)}if(c._style.backgroundGraphic){var b=g.id+this.BACKGROUND_ID_SUFFIX;var e=OpenLayers.Util.getElement(b);if(e&&e.parentNode){e.parentNode.removeChild(e)}}}}},nodeFactory:function(c,a){var b=OpenLayers.Util.getElement(c);if(b){if(!this.nodeTypeCompare(b,a)){b.parentNode.removeChild(b);b=this.nodeFactory(c,a)}}else{b=this.createNode(a,c)}return b},nodeTypeCompare:function(b,a){},createNode:function(a,b){},moveRoot:function(b){var a=this.root;if(b.root.parentNode==this.rendererRoot){a=b.root}a.parentNode.removeChild(a);b.rendererRoot.appendChild(a)},getRenderLayerId:function(){return this.root.parentNode.parentNode.id},isComplexSymbol:function(a){return(a!="circle")&&!!a},CLASS_NAME:"OpenLayers.Renderer.Elements"});OpenLayers.Renderer.symbol={star:[350,75,379,161,469,161,397,215,423,301,350,250,277,301,303,215,231,161,321,161,350,75],cross:[4,0,6,0,6,4,10,4,10,6,6,6,6,10,4,10,4,6,0,6,0,4,4,4,4,0],x:[0,0,25,0,50,35,75,0,100,0,65,50,100,100,75,100,50,65,25,100,0,100,35,50,0,0],square:[0,0,0,1,1,1,1,0,0,0],triangle:[0,10,10,10,5,0,0,10]};OpenLayers.Control.ArgParser=OpenLayers.Class(OpenLayers.Control,{center:null,zoom:null,layers:null,displayProjection:null,getParameters:function(b){b=b||window.location.href;var c=OpenLayers.Util.getParameters(b);var a=b.indexOf("#");if(a>0){b="?"+b.substring(a+1,b.length);OpenLayers.Util.extend(c,OpenLayers.Util.getParameters(b))}return c},setMap:function(e){OpenLayers.Control.prototype.setMap.apply(this,arguments);for(var c=0,a=this.map.controls.length;c<a;c++){var d=this.map.controls[c];if((d!=this)&&(d.CLASS_NAME=="OpenLayers.Control.ArgParser")){if(d.displayProjection!=this.displayProjection){this.displayProjection=d.displayProjection}break}}if(c==this.map.controls.length){var b=this.getParameters();if(b.layers){this.layers=b.layers;this.map.events.register("addlayer",this,this.configureLayers);this.configureLayers()}if(b.lat&&b.lon){this.center=new OpenLayers.LonLat(parseFloat(b.lon),parseFloat(b.lat));if(b.zoom){this.zoom=parseInt(b.zoom)}this.map.events.register("changebaselayer",this,this.setCenter);this.setCenter()}}},setCenter:function(){if(this.map.baseLayer){this.map.events.unregister("changebaselayer",this,this.setCenter);if(this.displayProjection){this.center.transform(this.displayProjection,this.map.getProjectionObject())}this.map.setCenter(this.center,this.zoom)}},configureLayers:function(){if(this.layers.length==this.map.layers.length){this.map.events.unregister("addlayer",this,this.configureLayers);for(var d=0,a=this.layers.length;d<a;d++){var b=this.map.layers[d];var e=this.layers.charAt(d);if(e=="B"){this.map.setBaseLayer(b)}else{if((e=="T")||(e=="F")){b.setVisibility(e=="T")}}}}},CLASS_NAME:"OpenLayers.Control.ArgParser"});OpenLayers.Control.Permalink=OpenLayers.Class(OpenLayers.Control,{argParserClass:OpenLayers.Control.ArgParser,element:null,anchor:false,base:"",displayProjection:null,initialize:function(b,c,a){if(b!==null&&typeof b=="object"&&!OpenLayers.Util.isElement(b)){a=b;this.base=document.location.href;OpenLayers.Control.prototype.initialize.apply(this,[a]);if(this.element!=null){this.element=OpenLayers.Util.getElement(this.element)}}else{OpenLayers.Control.prototype.initialize.apply(this,[a]);this.element=OpenLayers.Util.getElement(b);this.base=c||document.location.href}},destroy:function(){if(this.element.parentNode==this.div){this.div.removeChild(this.element)}this.element=null;this.map.events.unregister("moveend",this,this.updateLink);OpenLayers.Control.prototype.destroy.apply(this,arguments)},setMap:function(d){OpenLayers.Control.prototype.setMap.apply(this,arguments);for(var b=0,a=this.map.controls.length;b<a;b++){var c=this.map.controls[b];if(c.CLASS_NAME==this.argParserClass.CLASS_NAME){if(c.displayProjection!=this.displayProjection){this.displayProjection=c.displayProjection}break}}if(b==this.map.controls.length){this.map.addControl(new this.argParserClass({displayProjection:this.displayProjection}))}},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);if(!this.element&&!this.anchor){this.element=document.createElement("a");this.element.innerHTML=OpenLayers.i18n("Permalink");this.element.href="";this.div.appendChild(this.element)}this.map.events.on({moveend:this.updateLink,changelayer:this.updateLink,changebaselayer:this.updateLink,scope:this});this.updateLink();return this.div},updateLink:function(){var b=this.anchor?"#":"?";var a=this.base;if(a.indexOf(b)!=-1){a=a.substring(0,a.indexOf(b))}a+=b+OpenLayers.Util.getParameterString(this.createParams());if(this.anchor&&!this.element){window.location.href=a}else{this.element.href=a}},createParams:function(a,k,e){a=a||this.map.getCenter();var d=OpenLayers.Util.getParameters(this.base);if(a){d.zoom=k||this.map.getZoom();var j=a.lat;var b=a.lon;if(this.displayProjection){var c=OpenLayers.Projection.transform({x:b,y:j},this.map.getProjectionObject(),this.displayProjection);b=c.x;j=c.y}d.lat=Math.round(j*100000)/100000;d.lon=Math.round(b*100000)/100000;e=e||this.map.layers;d.layers="";for(var f=0,h=e.length;f<h;f++){var g=e[f];if(g.isBaseLayer){d.layers+=(g==this.map.baseLayer)?"B":"0"}else{d.layers+=(g.getVisibility())?"T":"F"}}}return d},CLASS_NAME:"OpenLayers.Control.Permalink"});OpenLayers.Layer.TMS=OpenLayers.Class(OpenLayers.Layer.Grid,{serviceVersion:"1.0.0",layername:null,type:null,isBaseLayer:true,tileOrigin:null,serverResolutions:null,zoomOffset:0,initialize:function(d,c,b){var a=[];a.push(d,c,{},b);OpenLayers.Layer.Grid.prototype.initialize.apply(this,a)},destroy:function(){OpenLayers.Layer.Grid.prototype.destroy.apply(this,arguments)},clone:function(a){if(a==null){a=new OpenLayers.Layer.TMS(this.name,this.url,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(d){d=this.adjustBounds(d);var c=this.map.getResolution();var a=Math.round((d.left-this.tileOrigin.lon)/(c*this.tileSize.w));var g=Math.round((d.bottom-this.tileOrigin.lat)/(c*this.tileSize.h));var f=this.serverResolutions!=null?OpenLayers.Util.indexOf(this.serverResolutions,c):this.map.getZoom()+this.zoomOffset;var e=this.serviceVersion+"/"+this.layername+"/"+f+"/"+a+"/"+g+"."+this.type;var b=this.url;if(OpenLayers.Util.isArray(b)){b=this.selectUrl(e,b)}return b+e},setMap:function(a){OpenLayers.Layer.Grid.prototype.setMap.apply(this,arguments);if(!this.tileOrigin){this.tileOrigin=new OpenLayers.LonLat(this.map.maxExtent.left,this.map.maxExtent.bottom)}},CLASS_NAME:"OpenLayers.Layer.TMS"});OpenLayers.Strategy.Fixed=OpenLayers.Class(OpenLayers.Strategy,{preload:false,activate:function(){if(OpenLayers.Strategy.prototype.activate.apply(this,arguments)){this.layer.events.on({refresh:this.load,scope:this});if(this.layer.visibility==true||this.preload){this.load()}else{this.layer.events.on({visibilitychanged:this.load,scope:this})}return true}return false},deactivate:function(){var a=OpenLayers.Strategy.prototype.deactivate.call(this);if(a){this.layer.events.un({refresh:this.load,visibilitychanged:this.load,scope:this})}return a},load:function(a){var b=this.layer;b.events.triggerEvent("loadstart");b.protocol.read(OpenLayers.Util.applyDefaults({callback:OpenLayers.Function.bind(this.merge,this,b.map.getProjectionObject()),filter:b.filter},a));b.events.un({visibilitychanged:this.load,scope:this})},merge:function(f,g){var d=this.layer;d.destroyFeatures();var e=g.features;if(e&&e.length>0){if(!f.equals(d.projection)){var c;for(var b=0,a=e.length;b<a;++b){c=e[b].geometry;if(c){c.transform(d.projection,f)}}}d.addFeatures(e)}d.events.triggerEvent("loadend")},CLASS_NAME:"OpenLayers.Strategy.Fixed"});OpenLayers.StyleMap=OpenLayers.Class({styles:null,extendDefault:true,initialize:function(c,a){this.styles={"default":new OpenLayers.Style(OpenLayers.Feature.Vector.style["default"]),select:new OpenLayers.Style(OpenLayers.Feature.Vector.style.select),temporary:new OpenLayers.Style(OpenLayers.Feature.Vector.style.temporary),"delete":new OpenLayers.Style(OpenLayers.Feature.Vector.style["delete"])};if(c instanceof OpenLayers.Style){this.styles["default"]=c;this.styles.select=c;this.styles.temporary=c;this.styles["delete"]=c}else{if(typeof c=="object"){for(var b in c){if(c[b] instanceof OpenLayers.Style){this.styles[b]=c[b]}else{if(typeof c[b]=="object"){this.styles[b]=new OpenLayers.Style(c[b])}else{this.styles["default"]=new OpenLayers.Style(c);this.styles.select=new OpenLayers.Style(c);this.styles.temporary=new OpenLayers.Style(c);this.styles["delete"]=new OpenLayers.Style(c);break}}}}}OpenLayers.Util.extend(this,a)},destroy:function(){for(var a in this.styles){this.styles[a].destroy()}this.styles=null},createSymbolizer:function(b,c){if(!b){b=new OpenLayers.Feature.Vector()}if(!this.styles[c]){c="default"}b.renderIntent=c;var a={};if(this.extendDefault&&c!="default"){a=this.styles["default"].createSymbolizer(b)}return OpenLayers.Util.extend(a,this.styles[c].createSymbolizer(b))},addUniqueValueRules:function(b,d,f,a){var e=[];for(var c in f){e.push(new OpenLayers.Rule({symbolizer:f[c],context:a,filter:new OpenLayers.Filter.Comparison({type:OpenLayers.Filter.Comparison.EQUAL_TO,property:d,value:c})}))}this.styles[b].addRules(e)},CLASS_NAME:"OpenLayers.StyleMap"});OpenLayers.Layer.Vector=OpenLayers.Class(OpenLayers.Layer,{EVENT_TYPES:["beforefeatureadded","beforefeaturesadded","featureadded","featuresadded","beforefeatureremoved","beforefeaturesremoved","featureremoved","featuresremoved","beforefeatureselected","featureselected","featureunselected","beforefeaturemodified","featuremodified","afterfeaturemodified","vertexmodified","vertexremoved","sketchstarted","sketchmodified","sketchcomplete","refresh"],isBaseLayer:false,isFixed:false,features:null,filter:null,selectedFeatures:null,unrenderedFeatures:null,reportError:true,style:null,styleMap:null,strategies:null,protocol:null,renderers:["SVG","VML","Canvas"],renderer:null,rendererOptions:null,geometryType:null,drawn:false,initialize:function(c,b){this.EVENT_TYPES=OpenLayers.Layer.Vector.prototype.EVENT_TYPES.concat(OpenLayers.Layer.prototype.EVENT_TYPES);OpenLayers.Layer.prototype.initialize.apply(this,arguments);if(!this.renderer||!this.renderer.supported()){this.assignRenderer()}if(!this.renderer||!this.renderer.supported()){this.renderer=null;this.displayError()}if(!this.styleMap){this.styleMap=new OpenLayers.StyleMap()}this.features=[];this.selectedFeatures=[];this.unrenderedFeatures={};if(this.strategies){for(var d=0,a=this.strategies.length;d<a;d++){this.strategies[d].setLayer(this)}}},destroy:function(){if(this.strategies){var c,b,a;for(b=0,a=this.strategies.length;b<a;b++){c=this.strategies[b];if(c.autoDestroy){c.destroy()}}this.strategies=null}if(this.protocol){if(this.protocol.autoDestroy){this.protocol.destroy()}this.protocol=null}this.destroyFeatures();this.features=null;this.selectedFeatures=null;this.unrenderedFeatures=null;if(this.renderer){this.renderer.destroy()}this.renderer=null;this.geometryType=null;this.drawn=null;OpenLayers.Layer.prototype.destroy.apply(this,arguments)},clone:function(e){if(e==null){e=new OpenLayers.Layer.Vector(this.name,this.getOptions())}e=OpenLayers.Layer.prototype.clone.apply(this,[e]);var c=this.features;var a=c.length;var d=new Array(a);for(var b=0;b<a;++b){d[b]=c[b].clone()}e.features=d;return e},refresh:function(a){if(this.calculateInRange()&&this.visibility){this.events.triggerEvent("refresh",a)}},assignRenderer:function(){for(var c=0,a=this.renderers.length;c<a;c++){var b=this.renderers[c];var d=(typeof b=="function")?b:OpenLayers.Renderer[b];if(d&&d.prototype.supported()){this.renderer=new d(this.div,this.rendererOptions);break}}},displayError:function(){if(this.reportError){OpenLayers.Console.userError(OpenLayers.i18n("browserNotSupported",{renderers:this.renderers.join("\n")}))}},setMap:function(a){OpenLayers.Layer.prototype.setMap.apply(this,arguments);if(!this.renderer){this.map.removeLayer(this)}else{this.renderer.map=this.map;this.renderer.setSize(this.map.getSize())}},afterAdd:function(){if(this.strategies){var c,b,a;for(b=0,a=this.strategies.length;b<a;b++){c=this.strategies[b];if(c.autoActivate){c.activate()}}}},removeMap:function(c){this.drawn=false;if(this.strategies){var d,b,a;for(b=0,a=this.strategies.length;b<a;b++){d=this.strategies[b];if(d.autoActivate){d.deactivate()}}}},onMapResize:function(){OpenLayers.Layer.prototype.onMapResize.apply(this,arguments);this.renderer.setSize(this.map.getSize())},moveTo:function(a,b,g){OpenLayers.Layer.prototype.moveTo.apply(this,arguments);var d=(OpenLayers.Renderer.NG&&this.renderer instanceof OpenLayers.Renderer.NG);if(d){g||this.renderer.updateDimensions(b)}else{var c=true;if(!g){this.renderer.root.style.visibility="hidden";this.div.style.left=-parseInt(this.map.layerContainerDiv.style.left)+"px";this.div.style.top=-parseInt(this.map.layerContainerDiv.style.top)+"px";var h=this.map.getExtent();c=this.renderer.setExtent(h,b);this.renderer.root.style.visibility="visible";if(OpenLayers.IS_GECKO===true){this.div.scrollLeft=this.div.scrollLeft}if(!b&&c){for(var e in this.unrenderedFeatures){var j=this.unrenderedFeatures[e];this.drawFeature(j)}}}}if(!this.drawn||(!d&&(b||!c))){this.drawn=true;var j;for(var e=0,f=this.features.length;e<f;e++){this.renderer.locked=(e!==(f-1));j=this.features[e];this.drawFeature(j)}}},redraw:function(){if(OpenLayers.Renderer.NG&&this.renderer instanceof OpenLayers.Renderer.NG){this.drawn=false}return OpenLayers.Layer.prototype.redraw.apply(this,arguments)},display:function(a){OpenLayers.Layer.prototype.display.apply(this,arguments);var b=this.div.style.display;if(b!=this.renderer.root.style.display){this.renderer.root.style.display=b}},addFeatures:function(b,k){if(!(OpenLayers.Util.isArray(b))){b=[b]}var h=!k||!k.silent;if(h){var a={features:b};var g=this.events.triggerEvent("beforefeaturesadded",a);if(g===false){return}b=a.features}var d=[];for(var c=0,f=b.length;c<f;c++){if(c!=(b.length-1)){this.renderer.locked=true}else{this.renderer.locked=false}var j=b[c];if(this.geometryType&&!(j.geometry instanceof this.geometryType)){var e=OpenLayers.i18n("componentShouldBe",{geomType:this.geometryType.prototype.CLASS_NAME});throw e}j.layer=this;if(!j.style&&this.style){j.style=OpenLayers.Util.extend({},this.style)}if(h){if(this.events.triggerEvent("beforefeatureadded",{feature:j})===false){continue}this.preFeatureInsert(j)}d.push(j);this.features.push(j);this.drawFeature(j);if(h){this.events.triggerEvent("featureadded",{feature:j});this.onFeatureInsert(j)}}if(h){this.events.triggerEvent("featuresadded",{features:d})}},removeFeatures:function(e,a){if(!e||e.length===0){return}if(e===this.features){return this.removeAllFeatures(a)}if(!(OpenLayers.Util.isArray(e))){e=[e]}if(e===this.selectedFeatures){e=e.slice()}var d=!a||!a.silent;if(d){this.events.triggerEvent("beforefeaturesremoved",{features:e})}for(var c=e.length-1;c>=0;c--){if(c!=0&&e[c-1].geometry){this.renderer.locked=true}else{this.renderer.locked=false}var b=e[c];delete this.unrenderedFeatures[b.id];if(d){this.events.triggerEvent("beforefeatureremoved",{feature:b})}this.features=OpenLayers.Util.removeItem(this.features,b);b.layer=null;if(b.geometry){this.renderer.eraseFeatures(b)}if(OpenLayers.Util.indexOf(this.selectedFeatures,b)!=-1){OpenLayers.Util.removeItem(this.selectedFeatures,b)}if(d){this.events.triggerEvent("featureremoved",{feature:b})}}if(d){this.events.triggerEvent("featuresremoved",{features:e})}},removeAllFeatures:function(a){var d=!a||!a.silent;var e=this.features;if(d){this.events.triggerEvent("beforefeaturesremoved",{features:e})}var c;for(var b=e.length-1;b>=0;b--){c=e[b];if(d){this.events.triggerEvent("beforefeatureremoved",{feature:c})}c.layer=null;if(d){this.events.triggerEvent("featureremoved",{feature:c})}}this.renderer.clear();this.features=[];this.unrenderedFeatures={};this.selectedFeatures=[];if(d){this.events.triggerEvent("featuresremoved",{features:e})}},destroyFeatures:function(d,a){var c=(d==undefined);if(c){d=this.features}if(d){this.removeFeatures(d,a);for(var b=d.length-1;b>=0;b--){d[b].destroy()}}},drawFeature:function(a,b){if(!this.drawn){return}if(typeof b!="object"){if(!b&&a.state===OpenLayers.State.DELETE){b="delete"}var c=b||a.renderIntent;b=a.style||this.style;if(!b){b=this.styleMap.createSymbolizer(a,c)}}var d=this.renderer.drawFeature(a,b);if(d===false||d===null){this.unrenderedFeatures[a.id]=a}else{delete this.unrenderedFeatures[a.id]}},eraseFeatures:function(a){this.renderer.eraseFeatures(a)},getFeatureFromEvent:function(a){if(!this.renderer){OpenLayers.Console.error(OpenLayers.i18n("getFeatureError"));return null}var b=null;var c=this.renderer.getFeatureIdFromEvent(a);if(c){if(typeof c==="string"){b=this.getFeatureById(c)}else{b=c}}return b},getFeatureBy:function(e,d){var c=null;for(var b=0,a=this.features.length;b<a;++b){if(this.features[b][e]==d){c=this.features[b];break}}return c},getFeatureById:function(a){return this.getFeatureBy("id",a)},getFeatureByFid:function(a){return this.getFeatureBy("fid",a)},getFeaturesByAttribute:function(d,e){var c,b,a=this.features.length,f=[];for(c=0;c<a;c++){b=this.features[c];if(b&&b.attributes){if(b.attributes[d]===e){f.push(b)}}}return f},onFeatureInsert:function(a){},preFeatureInsert:function(a){},getDataExtent:function(){var b=null;var d=this.features;if(d&&(d.length>0)){var e=null;for(var c=0,a=d.length;c<a;c++){e=d[c].geometry;if(e){if(b===null){b=new OpenLayers.Bounds()}b.extend(e.getBounds())}}}return b},CLASS_NAME:"OpenLayers.Layer.Vector"});OpenLayers.Layer.PointTrack=OpenLayers.Class(OpenLayers.Layer.Vector,{dataFrom:null,styleFrom:null,initialize:function(b,a){OpenLayers.Layer.Vector.prototype.initialize.apply(this,arguments)},addNodes:function(g,l){if(g.length<2){OpenLayers.Console.error("At least two point features have to be added to createa line from");return}var m=new Array(g.length-1);var h,b,j;for(var d=0,f=g.length;d<f;d++){h=g[d];j=h.geometry;if(!j){var e=h.lonlat;j=new OpenLayers.Geometry.Point(e.lon,e.lat)}else{if(j.CLASS_NAME!="OpenLayers.Geometry.Point"){OpenLayers.Console.error("Only features with point geometries are supported.");return}}if(d>0){var c=(this.dataFrom!=null)?(g[d+this.dataFrom].data||g[d+this.dataFrom].attributes):null;var a=(this.styleFrom!=null)?(g[d+this.styleFrom].style):null;var k=new OpenLayers.Geometry.LineString([b,j]);m[d-1]=new OpenLayers.Feature.Vector(k,c,a)}b=j}this.addFeatures(m,l)},CLASS_NAME:"OpenLayers.Layer.PointTrack"});OpenLayers.Layer.PointTrack.SOURCE_NODE=-1;OpenLayers.Layer.PointTrack.TARGET_NODE=0;OpenLayers.Layer.PointTrack.dataFrom={SOURCE_NODE:-1,TARGET_NODE:0};OpenLayers.Protocol.WFS=function(b){b=OpenLayers.Util.applyDefaults(b,OpenLayers.Protocol.WFS.DEFAULTS);var a=OpenLayers.Protocol.WFS["v"+b.version.replace(/\./g,"_")];if(!a){throw"Unsupported WFS version: "+b.version}return new a(b)};OpenLayers.Protocol.WFS.fromWMSLayer=function(d,c){var a,e;var g=d.params.LAYERS;var f=(OpenLayers.Util.isArray(g)?g[0]:g).split(":");if(f.length>1){e=f[0]}a=f.pop();var b={url:d.url,featureType:a,featurePrefix:e,srsName:d.projection&&d.projection.getCode()||d.map&&d.map.getProjectionObject().getCode(),version:"1.1.0"};return new OpenLayers.Protocol.WFS(OpenLayers.Util.applyDefaults(c,b))};OpenLayers.Protocol.WFS.DEFAULTS={version:"1.0.0"};OpenLayers.Layer.Markers=OpenLayers.Class(OpenLayers.Layer,{isBaseLayer:false,markers:null,drawn:false,initialize:function(b,a){OpenLayers.Layer.prototype.initialize.apply(this,arguments);this.markers=[]},destroy:function(){this.clearMarkers();this.markers=null;OpenLayers.Layer.prototype.destroy.apply(this,arguments)},setOpacity:function(b){if(b!=this.opacity){this.opacity=b;for(var c=0,a=this.markers.length;c<a;c++){this.markers[c].setOpacity(this.opacity)}}},moveTo:function(d,b,e){OpenLayers.Layer.prototype.moveTo.apply(this,arguments);if(b||!this.drawn){for(var c=0,a=this.markers.length;c<a;c++){this.drawMarker(this.markers[c])}this.drawn=true}},addMarker:function(a){this.markers.push(a);if(this.opacity!=null){a.setOpacity(this.opacity)}if(this.map&&this.map.getExtent()){a.map=this.map;this.drawMarker(a)}},removeMarker:function(a){if(this.markers&&this.markers.length){OpenLayers.Util.removeItem(this.markers,a);a.erase()}},clearMarkers:function(){if(this.markers!=null){while(this.markers.length>0){this.removeMarker(this.markers[0])}}},drawMarker:function(a){var b=this.map.getLayerPxFromLonLat(a.lonlat);if(b==null){a.display(false)}else{if(!a.isDrawn()){var c=a.draw(b);this.div.appendChild(c)}else{if(a.icon){a.icon.moveTo(b)}}}},getDataExtent:function(){var b=null;if(this.markers&&(this.markers.length>0)){var b=new OpenLayers.Bounds();for(var d=0,a=this.markers.length;d<a;d++){var c=this.markers[d];b.extend(c.lonlat)}}return b},CLASS_NAME:"OpenLayers.Layer.Markers"});OpenLayers.Control.Pan=OpenLayers.Class(OpenLayers.Control,{slideFactor:50,slideRatio:null,direction:null,type:OpenLayers.Control.TYPE_BUTTON,initialize:function(b,a){this.direction=b;this.CLASS_NAME+=this.direction;OpenLayers.Control.prototype.initialize.apply(this,[a])},trigger:function(){var a=OpenLayers.Function.bind(function(b){return this.slideRatio?this.map.getSize()[b]*this.slideRatio:this.slideFactor},this);switch(this.direction){case OpenLayers.Control.Pan.NORTH:this.map.pan(0,-a("h"));break;case OpenLayers.Control.Pan.SOUTH:this.map.pan(0,a("h"));break;case OpenLayers.Control.Pan.WEST:this.map.pan(-a("w"),0);break;case OpenLayers.Control.Pan.EAST:this.map.pan(a("w"),0);break}},CLASS_NAME:"OpenLayers.Control.Pan"});OpenLayers.Control.Pan.NORTH="North";OpenLayers.Control.Pan.SOUTH="South";OpenLayers.Control.Pan.EAST="East";OpenLayers.Control.Pan.WEST="West";OpenLayers.Format.CSWGetDomain=function(b){b=OpenLayers.Util.applyDefaults(b,OpenLayers.Format.CSWGetDomain.DEFAULTS);var a=OpenLayers.Format.CSWGetDomain["v"+b.version.replace(/\./g,"_")];if(!a){throw"Unsupported CSWGetDomain version: "+b.version}return new a(b)};OpenLayers.Format.CSWGetDomain.DEFAULTS={version:"2.0.2"};OpenLayers.Format.CSWGetDomain.v2_0_2=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance",csw:"http://www.opengis.net/cat/csw/2.0.2"},defaultPrefix:"csw",version:"2.0.2",schemaLocation:"http://www.opengis.net/cat/csw/2.0.2 http://schemas.opengis.net/csw/2.0.2/CSW-discovery.xsd",PropertyName:null,ParameterName:null,initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(a){if(typeof a=="string"){a=OpenLayers.Format.XML.prototype.read.apply(this,[a])}if(a&&a.nodeType==9){a=a.documentElement}var b={};this.readNode(a,b);return b},readers:{csw:{GetDomainResponse:function(a,b){this.readChildNodes(a,b)},DomainValues:function(d,e){if(!(OpenLayers.Util.isArray(e.DomainValues))){e.DomainValues=[]}var b=d.attributes;var f={};for(var c=0,a=b.length;c<a;++c){f[b[c].name]=b[c].nodeValue}this.readChildNodes(d,f);e.DomainValues.push(f)},PropertyName:function(a,b){b.PropertyName=this.getChildValue(a)},ParameterName:function(a,b){b.ParameterName=this.getChildValue(a)},ListOfValues:function(a,b){if(!(OpenLayers.Util.isArray(b.ListOfValues))){b.ListOfValues=[]}this.readChildNodes(a,b.ListOfValues)},Value:function(d,f){var b=d.attributes;var e={};for(var c=0,a=b.length;c<a;++c){e[b[c].name]=b[c].nodeValue}e.value=this.getChildValue(d);f.push({Value:e})},ConceptualScheme:function(a,b){b.ConceptualScheme={};this.readChildNodes(a,b.ConceptualScheme)},Name:function(a,b){b.Name=this.getChildValue(a)},Document:function(a,b){b.Document=this.getChildValue(a)},Authority:function(a,b){b.Authority=this.getChildValue(a)},RangeOfValues:function(a,b){b.RangeOfValues={};this.readChildNodes(a,b.RangeOfValues)},MinValue:function(d,f){var b=d.attributes;var e={};for(var c=0,a=b.length;c<a;++c){e[b[c].name]=b[c].nodeValue}e.value=this.getChildValue(d);f.MinValue=e},MaxValue:function(d,f){var b=d.attributes;var e={};for(var c=0,a=b.length;c<a;++c){e[b[c].name]=b[c].nodeValue}e.value=this.getChildValue(d);f.MaxValue=e}}},write:function(a){var b=this.writeNode("csw:GetDomain",a);return OpenLayers.Format.XML.prototype.write.apply(this,[b])},writers:{csw:{GetDomain:function(a){var b=this.createElementNSPlus("csw:GetDomain",{attributes:{service:"CSW",version:this.version}});if(a.PropertyName||this.PropertyName){this.writeNode("csw:PropertyName",a.PropertyName||this.PropertyName,b)}else{if(a.ParameterName||this.ParameterName){this.writeNode("csw:ParameterName",a.ParameterName||this.ParameterName,b)}}this.readChildNodes(b,a);return b},PropertyName:function(b){var a=this.createElementNSPlus("csw:PropertyName",{value:b});return a},ParameterName:function(b){var a=this.createElementNSPlus("csw:ParameterName",{value:b});return a}}},CLASS_NAME:"OpenLayers.Format.CSWGetDomain.v2_0_2"});OpenLayers.Geometry.Surface=OpenLayers.Class(OpenLayers.Geometry,{initialize:function(){OpenLayers.Geometry.prototype.initialize.apply(this,arguments)},CLASS_NAME:"OpenLayers.Geometry.Surface"});OpenLayers.Format.ArcXML.Features=OpenLayers.Class(OpenLayers.Format.XML,{initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(c){var b=new OpenLayers.Format.ArcXML();var a=b.read(c);return a.features.feature}});OpenLayers.Control.Snapping=OpenLayers.Class(OpenLayers.Control,{EVENT_TYPES:["beforesnap","snap","unsnap"],DEFAULTS:{tolerance:10,node:true,edge:true,vertex:true},greedy:true,precedence:["node","vertex","edge"],resolution:null,geoToleranceCache:null,layer:null,feature:null,point:null,initialize:function(a){Array.prototype.push.apply(this.EVENT_TYPES,OpenLayers.Control.prototype.EVENT_TYPES);OpenLayers.Control.prototype.initialize.apply(this,[a]);this.options=a||{};if(this.options.layer){this.setLayer(this.options.layer)}var b=OpenLayers.Util.extend({},this.options.defaults);this.defaults=OpenLayers.Util.applyDefaults(b,this.DEFAULTS);this.setTargets(this.options.targets);if(this.targets.length===0&&this.layer){this.addTargetLayer(this.layer)}this.geoToleranceCache={}},setLayer:function(a){if(this.active){this.deactivate();this.layer=a;this.activate()}else{this.layer=a}},setTargets:function(b){this.targets=[];if(b&&b.length){var d;for(var c=0,a=b.length;c<a;++c){d=b[c];if(d instanceof OpenLayers.Layer.Vector){this.addTargetLayer(d)}else{this.addTarget(d)}}}},addTargetLayer:function(a){this.addTarget({layer:a})},addTarget:function(a){a=OpenLayers.Util.applyDefaults(a,this.defaults);a.nodeTolerance=a.nodeTolerance||a.tolerance;a.vertexTolerance=a.vertexTolerance||a.tolerance;a.edgeTolerance=a.edgeTolerance||a.tolerance;this.targets.push(a)},removeTargetLayer:function(b){var c;for(var a=this.targets.length-1;a>=0;--a){c=this.targets[a];if(c.layer===b){this.removeTarget(c)}}},removeTarget:function(a){return OpenLayers.Util.removeItem(this.targets,a)},activate:function(){var a=OpenLayers.Control.prototype.activate.call(this);if(a){if(this.layer&&this.layer.events){this.layer.events.on({sketchstarted:this.onSketchModified,sketchmodified:this.onSketchModified,vertexmodified:this.onVertexModified,scope:this})}}return a},deactivate:function(){var a=OpenLayers.Control.prototype.deactivate.call(this);if(a){if(this.layer&&this.layer.events){this.layer.events.un({sketchstarted:this.onSketchModified,sketchmodified:this.onSketchModified,vertexmodified:this.onVertexModified,scope:this})}}this.feature=null;this.point=null;return a},onSketchModified:function(a){this.feature=a.feature;this.considerSnapping(a.vertex,a.vertex)},onVertexModified:function(a){this.feature=a.feature;var b=this.layer.map.getLonLatFromViewPortPx(a.pixel);this.considerSnapping(a.vertex,new OpenLayers.Geometry.Point(b.lon,b.lat))},considerSnapping:function(h,d){var a={rank:Number.POSITIVE_INFINITY,dist:Number.POSITIVE_INFINITY,x:null,y:null};var c=false;var j,f;for(var b=0,e=this.targets.length;b<e;++b){f=this.targets[b];j=this.testTarget(f,d);if(j){if(this.greedy){a=j;a.target=f;c=true;break}else{if((j.rank<a.rank)||(j.rank===a.rank&&j.dist<a.dist)){a=j;a.target=f;c=true}}}}if(c){var g=this.events.triggerEvent("beforesnap",{point:h,x:a.x,y:a.y,distance:a.dist,layer:a.target.layer,snapType:this.precedence[a.rank]});if(g!==false){h.x=a.x;h.y=a.y;this.point=h;this.events.triggerEvent("snap",{point:h,snapType:this.precedence[a.rank],layer:a.target.layer,distance:a.dist})}else{c=false}}if(this.point&&!c){h.x=d.x;h.y=d.y;this.point=null;this.events.triggerEvent("unsnap",{point:h})}},testTarget:function(z,f){var r=this.layer.map.getResolution();if("minResolution" in z){if(r<z.minResolution){return null}}if("maxResolution" in z){if(r>=z.maxResolution){return null}}var x={node:this.getGeoTolerance(z.nodeTolerance,r),vertex:this.getGeoTolerance(z.vertexTolerance,r),edge:this.getGeoTolerance(z.edgeTolerance,r)};var g=Math.max(x.node,x.vertex,x.edge);var h={rank:Number.POSITIVE_INFINITY,dist:Number.POSITIVE_INFINITY};var e=false;var c=z.layer.features;var b,a,d,y,o,p,n;var m=this.precedence.length;var l=new OpenLayers.LonLat(f.x,f.y);for(var v=0,w=c.length;v<w;++v){b=c[v];if(b!==this.feature&&!b._sketch&&b.state!==OpenLayers.State.DELETE&&(!z.filter||z.filter.evaluate(b.attributes))){if(b.atPoint(l,g,g)){for(var u=0,q=Math.min(h.rank+1,m);u<q;++u){a=this.precedence[u];if(z[a]){if(a==="edge"){o=b.geometry.distanceTo(f,{details:true});p=o.distance;if(p<=x[a]&&p<h.dist){h={rank:u,dist:p,x:o.x0,y:o.y0};e=true;break}}else{d=b.geometry.getVertices(a==="node");n=false;for(var t=0,s=d.length;t<s;++t){y=d[t];p=y.distanceTo(f);if(p<=x[a]&&(u<h.rank||(u===h.rank&&p<h.dist))){h={rank:u,dist:p,x:y.x,y:y.y};e=true;n=true}}if(n){break}}}}}}}return e?h:null},getGeoTolerance:function(a,b){if(b!==this.resolution){this.resolution=b;this.geoToleranceCache={}}var c=this.geoToleranceCache[a];if(c===undefined){c=a*b;this.geoToleranceCache[a]=c}return c},destroy:function(){if(this.active){this.deactivate()}delete this.layer;delete this.targets;OpenLayers.Control.prototype.destroy.call(this)},CLASS_NAME:"OpenLayers.Control.Snapping"});OpenLayers.Layer.WMS=OpenLayers.Class(OpenLayers.Layer.Grid,{DEFAULT_PARAMS:{service:"WMS",version:"1.1.1",request:"GetMap",styles:"",format:"image/jpeg"},reproject:false,isBaseLayer:true,encodeBBOX:false,noMagic:false,yx:{"EPSG:4326":true},initialize:function(d,c,e,b){var a=[];e=OpenLayers.Util.upperCaseObject(e);if(parseFloat(e.VERSION)>=1.3&&!e.EXCEPTIONS){e.EXCEPTIONS="INIMAGE"}a.push(d,c,e,b);OpenLayers.Layer.Grid.prototype.initialize.apply(this,a);OpenLayers.Util.applyDefaults(this.params,OpenLayers.Util.upperCaseObject(this.DEFAULT_PARAMS));if(!this.noMagic&&this.params.TRANSPARENT&&this.params.TRANSPARENT.toString().toLowerCase()=="true"){if((b==null)||(!b.isBaseLayer)){this.isBaseLayer=false}if(this.params.FORMAT=="image/jpeg"){this.params.FORMAT=OpenLayers.Util.alphaHack()?"image/gif":"image/png"}}},destroy:function(){OpenLayers.Layer.Grid.prototype.destroy.apply(this,arguments)},clone:function(a){if(a==null){a=new OpenLayers.Layer.WMS(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},reverseAxisOrder:function(){return(parseFloat(this.params.VERSION)>=1.3&&!!this.yx[this.map.getProjectionObject().getCode()])},getURL:function(c){c=this.adjustBounds(c);var d=this.getImageSize();var e={};var b=this.reverseAxisOrder();e.BBOX=this.encodeBBOX?c.toBBOX(null,b):c.toArray(b);e.WIDTH=d.w;e.HEIGHT=d.h;var a=this.getFullRequestString(e);return a},mergeNewParams:function(c){var b=OpenLayers.Util.upperCaseObject(c);var a=[b];return OpenLayers.Layer.Grid.prototype.mergeNewParams.apply(this,a)},getFullRequestString:function(e,c){var b=this.map.getProjectionObject();var a=this.projection&&this.projection.equals(b)?this.projection.getCode():b.getCode();var d=(a=="none")?null:a;if(parseFloat(this.params.VERSION)>=1.3){this.params.CRS=d}else{this.params.SRS=d}if(typeof this.params.TRANSPARENT=="boolean"){e.TRANSPARENT=this.params.TRANSPARENT?"TRUE":"FALSE"}return OpenLayers.Layer.Grid.prototype.getFullRequestString.apply(this,arguments)},CLASS_NAME:"OpenLayers.Layer.WMS"});OpenLayers.Layer.WMS.Untiled=OpenLayers.Class(OpenLayers.Layer.WMS,{singleTile:true,initialize:function(c,b,e,a){OpenLayers.Layer.WMS.prototype.initialize.apply(this,arguments);var d="The OpenLayers.Layer.WMS.Untiled class is deprecated and will be removed in 3.0. Instead, you should use the normal OpenLayers.Layer.WMS class, passing it the option 'singleTile' as true.";OpenLayers.Console.warn(d)},clone:function(a){if(a==null){a=new OpenLayers.Layer.WMS.Untiled(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.WMS.prototype.clone.apply(this,[a]);return a},CLASS_NAME:"OpenLayers.Layer.WMS.Untiled"});OpenLayers.Date={toISOString:(function(){if("toISOString" in Date.prototype){return function(b){return b.toISOString()}}else{function a(c,b){var d=c+"";while(d.length<b){d="0"+d}return d}return function(b){var c;if(isNaN(b.getTime())){c="Invalid Date"}else{c=b.getUTCFullYear()+"-"+a(b.getUTCMonth()+1,2)+"-"+a(b.getUTCDate(),2)+"T"+a(b.getUTCHours(),2)+":"+a(b.getUTCMinutes(),2)+":"+a(b.getUTCSeconds(),2)+"."+a(b.getUTCMilliseconds(),3)+"Z"}return c}}})(),parse:function(j){var b;var h=j.match(/^(?:(\d{4})(?:-(\d{2})(?:-(\d{2}))?)?)?(?:T(\d{1,2}):(\d{2}):(\d{2}(?:\.\d+)?)(Z|(?:[+-]\d{1,2}(?::(\d{2}))?)))?$/);if(h&&(h[1]||h[7])){var k=parseInt(h[1],10)||0;var i=(parseInt(h[2],10)-1)||0;var m=parseInt(h[3],10)||1;b=new Date(Date.UTC(k,i,m));var l=h[7];if(l){var n=parseInt(h[4],10);var d=parseInt(h[5],10);var a=parseFloat(h[6]);var o=a|0;var c=Math.round(1000*(a-o));b.setUTCHours(n,d,o,c);if(l!=="Z"){var g=parseInt(l,10);var f=parseInt(h[8],10)||0;var e=-1000*(60*(g*60)+f*60);b=new Date(b.getTime()+e)}}}else{b=new Date("invalid")}return b}};(function(){var g=window.XMLHttpRequest;var a=!!window.controllers,j=window.document.all&&!window.opera,k=j&&window.navigator.userAgent.match(/MSIE 7.0/);function d(){this._object=g&&!k?new g:new window.ActiveXObject("Microsoft.XMLHTTP");this._listeners=[]}function c(){return new d}c.prototype=d.prototype;if(a&&g.wrapped){c.wrapped=g.wrapped}c.UNSENT=0;c.OPENED=1;c.HEADERS_RECEIVED=2;c.LOADING=3;c.DONE=4;c.prototype.readyState=c.UNSENT;c.prototype.responseText="";c.prototype.responseXML=null;c.prototype.status=0;c.prototype.statusText="";c.prototype.priority="NORMAL";c.prototype.onreadystatechange=null;c.onreadystatechange=null;c.onopen=null;c.onsend=null;c.onabort=null;c.prototype.open=function(o,r,n,s,m){delete this._headers;if(arguments.length<3){n=true}this._async=n;var q=this,p=this.readyState,l;if(j&&n){l=function(){if(p!=c.DONE){e(q);q.abort()}};window.attachEvent("onunload",l)}if(c.onopen){c.onopen.apply(this,arguments)}if(arguments.length>4){this._object.open(o,r,n,s,m)}else{if(arguments.length>3){this._object.open(o,r,n,s)}else{this._object.open(o,r,n)}}this.readyState=c.OPENED;b(this);this._object.onreadystatechange=function(){if(a&&!n){return}q.readyState=q._object.readyState;h(q);if(q._aborted){q.readyState=c.UNSENT;return}if(q.readyState==c.DONE){delete q._data;e(q);if(j&&n){window.detachEvent("onunload",l)}}if(p!=q.readyState){b(q)}p=q.readyState}};function f(l){l._object.send(l._data);if(a&&!l._async){l.readyState=c.OPENED;h(l);while(l.readyState<c.DONE){l.readyState++;b(l);if(l._aborted){return}}}}c.prototype.send=function(l){if(c.onsend){c.onsend.apply(this,arguments)}if(!arguments.length){l=null}if(l&&l.nodeType){l=window.XMLSerializer?new window.XMLSerializer().serializeToString(l):l.xml;if(!oRequest._headers["Content-Type"]){oRequest._object.setRequestHeader("Content-Type","application/xml")}}this._data=l;f(this)};c.prototype.abort=function(){if(c.onabort){c.onabort.apply(this,arguments)}if(this.readyState>c.UNSENT){this._aborted=true}this._object.abort();e(this);this.readyState=c.UNSENT;delete this._data};c.prototype.getAllResponseHeaders=function(){return this._object.getAllResponseHeaders()};c.prototype.getResponseHeader=function(l){return this._object.getResponseHeader(l)};c.prototype.setRequestHeader=function(l,m){if(!this._headers){this._headers={}}this._headers[l]=m;return this._object.setRequestHeader(l,m)};c.prototype.addEventListener=function(o,n,m){for(var l=0,p;p=this._listeners[l];l++){if(p[0]==o&&p[1]==n&&p[2]==m){return}}this._listeners.push([o,n,m])};c.prototype.removeEventListener=function(o,n,m){for(var l=0,p;p=this._listeners[l];l++){if(p[0]==o&&p[1]==n&&p[2]==m){break}}if(p){this._listeners.splice(l,1)}};c.prototype.dispatchEvent=function(m){var n={type:m.type,target:this,currentTarget:this,eventPhase:2,bubbles:m.bubbles,cancelable:m.cancelable,timeStamp:m.timeStamp,stopPropagation:function(){},preventDefault:function(){},initEvent:function(){}};if(n.type=="readystatechange"&&this.onreadystatechange){(this.onreadystatechange.handleEvent||this.onreadystatechange).apply(this,[n])}for(var l=0,o;o=this._listeners[l];l++){if(o[0]==n.type&&!o[2]){(o[1].handleEvent||o[1]).apply(this,[n])}}};c.prototype.toString=function(){return"[object XMLHttpRequest]"};c.toString=function(){return"[XMLHttpRequest]"};function b(l){if(c.onreadystatechange){c.onreadystatechange.apply(l)}l.dispatchEvent({type:"readystatechange",bubbles:false,cancelable:false,timeStamp:new Date+0})}function i(n){var m=n.responseXML,l=n.responseText;if(j&&l&&m&&!m.documentElement&&n.getResponseHeader("Content-Type").match(/[^\/]+\/[^\+]+\+xml/)){m=new window.ActiveXObject("Microsoft.XMLDOM");m.async=false;m.validateOnParse=false;m.loadXML(l)}if(m){if((j&&m.parseError!=0)||!m.documentElement||(m.documentElement&&m.documentElement.tagName=="parsererror")){return null}}return m}function h(l){try{l.responseText=l._object.responseText}catch(m){}try{l.responseXML=i(l._object)}catch(m){}try{l.status=l._object.status}catch(m){}try{l.statusText=l._object.statusText}catch(m){}}function e(l){l._object.onreadystatechange=new window.Function}if(!window.Function.prototype.apply){window.Function.prototype.apply=function(l,m){if(!m){m=[]}l.__func=this;l.__func(m[0],m[1],m[2],m[3],m[4]);delete l.__func}}OpenLayers.Request.XMLHttpRequest=c})();OpenLayers.Format.KML=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{kml:"http://www.opengis.net/kml/2.2",gx:"http://www.google.com/kml/ext/2.2"},kmlns:"http://earth.google.com/kml/2.0",placemarksDesc:"No description available",foldersName:"OpenLayers export",foldersDesc:"Exported on "+new Date(),extractAttributes:true,extractStyles:false,extractTracks:false,trackAttributes:null,internalns:null,features:null,styles:null,styleBaseUrl:"",fetched:null,maxDepth:0,initialize:function(a){this.regExes={trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g),kmlColor:(/(\w{2})(\w{2})(\w{2})(\w{2})/),kmlIconPalette:(/root:\/\/icons\/palette-(\d+)(\.\w+)/),straightBracket:(/\$\[(.*?)\]/g)};this.externalProjection=new OpenLayers.Projection("EPSG:4326");OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(b){this.features=[];this.styles={};this.fetched={};var a={depth:0,styleBaseUrl:this.styleBaseUrl};return this.parseData(b,a)},parseData:function(g,c){if(typeof g=="string"){g=OpenLayers.Format.XML.prototype.read.apply(this,[g])}var e=["Link","NetworkLink","Style","StyleMap","Placemark"];for(var d=0,a=e.length;d<a;++d){var f=e[d];var b=this.getElementsByTagNameNS(g,"*",f);if(b.length==0){continue}switch(f.toLowerCase()){case"link":case"networklink":this.parseLinks(b,c);break;case"style":if(this.extractStyles){this.parseStyles(b,c)}break;case"stylemap":if(this.extractStyles){this.parseStyleMaps(b,c)}break;case"placemark":this.parseFeatures(b,c);break}}return this.features},parseLinks:function(c,d){if(d.depth>=this.maxDepth){return false}var g=OpenLayers.Util.extend({},d);g.depth++;for(var e=0,a=c.length;e<a;e++){var b=this.parseProperty(c[e],"*","href");if(b&&!this.fetched[b]){this.fetched[b]=true;var f=this.fetchLink(b);if(f){this.parseData(f,g)}}}},fetchLink:function(a){var b=OpenLayers.Request.GET({url:a,async:false});if(b){return b.responseText}},parseStyles:function(b,c){for(var e=0,a=b.length;e<a;e++){var f=this.parseStyle(b[e]);if(f){var d=(c.styleBaseUrl||"")+"#"+f.id;this.styles[d]=f}}},parseKmlColor:function(b){var a=null;if(b){var c=b.match(this.regExes.kmlColor);if(c){a={color:"#"+c[4]+c[3]+c[2],opacity:parseInt(c[1],16)/255}}}return a},parseStyle:function(A){var I={};var r=["LineStyle","PolyStyle","IconStyle","BalloonStyle","LabelStyle"];var e,l,L,g,d;for(var F=0,H=r.length;F<H;++F){e=r[F];l=this.getElementsByTagNameNS(A,"*",e)[0];if(!l){continue}switch(e.toLowerCase()){case"linestyle":var c=this.parseProperty(l,"*","color");var C=this.parseKmlColor(c);if(C){I.strokeColor=C.color;I.strokeOpacity=C.opacity}var z=this.parseProperty(l,"*","width");if(z){I.strokeWidth=z}break;case"polystyle":var c=this.parseProperty(l,"*","color");var C=this.parseKmlColor(c);if(C){I.fillOpacity=C.opacity;I.fillColor=C.color}var D=this.parseProperty(l,"*","fill");if(D=="0"){I.fillColor="none"}var j=this.parseProperty(l,"*","outline");if(j=="0"){I.strokeWidth="0"}break;case"iconstyle":var N=parseFloat(this.parseProperty(l,"*","scale")||1);var z=32*N;var u=32*N;var M=this.getElementsByTagNameNS(l,"*","Icon")[0];if(M){var E=this.parseProperty(M,"*","href");if(E){var q=this.parseProperty(M,"*","w");var G=this.parseProperty(M,"*","h");var f="http://maps.google.com/mapfiles/kml";if(OpenLayers.String.startsWith(E,f)&&!q&&!G){q=64;G=64;N=N/2}q=q||G;G=G||q;if(q){z=parseInt(q)*N}if(G){u=parseInt(G)*N}var b=E.match(this.regExes.kmlIconPalette);if(b){var J=b[1];var t=b[2];var p=this.parseProperty(M,"*","x");var o=this.parseProperty(M,"*","y");var n=p?p/32:0;var m=o?(7-o/32):7;var k=m*8+n;E="http://maps.google.com/mapfiles/kml/pal"+J+"/icon"+k+t}I.graphicOpacity=1;I.externalGraphic=E}}var s=this.getElementsByTagNameNS(l,"*","hotSpot")[0];if(s){var p=parseFloat(s.getAttribute("x"));var o=parseFloat(s.getAttribute("y"));var B=s.getAttribute("xunits");if(B=="pixels"){I.graphicXOffset=-p*N}else{if(B=="insetPixels"){I.graphicXOffset=-z+(p*N)}else{if(B=="fraction"){I.graphicXOffset=-z*p}}}var K=s.getAttribute("yunits");if(K=="pixels"){I.graphicYOffset=-u+(o*N)+1}else{if(K=="insetPixels"){I.graphicYOffset=-(o*N)+1}else{if(K=="fraction"){I.graphicYOffset=-u*(1-o)+1}}}}I.graphicWidth=z;I.graphicHeight=u;break;case"balloonstyle":var a=OpenLayers.Util.getXmlNodeValue(l);if(a){I.balloonStyle=a.replace(this.regExes.straightBracket,"${$1}")}break;case"labelstyle":var c=this.parseProperty(l,"*","color");var C=this.parseKmlColor(c);if(C){I.fontColor=C.color;I.fontOpacity=C.opacity}break;default:}}if(!I.strokeColor&&I.fillColor){I.strokeColor=I.fillColor}var v=A.getAttribute("id");if(v&&I){I.id=v}return I},parseStyleMaps:function(a,n){for(var g=0,h=a.length;g<h;g++){var d=a[g];var c=this.getElementsByTagNameNS(d,"*","Pair");var b=d.getAttribute("id");for(var f=0,m=c.length;f<m;f++){var e=c[f];var l=this.parseProperty(e,"*","key");var k=this.parseProperty(e,"*","styleUrl");if(k&&l=="normal"){this.styles[(n.styleBaseUrl||"")+"#"+b]=this.styles[(n.styleBaseUrl||"")+k]}if(k&&l=="highlight"){}}}},parseFeatures:function(b,m){var f=[];for(var g=0,h=b.length;g<h;g++){var c=b[g];var l=this.parseFeature.apply(this,[c]);if(l){if(this.extractStyles&&l.attributes&&l.attributes.styleUrl){l.style=this.getStyle(l.attributes.styleUrl,m)}if(this.extractStyles){var k=this.getElementsByTagNameNS(c,"*","Style")[0];if(k){var e=this.parseStyle(k);if(e){l.style=OpenLayers.Util.extend(l.style,e)}}}if(this.extractTracks){var j=this.getElementsByTagNameNS(c,this.namespaces.gx,"Track");if(j&&j.length>0){var d=j[0];var a={features:[],feature:l};this.readNode(d,a);if(a.features.length>0){f.push.apply(f,a.features)}}}else{f.push(l)}}else{throw"Bad Placemark: "+g}}this.features=this.features.concat(f)},readers:{kml:{when:function(b,a){a.whens.push(OpenLayers.Date.parse(this.getChildValue(b)))},_trackPointAttribute:function(c,a){var b=c.nodeName.split(":").pop();a.attributes[b].push(this.getChildValue(c))}},gx:{Track:function(c,b){var e={whens:[],points:[],angles:[]};if(this.trackAttributes){var a;e.attributes={};for(var f=0,m=this.trackAttributes.length;f<m;++f){a=this.trackAttributes[f];e.attributes[a]=[];if(!(a in this.readers.kml)){this.readers.kml[a]=this.readers.kml._trackPointAttribute}}}this.readChildNodes(c,e);if(e.whens.length!==e.points.length){throw new Error("gx:Track with unequal number of when ("+e.whens.length+") and gx:coord ("+e.points.length+") elements.")}var k=e.angles.length>0;if(k&&e.whens.length!==e.angles.length){throw new Error("gx:Track with unequal number of when ("+e.whens.length+") and gx:angles ("+e.angles.length+") elements.")}var n,l,h;for(var f=0,m=e.whens.length;f<m;++f){n=b.feature.clone();n.fid=b.feature.fid||b.feature.id;l=e.points[f];n.geometry=l;if("z" in l){n.attributes.altitude=l.z}if(this.internalProjection&&this.externalProjection){n.geometry.transform(this.externalProjection,this.internalProjection)}if(this.trackAttributes){for(var d=0,g=this.trackAttributes.length;d<g;++d){n.attributes[a]=e.attributes[this.trackAttributes[d]][f]}}n.attributes.when=e.whens[f];n.attributes.trackId=b.feature.id;if(k){h=e.angles[f];n.attributes.heading=parseFloat(h[0]);n.attributes.tilt=parseFloat(h[1]);n.attributes.roll=parseFloat(h[2])}b.features.push(n)}},coord:function(c,b){var e=this.getChildValue(c);var d=e.replace(this.regExes.trimSpace,"").split(/\s+/);var a=new OpenLayers.Geometry.Point(d[0],d[1]);if(d.length>2){a.z=parseFloat(d[2])}b.points.push(a)},angles:function(b,a){var d=this.getChildValue(b);var c=d.replace(this.regExes.trimSpace,"").split(/\s+/);a.angles.push(c)}}},parseFeature:function(b){var c=["MultiGeometry","Polygon","LineString","Point"];var j,e,k,a;for(var g=0,h=c.length;g<h;++g){j=c[g];this.internalns=b.namespaceURI?b.namespaceURI:this.kmlns;e=this.getElementsByTagNameNS(b,this.internalns,j);if(e.length>0){var a=this.parseGeometry[j.toLowerCase()];if(a){k=a.apply(this,[e[0]]);if(this.internalProjection&&this.externalProjection){k.transform(this.externalProjection,this.internalProjection)}}else{OpenLayers.Console.error(OpenLayers.i18n("unsupportedGeometryType",{geomType:j}))}break}}var f;if(this.extractAttributes){f=this.parseAttributes(b)}var l=new OpenLayers.Feature.Vector(k,f);var d=b.getAttribute("id")||b.getAttribute("name");if(d!=null){l.fid=d}return l},getStyle:function(b,a){var c=OpenLayers.Util.removeTail(b);var f=OpenLayers.Util.extend({},a);f.depth++;f.styleBaseUrl=c;if(!this.styles[b]&&!OpenLayers.String.startsWith(b,"#")&&f.depth<=this.maxDepth&&!this.fetched[c]){var e=this.fetchLink(c);if(e){this.parseData(e,f)}}var d=OpenLayers.Util.extend({},this.styles[b]);return d},parseGeometry:{point:function(d){var c=this.getElementsByTagNameNS(d,this.internalns,"coordinates");var e=[];if(c.length>0){var b=c[0].firstChild.nodeValue;b=b.replace(this.regExes.removeSpace,"");e=b.split(",")}var a=null;if(e.length>1){if(e.length==2){e[2]=null}a=new OpenLayers.Geometry.Point(e[0],e[1],e[2])}else{throw"Bad coordinate string: "+b}return a},linestring:function(c,e){var d=this.getElementsByTagNameNS(c,this.internalns,"coordinates");var l=null;if(d.length>0){var b=this.getChildValue(d[0]);b=b.replace(this.regExes.trimSpace,"");b=b.replace(this.regExes.trimComma,",");var a=b.split(this.regExes.splitSpace);var h=a.length;var k=new Array(h);var j,g;for(var f=0;f<h;++f){j=a[f].split(",");g=j.length;if(g>1){if(j.length==2){j[2]=null}k[f]=new OpenLayers.Geometry.Point(j[0],j[1],j[2])}else{throw"Bad LineString point coordinates: "+a[f]}}if(h){if(e){l=new OpenLayers.Geometry.LinearRing(k)}else{l=new OpenLayers.Geometry.LineString(k)}}else{throw"Bad LineString coordinates: "+b}}return l},polygon:function(f){var c=this.getElementsByTagNameNS(f,this.internalns,"LinearRing");var g=c.length;var e=new Array(g);if(g>0){var b;for(var d=0,a=c.length;d<a;++d){b=this.parseGeometry.linestring.apply(this,[c[d],true]);if(b){e[d]=b}else{throw"Bad LinearRing geometry: "+d}}}return new OpenLayers.Geometry.Polygon(e)},multigeometry:function(e){var h,g;var f=[];var c=e.childNodes;for(var b=0,a=c.length;b<a;++b){h=c[b];if(h.nodeType==1){var d=(h.prefix)?h.nodeName.split(":")[1]:h.nodeName;var g=this.parseGeometry[d.toLowerCase()];if(g){f.push(g.apply(this,[h]))}}}return new OpenLayers.Geometry.Collection(f)}},parseAttributes:function(d){var f={};var h=d.getElementsByTagName("ExtendedData");if(h.length){f=this.parseExtendedData(h[0])}var b,n,m;var c=d.childNodes;for(var j=0,k=c.length;j<k;++j){b=c[j];if(b.nodeType==1){n=b.childNodes;if(n.length>=1&&n.length<=3){var m;switch(n.length){case 1:m=n[0];break;case 2:var g=n[0];var e=n[1];m=(g.nodeType==3||g.nodeType==4)?g:e;break;case 3:default:m=n[1];break}if(m.nodeType==3||m.nodeType==4){var a=(b.prefix)?b.nodeName.split(":")[1]:b.nodeName;var l=OpenLayers.Util.getXmlNodeValue(m);if(l){l=l.replace(this.regExes.trimSpace,"");f[a]=l}}}}}return f},parseExtendedData:function(b){var d={};var f,h,e,k;var c=b.getElementsByTagName("Data");for(f=0,h=c.length;f<h;f++){e=c[f];k=e.getAttribute("name");var g={};var l=e.getElementsByTagName("value");if(l.length){g.value=this.getChildValue(l[0])}var a=e.getElementsByTagName("displayName");if(a.length){g.displayName=this.getChildValue(a[0])}d[k]=g}var j=b.getElementsByTagName("SimpleData");for(f=0,h=j.length;f<h;f++){var g={};e=j[f];k=e.getAttribute("name");g.value=this.getChildValue(e);g.displayName=k;d[k]=g}return d},parseProperty:function(c,d,b){var f;var a=this.getElementsByTagNameNS(c,d,b);try{f=OpenLayers.Util.getXmlNodeValue(a[0])}catch(g){f=null}return f},write:function(d){if(!(OpenLayers.Util.isArray(d))){d=[d]}var b=this.createElementNS(this.kmlns,"kml");var e=this.createFolderXML();for(var c=0,a=d.length;c<a;++c){e.appendChild(this.createPlacemarkXML(d[c]))}b.appendChild(e);return OpenLayers.Format.XML.prototype.write.apply(this,[b])},createFolderXML:function(){var c=this.createElementNS(this.kmlns,"Folder");if(this.foldersName){var e=this.createElementNS(this.kmlns,"name");var d=this.createTextNode(this.foldersName);e.appendChild(d);c.appendChild(e)}if(this.foldersDesc){var a=this.createElementNS(this.kmlns,"description");var b=this.createTextNode(this.foldersDesc);a.appendChild(b);c.appendChild(a)}return c},createPlacemarkXML:function(e){var g=this.createElementNS(this.kmlns,"name");var c=e.style&&e.style.label?e.style.label:e.attributes.name||e.id;g.appendChild(this.createTextNode(c));var d=this.createElementNS(this.kmlns,"description");var f=e.attributes.description||this.placemarksDesc;d.appendChild(this.createTextNode(f));var b=this.createElementNS(this.kmlns,"Placemark");if(e.fid!=null){b.setAttribute("id",e.fid)}b.appendChild(g);b.appendChild(d);var a=this.buildGeometryNode(e.geometry);b.appendChild(a);return b},buildGeometryNode:function(e){var c=e.CLASS_NAME;var b=c.substring(c.lastIndexOf(".")+1);var a=this.buildGeometry[b.toLowerCase()];var d=null;if(a){d=a.apply(this,[e])}return d},buildGeometry:{point:function(b){var a=this.createElementNS(this.kmlns,"Point");a.appendChild(this.buildCoordinatesNode(b));return a},multipoint:function(a){return this.buildGeometry.collection.apply(this,[a])},linestring:function(b){var a=this.createElementNS(this.kmlns,"LineString");a.appendChild(this.buildCoordinatesNode(b));return a},multilinestring:function(a){return this.buildGeometry.collection.apply(this,[a])},linearring:function(b){var a=this.createElementNS(this.kmlns,"LinearRing");a.appendChild(this.buildCoordinatesNode(b));return a},polygon:function(h){var b=this.createElementNS(this.kmlns,"Polygon");var g=h.components;var e,f,d;for(var c=0,a=g.length;c<a;++c){d=(c==0)?"outerBoundaryIs":"innerBoundaryIs";e=this.createElementNS(this.kmlns,d);f=this.buildGeometry.linearring.apply(this,[g[c]]);e.appendChild(f);b.appendChild(e)}return b},multipolygon:function(a){return this.buildGeometry.collection.apply(this,[a])},collection:function(d){var b=this.createElementNS(this.kmlns,"MultiGeometry");var e;for(var c=0,a=d.components.length;c<a;++c){e=this.buildGeometryNode.apply(this,[d.components[c]]);if(e){b.appendChild(e)}}return b}},buildCoordinatesNode:function(e){var a=this.createElementNS(this.kmlns,"coordinates");var j;var h=e.components;if(h){var g;var f=h.length;var c=new Array(f);for(var d=0;d<f;++d){g=h[d];c[d]=this.buildCoordinates(g)}j=c.join(" ")}else{j=this.buildCoordinates(e)}var b=this.createTextNode(j);a.appendChild(b);return a},buildCoordinates:function(a){if(this.internalProjection&&this.externalProjection){a=a.clone();a.transform(this.internalProjection,this.externalProjection)}return a.x+","+a.y},CLASS_NAME:"OpenLayers.Format.KML"});OpenLayers.Format.WMSCapabilities=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.1.1",profile:null,CLASS_NAME:"OpenLayers.Format.WMSCapabilities"});OpenLayers.Format.WMSCapabilities.v1=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{wms:"http://www.opengis.net/wms",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},defaultPrefix:"wms",initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(c){if(typeof c=="string"){c=OpenLayers.Format.XML.prototype.read.apply(this,[c])}var b=c;if(c&&c.nodeType==9){c=c.documentElement}var a={};this.readNode(c,a);if(a.service===undefined){var d=new OpenLayers.Format.OGCExceptionReport();a.error=d.read(b)}else{this.postProcessLayers(a)}return a},postProcessLayers:function(b){if(b.capability){b.capability.layers=[];var e=b.capability.nestedLayers;for(var d=0,a=e.length;d<a;++d){var c=e[d];this.processLayer(b.capability,c)}}},processLayer:function(a,h,c){if(h.formats===undefined){h.formats=a.request.getmap.formats}var f,j;if(c){h.styles=h.styles.concat(c.styles);var e=["queryable","cascaded","fixedWidth","fixedHeight","opaque","noSubsets","llbbox","minScale","maxScale","attribution"];var l=["srs","bbox","dimensions","authorityURLs"];var k;for(f=0,j=e.length;f<j;f++){k=e[f];if(k in c){if(h[k]==null){h[k]=c[k]}if(h[k]==null){var g=["cascaded","fixedWidth","fixedHeight"];var b=["queryable","opaque","noSubsets"];if(OpenLayers.Util.indexOf(g,k)!=-1){h[k]=0}if(OpenLayers.Util.indexOf(b,k)!=-1){h[k]=false}}}}for(f=0,j=l.length;f<j;f++){k=l[f];h[k]=OpenLayers.Util.applyDefaults(h[k],c[k])}}for(f=0,j=h.nestedLayers.length;f<j;f++){var d=h.nestedLayers[f];this.processLayer(a,d,h)}if(h.name){a.layers.push(h)}},readers:{wms:{Service:function(a,b){b.service={};this.readChildNodes(a,b.service)},Name:function(a,b){b.name=this.getChildValue(a)},Title:function(a,b){b.title=this.getChildValue(a)},Abstract:function(a,b){b["abstract"]=this.getChildValue(a)},BoundingBox:function(b,c){var d={};d.bbox=[parseFloat(b.getAttribute("minx")),parseFloat(b.getAttribute("miny")),parseFloat(b.getAttribute("maxx")),parseFloat(b.getAttribute("maxy"))];var a={x:parseFloat(b.getAttribute("resx")),y:parseFloat(b.getAttribute("resy"))};if(!(isNaN(a.x)&&isNaN(a.y))){d.res=a}return d},OnlineResource:function(a,b){b.href=this.getAttributeNS(a,this.namespaces.xlink,"href")},ContactInformation:function(a,b){b.contactInformation={};this.readChildNodes(a,b.contactInformation)},ContactPersonPrimary:function(a,b){b.personPrimary={};this.readChildNodes(a,b.personPrimary)},ContactPerson:function(a,b){b.person=this.getChildValue(a)},ContactOrganization:function(a,b){b.organization=this.getChildValue(a)},ContactPosition:function(a,b){b.position=this.getChildValue(a)},ContactAddress:function(a,b){b.contactAddress={};this.readChildNodes(a,b.contactAddress)},AddressType:function(a,b){b.type=this.getChildValue(a)},Address:function(a,b){b.address=this.getChildValue(a)},City:function(a,b){b.city=this.getChildValue(a)},StateOrProvince:function(a,b){b.stateOrProvince=this.getChildValue(a)},PostCode:function(a,b){b.postcode=this.getChildValue(a)},Country:function(a,b){b.country=this.getChildValue(a)},ContactVoiceTelephone:function(a,b){b.phone=this.getChildValue(a)},ContactFacsimileTelephone:function(a,b){b.fax=this.getChildValue(a)},ContactElectronicMailAddress:function(a,b){b.email=this.getChildValue(a)},Fees:function(b,c){var a=this.getChildValue(b);if(a&&a.toLowerCase()!="none"){c.fees=a}},AccessConstraints:function(a,b){var c=this.getChildValue(a);if(c&&c.toLowerCase()!="none"){b.accessConstraints=c}},Capability:function(a,b){b.capability={nestedLayers:[]};this.readChildNodes(a,b.capability)},Request:function(a,b){b.request={};this.readChildNodes(a,b.request)},GetCapabilities:function(a,b){b.getcapabilities={formats:[]};this.readChildNodes(a,b.getcapabilities)},Format:function(a,b){if(OpenLayers.Util.isArray(b.formats)){b.formats.push(this.getChildValue(a))}else{b.format=this.getChildValue(a)}},DCPType:function(a,b){this.readChildNodes(a,b)},HTTP:function(a,b){this.readChildNodes(a,b)},Get:function(a,b){b.get={};this.readChildNodes(a,b.get);if(!b.href){b.href=b.get.href}},Post:function(a,b){b.post={};this.readChildNodes(a,b.post);if(!b.href){b.href=b.get.href}},GetMap:function(a,b){b.getmap={formats:[]};this.readChildNodes(a,b.getmap)},GetFeatureInfo:function(a,b){b.getfeatureinfo={formats:[]};this.readChildNodes(a,b.getfeatureinfo)},Exception:function(a,b){b.exception={formats:[]};this.readChildNodes(a,b.exception)},Layer:function(b,e){var k=b.getAttributeNode("queryable");var c=(k&&k.specified)?b.getAttribute("queryable"):null;k=b.getAttributeNode("cascaded");var i=(k&&k.specified)?b.getAttribute("cascaded"):null;k=b.getAttributeNode("opaque");var f=(k&&k.specified)?b.getAttribute("opaque"):null;var j=b.getAttribute("noSubsets");var a=b.getAttribute("fixedWidth");var h=b.getAttribute("fixedHeight");var g={nestedLayers:[],styles:[],srs:{},metadataURLs:[],bbox:{},dimensions:{},authorityURLs:{},identifiers:{},keywords:[],queryable:(c&&c!=="")?(c==="1"||c==="true"):null,cascaded:(i!==null)?parseInt(i):null,opaque:f?(f==="1"||f==="true"):null,noSubsets:(j!==null)?(j==="1"||j==="true"):null,fixedWidth:(a!=null)?parseInt(a):null,fixedHeight:(h!=null)?parseInt(h):null};e.nestedLayers.push(g);this.readChildNodes(b,g);if(g.name){var d=g.name.split(":");if(d.length>0){g.prefix=d[0]}}},Attribution:function(a,b){b.attribution={};this.readChildNodes(a,b.attribution)},LogoURL:function(a,b){b.logo={width:a.getAttribute("width"),height:a.getAttribute("height")};this.readChildNodes(a,b.logo)},Style:function(b,c){var a={};c.styles.push(a);this.readChildNodes(b,a)},LegendURL:function(b,c){var a={width:b.getAttribute("width"),height:b.getAttribute("height")};c.legend=a;this.readChildNodes(b,a)},MetadataURL:function(a,b){var c={type:a.getAttribute("type")};b.metadataURLs.push(c);this.readChildNodes(a,c)},DataURL:function(a,b){b.dataURL={};this.readChildNodes(a,b.dataURL)},FeatureListURL:function(a,b){b.featureListURL={};this.readChildNodes(a,b.featureListURL)},AuthorityURL:function(b,d){var a=b.getAttribute("name");var c={};this.readChildNodes(b,c);d.authorityURLs[a]=c.href},Identifier:function(a,c){var b=a.getAttribute("authority");c.identifiers[b]=this.getChildValue(a)},KeywordList:function(a,b){this.readChildNodes(a,b)},SRS:function(a,b){b.srs[this.getChildValue(a)]=true}}},CLASS_NAME:"OpenLayers.Format.WMSCapabilities.v1"});OpenLayers.Format.WMSCapabilities.v1_1=OpenLayers.Class(OpenLayers.Format.WMSCapabilities.v1,{readers:{wms:OpenLayers.Util.applyDefaults({WMT_MS_Capabilities:function(a,b){this.readChildNodes(a,b)},Keyword:function(a,b){if(b.keywords){b.keywords.push(this.getChildValue(a))}},DescribeLayer:function(a,b){b.describelayer={formats:[]};this.readChildNodes(a,b.describelayer)},GetLegendGraphic:function(a,b){b.getlegendgraphic={formats:[]};this.readChildNodes(a,b.getlegendgraphic)},GetStyles:function(a,b){b.getstyles={formats:[]};this.readChildNodes(a,b.getstyles)},PutStyles:function(a,b){b.putstyles={formats:[]};this.readChildNodes(a,b.putstyles)},UserDefinedSymbolization:function(a,b){var c={supportSLD:parseInt(a.getAttribute("SupportSLD"))==1,userLayer:parseInt(a.getAttribute("UserLayer"))==1,userStyle:parseInt(a.getAttribute("UserStyle"))==1,remoteWFS:parseInt(a.getAttribute("RemoteWFS"))==1};b.userSymbols=c},LatLonBoundingBox:function(a,b){b.llbbox=[parseFloat(a.getAttribute("minx")),parseFloat(a.getAttribute("miny")),parseFloat(a.getAttribute("maxx")),parseFloat(a.getAttribute("maxy"))]},BoundingBox:function(a,b){var c=OpenLayers.Format.WMSCapabilities.v1.prototype.readers.wms.BoundingBox.apply(this,[a,b]);c.srs=a.getAttribute("SRS");b.bbox[c.srs]=c},ScaleHint:function(e,f){var d=e.getAttribute("min");var a=e.getAttribute("max");var c=Math.pow(2,0.5);var b=OpenLayers.INCHES_PER_UNIT.m;f.maxScale=parseFloat(((d/c)*b*OpenLayers.DOTS_PER_INCH).toPrecision(13));f.minScale=parseFloat(((a/c)*b*OpenLayers.DOTS_PER_INCH).toPrecision(13))},Dimension:function(b,d){var a=b.getAttribute("name").toLowerCase();var c={name:a,units:b.getAttribute("units"),unitsymbol:b.getAttribute("unitSymbol")};d.dimensions[c.name]=c},Extent:function(d,e){var b=d.getAttribute("name").toLowerCase();if(b in e.dimensions){var c=e.dimensions[b];c.nearestVal=d.getAttribute("nearestValue")==="1";c.multipleVal=d.getAttribute("multipleValues")==="1";c.current=d.getAttribute("current")==="1";c["default"]=d.getAttribute("default")||"";var a=this.getChildValue(d);c.values=a.split(",")}}},OpenLayers.Format.WMSCapabilities.v1.prototype.readers.wms)},CLASS_NAME:"OpenLayers.Format.WMSCapabilities.v1_1"});OpenLayers.Format.WMSCapabilities.v1_1_0=OpenLayers.Class(OpenLayers.Format.WMSCapabilities.v1_1,{version:"1.1.0",initialize:function(a){OpenLayers.Format.WMSCapabilities.v1_1.prototype.initialize.apply(this,[a])},readers:{wms:OpenLayers.Util.applyDefaults({SRS:function(e,f){var d=this.getChildValue(e);var b=d.split(/ +/);for(var c=0,a=b.length;c<a;c++){f.srs[b[c]]=true}}},OpenLayers.Format.WMSCapabilities.v1_1.prototype.readers.wms)},CLASS_NAME:"OpenLayers.Format.WMSCapabilities.v1_1_0"});OpenLayers.Strategy.BBOX=OpenLayers.Class(OpenLayers.Strategy,{bounds:null,resolution:null,ratio:2,resFactor:null,response:null,activate:function(){var a=OpenLayers.Strategy.prototype.activate.call(this);if(a){this.layer.events.on({moveend:this.update,scope:this});this.layer.events.on({refresh:this.update,scope:this});if(this.layer.visibility===true&&this.layer.inRange===true){this.update()}else{this.layer.events.on({visibilitychanged:this.update,scope:this})}}return a},deactivate:function(){var a=OpenLayers.Strategy.prototype.deactivate.call(this);if(a){this.layer.events.un({moveend:this.update,refresh:this.update,visibilitychanged:this.update,scope:this})}return a},update:function(b){var a=this.getMapBounds();if(a!==null&&((b&&b.force)||this.invalidBounds(a))){this.calculateBounds(a);this.resolution=this.layer.map.getResolution();this.triggerRead(b)}},getMapBounds:function(){if(this.layer.map===null){return null}var a=this.layer.map.getExtent();if(a&&!this.layer.projection.equals(this.layer.map.getProjectionObject())){a=a.clone().transform(this.layer.map.getProjectionObject(),this.layer.projection)}return a},invalidBounds:function(a){if(!a){a=this.getMapBounds()}var c=!this.bounds||!this.bounds.containsBounds(a);if(!c&&this.resFactor){var b=this.resolution/this.layer.map.getResolution();c=(b>=this.resFactor||b<=(1/this.resFactor))}return c},calculateBounds:function(b){if(!b){b=this.getMapBounds()}var a=b.getCenterLonLat();var d=b.getWidth()*this.ratio;var c=b.getHeight()*this.ratio;this.bounds=new OpenLayers.Bounds(a.lon-(d/2),a.lat-(c/2),a.lon+(d/2),a.lat+(c/2))},triggerRead:function(a){if(this.response){this.layer.protocol.abort(this.response);this.layer.events.triggerEvent("loadend")}this.layer.events.triggerEvent("loadstart");this.response=this.layer.protocol.read(OpenLayers.Util.applyDefaults({filter:this.createFilter(),callback:this.merge,scope:this},a))},createFilter:function(){var a=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.BBOX,value:this.bounds,projection:this.layer.projection});if(this.layer.filter){a=new OpenLayers.Filter.Logical({type:OpenLayers.Filter.Logical.AND,filters:[this.layer.filter,a]})}return a},merge:function(g){this.layer.destroyFeatures();var e=g.features;if(e&&e.length>0){var f=this.layer.projection;var d=this.layer.map.getProjectionObject();if(!d.equals(f)){var c;for(var b=0,a=e.length;b<a;++b){c=e[b].geometry;if(c){c.transform(f,d)}}}this.layer.addFeatures(e)}this.response=null;this.layer.events.triggerEvent("loadend")},CLASS_NAME:"OpenLayers.Strategy.BBOX"});OpenLayers.Handler.Feature=OpenLayers.Class(OpenLayers.Handler,{EVENTMAP:{click:{"in":"click",out:"clickout"},mousemove:{"in":"over",out:"out"},dblclick:{"in":"dblclick",out:null},mousedown:{"in":null,out:null},mouseup:{"in":null,out:null},touchstart:{"in":"click",out:"clickout"}},feature:null,lastFeature:null,down:null,up:null,touch:false,clickTolerance:4,geometryTypes:null,stopClick:true,stopDown:true,stopUp:false,initialize:function(d,b,c,a){OpenLayers.Handler.prototype.initialize.apply(this,[d,c,a]);this.layer=b},touchstart:function(a){if(!this.touch){this.touch=true;this.map.events.un({mousedown:this.mousedown,mouseup:this.mouseup,mousemove:this.mousemove,click:this.click,dblclick:this.dblclick,scope:this})}return OpenLayers.Event.isMultiTouch(a)?true:this.mousedown(a)},touchmove:function(a){OpenLayers.Event.stop(a)},mousedown:function(a){this.down=a.xy;return this.handle(a)?!this.stopDown:true},mouseup:function(a){this.up=a.xy;return this.handle(a)?!this.stopUp:true},click:function(a){return this.handle(a)?!this.stopClick:true},mousemove:function(a){if(!this.callbacks.over&&!this.callbacks.out){return true}this.handle(a);return true},dblclick:function(a){return !this.handle(a)},geometryTypeMatches:function(a){return this.geometryTypes==null||OpenLayers.Util.indexOf(this.geometryTypes,a.geometry.CLASS_NAME)>-1},handle:function(a){if(this.feature&&!this.feature.layer){this.feature=null}var c=a.type;var f=false;var e=!!(this.feature);var d=(c=="click"||c=="dblclick"||c=="touchstart");this.feature=this.layer.getFeatureFromEvent(a);if(this.feature&&!this.feature.layer){this.feature=null}if(this.lastFeature&&!this.lastFeature.layer){this.lastFeature=null}if(this.feature){if(c==="touchstart"){OpenLayers.Event.stop(a)}var b=(this.feature!=this.lastFeature);if(this.geometryTypeMatches(this.feature)){if(e&&b){if(this.lastFeature){this.triggerCallback(c,"out",[this.lastFeature])}this.triggerCallback(c,"in",[this.feature])}else{if(!e||d){this.triggerCallback(c,"in",[this.feature])}}this.lastFeature=this.feature;f=true}else{if(this.lastFeature&&(e&&b||d)){this.triggerCallback(c,"out",[this.lastFeature])}this.feature=null}}else{if(this.lastFeature&&(e||d)){this.triggerCallback(c,"out",[this.lastFeature])}}return f},triggerCallback:function(d,e,b){var c=this.EVENTMAP[d][e];if(c){if(d=="click"&&this.up&&this.down){var a=Math.sqrt(Math.pow(this.up.x-this.down.x,2)+Math.pow(this.up.y-this.down.y,2));if(a<=this.clickTolerance){this.callback(c,b)}}else{this.callback(c,b)}}},activate:function(){var a=false;if(OpenLayers.Handler.prototype.activate.apply(this,arguments)){this.moveLayerToTop();this.map.events.on({removelayer:this.handleMapEvents,changelayer:this.handleMapEvents,scope:this});a=true}return a},deactivate:function(){var a=false;if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){this.moveLayerBack();this.feature=null;this.lastFeature=null;this.down=null;this.up=null;this.touch=false;this.map.events.un({removelayer:this.handleMapEvents,changelayer:this.handleMapEvents,scope:this});a=true}return a},handleMapEvents:function(a){if(a.type=="removelayer"||a.property=="order"){this.moveLayerToTop()}},moveLayerToTop:function(){var a=Math.max(this.map.Z_INDEX_BASE.Feature-1,this.layer.getZIndex())+1;this.layer.setZIndex(a)},moveLayerBack:function(){var a=this.layer.getZIndex()-1;if(a>=this.map.Z_INDEX_BASE.Feature){this.layer.setZIndex(a)}else{this.map.setLayerZIndex(this.layer,this.map.getLayerIndex(this.layer))}},CLASS_NAME:"OpenLayers.Handler.Feature"});OpenLayers.Layer.Vector.RootContainer=OpenLayers.Class(OpenLayers.Layer.Vector,{displayInLayerSwitcher:false,layers:null,initialize:function(b,a){OpenLayers.Layer.Vector.prototype.initialize.apply(this,arguments)},display:function(){},getFeatureFromEvent:function(a){var d=this.layers;var c;for(var b=0;b<d.length;b++){c=d[b].getFeatureFromEvent(a);if(c){return c}}},setMap:function(a){OpenLayers.Layer.Vector.prototype.setMap.apply(this,arguments);this.collectRoots();a.events.register("changelayer",this,this.handleChangeLayer)},removeMap:function(a){a.events.unregister("changelayer",this,this.handleChangeLayer);this.resetRoots();OpenLayers.Layer.Vector.prototype.removeMap.apply(this,arguments)},collectRoots:function(){var b;for(var a=0;a<this.map.layers.length;++a){b=this.map.layers[a];if(OpenLayers.Util.indexOf(this.layers,b)!=-1){b.renderer.moveRoot(this.renderer)}}},resetRoots:function(){var b;for(var a=0;a<this.layers.length;++a){b=this.layers[a];if(this.renderer&&b.renderer.getRenderLayerId()==this.id){this.renderer.moveRoot(b.renderer)}}},handleChangeLayer:function(a){var b=a.layer;if(a.property=="order"&&OpenLayers.Util.indexOf(this.layers,b)!=-1){this.resetRoots();this.collectRoots()}},CLASS_NAME:"OpenLayers.Layer.Vector.RootContainer"});OpenLayers.Control.SelectFeature=OpenLayers.Class(OpenLayers.Control,{EVENT_TYPES:["beforefeaturehighlighted","featurehighlighted","featureunhighlighted"],multipleKey:null,toggleKey:null,multiple:false,clickout:true,toggle:false,hover:false,highlightOnly:false,box:false,onBeforeSelect:function(){},onSelect:function(){},onUnselect:function(){},scope:null,geometryTypes:null,layer:null,layers:null,callbacks:null,selectStyle:null,renderIntent:"select",handlers:null,initialize:function(c,a){this.EVENT_TYPES=OpenLayers.Control.SelectFeature.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);OpenLayers.Control.prototype.initialize.apply(this,[a]);if(this.scope===null){this.scope=this}this.initLayer(c);var b={click:this.clickFeature,clickout:this.clickoutFeature};if(this.hover){b.over=this.overFeature;b.out=this.outFeature}this.callbacks=OpenLayers.Util.extend(b,this.callbacks);this.handlers={feature:new OpenLayers.Handler.Feature(this,this.layer,this.callbacks,{geometryTypes:this.geometryTypes})};if(this.box){this.handlers.box=new OpenLayers.Handler.Box(this,{done:this.selectBox},{boxDivClassName:"olHandlerBoxSelectFeature"})}},initLayer:function(a){if(OpenLayers.Util.isArray(a)){this.layers=a;this.layer=new OpenLayers.Layer.Vector.RootContainer(this.id+"_container",{layers:a})}else{this.layer=a}},destroy:function(){if(this.active&&this.layers){this.map.removeLayer(this.layer)}OpenLayers.Control.prototype.destroy.apply(this,arguments);if(this.layers){this.layer.destroy()}},activate:function(){if(!this.active){if(this.layers){this.map.addLayer(this.layer)}this.handlers.feature.activate();if(this.box&&this.handlers.box){this.handlers.box.activate()}}return OpenLayers.Control.prototype.activate.apply(this,arguments)},deactivate:function(){if(this.active){this.handlers.feature.deactivate();if(this.handlers.box){this.handlers.box.deactivate()}if(this.layers){this.map.removeLayer(this.layer)}}return OpenLayers.Control.prototype.deactivate.apply(this,arguments)},unselectAll:function(b){var f=this.layers||[this.layer];var e,d;for(var a=0;a<f.length;++a){e=f[a];for(var c=e.selectedFeatures.length-1;c>=0;--c){d=e.selectedFeatures[c];if(!b||b.except!=d){this.unselect(d)}}}},clickFeature:function(a){if(!this.hover){var b=(OpenLayers.Util.indexOf(a.layer.selectedFeatures,a)>-1);if(b){if(this.toggleSelect()){this.unselect(a)}else{if(!this.multipleSelect()){this.unselectAll({except:a})}}}else{if(!this.multipleSelect()){this.unselectAll({except:a})}this.select(a)}}},multipleSelect:function(){return this.multiple||(this.handlers.feature.evt&&this.handlers.feature.evt[this.multipleKey])},toggleSelect:function(){return this.toggle||(this.handlers.feature.evt&&this.handlers.feature.evt[this.toggleKey])},clickoutFeature:function(a){if(!this.hover&&this.clickout){this.unselectAll()}},overFeature:function(b){var a=b.layer;if(this.hover){if(this.highlightOnly){this.highlight(b)}else{if(OpenLayers.Util.indexOf(a.selectedFeatures,b)==-1){this.select(b)}}}},outFeature:function(a){if(this.hover){if(this.highlightOnly){if(a._lastHighlighter==this.id){if(a._prevHighlighter&&a._prevHighlighter!=this.id){delete a._lastHighlighter;var b=this.map.getControl(a._prevHighlighter);if(b){b.highlight(a)}}else{this.unhighlight(a)}}}else{this.unselect(a)}}},highlight:function(c){var b=c.layer;var a=this.events.triggerEvent("beforefeaturehighlighted",{feature:c});if(a!==false){c._prevHighlighter=c._lastHighlighter;c._lastHighlighter=this.id;var d=this.selectStyle||this.renderIntent;b.drawFeature(c,d);this.events.triggerEvent("featurehighlighted",{feature:c})}},unhighlight:function(b){var a=b.layer;if(b._prevHighlighter==undefined){delete b._lastHighlighter}else{if(b._prevHighlighter==this.id){delete b._prevHighlighter}else{b._lastHighlighter=b._prevHighlighter;delete b._prevHighlighter}}a.drawFeature(b,b.style||b.layer.style||"default");this.events.triggerEvent("featureunhighlighted",{feature:b})},select:function(c){var a=this.onBeforeSelect.call(this.scope,c);var b=c.layer;if(a!==false){a=b.events.triggerEvent("beforefeatureselected",{feature:c});if(a!==false){b.selectedFeatures.push(c);this.highlight(c);if(!this.handlers.feature.lastFeature){this.handlers.feature.lastFeature=b.selectedFeatures[0]}b.events.triggerEvent("featureselected",{feature:c});this.onSelect.call(this.scope,c)}}},unselect:function(b){var a=b.layer;this.unhighlight(b);OpenLayers.Util.removeItem(a.selectedFeatures,b);a.events.triggerEvent("featureunselected",{feature:b});this.onUnselect.call(this.scope,b)},selectBox:function(e){if(e instanceof OpenLayers.Bounds){var h=this.map.getLonLatFromPixel(new OpenLayers.Pixel(e.left,e.bottom));var k=this.map.getLonLatFromPixel(new OpenLayers.Pixel(e.right,e.top));var a=new OpenLayers.Bounds(h.lon,h.lat,k.lon,k.lat);if(!this.multipleSelect()){this.unselectAll()}var j=this.multiple;this.multiple=true;var d=this.layers||[this.layer];var f;for(var b=0;b<d.length;++b){f=d[b];for(var c=0,g=f.features.length;c<g;++c){var m=f.features[c];if(!m.getVisibility()){continue}if(this.geometryTypes==null||OpenLayers.Util.indexOf(this.geometryTypes,m.geometry.CLASS_NAME)>-1){if(a.toGeometry().intersects(m.geometry)){if(OpenLayers.Util.indexOf(f.selectedFeatures,m)==-1){this.select(m)}}}}}this.multiple=j}},setMap:function(a){this.handlers.feature.setMap(a);if(this.box){this.handlers.box.setMap(a)}OpenLayers.Control.prototype.setMap.apply(this,arguments)},setLayer:function(b){var a=this.active;this.unselectAll();this.deactivate();if(this.layers){this.layer.destroy();this.layers=null}this.initLayer(b);this.handlers.feature.layer=this.layer;if(a){this.activate()}},CLASS_NAME:"OpenLayers.Control.SelectFeature"});OpenLayers.Handler.Point=OpenLayers.Class(OpenLayers.Handler,{point:null,layer:null,multi:false,mouseDown:false,stoppedDown:null,lastDown:null,lastUp:null,persist:false,stopDown:false,stopUp:false,layerOptions:null,pixelTolerance:5,touch:false,lastTouchPx:null,initialize:function(c,b,a){if(!(a&&a.layerOptions&&a.layerOptions.styleMap)){this.style=OpenLayers.Util.extend(OpenLayers.Feature.Vector.style["default"],{})}OpenLayers.Handler.prototype.initialize.apply(this,arguments)},activate:function(){if(!OpenLayers.Handler.prototype.activate.apply(this,arguments)){return false}var a=OpenLayers.Util.extend({displayInLayerSwitcher:false,calculateInRange:OpenLayers.Function.True},this.layerOptions);this.layer=new OpenLayers.Layer.Vector(this.CLASS_NAME,a);this.map.addLayer(this.layer);return true},createFeature:function(a){var b=this.map.getLonLatFromPixel(a);var c=new OpenLayers.Geometry.Point(b.lon,b.lat);this.point=new OpenLayers.Feature.Vector(c);this.callback("create",[this.point.geometry,this.point]);this.point.geometry.clearBounds();this.layer.addFeatures([this.point],{silent:true})},deactivate:function(){if(!OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){return false}this.cancel();if(this.layer.map!=null){this.destroyFeature(true);this.layer.destroy(false)}this.layer=null;this.touch=false;return true},destroyFeature:function(a){if(this.layer&&(a||!this.persist)){this.layer.destroyFeatures()}this.point=null},destroyPersistedFeature:function(){var a=this.layer;if(a&&a.features.length>1){this.layer.features[0].destroy()}},finalize:function(b){var a=b?"cancel":"done";this.mouseDown=false;this.lastDown=null;this.lastUp=null;this.lastTouchPx=null;this.callback(a,[this.geometryClone()]);this.destroyFeature(b)},cancel:function(){this.finalize(true)},click:function(a){OpenLayers.Event.stop(a);return false},dblclick:function(a){OpenLayers.Event.stop(a);return false},modifyFeature:function(a){if(!this.point){this.createFeature(a)}var b=this.map.getLonLatFromPixel(a);this.point.geometry.x=b.lon;this.point.geometry.y=b.lat;this.callback("modify",[this.point.geometry,this.point,false]);this.point.geometry.clearBounds();this.drawFeature()},drawFeature:function(){this.layer.drawFeature(this.point,this.style)},getGeometry:function(){var a=this.point&&this.point.geometry;if(a&&this.multi){a=new OpenLayers.Geometry.MultiPoint([a])}return a},geometryClone:function(){var a=this.getGeometry();return a&&a.clone()},mousedown:function(a){return this.down(a)},touchstart:function(a){if(!this.touch){this.touch=true;this.map.events.un({mousedown:this.mousedown,mouseup:this.mouseup,mousemove:this.mousemove,click:this.click,dblclick:this.dblclick,scope:this})}this.lastTouchPx=a.xy;return this.down(a)},mousemove:function(a){return this.move(a)},touchmove:function(a){this.lastTouchPx=a.xy;return this.move(a)},mouseup:function(a){return this.up(a)},touchend:function(a){a.xy=this.lastTouchPx;return this.up(a)},down:function(a){this.mouseDown=true;this.lastDown=a.xy;if(!this.touch){this.modifyFeature(a.xy)}this.stoppedDown=this.stopDown;return !this.stopDown},move:function(a){if(!this.touch&&(!this.mouseDown||this.stoppedDown)){this.modifyFeature(a.xy)}return true},up:function(a){this.mouseDown=false;this.stoppedDown=this.stopDown;if(!this.checkModifiers(a)){return true}if(this.lastUp&&this.lastUp.equals(a.xy)){return true}if(this.lastDown&&this.passesTolerance(this.lastDown,a.xy,this.pixelTolerance)){if(this.touch){this.modifyFeature(a.xy)}if(this.persist){this.destroyPersistedFeature()}this.lastUp=a.xy;this.finalize();return !this.stopUp}else{return true}},mouseout:function(a){if(OpenLayers.Util.mouseLeft(a,this.map.eventsDiv)){this.stoppedDown=this.stopDown;this.mouseDown=false}},passesTolerance:function(e,d,a){var b=true;if(a!=null&&e&&d){var c=e.distanceTo(d);if(c>a){b=false}}return b},CLASS_NAME:"OpenLayers.Handler.Point"});OpenLayers.Handler.Path=OpenLayers.Class(OpenLayers.Handler.Point,{line:null,maxVertices:null,doubleTouchTolerance:20,freehand:false,freehandToggle:"shiftKey",timerId:null,redoStack:null,initialize:function(c,b,a){OpenLayers.Handler.Point.prototype.initialize.apply(this,arguments)},createFeature:function(a){var b=this.map.getLonLatFromPixel(a);var c=new OpenLayers.Geometry.Point(b.lon,b.lat);this.point=new OpenLayers.Feature.Vector(c);this.line=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.LineString([this.point.geometry]));this.callback("create",[this.point.geometry,this.getSketch()]);this.point.geometry.clearBounds();this.layer.addFeatures([this.line,this.point],{silent:true})},destroyFeature:function(a){OpenLayers.Handler.Point.prototype.destroyFeature.call(this,a);this.line=null},destroyPersistedFeature:function(){var a=this.layer;if(a&&a.features.length>2){this.layer.features[0].destroy()}},removePoint:function(){if(this.point){this.layer.removeFeatures([this.point])}},addPoint:function(a){this.layer.removeFeatures([this.point]);var b=this.control.map.getLonLatFromPixel(a);this.point=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Point(b.lon,b.lat));this.line.geometry.addComponent(this.point.geometry,this.line.geometry.components.length);this.layer.addFeatures([this.point]);this.callback("point",[this.point.geometry,this.getGeometry()]);this.callback("modify",[this.point.geometry,this.getSketch()]);this.drawFeature();delete this.redoStack},insertXY:function(a,b){this.line.geometry.addComponent(new OpenLayers.Geometry.Point(a,b),this.getCurrentPointIndex());this.drawFeature();delete this.redoStack},insertDeltaXY:function(b,a){var c=this.getCurrentPointIndex()-1;var d=this.line.geometry.components[c];if(d&&!isNaN(d.x)&&!isNaN(d.y)){this.insertXY(d.x+b,d.y+a)}},insertDirectionLength:function(d,c){d*=Math.PI/180;var b=c*Math.cos(d);var a=c*Math.sin(d);this.insertDeltaXY(b,a)},insertDeflectionLength:function(c,b){var d=this.getCurrentPointIndex()-1;if(d>0){var e=this.line.geometry.components[d];var f=this.line.geometry.components[d-1];var a=Math.atan2(e.y-f.y,e.x-f.x);this.insertDirectionLength((a*180/Math.PI)+c,b)}},getCurrentPointIndex:function(){return this.line.geometry.components.length-1},undo:function(){var e=this.line.geometry;var b=e.components;var a=this.getCurrentPointIndex()-1;var d=b[a];var c=e.removeComponent(d);if(c){if(!this.redoStack){this.redoStack=[]}this.redoStack.push(d);this.drawFeature()}return c},redo:function(){var a=this.redoStack&&this.redoStack.pop();if(a){this.line.geometry.addComponent(a,this.getCurrentPointIndex());this.drawFeature()}return !!a},freehandMode:function(a){return(this.freehandToggle&&a[this.freehandToggle])?!this.freehand:this.freehand},modifyFeature:function(b,a){if(!this.line){this.createFeature(b)}var c=this.control.map.getLonLatFromPixel(b);this.point.geometry.x=c.lon;this.point.geometry.y=c.lat;this.callback("modify",[this.point.geometry,this.getSketch(),a]);this.point.geometry.clearBounds();this.drawFeature()},drawFeature:function(){this.layer.drawFeature(this.line,this.style);this.layer.drawFeature(this.point,this.style)},getSketch:function(){return this.line},getGeometry:function(){var a=this.line&&this.line.geometry;if(a&&this.multi){a=new OpenLayers.Geometry.MultiLineString([a])}return a},touchstart:function(a){if(this.timerId&&this.passesTolerance(this.lastTouchPx,a.xy,this.doubleTouchTolerance)){this.finishGeometry();window.clearTimeout(this.timerId);this.timerId=null;return false}else{if(this.timerId){window.clearTimeout(this.timerId);this.timerId=null}this.timerId=window.setTimeout(OpenLayers.Function.bind(function(){this.timerId=null},this),300);return OpenLayers.Handler.Point.prototype.touchstart.call(this,a)}},down:function(a){var b=this.stopDown;if(this.freehandMode(a)){b=true}if(!this.touch&&(!this.lastDown||!this.passesTolerance(this.lastDown,a.xy,this.pixelTolerance))){this.modifyFeature(a.xy,!!this.lastUp)}this.mouseDown=true;this.lastDown=a.xy;this.stoppedDown=b;return !b},move:function(a){if(this.stoppedDown&&this.freehandMode(a)){if(this.persist){this.destroyPersistedFeature()}this.addPoint(a.xy);return false}if(!this.touch&&(!this.mouseDown||this.stoppedDown)){this.modifyFeature(a.xy,!!this.lastUp)}return true},up:function(a){if(this.mouseDown&&(!this.lastUp||!this.lastUp.equals(a.xy))){if(this.stoppedDown&&this.freehandMode(a)){if(this.persist){this.destroyPersistedFeature()}this.removePoint();this.finalize()}else{if(this.passesTolerance(this.lastDown,a.xy,this.pixelTolerance)){if(this.touch){this.modifyFeature(a.xy)}if(this.lastUp==null&&this.persist){this.destroyPersistedFeature()}this.addPoint(a.xy);this.lastUp=a.xy;if(this.line.geometry.components.length===this.maxVertices+1){this.finishGeometry()}}}}this.stoppedDown=this.stopDown;this.mouseDown=false;return !this.stopUp},finishGeometry:function(){var a=this.line.geometry.components.length-1;this.line.geometry.removeComponent(this.line.geometry.components[a]);this.removePoint();this.finalize()},dblclick:function(a){if(!this.freehandMode(a)){this.finishGeometry()}return false},CLASS_NAME:"OpenLayers.Handler.Path"});OpenLayers.Layer.GML=OpenLayers.Class(OpenLayers.Layer.Vector,{loaded:false,format:null,formatOptions:null,initialize:function(d,c,b){var a=[];a.push(d,b);OpenLayers.Layer.Vector.prototype.initialize.apply(this,a);this.url=c},setVisibility:function(a,b){OpenLayers.Layer.Vector.prototype.setVisibility.apply(this,arguments);if(this.visibility&&!this.loaded){this.loadGML()}},moveTo:function(c,a,b){OpenLayers.Layer.Vector.prototype.moveTo.apply(this,arguments);if(this.visibility&&!this.loaded){this.loadGML()}},loadGML:function(){if(!this.loaded){this.events.triggerEvent("loadstart");OpenLayers.Request.GET({url:this.url,success:this.requestSuccess,failure:this.requestFailure,scope:this});this.loaded=true}},setUrl:function(a){this.url=a;this.destroyFeatures();this.loaded=false;this.loadGML()},requestSuccess:function(c){var d=c.responseXML;if(!d||!d.documentElement){d=c.responseText}var a={};OpenLayers.Util.extend(a,this.formatOptions);if(this.map&&!this.projection.equals(this.map.getProjectionObject())){a.externalProjection=this.projection;a.internalProjection=this.map.getProjectionObject()}var b=this.format?new this.format(a):new OpenLayers.Format.GML(a);this.addFeatures(b.read(d));this.events.triggerEvent("loadend")},requestFailure:function(a){OpenLayers.Console.userError(OpenLayers.i18n("errorLoadingGML",{url:this.url}));this.events.triggerEvent("loadend")},CLASS_NAME:"OpenLayers.Layer.GML"});OpenLayers.Control.PanPanel=OpenLayers.Class(OpenLayers.Control.Panel,{slideFactor:50,slideRatio:null,initialize:function(a){OpenLayers.Control.Panel.prototype.initialize.apply(this,[a]);var a={slideFactor:this.slideFactor,slideRatio:this.slideRatio};this.addControls([new OpenLayers.Control.Pan(OpenLayers.Control.Pan.NORTH,a),new OpenLayers.Control.Pan(OpenLayers.Control.Pan.SOUTH,a),new OpenLayers.Control.Pan(OpenLayers.Control.Pan.EAST,a),new OpenLayers.Control.Pan(OpenLayers.Control.Pan.WEST,a)])},CLASS_NAME:"OpenLayers.Control.PanPanel"});OpenLayers.Control.Attribution=OpenLayers.Class(OpenLayers.Control,{separator:", ",destroy:function(){this.map.events.un({removelayer:this.updateAttribution,addlayer:this.updateAttribution,changelayer:this.updateAttribution,changebaselayer:this.updateAttribution,scope:this});OpenLayers.Control.prototype.destroy.apply(this,arguments)},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);this.map.events.on({changebaselayer:this.updateAttribution,changelayer:this.updateAttribution,addlayer:this.updateAttribution,removelayer:this.updateAttribution,scope:this});this.updateAttribution();return this.div},updateAttribution:function(){var d=[];if(this.map&&this.map.layers){for(var c=0,a=this.map.layers.length;c<a;c++){var b=this.map.layers[c];if(b.attribution&&b.getVisibility()){if(OpenLayers.Util.indexOf(d,b.attribution)===-1){d.push(b.attribution)}}}this.div.innerHTML=d.join(this.separator)}},CLASS_NAME:"OpenLayers.Control.Attribution"});OpenLayers.Renderer.NG=OpenLayers.Class(OpenLayers.Renderer.Elements,{labelNodeType:null,updateDimensions:function(b){var a=this.map.getExtent();var d=a.scale(3);this.setExtent(d,true);var c=this.getResolution();var g=this.rendererRoot.parentNode;var e=parseFloat(g.parentNode.style.left);var f=parseFloat(g.parentNode.style.top);g.style.left=((d.left-a.left)/c-e)+"px";g.style.top=((a.top-d.top)/c-f)+"px"},setSize:function(){this.map.getExtent()&&this.updateDimensions()},drawFeature:function(b,c){if(c==null){c=b.style}if(b.geometry){var d=this.drawGeometry(b.geometry,c,b.id);if(d!==false&&c.label){var a=b.geometry.getCentroid();this.drawText(b.id,c,a)}else{this.removeText(b.id)}return d}},drawText:function(g,e,a){var b;if(typeof g!=="string"){b=g}else{b=this.nodeFactory(g+this.LABEL_ID_SUFFIX,this.labelNodeType);b._featureId=g}b._style=e;b._x=a.x;b._y=a.y;if(e.labelXOffset||e.labelYOffset){var d=isNaN(e.labelXOffset)?0:e.labelXOffset;var f=isNaN(e.labelYOffset)?0:e.labelYOffset;var c=this.getResolution();a.move(d*c,f*c)}if(b.parentNode!==this.textRoot){this.textRoot.appendChild(b)}return b},CLASS_NAME:"OpenLayers.Renderer.NG"});OpenLayers.Renderer.SVG2=OpenLayers.Class(OpenLayers.Renderer.NG,{xmlns:"http://www.w3.org/2000/svg",xlinkns:"http://www.w3.org/1999/xlink",symbolMetrics:null,labelNodeType:"g",initialize:function(a){if(!this.supported()){return}OpenLayers.Renderer.Elements.prototype.initialize.apply(this,arguments);this.symbolMetrics={}},supported:function(){var a="http://www.w3.org/TR/SVG11/feature#";return(document.implementation&&(document.implementation.hasFeature("org.w3c.svg","1.0")||document.implementation.hasFeature(a+"SVG","1.1")||document.implementation.hasFeature(a+"BasicStructure","1.1")))},updateDimensions:function(a){OpenLayers.Renderer.NG.prototype.updateDimensions.apply(this,arguments);var h=this.getResolution();var c=this.extent.getWidth();var k=this.extent.getHeight();var d=[this.extent.left,-this.extent.top,c,k].join(" ");this.rendererRoot.setAttributeNS(null,"viewBox",d);this.rendererRoot.setAttributeNS(null,"width",c/h);this.rendererRoot.setAttributeNS(null,"height",k/h);if(a===true){var e,f;var b=this.vectorRoot.childNodes;for(e=0,f=b.length;e<f;++e){this.setStyle(b[e])}var g=this.textRoot.childNodes;var j;for(e=0,f=g.length;e<f;++e){j=g[e];this.drawText(j,j._style,new OpenLayers.Geometry.Point(j._x,j._y))}}},getNodeType:function(c,b){var a=null;switch(c.CLASS_NAME){case"OpenLayers.Geometry.Point":if(b.externalGraphic){a="image"}else{if(this.isComplexSymbol(b.graphicName)){a="svg"}else{a="circle"}}break;case"OpenLayers.Geometry.Rectangle":a="rect";break;case"OpenLayers.Geometry.LineString":a="polyline";break;case"OpenLayers.Geometry.LinearRing":a="polygon";break;case"OpenLayers.Geometry.Polygon":case"OpenLayers.Geometry.Curve":case"OpenLayers.Geometry.Surface":a="path";break;default:break}return a},setStyle:function(n,s,b){s=s||n._style;b=b||n._options;var q=this.getResolution();var j=n._radius;var i=q;if(n._geometryClass=="OpenLayers.Geometry.Point"&&j){n.style.visibility="";if(s.graphic===false){n.style.visibility="hidden"}else{if(s.externalGraphic){if(s.graphicTitle){n.setAttributeNS(null,"title",s.graphicTitle);var e=this.nodeFactory(null,"title");e.textContent=s.graphicTitle;n.appendChild(e)}if(s.graphicWidth&&s.graphicHeight){n.setAttributeNS(null,"preserveAspectRatio","none")}var m=s.graphicWidth||s.graphicHeight;var l=s.graphicHeight||s.graphicWidth;m=m?m:s.pointRadius*2;l=l?l:s.pointRadius*2;m*=q;l*=q;var t=(s.graphicXOffset!=undefined)?s.graphicXOffset*q:-(0.5*m);var f=(s.graphicYOffset!=undefined)?s.graphicYOffset*q:-(0.5*l);var a=s.graphicOpacity||s.fillOpacity;n.setAttributeNS(null,"x",n._x+t);n.setAttributeNS(null,"y",n._y+f);n.setAttributeNS(null,"width",m);n.setAttributeNS(null,"height",l);n.setAttributeNS(this.xlinkns,"href",s.externalGraphic);n.setAttributeNS(null,"style","opacity: "+a);n.onclick=OpenLayers.Renderer.SVG2.preventDefault}else{if(this.isComplexSymbol(s.graphicName)){var c=s.pointRadius*3*q;var k=c*2;var d=this.importSymbol(s.graphicName);i=this.symbolMetrics[d.id].size*3/k*q;var g=n.parentNode;var h=n.nextSibling;if(g){g.removeChild(n)}n.firstChild&&n.removeChild(n.firstChild);n.appendChild(d.firstChild.cloneNode(true));n.setAttributeNS(null,"viewBox",d.getAttributeNS(null,"viewBox"));n.setAttributeNS(null,"width",k);n.setAttributeNS(null,"height",k);n.setAttributeNS(null,"x",n._x-c);n.setAttributeNS(null,"y",n._y-c);if(h){g.insertBefore(n,h)}else{if(g){g.appendChild(n)}}}else{n.setAttributeNS(null,"r",s.pointRadius*q)}}}var p=s.rotation;if(p!==undefined||n._rotation!==undefined){n._rotation=p;p|=0;if(n.nodeName!=="svg"){n.setAttributeNS(null,"transform",["rotate(",p,n._x,n._y,")"].join(" "))}else{var o=this.symbolMetrics[d.id];n.firstChild.setAttributeNS(null,"transform",["rotate(",p,o.x,o.y,")"].join(" "))}}}if(b.isFilled){n.setAttributeNS(null,"fill",s.fillColor);n.setAttributeNS(null,"fill-opacity",s.fillOpacity)}else{n.setAttributeNS(null,"fill","none")}if(b.isStroked){n.setAttributeNS(null,"stroke",s.strokeColor);n.setAttributeNS(null,"stroke-opacity",s.strokeOpacity);n.setAttributeNS(null,"stroke-width",s.strokeWidth*i);n.setAttributeNS(null,"stroke-linecap",s.strokeLinecap||"round");n.setAttributeNS(null,"stroke-linejoin","round");s.strokeDashstyle&&n.setAttributeNS(null,"stroke-dasharray",this.dashStyle(s,i))}else{n.setAttributeNS(null,"stroke","none")}if(s.pointerEvents){n.setAttributeNS(null,"pointer-events",s.pointerEvents)}if(s.cursor!=null){n.setAttributeNS(null,"cursor",s.cursor)}return n},dashStyle:function(e,d){var a=e.strokeWidth*d;var g=e.strokeDashstyle;switch(g){case"solid":return"none";case"dot":return[d,4*a].join();case"dash":return[4*a,4*a].join();case"dashdot":return[4*a,4*a,d,4*a].join();case"longdash":return[8*a,4*a].join();case"longdashdot":return[8*a,4*a,d,4*a].join();default:var f=OpenLayers.String.trim(g).split(/\s+/g);for(var b=0,c=f.length;b<c;b++){f[b]=f[b]*d}return f.join()}},createNode:function(a,c){var b=document.createElementNS(this.xmlns,a);if(c){b.setAttributeNS(null,"id",c)}return b},nodeTypeCompare:function(b,a){return(a==b.nodeName)},createRenderRoot:function(){return this.nodeFactory(this.container.id+"_svgRoot","svg")},createRoot:function(a){return this.nodeFactory(this.container.id+a,"g")},createDefs:function(){var a=this.nodeFactory(this.container.id+"_defs","defs");this.rendererRoot.appendChild(a);return a},drawPoint:function(a,b){return this.drawCircle(a,b,1)},drawCircle:function(c,d,b){var a=d.x;var e=-d.y;c.setAttributeNS(null,"cx",a);c.setAttributeNS(null,"cy",e);c._x=a;c._y=e;c._radius=b;return c},drawLineString:function(a,c){var b=this.getComponentsString(c.components);a.setAttributeNS(null,"points",b);return a},drawLinearRing:function(a,c){var b=this.getComponentsString(c.components);a.setAttributeNS(null,"points",b);return a},drawPolygon:function(b,h){var g=[];var i=true;var a=true;var c,k;for(var e=0,f=h.components.length;e<f;e++){g.push("M");k=this.getComponentsString(h.components[e].components," ");g.push(k)}g.push("z");b.setAttributeNS(null,"d",g.join(" "));b.setAttributeNS(null,"fill-rule","evenodd");return b},drawRectangle:function(a,b){a.setAttributeNS(null,"x",b.x);a.setAttributeNS(null,"y",-b.y);a.setAttributeNS(null,"width",b.width);a.setAttributeNS(null,"height",b.height);return a},drawSurface:function(f,h){var g=[];var b=true;for(var e=0,a=h.components.length;e<a;e++){if((e%3)==0&&(e/3)==0){var c=this.getShortString(h.components[e]);g.push("M",c)}else{if((e%3)==1){var c=this.getShortString(h.components[e]);g.push("C",c)}else{var c=this.getShortString(h.components[e]);g.push(c)}}}g.push("Z");f.setAttributeNS(null,"d",g.join(" "));return f},drawText:function(d,a,m){var e=OpenLayers.Renderer.NG.prototype.drawText.apply(this,arguments);var n=e.firstChild||this.nodeFactory(d+this.LABEL_ID_SUFFIX+"_text","text");var j=this.getResolution();n.setAttributeNS(null,"x",m.x/j);n.setAttributeNS(null,"y",-m.y/j);e.setAttributeNS(null,"transform","scale("+j+")");if(a.fontColor){n.setAttributeNS(null,"fill",a.fontColor)}if(a.fontOpacity){n.setAttributeNS(null,"opacity",a.fontOpacity)}if(a.fontFamily){n.setAttributeNS(null,"font-family",a.fontFamily)}if(a.fontSize){n.setAttributeNS(null,"font-size",a.fontSize)}if(a.fontWeight){n.setAttributeNS(null,"font-weight",a.fontWeight)}if(a.fontStyle){n.setAttributeNS(null,"font-style",a.fontStyle)}if(a.labelSelect===true){n.setAttributeNS(null,"pointer-events","visible");n._featureId=d}else{n.setAttributeNS(null,"pointer-events","none")}var h=a.labelAlign||"cm";n.setAttributeNS(null,"text-anchor",OpenLayers.Renderer.SVG2.LABEL_ALIGN[h[0]]||"middle");if(OpenLayers.IS_GECKO===true){n.setAttributeNS(null,"dominant-baseline",OpenLayers.Renderer.SVG2.LABEL_ALIGN[h[1]]||"central")}var b=a.label.split("\n");var f=b.length;while(n.childNodes.length>f){n.removeChild(n.lastChild)}for(var c=0;c<f;c++){var k=n.childNodes[c]||this.nodeFactory(d+this.LABEL_ID_SUFFIX+"_tspan_"+c,"tspan");if(a.labelSelect===true){k._featureId=d}if(OpenLayers.IS_GECKO===false){k.setAttributeNS(null,"baseline-shift",OpenLayers.Renderer.SVG2.LABEL_VSHIFT[h[1]]||"-35%")}k.setAttribute("x",m.x/j);if(c==0){var l=OpenLayers.Renderer.SVG2.LABEL_VFACTOR[h[1]];if(l==null){l=-0.5}k.setAttribute("dy",(l*(f-1))+"em")}else{k.setAttribute("dy","1em")}k.textContent=(b[c]==="")?" ":b[c];if(!k.parentNode){n.appendChild(k)}}if(!n.parentNode){e.appendChild(n)}return e},getComponentsString:function(d,e){var b=d.length;var a=new Array(b);for(var c=0;c<b;c++){a[c]=this.getShortString(d[c])}return a.join(e||",")},getShortString:function(a){return a.x+","+(-a.y)},importSymbol:function(f){if(!this.defs){this.defs=this.createDefs()}var b=this.container.id+"-"+f;var c=document.getElementById(b);if(c!=null){return c}var e=OpenLayers.Renderer.symbol[f];if(!e){throw new Error(f+" is not a valid symbol name")}var j=this.nodeFactory(b,"symbol");var d=this.nodeFactory(null,"polygon");j.appendChild(d);var o=new OpenLayers.Bounds(Number.MAX_VALUE,Number.MAX_VALUE,0,0);var m=[];var l,k;for(var g=0,h=e.length;g<h;g=g+2){l=e[g];k=e[g+1];o.left=Math.min(o.left,l);o.bottom=Math.min(o.bottom,k);o.right=Math.max(o.right,l);o.top=Math.max(o.top,k);m.push(l,",",k)}d.setAttributeNS(null,"points",m.join(" "));var a=o.getWidth();var n=o.getHeight();var p=[o.left-a,o.bottom-n,a*3,n*3];j.setAttributeNS(null,"viewBox",p.join(" "));this.symbolMetrics[b]={size:Math.max(a,n),x:o.getCenterLonLat().lon,y:o.getCenterLonLat().lat};this.defs.appendChild(j);return j},getFeatureIdFromEvent:function(a){var c=OpenLayers.Renderer.Elements.prototype.getFeatureIdFromEvent.apply(this,arguments);if(!c){var b=a.target;c=b.parentNode&&b!=this.rendererRoot&&b.parentNode._featureId}return c},CLASS_NAME:"OpenLayers.Renderer.SVG2"});OpenLayers.Renderer.SVG2.LABEL_ALIGN={l:"start",r:"end",b:"bottom",t:"hanging"};OpenLayers.Renderer.SVG2.LABEL_VSHIFT={t:"-70%",b:"0"};OpenLayers.Renderer.SVG2.LABEL_VFACTOR={t:0,b:-1};OpenLayers.Renderer.SVG2.preventDefault=function(a){a.preventDefault&&a.preventDefault()};OpenLayers.Kinetic=OpenLayers.Class({threshold:0,interval:10,deceleration:0.0035,nbPoints:100,delay:200,points:undefined,timerId:undefined,initialize:function(a){OpenLayers.Util.extend(this,a)},begin:function(){clearInterval(this.timerId);this.timerId=undefined;this.points=[]},update:function(a){this.points.unshift({xy:a,tick:new Date().getTime()});if(this.points.length>this.nbPoints){this.points.pop()}},end:function(k){var j,a=new Date().getTime();for(var f=0,e=this.points.length,h;f<e;f++){h=this.points[f];if(a-h.tick>this.delay){break}j=h}if(!j){return}var d=new Date().getTime()-j.tick;var g=Math.sqrt(Math.pow(k.x-j.xy.x,2)+Math.pow(k.y-j.xy.y,2));var c=g/d;if(c==0||c<this.threshold){return}var b=Math.asin((k.y-j.xy.y)/g);if(j.xy.x<=k.x){b=Math.PI-b}return{speed:c,theta:b}},move:function(c,j){var i=c.speed;var g=Math.cos(c.theta);var f=-Math.sin(c.theta);var e=0;var d=new Date().getTime();var b=0;var a=0;var h=function(){if(this.timerId==null){return}e+=this.interval;var q=new Date().getTime()-d;var n=(e+q)/2;var o=(-this.deceleration*Math.pow(n,2))/2+i*n;var k=o*g;var r=o*f;var m={};m.end=false;var l=-this.deceleration*n+i;if(l<=0){clearInterval(this.timerId);this.timerId=null;m.end=true}m.x=k-b;m.y=r-a;b=k;a=r;j(m.x,m.y,m.end)};this.timerId=window.setInterval(OpenLayers.Function.bind(h,this),this.interval)},CLASS_NAME:"OpenLayers.Kinetic"});OpenLayers.ProxyHost="";OpenLayers.nullHandler=function(a){OpenLayers.Console.userError(OpenLayers.i18n("unhandledRequest",{statusText:a.statusText}))};OpenLayers.loadURL=function(d,g,b,e,c){if(typeof g=="string"){g=OpenLayers.Util.getParameters(g)}var f=(e)?e:OpenLayers.nullHandler;var a=(c)?c:OpenLayers.nullHandler;return OpenLayers.Request.GET({url:d,params:g,success:f,failure:a,scope:b})};OpenLayers.parseXMLString=function(c){var a=c.indexOf("<");if(a>0){c=c.substring(a)}var b=OpenLayers.Util.Try(function(){var d=new ActiveXObject("Microsoft.XMLDOM");d.loadXML(c);return d},function(){return new DOMParser().parseFromString(c,"text/xml")},function(){var d=new XMLHttpRequest();d.open("GET","data:text/xml;charset=utf-8,"+encodeURIComponent(c),false);if(d.overrideMimeType){d.overrideMimeType("text/xml")}d.send(null);return d.responseXML});return b};OpenLayers.Ajax={emptyFunction:function(){},getTransport:function(){return OpenLayers.Util.Try(function(){return new XMLHttpRequest()},function(){return new ActiveXObject("Msxml2.XMLHTTP")},function(){return new ActiveXObject("Microsoft.XMLHTTP")})||false},activeRequestCount:0};OpenLayers.Ajax.Responders={responders:[],register:function(b){for(var a=0;a<this.responders.length;a++){if(b==this.responders[a]){return}}this.responders.push(b)},unregister:function(a){OpenLayers.Util.removeItem(this.reponders,a)},dispatch:function(g,c,f){var a;for(var b=0;b<this.responders.length;b++){a=this.responders[b];if(a[g]&&typeof a[g]=="function"){try{a[g].apply(a,[c,f])}catch(d){}}}}};OpenLayers.Ajax.Responders.register({onCreate:function(){OpenLayers.Ajax.activeRequestCount++},onComplete:function(){OpenLayers.Ajax.activeRequestCount--}});OpenLayers.Ajax.Base=OpenLayers.Class({initialize:function(a){this.options={method:"post",asynchronous:true,contentType:"application/xml",parameters:""};OpenLayers.Util.extend(this.options,a||{});this.options.method=this.options.method.toLowerCase();if(typeof this.options.parameters=="string"){this.options.parameters=OpenLayers.Util.getParameters(this.options.parameters)}}});OpenLayers.Ajax.Request=OpenLayers.Class(OpenLayers.Ajax.Base,{_complete:false,initialize:function(b,a){OpenLayers.Ajax.Base.prototype.initialize.apply(this,[a]);if(OpenLayers.ProxyHost&&OpenLayers.String.startsWith(b,"http")){b=OpenLayers.ProxyHost+encodeURIComponent(b)}this.transport=OpenLayers.Ajax.getTransport();this.request(b)},request:function(b){this.url=b;this.method=this.options.method;var d=OpenLayers.Util.extend({},this.options.parameters);if(this.method!="get"&&this.method!="post"){d._method=this.method;this.method="post"}this.parameters=d;if(d=OpenLayers.Util.getParameterString(d)){if(this.method=="get"){this.url+=((this.url.indexOf("?")>-1)?"&":"?")+d}else{if(/Konqueror|Safari|KHTML/.test(navigator.userAgent)){d+="&_="}}}try{var a=new OpenLayers.Ajax.Response(this);if(this.options.onCreate){this.options.onCreate(a)}OpenLayers.Ajax.Responders.dispatch("onCreate",this,a);this.transport.open(this.method.toUpperCase(),this.url,this.options.asynchronous);if(this.options.asynchronous){window.setTimeout(OpenLayers.Function.bind(this.respondToReadyState,this,1),10)}this.transport.onreadystatechange=OpenLayers.Function.bind(this.onStateChange,this);this.setRequestHeaders();this.body=this.method=="post"?(this.options.postBody||d):null;this.transport.send(this.body);if(!this.options.asynchronous&&this.transport.overrideMimeType){this.onStateChange()}}catch(c){this.dispatchException(c)}},onStateChange:function(){var a=this.transport.readyState;if(a>1&&!((a==4)&&this._complete)){this.respondToReadyState(this.transport.readyState)}},setRequestHeaders:function(){var e={"X-Requested-With":"XMLHttpRequest",Accept:"text/javascript, text/html, application/xml, text/xml, */*",OpenLayers:true};if(this.method=="post"){e["Content-type"]=this.options.contentType+(this.options.encoding?"; charset="+this.options.encoding:"");if(this.transport.overrideMimeType&&(navigator.userAgent.match(/Gecko\/(\d{4})/)||[0,2005])[1]<2005){e.Connection="close"}}if(typeof this.options.requestHeaders=="object"){var c=this.options.requestHeaders;if(typeof c.push=="function"){for(var b=0,d=c.length;b<d;b+=2){e[c[b]]=c[b+1]}}else{for(var b in c){e[b]=c[b]}}}for(var a in e){this.transport.setRequestHeader(a,e[a])}},success:function(){var a=this.getStatus();return !a||(a>=200&&a<300)},getStatus:function(){try{return this.transport.status||0}catch(a){return 0}},respondToReadyState:function(a){var c=OpenLayers.Ajax.Request.Events[a];var b=new OpenLayers.Ajax.Response(this);if(c=="Complete"){try{this._complete=true;(this.options["on"+b.status]||this.options["on"+(this.success()?"Success":"Failure")]||OpenLayers.Ajax.emptyFunction)(b)}catch(d){this.dispatchException(d)}var f=b.getHeader("Content-type")}try{(this.options["on"+c]||OpenLayers.Ajax.emptyFunction)(b);OpenLayers.Ajax.Responders.dispatch("on"+c,this,b)}catch(d){this.dispatchException(d)}if(c=="Complete"){this.transport.onreadystatechange=OpenLayers.Ajax.emptyFunction}},getHeader:function(a){try{return this.transport.getResponseHeader(a)}catch(b){return null}},dispatchException:function(c){var d=this.options.onException;if(d){d(this,c);OpenLayers.Ajax.Responders.dispatch("onException",this,c)}else{var e=false;var a=OpenLayers.Ajax.Responders.responders;for(var b=0;b<a.length;b++){if(a[b].onException){e=true;break}}if(e){OpenLayers.Ajax.Responders.dispatch("onException",this,c)}else{throw c}}}});OpenLayers.Ajax.Request.Events=["Uninitialized","Loading","Loaded","Interactive","Complete"];OpenLayers.Ajax.Response=OpenLayers.Class({status:0,statusText:"",initialize:function(c){this.request=c;var d=this.transport=c.transport,a=this.readyState=d.readyState;if((a>2&&!(!!(window.attachEvent&&!window.opera)))||a==4){this.status=this.getStatus();this.statusText=this.getStatusText();this.responseText=d.responseText==null?"":String(d.responseText)}if(a==4){var b=d.responseXML;this.responseXML=b===undefined?null:b}},getStatus:OpenLayers.Ajax.Request.prototype.getStatus,getStatusText:function(){try{return this.transport.statusText||""}catch(a){return""}},getHeader:OpenLayers.Ajax.Request.prototype.getHeader,getResponseHeader:function(a){return this.transport.getResponseHeader(a)}});OpenLayers.Ajax.getElementsByTagNameNS=function(b,a,c,e){var d=null;if(b.getElementsByTagNameNS){d=b.getElementsByTagNameNS(a,e)}else{d=b.getElementsByTagName(c+":"+e)}return d};OpenLayers.Ajax.serializeXMLToString=function(a){var b=new XMLSerializer();var c=b.serializeToString(a);return c};OpenLayers.Layer.GeoRSS=OpenLayers.Class(OpenLayers.Layer.Markers,{location:null,features:null,formatOptions:null,selectedFeature:null,icon:null,popupSize:null,useFeedTitle:true,initialize:function(c,a,b){OpenLayers.Layer.Markers.prototype.initialize.apply(this,[c,b]);this.location=a;this.features=[]},destroy:function(){OpenLayers.Layer.Markers.prototype.destroy.apply(this,arguments);this.clearFeatures();this.features=null},loadRSS:function(){if(!this.loaded){this.events.triggerEvent("loadstart");OpenLayers.Request.GET({url:this.location,success:this.parseData,scope:this});this.loaded=true}},moveTo:function(c,a,b){OpenLayers.Layer.Markers.prototype.moveTo.apply(this,arguments);if(this.visibility&&!this.loaded){this.loadRSS()}},parseData:function(k){var o=k.responseXML;if(!o||!o.documentElement){o=OpenLayers.Format.XML.prototype.read(k.responseText)}if(this.useFeedTitle){var a=null;try{a=o.getElementsByTagNameNS("*","title")[0].firstChild.nodeValue}catch(j){a=o.getElementsByTagName("title")[0].firstChild.nodeValue}if(a){this.setName(a)}}var s={};OpenLayers.Util.extend(s,this.formatOptions);if(this.map&&!this.projection.equals(this.map.getProjectionObject())){s.externalProjection=this.projection;s.internalProjection=this.map.getProjectionObject()}var p=new OpenLayers.Format.GeoRSS(s);var b=p.read(o);for(var g=0,h=b.length;g<h;g++){var f={};var r=b[g];if(!r.geometry){continue}var m=r.attributes.title?r.attributes.title:"Untitled";var q=r.attributes.description?r.attributes.description:"No description.";var l=r.attributes.link?r.attributes.link:"";var n=r.geometry.getBounds().getCenterLonLat();f.icon=this.icon==null?OpenLayers.Marker.defaultIcon():this.icon.clone();f.popupSize=this.popupSize?this.popupSize.clone():new OpenLayers.Size(250,120);if(m||q){f.title=m;f.description=q;var c='<div class="olLayerGeoRSSClose">[x]</div>';c+='<div class="olLayerGeoRSSTitle">';if(l){c+='<a class="link" href="'+l+'" target="_blank">'}c+=m;if(l){c+="</a>"}c+="</div>";c+='<div style="" class="olLayerGeoRSSDescription">';c+=q;c+="</div>";f.popupContentHTML=c}var r=new OpenLayers.Feature(this,n,f);this.features.push(r);var d=r.createMarker();d.events.register("click",r,this.markerClick);this.addMarker(d)}this.events.triggerEvent("loadend")},markerClick:function(c){var e=(this==this.layer.selectedFeature);this.layer.selectedFeature=(!e)?this:null;for(var d=0,a=this.layer.map.popups.length;d<a;d++){this.layer.map.removePopup(this.layer.map.popups[d])}if(!e){var b=this.createPopup();OpenLayers.Event.observe(b.div,"click",OpenLayers.Function.bind(function(){for(var g=0,f=this.layer.map.popups.length;g<f;g++){this.layer.map.removePopup(this.layer.map.popups[g])}},this));this.layer.map.addPopup(b)}OpenLayers.Event.stop(c)},clearFeatures:function(){if(this.features!=null){while(this.features.length>0){var a=this.features[0];OpenLayers.Util.removeItem(this.features,a);a.destroy()}}},CLASS_NAME:"OpenLayers.Layer.GeoRSS"});OpenLayers.Format.SOSCapabilities=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.0.0",CLASS_NAME:"OpenLayers.Format.SOSCapabilities"});OpenLayers.Layer.KaMap=OpenLayers.Class(OpenLayers.Layer.Grid,{isBaseLayer:true,units:null,resolution:OpenLayers.DOTS_PER_INCH,DEFAULT_PARAMS:{i:"jpeg",map:""},initialize:function(d,c,e,b){var a=[];a.push(d,c,e,b);OpenLayers.Layer.Grid.prototype.initialize.apply(this,a);this.params=OpenLayers.Util.applyDefaults(this.params,this.DEFAULT_PARAMS)},getURL:function(c){c=this.adjustBounds(c);var d=this.map.getResolution();var e=Math.round((this.map.getScale()*10000))/10000;var b=Math.round(c.left/d);var a=-Math.round(c.top/d);return this.getFullRequestString({t:a,l:b,s:e})},calculateGridLayout:function(a,n,e){var k=e*this.tileSize.w;var c=e*this.tileSize.h;var i=a.left;var l=Math.floor(i/k)-this.buffer;var j=i/k-l;var f=-j*this.tileSize.w;var m=l*k;var b=a.top;var h=Math.ceil(b/c)+this.buffer;var o=h-b/c;var d=-(o+1)*this.tileSize.h;var g=h*c;return{tilelon:k,tilelat:c,tileoffsetlon:m,tileoffsetlat:g,tileoffsetx:f,tileoffsety:d}},clone:function(a){if(a==null){a=new OpenLayers.Layer.KaMap(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);if(this.tileSize!=null){a.tileSize=this.tileSize.clone()}a.grid=[];return a},getTileBounds:function(c){var e=this.getResolution();var d=e*this.tileSize.w;var b=e*this.tileSize.h;var g=this.getLonLatFromViewPortPx(c);var a=d*Math.floor(g.lon/d);var f=b*Math.floor(g.lat/b);return new OpenLayers.Bounds(a,f,a+d,f+b)},CLASS_NAME:"OpenLayers.Layer.KaMap"});OpenLayers.Format.WMC=OpenLayers.Class(OpenLayers.Format.Context,{defaultVersion:"1.1.0",layerToContext:function(c){var g=this.getParser();var e={queryable:c.queryable,visibility:c.visibility,name:c.params.LAYERS,title:c.name,"abstract":c.metadata["abstract"],dataURL:c.metadata.dataURL,metadataURL:c.metadataURL,server:{version:c.params.VERSION,url:c.url},maxExtent:c.maxExtent,transparent:c.params.TRANSPARENT,numZoomLevels:c.numZoomLevels,units:c.units,isBaseLayer:c.isBaseLayer,opacity:c.opacity,displayInLayerSwitcher:c.displayInLayerSwitcher,singleTile:c.singleTile,tileSize:(c.singleTile||!c.tileSize)?undefined:{width:c.tileSize.w,height:c.tileSize.h},minScale:(c.options.resolutions||c.options.scales||c.options.maxResolution||c.options.minScale)?c.minScale:undefined,maxScale:(c.options.resolutions||c.options.scales||c.options.minResolution||c.options.maxScale)?c.maxScale:undefined,formats:[],styles:[],srs:c.srs,dimensions:c.dimensions};if(c.metadata.servertitle){e.server.title=c.metadata.servertitle}if(c.metadata.formats&&c.metadata.formats.length>0){for(var b=0,a=c.metadata.formats.length;b<a;b++){var f=c.metadata.formats[b];e.formats.push({value:f.value,current:(f.value==c.params.FORMAT)})}}else{e.formats.push({value:c.params.FORMAT,current:true})}if(c.metadata.styles&&c.metadata.styles.length>0){for(var b=0,a=c.metadata.styles.length;b<a;b++){var d=c.metadata.styles[b];if((d.href==c.params.SLD)||(d.body==c.params.SLD_BODY)||(d.name==c.params.STYLES)){d.current=true}else{d.current=false}e.styles.push(d)}}else{e.styles.push({href:c.params.SLD,body:c.params.SLD_BODY,name:c.params.STYLES||g.defaultStyleName,title:g.defaultStyleTitle,current:true})}return e},toContext:function(g){var e={};var f=g.layers;if(g.CLASS_NAME=="OpenLayers.Map"){var d=g.metadata||{};e.size=g.getSize();e.bounds=g.getExtent();e.projection=g.projection;e.title=g.title;e.keywords=d.keywords;e["abstract"]=d["abstract"];e.logo=d.logo;e.descriptionURL=d.descriptionURL;e.contactInformation=d.contactInformation;e.maxExtent=g.maxExtent}else{OpenLayers.Util.applyDefaults(e,g);if(e.layers!=undefined){delete (e.layers)}}if(e.layersContext==undefined){e.layersContext=[]}if(f!=undefined&&OpenLayers.Util.isArray(f)){for(var c=0,a=f.length;c<a;c++){var b=f[c];if(b instanceof OpenLayers.Layer.WMS){e.layersContext.push(this.layerToContext(b))}}}return e},CLASS_NAME:"OpenLayers.Format.WMC"});OpenLayers.Format.WMC.v1=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{ol:"http://openlayers.org/context",wmc:"http://www.opengis.net/context",sld:"http://www.opengis.net/sld",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},schemaLocation:"",getNamespacePrefix:function(a){var b=null;if(a==null){b=this.namespaces[this.defaultPrefix]}else{for(b in this.namespaces){if(this.namespaces[b]==a){break}}}return b},defaultPrefix:"wmc",rootPrefix:null,defaultStyleName:"",defaultStyleTitle:"Default",initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(c){if(typeof c=="string"){c=OpenLayers.Format.XML.prototype.read.apply(this,[c])}var a=c.documentElement;this.rootPrefix=a.prefix;var b={version:a.getAttribute("version")};this.runChildNodes(b,a);return b},runChildNodes:function(e,d){var b=d.childNodes;var a,c,g,j;for(var f=0,h=b.length;f<h;++f){a=b[f];if(a.nodeType==1){g=this.getNamespacePrefix(a.namespaceURI);j=a.nodeName.split(":").pop();c=this["read_"+g+"_"+j];if(c){c.apply(this,[e,a])}}}},read_wmc_General:function(a,b){this.runChildNodes(a,b)},read_wmc_BoundingBox:function(a,b){a.projection=b.getAttribute("SRS");a.bounds=new OpenLayers.Bounds(parseFloat(b.getAttribute("minx")),parseFloat(b.getAttribute("miny")),parseFloat(b.getAttribute("maxx")),parseFloat(b.getAttribute("maxy")))},read_wmc_LayerList:function(a,b){a.layersContext=[];this.runChildNodes(a,b)},read_wmc_Layer:function(a,b){var c={visibility:(b.getAttribute("hidden")!="1"),queryable:(b.getAttribute("queryable")=="1"),formats:[],styles:[],metadata:{}};this.runChildNodes(c,b);a.layersContext.push(c)},read_wmc_Extension:function(b,a){this.runChildNodes(b,a)},read_ol_units:function(b,a){b.units=this.getChildValue(a)},read_ol_maxExtent:function(c,b){var a=new OpenLayers.Bounds(b.getAttribute("minx"),b.getAttribute("miny"),b.getAttribute("maxx"),b.getAttribute("maxy"));c.maxExtent=a},read_ol_transparent:function(b,a){b.transparent=this.getChildValue(a)},read_ol_numZoomLevels:function(b,a){b.numZoomLevels=parseInt(this.getChildValue(a))},read_ol_opacity:function(b,a){b.opacity=parseFloat(this.getChildValue(a))},read_ol_singleTile:function(b,a){b.singleTile=(this.getChildValue(a)=="true")},read_ol_tileSize:function(b,a){var c={width:a.getAttribute("width"),height:a.getAttribute("height")};b.tileSize=c},read_ol_isBaseLayer:function(b,a){b.isBaseLayer=(this.getChildValue(a)=="true")},read_ol_displayInLayerSwitcher:function(b,a){b.displayInLayerSwitcher=(this.getChildValue(a)=="true")},read_wmc_Server:function(b,a){b.version=a.getAttribute("version");b.url=this.getOnlineResource_href(a);b.metadata.servertitle=a.getAttribute("title")},read_wmc_FormatList:function(b,a){this.runChildNodes(b,a)},read_wmc_Format:function(b,a){var c={value:this.getChildValue(a)};if(a.getAttribute("current")=="1"){c.current=true}b.formats.push(c)},read_wmc_StyleList:function(b,a){this.runChildNodes(b,a)},read_wmc_Style:function(c,b){var a={};this.runChildNodes(a,b);if(b.getAttribute("current")=="1"){a.current=true}c.styles.push(a)},read_wmc_SLD:function(a,b){this.runChildNodes(a,b)},read_sld_StyledLayerDescriptor:function(c,b){var a=OpenLayers.Format.XML.prototype.write.apply(this,[b]);c.body=a},read_sld_FeatureTypeStyle:function(c,b){var a=OpenLayers.Format.XML.prototype.write.apply(this,[b]);c.body=a},read_wmc_OnlineResource:function(b,a){b.href=this.getAttributeNS(a,this.namespaces.xlink,"href")},read_wmc_Name:function(c,b){var a=this.getChildValue(b);if(a){c.name=a}},read_wmc_Title:function(b,a){var c=this.getChildValue(a);if(c){b.title=c}},read_wmc_MetadataURL:function(b,a){b.metadataURL=this.getOnlineResource_href(a)},read_wmc_KeywordList:function(a,b){a.keywords=[];this.runChildNodes(a.keywords,b)},read_wmc_Keyword:function(a,b){a.push(this.getChildValue(b))},read_wmc_Abstract:function(c,b){var a=this.getChildValue(b);if(a){c["abstract"]=a}},read_wmc_LogoURL:function(a,b){a.logo={width:b.getAttribute("width"),height:b.getAttribute("height"),format:b.getAttribute("format"),href:this.getOnlineResource_href(b)}},read_wmc_DescriptionURL:function(a,b){a.descriptionURL=this.getOnlineResource_href(b)},read_wmc_ContactInformation:function(c,b){var a={};this.runChildNodes(a,b);c.contactInformation=a},read_wmc_ContactPersonPrimary:function(b,c){var a={};this.runChildNodes(a,c);b.personPrimary=a},read_wmc_ContactPerson:function(b,c){var a=this.getChildValue(c);if(a){b.person=a}},read_wmc_ContactOrganization:function(b,c){var a=this.getChildValue(c);if(a){b.organization=a}},read_wmc_ContactPosition:function(b,c){var a=this.getChildValue(c);if(a){b.position=a}},read_wmc_ContactAddress:function(a,b){var c={};this.runChildNodes(c,b);a.contactAddress=c},read_wmc_AddressType:function(c,b){var a=this.getChildValue(b);if(a){c.type=a}},read_wmc_Address:function(c,b){var a=this.getChildValue(b);if(a){c.address=a}},read_wmc_City:function(c,a){var b=this.getChildValue(a);if(b){c.city=b}},read_wmc_StateOrProvince:function(c,a){var b=this.getChildValue(a);if(b){c.stateOrProvince=b}},read_wmc_PostCode:function(c,b){var a=this.getChildValue(b);if(a){c.postcode=a}},read_wmc_Country:function(c,a){var b=this.getChildValue(a);if(b){c.country=b}},read_wmc_ContactVoiceTelephone:function(a,c){var b=this.getChildValue(c);if(b){a.phone=b}},read_wmc_ContactFacsimileTelephone:function(a,c){var b=this.getChildValue(c);if(b){a.fax=b}},read_wmc_ContactElectronicMailAddress:function(a,c){var b=this.getChildValue(c);if(b){a.email=b}},read_wmc_DataURL:function(b,a){b.dataURL=this.getOnlineResource_href(a)},read_wmc_LegendURL:function(b,c){var a={width:c.getAttribute("width"),height:c.getAttribute("height"),format:c.getAttribute("format"),href:this.getOnlineResource_href(c)};b.legend=a},read_wmc_DimensionList:function(b,a){b.dimensions={};this.runChildNodes(b.dimensions,a)},read_wmc_Dimension:function(d,c){var b=c.getAttribute("name").toLowerCase();var e={name:b,units:c.getAttribute("units")||"",unitSymbol:c.getAttribute("unitSymbol")||"",userValue:c.getAttribute("userValue")||"",nearestValue:c.getAttribute("nearestValue")==="1",multipleValues:c.getAttribute("multipleValues")==="1",current:c.getAttribute("current")==="1","default":c.getAttribute("default")||""};var a=this.getChildValue(c);e.values=a.split(",");d[e.name]=e},write:function(c,b){var a=this.createElementDefaultNS("ViewContext");this.setAttributes(a,{version:this.VERSION,id:(b&&typeof b.id=="string")?b.id:OpenLayers.Util.createUniqueID("OpenLayers_Context_")});this.setAttributeNS(a,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);a.appendChild(this.write_wmc_General(c));a.appendChild(this.write_wmc_LayerList(c));return OpenLayers.Format.XML.prototype.write.apply(this,[a])},createElementDefaultNS:function(c,b,a){var d=this.createElementNS(this.namespaces[this.defaultPrefix],c);if(b){d.appendChild(this.createTextNode(b))}if(a){this.setAttributes(d,a)}return d},setAttributes:function(b,d){var c;for(var a in d){c=d[a].toString();if(c.match(/[A-Z]/)){this.setAttributeNS(b,null,a,c)}else{b.setAttribute(a,c)}}},write_wmc_General:function(a){var c=this.createElementDefaultNS("General");if(a.size){c.appendChild(this.createElementDefaultNS("Window",null,{width:a.size.w,height:a.size.h}))}var b=a.bounds;c.appendChild(this.createElementDefaultNS("BoundingBox",null,{minx:b.left.toPrecision(18),miny:b.bottom.toPrecision(18),maxx:b.right.toPrecision(18),maxy:b.top.toPrecision(18),SRS:a.projection}));c.appendChild(this.createElementDefaultNS("Title",a.title));if(a.keywords){c.appendChild(this.write_wmc_KeywordList(a.keywords))}if(a["abstract"]){c.appendChild(this.createElementDefaultNS("Abstract",a["abstract"]))}if(a.logo){c.appendChild(this.write_wmc_URLType("LogoURL",a.logo.href,a.logo))}if(a.descriptionURL){c.appendChild(this.write_wmc_URLType("DescriptionURL",a.descriptionURL))}if(a.contactInformation){c.appendChild(this.write_wmc_ContactInformation(a.contactInformation))}c.appendChild(this.write_ol_MapExtension(a));return c},write_wmc_KeywordList:function(c){var d=this.createElementDefaultNS("KeywordList");for(var b=0,a=c.length;b<a;b++){d.appendChild(this.createElementDefaultNS("Keyword",c[b]))}return d},write_wmc_ContactInformation:function(a){var b=this.createElementDefaultNS("ContactInformation");if(a.personPrimary){b.appendChild(this.write_wmc_ContactPersonPrimary(a.personPrimary))}if(a.position){b.appendChild(this.createElementDefaultNS("ContactPosition",a.position))}if(a.contactAddress){b.appendChild(this.write_wmc_ContactAddress(a.contactAddress))}if(a.phone){b.appendChild(this.createElementDefaultNS("ContactVoiceTelephone",a.phone))}if(a.fax){b.appendChild(this.createElementDefaultNS("ContactFacsimileTelephone",a.fax))}if(a.email){b.appendChild(this.createElementDefaultNS("ContactElectronicMailAddress",a.email))}return b},write_wmc_ContactPersonPrimary:function(a){var b=this.createElementDefaultNS("ContactPersonPrimary");if(a.person){b.appendChild(this.createElementDefaultNS("ContactPerson",a.person))}if(a.organization){b.appendChild(this.createElementDefaultNS("ContactOrganization",a.organization))}return b},write_wmc_ContactAddress:function(b){var a=this.createElementDefaultNS("ContactAddress");if(b.type){a.appendChild(this.createElementDefaultNS("AddressType",b.type))}if(b.address){a.appendChild(this.createElementDefaultNS("Address",b.address))}if(b.city){a.appendChild(this.createElementDefaultNS("City",b.city))}if(b.stateOrProvince){a.appendChild(this.createElementDefaultNS("StateOrProvince",b.stateOrProvince))}if(b.postcode){a.appendChild(this.createElementDefaultNS("PostCode",b.postcode))}if(b.country){a.appendChild(this.createElementDefaultNS("Country",b.country))}return a},write_ol_MapExtension:function(b){var d=this.createElementDefaultNS("Extension");var c=b.maxExtent;if(c){var a=this.createElementNS(this.namespaces.ol,"ol:maxExtent");this.setAttributes(a,{minx:c.left.toPrecision(18),miny:c.bottom.toPrecision(18),maxx:c.right.toPrecision(18),maxy:c.top.toPrecision(18)});d.appendChild(a)}return d},write_wmc_LayerList:function(c){var d=this.createElementDefaultNS("LayerList");for(var b=0,a=c.layersContext.length;b<a;++b){d.appendChild(this.write_wmc_Layer(c.layersContext[b]))}return d},write_wmc_Layer:function(a){var b=this.createElementDefaultNS("Layer",null,{queryable:a.queryable?"1":"0",hidden:a.visibility?"0":"1"});b.appendChild(this.write_wmc_Server(a));b.appendChild(this.createElementDefaultNS("Name",a.name));b.appendChild(this.createElementDefaultNS("Title",a.title));if(a["abstract"]){b.appendChild(this.createElementDefaultNS("Abstract",a["abstract"]))}if(a.dataURL){b.appendChild(this.write_wmc_URLType("DataURL",a.dataURL))}if(a.metadataURL){b.appendChild(this.write_wmc_URLType("MetadataURL",a.metadataURL))}return b},write_wmc_LayerExtension:function(b){var d=this.createElementDefaultNS("Extension");var a=b.maxExtent;var h=this.createElementNS(this.namespaces.ol,"ol:maxExtent");this.setAttributes(h,{minx:a.left.toPrecision(18),miny:a.bottom.toPrecision(18),maxx:a.right.toPrecision(18),maxy:a.top.toPrecision(18)});d.appendChild(h);if(b.tileSize&&!b.singleTile){var j=this.createElementNS(this.namespaces.ol,"ol:tileSize");this.setAttributes(j,b.tileSize);d.appendChild(j)}var g=["transparent","numZoomLevels","units","isBaseLayer","opacity","displayInLayerSwitcher","singleTile"];var c;for(var e=0,f=g.length;e<f;++e){c=this.createOLPropertyNode(b,g[e]);if(c){d.appendChild(c)}}return d},createOLPropertyNode:function(b,c){var a=null;if(b[c]!=null){a=this.createElementNS(this.namespaces.ol,"ol:"+c);a.appendChild(this.createTextNode(b[c].toString()))}return a},write_wmc_Server:function(b){var d=b.server;var c=this.createElementDefaultNS("Server");var a={service:"OGC:WMS",version:d.version};if(d.title){a.title=d.title}this.setAttributes(c,a);c.appendChild(this.write_wmc_OnlineResource(d.url));return c},write_wmc_URLType:function(f,b,a){var e=this.createElementDefaultNS(f);e.appendChild(this.write_wmc_OnlineResource(b));if(a){var d=["width","height","format"];for(var c=0;c<d.length;c++){if(d[c] in a){e.setAttribute(d[c],a[d[c]])}}}return e},write_wmc_DimensionList:function(e){var f=this.createElementDefaultNS("DimensionList");var d={name:true,units:true,unitSymbol:true,userValue:true};for(var h in e.dimensions){var b={};var g=e.dimensions[h];for(var c in g){if(typeof g[c]=="boolean"){b[c]=Number(g[c])}else{b[c]=g[c]}}var a="";if(b.values){a=b.values.join(",");delete b.values}f.appendChild(this.createElementDefaultNS("Dimension",a,b))}return f},write_wmc_FormatList:function(c){var d=this.createElementDefaultNS("FormatList");for(var b=0,a=c.formats.length;b<a;b++){var e=c.formats[b];d.appendChild(this.createElementDefaultNS("Format",e.value,(e.current&&e.current==true)?{current:"1"}:null))}return d},write_wmc_StyleList:function(e){var c=this.createElementDefaultNS("StyleList");var k=e.styles;if(k&&OpenLayers.Util.isArray(k)){var a;for(var d=0,f=k.length;d<f;d++){var l=k[d];var b=this.createElementDefaultNS("Style",null,(l.current&&l.current==true)?{current:"1"}:null);if(l.href){a=this.createElementDefaultNS("SLD");if(l.name){a.appendChild(this.createElementDefaultNS("Name",l.name))}if(l.title){a.appendChild(this.createElementDefaultNS("Title",l.title))}if(l.legend){a.appendChild(this.write_wmc_URLType("LegendURL",l.legend.href,l.legend))}var g=this.write_wmc_OnlineResource(l.href);a.appendChild(g);b.appendChild(a)}else{if(l.body){a=this.createElementDefaultNS("SLD");if(l.name){a.appendChild(this.createElementDefaultNS("Name",l.name))}if(l.title){a.appendChild(this.createElementDefaultNS("Title",l.title))}if(l.legend){a.appendChild(this.write_wmc_URLType("LegendURL",l.legend.href,l.legend))}var h=OpenLayers.Format.XML.prototype.read.apply(this,[l.body]);var j=h.documentElement;if(a.ownerDocument&&a.ownerDocument.importNode){j=a.ownerDocument.importNode(j,true)}a.appendChild(j);b.appendChild(a)}else{b.appendChild(this.createElementDefaultNS("Name",l.name));b.appendChild(this.createElementDefaultNS("Title",l.title));if(l["abstract"]){b.appendChild(this.createElementDefaultNS("Abstract",l["abstract"]))}if(l.legend){b.appendChild(this.write_wmc_URLType("LegendURL",l.legend.href,l.legend))}}}c.appendChild(b)}}return c},write_wmc_OnlineResource:function(a){var b=this.createElementDefaultNS("OnlineResource");this.setAttributeNS(b,this.namespaces.xlink,"xlink:type","simple");this.setAttributeNS(b,this.namespaces.xlink,"xlink:href",a);return b},getOnlineResource_href:function(c){var b={};var a=c.getElementsByTagName("OnlineResource");if(a.length>0){this.read_wmc_OnlineResource(b,a[0])}return b.href},CLASS_NAME:"OpenLayers.Format.WMC.v1"});OpenLayers.Format.WMC.v1_1_0=OpenLayers.Class(OpenLayers.Format.WMC.v1,{VERSION:"1.1.0",schemaLocation:"http://www.opengis.net/context http://schemas.opengis.net/context/1.1.0/context.xsd",initialize:function(a){OpenLayers.Format.WMC.v1.prototype.initialize.apply(this,[a])},read_sld_MinScaleDenominator:function(c,b){var a=parseFloat(this.getChildValue(b));if(a>0){c.maxScale=a}},read_sld_MaxScaleDenominator:function(b,a){b.minScale=parseFloat(this.getChildValue(a))},read_wmc_SRS:function(b,a){if(!("srs" in b)){b.srs={}}b.srs[this.getChildValue(a)]=true},write_wmc_Layer:function(c){var d=OpenLayers.Format.WMC.v1.prototype.write_wmc_Layer.apply(this,[c]);if(c.maxScale){var e=this.createElementNS(this.namespaces.sld,"sld:MinScaleDenominator");e.appendChild(this.createTextNode(c.maxScale.toPrecision(16)));d.appendChild(e)}if(c.minScale){var a=this.createElementNS(this.namespaces.sld,"sld:MaxScaleDenominator");a.appendChild(this.createTextNode(c.minScale.toPrecision(16)));d.appendChild(a)}if(c.srs){for(var b in c.srs){d.appendChild(this.createElementDefaultNS("SRS",b))}}d.appendChild(this.write_wmc_FormatList(c));d.appendChild(this.write_wmc_StyleList(c));if(c.dimensions){d.appendChild(this.write_wmc_DimensionList(c))}d.appendChild(this.write_wmc_LayerExtension(c));return d},CLASS_NAME:"OpenLayers.Format.WMC.v1_1_0"});OpenLayers.Renderer.SVG=OpenLayers.Class(OpenLayers.Renderer.Elements,{xmlns:"http://www.w3.org/2000/svg",xlinkns:"http://www.w3.org/1999/xlink",MAX_PIXEL:15000,translationParameters:null,symbolMetrics:null,initialize:function(a){if(!this.supported()){return}OpenLayers.Renderer.Elements.prototype.initialize.apply(this,arguments);this.translationParameters={x:0,y:0};this.symbolMetrics={}},supported:function(){var a="http://www.w3.org/TR/SVG11/feature#";return(document.implementation&&(document.implementation.hasFeature("org.w3c.svg","1.0")||document.implementation.hasFeature(a+"SVG","1.1")||document.implementation.hasFeature(a+"BasicStructure","1.1")))},inValidRange:function(a,e,b){var d=a+(b?0:this.translationParameters.x);var c=e+(b?0:this.translationParameters.y);return(d>=-this.MAX_PIXEL&&d<=this.MAX_PIXEL&&c>=-this.MAX_PIXEL&&c<=this.MAX_PIXEL)},setExtent:function(b,d){OpenLayers.Renderer.Elements.prototype.setExtent.apply(this,arguments);var a=this.getResolution();var f=-b.left/a;var e=b.top/a;if(d){this.left=f;this.top=e;var c="0 0 "+this.size.w+" "+this.size.h;this.rendererRoot.setAttributeNS(null,"viewBox",c);this.translate(0,0);return true}else{var g=this.translate(f-this.left,e-this.top);if(!g){this.setExtent(b,true)}return g}},translate:function(a,c){if(!this.inValidRange(a,c,true)){return false}else{var b="";if(a||c){b="translate("+a+","+c+")"}this.root.setAttributeNS(null,"transform",b);this.translationParameters={x:a,y:c};return true}},setSize:function(a){OpenLayers.Renderer.prototype.setSize.apply(this,arguments);this.rendererRoot.setAttributeNS(null,"width",this.size.w);this.rendererRoot.setAttributeNS(null,"height",this.size.h)},getNodeType:function(c,b){var a=null;switch(c.CLASS_NAME){case"OpenLayers.Geometry.Point":if(b.externalGraphic){a="image"}else{if(this.isComplexSymbol(b.graphicName)){a="svg"}else{a="circle"}}break;case"OpenLayers.Geometry.Rectangle":a="rect";break;case"OpenLayers.Geometry.LineString":a="polyline";break;case"OpenLayers.Geometry.LinearRing":a="polygon";break;case"OpenLayers.Geometry.Polygon":case"OpenLayers.Geometry.Curve":case"OpenLayers.Geometry.Surface":a="path";break;default:break}return a},setStyle:function(o,s,b){s=s||o._style;b=b||o._options;var k=parseFloat(o.getAttributeNS(null,"r"));var j=1;var d;if(o._geometryClass=="OpenLayers.Geometry.Point"&&k){o.style.visibility="";if(s.graphic===false){o.style.visibility="hidden"}else{if(s.externalGraphic){d=this.getPosition(o);if(s.graphicTitle){o.setAttributeNS(null,"title",s.graphicTitle);var f=this.nodeFactory(null,"title");f.textContent=s.graphicTitle;o.appendChild(f)}if(s.graphicWidth&&s.graphicHeight){o.setAttributeNS(null,"preserveAspectRatio","none")}var n=s.graphicWidth||s.graphicHeight;var m=s.graphicHeight||s.graphicWidth;n=n?n:s.pointRadius*2;m=m?m:s.pointRadius*2;var t=(s.graphicXOffset!=undefined)?s.graphicXOffset:-(0.5*n);var g=(s.graphicYOffset!=undefined)?s.graphicYOffset:-(0.5*m);var a=s.graphicOpacity||s.fillOpacity;o.setAttributeNS(null,"x",(d.x+t).toFixed());o.setAttributeNS(null,"y",(d.y+g).toFixed());o.setAttributeNS(null,"width",n);o.setAttributeNS(null,"height",m);o.setAttributeNS(this.xlinkns,"href",s.externalGraphic);o.setAttributeNS(null,"style","opacity: "+a);o.onclick=OpenLayers.Renderer.SVG.preventDefault}else{if(this.isComplexSymbol(s.graphicName)){var c=s.pointRadius*3;var l=c*2;var e=this.importSymbol(s.graphicName);d=this.getPosition(o);j=this.symbolMetrics[e.id][0]*3/l;var h=o.parentNode;var i=o.nextSibling;if(h){h.removeChild(o)}o.firstChild&&o.removeChild(o.firstChild);o.appendChild(e.firstChild.cloneNode(true));o.setAttributeNS(null,"viewBox",e.getAttributeNS(null,"viewBox"));o.setAttributeNS(null,"width",l);o.setAttributeNS(null,"height",l);o.setAttributeNS(null,"x",d.x-c);o.setAttributeNS(null,"y",d.y-c);if(i){h.insertBefore(o,i)}else{if(h){h.appendChild(o)}}}else{o.setAttributeNS(null,"r",s.pointRadius)}}}var q=s.rotation;if((q!==undefined||o._rotation!==undefined)&&d){o._rotation=q;q|=0;if(o.nodeName!=="svg"){o.setAttributeNS(null,"transform","rotate("+q+" "+d.x+" "+d.y+")")}else{var p=this.symbolMetrics[e.id];o.firstChild.setAttributeNS(null,"transform","rotate("+q+" "+p[1]+" "+p[2]+")")}}}if(b.isFilled){o.setAttributeNS(null,"fill",s.fillColor);o.setAttributeNS(null,"fill-opacity",s.fillOpacity)}else{o.setAttributeNS(null,"fill","none")}if(b.isStroked){o.setAttributeNS(null,"stroke",s.strokeColor);o.setAttributeNS(null,"stroke-opacity",s.strokeOpacity);o.setAttributeNS(null,"stroke-width",s.strokeWidth*j);o.setAttributeNS(null,"stroke-linecap",s.strokeLinecap||"round");o.setAttributeNS(null,"stroke-linejoin","round");s.strokeDashstyle&&o.setAttributeNS(null,"stroke-dasharray",this.dashStyle(s,j))}else{o.setAttributeNS(null,"stroke","none")}if(s.pointerEvents){o.setAttributeNS(null,"pointer-events",s.pointerEvents)}if(s.cursor!=null){o.setAttributeNS(null,"cursor",s.cursor)}return o},dashStyle:function(c,b){var a=c.strokeWidth*b;var d=c.strokeDashstyle;switch(d){case"solid":return"none";case"dot":return[1,4*a].join();case"dash":return[4*a,4*a].join();case"dashdot":return[4*a,4*a,1,4*a].join();case"longdash":return[8*a,4*a].join();case"longdashdot":return[8*a,4*a,1,4*a].join();default:return OpenLayers.String.trim(d).replace(/\s+/g,",")}},createNode:function(a,c){var b=document.createElementNS(this.xmlns,a);if(c){b.setAttributeNS(null,"id",c)}return b},nodeTypeCompare:function(b,a){return(a==b.nodeName)},createRenderRoot:function(){return this.nodeFactory(this.container.id+"_svgRoot","svg")},createRoot:function(a){return this.nodeFactory(this.container.id+a,"g")},createDefs:function(){var a=this.nodeFactory(this.container.id+"_defs","defs");this.rendererRoot.appendChild(a);return a},drawPoint:function(a,b){return this.drawCircle(a,b,1)},drawCircle:function(d,e,b){var c=this.getResolution();var a=(e.x/c+this.left);var f=(this.top-e.y/c);if(this.inValidRange(a,f)){d.setAttributeNS(null,"cx",a);d.setAttributeNS(null,"cy",f);d.setAttributeNS(null,"r",b);return d}else{return false}},drawLineString:function(b,c){var a=this.getComponentsString(c.components);if(a.path){b.setAttributeNS(null,"points",a.path);return(a.complete?b:null)}else{return false}},drawLinearRing:function(b,c){var a=this.getComponentsString(c.components);if(a.path){b.setAttributeNS(null,"points",a.path);return(a.complete?b:null)}else{return false}},drawPolygon:function(b,h){var g="";var i=true;var a=true;var c,k;for(var e=0,f=h.components.length;e<f;e++){g+=" M";c=this.getComponentsString(h.components[e].components," ");k=c.path;if(k){g+=" "+k;a=c.complete&&a}else{i=false}}g+=" z";if(i){b.setAttributeNS(null,"d",g);b.setAttributeNS(null,"fill-rule","evenodd");return a?b:null}else{return false}},drawRectangle:function(c,d){var b=this.getResolution();var a=(d.x/b+this.left);var e=(this.top-d.y/b);if(this.inValidRange(a,e)){c.setAttributeNS(null,"x",a);c.setAttributeNS(null,"y",e);c.setAttributeNS(null,"width",d.width/b);c.setAttributeNS(null,"height",d.height/b);return c}else{return false}},drawSurface:function(f,h){var g=null;var b=true;for(var e=0,a=h.components.length;e<a;e++){if((e%3)==0&&(e/3)==0){var c=this.getShortString(h.components[e]);if(!c){b=false}g="M "+c}else{if((e%3)==1){var c=this.getShortString(h.components[e]);if(!c){b=false}g+=" C "+c}else{var c=this.getShortString(h.components[e]);if(!c){b=false}g+=" "+c}}}g+=" Z";if(b){f.setAttributeNS(null,"d",g);return f}else{return false}},drawText:function(e,a,n){var b=this.getResolution();var m=(n.x/b+this.left);var j=(n.y/b-this.top);var l=this.nodeFactory(e+this.LABEL_ID_SUFFIX,"text");l.setAttributeNS(null,"x",m);l.setAttributeNS(null,"y",-j);if(a.fontColor){l.setAttributeNS(null,"fill",a.fontColor)}if(a.fontOpacity){l.setAttributeNS(null,"opacity",a.fontOpacity)}if(a.fontFamily){l.setAttributeNS(null,"font-family",a.fontFamily)}if(a.fontSize){l.setAttributeNS(null,"font-size",a.fontSize)}if(a.fontWeight){l.setAttributeNS(null,"font-weight",a.fontWeight)}if(a.fontStyle){l.setAttributeNS(null,"font-style",a.fontStyle)}if(a.labelSelect===true){l.setAttributeNS(null,"pointer-events","visible");l._featureId=e}else{l.setAttributeNS(null,"pointer-events","none")}var g=a.labelAlign||"cm";l.setAttributeNS(null,"text-anchor",OpenLayers.Renderer.SVG.LABEL_ALIGN[g[0]]||"middle");if(OpenLayers.IS_GECKO===true){l.setAttributeNS(null,"dominant-baseline",OpenLayers.Renderer.SVG.LABEL_ALIGN[g[1]]||"central")}var c=a.label.split("\n");var f=c.length;while(l.childNodes.length>f){l.removeChild(l.lastChild)}for(var d=0;d<f;d++){var h=this.nodeFactory(e+this.LABEL_ID_SUFFIX+"_tspan_"+d,"tspan");if(a.labelSelect===true){h._featureId=e;h._geometry=n;h._geometryClass=n.CLASS_NAME}if(OpenLayers.IS_GECKO===false){h.setAttributeNS(null,"baseline-shift",OpenLayers.Renderer.SVG.LABEL_VSHIFT[g[1]]||"-35%")}h.setAttribute("x",m);if(d==0){var k=OpenLayers.Renderer.SVG.LABEL_VFACTOR[g[1]];if(k==null){k=-0.5}h.setAttribute("dy",(k*(f-1))+"em")}else{h.setAttribute("dy","1em")}h.textContent=(c[d]==="")?" ":c[d];if(!h.parentNode){l.appendChild(h)}}if(!l.parentNode){this.textRoot.appendChild(l)}},getComponentsString:function(d,c){var f=[];var a=true;var e=d.length;var j=[];var g,h;for(var b=0;b<e;b++){h=d[b];f.push(h);g=this.getShortString(h);if(g){j.push(g)}else{if(b>0){if(this.getShortString(d[b-1])){j.push(this.clipLine(d[b],d[b-1]))}}if(b<e-1){if(this.getShortString(d[b+1])){j.push(this.clipLine(d[b],d[b+1]))}}a=false}}return{path:j.join(c||","),complete:a}},clipLine:function(e,h){if(h.equals(e)){return""}var f=this.getResolution();var b=this.MAX_PIXEL-this.translationParameters.x;var a=this.MAX_PIXEL-this.translationParameters.y;var d=h.x/f+this.left;var j=this.top-h.y/f;var c=e.x/f+this.left;var i=this.top-e.y/f;var g;if(c<-b||c>b){g=(i-j)/(c-d);c=c<0?-b:b;i=j+(c-d)*g}if(i<-a||i>a){g=(c-d)/(i-j);i=i<0?-a:a;c=d+(i-j)*g}return c+","+i},getShortString:function(b){var c=this.getResolution();var a=(b.x/c+this.left);var d=(this.top-b.y/c);if(this.inValidRange(a,d)){return a+","+d}else{return false}},getPosition:function(a){return({x:parseFloat(a.getAttributeNS(null,"cx")),y:parseFloat(a.getAttributeNS(null,"cy"))})},importSymbol:function(f){if(!this.defs){this.defs=this.createDefs()}var b=this.container.id+"-"+f;var c=document.getElementById(b);if(c!=null){return c}var e=OpenLayers.Renderer.symbol[f];if(!e){throw new Error(f+" is not a valid symbol name")}var h=this.nodeFactory(b,"symbol");var d=this.nodeFactory(null,"polygon");h.appendChild(d);var n=new OpenLayers.Bounds(Number.MAX_VALUE,Number.MAX_VALUE,0,0);var l=[];var k,j;for(var g=0;g<e.length;g=g+2){k=e[g];j=e[g+1];n.left=Math.min(n.left,k);n.bottom=Math.min(n.bottom,j);n.right=Math.max(n.right,k);n.top=Math.max(n.top,j);l.push(k,",",j)}d.setAttributeNS(null,"points",l.join(" "));var a=n.getWidth();var m=n.getHeight();var o=[n.left-a,n.bottom-m,a*3,m*3];h.setAttributeNS(null,"viewBox",o.join(" "));this.symbolMetrics[b]=[Math.max(a,m),n.getCenterLonLat().lon,n.getCenterLonLat().lat];this.defs.appendChild(h);return h},getFeatureIdFromEvent:function(a){var c=OpenLayers.Renderer.Elements.prototype.getFeatureIdFromEvent.apply(this,arguments);if(!c){var b=a.target;c=b.parentNode&&b!=this.rendererRoot&&b.parentNode._featureId}return c},CLASS_NAME:"OpenLayers.Renderer.SVG"});OpenLayers.Renderer.SVG.LABEL_ALIGN={l:"start",r:"end",b:"bottom",t:"hanging"};OpenLayers.Renderer.SVG.LABEL_VSHIFT={t:"-70%",b:"0"};OpenLayers.Renderer.SVG.LABEL_VFACTOR={t:0,b:-1};OpenLayers.Renderer.SVG.preventDefault=function(a){a.preventDefault&&a.preventDefault()};OpenLayers.Format.SLD.v1_0_0=OpenLayers.Class(OpenLayers.Format.SLD.v1,{VERSION:"1.0.0",schemaLocation:"http://www.opengis.net/sld http://schemas.opengis.net/sld/1.0.0/StyledLayerDescriptor.xsd",initialize:function(a){OpenLayers.Format.SLD.v1.prototype.initialize.apply(this,[a])},CLASS_NAME:"OpenLayers.Format.SLD.v1_0_0"});OpenLayers.Format.OWSContext=OpenLayers.Class(OpenLayers.Format.Context,{defaultVersion:"0.3.1",getVersion:function(b,c){var a=OpenLayers.Format.XML.VersionedOGC.prototype.getVersion.apply(this,arguments);if(a==="0.3.0"){a=this.defaultVersion}return a},toContext:function(b){var a={};if(b.CLASS_NAME=="OpenLayers.Map"){a.bounds=b.getExtent();a.maxExtent=b.maxExtent;a.projection=b.projection;a.size=b.getSize();a.layers=b.layers}return a},CLASS_NAME:"OpenLayers.Format.OWSContext"});OpenLayers.Format.OWSContext.v0_3_1=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{owc:"http://www.opengis.net/ows-context",gml:"http://www.opengis.net/gml",kml:"http://www.opengis.net/kml/2.2",ogc:"http://www.opengis.net/ogc",ows:"http://www.opengis.net/ows",sld:"http://www.opengis.net/sld",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},VERSION:"0.3.1",schemaLocation:"http://www.opengis.net/ows-context http://www.ogcnetwork.net/schemas/owc/0.3.1/owsContext.xsd",defaultPrefix:"owc",extractAttributes:true,xy:true,regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},featureNS:"http://mapserver.gis.umn.edu/mapserver",featureType:"vector",geometryName:"geometry",nestingLayerLookup:null,initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a]);OpenLayers.Format.GML.v2.prototype.setGeometryTypes.call(this)},setNestingPath:function(b){if(b.layersContext){for(var c=0,a=b.layersContext.length;c<a;c++){var f=b.layersContext[c];var d=[];var e=b.title||"";if(b.metadata&&b.metadata.nestingPath){d=b.metadata.nestingPath.slice()}if(e!=""){d.push(e)}f.metadata.nestingPath=d;if(f.layersContext){this.setNestingPath(f)}}}},decomposeNestingPath:function(c){var b=[];if(OpenLayers.Util.isArray(c)){var d=c.slice();while(d.length>0){b.push(d.slice());d.pop()}b.reverse()}return b},read:function(b){if(typeof b=="string"){b=OpenLayers.Format.XML.prototype.read.apply(this,[b])}if(b&&b.nodeType==9){b=b.documentElement}var a={};this.readNode(b,a);this.setNestingPath({layersContext:a.layersContext});var c=[];this.processLayer(c,a);delete a.layersContext;a.layersContext=c;return a},processLayer:function(b,e){if(e.layersContext){for(var d=0,a=e.layersContext.length;d<a;d++){var c=e.layersContext[d];b.push(c);if(c.layersContext){this.processLayer(b,c)}}}},write:function(d,c){var b="OWSContext";this.nestingLayerLookup={};c=c||{};OpenLayers.Util.applyDefaults(c,d);var a=this.writeNode(b,c);this.nestingLayerLookup=null;this.setAttributeNS(a,this.namespaces.xsi,"xsi:schemaLocation",this.schemaLocation);return OpenLayers.Format.XML.prototype.write.apply(this,[a])},readers:{kml:{Document:function(a,b){b.features=new OpenLayers.Format.KML({kmlns:this.namespaces.kml,extractStyles:true}).read(a)}},owc:{OWSContext:function(a,b){this.readChildNodes(a,b)},General:function(a,b){this.readChildNodes(a,b)},ResourceList:function(a,b){this.readChildNodes(a,b)},Layer:function(a,c){var b={metadata:{},visibility:(a.getAttribute("hidden")!="1"),queryable:(a.getAttribute("queryable")=="1"),opacity:((a.getAttribute("opacity")!=null)?parseFloat(a.getAttribute("opacity")):null),name:a.getAttribute("name"),categoryLayer:(a.getAttribute("name")==null),formats:[],styles:[]};if(!c.layersContext){c.layersContext=[]}c.layersContext.push(b);this.readChildNodes(a,b)},InlineGeometry:function(b,d){d.features=[];var c=this.getElementsByTagNameNS(b,this.namespaces.gml,"featureMember");var a;if(c.length>=1){a=c[0]}if(a&&a.firstChild){var e=(a.firstChild.nextSibling)?a.firstChild.nextSibling:a.firstChild;this.setNamespace("feature",e.namespaceURI);this.featureType=e.localName||e.nodeName.split(":").pop();this.readChildNodes(b,d)}},Server:function(a,b){if((!b.service&&!b.version)||(b.service!=OpenLayers.Format.Context.serviceTypes.WMS)){b.service=a.getAttribute("service");b.version=a.getAttribute("version");this.readChildNodes(a,b)}},Name:function(a,b){b.name=this.getChildValue(a);this.readChildNodes(a,b)},Title:function(a,b){b.title=this.getChildValue(a);this.readChildNodes(a,b)},StyleList:function(a,b){this.readChildNodes(a,b.styles)},Style:function(b,c){var a={};c.push(a);this.readChildNodes(b,a)},LegendURL:function(b,c){var a={};c.legend=a;this.readChildNodes(b,a)},OnlineResource:function(a,b){b.url=this.getAttributeNS(a,this.namespaces.xlink,"href");this.readChildNodes(a,b)}},ows:OpenLayers.Format.OWSCommon.v1_0_0.prototype.readers.ows,gml:OpenLayers.Format.GML.v2.prototype.readers.gml,sld:OpenLayers.Format.SLD.v1_0_0.prototype.readers.sld,feature:OpenLayers.Format.GML.v2.prototype.readers.feature},writers:{owc:{OWSContext:function(a){var b=this.createElementNSPlus("OWSContext",{attributes:{version:this.VERSION,id:a.id||OpenLayers.Util.createUniqueID("OpenLayers_OWSContext_")}});this.writeNode("General",a,b);this.writeNode("ResourceList",a,b);return b},General:function(a){var b=this.createElementNSPlus("General");this.writeNode("ows:BoundingBox",a,b);this.writeNode("ows:Title",a.title||"OpenLayers OWSContext",b);return b},ResourceList:function(c){var f=this.createElementNSPlus("ResourceList");for(var e=0,b=c.layers.length;e<b;e++){var d=c.layers[e];var a=this.decomposeNestingPath(d.metadata.nestingPath);this.writeNode("_Layer",{layer:d,subPaths:a},f)}return f},Server:function(a){var b=this.createElementNSPlus("Server",{attributes:{version:a.version,service:a.service}});this.writeNode("OnlineResource",a,b);return b},OnlineResource:function(a){var b=this.createElementNSPlus("OnlineResource",{attributes:{"xlink:href":a.url}});return b},InlineGeometry:function(c){var d=this.createElementNSPlus("InlineGeometry");this.writeNode("gml:boundedBy",c.getDataExtent(),d);for(var b=0,a=c.features.length;b<a;b++){this.writeNode("gml:featureMember",c.features[b],d)}return d},StyleList:function(d){var c=this.createElementNSPlus("StyleList");for(var b=0,a=d.length;b<a;b++){this.writeNode("Style",d[b],c)}return c},Style:function(a){var b=this.createElementNSPlus("Style");this.writeNode("Name",a,b);this.writeNode("Title",a,b);if(a.legend){this.writeNode("LegendURL",a,b)}return b},Name:function(b){var a=this.createElementNSPlus("Name",{value:b.name});return a},Title:function(b){var a=this.createElementNSPlus("Title",{value:b.title});return a},LegendURL:function(a){var b=this.createElementNSPlus("LegendURL");this.writeNode("OnlineResource",a.legend,b);return b},_WMS:function(a){var b=this.createElementNSPlus("Layer",{attributes:{name:a.params.LAYERS,queryable:a.queryable?"1":"0",hidden:a.visibility?"0":"1",opacity:a.opacity?a.opacity:null}});this.writeNode("ows:Title",a.name,b);this.writeNode("ows:OutputFormat",a.params.FORMAT,b);this.writeNode("Server",{service:OpenLayers.Format.Context.serviceTypes.WMS,version:a.params.VERSION,url:a.url},b);if(a.metadata.styles&&a.metadata.styles.length>0){this.writeNode("StyleList",a.metadata.styles,b)}return b},_Layer:function(b){var c,g,d,f;c=b.layer;g=b.subPaths;d=null;f=null;if(g.length>0){var e=g[0].join("/");var a=e.lastIndexOf("/");d=this.nestingLayerLookup[e];f=(a>0)?e.substring(a+1,e.length):e;if(!d){d=this.createElementNSPlus("Layer");this.writeNode("ows:Title",f,d);this.nestingLayerLookup[e]=d}b.subPaths.shift();this.writeNode("_Layer",b,d);return d}else{if(c instanceof OpenLayers.Layer.WMS){d=this.writeNode("_WMS",c)}else{if(c instanceof OpenLayers.Layer.Vector){if(c.protocol instanceof OpenLayers.Protocol.WFS.v1){d=this.writeNode("_WFS",c)}else{if(c.protocol instanceof OpenLayers.Protocol.HTTP){if(c.protocol.format instanceof OpenLayers.Format.GML){c.protocol.format.version="2.1.2";d=this.writeNode("_GML",c)}else{if(c.protocol.format instanceof OpenLayers.Format.KML){c.protocol.format.version="2.2";d=this.writeNode("_KML",c)}}}else{this.setNamespace("feature",this.featureNS);d=this.writeNode("_InlineGeometry",c)}}}}if(c.options.maxScale){this.writeNode("sld:MinScaleDenominator",c.options.maxScale,d)}if(c.options.minScale){this.writeNode("sld:MaxScaleDenominator",c.options.minScale,d)}this.nestingLayerLookup[c.name]=d;return d}},_WFS:function(a){var b=this.createElementNSPlus("Layer",{attributes:{name:a.protocol.featurePrefix+":"+a.protocol.featureType,hidden:a.visibility?"0":"1"}});this.writeNode("ows:Title",a.name,b);this.writeNode("Server",{service:OpenLayers.Format.Context.serviceTypes.WFS,version:a.protocol.version,url:a.protocol.url},b);return b},_InlineGeometry:function(a){var b=this.createElementNSPlus("Layer",{attributes:{name:this.featureType,hidden:a.visibility?"0":"1"}});this.writeNode("ows:Title",a.name,b);this.writeNode("InlineGeometry",a,b);return b},_GML:function(a){var b=this.createElementNSPlus("Layer");this.writeNode("ows:Title",a.name,b);this.writeNode("Server",{service:OpenLayers.Format.Context.serviceTypes.GML,url:a.protocol.url,version:a.protocol.format.version},b);return b},_KML:function(a){var b=this.createElementNSPlus("Layer");this.writeNode("ows:Title",a.name,b);this.writeNode("Server",{service:OpenLayers.Format.Context.serviceTypes.KML,version:a.protocol.format.version,url:a.protocol.url},b);return b}},gml:OpenLayers.Util.applyDefaults({boundedBy:function(b){var a=this.createElementNSPlus("gml:boundedBy");this.writeNode("gml:Box",b,a);return a}},OpenLayers.Format.GML.v2.prototype.writers.gml),ows:OpenLayers.Format.OWSCommon.v1_0_0.prototype.writers.ows,sld:OpenLayers.Format.SLD.v1_0_0.prototype.writers.sld,feature:OpenLayers.Format.GML.v2.prototype.writers.feature},CLASS_NAME:"OpenLayers.Format.OWSContext.v0_3_1"});OpenLayers.Control.ScaleLine=OpenLayers.Class(OpenLayers.Control,{maxWidth:100,topOutUnits:"km",topInUnits:"m",bottomOutUnits:"mi",bottomInUnits:"ft",eTop:null,eBottom:null,geodesic:false,draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);if(!this.eTop){this.eTop=document.createElement("div");this.eTop.className=this.displayClass+"Top";var a=this.topInUnits.length;this.div.appendChild(this.eTop);if((this.topOutUnits=="")||(this.topInUnits=="")){this.eTop.style.visibility="hidden"}else{this.eTop.style.visibility="visible"}this.eBottom=document.createElement("div");this.eBottom.className=this.displayClass+"Bottom";this.div.appendChild(this.eBottom);if((this.bottomOutUnits=="")||(this.bottomInUnits=="")){this.eBottom.style.visibility="hidden"}else{this.eBottom.style.visibility="visible"}}this.map.events.register("moveend",this,this.update);this.update();return this.div},getBarLen:function(b){var d=parseInt(Math.log(b)/Math.log(10));var a=Math.pow(10,d);var c=parseInt(b/a);var e;if(c>5){e=5}else{if(c>2){e=2}else{e=1}}return e*a},update:function(){var j=this.map.getResolution();if(!j){return}var o=this.map.getUnits();var e=OpenLayers.INCHES_PER_UNIT;var l=this.maxWidth*j*e[o];var n=1;if(this.geodesic===true){var b=(this.map.getGeodesicPixelSize().w||0.000001)*this.maxWidth;var f=l/e.km;n=b/f;l*=n}var a;var d;if(l>100000){a=this.topOutUnits;d=this.bottomOutUnits}else{a=this.topInUnits;d=this.bottomInUnits}var h=l/e[a];var k=l/e[d];var i=this.getBarLen(h);var g=this.getBarLen(k);h=i/e[o]*e[a];k=g/e[o]*e[d];var c=h/j/n;var m=k/j/n;if(this.eBottom.style.visibility=="visible"){this.eBottom.style.width=Math.round(m)+"px";this.eBottom.innerHTML=g+" "+d}if(this.eTop.style.visibility=="visible"){this.eTop.style.width=Math.round(c)+"px";this.eTop.innerHTML=i+" "+a}},CLASS_NAME:"OpenLayers.Control.ScaleLine"});OpenLayers.Control.PanZoom=OpenLayers.Class(OpenLayers.Control,{slideFactor:50,slideRatio:null,buttons:null,position:null,initialize:function(a){this.position=new OpenLayers.Pixel(OpenLayers.Control.PanZoom.X,OpenLayers.Control.PanZoom.Y);OpenLayers.Control.prototype.initialize.apply(this,arguments)},destroy:function(){this.removeButtons();this.buttons=null;this.position=null;OpenLayers.Control.prototype.destroy.apply(this,arguments)},draw:function(b){OpenLayers.Control.prototype.draw.apply(this,arguments);b=this.position;this.buttons=[];var c=new OpenLayers.Size(18,18);var a=new OpenLayers.Pixel(b.x+c.w/2,b.y);this._addButton("panup","north-mini.png",a,c);b.y=a.y+c.h;this._addButton("panleft","west-mini.png",b,c);this._addButton("panright","east-mini.png",b.add(c.w,0),c);this._addButton("pandown","south-mini.png",a.add(0,c.h*2),c);this._addButton("zoomin","zoom-plus-mini.png",a.add(0,c.h*3+5),c);this._addButton("zoomworld","zoom-world-mini.png",a.add(0,c.h*4+5),c);this._addButton("zoomout","zoom-minus-mini.png",a.add(0,c.h*5+5),c);return this.div},_addButton:function(a,d,i,g){var f=OpenLayers.Util.getImagesLocation()+d;var b=OpenLayers.Util.createAlphaImageDiv(this.id+"_"+a,i,g,f,"absolute");b.style.cursor="pointer";this.div.appendChild(b);OpenLayers.Event.observe(b,"mousedown",OpenLayers.Function.bindAsEventListener(this.buttonDown,b));OpenLayers.Event.observe(b,"dblclick",OpenLayers.Function.bindAsEventListener(this.doubleClick,b));OpenLayers.Event.observe(b,"click",OpenLayers.Function.bindAsEventListener(this.doubleClick,b));b.action=a;b.map=this.map;if(!this.slideRatio){var c=this.slideFactor;var e=function(){return c}}else{var h=this.slideRatio;var e=function(j){return this.map.getSize()[j]*h}}b.getSlideFactor=e;this.buttons.push(b);return b},_removeButton:function(a){OpenLayers.Event.stopObservingElement(a);a.map=null;a.getSlideFactor=null;this.div.removeChild(a);OpenLayers.Util.removeItem(this.buttons,a)},removeButtons:function(){for(var a=this.buttons.length-1;a>=0;--a){this._removeButton(this.buttons[a])}},doubleClick:function(a){OpenLayers.Event.stop(a);return false},buttonDown:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}switch(this.action){case"panup":this.map.pan(0,-this.getSlideFactor("h"));break;case"pandown":this.map.pan(0,this.getSlideFactor("h"));break;case"panleft":this.map.pan(-this.getSlideFactor("w"),0);break;case"panright":this.map.pan(this.getSlideFactor("w"),0);break;case"zoomin":this.map.zoomIn();break;case"zoomout":this.map.zoomOut();break;case"zoomworld":this.map.zoomToMaxExtent();break}OpenLayers.Event.stop(a)},CLASS_NAME:"OpenLayers.Control.PanZoom"});OpenLayers.Control.PanZoom.X=4;OpenLayers.Control.PanZoom.Y=4;OpenLayers.Icon=OpenLayers.Class({url:null,size:null,offset:null,calculateOffset:null,imageDiv:null,px:null,initialize:function(a,b,d,c){this.url=a;this.size=(b)?b:new OpenLayers.Size(20,20);this.offset=d?d:new OpenLayers.Pixel(-(this.size.w/2),-(this.size.h/2));this.calculateOffset=c;var e=OpenLayers.Util.createUniqueID("OL_Icon_");this.imageDiv=OpenLayers.Util.createAlphaImageDiv(e)},destroy:function(){this.erase();OpenLayers.Event.stopObservingElement(this.imageDiv.firstChild);this.imageDiv.innerHTML="";this.imageDiv=null},clone:function(){return new OpenLayers.Icon(this.url,this.size,this.offset,this.calculateOffset)},setSize:function(a){if(a!=null){this.size=a}this.draw()},setUrl:function(a){if(a!=null){this.url=a}this.draw()},draw:function(a){OpenLayers.Util.modifyAlphaImageDiv(this.imageDiv,null,null,this.size,this.url,"absolute");this.moveTo(a);return this.imageDiv},erase:function(){if(this.imageDiv!=null&&this.imageDiv.parentNode!=null){OpenLayers.Element.remove(this.imageDiv)}},setOpacity:function(a){OpenLayers.Util.modifyAlphaImageDiv(this.imageDiv,null,null,null,null,null,null,null,a)},moveTo:function(a){if(a!=null){this.px=a}if(this.imageDiv!=null){if(this.px==null){this.display(false)}else{if(this.calculateOffset){this.offset=this.calculateOffset(this.size)}var b=this.px.offset(this.offset);OpenLayers.Util.modifyAlphaImageDiv(this.imageDiv,null,b)}}},display:function(a){this.imageDiv.style.display=(a)?"":"none"},isDrawn:function(){var a=(this.imageDiv&&this.imageDiv.parentNode&&(this.imageDiv.parentNode.nodeType!=11));return a},CLASS_NAME:"OpenLayers.Icon"});OpenLayers.Marker=OpenLayers.Class({icon:null,lonlat:null,events:null,map:null,initialize:function(c,b){this.lonlat=c;var a=(b)?b:OpenLayers.Marker.defaultIcon();if(this.icon==null){this.icon=a}else{this.icon.url=a.url;this.icon.size=a.size;this.icon.offset=a.offset;this.icon.calculateOffset=a.calculateOffset}this.events=new OpenLayers.Events(this,this.icon.imageDiv,null)},destroy:function(){this.erase();this.map=null;this.events.destroy();this.events=null;if(this.icon!=null){this.icon.destroy();this.icon=null}},draw:function(a){return this.icon.draw(a)},erase:function(){if(this.icon!=null){this.icon.erase()}},moveTo:function(a){if((a!=null)&&(this.icon!=null)){this.icon.moveTo(a)}this.lonlat=this.map.getLonLatFromLayerPx(a)},isDrawn:function(){var a=(this.icon&&this.icon.isDrawn());return a},onScreen:function(){var b=false;if(this.map){var a=this.map.getExtent();b=a.containsLonLat(this.lonlat)}return b},inflate:function(b){if(this.icon){var a=new OpenLayers.Size(this.icon.size.w*b,this.icon.size.h*b);this.icon.setSize(a)}},setOpacity:function(a){this.icon.setOpacity(a)},setUrl:function(a){this.icon.setUrl(a)},display:function(a){this.icon.display(a)},CLASS_NAME:"OpenLayers.Marker"});OpenLayers.Marker.defaultIcon=function(){var a=OpenLayers.Util.getImagesLocation()+"marker.png";var b=new OpenLayers.Size(21,25);var c=function(d){return new OpenLayers.Pixel(-(d.w/2),-d.h)};return new OpenLayers.Icon(a,b,null,c)};OpenLayers.Popup=OpenLayers.Class({events:null,id:"",lonlat:null,div:null,contentSize:null,size:null,contentHTML:null,backgroundColor:"",opacity:"",border:"",contentDiv:null,groupDiv:null,closeDiv:null,autoSize:false,minSize:null,maxSize:null,displayClass:"olPopup",contentDisplayClass:"olPopupContent",padding:0,disableFirefoxOverflowHack:false,fixPadding:function(){if(typeof this.padding=="number"){this.padding=new OpenLayers.Bounds(this.padding,this.padding,this.padding,this.padding)}},panMapIfOutOfView:false,keepInMap:false,closeOnMove:false,map:null,initialize:function(g,c,f,b,e,d){if(g==null){g=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")}this.id=g;this.lonlat=c;this.contentSize=(f!=null)?f:new OpenLayers.Size(OpenLayers.Popup.WIDTH,OpenLayers.Popup.HEIGHT);if(b!=null){this.contentHTML=b}this.backgroundColor=OpenLayers.Popup.COLOR;this.opacity=OpenLayers.Popup.OPACITY;this.border=OpenLayers.Popup.BORDER;this.div=OpenLayers.Util.createDiv(this.id,null,null,null,null,null,"hidden");this.div.className=this.displayClass;var a=this.id+"_GroupDiv";this.groupDiv=OpenLayers.Util.createDiv(a,null,null,null,"relative",null,"hidden");var g=this.div.id+"_contentDiv";this.contentDiv=OpenLayers.Util.createDiv(g,null,this.contentSize.clone(),null,"relative");this.contentDiv.className=this.contentDisplayClass;this.groupDiv.appendChild(this.contentDiv);this.div.appendChild(this.groupDiv);if(e){this.addCloseBox(d)}this.registerEvents()},destroy:function(){this.id=null;this.lonlat=null;this.size=null;this.contentHTML=null;this.backgroundColor=null;this.opacity=null;this.border=null;if(this.closeOnMove&&this.map){this.map.events.unregister("movestart",this,this.hide)}this.events.destroy();this.events=null;if(this.closeDiv){OpenLayers.Event.stopObservingElement(this.closeDiv);this.groupDiv.removeChild(this.closeDiv)}this.closeDiv=null;this.div.removeChild(this.groupDiv);this.groupDiv=null;if(this.map!=null){this.map.removePopup(this)}this.map=null;this.div=null;this.autoSize=null;this.minSize=null;this.maxSize=null;this.padding=null;this.panMapIfOutOfView=null},draw:function(a){if(a==null){if((this.lonlat!=null)&&(this.map!=null)){a=this.map.getLayerPxFromLonLat(this.lonlat)}}if(this.closeOnMove){this.map.events.register("movestart",this,this.hide)}if(!this.disableFirefoxOverflowHack&&OpenLayers.BROWSER_NAME=="firefox"){this.map.events.register("movestart",this,function(){var b=document.defaultView.getComputedStyle(this.contentDiv,null);var c=b.getPropertyValue("overflow");if(c!="hidden"){this.contentDiv._oldOverflow=c;this.contentDiv.style.overflow="hidden"}});this.map.events.register("moveend",this,function(){var b=this.contentDiv._oldOverflow;if(b){this.contentDiv.style.overflow=b;this.contentDiv._oldOverflow=null}})}this.moveTo(a);if(!this.autoSize&&!this.size){this.setSize(this.contentSize)}this.setBackgroundColor();this.setOpacity();this.setBorder();this.setContentHTML();if(this.panMapIfOutOfView){this.panIntoView()}return this.div},updatePosition:function(){if((this.lonlat)&&(this.map)){var a=this.map.getLayerPxFromLonLat(this.lonlat);if(a){this.moveTo(a)}}},moveTo:function(a){if((a!=null)&&(this.div!=null)){this.div.style.left=a.x+"px";this.div.style.top=a.y+"px"}},visible:function(){return OpenLayers.Element.visible(this.div)},toggle:function(){if(this.visible()){this.hide()}else{this.show()}},show:function(){this.div.style.display="";if(this.panMapIfOutOfView){this.panIntoView()}},hide:function(){this.div.style.display="none"},setSize:function(c){this.size=c.clone();var b=this.getContentDivPadding();var a=b.left+b.right;var e=b.top+b.bottom;this.fixPadding();a+=this.padding.left+this.padding.right;e+=this.padding.top+this.padding.bottom;if(this.closeDiv){var d=parseInt(this.closeDiv.style.width);a+=d+b.right}this.size.w+=a;this.size.h+=e;if(OpenLayers.BROWSER_NAME=="msie"){this.contentSize.w+=b.left+b.right;this.contentSize.h+=b.bottom+b.top}if(this.div!=null){this.div.style.width=this.size.w+"px";this.div.style.height=this.size.h+"px"}if(this.contentDiv!=null){this.contentDiv.style.width=c.w+"px";this.contentDiv.style.height=c.h+"px"}},updateSize:function(){var e="<div class='"+this.contentDisplayClass+"'>"+this.contentDiv.innerHTML+"</div>";var h=(this.map)?this.map.layerContainerDiv:document.body;var i=OpenLayers.Util.getRenderedDimensions(e,null,{displayClass:this.displayClass,containerElement:h});var g=this.getSafeContentSize(i);var f=null;if(g.equals(i)){f=i}else{var b=new OpenLayers.Size();b.w=(g.w<i.w)?g.w:null;b.h=(g.h<i.h)?g.h:null;if(b.w&&b.h){f=g}else{var d=OpenLayers.Util.getRenderedDimensions(e,b,{displayClass:this.contentDisplayClass,containerElement:h});var c=OpenLayers.Element.getStyle(this.contentDiv,"overflow");if((c!="hidden")&&(d.equals(g))){var a=OpenLayers.Util.getScrollbarWidth();if(b.w){d.h+=a}else{d.w+=a}}f=this.getSafeContentSize(d)}}this.setSize(f)},setBackgroundColor:function(a){if(a!=undefined){this.backgroundColor=a}if(this.div!=null){this.div.style.backgroundColor=this.backgroundColor}},setOpacity:function(a){if(a!=undefined){this.opacity=a}if(this.div!=null){this.div.style.opacity=this.opacity;this.div.style.filter="alpha(opacity="+this.opacity*100+")"}},setBorder:function(a){if(a!=undefined){this.border=a}if(this.div!=null){this.div.style.border=this.border}},setContentHTML:function(a){if(a!=null){this.contentHTML=a}if((this.contentDiv!=null)&&(this.contentHTML!=null)&&(this.contentHTML!=this.contentDiv.innerHTML)){this.contentDiv.innerHTML=this.contentHTML;if(this.autoSize){this.registerImageListeners();this.updateSize()}}},registerImageListeners:function(){var f=function(){this.popup.updateSize();if(this.popup.visible()&&this.popup.panMapIfOutOfView){this.popup.panIntoView()}OpenLayers.Event.stopObserving(this.img,"load",this.img._onImageLoad)};var b=this.contentDiv.getElementsByTagName("img");for(var e=0,a=b.length;e<a;e++){var c=b[e];if(c.width==0||c.height==0){var d={popup:this,img:c};c._onImgLoad=OpenLayers.Function.bind(f,d);OpenLayers.Event.observe(c,"load",c._onImgLoad)}}},getSafeContentSize:function(k){var d=k.clone();var i=this.getContentDivPadding();var j=i.left+i.right;var g=i.top+i.bottom;this.fixPadding();j+=this.padding.left+this.padding.right;g+=this.padding.top+this.padding.bottom;if(this.closeDiv){var c=parseInt(this.closeDiv.style.width);j+=c+i.right}if(this.minSize){d.w=Math.max(d.w,(this.minSize.w-j));d.h=Math.max(d.h,(this.minSize.h-g))}if(this.maxSize){d.w=Math.min(d.w,(this.maxSize.w-j));d.h=Math.min(d.h,(this.maxSize.h-g))}if(this.map&&this.map.size){var f=0,e=0;if(this.keepInMap&&!this.panMapIfOutOfView){var h=this.map.getPixelFromLonLat(this.lonlat);switch(this.relativePosition){case"tr":f=h.x;e=this.map.size.h-h.y;break;case"tl":f=this.map.size.w-h.x;e=this.map.size.h-h.y;break;case"bl":f=this.map.size.w-h.x;e=h.y;break;case"br":f=h.x;e=h.y;break;default:f=h.x;e=this.map.size.h-h.y;break}}var a=this.map.size.h-this.map.paddingForPopups.top-this.map.paddingForPopups.bottom-g-e;var b=this.map.size.w-this.map.paddingForPopups.left-this.map.paddingForPopups.right-j-f;d.w=Math.min(d.w,b);d.h=Math.min(d.h,a)}return d},getContentDivPadding:function(){var a=this._contentDivPadding;if(!a){if(this.div.parentNode==null){this.div.style.display="none";document.body.appendChild(this.div)}a=new OpenLayers.Bounds(OpenLayers.Element.getStyle(this.contentDiv,"padding-left"),OpenLayers.Element.getStyle(this.contentDiv,"padding-bottom"),OpenLayers.Element.getStyle(this.contentDiv,"padding-right"),OpenLayers.Element.getStyle(this.contentDiv,"padding-top"));this._contentDivPadding=a;if(this.div.parentNode==document.body){document.body.removeChild(this.div);this.div.style.display=""}}return a},addCloseBox:function(c){this.closeDiv=OpenLayers.Util.createDiv(this.id+"_close",null,new OpenLayers.Size(17,17));this.closeDiv.className="olPopupCloseBox";var b=this.getContentDivPadding();this.closeDiv.style.right=b.right+"px";this.closeDiv.style.top=b.top+"px";this.groupDiv.appendChild(this.closeDiv);var a=c||function(d){this.hide();OpenLayers.Event.stop(d)};OpenLayers.Event.observe(this.closeDiv,"touchend",OpenLayers.Function.bindAsEventListener(a,this));OpenLayers.Event.observe(this.closeDiv,"click",OpenLayers.Function.bindAsEventListener(a,this))},panIntoView:function(){var e=this.map.getSize();var d=this.map.getViewPortPxFromLayerPx(new OpenLayers.Pixel(parseInt(this.div.style.left),parseInt(this.div.style.top)));var c=d.clone();if(d.x<this.map.paddingForPopups.left){c.x=this.map.paddingForPopups.left}else{if((d.x+this.size.w)>(e.w-this.map.paddingForPopups.right)){c.x=e.w-this.map.paddingForPopups.right-this.size.w}}if(d.y<this.map.paddingForPopups.top){c.y=this.map.paddingForPopups.top}else{if((d.y+this.size.h)>(e.h-this.map.paddingForPopups.bottom)){c.y=e.h-this.map.paddingForPopups.bottom-this.size.h}}var b=d.x-c.x;var a=d.y-c.y;this.map.pan(b,a)},registerEvents:function(){this.events=new OpenLayers.Events(this,this.div,null,true);function a(b){OpenLayers.Event.stop(b,true)}this.events.on({mousedown:this.onmousedown,mousemove:this.onmousemove,mouseup:this.onmouseup,click:this.onclick,mouseout:this.onmouseout,dblclick:this.ondblclick,touchstart:a,scope:this})},onmousedown:function(a){this.mousedown=true;OpenLayers.Event.stop(a,true)},onmousemove:function(a){if(this.mousedown){OpenLayers.Event.stop(a,true)}},onmouseup:function(a){if(this.mousedown){this.mousedown=false;OpenLayers.Event.stop(a,true)}},onclick:function(a){OpenLayers.Event.stop(a,true)},onmouseout:function(a){this.mousedown=false},ondblclick:function(a){OpenLayers.Event.stop(a,true)},CLASS_NAME:"OpenLayers.Popup"});OpenLayers.Popup.WIDTH=200;OpenLayers.Popup.HEIGHT=200;OpenLayers.Popup.COLOR="white";OpenLayers.Popup.OPACITY=1;OpenLayers.Popup.BORDER="0px";OpenLayers.Strategy.Paging=OpenLayers.Class(OpenLayers.Strategy,{features:null,length:10,num:null,paging:false,activate:function(){var a=OpenLayers.Strategy.prototype.activate.call(this);if(a){this.layer.events.on({beforefeaturesadded:this.cacheFeatures,scope:this})}return a},deactivate:function(){var a=OpenLayers.Strategy.prototype.deactivate.call(this);if(a){this.clearCache();this.layer.events.un({beforefeaturesadded:this.cacheFeatures,scope:this})}return a},cacheFeatures:function(a){if(!this.paging){this.clearCache();this.features=a.features;this.pageNext(a)}},clearCache:function(){if(this.features){for(var a=0;a<this.features.length;++a){this.features[a].destroy()}}this.features=null;this.num=null},pageCount:function(){var a=this.features?this.features.length:0;return Math.ceil(a/this.length)},pageNum:function(){return this.num},pageLength:function(a){if(a&&a>0){this.length=a}return this.length},pageNext:function(a){var b=false;if(this.features){if(this.num===null){this.num=-1}var c=(this.num+1)*this.length;b=this.page(c,a)}return b},pagePrevious:function(){var a=false;if(this.features){if(this.num===null){this.num=this.pageCount()}var b=(this.num-1)*this.length;a=this.page(b)}return a},page:function(e,c){var d=false;if(this.features){if(e>=0&&e<this.features.length){var a=Math.floor(e/this.length);if(a!=this.num){this.paging=true;var b=this.features.slice(e,e+this.length);this.layer.removeFeatures(this.layer.features);this.num=a;if(c&&c.features){c.features=b}else{this.layer.addFeatures(b)}this.paging=false;d=true}}}return d},CLASS_NAME:"OpenLayers.Strategy.Paging"});OpenLayers.Popup.Anchored=OpenLayers.Class(OpenLayers.Popup,{relativePosition:null,keepInMap:true,anchor:null,initialize:function(h,d,g,c,b,f,e){var a=[h,d,g,c,f,e];OpenLayers.Popup.prototype.initialize.apply(this,a);this.anchor=(b!=null)?b:{size:new OpenLayers.Size(0,0),offset:new OpenLayers.Pixel(0,0)}},destroy:function(){this.anchor=null;this.relativePosition=null;OpenLayers.Popup.prototype.destroy.apply(this,arguments)},show:function(){this.updatePosition();OpenLayers.Popup.prototype.show.apply(this,arguments)},moveTo:function(c){var b=this.relativePosition;this.relativePosition=this.calculateRelativePosition(c);var d=this.calculateNewPx(c);var a=new Array(d);OpenLayers.Popup.prototype.moveTo.apply(this,a);if(this.relativePosition!=b){this.updateRelativePosition()}},setSize:function(b){OpenLayers.Popup.prototype.setSize.apply(this,arguments);if((this.lonlat)&&(this.map)){var a=this.map.getLayerPxFromLonLat(this.lonlat);this.moveTo(a)}},calculateRelativePosition:function(b){var d=this.map.getLonLatFromLayerPx(b);var c=this.map.getExtent();var a=c.determineQuadrant(d);return OpenLayers.Bounds.oppositeQuadrant(a)},updateRelativePosition:function(){},calculateNewPx:function(b){var e=b.offset(this.anchor.offset);var a=this.size||this.contentSize;var d=(this.relativePosition.charAt(0)=="t");e.y+=(d)?-a.h:this.anchor.size.h;var c=(this.relativePosition.charAt(1)=="l");e.x+=(c)?-a.w:this.anchor.size.w;return e},CLASS_NAME:"OpenLayers.Popup.Anchored"});OpenLayers.Popup.Framed=OpenLayers.Class(OpenLayers.Popup.Anchored,{imageSrc:null,imageSize:null,isAlphaImage:false,positionBlocks:null,blocks:null,fixedRelativePosition:false,initialize:function(g,c,f,b,a,e,d){OpenLayers.Popup.Anchored.prototype.initialize.apply(this,arguments);if(this.fixedRelativePosition){this.updateRelativePosition();this.calculateRelativePosition=function(h){return this.relativePosition}}this.contentDiv.style.position="absolute";this.contentDiv.style.zIndex=1;if(e){this.closeDiv.style.zIndex=1}this.groupDiv.style.position="absolute";this.groupDiv.style.top="0px";this.groupDiv.style.left="0px";this.groupDiv.style.height="100%";this.groupDiv.style.width="100%"},destroy:function(){this.imageSrc=null;this.imageSize=null;this.isAlphaImage=null;this.fixedRelativePosition=false;this.positionBlocks=null;for(var a=0;a<this.blocks.length;a++){var b=this.blocks[a];if(b.image){b.div.removeChild(b.image)}b.image=null;if(b.div){this.groupDiv.removeChild(b.div)}b.div=null}this.blocks=null;OpenLayers.Popup.Anchored.prototype.destroy.apply(this,arguments)},setBackgroundColor:function(a){},setBorder:function(){},setOpacity:function(a){},setSize:function(a){OpenLayers.Popup.Anchored.prototype.setSize.apply(this,arguments);this.updateBlocks()},updateRelativePosition:function(){this.padding=this.positionBlocks[this.relativePosition].padding;if(this.closeDiv){var a=this.getContentDivPadding();this.closeDiv.style.right=a.right+this.padding.right+"px";this.closeDiv.style.top=a.top+this.padding.top+"px"}this.updateBlocks()},calculateNewPx:function(a){var b=OpenLayers.Popup.Anchored.prototype.calculateNewPx.apply(this,arguments);b=b.offset(this.positionBlocks[this.relativePosition].offset);return b},createBlocks:function(){this.blocks=[];var f=null;for(var e in this.positionBlocks){f=e;break}var a=this.positionBlocks[f];for(var d=0;d<a.blocks.length;d++){var h={};this.blocks.push(h);var b=this.id+"_FrameDecorationDiv_"+d;h.div=OpenLayers.Util.createDiv(b,null,null,null,"absolute",null,"hidden",null);var c=this.id+"_FrameDecorationImg_"+d;var g=(this.isAlphaImage)?OpenLayers.Util.createAlphaImageDiv:OpenLayers.Util.createImage;h.image=g(c,null,this.imageSize,this.imageSrc,"absolute",null,null,null);h.div.appendChild(h.image);this.groupDiv.appendChild(h.div)}},updateBlocks:function(){if(!this.blocks){this.createBlocks()}if(this.size&&this.relativePosition){var j=this.positionBlocks[this.relativePosition];for(var f=0;f<j.blocks.length;f++){var c=j.blocks[f];var e=this.blocks[f];var d=c.anchor.left;var k=c.anchor.bottom;var a=c.anchor.right;var n=c.anchor.top;var m=(isNaN(c.size.w))?this.size.w-(a+d):c.size.w;var g=(isNaN(c.size.h))?this.size.h-(k+n):c.size.h;e.div.style.width=(m<0?0:m)+"px";e.div.style.height=(g<0?0:g)+"px";e.div.style.left=(d!=null)?d+"px":"";e.div.style.bottom=(k!=null)?k+"px":"";e.div.style.right=(a!=null)?a+"px":"";e.div.style.top=(n!=null)?n+"px":"";e.image.style.left=c.position.x+"px";e.image.style.top=c.position.y+"px"}this.contentDiv.style.left=this.padding.left+"px";this.contentDiv.style.top=this.padding.top+"px"}},CLASS_NAME:"OpenLayers.Popup.Framed"});OpenLayers.Layer.XYZ=OpenLayers.Class(OpenLayers.Layer.Grid,{isBaseLayer:true,sphericalMercator:false,zoomOffset:0,serverResolutions:null,initialize:function(d,c,b){if(b&&b.sphericalMercator||this.sphericalMercator){b=OpenLayers.Util.extend({maxExtent:new OpenLayers.Bounds(-128*156543.03390625,-128*156543.03390625,128*156543.03390625,128*156543.03390625),maxResolution:156543.03390625,numZoomLevels:19,units:"m",projection:"EPSG:900913"},b)}c=c||this.url;d=d||this.name;var a=[d,c,{},b];OpenLayers.Layer.Grid.prototype.initialize.apply(this,a)},clone:function(a){if(a==null){a=new OpenLayers.Layer.XYZ(this.name,this.url,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(d){var a=this.getXYZ(d);var b=this.url;if(OpenLayers.Util.isArray(b)){var c=""+a.x+a.y+a.z;b=this.selectUrl(c,b)}return OpenLayers.String.format(b,a)},getXYZ:function(d){var c=this.map.getResolution();var a=Math.round((d.left-this.maxExtent.left)/(c*this.tileSize.w));var f=Math.round((this.maxExtent.top-d.top)/(c*this.tileSize.h));var e=this.serverResolutions!=null?OpenLayers.Util.indexOf(this.serverResolutions,c):this.map.getZoom()+this.zoomOffset;var b=Math.pow(2,e);if(this.wrapDateLine){a=((a%b)+b)%b}return{x:a,y:f,z:e}},setMap:function(a){OpenLayers.Layer.Grid.prototype.setMap.apply(this,arguments);if(!this.tileOrigin){this.tileOrigin=new OpenLayers.LonLat(this.maxExtent.left,this.maxExtent.bottom)}},CLASS_NAME:"OpenLayers.Layer.XYZ"});OpenLayers.Layer.OSM=OpenLayers.Class(OpenLayers.Layer.XYZ,{name:"OpenStreetMap",attribution:"Data CC-By-SA by <a href='http://openstreetmap.org/'>OpenStreetMap</a>",sphericalMercator:true,url:"http://tile.openstreetmap.org/${z}/${x}/${y}.png",clone:function(a){if(a==null){a=new OpenLayers.Layer.OSM(this.name,this.url,this.getOptions())}a=OpenLayers.Layer.XYZ.prototype.clone.apply(this,[a]);return a},wrapDateLine:true,CLASS_NAME:"OpenLayers.Layer.OSM"});OpenLayers.Handler.Drag=OpenLayers.Class(OpenLayers.Handler,{started:false,stopDown:true,dragging:false,touch:false,last:null,start:null,lastMoveEvt:null,oldOnselectstart:null,interval:0,timeoutId:null,documentDrag:false,documentEvents:null,initialize:function(d,c,a){OpenLayers.Handler.prototype.initialize.apply(this,arguments);if(this.documentDrag===true){var b=this;this._docMove=function(e){b.mousemove({xy:{x:e.clientX,y:e.clientY},element:document})};this._docUp=function(e){b.mouseup({xy:{x:e.clientX,y:e.clientY}})}}},dragstart:function(b){var a=true;this.dragging=false;if(this.checkModifiers(b)&&(OpenLayers.Event.isLeftClick(b)||OpenLayers.Event.isSingleTouch(b))){this.started=true;this.start=b.xy;this.last=b.xy;OpenLayers.Element.addClass(this.map.viewPortDiv,"olDragDown");this.down(b);this.callback("down",[b.xy]);OpenLayers.Event.stop(b);if(!this.oldOnselectstart){this.oldOnselectstart=document.onselectstart?document.onselectstart:OpenLayers.Function.True}document.onselectstart=OpenLayers.Function.False;a=!this.stopDown}else{this.started=false;this.start=null;this.last=null}return a},dragmove:function(a){this.lastMoveEvt=a;if(this.started&&!this.timeoutId&&(a.xy.x!=this.last.x||a.xy.y!=this.last.y)){if(this.documentDrag===true&&this.documentEvents){if(a.element===document){this.adjustXY(a);this.setEvent(a)}else{this.removeDocumentEvents()}}if(this.interval>0){this.timeoutId=setTimeout(OpenLayers.Function.bind(this.removeTimeout,this),this.interval)}this.dragging=true;this.move(a);this.callback("move",[a.xy]);if(!this.oldOnselectstart){this.oldOnselectstart=document.onselectstart;document.onselectstart=OpenLayers.Function.False}this.last=a.xy}return true},dragend:function(b){if(this.started){if(this.documentDrag===true&&this.documentEvents){this.adjustXY(b);this.removeDocumentEvents()}var a=(this.start!=this.last);this.started=false;this.dragging=false;OpenLayers.Element.removeClass(this.map.viewPortDiv,"olDragDown");this.up(b);this.callback("up",[b.xy]);if(a){this.callback("done",[b.xy])}document.onselectstart=this.oldOnselectstart}return true},down:function(a){},move:function(a){},up:function(a){},out:function(a){},mousedown:function(a){return this.dragstart(a)},touchstart:function(a){if(!this.touch){this.touch=true;this.map.events.un({mousedown:this.mousedown,mouseup:this.mouseup,mousemove:this.mousemove,click:this.click,scope:this})}return this.dragstart(a)},mousemove:function(a){return this.dragmove(a)},touchmove:function(a){return this.dragmove(a)},removeTimeout:function(){this.timeoutId=null;if(this.dragging){this.mousemove(this.lastMoveEvt)}},mouseup:function(a){return this.dragend(a)},touchend:function(a){a.xy=this.last;return this.dragend(a)},mouseout:function(b){if(this.started&&OpenLayers.Util.mouseLeft(b,this.map.eventsDiv)){if(this.documentDrag===true){this.addDocumentEvents()}else{var a=(this.start!=this.last);this.started=false;this.dragging=false;OpenLayers.Element.removeClass(this.map.viewPortDiv,"olDragDown");this.out(b);this.callback("out",[]);if(a){this.callback("done",[b.xy])}if(document.onselectstart){document.onselectstart=this.oldOnselectstart}}}return true},click:function(a){return(this.start==this.last)},activate:function(){var a=false;if(OpenLayers.Handler.prototype.activate.apply(this,arguments)){this.dragging=false;a=true}return a},deactivate:function(){var a=false;if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){this.touch=false;this.started=false;this.dragging=false;this.start=null;this.last=null;a=true;OpenLayers.Element.removeClass(this.map.viewPortDiv,"olDragDown")}return a},adjustXY:function(a){var b=OpenLayers.Util.pagePosition(this.map.viewPortDiv);a.xy.x-=b[0];a.xy.y-=b[1]},addDocumentEvents:function(){OpenLayers.Element.addClass(document.body,"olDragDown");this.documentEvents=true;OpenLayers.Event.observe(document,"mousemove",this._docMove);OpenLayers.Event.observe(document,"mouseup",this._docUp)},removeDocumentEvents:function(){OpenLayers.Element.removeClass(document.body,"olDragDown");this.documentEvents=false;OpenLayers.Event.stopObserving(document,"mousemove",this._docMove);OpenLayers.Event.stopObserving(document,"mouseup",this._docUp)},CLASS_NAME:"OpenLayers.Handler.Drag"});OpenLayers.Handler.Box=OpenLayers.Class(OpenLayers.Handler,{dragHandler:null,boxDivClassName:"olHandlerBoxZoomBox",boxOffsets:null,initialize:function(c,b,a){OpenLayers.Handler.prototype.initialize.apply(this,arguments);this.dragHandler=new OpenLayers.Handler.Drag(this,{down:this.startBox,move:this.moveBox,out:this.removeBox,up:this.endBox},{keyMask:this.keyMask})},destroy:function(){OpenLayers.Handler.prototype.destroy.apply(this,arguments);if(this.dragHandler){this.dragHandler.destroy();this.dragHandler=null}},setMap:function(a){OpenLayers.Handler.prototype.setMap.apply(this,arguments);if(this.dragHandler){this.dragHandler.setMap(a)}},startBox:function(a){this.callback("start",[]);this.zoomBox=OpenLayers.Util.createDiv("zoomBox",new OpenLayers.Pixel(-9999,-9999));this.zoomBox.className=this.boxDivClassName;this.zoomBox.style.zIndex=this.map.Z_INDEX_BASE.Popup-1;this.map.eventsDiv.appendChild(this.zoomBox);OpenLayers.Element.addClass(this.map.eventsDiv,"olDrawBox")},moveBox:function(e){var d=this.dragHandler.start.x;var b=this.dragHandler.start.y;var c=Math.abs(d-e.x);var a=Math.abs(b-e.y);var f=this.getBoxOffsets();this.zoomBox.style.width=(c+f.width+1)+"px";this.zoomBox.style.height=(a+f.height+1)+"px";this.zoomBox.style.left=(e.x<d?d-c-f.left:d-f.left)+"px";this.zoomBox.style.top=(e.y<b?b-a-f.top:b-f.top)+"px"},endBox:function(b){var a;if(Math.abs(this.dragHandler.start.x-b.x)>5||Math.abs(this.dragHandler.start.y-b.y)>5){var g=this.dragHandler.start;var f=Math.min(g.y,b.y);var c=Math.max(g.y,b.y);var e=Math.min(g.x,b.x);var d=Math.max(g.x,b.x);a=new OpenLayers.Bounds(e,c,d,f)}else{a=this.dragHandler.start.clone()}this.removeBox();this.callback("done",[a])},removeBox:function(){this.map.eventsDiv.removeChild(this.zoomBox);this.zoomBox=null;this.boxOffsets=null;OpenLayers.Element.removeClass(this.map.eventsDiv,"olDrawBox")},activate:function(){if(OpenLayers.Handler.prototype.activate.apply(this,arguments)){this.dragHandler.activate();return true}else{return false}},deactivate:function(){if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){if(this.dragHandler.deactivate()){if(this.zoomBox){this.removeBox()}}return true}else{return false}},getBoxOffsets:function(){if(!this.boxOffsets){var d=document.createElement("div");d.style.position="absolute";d.style.border="1px solid black";d.style.width="3px";document.body.appendChild(d);var a=d.clientWidth==3;document.body.removeChild(d);var f=parseInt(OpenLayers.Element.getStyle(this.zoomBox,"border-left-width"));var c=parseInt(OpenLayers.Element.getStyle(this.zoomBox,"border-right-width"));var e=parseInt(OpenLayers.Element.getStyle(this.zoomBox,"border-top-width"));var b=parseInt(OpenLayers.Element.getStyle(this.zoomBox,"border-bottom-width"));this.boxOffsets={left:f,right:c,top:e,bottom:b,width:a===false?f+c:0,height:a===false?e+b:0}}return this.boxOffsets},CLASS_NAME:"OpenLayers.Handler.Box"});OpenLayers.Control.ZoomBox=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_TOOL,out:false,alwaysZoom:false,draw:function(){this.handler=new OpenLayers.Handler.Box(this,{done:this.zoomBox},{keyMask:this.keyMask})},zoomBox:function(h){if(h instanceof OpenLayers.Bounds){var b;if(!this.out){var i=this.map.getLonLatFromPixel(new OpenLayers.Pixel(h.left,h.bottom));var m=this.map.getLonLatFromPixel(new OpenLayers.Pixel(h.right,h.top));b=new OpenLayers.Bounds(i.lon,i.lat,m.lon,m.lat)}else{var g=Math.abs(h.right-h.left);var j=Math.abs(h.top-h.bottom);var e=Math.min((this.map.size.h/j),(this.map.size.w/g));var n=this.map.getExtent();var a=this.map.getLonLatFromPixel(h.getCenterPixel());var c=a.lon-(n.getWidth()/2)*e;var f=a.lon+(n.getWidth()/2)*e;var l=a.lat-(n.getHeight()/2)*e;var d=a.lat+(n.getHeight()/2)*e;b=new OpenLayers.Bounds(c,l,f,d)}var k=this.map.getZoom();this.map.zoomToExtent(b);if(k==this.map.getZoom()&&this.alwaysZoom==true){this.map.zoomTo(k+(this.out?-1:1))}}else{if(!this.out){this.map.setCenter(this.map.getLonLatFromPixel(h),this.map.getZoom()+1)}else{this.map.setCenter(this.map.getLonLatFromPixel(h),this.map.getZoom()-1)}}},CLASS_NAME:"OpenLayers.Control.ZoomBox"});OpenLayers.Control.DragPan=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_TOOL,panned:false,interval:1,documentDrag:false,kinetic:null,enableKinetic:false,kineticInterval:10,draw:function(){if(this.enableKinetic){var a={interval:this.kineticInterval};if(typeof this.enableKinetic==="object"){a=OpenLayers.Util.extend(a,this.enableKinetic)}this.kinetic=new OpenLayers.Kinetic(a)}this.handler=new OpenLayers.Handler.Drag(this,{move:this.panMap,done:this.panMapDone,down:this.panMapStart},{interval:this.interval,documentDrag:this.documentDrag})},panMapStart:function(){if(this.kinetic){this.kinetic.begin()}},panMap:function(a){if(this.kinetic){this.kinetic.update(a)}this.panned=true;this.map.pan(this.handler.last.x-a.x,this.handler.last.y-a.y,{dragging:true,animate:false})},panMapDone:function(c){if(this.panned){var b=null;if(this.kinetic){b=this.kinetic.end(c)}this.map.pan(this.handler.last.x-c.x,this.handler.last.y-c.y,{dragging:!!b,animate:false});if(b){var a=this;this.kinetic.move(b,function(d,f,e){a.map.pan(d,f,{dragging:!e,animate:false})})}this.panned=false}},CLASS_NAME:"OpenLayers.Control.DragPan"});OpenLayers.Control.Navigation=OpenLayers.Class(OpenLayers.Control,{dragPan:null,dragPanOptions:null,pinchZoom:null,pinchZoomOptions:null,documentDrag:false,zoomBox:null,zoomBoxEnabled:true,zoomWheelEnabled:true,mouseWheelOptions:null,handleRightClicks:false,zoomBoxKeyMask:OpenLayers.Handler.MOD_SHIFT,autoActivate:true,initialize:function(a){this.handlers={};OpenLayers.Control.prototype.initialize.apply(this,arguments)},destroy:function(){this.deactivate();if(this.dragPan){this.dragPan.destroy()}this.dragPan=null;if(this.zoomBox){this.zoomBox.destroy()}this.zoomBox=null;if(this.pinchZoom){this.pinchZoom.destroy()}this.pinchZoom=null;OpenLayers.Control.prototype.destroy.apply(this,arguments)},activate:function(){this.dragPan.activate();if(this.zoomWheelEnabled){this.handlers.wheel.activate()}this.handlers.click.activate();if(this.zoomBoxEnabled){this.zoomBox.activate()}if(this.pinchZoom){this.pinchZoom.activate()}return OpenLayers.Control.prototype.activate.apply(this,arguments)},deactivate:function(){if(this.pinchZoom){this.pinchZoom.deactivate()}this.zoomBox.deactivate();this.dragPan.deactivate();this.handlers.click.deactivate();this.handlers.wheel.deactivate();return OpenLayers.Control.prototype.deactivate.apply(this,arguments)},draw:function(){if(this.handleRightClicks){this.map.viewPortDiv.oncontextmenu=OpenLayers.Function.False}var a={click:this.defaultClick,dblclick:this.defaultDblClick,dblrightclick:this.defaultDblRightClick};var b={"double":true,stopDouble:true};this.handlers.click=new OpenLayers.Handler.Click(this,a,b);this.dragPan=new OpenLayers.Control.DragPan(OpenLayers.Util.extend({map:this.map,documentDrag:this.documentDrag},this.dragPanOptions));this.zoomBox=new OpenLayers.Control.ZoomBox({map:this.map,keyMask:this.zoomBoxKeyMask});this.dragPan.draw();this.zoomBox.draw();this.handlers.wheel=new OpenLayers.Handler.MouseWheel(this,{up:this.wheelUp,down:this.wheelDown},this.mouseWheelOptions);if(OpenLayers.Control.PinchZoom){this.pinchZoom=new OpenLayers.Control.PinchZoom(OpenLayers.Util.extend({map:this.map},this.pinchZoomOptions))}},defaultClick:function(a){if(a.lastTouches&&a.lastTouches.length==2){this.map.zoomOut()}},defaultDblClick:function(b){var a=this.map.getLonLatFromViewPortPx(b.xy);this.map.setCenter(a,this.map.zoom+1)},defaultDblRightClick:function(b){var a=this.map.getLonLatFromViewPortPx(b.xy);this.map.setCenter(a,this.map.zoom-1)},wheelChange:function(i,c){var h=this.map.getZoom();var f=this.map.getZoom()+Math.round(c);f=Math.max(f,0);f=Math.min(f,this.map.getNumZoomLevels());if(f===h){return}var j=this.map.getSize();var e=j.w/2-i.xy.x;var d=i.xy.y-j.h/2;var g=this.map.baseLayer.getResolutionForZoom(f);var a=this.map.getLonLatFromPixel(i.xy);var b=new OpenLayers.LonLat(a.lon+e*g,a.lat+d*g);this.map.setCenter(b,f)},wheelUp:function(a,b){this.wheelChange(a,b||1)},wheelDown:function(a,b){this.wheelChange(a,b||-1)},disableZoomBox:function(){this.zoomBoxEnabled=false;this.zoomBox.deactivate()},enableZoomBox:function(){this.zoomBoxEnabled=true;if(this.active){this.zoomBox.activate()}},disableZoomWheel:function(){this.zoomWheelEnabled=false;this.handlers.wheel.deactivate()},enableZoomWheel:function(){this.zoomWheelEnabled=true;if(this.active){this.handlers.wheel.activate()}},CLASS_NAME:"OpenLayers.Control.Navigation"});OpenLayers.Control.DrawFeature=OpenLayers.Class(OpenLayers.Control,{layer:null,callbacks:null,EVENT_TYPES:["featureadded"],multi:false,featureAdded:function(){},handlerOptions:null,initialize:function(b,c,a){this.EVENT_TYPES=OpenLayers.Control.DrawFeature.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);OpenLayers.Control.prototype.initialize.apply(this,[a]);this.callbacks=OpenLayers.Util.extend({done:this.drawFeature,modify:function(f,e){this.layer.events.triggerEvent("sketchmodified",{vertex:f,feature:e})},create:function(f,e){this.layer.events.triggerEvent("sketchstarted",{vertex:f,feature:e})}},this.callbacks);this.layer=b;this.handlerOptions=this.handlerOptions||{};if(!("multi" in this.handlerOptions)){this.handlerOptions.multi=this.multi}var d=this.layer.styleMap&&this.layer.styleMap.styles.temporary;if(d){this.handlerOptions.layerOptions=OpenLayers.Util.applyDefaults(this.handlerOptions.layerOptions,{styleMap:new OpenLayers.StyleMap({"default":d})})}this.handler=new c(this,this.callbacks,this.handlerOptions)},drawFeature:function(c){var a=new OpenLayers.Feature.Vector(c);var b=this.layer.events.triggerEvent("sketchcomplete",{feature:a});if(b!==false){a.state=OpenLayers.State.INSERT;this.layer.addFeatures([a]);this.featureAdded(a);this.events.triggerEvent("featureadded",{feature:a})}},insertXY:function(a,b){if(this.handler&&this.handler.line){this.handler.insertXY(a,b)}},insertDeltaXY:function(b,a){if(this.handler&&this.handler.line){this.handler.insertDeltaXY(b,a)}},insertDirectionLength:function(b,a){if(this.handler&&this.handler.line){this.handler.insertDirectionLength(b,a)}},insertDeflectionLength:function(b,a){if(this.handler&&this.handler.line){this.handler.insertDeflectionLength(b,a)}},undo:function(){return this.handler.undo&&this.handler.undo()},redo:function(){return this.handler.redo&&this.handler.redo()},finishSketch:function(){this.handler.finishGeometry()},cancel:function(){this.handler.cancel()},CLASS_NAME:"OpenLayers.Control.DrawFeature"});OpenLayers.Handler.Polygon=OpenLayers.Class(OpenLayers.Handler.Path,{holeModifier:null,drawingHole:false,polygon:null,initialize:function(c,b,a){OpenLayers.Handler.Path.prototype.initialize.apply(this,arguments)},createFeature:function(a){var b=this.map.getLonLatFromPixel(a);var c=new OpenLayers.Geometry.Point(b.lon,b.lat);this.point=new OpenLayers.Feature.Vector(c);this.line=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.LinearRing([this.point.geometry]));this.polygon=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Polygon([this.line.geometry]));this.callback("create",[this.point.geometry,this.getSketch()]);this.point.geometry.clearBounds();this.layer.addFeatures([this.polygon,this.point],{silent:true})},addPoint:function(a){if(!this.drawingHole&&this.holeModifier&&this.evt&&this.evt[this.holeModifier]){var f=this.point.geometry;var e=this.control.layer.features;var d,c;for(var b=e.length-1;b>=0;--b){d=e[b].geometry;if((d instanceof OpenLayers.Geometry.Polygon||d instanceof OpenLayers.Geometry.MultiPolygon)&&d.intersects(f)){c=e[b];this.control.layer.removeFeatures([c],{silent:true});this.control.layer.events.registerPriority("sketchcomplete",this,this.finalizeInteriorRing);this.control.layer.events.registerPriority("sketchmodified",this,this.enforceTopology);c.geometry.addComponent(this.line.geometry);this.polygon=c;this.drawingHole=true;break}}}OpenLayers.Handler.Path.prototype.addPoint.apply(this,arguments)},getCurrentPointIndex:function(){return this.line.geometry.components.length-2},enforceTopology:function(d){var a=d.vertex;var c=this.line.geometry.components;if(!this.polygon.geometry.intersects(a)){var b=c[c.length-3];a.x=b.x;a.y=b.y}},finishGeometry:function(){var a=this.line.geometry.components.length-2;this.line.geometry.removeComponent(this.line.geometry.components[a]);this.removePoint();this.finalize()},finalizeInteriorRing:function(){var c=this.line.geometry;var b=(c.getArea()!==0);if(b){var h=this.polygon.geometry.components;for(var d=h.length-2;d>=0;--d){if(c.intersects(h[d])){b=false;break}}if(b){var g;outer:for(var d=h.length-2;d>0;--d){var e=h[d].components;for(var a=0,f=e.length;a<f;++a){if(c.containsPoint(e[a])){b=false;break outer}}}}}if(b){if(this.polygon.state!==OpenLayers.State.INSERT){this.polygon.state=OpenLayers.State.UPDATE}}else{this.polygon.geometry.removeComponent(c)}this.restoreFeature();return false},cancel:function(){if(this.drawingHole){this.polygon.geometry.removeComponent(this.line.geometry);this.restoreFeature(true)}return OpenLayers.Handler.Path.prototype.cancel.apply(this,arguments)},restoreFeature:function(a){this.control.layer.events.unregister("sketchcomplete",this,this.finalizeInteriorRing);this.control.layer.events.unregister("sketchmodified",this,this.enforceTopology);this.layer.removeFeatures([this.polygon],{silent:true});this.control.layer.addFeatures([this.polygon],{silent:true});this.drawingHole=false;if(!a){this.control.layer.events.triggerEvent("sketchcomplete",{feature:this.polygon})}},destroyFeature:function(a){OpenLayers.Handler.Path.prototype.destroyFeature.call(this,a);this.polygon=null},drawFeature:function(){this.layer.drawFeature(this.polygon,this.style);this.layer.drawFeature(this.point,this.style)},getSketch:function(){return this.polygon},getGeometry:function(){var a=this.polygon&&this.polygon.geometry;if(a&&this.multi){a=new OpenLayers.Geometry.MultiPolygon([a])}return a},CLASS_NAME:"OpenLayers.Handler.Polygon"});OpenLayers.Control.EditingToolbar=OpenLayers.Class(OpenLayers.Control.Panel,{initialize:function(c,b){OpenLayers.Control.Panel.prototype.initialize.apply(this,[b]);this.addControls([new OpenLayers.Control.Navigation()]);var a=[new OpenLayers.Control.DrawFeature(c,OpenLayers.Handler.Point,{displayClass:"olControlDrawFeaturePoint"}),new OpenLayers.Control.DrawFeature(c,OpenLayers.Handler.Path,{displayClass:"olControlDrawFeaturePath"}),new OpenLayers.Control.DrawFeature(c,OpenLayers.Handler.Polygon,{displayClass:"olControlDrawFeaturePolygon"})];this.addControls(a)},draw:function(){var a=OpenLayers.Control.Panel.prototype.draw.apply(this,arguments);if(this.defaultControl===null){this.defaultControl=this.controls[0]}return a},CLASS_NAME:"OpenLayers.Control.EditingToolbar"});OpenLayers.Rico=OpenLayers.Rico||{};OpenLayers.Rico.Color=OpenLayers.Class({initialize:function(c,b,a){this.rgb={r:c,g:b,b:a}},setRed:function(a){this.rgb.r=a},setGreen:function(a){this.rgb.g=a},setBlue:function(a){this.rgb.b=a},setHue:function(b){var a=this.asHSB();a.h=b;this.rgb=OpenLayers.Rico.Color.HSBtoRGB(a.h,a.s,a.b)},setSaturation:function(b){var a=this.asHSB();a.s=b;this.rgb=OpenLayers.Rico.Color.HSBtoRGB(a.h,a.s,a.b)},setBrightness:function(a){var c=this.asHSB();c.b=a;this.rgb=OpenLayers.Rico.Color.HSBtoRGB(c.h,c.s,c.b)},darken:function(b){var a=this.asHSB();this.rgb=OpenLayers.Rico.Color.HSBtoRGB(a.h,a.s,Math.max(a.b-b,0))},brighten:function(b){var a=this.asHSB();this.rgb=OpenLayers.Rico.Color.HSBtoRGB(a.h,a.s,Math.min(a.b+b,1))},blend:function(a){this.rgb.r=Math.floor((this.rgb.r+a.rgb.r)/2);this.rgb.g=Math.floor((this.rgb.g+a.rgb.g)/2);this.rgb.b=Math.floor((this.rgb.b+a.rgb.b)/2)},isBright:function(){var a=this.asHSB();return this.asHSB().b>0.5},isDark:function(){return !this.isBright()},asRGB:function(){return"rgb("+this.rgb.r+","+this.rgb.g+","+this.rgb.b+")"},asHex:function(){return"#"+this.rgb.r.toColorPart()+this.rgb.g.toColorPart()+this.rgb.b.toColorPart()},asHSB:function(){return OpenLayers.Rico.Color.RGBtoHSB(this.rgb.r,this.rgb.g,this.rgb.b)},toString:function(){return this.asHex()}});OpenLayers.Rico.Color.createFromHex=function(d){if(d.length==4){var b=d;var d="#";for(var c=1;c<4;c++){d+=(b.charAt(c)+b.charAt(c))}}if(d.indexOf("#")==0){d=d.substring(1)}var f=d.substring(0,2);var e=d.substring(2,4);var a=d.substring(4,6);return new OpenLayers.Rico.Color(parseInt(f,16),parseInt(e,16),parseInt(a,16))};OpenLayers.Rico.Color.createColorFromBackground=function(d){var b=OpenLayers.Element.getStyle(OpenLayers.Util.getElement(d),"backgroundColor");if(b=="transparent"&&d.parentNode){return OpenLayers.Rico.Color.createColorFromBackground(d.parentNode)}if(b==null){return new OpenLayers.Rico.Color(255,255,255)}if(b.indexOf("rgb(")==0){var a=b.substring(4,b.length-1);var c=a.split(",");return new OpenLayers.Rico.Color(parseInt(c[0]),parseInt(c[1]),parseInt(c[2]))}else{if(b.indexOf("#")==0){return OpenLayers.Rico.Color.createFromHex(b)}else{return new OpenLayers.Rico.Color(255,255,255)}}};OpenLayers.Rico.Color.HSBtoRGB=function(i,e,k){var c=0;var d=0;var l=0;if(e==0){c=parseInt(k*255+0.5);d=c;l=c}else{var g=(i-Math.floor(i))*6;var j=g-Math.floor(g);var b=k*(1-e);var a=k*(1-e*j);var m=k*(1-(e*(1-j)));switch(parseInt(g)){case 0:c=(k*255+0.5);d=(m*255+0.5);l=(b*255+0.5);break;case 1:c=(a*255+0.5);d=(k*255+0.5);l=(b*255+0.5);break;case 2:c=(b*255+0.5);d=(k*255+0.5);l=(m*255+0.5);break;case 3:c=(b*255+0.5);d=(a*255+0.5);l=(k*255+0.5);break;case 4:c=(m*255+0.5);d=(b*255+0.5);l=(k*255+0.5);break;case 5:c=(k*255+0.5);d=(b*255+0.5);l=(a*255+0.5);break}}return{r:parseInt(c),g:parseInt(d),b:parseInt(l)}};OpenLayers.Rico.Color.RGBtoHSB=function(a,f,l){var h;var e;var k;var m=(a>f)?a:f;if(l>m){m=l}var i=(a<f)?a:f;if(l<i){i=l}k=m/255;if(m!=0){e=(m-i)/m}else{e=0}if(e==0){h=0}else{var c=(m-a)/(m-i);var j=(m-f)/(m-i);var d=(m-l)/(m-i);if(a==m){h=d-j}else{if(f==m){h=2+c-d}else{h=4+j-c}}h=h/6;if(h<0){h=h+1}}return{h:h,s:e,b:k}};OpenLayers.Rico=OpenLayers.Rico||{};OpenLayers.Rico.Corner={round:function(d,b){d=OpenLayers.Util.getElement(d);this._setOptions(b);var a=this.options.color;if(this.options.color=="fromElement"){a=this._background(d)}var c=this.options.bgColor;if(this.options.bgColor=="fromParent"){c=this._background(d.offsetParent)}this._roundCornersImpl(d,a,c)},changeColor:function(c,b){c.style.backgroundColor=b;var a=c.parentNode.getElementsByTagName("span");for(var d=0;d<a.length;d++){a[d].style.backgroundColor=b}},changeOpacity:function(c,f){var d=f;var a="alpha(opacity="+f*100+")";c.style.opacity=d;c.style.filter=a;var b=c.parentNode.getElementsByTagName("span");for(var e=0;e<b.length;e++){b[e].style.opacity=d;b[e].style.filter=a}},reRound:function(d,c){var b=d.parentNode.childNodes[0];var a=d.parentNode.childNodes[2];d.parentNode.removeChild(b);d.parentNode.removeChild(a);this.round(d.parentNode,c)},_roundCornersImpl:function(c,a,b){if(this.options.border){this._renderBorder(c,b)}if(this._isTopRounded()){this._roundTopCorners(c,a,b)}if(this._isBottomRounded()){this._roundBottomCorners(c,a,b)}},_renderBorder:function(d,e){var b="1px solid "+this._borderColor(e);var a="border-left: "+b;var f="border-right: "+b;var c="style='"+a+";"+f+"'";d.innerHTML="<div "+c+">"+d.innerHTML+"</div>"},_roundTopCorners:function(c,a,e){var d=this._createCorner(e);for(var b=0;b<this.options.numSlices;b++){d.appendChild(this._createCornerSlice(a,e,b,"top"))}c.style.paddingTop=0;c.insertBefore(d,c.firstChild)},_roundBottomCorners:function(c,a,e){var d=this._createCorner(e);for(var b=(this.options.numSlices-1);b>=0;b--){d.appendChild(this._createCornerSlice(a,e,b,"bottom"))}c.style.paddingBottom=0;c.appendChild(d)},_createCorner:function(b){var a=document.createElement("div");a.style.backgroundColor=(this._isTransparent()?"transparent":b);return a},_createCornerSlice:function(c,d,g,a){var e=document.createElement("span");var b=e.style;b.backgroundColor=c;b.display="block";b.height="1px";b.overflow="hidden";b.fontSize="1px";var f=this._borderColor(c,d);if(this.options.border&&g==0){b.borderTopStyle="solid";b.borderTopWidth="1px";b.borderLeftWidth="0px";b.borderRightWidth="0px";b.borderBottomWidth="0px";b.height="0px";b.borderColor=f}else{if(f){b.borderColor=f;b.borderStyle="solid";b.borderWidth="0px 1px"}}if(!this.options.compact&&(g==(this.options.numSlices-1))){b.height="2px"}this._setMargin(e,g,a);this._setBorder(e,g,a);return e},_setOptions:function(a){this.options={corners:"all",color:"fromElement",bgColor:"fromParent",blend:true,border:false,compact:false};OpenLayers.Util.extend(this.options,a||{});this.options.numSlices=this.options.compact?2:4;if(this._isTransparent()){this.options.blend=false}},_whichSideTop:function(){if(this._hasString(this.options.corners,"all","top")){return""}if(this.options.corners.indexOf("tl")>=0&&this.options.corners.indexOf("tr")>=0){return""}if(this.options.corners.indexOf("tl")>=0){return"left"}else{if(this.options.corners.indexOf("tr")>=0){return"right"}}return""},_whichSideBottom:function(){if(this._hasString(this.options.corners,"all","bottom")){return""}if(this.options.corners.indexOf("bl")>=0&&this.options.corners.indexOf("br")>=0){return""}if(this.options.corners.indexOf("bl")>=0){return"left"}else{if(this.options.corners.indexOf("br")>=0){return"right"}}return""},_borderColor:function(a,b){if(a=="transparent"){return b}else{if(this.options.border){return this.options.border}else{if(this.options.blend){return this._blend(b,a)}else{return""}}}},_setMargin:function(d,e,b){var c=this._marginSize(e);var a=b=="top"?this._whichSideTop():this._whichSideBottom();if(a=="left"){d.style.marginLeft=c+"px";d.style.marginRight="0px"}else{if(a=="right"){d.style.marginRight=c+"px";d.style.marginLeft="0px"}else{d.style.marginLeft=c+"px";d.style.marginRight=c+"px"}}},_setBorder:function(d,e,b){var c=this._borderSize(e);var a=b=="top"?this._whichSideTop():this._whichSideBottom();if(a=="left"){d.style.borderLeftWidth=c+"px";d.style.borderRightWidth="0px"}else{if(a=="right"){d.style.borderRightWidth=c+"px";d.style.borderLeftWidth="0px"}else{d.style.borderLeftWidth=c+"px";d.style.borderRightWidth=c+"px"}}if(this.options.border!=false){d.style.borderLeftWidth=c+"px";d.style.borderRightWidth=c+"px"}},_marginSize:function(e){if(this._isTransparent()){return 0}var d=[5,3,2,1];var a=[3,2,1,0];var c=[2,1];var b=[1,0];if(this.options.compact&&this.options.blend){return b[e]}else{if(this.options.compact){return c[e]}else{if(this.options.blend){return a[e]}else{return d[e]}}}},_borderSize:function(e){var d=[5,3,2,1];var b=[2,1,1,1];var a=[1,0];var c=[0,2,0,0];if(this.options.compact&&(this.options.blend||this._isTransparent())){return 1}else{if(this.options.compact){return a[e]}else{if(this.options.blend){return b[e]}else{if(this.options.border){return c[e]}else{if(this._isTransparent()){return d[e]}}}}}return 0},_hasString:function(b){for(var a=1;a<arguments.length;a++){if(b.indexOf(arguments[a])>=0){return true}}return false},_blend:function(c,a){var b=OpenLayers.Rico.Color.createFromHex(c);b.blend(OpenLayers.Rico.Color.createFromHex(a));return b},_background:function(a){try{return OpenLayers.Rico.Color.createColorFromBackground(a).asHex()}catch(b){return"#ffffff"}},_isTransparent:function(){return this.options.color=="transparent"},_isTopRounded:function(){return this._hasString(this.options.corners,"all","top","tl","tr")},_isBottomRounded:function(){return this._hasString(this.options.corners,"all","bottom","bl","br")},_hasSingleTextChild:function(a){return a.childNodes.length==1&&a.childNodes[0].nodeType==3}};OpenLayers.Popup.AnchoredBubble=OpenLayers.Class(OpenLayers.Popup.Anchored,{rounded:false,initialize:function(g,c,f,b,a,e,d){this.padding=new OpenLayers.Bounds(0,OpenLayers.Popup.AnchoredBubble.CORNER_SIZE,0,OpenLayers.Popup.AnchoredBubble.CORNER_SIZE);OpenLayers.Popup.Anchored.prototype.initialize.apply(this,arguments)},draw:function(a){OpenLayers.Popup.Anchored.prototype.draw.apply(this,arguments);this.setContentHTML();this.setBackgroundColor();this.setOpacity();return this.div},updateRelativePosition:function(){this.setRicoCorners()},setSize:function(a){OpenLayers.Popup.Anchored.prototype.setSize.apply(this,arguments);this.setRicoCorners()},setBackgroundColor:function(a){if(a!=undefined){this.backgroundColor=a}if(this.div!=null){if(this.contentDiv!=null){this.div.style.background="transparent";OpenLayers.Rico.Corner.changeColor(this.groupDiv,this.backgroundColor)}}},setOpacity:function(a){OpenLayers.Popup.Anchored.prototype.setOpacity.call(this,a);if(this.div!=null){if(this.groupDiv!=null){OpenLayers.Rico.Corner.changeOpacity(this.groupDiv,this.opacity)}}},setBorder:function(a){this.border=0},setRicoCorners:function(){var a=this.getCornersToRound(this.relativePosition);var b={corners:a,color:this.backgroundColor,bgColor:"transparent",blend:false};if(!this.rounded){OpenLayers.Rico.Corner.round(this.div,b);this.rounded=true}else{OpenLayers.Rico.Corner.reRound(this.groupDiv,b);this.setBackgroundColor();this.setOpacity()}},getCornersToRound:function(){var a=["tl","tr","bl","br"];var b=OpenLayers.Bounds.oppositeQuadrant(this.relativePosition);OpenLayers.Util.removeItem(a,b);return a.join(" ")},CLASS_NAME:"OpenLayers.Popup.AnchoredBubble"});OpenLayers.Popup.AnchoredBubble.CORNER_SIZE=5;OpenLayers.Protocol.WFS.v1=OpenLayers.Class(OpenLayers.Protocol,{version:null,srsName:"EPSG:4326",featureType:null,featureNS:null,geometryName:"the_geom",schema:null,featurePrefix:"feature",formatOptions:null,readFormat:null,readOptions:null,initialize:function(a){OpenLayers.Protocol.prototype.initialize.apply(this,[a]);if(!a.format){this.format=OpenLayers.Format.WFST(OpenLayers.Util.extend({version:this.version,featureType:this.featureType,featureNS:this.featureNS,featurePrefix:this.featurePrefix,geometryName:this.geometryName,srsName:this.srsName,schema:this.schema},this.formatOptions))}if(!a.geometryName&&parseFloat(this.format.version)>1){this.setGeometryName(null)}},destroy:function(){if(this.options&&!this.options.format){this.format.destroy()}this.format=null;OpenLayers.Protocol.prototype.destroy.apply(this)},read:function(b){OpenLayers.Protocol.prototype.read.apply(this,arguments);b=OpenLayers.Util.extend({},b);OpenLayers.Util.applyDefaults(b,this.options||{});var a=new OpenLayers.Protocol.Response({requestType:"read"});var c=OpenLayers.Format.XML.prototype.write.apply(this.format,[this.format.writeNode("wfs:GetFeature",b)]);a.priv=OpenLayers.Request.POST({url:b.url,callback:this.createCallback(this.handleRead,a,b),params:b.params,headers:b.headers,data:c});return a},setFeatureType:function(a){this.featureType=a;this.format.featureType=a},setGeometryName:function(a){this.geometryName=a;this.format.geometryName=a},handleRead:function(b,c){c=OpenLayers.Util.extend({},c);OpenLayers.Util.applyDefaults(c,this.options);if(c.callback){var d=b.priv;if(d.status>=200&&d.status<300){var a=this.parseResponse(d,c.readOptions);if(a&&a.success!==false){if(c.readOptions&&c.readOptions.output=="object"){OpenLayers.Util.extend(b,a)}else{b.features=a}b.code=OpenLayers.Protocol.Response.SUCCESS}else{b.code=OpenLayers.Protocol.Response.FAILURE;b.error=a}}else{b.code=OpenLayers.Protocol.Response.FAILURE}c.callback.call(c.scope,b)}},parseResponse:function(c,b){var e=c.responseXML;if(!e||!e.documentElement){e=c.responseText}if(!e||e.length<=0){return null}var a=(this.readFormat!==null)?this.readFormat.read(e):this.format.read(e,b);if(!this.featureNS){var d=this.readFormat||this.format;this.featureNS=d.featureNS;d.autoConfig=false;if(!this.geometryName){this.setGeometryName(d.geometryName)}}return a},commit:function(c,b){b=OpenLayers.Util.extend({},b);OpenLayers.Util.applyDefaults(b,this.options);var a=new OpenLayers.Protocol.Response({requestType:"commit",reqFeatures:c});a.priv=OpenLayers.Request.POST({url:b.url,headers:b.headers,data:this.format.write(c,b),callback:this.createCallback(this.handleCommit,a,b)});return a},handleCommit:function(a,b){if(b.callback){var c=a.priv;var d=c.responseXML;if(!d||!d.documentElement){d=c.responseText}var e=this.format.read(d)||{};a.insertIds=e.insertIds||[];if(e.success){a.code=OpenLayers.Protocol.Response.SUCCESS}else{a.code=OpenLayers.Protocol.Response.FAILURE;a.error=e}b.callback.call(b.scope,a)}},filterDelete:function(e,c){c=OpenLayers.Util.extend({},c);OpenLayers.Util.applyDefaults(c,this.options);var b=new OpenLayers.Protocol.Response({requestType:"commit"});var a=this.format.createElementNSPlus("wfs:Transaction",{attributes:{service:"WFS",version:this.version}});var d=this.format.createElementNSPlus("wfs:Delete",{attributes:{typeName:(c.featureNS?this.featurePrefix+":":"")+c.featureType}});if(c.featureNS){d.setAttribute("xmlns:"+this.featurePrefix,c.featureNS)}var g=this.format.writeNode("ogc:Filter",e);d.appendChild(g);a.appendChild(d);var f=OpenLayers.Format.XML.prototype.write.apply(this.format,[a]);return OpenLayers.Request.POST({url:this.url,callback:c.callback||function(){},data:f})},abort:function(a){if(a){a.priv.abort()}},CLASS_NAME:"OpenLayers.Protocol.WFS.v1"});OpenLayers.Layer.WorldWind=OpenLayers.Class(OpenLayers.Layer.Grid,{DEFAULT_PARAMS:{},isBaseLayer:true,lzd:null,zoomLevels:null,initialize:function(d,c,e,g,f,b){this.lzd=e;this.zoomLevels=g;var a=[];a.push(d,c,f,b);OpenLayers.Layer.Grid.prototype.initialize.apply(this,a);this.params=OpenLayers.Util.applyDefaults(this.params,this.DEFAULT_PARAMS)},getZoom:function(){var b=this.map.getZoom();var a=this.map.getMaxExtent();b=b-Math.log(this.maxResolution/(this.lzd/512))/Math.log(2);return b},getURL:function(e){e=this.adjustBounds(e);var d=this.getZoom();var b=this.map.getMaxExtent();var c=this.lzd/Math.pow(2,this.getZoom());var a=Math.floor((e.left-b.left)/c);var f=Math.floor((e.bottom-b.bottom)/c);if(this.map.getResolution()<=(this.lzd/512)&&this.getZoom()<=this.zoomLevels){return this.getFullRequestString({L:d,X:a,Y:f})}else{return OpenLayers.Util.getImagesLocation()+"blank.gif"}},CLASS_NAME:"OpenLayers.Layer.WorldWind"});OpenLayers.Protocol.WFS.v1_1_0=OpenLayers.Class(OpenLayers.Protocol.WFS.v1,{version:"1.1.0",initialize:function(a){OpenLayers.Protocol.WFS.v1.prototype.initialize.apply(this,arguments);if(this.outputFormat&&!this.readFormat){if(this.outputFormat.toLowerCase()=="gml2"){this.readFormat=new OpenLayers.Format.GML.v2({featureType:this.featureType,featureNS:this.featureNS,geometryName:this.geometryName})}else{if(this.outputFormat.toLowerCase()=="json"){this.readFormat=new OpenLayers.Format.GeoJSON()}}}},CLASS_NAME:"OpenLayers.Protocol.WFS.v1_1_0"});OpenLayers.Format.WMTSCapabilities=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.0.0",yx:{"urn:ogc:def:crs:EPSG::4326":true},createLayer:function(e,f){var k;var l={layer:true,matrixSet:true};for(var c in l){if(!(c in f)){throw new Error("Missing property '"+c+"' in layer configuration.")}}var g=e.contents;var d=g.tileMatrixSets[f.matrixSet];var j=g.layers;var b;for(var h=0,m=g.layers.length;h<m;++h){if(g.layers[h].identifier===f.layer){b=g.layers[h];break}}if(b&&d){var a;for(var h=0,m=b.styles.length;h<m;++h){a=b.styles[h];if(a.isDefault){break}}k=new OpenLayers.Layer.WMTS(OpenLayers.Util.applyDefaults(f,{url:e.operationsMetadata.GetTile.dcp.http.get,name:b.title,style:a.identifier,matrixIds:d.matrixIds}))}return k},CLASS_NAME:"OpenLayers.Format.WMTSCapabilities"});OpenLayers.Layer.Google.v3={DEFAULTS:{maxExtent:new OpenLayers.Bounds(-128*156543.03390625,-128*156543.03390625,128*156543.03390625,128*156543.03390625),sphericalMercator:true,maxResolution:156543.03390625,units:"m",projection:"EPSG:900913"},animationEnabled:true,loadMapObject:function(){if(!this.type){this.type=google.maps.MapTypeId.ROADMAP}var d;var c=OpenLayers.Layer.Google.cache[this.map.id];if(c){d=c.mapObject;++c.count}else{var b=this.map.viewPortDiv;var e=document.createElement("div");e.id=this.map.id+"_GMapContainer";e.style.position="absolute";e.style.width="100%";e.style.height="100%";b.appendChild(e);var a=this.map.getCenter();d=new google.maps.Map(e,{center:a?new google.maps.LatLng(a.lat,a.lon):new google.maps.LatLng(0,0),zoom:this.map.getZoom()||0,mapTypeId:this.type,disableDefaultUI:true,keyboardShortcuts:false,draggable:false,disableDoubleClickZoom:true,scrollwheel:false,streetViewControl:false});c={mapObject:d,count:1};OpenLayers.Layer.Google.cache[this.map.id]=c;this.repositionListener=google.maps.event.addListenerOnce(d,"center_changed",OpenLayers.Function.bind(this.repositionMapElements,this))}this.mapObject=d;this.setGMapVisibility(this.visibility)},repositionMapElements:function(){google.maps.event.trigger(this.mapObject,"resize");var e=this.mapObject.getDiv().firstChild;if(!e||e.childNodes.length<3){this.repositionTimer=window.setTimeout(OpenLayers.Function.bind(this.repositionMapElements,this),250);return false}var d=OpenLayers.Layer.Google.cache[this.map.id];var b=this.map.viewPortDiv;while(e.lastChild.style.display=="none"){b.appendChild(e.lastChild)}var c=e.lastChild;b.appendChild(c);c.style.zIndex="1100";c.style.bottom="";c.className="olLayerGoogleCopyright olLayerGoogleV3";c.style.display="";d.termsOfUse=c;var a=e.lastChild;b.appendChild(a);a.style.zIndex="1100";a.style.bottom="";a.className="olLayerGooglePoweredBy olLayerGoogleV3 gmnoprint";a.style.display="";d.poweredBy=a;this.setGMapVisibility(this.visibility)},onMapResize:function(){if(this.visibility){google.maps.event.trigger(this.mapObject,"resize")}else{var a=OpenLayers.Layer.Google.cache[this.map.id];if(!a.resized){var b=this;google.maps.event.addListenerOnce(this.mapObject,"tilesloaded",function(){google.maps.event.trigger(b.mapObject,"resize");b.moveTo(b.map.getCenter(),b.map.getZoom());delete a.resized})}a.resized=true}},setGMapVisibility:function(g){var b=OpenLayers.Layer.Google.cache[this.map.id];if(b){var e=this.type;var f=this.map.layers;var d;for(var c=f.length-1;c>=0;--c){d=f[c];if(d instanceof OpenLayers.Layer.Google&&d.visibility===true&&d.inRange===true){e=d.type;g=true;break}}var a=this.mapObject.getDiv();if(g===true){this.mapObject.setMapTypeId(e);a.style.left="";if(b.termsOfUse&&b.termsOfUse.style){b.termsOfUse.style.left="";b.termsOfUse.style.display="";b.poweredBy.style.display=""}b.displayed=this.id}else{delete b.displayed;a.style.left="-9999px";if(b.termsOfUse&&b.termsOfUse.style){b.termsOfUse.style.display="none";b.termsOfUse.style.left="-9999px";b.poweredBy.style.display="none"}}}},getMapContainer:function(){return this.mapObject.getDiv()},getMapObjectBoundsFromOLBounds:function(c){var b=null;if(c!=null){var a=this.sphericalMercator?this.inverseMercator(c.bottom,c.left):new OpenLayers.LonLat(c.bottom,c.left);var d=this.sphericalMercator?this.inverseMercator(c.top,c.right):new OpenLayers.LonLat(c.top,c.right);b=new google.maps.LatLngBounds(new google.maps.LatLng(a.lat,a.lon),new google.maps.LatLng(d.lat,d.lon))}return b},getMapObjectLonLatFromMapObjectPixel:function(h){var b=this.map.getSize();var f=this.getLongitudeFromMapObjectLonLat(this.mapObject.center);var d=this.getLatitudeFromMapObjectLonLat(this.mapObject.center);var a=this.map.getResolution();var g=h.x-(b.w/2);var e=h.y-(b.h/2);var c=new OpenLayers.LonLat(f+g*a,d-e*a);if(this.wrapDateLine){c=c.wrapDateLine(this.maxExtent)}return this.getMapObjectLonLatFromLonLat(c.lon,c.lat)},getMapObjectPixelFromMapObjectLonLat:function(f){var e=this.getLongitudeFromMapObjectLonLat(f);var d=this.getLatitudeFromMapObjectLonLat(f);var b=this.map.getResolution();var c=this.map.getExtent();var a=new OpenLayers.Pixel((1/b*(e-c.left)),(1/b*(c.top-d)));return this.getMapObjectPixelFromXY(a.x,a.y)},setMapObjectCenter:function(a,c){if(this.animationEnabled===false&&c!=this.mapObject.zoom){var b=this.getMapContainer();google.maps.event.addListenerOnce(this.mapObject,"idle",function(){b.style.visibility=""});b.style.visibility="hidden"}this.mapObject.setOptions({center:a,zoom:c})},getMapObjectZoomFromMapObjectBounds:function(a){return this.mapObject.getBoundsZoomLevel(a)},getMapObjectLonLatFromLonLat:function(d,b){var c;if(this.sphericalMercator){var a=this.inverseMercator(d,b);c=new google.maps.LatLng(a.lat,a.lon)}else{c=new google.maps.LatLng(b,d)}return c},getMapObjectPixelFromXY:function(a,b){return new google.maps.Point(a,b)},destroy:function(){if(this.repositionListener){google.maps.event.removeListener(this.repositionListener)}if(this.repositionTimer){window.clearTimeout(this.repositionTimer)}OpenLayers.Layer.Google.prototype.destroy.apply(this,arguments)}};OpenLayers.Format.WPSDescribeProcess=OpenLayers.Class(OpenLayers.Format.XML,{VERSION:"1.0.0",namespaces:{wps:"http://www.opengis.net/wps/1.0.0",ows:"http://www.opengis.net/ows/1.1",xsi:"http://www.w3.org/2001/XMLSchema-instance"},schemaLocation:"http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsAll.xsd",defaultPrefix:"wps",regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},read:function(a){if(typeof a=="string"){a=OpenLayers.Format.XML.prototype.read.apply(this,[a])}if(a&&a.nodeType==9){a=a.documentElement}var b={};this.readNode(a,b);return b},readers:{wps:{ProcessDescriptions:function(a,b){b.processDescriptions={};this.readChildNodes(a,b.processDescriptions)},ProcessDescription:function(c,a){var d=this.getAttributeNS(c,this.namespaces.wps,"processVersion");var b={processVersion:d,statusSupported:(c.getAttribute("statusSupported")==="true"),storeSupported:(c.getAttribute("storeSupported")==="true")};this.readChildNodes(c,b);a[b.identifier]=b},DataInputs:function(b,a){a.dataInputs=[];this.readChildNodes(b,a.dataInputs)},ProcessOutputs:function(b,a){a.processOutputs=[];this.readChildNodes(b,a.processOutputs)},Output:function(c,b){var a={};this.readChildNodes(c,a);b.push(a)},ComplexOutput:function(b,a){a.complexOutput={};this.readChildNodes(b,a.complexOutput)},Input:function(c,b){var a={maxOccurs:parseInt(c.getAttribute("maxOccurs")),minOccurs:parseInt(c.getAttribute("minOccurs"))};this.readChildNodes(c,a);b.push(a)},BoundingBoxData:function(b,a){a.boundingBoxData={};this.readChildNodes(b,a.boundingBoxData)},CRS:function(a,b){if(!b.CRSs){b.CRSs={}}b.CRSs[this.getChildValue(a)]=true},LiteralData:function(b,a){a.literalData={};this.readChildNodes(b,a.literalData)},ComplexData:function(b,a){a.complexData={};this.readChildNodes(b,a.complexData)},Default:function(b,a){a["default"]={};this.readChildNodes(b,a["default"])},Supported:function(b,a){a.supported={};this.readChildNodes(b,a.supported)},Format:function(a,c){var b={};this.readChildNodes(a,b);if(!c.formats){c.formats={}}c.formats[b.mimeType]=true},MimeType:function(a,b){b.mimeType=this.getChildValue(a)}},ows:OpenLayers.Format.OWSCommon.v1_1_0.prototype.readers.ows},CLASS_NAME:"OpenLayers.Format.WPSDescribeProcess"});OpenLayers.Control.MouseDefaults=OpenLayers.Class(OpenLayers.Control,{performedDrag:false,wheelObserver:null,initialize:function(){OpenLayers.Control.prototype.initialize.apply(this,arguments)},destroy:function(){if(this.handler){this.handler.destroy()}this.handler=null;this.map.events.un({click:this.defaultClick,dblclick:this.defaultDblClick,mousedown:this.defaultMouseDown,mouseup:this.defaultMouseUp,mousemove:this.defaultMouseMove,mouseout:this.defaultMouseOut,scope:this});OpenLayers.Event.stopObserving(window,"DOMMouseScroll",this.wheelObserver);OpenLayers.Event.stopObserving(window,"mousewheel",this.wheelObserver);OpenLayers.Event.stopObserving(document,"mousewheel",this.wheelObserver);this.wheelObserver=null;OpenLayers.Control.prototype.destroy.apply(this,arguments)},draw:function(){this.map.events.on({click:this.defaultClick,dblclick:this.defaultDblClick,mousedown:this.defaultMouseDown,mouseup:this.defaultMouseUp,mousemove:this.defaultMouseMove,mouseout:this.defaultMouseOut,scope:this});this.registerWheelEvents()},registerWheelEvents:function(){this.wheelObserver=OpenLayers.Function.bindAsEventListener(this.onWheelEvent,this);OpenLayers.Event.observe(window,"DOMMouseScroll",this.wheelObserver);OpenLayers.Event.observe(window,"mousewheel",this.wheelObserver);OpenLayers.Event.observe(document,"mousewheel",this.wheelObserver)},defaultClick:function(b){if(!OpenLayers.Event.isLeftClick(b)){return}var a=!this.performedDrag;this.performedDrag=false;return a},defaultDblClick:function(b){var a=this.map.getLonLatFromViewPortPx(b.xy);this.map.setCenter(a,this.map.zoom+1);OpenLayers.Event.stop(b);return false},defaultMouseDown:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}this.mouseDragStart=a.xy.clone();this.performedDrag=false;if(a.shiftKey){this.map.div.style.cursor="crosshair";this.zoomBox=OpenLayers.Util.createDiv("zoomBox",this.mouseDragStart,null,null,"absolute","2px solid red");this.zoomBox.style.backgroundColor="white";this.zoomBox.style.filter="alpha(opacity=50)";this.zoomBox.style.opacity="0.50";this.zoomBox.style.fontSize="1px";this.zoomBox.style.zIndex=this.map.Z_INDEX_BASE.Popup-1;this.map.eventsDiv.appendChild(this.zoomBox)}document.onselectstart=OpenLayers.Function.False;OpenLayers.Event.stop(a)},defaultMouseMove:function(e){this.mousePosition=e.xy.clone();if(this.mouseDragStart!=null){if(this.zoomBox){var d=Math.abs(this.mouseDragStart.x-e.xy.x);var b=Math.abs(this.mouseDragStart.y-e.xy.y);this.zoomBox.style.width=Math.max(1,d)+"px";this.zoomBox.style.height=Math.max(1,b)+"px";if(e.xy.x<this.mouseDragStart.x){this.zoomBox.style.left=e.xy.x+"px"}if(e.xy.y<this.mouseDragStart.y){this.zoomBox.style.top=e.xy.y+"px"}}else{var d=this.mouseDragStart.x-e.xy.x;var b=this.mouseDragStart.y-e.xy.y;var f=this.map.getSize();var a=new OpenLayers.Pixel(f.w/2+d,f.h/2+b);var c=this.map.getLonLatFromViewPortPx(a);this.map.setCenter(c,null,true);this.mouseDragStart=e.xy.clone();this.map.div.style.cursor="move"}this.performedDrag=true}},defaultMouseUp:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}if(this.zoomBox){this.zoomBoxEnd(a)}else{if(this.performedDrag){this.map.setCenter(this.map.center)}}document.onselectstart=null;this.mouseDragStart=null;this.map.div.style.cursor=""},defaultMouseOut:function(a){if(this.mouseDragStart!=null&&OpenLayers.Util.mouseLeft(a,this.map.eventsDiv)){if(this.zoomBox){this.removeZoomBox()}this.mouseDragStart=null}},defaultWheelUp:function(a){if(this.map.getZoom()<=this.map.getNumZoomLevels()){this.map.setCenter(this.map.getLonLatFromPixel(a.xy),this.map.getZoom()+1)}},defaultWheelDown:function(a){if(this.map.getZoom()>0){this.map.setCenter(this.map.getLonLatFromPixel(a.xy),this.map.getZoom()-1)}},zoomBoxEnd:function(b){if(this.mouseDragStart!=null){if(Math.abs(this.mouseDragStart.x-b.xy.x)>5||Math.abs(this.mouseDragStart.y-b.xy.y)>5){var h=this.map.getLonLatFromViewPortPx(this.mouseDragStart);var a=this.map.getLonLatFromViewPortPx(b.xy);var g=Math.max(h.lat,a.lat);var c=Math.min(h.lat,a.lat);var f=Math.min(h.lon,a.lon);var d=Math.max(h.lon,a.lon);var e=new OpenLayers.Bounds(f,c,d,g);this.map.zoomToExtent(e)}else{var a=this.map.getLonLatFromViewPortPx(b.xy);this.map.setCenter(new OpenLayers.LonLat((a.lon),(a.lat)),this.map.getZoom()+1)}this.removeZoomBox()}},removeZoomBox:function(){this.map.eventsDiv.removeChild(this.zoomBox);this.zoomBox=null},onWheelEvent:function(c){var b=false;var a=OpenLayers.Event.element(c);while(a!=null){if(this.map&&a==this.map.div){b=true;break}a=a.parentNode}if(b){var d=0;if(!c){c=window.event}if(c.wheelDelta){d=c.wheelDelta/120;if(window.opera&&window.opera.version()<9.2){d=-d}}else{if(c.detail){d=-c.detail/3}}if(d){c.xy=this.mousePosition;if(d<0){this.defaultWheelDown(c)}else{this.defaultWheelUp(c)}}OpenLayers.Event.stop(c)}},CLASS_NAME:"OpenLayers.Control.MouseDefaults"});OpenLayers.Control.PanZoomBar=OpenLayers.Class(OpenLayers.Control.PanZoom,{zoomStopWidth:18,zoomStopHeight:11,slider:null,sliderEvents:null,zoombarDiv:null,divEvents:null,zoomWorldIcon:false,panIcons:true,forceFixedZoomLevel:false,mouseDragStart:null,deltaY:null,zoomStart:null,destroy:function(){this._removeZoomBar();this.map.events.un({changebaselayer:this.redraw,scope:this});OpenLayers.Control.PanZoom.prototype.destroy.apply(this,arguments);delete this.mouseDragStart;delete this.zoomStart},setMap:function(a){OpenLayers.Control.PanZoom.prototype.setMap.apply(this,arguments);this.map.events.register("changebaselayer",this,this.redraw)},redraw:function(){if(this.div!=null){this.removeButtons();this._removeZoomBar()}this.draw()},draw:function(b){OpenLayers.Control.prototype.draw.apply(this,arguments);b=this.position.clone();this.buttons=[];var d=new OpenLayers.Size(18,18);if(this.panIcons){var a=new OpenLayers.Pixel(b.x+d.w/2,b.y);var c=d.w;if(this.zoomWorldIcon){a=new OpenLayers.Pixel(b.x+d.w,b.y)}this._addButton("panup","north-mini.png",a,d);b.y=a.y+d.h;this._addButton("panleft","west-mini.png",b,d);if(this.zoomWorldIcon){this._addButton("zoomworld","zoom-world-mini.png",b.add(d.w,0),d);c*=2}this._addButton("panright","east-mini.png",b.add(c,0),d);this._addButton("pandown","south-mini.png",a.add(0,d.h*2),d);this._addButton("zoomin","zoom-plus-mini.png",a.add(0,d.h*3+5),d);a=this._addZoomBar(a.add(0,d.h*4+5));this._addButton("zoomout","zoom-minus-mini.png",a,d)}else{this._addButton("zoomin","zoom-plus-mini.png",b,d);a=this._addZoomBar(b.add(0,d.h));this._addButton("zoomout","zoom-minus-mini.png",a,d);if(this.zoomWorldIcon){a=a.add(0,d.h+3);this._addButton("zoomworld","zoom-world-mini.png",a,d)}}return this.div},_addZoomBar:function(a){var e=OpenLayers.Util.getImagesLocation();var g=this.id+"_"+this.map.id;var b=this.map.getNumZoomLevels()-1-this.map.getZoom();var c=OpenLayers.Util.createAlphaImageDiv(g,a.add(-1,b*this.zoomStopHeight),new OpenLayers.Size(20,9),e+"slider.png","absolute");c.style.cursor="move";this.slider=c;this.sliderEvents=new OpenLayers.Events(this,c,null,true,{includeXY:true});this.sliderEvents.on({touchstart:this.zoomBarDown,touchmove:this.zoomBarDrag,touchend:this.zoomBarUp,mousedown:this.zoomBarDown,mousemove:this.zoomBarDrag,mouseup:this.zoomBarUp,dblclick:this.doubleClick,click:this.doubleClick});var d=new OpenLayers.Size();d.h=this.zoomStopHeight*this.map.getNumZoomLevels();d.w=this.zoomStopWidth;var f=null;if(OpenLayers.Util.alphaHack()){var g=this.id+"_"+this.map.id;f=OpenLayers.Util.createAlphaImageDiv(g,a,new OpenLayers.Size(d.w,this.zoomStopHeight),e+"zoombar.png","absolute",null,"crop");f.style.height=d.h+"px"}else{f=OpenLayers.Util.createDiv("OpenLayers_Control_PanZoomBar_Zoombar"+this.map.id,a,d,e+"zoombar.png")}f.style.cursor="pointer";this.zoombarDiv=f;this.divEvents=new OpenLayers.Events(this,f,null,true,{includeXY:true});this.divEvents.on({touchmove:this.passEventToSlider,mousedown:this.divClick,mousemove:this.passEventToSlider,dblclick:this.doubleClick,click:this.doubleClick});this.div.appendChild(f);this.startTop=parseInt(f.style.top);this.div.appendChild(c);this.map.events.register("zoomend",this,this.moveZoomBar);a=a.add(0,this.zoomStopHeight*this.map.getNumZoomLevels());return a},_removeZoomBar:function(){this.sliderEvents.un({touchmove:this.zoomBarDrag,mousedown:this.zoomBarDown,mousemove:this.zoomBarDrag,mouseup:this.zoomBarUp,dblclick:this.doubleClick,click:this.doubleClick});this.sliderEvents.destroy();this.divEvents.un({touchmove:this.passEventToSlider,mousedown:this.divClick,mousemove:this.passEventToSlider,dblclick:this.doubleClick,click:this.doubleClick});this.divEvents.destroy();this.div.removeChild(this.zoombarDiv);this.zoombarDiv=null;this.div.removeChild(this.slider);this.slider=null;this.map.events.unregister("zoomend",this,this.moveZoomBar)},passEventToSlider:function(a){this.sliderEvents.handleBrowserEvent(a)},divClick:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}var c=a.xy.y/this.zoomStopHeight;if(this.forceFixedZoomLevel||!this.map.fractionalZoom){c=Math.floor(c)}var b=(this.map.getNumZoomLevels()-1)-c;b=Math.min(Math.max(b,0),this.map.getNumZoomLevels()-1);this.map.zoomTo(b);OpenLayers.Event.stop(a)},zoomBarDown:function(a){if(!OpenLayers.Event.isLeftClick(a)&&!OpenLayers.Event.isSingleTouch(a)){return}this.map.events.on({touchmove:this.passEventToSlider,mousemove:this.passEventToSlider,mouseup:this.passEventToSlider,scope:this});this.mouseDragStart=a.xy.clone();this.zoomStart=a.xy.clone();this.div.style.cursor="move";this.zoombarDiv.offsets=null;OpenLayers.Event.stop(a)},zoomBarDrag:function(b){if(this.mouseDragStart!=null){var a=this.mouseDragStart.y-b.xy.y;var d=OpenLayers.Util.pagePosition(this.zoombarDiv);if((b.clientY-d[1])>0&&(b.clientY-d[1])<parseInt(this.zoombarDiv.style.height)-2){var c=parseInt(this.slider.style.top)-a;this.slider.style.top=c+"px";this.mouseDragStart=b.xy.clone()}this.deltaY=this.zoomStart.y-b.xy.y;OpenLayers.Event.stop(b)}},zoomBarUp:function(a){if(!OpenLayers.Event.isLeftClick(a)&&a.type!=="touchend"){return}if(this.mouseDragStart){this.div.style.cursor="";this.map.events.un({touchmove:this.passEventToSlider,mouseup:this.passEventToSlider,mousemove:this.passEventToSlider,scope:this});var b=this.map.zoom;if(!this.forceFixedZoomLevel&&this.map.fractionalZoom){b+=this.deltaY/this.zoomStopHeight;b=Math.min(Math.max(b,0),this.map.getNumZoomLevels()-1)}else{b+=this.deltaY/this.zoomStopHeight;b=Math.max(Math.round(b),0)}this.map.zoomTo(b);this.mouseDragStart=null;this.zoomStart=null;this.deltaY=0;OpenLayers.Event.stop(a)}},moveZoomBar:function(){var a=((this.map.getNumZoomLevels()-1)-this.map.getZoom())*this.zoomStopHeight+this.startTop+1;this.slider.style.top=a+"px"},CLASS_NAME:"OpenLayers.Control.PanZoomBar"});OpenLayers.Format.CSWGetRecords.v2_0_2=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{csw:"http://www.opengis.net/cat/csw/2.0.2",dc:"http://purl.org/dc/elements/1.1/",dct:"http://purl.org/dc/terms/",geonet:"http://www.fao.org/geonetwork",ogc:"http://www.opengis.net/ogc",ows:"http://www.opengis.net/ows",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},defaultPrefix:"csw",version:"2.0.2",schemaLocation:"http://www.opengis.net/cat/csw/2.0.2 http://schemas.opengis.net/csw/2.0.2/CSW-discovery.xsd",requestId:null,resultType:null,outputFormat:null,outputSchema:null,startPosition:null,maxRecords:null,DistributedSearch:null,ResponseHandler:null,Query:null,regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(a){if(typeof a=="string"){a=OpenLayers.Format.XML.prototype.read.apply(this,[a])}if(a&&a.nodeType==9){a=a.documentElement}var b={};this.readNode(a,b);return b},readers:{csw:{GetRecordsResponse:function(b,c){c.records=[];this.readChildNodes(b,c);var a=this.getAttributeNS(b,"","version");if(a!=""){c.version=a}},RequestId:function(a,b){b.RequestId=this.getChildValue(a)},SearchStatus:function(a,c){c.SearchStatus={};var b=this.getAttributeNS(a,"","timestamp");if(b!=""){c.SearchStatus.timestamp=b}},SearchResults:function(d,e){this.readChildNodes(d,e);var b=d.attributes;var f={};for(var c=0,a=b.length;c<a;++c){if((b[c].name=="numberOfRecordsMatched")||(b[c].name=="numberOfRecordsReturned")||(b[c].name=="nextRecord")){f[b[c].name]=parseInt(b[c].nodeValue)}else{f[b[c].name]=b[c].nodeValue}}e.SearchResults=f},SummaryRecord:function(b,c){var a={type:"SummaryRecord"};this.readChildNodes(b,a);c.records.push(a)},BriefRecord:function(b,c){var a={type:"BriefRecord"};this.readChildNodes(b,a);c.records.push(a)},DCMIRecord:function(b,c){var a={type:"DCMIRecord"};this.readChildNodes(b,a);c.records.push(a)},Record:function(b,c){var a={type:"Record"};this.readChildNodes(b,a);c.records.push(a)},"*":function(b,c){var a=b.localName||b.nodeName.split(":").pop();c[a]=this.getChildValue(b)}},geonet:{info:function(b,c){var a={};this.readChildNodes(b,a);c.gninfo=a}},dc:{"*":function(f,g){var d=f.localName||f.nodeName.split(":").pop();if(!(OpenLayers.Util.isArray(g[d]))){g[d]=new Array()}var c={};var b=f.attributes;for(var e=0,a=b.length;e<a;++e){c[b[e].name]=b[e].nodeValue}c.value=this.getChildValue(f);g[d].push(c)}},dct:{"*":function(b,c){var a=b.localName||b.nodeName.split(":").pop();if(!(OpenLayers.Util.isArray(c[a]))){c[a]=new Array()}c[a].push(this.getChildValue(b))}},ows:OpenLayers.Util.applyDefaults({BoundingBox:function(a,b){if(b.bounds){b.BoundingBox=[{crs:b.projection,value:[b.bounds.left,b.bounds.bottom,b.bounds.right,b.bounds.top]}];delete b.projection;delete b.bounds}OpenLayers.Format.OWSCommon.v1_0_0.prototype.readers.ows["BoundingBox"].apply(this,arguments)}},OpenLayers.Format.OWSCommon.v1_0_0.prototype.readers.ows)},write:function(a){var b=this.writeNode("csw:GetRecords",a);return OpenLayers.Format.XML.prototype.write.apply(this,[b])},writers:{csw:{GetRecords:function(b){if(!b){b={}}var e=this.createElementNSPlus("csw:GetRecords",{attributes:{service:"CSW",version:this.version,requestId:b.requestId||this.requestId,resultType:b.resultType||this.resultType,outputFormat:b.outputFormat||this.outputFormat,outputSchema:b.outputSchema||this.outputSchema,startPosition:b.startPosition||this.startPosition,maxRecords:b.maxRecords||this.maxRecords}});if(b.DistributedSearch||this.DistributedSearch){this.writeNode("csw:DistributedSearch",b.DistributedSearch||this.DistributedSearch,e)}var d=b.ResponseHandler||this.ResponseHandler;if(OpenLayers.Util.isArray(d)&&d.length>0){for(var c=0,a=d.length;c<a;c++){this.writeNode("csw:ResponseHandler",d[c],e)}}this.writeNode("Query",b.Query||this.Query,e);return e},DistributedSearch:function(a){var b=this.createElementNSPlus("csw:DistributedSearch",{attributes:{hopCount:a.hopCount}});return b},ResponseHandler:function(a){var b=this.createElementNSPlus("csw:ResponseHandler",{value:a.value});return b},Query:function(b){if(!b){b={}}var e=this.createElementNSPlus("csw:Query",{attributes:{typeNames:b.typeNames||"csw:Record"}});var d=b.ElementName;if(OpenLayers.Util.isArray(d)&&d.length>0){for(var c=0,a=d.length;c<a;c++){this.writeNode("csw:ElementName",d[c],e)}}else{this.writeNode("csw:ElementSetName",b.ElementSetName||{value:"summary"},e)}if(b.Constraint){this.writeNode("csw:Constraint",b.Constraint,e)}if(b.SortBy){this.writeNode("ogc:SortBy",b.SortBy,e)}return e},ElementName:function(a){var b=this.createElementNSPlus("csw:ElementName",{value:a.value});return b},ElementSetName:function(a){var b=this.createElementNSPlus("csw:ElementSetName",{attributes:{typeNames:a.typeNames},value:a.value});return b},Constraint:function(a){var b=this.createElementNSPlus("csw:Constraint",{attributes:{version:a.version}});if(a.Filter){var c=new OpenLayers.Format.Filter({version:a.version});b.appendChild(c.write(a.Filter))}else{if(a.CqlText){var d=this.createElementNSPlus("CqlText",{value:a.CqlText.value});b.appendChild(d)}}return b}},ogc:OpenLayers.Format.Filter.v1_1_0.prototype.writers.ogc},CLASS_NAME:"OpenLayers.Format.CSWGetRecords.v2_0_2"});OpenLayers.Marker.Box=OpenLayers.Class(OpenLayers.Marker,{bounds:null,div:null,initialize:function(b,c,a){this.bounds=b;this.div=OpenLayers.Util.createDiv();this.div.style.overflow="hidden";this.events=new OpenLayers.Events(this,this.div,null);this.setBorder(c,a)},destroy:function(){this.bounds=null;this.div=null;OpenLayers.Marker.prototype.destroy.apply(this,arguments)},setBorder:function(a,b){if(!a){a="red"}if(!b){b=2}this.div.style.border=b+"px solid "+a},draw:function(a,b){OpenLayers.Util.modifyDOMElement(this.div,null,a,b);return this.div},onScreen:function(){var b=false;if(this.map){var a=this.map.getExtent();b=a.containsBounds(this.bounds,true,true)}return b},display:function(a){this.div.style.display=(a)?"":"none"},CLASS_NAME:"OpenLayers.Marker.Box"});OpenLayers.Format.Text=OpenLayers.Class(OpenLayers.Format,{defaultStyle:null,extractStyles:true,initialize:function(a){a=a||{};if(a.extractStyles!==false){a.defaultStyle={externalGraphic:OpenLayers.Util.getImagesLocation()+"marker.png",graphicWidth:21,graphicHeight:25,graphicXOffset:-10.5,graphicYOffset:-12.5}}OpenLayers.Format.prototype.initialize.apply(this,[a])},read:function(j){var a=j.split("\n");var b;var g=[];for(var t=0;t<(a.length-1);t++){var s=a[t].replace(/^\s*/,"").replace(/\s*$/,"");if(s.charAt(0)!="#"){if(!b){b=s.split("\t")}else{var l=s.split("\t");var d=new OpenLayers.Geometry.Point(0,0);var h={};var p=this.defaultStyle?OpenLayers.Util.applyDefaults({},this.defaultStyle):null;var q,r,c,n;var k=false;for(var i=0;i<l.length;i++){if(l[i]){if(b[i]=="point"){var o=l[i].split(",");d.y=parseFloat(o[0]);d.x=parseFloat(o[1]);k=true}else{if(b[i]=="lat"){d.y=parseFloat(l[i]);k=true}else{if(b[i]=="lon"){d.x=parseFloat(l[i]);k=true}else{if(b[i]=="title"){h.title=l[i]}else{if(b[i]=="image"||b[i]=="icon"&&p){p.externalGraphic=l[i]}else{if(b[i]=="iconSize"&&p){var m=l[i].split(",");p.graphicWidth=parseFloat(m[0]);p.graphicHeight=parseFloat(m[1])}else{if(b[i]=="iconOffset"&&p){var f=l[i].split(",");p.graphicXOffset=parseFloat(f[0]);p.graphicYOffset=parseFloat(f[1])}else{if(b[i]=="description"){h.description=l[i]}else{if(b[i]=="overflow"){h.overflow=l[i]}else{h[b[i]]=l[i]}}}}}}}}}}}if(k){if(this.internalProjection&&this.externalProjection){d.transform(this.externalProjection,this.internalProjection)}var e=new OpenLayers.Feature.Vector(d,h,p);g.push(e)}}}}return g},CLASS_NAME:"OpenLayers.Format.Text"});OpenLayers.Layer.Text=OpenLayers.Class(OpenLayers.Layer.Markers,{location:null,features:null,formatOptions:null,selectedFeature:null,initialize:function(b,a){OpenLayers.Layer.Markers.prototype.initialize.apply(this,arguments);this.features=new Array()},destroy:function(){OpenLayers.Layer.Markers.prototype.destroy.apply(this,arguments);this.clearFeatures();this.features=null},loadText:function(){if(!this.loaded){if(this.location!=null){var a=function(b){this.events.triggerEvent("loadend")};this.events.triggerEvent("loadstart");OpenLayers.Request.GET({url:this.location,success:this.parseData,failure:a,scope:this});this.loaded=true}}},moveTo:function(c,a,b){OpenLayers.Layer.Markers.prototype.moveTo.apply(this,arguments);if(this.visibility&&!this.loaded){this.loadText()}},parseData:function(k){var m=k.responseText;var o={};OpenLayers.Util.extend(o,this.formatOptions);if(this.map&&!this.projection.equals(this.map.getProjectionObject())){o.externalProjection=this.projection;o.internalProjection=this.map.getProjectionObject()}var b=new OpenLayers.Format.Text(o);var c=b.read(m);for(var g=0,h=c.length;g<h;g++){var f={};var n=c[g];var l;var j,d;l=new OpenLayers.LonLat(n.geometry.x,n.geometry.y);if(n.style.graphicWidth&&n.style.graphicHeight){j=new OpenLayers.Size(n.style.graphicWidth,n.style.graphicHeight)}if(n.style.graphicXOffset!==undefined&&n.style.graphicYOffset!==undefined){d=new OpenLayers.Pixel(n.style.graphicXOffset,n.style.graphicYOffset)}if(n.style.externalGraphic!=null){f.icon=new OpenLayers.Icon(n.style.externalGraphic,j,d)}else{f.icon=OpenLayers.Marker.defaultIcon();if(j!=null){f.icon.setSize(j)}}if((n.attributes.title!=null)&&(n.attributes.description!=null)){f.popupContentHTML="<h2>"+n.attributes.title+"</h2><p>"+n.attributes.description+"</p>"}f.overflow=n.attributes.overflow||"auto";var a=new OpenLayers.Feature(this,l,f);this.features.push(a);var e=a.createMarker();if((n.attributes.title!=null)&&(n.attributes.description!=null)){e.events.register("click",a,this.markerClick)}this.addMarker(e)}this.events.triggerEvent("loadend")},markerClick:function(b){var d=(this==this.layer.selectedFeature);this.layer.selectedFeature=(!d)?this:null;for(var c=0,a=this.layer.map.popups.length;c<a;c++){this.layer.map.removePopup(this.layer.map.popups[c])}if(!d){this.layer.map.addPopup(this.createPopup())}OpenLayers.Event.stop(b)},clearFeatures:function(){if(this.features!=null){while(this.features.length>0){var a=this.features[0];OpenLayers.Util.removeItem(this.features,a);a.destroy()}}},CLASS_NAME:"OpenLayers.Layer.Text"});OpenLayers.Control.Scale=OpenLayers.Class(OpenLayers.Control,{element:null,geodesic:false,initialize:function(b,a){OpenLayers.Control.prototype.initialize.apply(this,[a]);this.element=OpenLayers.Util.getElement(b)},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);if(!this.element){this.element=document.createElement("div");this.div.appendChild(this.element)}this.map.events.register("moveend",this,this.updateScale);this.updateScale();return this.div},updateScale:function(){var c;if(this.geodesic===true){var a=this.map.getUnits();if(!a){return}var b=OpenLayers.INCHES_PER_UNIT;c=(this.map.getGeodesicPixelSize().w||0.000001)*b.km*OpenLayers.DOTS_PER_INCH}else{c=this.map.getScale()}if(!c){return}if(c>=9500&&c<=950000){c=Math.round(c/1000)+"K"}else{if(c>=950000){c=Math.round(c/1000000)+"M"}else{c=Math.round(c)}}this.element.innerHTML=OpenLayers.i18n("Scale = 1 : ${scaleDenom}",{scaleDenom:c})},CLASS_NAME:"OpenLayers.Control.Scale"});OpenLayers.Protocol.SOS=function(b){b=OpenLayers.Util.applyDefaults(b,OpenLayers.Protocol.SOS.DEFAULTS);var a=OpenLayers.Protocol.SOS["v"+b.version.replace(/\./g,"_")];if(!a){throw"Unsupported SOS version: "+b.version}return new a(b)};OpenLayers.Protocol.SOS.DEFAULTS={version:"1.0.0"};OpenLayers.Protocol.SOS.v1_0_0=OpenLayers.Class(OpenLayers.Protocol,{fois:null,formatOptions:null,initialize:function(a){OpenLayers.Protocol.prototype.initialize.apply(this,[a]);if(!a.format){this.format=new OpenLayers.Format.SOSGetFeatureOfInterest(this.formatOptions)}},destroy:function(){if(this.options&&!this.options.format){this.format.destroy()}this.format=null;OpenLayers.Protocol.prototype.destroy.apply(this)},read:function(b){b=OpenLayers.Util.extend({},b);OpenLayers.Util.applyDefaults(b,this.options||{});var a=new OpenLayers.Protocol.Response({requestType:"read"});var d=this.format;var c=OpenLayers.Format.XML.prototype.write.apply(d,[d.writeNode("sos:GetFeatureOfInterest",{fois:this.fois})]);a.priv=OpenLayers.Request.POST({url:b.url,callback:this.createCallback(this.handleRead,a,b),data:c});return a},handleRead:function(a,b){if(b.callback){var c=a.priv;if(c.status>=200&&c.status<300){a.features=this.parseFeatures(c);a.code=OpenLayers.Protocol.Response.SUCCESS}else{a.code=OpenLayers.Protocol.Response.FAILURE}b.callback.call(b.scope,a)}},parseFeatures:function(a){var b=a.responseXML;if(!b||!b.documentElement){b=a.responseText}if(!b||b.length<=0){return null}return this.format.read(b)},CLASS_NAME:"OpenLayers.Protocol.SOS.v1_0_0"});OpenLayers.Layer.PointGrid=OpenLayers.Class(OpenLayers.Layer.Vector,{dx:null,dy:null,ratio:1.5,maxFeatures:250,rotation:0,origin:null,gridBounds:null,initialize:function(a){a=a||{};OpenLayers.Layer.Vector.prototype.initialize.apply(this,[a.name,a])},setMap:function(a){OpenLayers.Layer.Vector.prototype.setMap.apply(this,arguments);a.events.register("moveend",this,this.onMoveEnd)},removeMap:function(a){a.events.unregister("moveend",this,this.onMoveEnd);OpenLayers.Layer.Vector.prototype.removeMap.apply(this,arguments)},setRatio:function(a){this.ratio=a;this.updateGrid(true)},setMaxFeatures:function(a){this.maxFeatures=a;this.updateGrid(true)},setSpacing:function(b,a){this.dx=b;this.dy=a||b;this.updateGrid(true)},setOrigin:function(a){this.origin=a;this.updateGrid(true)},getOrigin:function(){if(!this.origin){this.origin=this.map.getExtent().getCenterLonLat()}return this.origin},setRotation:function(a){this.rotation=a;this.updateGrid(true)},onMoveEnd:function(){this.updateGrid()},getViewBounds:function(){var d=this.map.getExtent();if(this.rotation){var a=this.getOrigin();var b=new OpenLayers.Geometry.Point(a.lon,a.lat);var c=d.toGeometry();c.rotate(-this.rotation,b);d=c.getBounds()}return d},updateGrid:function(c){if(c||this.invalidBounds()){var g=this.getViewBounds();var z=this.getOrigin();var r=new OpenLayers.Geometry.Point(z.lon,z.lat);var d=g.getWidth();var q=g.getHeight();var a=d/q;var o=Math.sqrt(this.dx*this.dy*this.maxFeatures/a);var u=o*a;var v=Math.min(d*this.ratio,u);var n=Math.min(q*this.ratio,o);var w=g.getCenterLonLat();this.gridBounds=new OpenLayers.Bounds(w.lon-(v/2),w.lat-(n/2),w.lon+(v/2),w.lat+(n/2));var l=Math.floor(n/this.dy);var m=Math.floor(v/this.dx);var b=z.lon+(this.dx*Math.ceil((this.gridBounds.left-z.lon)/this.dx));var e=z.lat+(this.dy*Math.ceil((this.gridBounds.bottom-z.lat)/this.dy));var f=new Array(l*m);var k,h,p;for(var t=0;t<m;++t){k=b+(t*this.dx);for(var s=0;s<l;++s){h=e+(s*this.dy);p=new OpenLayers.Geometry.Point(k,h);if(this.rotation){p.rotate(this.rotation,r)}f[(t*l)+s]=new OpenLayers.Feature.Vector(p)}}this.destroyFeatures(this.features,{silent:true});this.addFeatures(f,{silent:true})}},invalidBounds:function(){return !this.gridBounds||!this.gridBounds.containsBounds(this.getViewBounds())},CLASS_NAME:"OpenLayers.Layer.PointGrid"});OpenLayers.Handler.RegularPolygon=OpenLayers.Class(OpenLayers.Handler.Drag,{sides:4,radius:null,snapAngle:null,snapToggle:"shiftKey",layerOptions:null,persist:false,irregular:false,angle:null,fixedRadius:false,feature:null,layer:null,origin:null,initialize:function(c,b,a){if(!(a&&a.layerOptions&&a.layerOptions.styleMap)){this.style=OpenLayers.Util.extend(OpenLayers.Feature.Vector.style["default"],{})}OpenLayers.Handler.Drag.prototype.initialize.apply(this,[c,b,a]);this.options=(a)?a:{}},setOptions:function(a){OpenLayers.Util.extend(this.options,a);OpenLayers.Util.extend(this,a)},activate:function(){var a=false;if(OpenLayers.Handler.Drag.prototype.activate.apply(this,arguments)){var b=OpenLayers.Util.extend({displayInLayerSwitcher:false,calculateInRange:OpenLayers.Function.True},this.layerOptions);this.layer=new OpenLayers.Layer.Vector(this.CLASS_NAME,b);this.map.addLayer(this.layer);a=true}return a},deactivate:function(){var a=false;if(OpenLayers.Handler.Drag.prototype.deactivate.apply(this,arguments)){if(this.dragging){this.cancel()}if(this.layer.map!=null){this.layer.destroy(false);if(this.feature){this.feature.destroy()}}this.layer=null;this.feature=null;a=true}return a},down:function(a){this.fixedRadius=!!(this.radius);var b=this.map.getLonLatFromPixel(a.xy);this.origin=new OpenLayers.Geometry.Point(b.lon,b.lat);if(!this.fixedRadius||this.irregular){this.radius=this.map.getResolution()}if(this.persist){this.clear()}this.feature=new OpenLayers.Feature.Vector();this.createGeometry();this.callback("create",[this.origin,this.feature]);this.layer.addFeatures([this.feature],{silent:true});this.layer.drawFeature(this.feature,this.style)},move:function(c){var f=this.map.getLonLatFromPixel(c.xy);var a=new OpenLayers.Geometry.Point(f.lon,f.lat);if(this.irregular){var g=Math.sqrt(2)*Math.abs(a.y-this.origin.y)/2;this.radius=Math.max(this.map.getResolution()/2,g)}else{if(this.fixedRadius){this.origin=a}else{this.calculateAngle(a,c);this.radius=Math.max(this.map.getResolution()/2,a.distanceTo(this.origin))}}this.modifyGeometry();if(this.irregular){var d=a.x-this.origin.x;var b=a.y-this.origin.y;var e;if(b==0){e=d/(this.radius*Math.sqrt(2))}else{e=d/b}this.feature.geometry.resize(1,this.origin,e);this.feature.geometry.move(d/2,b/2)}this.layer.drawFeature(this.feature,this.style)},up:function(a){this.finalize();if(this.start==this.last){this.callback("done",[a.xy])}},out:function(a){this.finalize()},createGeometry:function(){this.angle=Math.PI*((1/this.sides)-(1/2));if(this.snapAngle){this.angle+=this.snapAngle*(Math.PI/180)}this.feature.geometry=OpenLayers.Geometry.Polygon.createRegularPolygon(this.origin,this.radius,this.sides,this.snapAngle)},modifyGeometry:function(){var d,a;var b=this.feature.geometry.components[0];if(b.components.length!=(this.sides+1)){this.createGeometry();b=this.feature.geometry.components[0]}for(var c=0;c<this.sides;++c){a=b.components[c];d=this.angle+(c*2*Math.PI/this.sides);a.x=this.origin.x+(this.radius*Math.cos(d));a.y=this.origin.y+(this.radius*Math.sin(d));a.clearBounds()}},calculateAngle:function(a,b){var d=Math.atan2(a.y-this.origin.y,a.x-this.origin.x);if(this.snapAngle&&(this.snapToggle&&!b[this.snapToggle])){var c=(Math.PI/180)*this.snapAngle;this.angle=Math.round(d/c)*c}else{this.angle=d}},cancel:function(){this.callback("cancel",null);this.finalize()},finalize:function(){this.origin=null;this.radius=this.options.radius},clear:function(){if(this.layer){this.layer.renderer.clear();this.layer.destroyFeatures()}},callback:function(b,a){if(this.callbacks[b]){this.callbacks[b].apply(this.control,[this.feature.geometry.clone()])}if(!this.persist&&(b=="done"||b=="cancel")){this.clear()}},CLASS_NAME:"OpenLayers.Handler.RegularPolygon"});OpenLayers.Layer.MapGuide=OpenLayers.Class(OpenLayers.Layer.Grid,{isBaseLayer:true,useHttpTile:false,singleTile:false,useOverlay:false,useAsyncOverlay:true,TILE_PARAMS:{operation:"GETTILEIMAGE",version:"1.2.0"},SINGLE_TILE_PARAMS:{operation:"GETMAPIMAGE",format:"PNG",locale:"en",clip:"1",version:"1.0.0"},OVERLAY_PARAMS:{operation:"GETDYNAMICMAPOVERLAYIMAGE",format:"PNG",locale:"en",clip:"1",version:"2.0.0"},FOLDER_PARAMS:{tileColumnsPerFolder:30,tileRowsPerFolder:30,format:"png",querystring:null},defaultSize:new OpenLayers.Size(300,300),tileOriginCorner:"tl",initialize:function(c,b,d,a){OpenLayers.Layer.Grid.prototype.initialize.apply(this,arguments);if(a==null||a.isBaseLayer==null){this.isBaseLayer=((this.transparent!="true")&&(this.transparent!=true))}if(a&&a.useOverlay!=null){this.useOverlay=a.useOverlay}if(this.singleTile){if(this.useOverlay){OpenLayers.Util.applyDefaults(this.params,this.OVERLAY_PARAMS);if(!this.useAsyncOverlay){this.params.version="1.0.0"}}else{OpenLayers.Util.applyDefaults(this.params,this.SINGLE_TILE_PARAMS)}}else{if(this.useHttpTile){OpenLayers.Util.applyDefaults(this.params,this.FOLDER_PARAMS)}else{OpenLayers.Util.applyDefaults(this.params,this.TILE_PARAMS)}this.setTileSize(this.defaultSize)}},clone:function(a){if(a==null){a=new OpenLayers.Layer.MapGuide(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(a){var d;var b=a.getCenterLonLat();var h=this.map.getSize();if(this.singleTile){var e={setdisplaydpi:OpenLayers.DOTS_PER_INCH,setdisplayheight:h.h*this.ratio,setdisplaywidth:h.w*this.ratio,setviewcenterx:b.lon,setviewcentery:b.lat,setviewscale:this.map.getScale()};if(this.useOverlay&&!this.useAsyncOverlay){var i={};i=OpenLayers.Util.extend(i,e);i.operation="GETVISIBLEMAPEXTENT";i.version="1.0.0";i.session=this.params.session;i.mapName=this.params.mapName;i.format="text/xml";d=this.getFullRequestString(i);OpenLayers.Request.GET({url:d,async:false})}d=this.getFullRequestString(e)}else{var g=this.map.getResolution();var f=Math.floor((a.left-this.maxExtent.left)/g);f=Math.round(f/this.tileSize.w);var c=Math.floor((this.maxExtent.top-a.top)/g);c=Math.round(c/this.tileSize.h);if(this.useHttpTile){d=this.getImageFilePath({tilecol:f,tilerow:c,scaleindex:this.resolutions.length-this.map.zoom-1})}else{d=this.getFullRequestString({tilecol:f,tilerow:c,scaleindex:this.resolutions.length-this.map.zoom-1})}}return d},getFullRequestString:function(f,e){var b=(e==null)?this.url:e;if(typeof b=="object"){b=b[Math.floor(Math.random()*b.length)]}var i=b;var g=OpenLayers.Util.extend({},this.params);g=OpenLayers.Util.extend(g,f);var d=OpenLayers.Util.upperCaseObject(OpenLayers.Util.getParameters(b));for(var h in g){if(h.toUpperCase() in d){delete g[h]}}var a=OpenLayers.Util.getParameterString(g);a=a.replace(/,/g,"+");if(a!=""){var c=b.charAt(b.length-1);if((c=="&")||(c=="?")){i+=a}else{if(b.indexOf("?")==-1){i+="?"+a}else{i+="&"+a}}}return i},getImageFilePath:function(g,e){var c=(e==null)?this.url:e;if(typeof c=="object"){c=c[Math.floor(Math.random()*c.length)]}var b=c;var d="";var f="";if(g.tilerow<0){d="-"}if(g.tilerow==0){d+="0"}else{d+=Math.floor(Math.abs(g.tilerow/this.params.tileRowsPerFolder))*this.params.tileRowsPerFolder}if(g.tilecol<0){f="-"}if(g.tilecol==0){f+="0"}else{f+=Math.floor(Math.abs(g.tilecol/this.params.tileColumnsPerFolder))*this.params.tileColumnsPerFolder}var a="/S"+Math.floor(g.scaleindex)+"/"+this.params.basemaplayergroupname+"/R"+d+"/C"+f+"/"+(g.tilerow%this.params.tileRowsPerFolder)+"_"+(g.tilecol%this.params.tileColumnsPerFolder)+"."+this.params.format;if(this.params.querystring){a+="?"+this.params.querystring}b+=a;return b},calculateGridLayout:function(a,n,e){var k=e*this.tileSize.w;var c=e*this.tileSize.h;var i=a.left-n.lon;var l=Math.floor(i/k)-this.buffer;var j=i/k-l;var f=-j*this.tileSize.w;var m=n.lon+l*k;var b=n.lat-a.top+c;var h=Math.floor(b/c)-this.buffer;var o=h-b/c;var d=o*this.tileSize.h;var g=n.lat-c*h;return{tilelon:k,tilelat:c,tileoffsetlon:m,tileoffsetlat:g,tileoffsetx:f,tileoffsety:d}},CLASS_NAME:"OpenLayers.Layer.MapGuide"});OpenLayers.Control.Measure=OpenLayers.Class(OpenLayers.Control,{EVENT_TYPES:["measure","measurepartial"],handlerOptions:null,callbacks:null,displaySystem:"metric",geodesic:false,displaySystemUnits:{geographic:["dd"],english:["mi","ft","in"],metric:["km","m"]},partialDelay:300,delayedTrigger:null,persist:false,immediate:false,initialize:function(b,a){this.EVENT_TYPES=OpenLayers.Control.Measure.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);OpenLayers.Control.prototype.initialize.apply(this,[a]);var c={done:this.measureComplete,point:this.measurePartial};if(this.immediate){c.modify=this.measureImmediate}this.callbacks=OpenLayers.Util.extend(c,this.callbacks);this.handlerOptions=OpenLayers.Util.extend({persist:this.persist},this.handlerOptions);this.handler=new b(this,this.callbacks,this.handlerOptions)},deactivate:function(){this.cancelDelay();return OpenLayers.Control.prototype.deactivate.apply(this,arguments)},cancel:function(){this.cancelDelay();this.handler.cancel()},setImmediate:function(a){this.immediate=a;if(this.immediate){this.callbacks.modify=this.measureImmediate}else{delete this.callbacks.modify}},updateHandler:function(b,a){var c=this.active;if(c){this.deactivate()}this.handler=new b(this,this.callbacks,a);if(c){this.activate()}},measureComplete:function(a){this.cancelDelay();this.measure(a,"measure")},measurePartial:function(a,b){this.cancelDelay();b=b.clone();if(this.handler.freehandMode(this.handler.evt)){this.measure(b,"measurepartial")}else{this.delayedTrigger=window.setTimeout(OpenLayers.Function.bind(function(){this.delayedTrigger=null;this.measure(b,"measurepartial")},this),this.partialDelay)}},measureImmediate:function(a,c,b){if(b&&this.delayedTrigger===null&&!this.handler.freehandMode(this.handler.evt)){this.measure(c.geometry,"measurepartial")}},cancelDelay:function(){if(this.delayedTrigger!==null){window.clearTimeout(this.delayedTrigger);this.delayedTrigger=null}},measure:function(d,b){var c,a;if(d.CLASS_NAME.indexOf("LineString")>-1){c=this.getBestLength(d);a=1}else{c=this.getBestArea(d);a=2}this.events.triggerEvent(b,{measure:c[0],units:c[1],order:a,geometry:d})},getBestArea:function(f){var b=this.displaySystemUnits[this.displaySystem];var e,d;for(var c=0,a=b.length;c<a;++c){e=b[c];d=this.getArea(f,e);if(d>1){break}}return[d,e]},getArea:function(f,a){var b,c;if(this.geodesic){b=f.getGeodesicArea(this.map.getProjectionObject());c="m"}else{b=f.getArea();c=this.map.getUnits()}var e=OpenLayers.INCHES_PER_UNIT[a];if(e){var d=OpenLayers.INCHES_PER_UNIT[c];b*=Math.pow((d/e),2)}return b},getBestLength:function(f){var b=this.displaySystemUnits[this.displaySystem];var e,d;for(var c=0,a=b.length;c<a;++c){e=b[c];d=this.getLength(f,e);if(d>1){break}}return[d,e]},getLength:function(f,a){var b,c;if(this.geodesic){b=f.getGeodesicLength(this.map.getProjectionObject());c="m"}else{b=f.getLength();c=this.map.getUnits()}var e=OpenLayers.INCHES_PER_UNIT[a];if(e){var d=OpenLayers.INCHES_PER_UNIT[c];b*=(d/e)}return b},CLASS_NAME:"OpenLayers.Control.Measure"});OpenLayers.Format.WMC.v1_0_0=OpenLayers.Class(OpenLayers.Format.WMC.v1,{VERSION:"1.0.0",schemaLocation:"http://www.opengis.net/context http://schemas.opengis.net/context/1.0.0/context.xsd",initialize:function(a){OpenLayers.Format.WMC.v1.prototype.initialize.apply(this,[a])},read_wmc_SRS:function(f,e){var d=this.getChildValue(e);if(typeof f.projections!="object"){f.projections={}}var b=d.split(/ +/);for(var c=0,a=b.length;c<a;c++){f.projections[b[c]]=true}},write_wmc_Layer:function(b){var c=OpenLayers.Format.WMC.v1.prototype.write_wmc_Layer.apply(this,[b]);if(b.srs){var d=[];for(var a in b.srs){d.push(a)}c.appendChild(this.createElementDefaultNS("SRS",d.join(" ")))}c.appendChild(this.write_wmc_FormatList(b));c.appendChild(this.write_wmc_StyleList(b));if(b.dimensions){c.appendChild(this.write_wmc_DimensionList(b))}c.appendChild(this.write_wmc_LayerExtension(b))},CLASS_NAME:"OpenLayers.Format.WMC.v1_0_0"});OpenLayers.Format.WMTSCapabilities.v1_0_0=OpenLayers.Class(OpenLayers.Format.OWSCommon.v1_1_0,{version:"1.0.0",namespaces:{ows:"http://www.opengis.net/ows/1.1",wmts:"http://www.opengis.net/wmts/1.0",xlink:"http://www.w3.org/1999/xlink"},yx:null,defaultPrefix:"wmts",initialize:function(b){OpenLayers.Format.XML.prototype.initialize.apply(this,[b]);this.options=b;var a=OpenLayers.Util.extend({},OpenLayers.Format.WMTSCapabilities.prototype.yx);this.yx=OpenLayers.Util.extend(a,this.yx)},read:function(b){if(typeof b=="string"){b=OpenLayers.Format.XML.prototype.read.apply(this,[b])}if(b&&b.nodeType==9){b=b.documentElement}var a={};this.readNode(b,a);a.version=this.version;return a},readers:{wmts:{Capabilities:function(a,b){this.readChildNodes(a,b)},Contents:function(a,b){b.contents={};b.contents.layers=[];b.contents.tileMatrixSets={};this.readChildNodes(a,b.contents)},Layer:function(b,c){var a={styles:[],formats:[],tileMatrixSetLinks:[]};a.layers=[];this.readChildNodes(b,a);c.layers.push(a)},Style:function(b,c){var a={};a.isDefault=(b.getAttribute("isDefault")==="true");this.readChildNodes(b,a);c.styles.push(a)},Format:function(a,b){b.formats.push(this.getChildValue(a))},TileMatrixSetLink:function(b,c){var a={};this.readChildNodes(b,a);c.tileMatrixSetLinks.push(a)},TileMatrixSet:function(b,c){if(c.layers){var a={matrixIds:[]};this.readChildNodes(b,a);c.tileMatrixSets[a.identifier]=a}else{c.tileMatrixSet=this.getChildValue(b)}},TileMatrix:function(b,c){var a={supportedCRS:c.supportedCRS};this.readChildNodes(b,a);c.matrixIds.push(a)},ScaleDenominator:function(a,b){b.scaleDenominator=parseFloat(this.getChildValue(a))},TopLeftCorner:function(d,f){var c=this.getChildValue(d);var e=c.split(" ");var a;if(f.supportedCRS){var b=f.supportedCRS.replace(/urn:ogc:def:crs:(\w+):.+:(\w+)$/,"urn:ogc:def:crs:$1::$2");a=!!this.yx[b]}if(a){f.topLeftCorner=new OpenLayers.LonLat(e[1],e[0])}else{f.topLeftCorner=new OpenLayers.LonLat(e[0],e[1])}},TileWidth:function(a,b){b.tileWidth=parseInt(this.getChildValue(a))},TileHeight:function(a,b){b.tileHeight=parseInt(this.getChildValue(a))},MatrixWidth:function(a,b){b.matrixWidth=parseInt(this.getChildValue(a))},MatrixHeight:function(a,b){b.matrixHeight=parseInt(this.getChildValue(a))},ResourceURL:function(a,b){b.resourceUrl=b.resourceUrl||{};b.resourceUrl[a.getAttribute("resourceType")]={format:a.getAttribute("format"),template:a.getAttribute("template")}},WSDL:function(a,b){b.wsdl={};b.wsdl.href=a.getAttribute("xlink:href")},ServiceMetadataURL:function(a,b){b.serviceMetadataUrl={};b.serviceMetadataUrl.href=a.getAttribute("xlink:href")}},ows:OpenLayers.Format.OWSCommon.v1_1_0.prototype.readers.ows},CLASS_NAME:"OpenLayers.Format.WMTSCapabilities.v1_0_0"});OpenLayers.Popup.FramedCloud=OpenLayers.Class(OpenLayers.Popup.Framed,{contentDisplayClass:"olFramedCloudPopupContent",autoSize:true,panMapIfOutOfView:true,imageSize:new OpenLayers.Size(1276,736),isAlphaImage:false,fixedRelativePosition:false,positionBlocks:{tl:{offset:new OpenLayers.Pixel(44,0),padding:new OpenLayers.Bounds(8,40,8,9),blocks:[{size:new OpenLayers.Size("auto","auto"),anchor:new OpenLayers.Bounds(0,51,22,0),position:new OpenLayers.Pixel(0,0)},{size:new OpenLayers.Size(22,"auto"),anchor:new OpenLayers.Bounds(null,50,0,0),position:new OpenLayers.Pixel(-1238,0)},{size:new OpenLayers.Size("auto",19),anchor:new OpenLayers.Bounds(0,32,22,null),position:new OpenLayers.Pixel(0,-631)},{size:new OpenLayers.Size(22,18),anchor:new OpenLayers.Bounds(null,32,0,null),position:new OpenLayers.Pixel(-1238,-632)},{size:new OpenLayers.Size(81,35),anchor:new OpenLayers.Bounds(null,0,0,null),position:new OpenLayers.Pixel(0,-688)}]},tr:{offset:new OpenLayers.Pixel(-45,0),padding:new OpenLayers.Bounds(8,40,8,9),blocks:[{size:new OpenLayers.Size("auto","auto"),anchor:new OpenLayers.Bounds(0,51,22,0),position:new OpenLayers.Pixel(0,0)},{size:new OpenLayers.Size(22,"auto"),anchor:new OpenLayers.Bounds(null,50,0,0),position:new OpenLayers.Pixel(-1238,0)},{size:new OpenLayers.Size("auto",19),anchor:new OpenLayers.Bounds(0,32,22,null),position:new OpenLayers.Pixel(0,-631)},{size:new OpenLayers.Size(22,19),anchor:new OpenLayers.Bounds(null,32,0,null),position:new OpenLayers.Pixel(-1238,-631)},{size:new OpenLayers.Size(81,35),anchor:new OpenLayers.Bounds(0,0,null,null),position:new OpenLayers.Pixel(-215,-687)}]},bl:{offset:new OpenLayers.Pixel(45,0),padding:new OpenLayers.Bounds(8,9,8,40),blocks:[{size:new OpenLayers.Size("auto","auto"),anchor:new OpenLayers.Bounds(0,21,22,32),position:new OpenLayers.Pixel(0,0)},{size:new OpenLayers.Size(22,"auto"),anchor:new OpenLayers.Bounds(null,21,0,32),position:new OpenLayers.Pixel(-1238,0)},{size:new OpenLayers.Size("auto",21),anchor:new OpenLayers.Bounds(0,0,22,null),position:new OpenLayers.Pixel(0,-629)},{size:new OpenLayers.Size(22,21),anchor:new OpenLayers.Bounds(null,0,0,null),position:new OpenLayers.Pixel(-1238,-629)},{size:new OpenLayers.Size(81,33),anchor:new OpenLayers.Bounds(null,null,0,0),position:new OpenLayers.Pixel(-101,-674)}]},br:{offset:new OpenLayers.Pixel(-44,0),padding:new OpenLayers.Bounds(8,9,8,40),blocks:[{size:new OpenLayers.Size("auto","auto"),anchor:new OpenLayers.Bounds(0,21,22,32),position:new OpenLayers.Pixel(0,0)},{size:new OpenLayers.Size(22,"auto"),anchor:new OpenLayers.Bounds(null,21,0,32),position:new OpenLayers.Pixel(-1238,0)},{size:new OpenLayers.Size("auto",21),anchor:new OpenLayers.Bounds(0,0,22,null),position:new OpenLayers.Pixel(0,-629)},{size:new OpenLayers.Size(22,21),anchor:new OpenLayers.Bounds(null,0,0,null),position:new OpenLayers.Pixel(-1238,-629)},{size:new OpenLayers.Size(81,33),anchor:new OpenLayers.Bounds(0,null,null,0),position:new OpenLayers.Pixel(-311,-674)}]}},minSize:new OpenLayers.Size(105,10),maxSize:new OpenLayers.Size(1200,660),initialize:function(g,c,f,b,a,e,d){this.imageSrc=OpenLayers.Util.getImagesLocation()+"cloud-popup-relative.png";OpenLayers.Popup.Framed.prototype.initialize.apply(this,arguments);this.contentDiv.className=this.contentDisplayClass},destroy:function(){OpenLayers.Popup.Framed.prototype.destroy.apply(this,arguments)},CLASS_NAME:"OpenLayers.Popup.FramedCloud"});OpenLayers.Geometry.Rectangle=OpenLayers.Class(OpenLayers.Geometry,{x:null,y:null,width:null,height:null,initialize:function(b,d,c,a){OpenLayers.Geometry.prototype.initialize.apply(this,arguments);this.x=b;this.y=d;this.width=c;this.height=a},calculateBounds:function(){this.bounds=new OpenLayers.Bounds(this.x,this.y,this.x+this.width,this.y+this.height)},getLength:function(){var a=(2*this.width)+(2*this.height);return a},getArea:function(){var a=this.width*this.height;return a},CLASS_NAME:"OpenLayers.Geometry.Rectangle"});OpenLayers.Strategy.Refresh=OpenLayers.Class(OpenLayers.Strategy,{force:false,interval:0,timer:null,activate:function(){var a=OpenLayers.Strategy.prototype.activate.call(this);if(a){if(this.layer.visibility===true){this.start()}this.layer.events.on({visibilitychanged:this.reset,scope:this})}return a},deactivate:function(){var a=OpenLayers.Strategy.prototype.deactivate.call(this);if(a){this.stop()}return a},reset:function(){if(this.layer.visibility===true){this.start()}else{this.stop()}},start:function(){if(this.interval&&typeof this.interval==="number"&&this.interval>0){this.timer=window.setInterval(OpenLayers.Function.bind(this.refresh,this),this.interval)}},refresh:function(){if(this.layer&&this.layer.refresh&&typeof this.layer.refresh=="function"){this.layer.refresh({force:this.force})}},stop:function(){if(this.timer!==null){window.clearInterval(this.timer);this.timer=null}},CLASS_NAME:"OpenLayers.Strategy.Refresh"});OpenLayers.Format.SOSCapabilities.v1_0_0=OpenLayers.Class(OpenLayers.Format.SOSCapabilities,{namespaces:{ows:"http://www.opengis.net/ows/1.1",sos:"http://www.opengis.net/sos/1.0",gml:"http://www.opengis.net/gml",xlink:"http://www.w3.org/1999/xlink"},regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a]);this.options=a},read:function(b){if(typeof b=="string"){b=OpenLayers.Format.XML.prototype.read.apply(this,[b])}if(b&&b.nodeType==9){b=b.documentElement}var a={};this.readNode(b,a);return a},readers:{gml:OpenLayers.Util.applyDefaults({name:function(a,b){b.name=this.getChildValue(a)},TimePeriod:function(a,b){b.timePeriod={};this.readChildNodes(a,b.timePeriod)},beginPosition:function(b,a){a.beginPosition=this.getChildValue(b)},endPosition:function(b,a){a.endPosition=this.getChildValue(b)}},OpenLayers.Format.GML.v3.prototype.readers.gml),sos:{Capabilities:function(a,b){this.readChildNodes(a,b)},Contents:function(a,b){b.contents={};this.readChildNodes(a,b.contents)},ObservationOfferingList:function(b,a){a.offeringList={};this.readChildNodes(b,a.offeringList)},ObservationOffering:function(b,a){var c=this.getAttributeNS(b,this.namespaces.gml,"id");a[c]={procedures:[],observedProperties:[],featureOfInterestIds:[],responseFormats:[],resultModels:[],responseModes:[]};this.readChildNodes(b,a[c])},time:function(a,b){b.time={};this.readChildNodes(a,b.time)},procedure:function(a,b){b.procedures.push(this.getAttributeNS(a,this.namespaces.xlink,"href"))},observedProperty:function(a,b){b.observedProperties.push(this.getAttributeNS(a,this.namespaces.xlink,"href"))},featureOfInterest:function(a,b){b.featureOfInterestIds.push(this.getAttributeNS(a,this.namespaces.xlink,"href"))},responseFormat:function(a,b){b.responseFormats.push(this.getChildValue(a))},resultModel:function(a,b){b.resultModels.push(this.getChildValue(a))},responseMode:function(a,b){b.responseModes.push(this.getChildValue(a))}},ows:OpenLayers.Format.OWSCommon.v1_1_0.prototype.readers.ows},CLASS_NAME:"OpenLayers.Format.SOSCapabilities.v1_0_0"});OpenLayers.Handler.Pinch=OpenLayers.Class(OpenLayers.Handler,{started:false,stopDown:false,pinching:false,last:null,start:null,initialize:function(c,b,a){OpenLayers.Handler.prototype.initialize.apply(this,arguments)},touchstart:function(b){var a=true;this.pinching=false;if(OpenLayers.Event.isMultiTouch(b)){this.started=true;this.last=this.start={distance:this.getDistance(b.touches),delta:0,scale:1};this.callback("start",[b,this.start]);a=!this.stopDown}else{this.started=false;this.start=null;this.last=null}OpenLayers.Event.stop(b);return a},touchmove:function(a){if(this.started&&OpenLayers.Event.isMultiTouch(a)){this.pinching=true;var b=this.getPinchData(a);this.callback("move",[a,b]);this.last=b;OpenLayers.Event.stop(a)}return true},touchend:function(a){if(this.started){this.started=false;this.pinching=false;this.callback("done",[a,this.start,this.last]);this.start=null;this.last=null}return true},activate:function(){var a=false;if(OpenLayers.Handler.prototype.activate.apply(this,arguments)){this.pinching=false;a=true}return a},deactivate:function(){var a=false;if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){this.started=false;this.pinching=false;this.start=null;this.last=null;a=true}return a},getDistance:function(c){var b=c[0];var a=c[1];return Math.sqrt(Math.pow(b.clientX-a.clientX,2)+Math.pow(b.clientY-a.clientY,2))},getPinchData:function(a){var c=this.getDistance(a.touches);var b=c/this.start.distance;return{distance:c,delta:this.last.distance-c,scale:b}},CLASS_NAME:"OpenLayers.Handler.Pinch"});OpenLayers.Control.NavToolbar=OpenLayers.Class(OpenLayers.Control.Panel,{initialize:function(a){OpenLayers.Control.Panel.prototype.initialize.apply(this,[a]);this.addControls([new OpenLayers.Control.Navigation(),new OpenLayers.Control.ZoomBox()])},draw:function(){var a=OpenLayers.Control.Panel.prototype.draw.apply(this,arguments);if(this.defaultControl===null){this.defaultControl=this.controls[0]}return a},CLASS_NAME:"OpenLayers.Control.NavToolbar"});OpenLayers.Tile.WFS=OpenLayers.Class(OpenLayers.Tile,{features:null,url:null,request:null,initialize:function(d,a,e,b,c){OpenLayers.Tile.prototype.initialize.apply(this,arguments);this.url=b;this.features=[]},destroy:function(){OpenLayers.Tile.prototype.destroy.apply(this,arguments);this.destroyAllFeatures();this.features=null;this.url=null;if(this.request){this.request.abort();this.request=null}},clear:function(){this.destroyAllFeatures()},draw:function(){if(OpenLayers.Tile.prototype.draw.apply(this,arguments)){if(this.isLoading){this.events.triggerEvent("reload")}else{this.isLoading=true;this.events.triggerEvent("loadstart")}this.loadFeaturesForRegion(this.requestSuccess)}},loadFeaturesForRegion:function(b,a){if(this.request){this.request.abort()}this.request=OpenLayers.Request.GET({url:this.url,success:b,failure:a,scope:this})},requestSuccess:function(b){if(this.features){var d=b.responseXML;if(!d||!d.documentElement){d=b.responseText}if(this.layer.vectorMode){this.layer.addFeatures(this.layer.formatObject.read(d))}else{var a=new OpenLayers.Format.XML();if(typeof d=="string"){d=a.read(d)}var c=a.getElementsByTagNameNS(d,"http://www.opengis.net/gml","featureMember");this.addResults(c)}}if(this.events){this.events.triggerEvent("loadend")}this.request=null},addResults:function(c){for(var b=0;b<c.length;b++){var a=new this.layer.featureClass(this.layer,c[b]);this.features.push(a)}},destroyAllFeatures:function(){while(this.features.length>0){var a=this.features.shift();a.destroy()}},CLASS_NAME:"OpenLayers.Tile.WFS"});OpenLayers.Control.Geolocate=OpenLayers.Class(OpenLayers.Control,{EVENT_TYPES:["locationupdated","locationfailed","locationuncapable"],geolocation:navigator.geolocation,bind:true,watch:false,geolocationOptions:null,initialize:function(a){this.EVENT_TYPES=OpenLayers.Control.Geolocate.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);this.geolocationOptions={};OpenLayers.Control.prototype.initialize.apply(this,[a])},destroy:function(){this.deactivate();OpenLayers.Control.prototype.destroy.apply(this,arguments)},activate:function(){if(!this.geolocation){this.events.triggerEvent("locationuncapable");return false}if(OpenLayers.Control.prototype.activate.apply(this,arguments)){if(this.watch){this.watchId=this.geolocation.watchPosition(OpenLayers.Function.bind(this.geolocate,this),OpenLayers.Function.bind(this.failure,this),this.geolocationOptions)}else{this.getCurrentLocation()}return true}return false},deactivate:function(){if(this.active&&this.watchId!==null){this.geolocation.clearWatch(this.watchId)}return OpenLayers.Control.prototype.deactivate.apply(this,arguments)},geolocate:function(b){var a=new OpenLayers.LonLat(b.coords.longitude,b.coords.latitude).transform(new OpenLayers.Projection("EPSG:4326"),this.map.getProjectionObject());if(this.bind){this.map.setCenter(a)}this.events.triggerEvent("locationupdated",{position:b,point:new OpenLayers.Geometry.Point(a.lon,a.lat)})},getCurrentLocation:function(){if(!this.active||this.watch){return false}this.geolocation.getCurrentPosition(OpenLayers.Function.bind(this.geolocate,this),OpenLayers.Function.bind(this.failure,this),this.geolocationOptions);return true},failure:function(a){this.events.triggerEvent("locationfailed",{error:a})},CLASS_NAME:"OpenLayers.Control.Geolocate"});OpenLayers.Layer.ArcGIS93Rest=OpenLayers.Class(OpenLayers.Layer.Grid,{DEFAULT_PARAMS:{format:"png"},isBaseLayer:true,initialize:function(d,c,e,b){var a=[];e=OpenLayers.Util.upperCaseObject(e);a.push(d,c,e,b);OpenLayers.Layer.Grid.prototype.initialize.apply(this,a);OpenLayers.Util.applyDefaults(this.params,OpenLayers.Util.upperCaseObject(this.DEFAULT_PARAMS));if(this.params.TRANSPARENT&&this.params.TRANSPARENT.toString().toLowerCase()=="true"){if((b==null)||(!b.isBaseLayer)){this.isBaseLayer=false}if(this.params.FORMAT=="jpg"){this.params.FORMAT=OpenLayers.Util.alphaHack()?"gif":"png"}}},destroy:function(){OpenLayers.Layer.Grid.prototype.destroy.apply(this,arguments)},clone:function(a){if(a==null){a=new OpenLayers.Layer.ArcGIS93Rest(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(e){e=this.adjustBounds(e);var d=this.projection.getCode().split(":");var c=d[d.length-1];var g=this.getImageSize();var h={BBOX:e.toBBOX(),SIZE:g.w+","+g.h,F:"image",BBOXSR:c,IMAGESR:c};if(this.layerDefs){var f=[];var a;for(a in this.layerDefs){if(this.layerDefs.hasOwnProperty(a)){if(this.layerDefs[a]){f.push(a);f.push(":");f.push(this.layerDefs[a]);f.push(";")}}}if(f.length>0){h.LAYERDEFS=f.join("")}}var b=this.getFullRequestString(h);return b},setLayerFilter:function(b,a){if(!this.layerDefs){this.layerDefs={}}if(a){this.layerDefs[b]=a}else{delete this.layerDefs[b]}},clearLayerFilter:function(a){if(a){delete this.layerDefs[a]}else{delete this.layerDefs}},mergeNewParams:function(c){var b=OpenLayers.Util.upperCaseObject(c);var a=[b];return OpenLayers.Layer.Grid.prototype.mergeNewParams.apply(this,a)},CLASS_NAME:"OpenLayers.Layer.ArcGIS93Rest"});OpenLayers.Control.GetFeature=OpenLayers.Class(OpenLayers.Control,{protocol:null,multipleKey:null,toggleKey:null,modifiers:null,multiple:false,click:true,single:true,clickout:true,toggle:false,clickTolerance:5,hover:false,box:false,maxFeatures:10,features:null,hoverFeature:null,handlerOptions:null,handlers:null,hoverResponse:null,filterType:OpenLayers.Filter.Spatial.BBOX,EVENT_TYPES:["featureselected","featuresselected","featureunselected","clickout","beforefeatureselected","beforefeaturesselected","hoverfeature","outfeature"],initialize:function(a){this.EVENT_TYPES=OpenLayers.Control.GetFeature.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);a.handlerOptions=a.handlerOptions||{};OpenLayers.Control.prototype.initialize.apply(this,[a]);this.features={};this.handlers={};if(this.click){this.handlers.click=new OpenLayers.Handler.Click(this,{click:this.selectClick},this.handlerOptions.click||{})}if(this.box){this.handlers.box=new OpenLayers.Handler.Box(this,{done:this.selectBox},OpenLayers.Util.extend(this.handlerOptions.box,{boxDivClassName:"olHandlerBoxSelectFeature"}))}if(this.hover){this.handlers.hover=new OpenLayers.Handler.Hover(this,{move:this.cancelHover,pause:this.selectHover},OpenLayers.Util.extend(this.handlerOptions.hover,{delay:250}))}},activate:function(){if(!this.active){for(var a in this.handlers){this.handlers[a].activate()}}return OpenLayers.Control.prototype.activate.apply(this,arguments)},deactivate:function(){if(this.active){for(var a in this.handlers){this.handlers[a].deactivate()}}return OpenLayers.Control.prototype.deactivate.apply(this,arguments)},selectClick:function(a){var b=this.pixelToBounds(a.xy);this.setModifiers(a);this.request(b,{single:this.single})},selectBox:function(a){var c;if(a instanceof OpenLayers.Bounds){var d=this.map.getLonLatFromPixel(new OpenLayers.Pixel(a.left,a.bottom));var b=this.map.getLonLatFromPixel(new OpenLayers.Pixel(a.right,a.top));c=new OpenLayers.Bounds(d.lon,d.lat,b.lon,b.lat)}else{if(this.click){return}c=this.pixelToBounds(a)}this.setModifiers(this.handlers.box.dragHandler.evt);this.request(c)},selectHover:function(a){var b=this.pixelToBounds(a.xy);this.request(b,{single:true,hover:true})},cancelHover:function(){if(this.hoverResponse){this.protocol.abort(this.hoverResponse);this.hoverResponse=null;OpenLayers.Element.removeClass(this.map.viewPortDiv,"olCursorWait")}},request:function(d,b){b=b||{};var c=new OpenLayers.Filter.Spatial({type:this.filterType,value:d});OpenLayers.Element.addClass(this.map.viewPortDiv,"olCursorWait");var a=this.protocol.read({maxFeatures:b.single==true?this.maxFeatures:undefined,filter:c,callback:function(e){if(e.success()){if(e.features.length){if(b.single==true){this.selectBestFeature(e.features,d.getCenterLonLat(),b)}else{this.select(e.features)}}else{if(b.hover){this.hoverSelect()}else{this.events.triggerEvent("clickout");if(this.clickout){this.unselectAll()}}}}OpenLayers.Element.removeClass(this.map.viewPortDiv,"olCursorWait")},scope:this});if(b.hover==true){this.hoverResponse=a}},selectBestFeature:function(b,a,j){j=j||{};if(b.length){var g=new OpenLayers.Geometry.Point(a.lon,a.lat);var h,d,e;var f=Number.MAX_VALUE;for(var c=0;c<b.length;++c){h=b[c];if(h.geometry){e=g.distanceTo(h.geometry,{edge:false});if(e<f){f=e;d=h;if(f==0){break}}}}if(j.hover==true){this.hoverSelect(d)}else{this.select(d||b)}}},setModifiers:function(a){this.modifiers={multiple:this.multiple||(this.multipleKey&&a[this.multipleKey]),toggle:this.toggle||(this.toggleKey&&a[this.toggleKey])}},select:function(e){if(!this.modifiers.multiple&&!this.modifiers.toggle){this.unselectAll()}if(!(OpenLayers.Util.isArray(e))){e=[e]}var b=this.events.triggerEvent("beforefeaturesselected",{features:e});if(b!==false){var f=[];var d;for(var c=0,a=e.length;c<a;++c){d=e[c];if(this.features[d.fid||d.id]){if(this.modifiers.toggle){this.unselect(this.features[d.fid||d.id])}}else{b=this.events.triggerEvent("beforefeatureselected",{feature:d});if(b!==false){this.features[d.fid||d.id]=d;f.push(d);this.events.triggerEvent("featureselected",{feature:d})}}}this.events.triggerEvent("featuresselected",{features:f})}},hoverSelect:function(a){var c=a?a.fid||a.id:null;var b=this.hoverFeature?this.hoverFeature.fid||this.hoverFeature.id:null;if(b&&b!=c){this.events.triggerEvent("outfeature",{feature:this.hoverFeature});this.hoverFeature=null}if(c&&c!=b){this.events.triggerEvent("hoverfeature",{feature:a});this.hoverFeature=a}},unselect:function(a){delete this.features[a.fid||a.id];this.events.triggerEvent("featureunselected",{feature:a})},unselectAll:function(){for(var a in this.features){this.unselect(this.features[a])}},setMap:function(b){for(var a in this.handlers){this.handlers[a].setMap(b)}OpenLayers.Control.prototype.setMap.apply(this,arguments)},pixelToBounds:function(b){var e=b.add(-this.clickTolerance/2,this.clickTolerance/2);var a=b.add(this.clickTolerance/2,-this.clickTolerance/2);var c=this.map.getLonLatFromPixel(e);var d=this.map.getLonLatFromPixel(a);return new OpenLayers.Bounds(c.lon,c.lat,d.lon,d.lat)},CLASS_NAME:"OpenLayers.Control.GetFeature"});OpenLayers.Format.QueryStringFilter=(function(){var b={};b[OpenLayers.Filter.Comparison.EQUAL_TO]="eq";b[OpenLayers.Filter.Comparison.NOT_EQUAL_TO]="ne";b[OpenLayers.Filter.Comparison.LESS_THAN]="lt";b[OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO]="lte";b[OpenLayers.Filter.Comparison.GREATER_THAN]="gt";b[OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO]="gte";b[OpenLayers.Filter.Comparison.LIKE]="ilike";function a(c){c=c.replace(/%/g,"\\%");c=c.replace(/\\\\\.(\*)?/g,function(e,d){return d?e:"\\\\_"});c=c.replace(/\\\\\.\*/g,"\\\\%");c=c.replace(/(\\)?\.(\*)?/g,function(e,d,f){return d||f?e:"_"});c=c.replace(/(\\)?\.\*/g,function(e,d){return d?e:"%"});c=c.replace(/\\\./g,".");c=c.replace(/(\\)?\\\*/g,function(e,d){return d?e:"*"});return c}return OpenLayers.Class(OpenLayers.Format,{wildcarded:false,srsInBBOX:false,write:function(f,j){j=j||{};var e=f.CLASS_NAME;var g=e.substring(e.lastIndexOf(".")+1);switch(g){case"Spatial":switch(f.type){case OpenLayers.Filter.Spatial.BBOX:j.bbox=f.value.toArray();if(this.srsInBBOX&&f.projection){j.bbox.push(f.projection.getCode())}break;case OpenLayers.Filter.Spatial.DWITHIN:j.tolerance=f.distance;case OpenLayers.Filter.Spatial.WITHIN:j.lon=f.value.x;j.lat=f.value.y;break;default:OpenLayers.Console.warn("Unknown spatial filter type "+f.type)}break;case"Comparison":var k=b[f.type];if(k!==undefined){var h=f.value;if(f.type==OpenLayers.Filter.Comparison.LIKE){h=a(h);if(this.wildcarded){h="%"+h+"%"}}j[f.property+"__"+k]=h;j.queryable=j.queryable||[];j.queryable.push(f.property)}else{OpenLayers.Console.warn("Unknown comparison filter type "+f.type)}break;case"Logical":if(f.type===OpenLayers.Filter.Logical.AND){for(var d=0,c=f.filters.length;d<c;d++){j=this.write(f.filters[d],j)}}else{OpenLayers.Console.warn("Unsupported logical filter type "+f.type)}break;default:OpenLayers.Console.warn("Unknown filter type "+g)}return j},CLASS_NAME:"OpenLayers.Format.QueryStringFilter"})})();OpenLayers.Control.MousePosition=OpenLayers.Class(OpenLayers.Control,{autoActivate:true,element:null,prefix:"",separator:", ",suffix:"",numDigits:5,granularity:10,emptyString:null,lastXy:null,displayProjection:null,destroy:function(){this.deactivate();OpenLayers.Control.prototype.destroy.apply(this,arguments)},activate:function(){if(OpenLayers.Control.prototype.activate.apply(this,arguments)){this.map.events.register("mousemove",this,this.redraw);this.map.events.register("mouseout",this,this.reset);this.redraw();return true}else{return false}},deactivate:function(){if(OpenLayers.Control.prototype.deactivate.apply(this,arguments)){this.map.events.unregister("mousemove",this,this.redraw);this.map.events.unregister("mouseout",this,this.reset);this.element.innerHTML="";return true}else{return false}},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);if(!this.element){this.div.left="";this.div.top="";this.element=this.div}return this.div},redraw:function(a){var c;if(a==null){this.reset();return}else{if(this.lastXy==null||Math.abs(a.xy.x-this.lastXy.x)>this.granularity||Math.abs(a.xy.y-this.lastXy.y)>this.granularity){this.lastXy=a.xy;return}c=this.map.getLonLatFromPixel(a.xy);if(!c){return}if(this.displayProjection){c.transform(this.map.getProjectionObject(),this.displayProjection)}this.lastXy=a.xy}var b=this.formatOutput(c);if(b!=this.element.innerHTML){this.element.innerHTML=b}},reset:function(a){if(this.emptyString!=null){this.element.innerHTML=this.emptyString}},formatOutput:function(b){var c=parseInt(this.numDigits);var a=this.prefix+b.lon.toFixed(c)+this.separator+b.lat.toFixed(c)+this.suffix;return a},CLASS_NAME:"OpenLayers.Control.MousePosition"});OpenLayers.Protocol.HTTP=OpenLayers.Class(OpenLayers.Protocol,{url:null,headers:null,params:null,callback:null,scope:null,readWithPOST:false,wildcarded:false,srsInBBOX:false,initialize:function(a){a=a||{};this.params={};this.headers={};OpenLayers.Protocol.prototype.initialize.apply(this,arguments);if(!this.filterToParams&&OpenLayers.Format.QueryStringFilter){var b=new OpenLayers.Format.QueryStringFilter({wildcarded:this.wildcarded,srsInBBOX:this.srsInBBOX});this.filterToParams=function(c,d){return b.write(c,d)}}},destroy:function(){this.params=null;this.headers=null;OpenLayers.Protocol.prototype.destroy.apply(this)},read:function(a){OpenLayers.Protocol.prototype.read.apply(this,arguments);a=a||{};a.params=OpenLayers.Util.applyDefaults(a.params,this.options.params);a=OpenLayers.Util.applyDefaults(a,this.options);if(a.filter&&this.filterToParams){a.params=this.filterToParams(a.filter,a.params)}var b=(a.readWithPOST!==undefined)?a.readWithPOST:this.readWithPOST;var c=new OpenLayers.Protocol.Response({requestType:"read"});if(b){c.priv=OpenLayers.Request.POST({url:a.url,callback:this.createCallback(this.handleRead,c,a),data:OpenLayers.Util.getParameterString(a.params),headers:{"Content-Type":"application/x-www-form-urlencoded"}})}else{c.priv=OpenLayers.Request.GET({url:a.url,callback:this.createCallback(this.handleRead,c,a),params:a.params,headers:a.headers})}return c},handleRead:function(b,a){this.handleResponse(b,a)},create:function(b,a){a=OpenLayers.Util.applyDefaults(a,this.options);var c=new OpenLayers.Protocol.Response({reqFeatures:b,requestType:"create"});c.priv=OpenLayers.Request.POST({url:a.url,callback:this.createCallback(this.handleCreate,c,a),headers:a.headers,data:this.format.write(b)});return c},handleCreate:function(b,a){this.handleResponse(b,a)},update:function(c,b){b=b||{};var a=b.url||c.url||this.options.url+"/"+c.fid;b=OpenLayers.Util.applyDefaults(b,this.options);var d=new OpenLayers.Protocol.Response({reqFeatures:c,requestType:"update"});d.priv=OpenLayers.Request.PUT({url:a,callback:this.createCallback(this.handleUpdate,d,b),headers:b.headers,data:this.format.write(c)});return d},handleUpdate:function(b,a){this.handleResponse(b,a)},"delete":function(c,b){b=b||{};var a=b.url||c.url||this.options.url+"/"+c.fid;b=OpenLayers.Util.applyDefaults(b,this.options);var d=new OpenLayers.Protocol.Response({reqFeatures:c,requestType:"delete"});d.priv=OpenLayers.Request.DELETE({url:a,callback:this.createCallback(this.handleDelete,d,b),headers:b.headers});return d},handleDelete:function(b,a){this.handleResponse(b,a)},handleResponse:function(c,a){var b=c.priv;if(a.callback){if(b.status>=200&&b.status<300){if(c.requestType!="delete"){c.features=this.parseFeatures(b)}c.code=OpenLayers.Protocol.Response.SUCCESS}else{c.code=OpenLayers.Protocol.Response.FAILURE}a.callback.call(a.scope,c)}},parseFeatures:function(a){var b=a.responseXML;if(!b||!b.documentElement){b=a.responseText}if(!b||b.length<=0){return null}return this.format.read(b)},commit:function(b,q){q=OpenLayers.Util.applyDefaults(q,this.options);var d=[],m=0;var k={};k[OpenLayers.State.INSERT]=[];k[OpenLayers.State.UPDATE]=[];k[OpenLayers.State.DELETE]=[];var p,l,c=[];for(var e=0,j=b.length;e<j;++e){p=b[e];l=k[p.state];if(l){l.push(p);c.push(p)}}var g=(k[OpenLayers.State.INSERT].length>0?1:0)+k[OpenLayers.State.UPDATE].length+k[OpenLayers.State.DELETE].length;var o=true;var a=new OpenLayers.Protocol.Response({reqFeatures:c});function h(s){var r=s.features?s.features.length:0;var u=new Array(r);for(var t=0;t<r;++t){u[t]=s.features[t].fid}a.insertIds=u;n.apply(this,[s])}function n(i){this.callUserCallback(i,q);o=o&&i.success();m++;if(m>=g){if(q.callback){a.code=o?OpenLayers.Protocol.Response.SUCCESS:OpenLayers.Protocol.Response.FAILURE;q.callback.apply(q.scope,[a])}}}var f=k[OpenLayers.State.INSERT];if(f.length>0){d.push(this.create(f,OpenLayers.Util.applyDefaults({callback:h,scope:this},q.create)))}f=k[OpenLayers.State.UPDATE];for(var e=f.length-1;e>=0;--e){d.push(this.update(f[e],OpenLayers.Util.applyDefaults({callback:n,scope:this},q.update)))}f=k[OpenLayers.State.DELETE];for(var e=f.length-1;e>=0;--e){d.push(this["delete"](f[e],OpenLayers.Util.applyDefaults({callback:n,scope:this},q["delete"])))}return d},abort:function(a){if(a){a.priv.abort()}},callUserCallback:function(c,a){var b=a[c.requestType];if(b&&b.callback){b.callback.call(b.scope,c)}},CLASS_NAME:"OpenLayers.Protocol.HTTP"});OpenLayers.Control.Button=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_BUTTON,trigger:function(){},CLASS_NAME:"OpenLayers.Control.Button"});OpenLayers.Strategy.Cluster=OpenLayers.Class(OpenLayers.Strategy,{distance:20,threshold:null,features:null,clusters:null,clustering:false,resolution:null,activate:function(){var a=OpenLayers.Strategy.prototype.activate.call(this);if(a){this.layer.events.on({beforefeaturesadded:this.cacheFeatures,moveend:this.cluster,scope:this})}return a},deactivate:function(){var a=OpenLayers.Strategy.prototype.deactivate.call(this);if(a){this.clearCache();this.layer.events.un({beforefeaturesadded:this.cacheFeatures,moveend:this.cluster,scope:this})}return a},cacheFeatures:function(b){var a=true;if(!this.clustering){this.clearCache();this.features=b.features;this.cluster();a=false}return a},clearCache:function(){this.features=null},cluster:function(a){if((!a||a.zoomChanged)&&this.features){var c=this.layer.map.getResolution();if(c!=this.resolution||!this.clustersExist()){this.resolution=c;var h=[];var m,b,k;for(var e=0;e<this.features.length;++e){m=this.features[e];if(m.geometry){b=false;for(var d=h.length-1;d>=0;--d){k=h[d];if(this.shouldCluster(k,m)){this.addToCluster(k,m);b=true;break}}if(!b){h.push(this.createCluster(this.features[e]))}}}this.layer.removeAllFeatures();if(h.length>0){if(this.threshold>1){var g=h.slice();h=[];var l;for(var e=0,f=g.length;e<f;++e){l=g[e];if(l.attributes.count<this.threshold){Array.prototype.push.apply(h,l.cluster)}else{h.push(l)}}}this.clustering=true;this.layer.addFeatures(h);this.clustering=false}this.clusters=h}}},clustersExist:function(){var b=false;if(this.clusters&&this.clusters.length>0&&this.clusters.length==this.layer.features.length){b=true;for(var a=0;a<this.clusters.length;++a){if(this.clusters[a]!=this.layer.features[a]){b=false;break}}}return b},shouldCluster:function(a,b){var e=a.geometry.getBounds().getCenterLonLat();var c=b.geometry.getBounds().getCenterLonLat();var d=(Math.sqrt(Math.pow((e.lon-c.lon),2)+Math.pow((e.lat-c.lat),2))/this.resolution);return(d<=this.distance)},addToCluster:function(a,b){a.cluster.push(b);a.attributes.count+=1},createCluster:function(c){var b=c.geometry.getBounds().getCenterLonLat();var a=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Point(b.lon,b.lat),{count:1});a.cluster=[c];return a},CLASS_NAME:"OpenLayers.Strategy.Cluster"});OpenLayers.Control.OverviewMap=OpenLayers.Class(OpenLayers.Control,{element:null,ovmap:null,size:new OpenLayers.Size(180,90),layers:null,minRectSize:15,minRectDisplayClass:"RectReplacement",minRatio:8,maxRatio:32,mapOptions:null,autoPan:false,handlers:null,resolutionFactor:1,maximized:false,initialize:function(a){this.layers=[];this.handlers={};OpenLayers.Control.prototype.initialize.apply(this,[a])},destroy:function(){if(!this.mapDiv){return}if(this.handlers.click){this.handlers.click.destroy()}if(this.handlers.drag){this.handlers.drag.destroy()}this.ovmap&&this.ovmap.eventsDiv.removeChild(this.extentRectangle);this.extentRectangle=null;if(this.rectEvents){this.rectEvents.destroy();this.rectEvents=null}if(this.ovmap){this.ovmap.destroy();this.ovmap=null}this.element.removeChild(this.mapDiv);this.mapDiv=null;this.div.removeChild(this.element);this.element=null;if(this.maximizeDiv){OpenLayers.Event.stopObservingElement(this.maximizeDiv);this.div.removeChild(this.maximizeDiv);this.maximizeDiv=null}if(this.minimizeDiv){OpenLayers.Event.stopObservingElement(this.minimizeDiv);this.div.removeChild(this.minimizeDiv);this.minimizeDiv=null}this.map.events.un({moveend:this.update,changebaselayer:this.baseLayerDraw,scope:this});OpenLayers.Control.prototype.destroy.apply(this,arguments)},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);if(!(this.layers.length>0)){if(this.map.baseLayer){var d=this.map.baseLayer.clone();this.layers=[d]}else{this.map.events.register("changebaselayer",this,this.baseLayerDraw);return this.div}}this.element=document.createElement("div");this.element.className=this.displayClass+"Element";this.element.style.display="none";this.mapDiv=document.createElement("div");this.mapDiv.style.width=this.size.w+"px";this.mapDiv.style.height=this.size.h+"px";this.mapDiv.style.position="relative";this.mapDiv.style.overflow="hidden";this.mapDiv.id=OpenLayers.Util.createUniqueID("overviewMap");this.extentRectangle=document.createElement("div");this.extentRectangle.style.position="absolute";this.extentRectangle.style.zIndex=1000;this.extentRectangle.className=this.displayClass+"ExtentRectangle";this.element.appendChild(this.mapDiv);this.div.appendChild(this.element);if(!this.outsideViewport){this.div.className+=" "+this.displayClass+"Container";var e=OpenLayers.Util.getImagesLocation();var b=e+"layer-switcher-maximize.png";this.maximizeDiv=OpenLayers.Util.createAlphaImageDiv(this.displayClass+"MaximizeButton",null,new OpenLayers.Size(18,18),b,"absolute");this.maximizeDiv.style.display="none";this.maximizeDiv.className=this.displayClass+"MaximizeButton";OpenLayers.Event.observe(this.maximizeDiv,"click",OpenLayers.Function.bindAsEventListener(this.maximizeControl,this));this.div.appendChild(this.maximizeDiv);var b=e+"layer-switcher-minimize.png";this.minimizeDiv=OpenLayers.Util.createAlphaImageDiv("OpenLayers_Control_minimizeDiv",null,new OpenLayers.Size(18,18),b,"absolute");this.minimizeDiv.style.display="none";this.minimizeDiv.className=this.displayClass+"MinimizeButton";OpenLayers.Event.observe(this.minimizeDiv,"click",OpenLayers.Function.bindAsEventListener(this.minimizeControl,this));this.div.appendChild(this.minimizeDiv);var f=["dblclick","mousedown"];for(var c=0,a=f.length;c<a;c++){OpenLayers.Event.observe(this.maximizeDiv,f[c],OpenLayers.Event.stop);OpenLayers.Event.observe(this.minimizeDiv,f[c],OpenLayers.Event.stop)}this.minimizeControl()}else{this.element.style.display=""}if(this.map.getExtent()){this.update()}this.map.events.register("moveend",this,this.update);if(this.maximized){this.maximizeControl()}return this.div},baseLayerDraw:function(){this.draw();this.map.events.unregister("changebaselayer",this,this.baseLayerDraw)},rectDrag:function(i){var d=this.handlers.drag.last.x-i.x;var b=this.handlers.drag.last.y-i.y;if(d!=0||b!=0){var g=this.rectPxBounds.top;var a=this.rectPxBounds.left;var e=Math.abs(this.rectPxBounds.getHeight());var c=this.rectPxBounds.getWidth();var f=Math.max(0,(g-b));f=Math.min(f,this.ovmap.size.h-this.hComp-e);var h=Math.max(0,(a-d));h=Math.min(h,this.ovmap.size.w-this.wComp-c);this.setRectPxBounds(new OpenLayers.Bounds(h,f+e,h+c,f))}},mapDivClick:function(i){var b=this.rectPxBounds.getCenterPixel();var e=i.xy.x-b.x;var d=i.xy.y-b.y;var g=this.rectPxBounds.top;var c=this.rectPxBounds.left;var j=Math.abs(this.rectPxBounds.getHeight());var a=this.rectPxBounds.getWidth();var f=Math.max(0,(g+d));f=Math.min(f,this.ovmap.size.h-j);var h=Math.max(0,(c+e));h=Math.min(h,this.ovmap.size.w-a);this.setRectPxBounds(new OpenLayers.Bounds(h,f+j,h+a,f));this.updateMapToRect()},maximizeControl:function(a){this.element.style.display="";this.showToggle(false);if(a!=null){OpenLayers.Event.stop(a)}},minimizeControl:function(a){this.element.style.display="none";this.showToggle(true);if(a!=null){OpenLayers.Event.stop(a)}},showToggle:function(a){this.maximizeDiv.style.display=a?"":"none";this.minimizeDiv.style.display=a?"none":""},update:function(){if(this.ovmap==null){this.createMap()}if(this.autoPan||!this.isSuitableOverview()){this.updateOverview()}this.updateRectToMap()},isSuitableOverview:function(){var b=this.map.getExtent();var a=this.map.maxExtent;var c=new OpenLayers.Bounds(Math.max(b.left,a.left),Math.max(b.bottom,a.bottom),Math.min(b.right,a.right),Math.min(b.top,a.top));if(this.ovmap.getProjection()!=this.map.getProjection()){c=c.transform(this.map.getProjectionObject(),this.ovmap.getProjectionObject())}var d=this.ovmap.getResolution()/this.map.getResolution();return((d>this.minRatio)&&(d<=this.maxRatio)&&(this.ovmap.getExtent().containsBounds(c)))},updateOverview:function(){var c=this.map.getResolution();var b=this.ovmap.getResolution();var d=b/c;if(d>this.maxRatio){b=this.minRatio*c}else{if(d<=this.minRatio){b=this.maxRatio*c}}var a;if(this.ovmap.getProjection()!=this.map.getProjection()){a=this.map.center.clone();a.transform(this.map.getProjectionObject(),this.ovmap.getProjectionObject())}else{a=this.map.center}this.ovmap.setCenter(a,this.ovmap.getZoomForResolution(b*this.resolutionFactor));this.updateRectToMap()},createMap:function(){var b=OpenLayers.Util.extend({controls:[],maxResolution:"auto",fallThrough:false},this.mapOptions);this.ovmap=new OpenLayers.Map(this.mapDiv,b);this.ovmap.eventsDiv.appendChild(this.extentRectangle);OpenLayers.Event.stopObserving(window,"unload",this.ovmap.unloadDestroy);this.ovmap.addLayers(this.layers);this.ovmap.zoomToMaxExtent();this.wComp=parseInt(OpenLayers.Element.getStyle(this.extentRectangle,"border-left-width"))+parseInt(OpenLayers.Element.getStyle(this.extentRectangle,"border-right-width"));this.wComp=(this.wComp)?this.wComp:2;this.hComp=parseInt(OpenLayers.Element.getStyle(this.extentRectangle,"border-top-width"))+parseInt(OpenLayers.Element.getStyle(this.extentRectangle,"border-bottom-width"));this.hComp=(this.hComp)?this.hComp:2;this.handlers.drag=new OpenLayers.Handler.Drag(this,{move:this.rectDrag,done:this.updateMapToRect},{map:this.ovmap});this.handlers.click=new OpenLayers.Handler.Click(this,{click:this.mapDivClick},{single:true,"double":false,stopSingle:true,stopDouble:true,pixelTolerance:1,map:this.ovmap});this.handlers.click.activate();this.rectEvents=new OpenLayers.Events(this,this.extentRectangle,null,true);this.rectEvents.register("mouseover",this,function(d){if(!this.handlers.drag.active&&!this.map.dragging){this.handlers.drag.activate()}});this.rectEvents.register("mouseout",this,function(d){if(!this.handlers.drag.dragging){this.handlers.drag.deactivate()}});if(this.ovmap.getProjection()!=this.map.getProjection()){var c=this.map.getProjectionObject().getUnits()||this.map.units||this.map.baseLayer.units;var a=this.ovmap.getProjectionObject().getUnits()||this.ovmap.units||this.ovmap.baseLayer.units;this.resolutionFactor=c&&a?OpenLayers.INCHES_PER_UNIT[c]/OpenLayers.INCHES_PER_UNIT[a]:1}},updateRectToMap:function(){var b;if(this.ovmap.getProjection()!=this.map.getProjection()){b=this.map.getExtent().transform(this.map.getProjectionObject(),this.ovmap.getProjectionObject())}else{b=this.map.getExtent()}var a=this.getRectBoundsFromMapBounds(b);if(a){this.setRectPxBounds(a)}},updateMapToRect:function(){var a=this.getMapBoundsFromRectBounds(this.rectPxBounds);if(this.ovmap.getProjection()!=this.map.getProjection()){a=a.transform(this.ovmap.getProjectionObject(),this.map.getProjectionObject())}this.map.panTo(a.getCenterLonLat())},setRectPxBounds:function(d){var g=Math.max(d.top,0);var e=Math.max(d.left,0);var b=Math.min(d.top+Math.abs(d.getHeight()),this.ovmap.size.h-this.hComp);var h=Math.min(d.left+d.getWidth(),this.ovmap.size.w-this.wComp);var c=Math.max(h-e,0);var i=Math.max(b-g,0);if(c<this.minRectSize||i<this.minRectSize){this.extentRectangle.className=this.displayClass+this.minRectDisplayClass;var f=e+(c/2)-(this.minRectSize/2);var a=g+(i/2)-(this.minRectSize/2);this.extentRectangle.style.top=Math.round(a)+"px";this.extentRectangle.style.left=Math.round(f)+"px";this.extentRectangle.style.height=this.minRectSize+"px";this.extentRectangle.style.width=this.minRectSize+"px"}else{this.extentRectangle.className=this.displayClass+"ExtentRectangle";this.extentRectangle.style.top=Math.round(g)+"px";this.extentRectangle.style.left=Math.round(e)+"px";this.extentRectangle.style.height=Math.round(i)+"px";this.extentRectangle.style.width=Math.round(c)+"px"}this.rectPxBounds=new OpenLayers.Bounds(Math.round(e),Math.round(b),Math.round(h),Math.round(g))},getRectBoundsFromMapBounds:function(d){var a=new OpenLayers.LonLat(d.left,d.bottom);var f=new OpenLayers.LonLat(d.right,d.top);var c=this.getOverviewPxFromLonLat(a);var b=this.getOverviewPxFromLonLat(f);var e=null;if(c&&b){e=new OpenLayers.Bounds(c.x,c.y,b.x,b.y)}return e},getMapBoundsFromRectBounds:function(d){var c=new OpenLayers.Pixel(d.left,d.bottom);var b=new OpenLayers.Pixel(d.right,d.top);var a=this.getLonLatFromOverviewPx(c);var e=this.getLonLatFromOverviewPx(b);return new OpenLayers.Bounds(a.lon,a.lat,e.lon,e.lat)},getLonLatFromOverviewPx:function(f){var c=this.ovmap.size;var b=this.ovmap.getResolution();var a=this.ovmap.getExtent().getCenterLonLat();var e=f.x-(c.w/2);var d=f.y-(c.h/2);return new OpenLayers.LonLat(a.lon+e*b,a.lat-d*b)},getOverviewPxFromLonLat:function(d){var b=this.ovmap.getResolution();var c=this.ovmap.getExtent();var a=null;if(c){a=new OpenLayers.Pixel(Math.round(1/b*(d.lon-c.left)),Math.round(1/b*(c.top-d.lat)))}return a},CLASS_NAME:"OpenLayers.Control.OverviewMap"});OpenLayers.Format.WPSCapabilities=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.0.0",CLASS_NAME:"OpenLayers.Format.WPSCapabilities"});OpenLayers.Format.WPSCapabilities.v1_0_0=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{ows:"http://www.opengis.net/ows/1.1",wps:"http://www.opengis.net/wps/1.0.0",xlink:"http://www.w3.org/1999/xlink"},regExes:{trimSpace:(/^\s*|\s*$/g),removeSpace:(/\s*/g),splitSpace:(/\s+/),trimComma:(/\s*,\s*/g)},initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(b){if(typeof b=="string"){b=OpenLayers.Format.XML.prototype.read.apply(this,[b])}if(b&&b.nodeType==9){b=b.documentElement}var a={};this.readNode(b,a);return a},readers:{wps:{Capabilities:function(a,b){this.readChildNodes(a,b)},ProcessOfferings:function(a,b){b.processOfferings={};this.readChildNodes(a,b.processOfferings)},Process:function(b,a){var d=this.getAttributeNS(b,this.namespaces.wps,"processVersion");var c={processVersion:d};this.readChildNodes(b,c);a[c.identifier]=c},Languages:function(a,b){b.languages=[];this.readChildNodes(a,b.languages)},Default:function(a,b){var c={isDefault:true};this.readChildNodes(a,c);b.push(c)},Supported:function(a,b){var c={};this.readChildNodes(a,c);b.push(c)}},ows:OpenLayers.Format.OWSCommon.v1_1_0.prototype.readers.ows},CLASS_NAME:"OpenLayers.Format.WPSCapabilities.v1_0_0"});OpenLayers.Control.PinchZoom=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_TOOL,containerOrigin:null,pinchOrigin:null,currentCenter:null,autoActivate:true,initialize:function(a){OpenLayers.Control.prototype.initialize.apply(this,arguments);this.handler=new OpenLayers.Handler.Pinch(this,{start:this.pinchStart,move:this.pinchMove,done:this.pinchDone},this.handlerOptions)},activate:function(){var a=OpenLayers.Control.prototype.activate.apply(this,arguments);if(a){this.map.events.on({moveend:this.updateContainerOrigin,scope:this});this.updateContainerOrigin()}return a},deactivate:function(){var a=OpenLayers.Control.prototype.deactivate.apply(this,arguments);if(this.map&&this.map.events){this.map.events.un({moveend:this.updateContainerOrigin,scope:this})}return a},updateContainerOrigin:function(){var a=this.map.layerContainerDiv;this.containerOrigin={x:parseInt(a.style.left,10),y:parseInt(a.style.top,10)}},pinchStart:function(a,b){this.pinchOrigin=a.xy;this.currentCenter=a.xy},pinchMove:function(b,h){var g=h.scale;var f=this.containerOrigin;var d=this.pinchOrigin;var e=b.xy;var c=Math.round((e.x-d.x)+(g-1)*(f.x-d.x));var a=Math.round((e.y-d.y)+(g-1)*(f.y-d.y));this.applyTransform("translate("+c+"px, "+a+"px) scale("+g+")");this.currentCenter=e},applyTransform:function(a){var b=this.map.layerContainerDiv.style;b["-webkit-transform"]=a;b["-moz-transform"]=a},pinchDone:function(b,h,g){this.applyTransform("");var f=this.map.getZoomForResolution(this.map.getResolution()/g.scale,true);if(f!==this.map.getZoom()||!this.currentCenter.equals(this.pinchOrigin)){var d=this.map.getResolutionForZoom(f);var a=this.map.getLonLatFromPixel(this.pinchOrigin);var c=this.currentCenter;var e=this.map.getSize();a.lon+=d*((e.w/2)-c.x);a.lat-=d*((e.h/2)-c.y);this.map.setCenter(a,f)}},CLASS_NAME:"OpenLayers.Control.PinchZoom"});OpenLayers.Control.TouchNavigation=OpenLayers.Class(OpenLayers.Control,{dragPan:null,dragPanOptions:null,pinchZoom:null,pinchZoomOptions:null,clickHandlerOptions:null,documentDrag:false,autoActivate:true,initialize:function(a){this.handlers={};OpenLayers.Control.prototype.initialize.apply(this,arguments)},destroy:function(){this.deactivate();if(this.dragPan){this.dragPan.destroy()}this.dragPan=null;if(this.pinchZoom){this.pinchZoom.destroy();delete this.pinchZoom}OpenLayers.Control.prototype.destroy.apply(this,arguments)},activate:function(){if(OpenLayers.Control.prototype.activate.apply(this,arguments)){this.dragPan.activate();this.handlers.click.activate();this.pinchZoom.activate();return true}return false},deactivate:function(){if(OpenLayers.Control.prototype.deactivate.apply(this,arguments)){this.dragPan.deactivate();this.handlers.click.deactivate();this.pinchZoom.deactivate();return true}return false},draw:function(){var a={click:this.defaultClick,dblclick:this.defaultDblClick};var b=OpenLayers.Util.extend({"double":true,stopDouble:true,pixelTolerance:2},this.clickHandlerOptions);this.handlers.click=new OpenLayers.Handler.Click(this,a,b);this.dragPan=new OpenLayers.Control.DragPan(OpenLayers.Util.extend({map:this.map,documentDrag:this.documentDrag},this.dragPanOptions));this.dragPan.draw();this.pinchZoom=new OpenLayers.Control.PinchZoom(OpenLayers.Util.extend({map:this.map},this.pinchZoomOptions))},defaultClick:function(a){if(a.lastTouches&&a.lastTouches.length==2){this.map.zoomOut()}},defaultDblClick:function(b){var a=this.map.getLonLatFromViewPortPx(b.xy);this.map.setCenter(a,this.map.zoom+1)},CLASS_NAME:"OpenLayers.Control.TouchNavigation"});OpenLayers.Style2=OpenLayers.Class({id:null,name:null,title:null,description:null,layerName:null,isDefault:false,rules:null,initialize:function(a){OpenLayers.Util.extend(this,a);this.id=OpenLayers.Util.createUniqueID(this.CLASS_NAME+"_")},destroy:function(){for(var b=0,a=this.rules.length;b<a;b++){this.rules[b].destroy()}delete this.rules},clone:function(){var b=OpenLayers.Util.extend({},this);if(this.rules){b.rules=[];for(var c=0,a=this.rules.length;c<a;++c){b.rules.push(this.rules[c].clone())}}return new OpenLayers.Style2(b)},CLASS_NAME:"OpenLayers.Style2"});OpenLayers.Control.DragFeature=OpenLayers.Class(OpenLayers.Control,{geometryTypes:null,onStart:function(b,a){},onDrag:function(b,a){},onComplete:function(b,a){},onEnter:function(a){},onLeave:function(a){},documentDrag:false,layer:null,feature:null,dragCallbacks:{},featureCallbacks:{},lastPixel:null,initialize:function(b,a){OpenLayers.Control.prototype.initialize.apply(this,[a]);this.layer=b;this.handlers={drag:new OpenLayers.Handler.Drag(this,OpenLayers.Util.extend({down:this.downFeature,move:this.moveFeature,up:this.upFeature,out:this.cancel,done:this.doneDragging},this.dragCallbacks),{documentDrag:this.documentDrag}),feature:new OpenLayers.Handler.Feature(this,this.layer,OpenLayers.Util.extend({click:this.clickFeature,clickout:this.clickoutFeature,over:this.overFeature,out:this.outFeature},this.featureCallbacks),{geometryTypes:this.geometryTypes})}},clickFeature:function(a){if(this.handlers.feature.touch&&!this.over&&this.overFeature(a)){this.handlers.drag.dragstart(this.handlers.feature.evt);this.handlers.drag.stopDown=false}},clickoutFeature:function(a){if(this.handlers.feature.touch&&this.over){this.outFeature(a);this.handlers.drag.stopDown=true}},destroy:function(){this.layer=null;OpenLayers.Control.prototype.destroy.apply(this,[])},activate:function(){return(this.handlers.feature.activate()&&OpenLayers.Control.prototype.activate.apply(this,arguments))},deactivate:function(){this.handlers.drag.deactivate();this.handlers.feature.deactivate();this.feature=null;this.dragging=false;this.lastPixel=null;OpenLayers.Element.removeClass(this.map.viewPortDiv,this.displayClass+"Over");return OpenLayers.Control.prototype.deactivate.apply(this,arguments)},overFeature:function(b){var a=false;if(!this.handlers.drag.dragging){this.feature=b;this.handlers.drag.activate();a=true;this.over=true;OpenLayers.Element.addClass(this.map.viewPortDiv,this.displayClass+"Over");this.onEnter(b)}else{if(this.feature.id==b.id){this.over=true}else{this.over=false}}return a},downFeature:function(a){this.lastPixel=a;this.onStart(this.feature,a)},moveFeature:function(a){var b=this.map.getResolution();this.feature.geometry.move(b*(a.x-this.lastPixel.x),b*(this.lastPixel.y-a.y));this.layer.drawFeature(this.feature);this.lastPixel=a;this.onDrag(this.feature,a)},upFeature:function(a){if(!this.over){this.handlers.drag.deactivate()}},doneDragging:function(a){this.onComplete(this.feature,a)},outFeature:function(a){if(!this.handlers.drag.dragging){this.over=false;this.handlers.drag.deactivate();OpenLayers.Element.removeClass(this.map.viewPortDiv,this.displayClass+"Over");this.onLeave(a);this.feature=null}else{if(this.feature.id==a.id){this.over=false}}},cancel:function(){this.handlers.drag.deactivate();this.over=false},setMap:function(a){this.handlers.drag.setMap(a);this.handlers.feature.setMap(a);OpenLayers.Control.prototype.setMap.apply(this,arguments)},CLASS_NAME:"OpenLayers.Control.DragFeature"});OpenLayers.Handler.Keyboard=OpenLayers.Class(OpenLayers.Handler,{KEY_EVENTS:["keydown","keyup"],eventListener:null,initialize:function(c,b,a){OpenLayers.Handler.prototype.initialize.apply(this,arguments);this.eventListener=OpenLayers.Function.bindAsEventListener(this.handleKeyEvent,this)},destroy:function(){this.deactivate();this.eventListener=null;OpenLayers.Handler.prototype.destroy.apply(this,arguments)},activate:function(){if(OpenLayers.Handler.prototype.activate.apply(this,arguments)){for(var b=0,a=this.KEY_EVENTS.length;b<a;b++){OpenLayers.Event.observe(document,this.KEY_EVENTS[b],this.eventListener)}return true}else{return false}},deactivate:function(){var c=false;if(OpenLayers.Handler.prototype.deactivate.apply(this,arguments)){for(var b=0,a=this.KEY_EVENTS.length;b<a;b++){OpenLayers.Event.stopObserving(document,this.KEY_EVENTS[b],this.eventListener)}c=true}return c},handleKeyEvent:function(a){if(this.checkModifiers(a)){this.callback(a.type,[a])}},CLASS_NAME:"OpenLayers.Handler.Keyboard"});OpenLayers.Control.ModifyFeature=OpenLayers.Class(OpenLayers.Control,{geometryTypes:null,clickout:true,toggle:true,standalone:false,layer:null,feature:null,vertices:null,virtualVertices:null,selectControl:null,dragControl:null,handlers:null,deleteCodes:null,virtualStyle:null,vertexRenderIntent:null,mode:null,modified:false,radiusHandle:null,dragHandle:null,onModificationStart:function(){},onModification:function(){},onModificationEnd:function(){},initialize:function(d,c){c=c||{};this.layer=d;this.vertices=[];this.virtualVertices=[];this.virtualStyle=OpenLayers.Util.extend({},this.layer.style||this.layer.styleMap.createSymbolizer(null,c.vertexRenderIntent));this.virtualStyle.fillOpacity=0.3;this.virtualStyle.strokeOpacity=0.3;this.deleteCodes=[46,68];this.mode=OpenLayers.Control.ModifyFeature.RESHAPE;OpenLayers.Control.prototype.initialize.apply(this,[c]);if(!(OpenLayers.Util.isArray(this.deleteCodes))){this.deleteCodes=[this.deleteCodes]}var f=this;var a={geometryTypes:this.geometryTypes,clickout:this.clickout,toggle:this.toggle,onBeforeSelect:this.beforeSelectFeature,onSelect:this.selectFeature,onUnselect:this.unselectFeature,scope:this};if(this.standalone===false){this.selectControl=new OpenLayers.Control.SelectFeature(d,a)}var b={geometryTypes:["OpenLayers.Geometry.Point"],snappingOptions:this.snappingOptions,onStart:function(h,g){f.dragStart.apply(f,[h,g])},onDrag:function(h,g){f.dragVertex.apply(f,[h,g])},onComplete:function(g){f.dragComplete.apply(f,[g])},featureCallbacks:{over:function(g){if(f.standalone!==true||g._sketch||f.feature===g){f.dragControl.overFeature.apply(f.dragControl,[g])}}}};this.dragControl=new OpenLayers.Control.DragFeature(d,b);var e={keydown:this.handleKeypress};this.handlers={keyboard:new OpenLayers.Handler.Keyboard(this,e)}},destroy:function(){this.layer=null;this.standalone||this.selectControl.destroy();this.dragControl.destroy();OpenLayers.Control.prototype.destroy.apply(this,[])},activate:function(){return((this.standalone||this.selectControl.activate())&&this.handlers.keyboard.activate()&&OpenLayers.Control.prototype.activate.apply(this,arguments))},deactivate:function(){var c=false;if(OpenLayers.Control.prototype.deactivate.apply(this,arguments)){this.layer.removeFeatures(this.vertices,{silent:true});this.layer.removeFeatures(this.virtualVertices,{silent:true});this.vertices=[];this.dragControl.deactivate();var a=this.feature;var b=a&&a.geometry&&a.layer;if(this.standalone===false){if(b){this.selectControl.unselect.apply(this.selectControl,[a])}this.selectControl.deactivate()}else{if(b){this.unselectFeature(a)}}this.handlers.keyboard.deactivate();c=true}return c},beforeSelectFeature:function(a){return this.layer.events.triggerEvent("beforefeaturemodified",{feature:a})},selectFeature:function(b){if(!this.standalone||this.beforeSelectFeature(b)!==false){this.feature=b;this.modified=false;this.resetVertices();this.dragControl.activate();this.onModificationStart(this.feature)}var a=b.modified;if(b.geometry&&!(a&&a.geometry)){this._originalGeometry=b.geometry.clone()}},unselectFeature:function(a){this.layer.removeFeatures(this.vertices,{silent:true});this.vertices=[];this.layer.destroyFeatures(this.virtualVertices,{silent:true});this.virtualVertices=[];if(this.dragHandle){this.layer.destroyFeatures([this.dragHandle],{silent:true});delete this.dragHandle}if(this.radiusHandle){this.layer.destroyFeatures([this.radiusHandle],{silent:true});delete this.radiusHandle}this.feature=null;this.dragControl.deactivate();this.onModificationEnd(a);this.layer.events.triggerEvent("afterfeaturemodified",{feature:a,modified:this.modified});this.modified=false},dragStart:function(b,a){if(b!=this.feature&&!b.geometry.parent&&b!=this.dragHandle&&b!=this.radiusHandle){if(this.standalone===false&&this.feature){this.selectControl.clickFeature.apply(this.selectControl,[this.feature])}if(this.geometryTypes==null||OpenLayers.Util.indexOf(this.geometryTypes,b.geometry.CLASS_NAME)!=-1){this.standalone||this.selectControl.clickFeature.apply(this.selectControl,[b]);this.dragControl.overFeature.apply(this.dragControl,[b]);this.dragControl.lastPixel=a;this.dragControl.handlers.drag.started=true;this.dragControl.handlers.drag.start=a;this.dragControl.handlers.drag.last=a}}},dragVertex:function(b,a){this.modified=true;if(this.feature.geometry.CLASS_NAME=="OpenLayers.Geometry.Point"){if(this.feature!=b){this.feature=b}this.layer.events.triggerEvent("vertexmodified",{vertex:b.geometry,feature:this.feature,pixel:a})}else{if(b._index){b.geometry.parent.addComponent(b.geometry,b._index);delete b._index;OpenLayers.Util.removeItem(this.virtualVertices,b);this.vertices.push(b)}else{if(b==this.dragHandle){this.layer.removeFeatures(this.vertices,{silent:true});this.vertices=[];if(this.radiusHandle){this.layer.destroyFeatures([this.radiusHandle],{silent:true});this.radiusHandle=null}}else{if(b!==this.radiusHandle){this.layer.events.triggerEvent("vertexmodified",{vertex:b.geometry,feature:this.feature,pixel:a})}}}if(this.virtualVertices.length>0){this.layer.destroyFeatures(this.virtualVertices,{silent:true});this.virtualVertices=[]}this.layer.drawFeature(this.feature,this.standalone?undefined:this.selectControl.renderIntent)}this.layer.drawFeature(b)},dragComplete:function(a){this.resetVertices();this.setFeatureState();this.onModification(this.feature);this.layer.events.triggerEvent("featuremodified",{feature:this.feature})},setFeatureState:function(){if(this.feature.state!=OpenLayers.State.INSERT&&this.feature.state!=OpenLayers.State.DELETE){this.feature.state=OpenLayers.State.UPDATE;if(this.modified&&this._originalGeometry){var a=this.feature;a.modified=OpenLayers.Util.extend(a.modified,{geometry:this._originalGeometry});delete this._originalGeometry}}},resetVertices:function(){if(this.dragControl.feature){this.dragControl.outFeature(this.dragControl.feature)}if(this.vertices.length>0){this.layer.removeFeatures(this.vertices,{silent:true});this.vertices=[]}if(this.virtualVertices.length>0){this.layer.removeFeatures(this.virtualVertices,{silent:true});this.virtualVertices=[]}if(this.dragHandle){this.layer.destroyFeatures([this.dragHandle],{silent:true});this.dragHandle=null}if(this.radiusHandle){this.layer.destroyFeatures([this.radiusHandle],{silent:true});this.radiusHandle=null}if(this.feature&&this.feature.geometry.CLASS_NAME!="OpenLayers.Geometry.Point"){if((this.mode&OpenLayers.Control.ModifyFeature.DRAG)){this.collectDragHandle()}if((this.mode&(OpenLayers.Control.ModifyFeature.ROTATE|OpenLayers.Control.ModifyFeature.RESIZE))){this.collectRadiusHandle()}if(this.mode&OpenLayers.Control.ModifyFeature.RESHAPE){if(!(this.mode&OpenLayers.Control.ModifyFeature.RESIZE)){this.collectVertices()}}}},handleKeypress:function(a){var b=a.keyCode;if(this.feature&&OpenLayers.Util.indexOf(this.deleteCodes,b)!=-1){var c=this.dragControl.feature;if(c&&OpenLayers.Util.indexOf(this.vertices,c)!=-1&&!this.dragControl.handlers.drag.dragging&&c.geometry.parent){c.geometry.parent.removeComponent(c.geometry);this.layer.events.triggerEvent("vertexremoved",{vertex:c.geometry,feature:this.feature,pixel:a.xy});this.layer.drawFeature(this.feature,this.standalone?undefined:this.selectControl.renderIntent);this.modified=true;this.resetVertices();this.setFeatureState();this.onModification(this.feature);this.layer.events.triggerEvent("featuremodified",{feature:this.feature})}}},collectVertices:function(){this.vertices=[];this.virtualVertices=[];var a=this;function b(h){var d,e,j,f;if(h.CLASS_NAME=="OpenLayers.Geometry.Point"){e=new OpenLayers.Feature.Vector(h);e._sketch=true;e.renderIntent=a.vertexRenderIntent;a.vertices.push(e)}else{var c=h.components.length;if(h.CLASS_NAME=="OpenLayers.Geometry.LinearRing"){c-=1}for(d=0;d<c;++d){j=h.components[d];if(j.CLASS_NAME=="OpenLayers.Geometry.Point"){e=new OpenLayers.Feature.Vector(j);e._sketch=true;e.renderIntent=a.vertexRenderIntent;a.vertices.push(e)}else{b(j)}}if(h.CLASS_NAME!="OpenLayers.Geometry.MultiPoint"){for(d=0,f=h.components.length;d<f-1;++d){var m=h.components[d];var n=h.components[d+1];if(m.CLASS_NAME=="OpenLayers.Geometry.Point"&&n.CLASS_NAME=="OpenLayers.Geometry.Point"){var k=(m.x+n.x)/2;var g=(m.y+n.y)/2;var l=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.Point(k,g),null,a.virtualStyle);l.geometry.parent=h;l._index=d+1;l._sketch=true;a.virtualVertices.push(l)}}}}}b.call(this,this.feature.geometry);this.layer.addFeatures(this.virtualVertices,{silent:true});this.layer.addFeatures(this.vertices,{silent:true})},collectDragHandle:function(){var d=this.feature.geometry;var a=d.getBounds().getCenterLonLat();var c=new OpenLayers.Geometry.Point(a.lon,a.lat);var b=new OpenLayers.Feature.Vector(c);c.move=function(e,f){OpenLayers.Geometry.Point.prototype.move.call(this,e,f);d.move(e,f)};b._sketch=true;this.dragHandle=b;this.layer.addFeatures([this.dragHandle],{silent:true})},collectRadiusHandle:function(){var h=this.feature.geometry;var a=h.getBounds();var b=a.getCenterLonLat();var i=new OpenLayers.Geometry.Point(b.lon,b.lat);var g=new OpenLayers.Geometry.Point(a.right,a.bottom);var f=new OpenLayers.Feature.Vector(g);var c=(this.mode&OpenLayers.Control.ModifyFeature.RESIZE);var e=(this.mode&OpenLayers.Control.ModifyFeature.RESHAPE);var d=(this.mode&OpenLayers.Control.ModifyFeature.ROTATE);g.move=function(t,s){OpenLayers.Geometry.Point.prototype.move.call(this,t,s);var u=this.x-i.x;var p=this.y-i.y;var v=u-t;var q=p-s;if(d){var k=Math.atan2(q,v);var j=Math.atan2(p,u);var n=j-k;n*=180/Math.PI;h.rotate(n,i)}if(c){var m,r;if(e){m=p/q;r=(u/v)/m}else{var o=Math.sqrt((v*v)+(q*q));var l=Math.sqrt((u*u)+(p*p));m=l/o}h.resize(m,i,r)}};f._sketch=true;this.radiusHandle=f;this.layer.addFeatures([this.radiusHandle],{silent:true})},setMap:function(a){this.standalone||this.selectControl.setMap(a);this.dragControl.setMap(a);OpenLayers.Control.prototype.setMap.apply(this,arguments)},CLASS_NAME:"OpenLayers.Control.ModifyFeature"});OpenLayers.Control.ModifyFeature.RESHAPE=1;OpenLayers.Control.ModifyFeature.RESIZE=2;OpenLayers.Control.ModifyFeature.ROTATE=4;OpenLayers.Control.ModifyFeature.DRAG=8;OpenLayers.Format.WFS=OpenLayers.Class(OpenLayers.Format.GML,{layer:null,wfsns:"http://www.opengis.net/wfs",ogcns:"http://www.opengis.net/ogc",initialize:function(a,b){OpenLayers.Format.GML.prototype.initialize.apply(this,[a]);this.layer=b;if(this.layer.featureNS){this.featureNS=this.layer.featureNS}if(this.layer.options.geometry_column){this.geometryName=this.layer.options.geometry_column}if(this.layer.options.typename){this.featureName=this.layer.options.typename}},write:function(b){var c=this.createElementNS(this.wfsns,"wfs:Transaction");c.setAttribute("version","1.0.0");c.setAttribute("service","WFS");for(var a=0;a<b.length;a++){switch(b[a].state){case OpenLayers.State.INSERT:c.appendChild(this.insert(b[a]));break;case OpenLayers.State.UPDATE:c.appendChild(this.update(b[a]));break;case OpenLayers.State.DELETE:c.appendChild(this.remove(b[a]));break}}return OpenLayers.Format.XML.prototype.write.apply(this,[c])},createFeatureXML:function(f){var c=this.buildGeometryNode(f.geometry);var g=this.createElementNS(this.featureNS,"feature:"+this.geometryName);g.appendChild(c);var b=this.createElementNS(this.featureNS,"feature:"+this.featureName);b.appendChild(g);for(var a in f.attributes){var h=this.createTextNode(f.attributes[a]);var d=a;if(a.search(":")!=-1){d=a.split(":")[1]}var e=this.createElementNS(this.featureNS,"feature:"+d);e.appendChild(h);b.appendChild(e)}return b},insert:function(b){var a=this.createElementNS(this.wfsns,"wfs:Insert");a.appendChild(this.createFeatureXML(b));return a},update:function(j){if(!j.fid){OpenLayers.Console.userError(OpenLayers.i18n("noFID"))}var f=this.createElementNS(this.wfsns,"wfs:Update");f.setAttribute("typeName",this.featurePrefix+":"+this.featureName);f.setAttribute("xmlns:"+this.featurePrefix,this.featureNS);var h=this.createElementNS(this.wfsns,"wfs:Property");var a=this.createElementNS(this.wfsns,"wfs:Name");var c=this.createTextNode(this.geometryName);a.appendChild(c);h.appendChild(a);var i=this.createElementNS(this.wfsns,"wfs:Value");var d=this.buildGeometryNode(j.geometry);if(j.layer){d.setAttribute("srsName",j.layer.projection.getCode())}i.appendChild(d);h.appendChild(i);f.appendChild(h);for(var e in j.attributes){h=this.createElementNS(this.wfsns,"wfs:Property");a=this.createElementNS(this.wfsns,"wfs:Name");a.appendChild(this.createTextNode(e));h.appendChild(a);i=this.createElementNS(this.wfsns,"wfs:Value");i.appendChild(this.createTextNode(j.attributes[e]));h.appendChild(i);f.appendChild(h)}var g=this.createElementNS(this.ogcns,"ogc:Filter");var b=this.createElementNS(this.ogcns,"ogc:FeatureId");b.setAttribute("fid",j.fid);g.appendChild(b);f.appendChild(g);return f},remove:function(b){if(!b.fid){OpenLayers.Console.userError(OpenLayers.i18n("noFID"));return false}var a=this.createElementNS(this.wfsns,"wfs:Delete");a.setAttribute("typeName",this.featurePrefix+":"+this.featureName);a.setAttribute("xmlns:"+this.featurePrefix,this.featureNS);var c=this.createElementNS(this.ogcns,"ogc:Filter");var d=this.createElementNS(this.ogcns,"ogc:FeatureId");d.setAttribute("fid",b.fid);c.appendChild(d);a.appendChild(c);return a},destroy:function(){this.layer=null},CLASS_NAME:"OpenLayers.Format.WFS"});OpenLayers.Format.WFSCapabilities.v1_0_0=OpenLayers.Class(OpenLayers.Format.WFSCapabilities.v1,{initialize:function(a){OpenLayers.Format.WFSCapabilities.v1.prototype.initialize.apply(this,[a])},read_cap_Service:function(b,c){var a={};this.runChildNodes(a,c);b.service=a},read_cap_Fees:function(a,c){var b=this.getChildValue(c);if(b&&b.toLowerCase()!="none"){a.fees=b}},read_cap_AccessConstraints:function(a,b){var c=this.getChildValue(b);if(c&&c.toLowerCase()!="none"){a.accessConstraints=c}},read_cap_OnlineResource:function(a,c){var b=this.getChildValue(c);if(b&&b.toLowerCase()!="none"){a.onlineResource=b}},read_cap_Keywords:function(a,c){var b=this.getChildValue(c);if(b&&b.toLowerCase()!="none"){a.keywords=b.split(", ")}},read_cap_Capability:function(a,c){var b={};this.runChildNodes(b,c);a.capability=b},read_cap_Request:function(c,b){var a={};this.runChildNodes(a,b);c.request=a},read_cap_GetFeature:function(b,a){var c={href:{},formats:[]};this.runChildNodes(c,a);b.getfeature=c},read_cap_ResultFormat:function(e,d){var c=d.childNodes;var b;for(var a=0;a<c.length;a++){b=c[a];if(b.nodeType==1){e.formats.push(b.nodeName)}}},read_cap_DCPType:function(b,a){this.runChildNodes(b,a)},read_cap_HTTP:function(b,a){this.runChildNodes(b.href,a)},read_cap_Get:function(b,a){b.get=a.getAttribute("onlineResource")},read_cap_Post:function(b,a){b.post=a.getAttribute("onlineResource")},read_cap_SRS:function(c,b){var a=this.getChildValue(b);if(a){c.srs=a}},CLASS_NAME:"OpenLayers.Format.WFSCapabilities.v1_0_0"});OpenLayers.Format.WMSCapabilities.v1_3=OpenLayers.Class(OpenLayers.Format.WMSCapabilities.v1,{readers:{wms:OpenLayers.Util.applyDefaults({WMS_Capabilities:function(a,b){this.readChildNodes(a,b)},LayerLimit:function(a,b){b.layerLimit=parseInt(this.getChildValue(a))},MaxWidth:function(a,b){b.maxWidth=parseInt(this.getChildValue(a))},MaxHeight:function(a,b){b.maxHeight=parseInt(this.getChildValue(a))},BoundingBox:function(a,b){var c=OpenLayers.Format.WMSCapabilities.v1.prototype.readers.wms.BoundingBox.apply(this,[a,b]);c.srs=a.getAttribute("CRS");b.bbox[c.srs]=c},CRS:function(a,b){this.readers.wms.SRS.apply(this,[a,b])},EX_GeographicBoundingBox:function(a,b){b.llbbox=[];this.readChildNodes(a,b.llbbox)},westBoundLongitude:function(a,b){b[0]=this.getChildValue(a)},eastBoundLongitude:function(a,b){b[2]=this.getChildValue(a)},southBoundLatitude:function(a,b){b[1]=this.getChildValue(a)},northBoundLatitude:function(a,b){b[3]=this.getChildValue(a)},MinScaleDenominator:function(a,b){b.maxScale=parseFloat(this.getChildValue(a)).toPrecision(16)},MaxScaleDenominator:function(a,b){b.minScale=parseFloat(this.getChildValue(a)).toPrecision(16)},Dimension:function(b,d){var a=b.getAttribute("name").toLowerCase();var c={name:a,units:b.getAttribute("units"),unitsymbol:b.getAttribute("unitSymbol"),nearestVal:b.getAttribute("nearestValue")==="1",multipleVal:b.getAttribute("multipleValues")==="1","default":b.getAttribute("default")||"",current:b.getAttribute("current")==="1",values:this.getChildValue(b).split(",")};d.dimensions[c.name]=c},Keyword:function(b,c){var a={value:this.getChildValue(b),vocabulary:b.getAttribute("vocabulary")};if(c.keywords){c.keywords.push(a)}}},OpenLayers.Format.WMSCapabilities.v1.prototype.readers.wms),sld:{UserDefinedSymbolization:function(a,b){this.readers.wms.UserDefinedSymbolization.apply(this,[a,b]);b.userSymbols.inlineFeature=parseInt(a.getAttribute("InlineFeature"))==1;b.userSymbols.remoteWCS=parseInt(a.getAttribute("RemoteWCS"))==1},DescribeLayer:function(a,b){this.readers.wms.DescribeLayer.apply(this,[a,b])},GetLegendGraphic:function(a,b){this.readers.wms.GetLegendGraphic.apply(this,[a,b])}}},CLASS_NAME:"OpenLayers.Format.WMSCapabilities.v1_3"});OpenLayers.Layer.Yahoo=OpenLayers.Class(OpenLayers.Layer.EventPane,OpenLayers.Layer.FixedZoomLevels,{MIN_ZOOM_LEVEL:0,MAX_ZOOM_LEVEL:17,RESOLUTIONS:[1.40625,0.703125,0.3515625,0.17578125,0.087890625,0.0439453125,0.02197265625,0.010986328125,0.0054931640625,0.00274658203125,0.001373291015625,0.0006866455078125,0.00034332275390625,0.000171661376953125,0.0000858306884765625,0.00004291534423828125,0.00002145767211914062,0.00001072883605957031],type:null,wrapDateLine:true,sphericalMercator:false,initialize:function(b,a){OpenLayers.Layer.EventPane.prototype.initialize.apply(this,arguments);OpenLayers.Layer.FixedZoomLevels.prototype.initialize.apply(this,arguments);if(this.sphericalMercator){OpenLayers.Util.extend(this,OpenLayers.Layer.SphericalMercator);this.initMercatorParameters()}},loadMapObject:function(){try{var a=this.getMapObjectSizeFromOLSize(this.map.getSize());this.mapObject=new YMap(this.div,this.type,a);this.mapObject.disableKeyControls();this.mapObject.disableDragMap();if(!this.mapObject.moveByXY||(typeof this.mapObject.moveByXY!="function")){this.dragPanMapObject=null}}catch(b){}},onMapResize:function(){try{var a=this.getMapObjectSizeFromOLSize(this.map.getSize());this.mapObject.resizeTo(a)}catch(b){}},setMap:function(a){OpenLayers.Layer.EventPane.prototype.setMap.apply(this,arguments);this.map.events.register("moveend",this,this.fixYahooEventPane)},fixYahooEventPane:function(){var a=OpenLayers.Util.getElement("ygddfdiv");if(a!=null){if(a.parentNode!=null){a.parentNode.removeChild(a)}this.map.events.unregister("moveend",this,this.fixYahooEventPane)}},getWarningHTML:function(){return OpenLayers.i18n("getLayerWarning",{layerType:"Yahoo",layerLib:"Yahoo"})},getOLZoomFromMapObjectZoom:function(a){var b=null;if(a!=null){b=OpenLayers.Layer.FixedZoomLevels.prototype.getOLZoomFromMapObjectZoom.apply(this,[a]);b=18-b}return b},getMapObjectZoomFromOLZoom:function(a){var b=null;if(a!=null){b=OpenLayers.Layer.FixedZoomLevels.prototype.getMapObjectZoomFromOLZoom.apply(this,[a]);b=18-b}return b},setMapObjectCenter:function(a,b){this.mapObject.drawZoomAndCenter(a,b)},getMapObjectCenter:function(){return this.mapObject.getCenterLatLon()},dragPanMapObject:function(b,a){this.mapObject.moveByXY({x:-b,y:a})},getMapObjectZoom:function(){return this.mapObject.getZoomLevel()},getMapObjectLonLatFromMapObjectPixel:function(a){return this.mapObject.convertXYLatLon(a)},getMapObjectPixelFromMapObjectLonLat:function(a){return this.mapObject.convertLatLonXY(a)},getLongitudeFromMapObjectLonLat:function(a){return this.sphericalMercator?this.forwardMercator(a.Lon,a.Lat).lon:a.Lon},getLatitudeFromMapObjectLonLat:function(a){return this.sphericalMercator?this.forwardMercator(a.Lon,a.Lat).lat:a.Lat},getMapObjectLonLatFromLonLat:function(d,c){var a;if(this.sphericalMercator){var b=this.inverseMercator(d,c);a=new YGeoPoint(b.lat,b.lon)}else{a=new YGeoPoint(c,d)}return a},getXFromMapObjectPixel:function(a){return a.x},getYFromMapObjectPixel:function(a){return a.y},getMapObjectPixelFromXY:function(a,b){return new YCoordPoint(a,b)},getMapObjectSizeFromOLSize:function(a){return new YSize(a.w,a.h)},CLASS_NAME:"OpenLayers.Layer.Yahoo"});OpenLayers.Layer.MapServer=OpenLayers.Class(OpenLayers.Layer.Grid,{DEFAULT_PARAMS:{mode:"map",map_imagetype:"png"},initialize:function(d,c,e,b){var a=[];a.push(d,c,e,b);OpenLayers.Layer.Grid.prototype.initialize.apply(this,a);this.params=OpenLayers.Util.applyDefaults(this.params,this.DEFAULT_PARAMS);if(b==null||b.isBaseLayer==null){this.isBaseLayer=((this.params.transparent!="true")&&(this.params.transparent!=true))}},clone:function(a){if(a==null){a=new OpenLayers.Layer.MapServer(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(c){c=this.adjustBounds(c);var b=[c.left,c.bottom,c.right,c.top];var d=this.getImageSize();var a=this.getFullRequestString({mapext:b,imgext:b,map_size:[d.w,d.h],imgx:d.w/2,imgy:d.h/2,imgxy:[d.w,d.h]});return a},getFullRequestString:function(f,e){var b=(e==null)?this.url:e;var g=OpenLayers.Util.extend({},this.params);g=OpenLayers.Util.extend(g,f);var a=OpenLayers.Util.getParameterString(g);if(OpenLayers.Util.isArray(b)){b=this.selectUrl(a,b)}var d=OpenLayers.Util.upperCaseObject(OpenLayers.Util.getParameters(b));for(var h in g){if(h.toUpperCase() in d){delete g[h]}}a=OpenLayers.Util.getParameterString(g);var i=b;a=a.replace(/,/g,"+");if(a!=""){var c=b.charAt(b.length-1);if((c=="&")||(c=="?")){i+=a}else{if(b.indexOf("?")==-1){i+="?"+a}else{i+="&"+a}}}return i},CLASS_NAME:"OpenLayers.Layer.MapServer"});OpenLayers.Layer.MapServer.Untiled=OpenLayers.Class(OpenLayers.Layer.MapServer,{singleTile:true,initialize:function(c,b,e,a){OpenLayers.Layer.MapServer.prototype.initialize.apply(this,arguments);var d="The OpenLayers.Layer.MapServer.Untiled class is deprecated and will be removed in 3.0. Instead, you should use the normal OpenLayers.Layer.MapServer class, passing it the option 'singleTile' as true.";OpenLayers.Console.warn(d)},clone:function(a){if(a==null){a=new OpenLayers.Layer.MapServer.Untiled(this.name,this.url,this.params,this.getOptions())}a=OpenLayers.Layer.MapServer.prototype.clone.apply(this,[a]);return a},CLASS_NAME:"OpenLayers.Layer.MapServer.Untiled"});OpenLayers.Layer.Zoomify=OpenLayers.Class(OpenLayers.Layer.Grid,{url:null,size:null,isBaseLayer:true,standardTileSize:256,tileOriginCorner:"tl",numberOfTiers:0,tileCountUpToTier:new Array(),tierSizeInTiles:new Array(),tierImageSize:new Array(),initialize:function(d,c,e,b){this.initializeZoomify(e);var a=[];a.push(d,c,e,{},b);OpenLayers.Layer.Grid.prototype.initialize.apply(this,a)},initializeZoomify:function(c){var d=c.clone();var a=new OpenLayers.Size(Math.ceil(d.w/this.standardTileSize),Math.ceil(d.h/this.standardTileSize));this.tierSizeInTiles.push(a);this.tierImageSize.push(d);while(d.w>this.standardTileSize||d.h>this.standardTileSize){d=new OpenLayers.Size(Math.floor(d.w/2),Math.floor(d.h/2));a=new OpenLayers.Size(Math.ceil(d.w/this.standardTileSize),Math.ceil(d.h/this.standardTileSize));this.tierSizeInTiles.push(a);this.tierImageSize.push(d)}this.tierSizeInTiles.reverse();this.tierImageSize.reverse();this.numberOfTiers=this.tierSizeInTiles.length;this.tileCountUpToTier[0]=0;for(var b=1;b<this.numberOfTiers;b++){this.tileCountUpToTier.push(this.tierSizeInTiles[b-1].w*this.tierSizeInTiles[b-1].h+this.tileCountUpToTier[b-1])}},destroy:function(){OpenLayers.Layer.Grid.prototype.destroy.apply(this,arguments);this.tileCountUpToTier.length=0;this.tierSizeInTiles.length=0;this.tierImageSize.length=0},clone:function(a){if(a==null){a=new OpenLayers.Layer.Zoomify(this.name,this.url,this.size,this.options)}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(d){d=this.adjustBounds(d);var c=this.map.getResolution();var a=Math.round((d.left-this.tileOrigin.lon)/(c*this.tileSize.w));var h=Math.round((this.tileOrigin.lat-d.top)/(c*this.tileSize.h));var g=this.map.getZoom();var f=a+h*this.tierSizeInTiles[g].w+this.tileCountUpToTier[g];var e="TileGroup"+Math.floor((f)/256)+"/"+g+"-"+a+"-"+h+".jpg";var b=this.url;if(OpenLayers.Util.isArray(b)){b=this.selectUrl(e,b)}return b+e},getImageSize:function(){if(arguments.length>0){var e=this.adjustBounds(arguments[0]);var c=this.map.getResolution();var a=Math.round((e.left-this.tileOrigin.lon)/(c*this.tileSize.w));var g=Math.round((this.tileOrigin.lat-e.top)/(c*this.tileSize.h));var f=this.map.getZoom();var b=this.standardTileSize;var d=this.standardTileSize;if(a==this.tierSizeInTiles[f].w-1){var b=this.tierImageSize[f].w%this.standardTileSize}if(g==this.tierSizeInTiles[f].h-1){var d=this.tierImageSize[f].h%this.standardTileSize}return(new OpenLayers.Size(b,d))}else{return this.tileSize}},setMap:function(a){OpenLayers.Layer.Grid.prototype.setMap.apply(this,arguments);this.tileOrigin=new OpenLayers.LonLat(this.map.maxExtent.left,this.map.maxExtent.top)},calculateGridLayout:function(a,n,e){var k=e*this.tileSize.w;var c=e*this.tileSize.h;var i=a.left-n.lon;var l=Math.floor(i/k)-this.buffer;var j=i/k-l;var f=-j*this.tileSize.w;var m=n.lon+l*k;var b=n.lat-a.top+c;var h=Math.floor(b/c)-this.buffer;var o=h-b/c;var d=o*this.tileSize.h;var g=n.lat-c*h;return{tilelon:k,tilelat:c,tileoffsetlon:m,tileoffsetlat:g,tileoffsetx:f,tileoffsety:d}},CLASS_NAME:"OpenLayers.Layer.Zoomify"});OpenLayers.Layer.WMTS=OpenLayers.Class(OpenLayers.Layer.Grid,{isBaseLayer:true,version:"1.0.0",requestEncoding:"KVP",url:null,layer:null,matrixSet:null,style:null,format:"image/jpeg",tileOrigin:null,tileFullExtent:null,formatSuffix:null,matrixIds:null,dimensions:null,params:null,zoomOffset:0,formatSuffixMap:{"image/png":"png","image/png8":"png","image/png24":"png","image/png32":"png",png:"png","image/jpeg":"jpg","image/jpg":"jpg",jpeg:"jpg",jpg:"jpg"},matrix:null,initialize:function(c){var f={url:true,layer:true,style:true,matrixSet:true};for(var g in f){if(!(g in c)){throw new Error("Missing property '"+g+"' in layer configuration.")}}c.params=OpenLayers.Util.upperCaseObject(c.params);var b=[c.name,c.url,c.params,c];OpenLayers.Layer.Grid.prototype.initialize.apply(this,b);if(!this.formatSuffix){this.formatSuffix=this.formatSuffixMap[this.format]||this.format.split("/").pop()}if(this.matrixIds){var a=this.matrixIds.length;if(a&&typeof this.matrixIds[0]==="string"){var e=this.matrixIds;this.matrixIds=new Array(a);for(var d=0;d<a;++d){this.matrixIds[d]={identifier:e[d]}}}}},setMap:function(){OpenLayers.Layer.Grid.prototype.setMap.apply(this,arguments);this.updateMatrixProperties()},updateMatrixProperties:function(){this.matrix=this.getMatrix();if(this.matrix){if(this.matrix.topLeftCorner){this.tileOrigin=this.matrix.topLeftCorner}if(this.matrix.tileWidth&&this.matrix.tileHeight){this.tileSize=new OpenLayers.Size(this.matrix.tileWidth,this.matrix.tileHeight)}if(!this.tileOrigin){this.tileOrigin=new OpenLayers.LonLat(this.maxExtent.left,this.maxExtent.top)}if(!this.tileFullExtent){this.tileFullExtent=this.maxExtent}}},moveTo:function(b,a,c){if(a||!this.matrix){this.updateMatrixProperties()}return OpenLayers.Layer.Grid.prototype.moveTo.apply(this,arguments)},clone:function(a){if(a==null){a=new OpenLayers.Layer.WMTS(this.options)}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getMatrix:function(){var b;if(!this.matrixIds||this.matrixIds.length===0){b={identifier:this.map.getZoom()+this.zoomOffset}}else{if("scaleDenominator" in this.matrixIds[0]){var a=OpenLayers.METERS_PER_INCH*OpenLayers.INCHES_PER_UNIT[this.units]*this.map.getResolution()/0.00028;var e=Number.POSITIVE_INFINITY;var f;for(var c=0,d=this.matrixIds.length;c<d;++c){f=Math.abs(1-(this.matrixIds[c].scaleDenominator/a));if(f<e){e=f;b=this.matrixIds[c]}}}else{b=this.matrixIds[this.map.getZoom()+this.zoomOffset]}}return b},getTileInfo:function(f){var b=this.map.getResolution();var d=(f.lon-this.tileOrigin.lon)/(b*this.tileSize.w);var c=(this.tileOrigin.lat-f.lat)/(b*this.tileSize.h);var a=Math.floor(d);var e=Math.floor(c);return{col:a,row:e,i:Math.floor((d-a)*this.tileSize.w),j:Math.floor((c-e)*this.tileSize.h)}},getURL:function(d){d=this.adjustBounds(d);var b="";if(!this.tileFullExtent||this.tileFullExtent.intersectsBounds(d)){var a=d.getCenterLonLat();var f=this.getTileInfo(a);var h=this.matrix.identifier;if(this.requestEncoding.toUpperCase()==="REST"){var e=this.version+"/"+this.layer+"/"+this.style+"/";if(this.dimensions){for(var c=0;c<this.dimensions.length;c++){if(this.params[this.dimensions[c]]){e=e+this.params[this.dimensions[c]]+"/"}}}e=e+this.matrixSet+"/"+this.matrix.identifier+"/"+f.row+"/"+f.col+"."+this.formatSuffix;if(OpenLayers.Util.isArray(this.url)){b=this.selectUrl(e,this.url)}else{b=this.url}if(!b.match(/\/$/)){b=b+"/"}b=b+e}else{if(this.requestEncoding.toUpperCase()==="KVP"){var g={SERVICE:"WMTS",REQUEST:"GetTile",VERSION:this.version,LAYER:this.layer,STYLE:this.style,TILEMATRIXSET:this.matrixSet,TILEMATRIX:this.matrix.identifier,TILEROW:f.row,TILECOL:f.col,FORMAT:this.format};b=OpenLayers.Layer.Grid.prototype.getFullRequestString.apply(this,[g])}}}return b},mergeNewParams:function(a){if(this.requestEncoding.toUpperCase()==="KVP"){return OpenLayers.Layer.Grid.prototype.mergeNewParams.apply(this,[OpenLayers.Util.upperCaseObject(a)])}},CLASS_NAME:"OpenLayers.Layer.WMTS"});OpenLayers.Format.CQL=(function(){var k=["PROPERTY","COMPARISON","VALUE","LOGICAL"],e={PROPERTY:/^[_a-zA-Z]\w*/,COMPARISON:/^(=|<>|<=|<|>=|>|LIKE)/i,COMMA:/^,/,LOGICAL:/^(AND|OR)/i,VALUE:/^('\w+'|\d+(\.\d*)?|\.\d+)/,LPAREN:/^\(/,RPAREN:/^\)/,SPATIAL:/^(BBOX|INTERSECTS|DWITHIN|WITHIN|CONTAINS)/i,NOT:/^NOT/i,BETWEEN:/^BETWEEN/i,GEOMETRY:function(r){var p=/^(POINT|LINESTRING|POLYGON|MULTIPOINT|MULTILINESTRING|MULTIPOLYGON|GEOMETRYCOLLECTION)/.exec(r);if(p){var o=r.length;var i=r.indexOf("(",p[0].length);if(i>-1){var q=1;while(i<o&&q>0){i++;switch(r.charAt(i)){case"(":q++;break;case")":q--;break;default:}}}return[r.substr(0,i+1)]}},END:/^$/},j={LPAREN:["GEOMETRY","SPATIAL","PROPERTY","VALUE","LPAREN"],RPAREN:["NOT","LOGICAL","END","RPAREN"],PROPERTY:["COMPARISON","BETWEEN","COMMA"],BETWEEN:["VALUE"],COMPARISON:["VALUE"],COMMA:["GEOMETRY","VALUE","PROPERTY"],VALUE:["LOGICAL","COMMA","RPAREN","END"],SPATIAL:["LPAREN"],LOGICAL:["NOT","VALUE","SPATIAL","PROPERTY","LPAREN"],NOT:["PROPERTY","LPAREN"],GEOMETRY:["COMMA","RPAREN"]},g={"=":OpenLayers.Filter.Comparison.EQUAL_TO,"<>":OpenLayers.Filter.Comparison.NOT_EQUAL_TO,"<":OpenLayers.Filter.Comparison.LESS_THAN,"<=":OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO,">":OpenLayers.Filter.Comparison.GREATER_THAN,">=":OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO,LIKE:OpenLayers.Filter.Comparison.LIKE,BETWEEN:OpenLayers.Filter.Comparison.BETWEEN},d={},n={AND:OpenLayers.Filter.Logical.AND,OR:OpenLayers.Filter.Logical.OR},b={},a={RPAREN:3,LOGICAL:2,COMPARISON:1};var h;for(h in g){if(g.hasOwnProperty(h)){d[g[h]]=h}}for(h in n){if(n.hasOwnProperty(h)){b[n[h]]=h}}function c(o,i){if(i instanceof RegExp){return i.exec(o)}else{return i(o)}}function f(x,v){var q,p,u=v.length;for(q=0;q<u;q++){p=v[q];var t=e[p];var r=c(x,t);if(r){var s=r[0];var w=x.substr(s.length).replace(/^\s*/,"");return{type:p,text:s,remainder:w}}}var o="ERROR: In parsing: ["+x+"], expected one of: ";for(q=0;q<u;q++){p=v[q];o+="\n    "+p+": "+e[p]}throw new Error(o)}function m(q){var o=[];var i,p=["NOT","GEOMETRY","SPATIAL","PROPERTY","LPAREN"];do{i=f(q,p);q=i.remainder;p=j[i.type];if(i.type!="END"&&!p){throw new Error("No follows list for "+i.type)}o.push(i)}while(i.type!="END");return o}function l(u){var t=[],v=[];while(u.length){var w=u.shift();switch(w.type){case"PROPERTY":case"GEOMETRY":case"VALUE":v.push(w);break;case"COMPARISON":case"BETWEEN":case"LOGICAL":var o=a[w.type];while(t.length>0&&(a[t[t.length-1].type]<=o)){v.push(t.pop())}t.push(w);break;case"SPATIAL":case"NOT":case"LPAREN":t.push(w);break;case"RPAREN":while(t.length>0&&(t[t.length-1].type!="LPAREN")){v.push(t.pop())}t.pop();if(t.length>0&&t[t.length-1].type=="SPATIAL"){v.push(t.pop())}case"COMMA":case"END":break;default:throw new Error("Unknown token type "+w.type)}}while(t.length>0){v.push(t.pop())}function q(){var J=v.pop();switch(J.type){case"LOGICAL":var B=q(),y=q();return new OpenLayers.Filter.Logical({filters:[y,B],type:n[J.text.toUpperCase()]});case"NOT":var A=q();return new OpenLayers.Filter.Logical({filters:[A],type:OpenLayers.Filter.Logical.NOT});case"BETWEEN":var z,E,H;v.pop();E=q();z=q();H=q();return new OpenLayers.Filter.Comparison({property:H,lowerBoundary:z,upperBoundary:E,type:OpenLayers.Filter.Comparison.BETWEEN});case"COMPARISON":var F=q(),H=q();return new OpenLayers.Filter.Comparison({property:H,value:F,type:g[J.text.toUpperCase()]});case"VALUE":if((/^'.*'$/).test(J.text)){return J.text.substr(1,J.text.length-2)}else{return Number(J.text)}case"SPATIAL":switch(J.text.toUpperCase()){case"BBOX":var C=q(),D=q(),G=q(),I=q(),p=q();return new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.BBOX,property:p,value:OpenLayers.Bounds.fromArray([I,G,D,C])});case"INTERSECTS":var F=q(),H=q();return new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.INTERSECTS,property:H,value:F});case"WITHIN":var F=q(),H=q();return new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.WITHIN,property:H,value:F});case"CONTAINS":var F=q(),H=q();return new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.CONTAINS,property:H,value:F});case"DWITHIN":var i=q(),F=q(),H=q();return new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.DWITHIN,value:F,property:H,distance:Number(i)})}case"GEOMETRY":return OpenLayers.Geometry.fromWKT(J.text);default:return J.text}}var x=q();if(v.length>0){var r="Remaining tokens after building AST: \n";for(var s=v.length-1;s>=0;s--){r+=v[s].type+": "+v[s].text+"\n"}throw new Error(r)}return x}return OpenLayers.Class(OpenLayers.Format,{read:function(o){var i=l(m(o));if(this.keepData){this.data=i}return i},write:function(q){if(q instanceof OpenLayers.Geometry){return q.toString()}switch(q.CLASS_NAME){case"OpenLayers.Filter.Spatial":switch(q.type){case OpenLayers.Filter.Spatial.BBOX:return"BBOX("+q.property+","+q.value.toBBOX()+")";case OpenLayers.Filter.Spatial.DWITHIN:return"DWITHIN("+q.property+", "+this.write(q.value)+", "+q.distance+")";case OpenLayers.Filter.Spatial.WITHIN:return"WITHIN("+q.property+", "+this.write(q.value)+")";case OpenLayers.Filter.Spatial.INTERSECTS:return"INTERSECTS("+q.property+", "+this.write(q.value)+")";case OpenLayers.Filter.Spatial.CONTAINS:return"CONTAINS("+q.property+", "+this.write(q.value)+")";default:throw new Error("Unknown spatial filter type: "+q.type)}case"OpenLayers.Filter.Logical":if(q.type==OpenLayers.Filter.Logical.NOT){return"NOT ("+this.write(q.filters[0])+")"}else{var p="(";var r=true;for(var o=0;o<q.filters.length;o++){if(r){r=false}else{p+=") "+b[q.type]+" ("}p+=this.write(q.filters[o])}return p+")"}case"OpenLayers.Filter.Comparison":if(q.type==OpenLayers.Filter.Comparison.BETWEEN){return q.property+" BETWEEN "+this.write(q.lowerBoundary)+" AND "+this.write(q.upperBoundary)}else{return q.property+" "+d[q.type]+" "+this.write(q.value)}case undefined:if(typeof q==="string"){return"'"+q+"'"}else{if(typeof q==="number"){return String(q)}}default:throw new Error("Can't encode: "+q.CLASS_NAME+" "+q)}},CLASS_NAME:"OpenLayers.Format.CQL"})})();OpenLayers.Renderer.VML=OpenLayers.Class(OpenLayers.Renderer.Elements,{xmlns:"urn:schemas-microsoft-com:vml",symbolCache:{},offset:null,initialize:function(b){if(!this.supported()){return}if(!document.namespaces.olv){document.namespaces.add("olv",this.xmlns);var e=document.createStyleSheet();var c=["shape","rect","oval","fill","stroke","imagedata","group","textbox"];for(var d=0,a=c.length;d<a;d++){e.addRule("olv\\:"+c[d],"behavior: url(#default#VML); position: absolute; display: inline-block;")}}OpenLayers.Renderer.Elements.prototype.initialize.apply(this,arguments)},supported:function(){return !!(document.namespaces)},setExtent:function(j,a){OpenLayers.Renderer.Elements.prototype.setExtent.apply(this,arguments);var c=this.getResolution();var b=(j.left/c)|0;var f=(j.top/c-this.size.h)|0;if(a||!this.offset){this.offset={x:b,y:f};b=0;f=0}else{b=b-this.offset.x;f=f-this.offset.y}var l=b+" "+f;this.root.coordorigin=l;var h=[this.root,this.vectorRoot,this.textRoot];var g;for(var d=0,e=h.length;d<e;++d){g=h[d];var k=this.size.w+" "+this.size.h;g.coordsize=k}this.root.style.flip="y";return true},setSize:function(f){OpenLayers.Renderer.prototype.setSize.apply(this,arguments);var d=[this.rendererRoot,this.root,this.vectorRoot,this.textRoot];var c=this.size.w+"px";var g=this.size.h+"px";var b;for(var e=0,a=d.length;e<a;++e){b=d[e];b.style.width=c;b.style.height=g}},getNodeType:function(c,b){var a=null;switch(c.CLASS_NAME){case"OpenLayers.Geometry.Point":if(b.externalGraphic){a="olv:rect"}else{if(this.isComplexSymbol(b.graphicName)){a="olv:shape"}else{a="olv:oval"}}break;case"OpenLayers.Geometry.Rectangle":a="olv:rect";break;case"OpenLayers.Geometry.LineString":case"OpenLayers.Geometry.LinearRing":case"OpenLayers.Geometry.Polygon":case"OpenLayers.Geometry.Curve":case"OpenLayers.Geometry.Surface":a="olv:shape";break;default:break}return a},setStyle:function(e,b,q,k){b=b||e._style;q=q||e._options;var c=b.fillColor;if(e._geometryClass==="OpenLayers.Geometry.Point"){if(b.externalGraphic){q.isFilled=true;if(b.graphicTitle){e.title=b.graphicTitle}var d=b.graphicWidth||b.graphicHeight;var l=b.graphicHeight||b.graphicWidth;d=d?d:b.pointRadius*2;l=l?l:b.pointRadius*2;var g=this.getResolution();var i=(b.graphicXOffset!=undefined)?b.graphicXOffset:-(0.5*d);var f=(b.graphicYOffset!=undefined)?b.graphicYOffset:-(0.5*l);e.style.left=(((k.x/g-this.offset.x)+i)|0)+"px";e.style.top=(((k.y/g-this.offset.y)-(f+l))|0)+"px";e.style.width=d+"px";e.style.height=l+"px";e.style.flip="y";c="none";q.isStroked=false}else{if(this.isComplexSymbol(b.graphicName)){var a=this.importSymbol(b.graphicName);e.path=a.path;e.coordorigin=a.left+","+a.bottom;var p=a.size;e.coordsize=p+","+p;this.drawCircle(e,k,b.pointRadius);e.style.flip="y"}else{this.drawCircle(e,k,b.pointRadius)}}}if(q.isFilled){e.fillcolor=c}else{e.filled="false"}var j=e.getElementsByTagName("fill");var o=(j.length==0)?null:j[0];if(!q.isFilled){if(o){e.removeChild(o)}}else{if(!o){o=this.createNode("olv:fill",e.id+"_fill")}o.opacity=b.fillOpacity;if(e._geometryClass==="OpenLayers.Geometry.Point"&&b.externalGraphic){if(b.graphicOpacity){o.opacity=b.graphicOpacity}o.src=b.externalGraphic;o.type="frame";if(!(b.graphicWidth&&b.graphicHeight)){o.aspect="atmost"}}if(o.parentNode!=e){e.appendChild(o)}}var n=b.rotation;if((n!==undefined||e._rotation!==undefined)){e._rotation=n;if(b.externalGraphic){this.graphicRotate(e,i,f,b);o.opacity=0}else{if(e._geometryClass==="OpenLayers.Geometry.Point"){e.style.rotation=n||0}}}var h=e.getElementsByTagName("stroke");var m=(h.length==0)?null:h[0];if(!q.isStroked){e.stroked=false;if(m){m.on=false}}else{if(!m){m=this.createNode("olv:stroke",e.id+"_stroke");e.appendChild(m)}m.on=true;m.color=b.strokeColor;m.weight=b.strokeWidth+"px";m.opacity=b.strokeOpacity;m.endcap=b.strokeLinecap=="butt"?"flat":(b.strokeLinecap||"round");if(b.strokeDashstyle){m.dashstyle=this.dashStyle(b)}}if(b.cursor!="inherit"&&b.cursor!=null){e.style.cursor=b.cursor}return e},graphicRotate:function(n,r,e,q){var q=q||n._style;var o=q.rotation||0;var a,j;if(!(q.graphicWidth&&q.graphicHeight)){var s=new Image();s.onreadystatechange=OpenLayers.Function.bind(function(){if(s.readyState=="complete"||s.readyState=="interactive"){a=s.width/s.height;j=Math.max(q.pointRadius*2,q.graphicWidth||0,q.graphicHeight||0);r=r*a;q.graphicWidth=j*a;q.graphicHeight=j;this.graphicRotate(n,r,e,q)}},this);s.src=q.externalGraphic;return}else{j=Math.max(q.graphicWidth,q.graphicHeight);a=q.graphicWidth/q.graphicHeight}var m=Math.round(q.graphicWidth||j*a);var k=Math.round(q.graphicHeight||j);n.style.width=m+"px";n.style.height=k+"px";var l=document.getElementById(n.id+"_image");if(!l){l=this.createNode("olv:imagedata",n.id+"_image");n.appendChild(l)}l.style.width=m+"px";l.style.height=k+"px";l.src=q.externalGraphic;l.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='', sizingMethod='scale')";var f=o*Math.PI/180;var h=Math.sin(f);var d=Math.cos(f);var g="progid:DXImageTransform.Microsoft.Matrix(M11="+d+",M12="+(-h)+",M21="+h+",M22="+d+",SizingMethod='auto expand')\n";var b=q.graphicOpacity||q.fillOpacity;if(b&&b!=1){g+="progid:DXImageTransform.Microsoft.BasicImage(opacity="+b+")\n"}n.style.filter=g;var p=new OpenLayers.Geometry.Point(-r,-e);var c=new OpenLayers.Bounds(0,0,m,k).toGeometry();c.rotate(q.rotation,p);var i=c.getBounds();n.style.left=Math.round(parseInt(n.style.left)+i.left)+"px";n.style.top=Math.round(parseInt(n.style.top)-i.bottom)+"px"},postDraw:function(a){a.style.visibility="visible";var c=a._style.fillColor;var b=a._style.strokeColor;if(c=="none"&&a.fillcolor!=c){a.fillcolor=c}if(b=="none"&&a.strokecolor!=b){a.strokecolor=b}},setNodeDimension:function(b,e){var d=e.getBounds();if(d){var a=this.getResolution();var c=new OpenLayers.Bounds((d.left/a-this.offset.x)|0,(d.bottom/a-this.offset.y)|0,(d.right/a-this.offset.x)|0,(d.top/a-this.offset.y)|0);b.style.left=c.left+"px";b.style.top=c.top+"px";b.style.width=c.getWidth()+"px";b.style.height=c.getHeight()+"px";b.coordorigin=c.left+" "+c.top;b.coordsize=c.getWidth()+" "+c.getHeight()}},dashStyle:function(a){var c=a.strokeDashstyle;switch(c){case"solid":case"dot":case"dash":case"dashdot":case"longdash":case"longdashdot":return c;default:var b=c.split(/[ ,]/);if(b.length==2){if(1*b[0]>=2*b[1]){return"longdash"}return(b[0]==1||b[1]==1)?"dot":"dash"}else{if(b.length==4){return(1*b[0]>=2*b[1])?"longdashdot":"dashdot"}}return"solid"}},createNode:function(a,c){var b=document.createElement(a);if(c){b.id=c}b.unselectable="on";b.onselectstart=OpenLayers.Function.False;return b},nodeTypeCompare:function(c,b){var d=b;var a=d.indexOf(":");if(a!=-1){d=d.substr(a+1)}var e=c.nodeName;a=e.indexOf(":");if(a!=-1){e=e.substr(a+1)}return(d==e)},createRenderRoot:function(){return this.nodeFactory(this.container.id+"_vmlRoot","div")},createRoot:function(a){return this.nodeFactory(this.container.id+a,"olv:group")},drawPoint:function(a,b){return this.drawCircle(a,b,1)},drawCircle:function(d,e,a){if(!isNaN(e.x)&&!isNaN(e.y)){var b=this.getResolution();d.style.left=(((e.x/b-this.offset.x)|0)-a)+"px";d.style.top=(((e.y/b-this.offset.y)|0)-a)+"px";var c=a*2;d.style.width=c+"px";d.style.height=c+"px";return d}return false},drawLineString:function(a,b){return this.drawLine(a,b,false)},drawLinearRing:function(a,b){return this.drawLine(a,b,true)},drawLine:function(b,k,g){this.setNodeDimension(b,k);var c=this.getResolution();var a=k.components.length;var e=new Array(a);var h,l,j;for(var f=0;f<a;f++){h=k.components[f];l=(h.x/c-this.offset.x)|0;j=(h.y/c-this.offset.y)|0;e[f]=" "+l+","+j+" l "}var d=(g)?" x e":" e";b.path="m"+e.join("")+d;return b},drawPolygon:function(c,m){this.setNodeDimension(c,m);var d=this.getResolution();var r=[];var e,k,o,a,g,b,f,q,h,p,n,l;for(e=0,k=m.components.length;e<k;e++){r.push("m");o=m.components[e].components;a=(e===0);g=null;b=null;for(f=0,q=o.length;f<q;f++){h=o[f];n=(h.x/d-this.offset.x)|0;l=(h.y/d-this.offset.y)|0;p=" "+n+","+l;r.push(p);if(f==0){r.push(" l")}if(!a){if(!g){g=p}else{if(g!=p){if(!b){b=p}else{if(b!=p){a=true}}}}}}r.push(a?" x ":" ")}r.push("e");c.path=r.join("");return c},drawRectangle:function(b,c){var a=this.getResolution();b.style.left=((c.x/a-this.offset.x)|0)+"px";b.style.top=((c.y/a-this.offset.y)|0)+"px";b.style.width=((c.width/a)|0)+"px";b.style.height=((c.height/a)|0)+"px";return b},drawText:function(d,a,h){var g=this.nodeFactory(d+this.LABEL_ID_SUFFIX,"olv:rect");var f=this.nodeFactory(d+this.LABEL_ID_SUFFIX+"_textbox","olv:textbox");var c=this.getResolution();g.style.left=((h.x/c-this.offset.x)|0)+"px";g.style.top=((h.y/c-this.offset.y)|0)+"px";g.style.flip="y";f.innerText=a.label;if(a.cursor!="inherit"&&a.cursor!=null){f.style.cursor=a.cursor}if(a.fontColor){f.style.color=a.fontColor}if(a.fontOpacity){f.style.filter="alpha(opacity="+(a.fontOpacity*100)+")"}if(a.fontFamily){f.style.fontFamily=a.fontFamily}if(a.fontSize){f.style.fontSize=a.fontSize}if(a.fontWeight){f.style.fontWeight=a.fontWeight}if(a.fontStyle){f.style.fontStyle=a.fontStyle}if(a.labelSelect===true){g._featureId=d;f._featureId=d;f._geometry=h;f._geometryClass=h.CLASS_NAME}f.style.whiteSpace="nowrap";f.inset="1px,0px,0px,0px";if(!g.parentNode){g.appendChild(f);this.textRoot.appendChild(g)}var e=a.labelAlign||"cm";if(e.length==1){e+="m"}var i=f.clientWidth*(OpenLayers.Renderer.VML.LABEL_SHIFT[e.substr(0,1)]);var b=f.clientHeight*(OpenLayers.Renderer.VML.LABEL_SHIFT[e.substr(1,1)]);g.style.left=parseInt(g.style.left)-i-1+"px";g.style.top=parseInt(g.style.top)+b+"px"},drawSurface:function(a,g){this.setNodeDimension(a,g);var b=this.getResolution();var j=[];var d,h,f;for(var c=0,e=g.components.length;c<e;c++){d=g.components[c];h=(d.x/b-this.offset.x)|0;f=(d.y/b-this.offset.y)|0;if((c%3)==0&&(c/3)==0){j.push("m")}else{if((c%3)==1){j.push(" c")}}j.push(" "+h+","+f)}j.push(" x e");a.path=j.join("");return a},moveRoot:function(b){var a=this.map.getLayer(b.container.id);if(a instanceof OpenLayers.Layer.Vector.RootContainer){a=this.map.getLayer(this.container.id)}a&&a.renderer.clear();OpenLayers.Renderer.Elements.prototype.moveRoot.apply(this,arguments);a&&a.redraw()},importSymbol:function(d){var b=this.container.id+"-"+d;var a=this.symbolCache[b];if(a){return a}var c=OpenLayers.Renderer.symbol[d];if(!c){throw new Error(d+" is not a valid symbol name")}var k=new OpenLayers.Bounds(Number.MAX_VALUE,Number.MAX_VALUE,0,0);var e=["m"];for(var f=0;f<c.length;f=f+2){var h=c[f];var g=c[f+1];k.left=Math.min(k.left,h);k.bottom=Math.min(k.bottom,g);k.right=Math.max(k.right,h);k.top=Math.max(k.top,g);e.push(h);e.push(g);if(f==0){e.push("l")}}e.push("x e");var l=e.join(" ");var j=(k.getWidth()-k.getHeight())/2;if(j>0){k.bottom=k.bottom-j;k.top=k.top+j}else{k.left=k.left+j;k.right=k.right-j}a={path:l,size:k.getWidth(),left:k.left,bottom:k.bottom};this.symbolCache[b]=a;return a},CLASS_NAME:"OpenLayers.Renderer.VML"});OpenLayers.Renderer.VML.LABEL_SHIFT={l:0,c:0.5,r:1,t:0,m:0.5,b:1};OpenLayers.Layer.MultiMap=OpenLayers.Class(OpenLayers.Layer.EventPane,OpenLayers.Layer.FixedZoomLevels,{MIN_ZOOM_LEVEL:1,MAX_ZOOM_LEVEL:17,RESOLUTIONS:[9,1.40625,0.703125,0.3515625,0.17578125,0.087890625,0.0439453125,0.02197265625,0.010986328125,0.0054931640625,0.00274658203125,0.001373291015625,0.0006866455078125,0.00034332275390625,0.000171661376953125,0.0000858306884765625,0.00004291534423828125],type:null,initialize:function(b,a){OpenLayers.Layer.EventPane.prototype.initialize.apply(this,arguments);OpenLayers.Layer.FixedZoomLevels.prototype.initialize.apply(this,arguments);if(this.sphericalMercator){OpenLayers.Util.extend(this,OpenLayers.Layer.SphericalMercator);this.initMercatorParameters();this.RESOLUTIONS.unshift(10)}},loadMapObject:function(){try{this.mapObject=new MultimapViewer(this.div)}catch(a){}},getWarningHTML:function(){return OpenLayers.i18n("getLayerWarning",{layerType:"MM",layerLib:"MultiMap"})},setMapObjectCenter:function(a,b){this.mapObject.goToPosition(a,b)},getMapObjectCenter:function(){return this.mapObject.getCurrentPosition()},getMapObjectZoom:function(){return this.mapObject.getZoomFactor()},getMapObjectLonLatFromMapObjectPixel:function(a){a.x=a.x-(this.map.getSize().w/2);a.y=a.y-(this.map.getSize().h/2);return this.mapObject.getMapPositionAt(a)},getMapObjectPixelFromMapObjectLonLat:function(a){return this.mapObject.geoPosToContainerPixels(a)},getLongitudeFromMapObjectLonLat:function(a){return this.sphericalMercator?this.forwardMercator(a.lon,a.lat).lon:a.lon},getLatitudeFromMapObjectLonLat:function(a){return this.sphericalMercator?this.forwardMercator(a.lon,a.lat).lat:a.lat},getMapObjectLonLatFromLonLat:function(d,c){var a;if(this.sphericalMercator){var b=this.inverseMercator(d,c);a=new MMLatLon(b.lat,b.lon)}else{a=new MMLatLon(c,d)}return a},getXFromMapObjectPixel:function(a){return a.x},getYFromMapObjectPixel:function(a){return a.y},getMapObjectPixelFromXY:function(a,b){return new MMPoint(a,b)},CLASS_NAME:"OpenLayers.Layer.MultiMap"});OpenLayers.Control.MouseToolbar=OpenLayers.Class(OpenLayers.Control.MouseDefaults,{mode:null,buttons:null,direction:"vertical",buttonClicked:null,initialize:function(a,b){OpenLayers.Control.prototype.initialize.apply(this,arguments);this.position=new OpenLayers.Pixel(OpenLayers.Control.MouseToolbar.X,OpenLayers.Control.MouseToolbar.Y);if(a){this.position=a}if(b){this.direction=b}this.measureDivs=[]},destroy:function(){for(var b in this.buttons){var a=this.buttons[b];a.map=null;a.events.destroy()}OpenLayers.Control.MouseDefaults.prototype.destroy.apply(this,arguments)},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);OpenLayers.Control.MouseDefaults.prototype.draw.apply(this,arguments);this.buttons={};var b=new OpenLayers.Size(28,28);var a=new OpenLayers.Pixel(OpenLayers.Control.MouseToolbar.X,0);this._addButton("zoombox","drag-rectangle-off.png","drag-rectangle-on.png",a,b,"Shift->Drag to zoom to area");a=a.add((this.direction=="vertical"?0:b.w),(this.direction=="vertical"?b.h:0));this._addButton("pan","panning-hand-off.png","panning-hand-on.png",a,b,"Drag the map to pan.");a=a.add((this.direction=="vertical"?0:b.w),(this.direction=="vertical"?b.h:0));this.switchModeTo("pan");return this.div},_addButton:function(a,e,d,i,g,h){var f=OpenLayers.Util.getImagesLocation()+e;var c=OpenLayers.Util.getImagesLocation()+d;var b=OpenLayers.Util.createAlphaImageDiv("OpenLayers_Control_MouseToolbar_"+a,i,g,f,"absolute");this.div.appendChild(b);b.imgLocation=f;b.activeImgLocation=c;b.events=new OpenLayers.Events(this,b,null,true);b.events.on({mousedown:this.buttonDown,mouseup:this.buttonUp,dblclick:OpenLayers.Event.stop,scope:this});b.action=a;b.title=h;b.alt=h;b.map=this.map;this.buttons[a]=b;return b},buttonDown:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}this.buttonClicked=a.element.action;OpenLayers.Event.stop(a)},buttonUp:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}if(this.buttonClicked!=null){if(this.buttonClicked==a.element.action){this.switchModeTo(a.element.action)}OpenLayers.Event.stop(a);this.buttonClicked=null}},defaultDblClick:function(b){this.switchModeTo("pan");this.performedDrag=false;var a=this.map.getLonLatFromViewPortPx(b.xy);this.map.setCenter(a,this.map.zoom+1);OpenLayers.Event.stop(b);return false},defaultMouseDown:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}this.mouseDragStart=a.xy.clone();this.performedDrag=false;this.startViaKeyboard=false;if(a.shiftKey&&this.mode!="zoombox"){this.switchModeTo("zoombox");this.startViaKeyboard=true}else{if(a.altKey&&this.mode!="measure"){this.switchModeTo("measure")}else{if(!this.mode){this.switchModeTo("pan")}}}switch(this.mode){case"zoombox":this.map.div.style.cursor="crosshair";this.zoomBox=OpenLayers.Util.createDiv("zoomBox",this.mouseDragStart,null,null,"absolute","2px solid red");this.zoomBox.style.backgroundColor="white";this.zoomBox.style.filter="alpha(opacity=50)";this.zoomBox.style.opacity="0.50";this.zoomBox.style.fontSize="1px";this.zoomBox.style.zIndex=this.map.Z_INDEX_BASE.Popup-1;this.map.eventsDiv.appendChild(this.zoomBox);this.performedDrag=true;break;case"measure":var c="";if(this.measureStart){var b=this.map.getLonLatFromViewPortPx(this.mouseDragStart);c=OpenLayers.Util.distVincenty(this.measureStart,b);c=Math.round(c*100)/100;c=c+"km";this.measureStartBox=this.measureBox}this.measureStart=this.map.getLonLatFromViewPortPx(this.mouseDragStart);this.measureBox=OpenLayers.Util.createDiv(null,this.mouseDragStart.add(-2-parseInt(this.map.layerContainerDiv.style.left),-2-parseInt(this.map.layerContainerDiv.style.top)),null,null,"absolute");this.measureBox.style.width="4px";this.measureBox.style.height="4px";this.measureBox.style.fontSize="1px";this.measureBox.style.backgroundColor="red";this.measureBox.style.zIndex=this.map.Z_INDEX_BASE.Popup-1;this.map.layerContainerDiv.appendChild(this.measureBox);if(c){this.measureBoxDistance=OpenLayers.Util.createDiv(null,this.mouseDragStart.add(-2-parseInt(this.map.layerContainerDiv.style.left),2-parseInt(this.map.layerContainerDiv.style.top)),null,null,"absolute");this.measureBoxDistance.innerHTML=c;this.measureBoxDistance.style.zIndex=this.map.Z_INDEX_BASE.Popup-1;this.map.layerContainerDiv.appendChild(this.measureBoxDistance);this.measureDivs.push(this.measureBoxDistance)}this.measureBox.style.zIndex=this.map.Z_INDEX_BASE.Popup-1;this.map.layerContainerDiv.appendChild(this.measureBox);this.measureDivs.push(this.measureBox);break;default:this.map.div.style.cursor="move";break}document.onselectstart=OpenLayers.Function.False;OpenLayers.Event.stop(a)},switchModeTo:function(c){if(c!=this.mode){if(this.mode&&this.buttons[this.mode]){OpenLayers.Util.modifyAlphaImageDiv(this.buttons[this.mode],null,null,null,this.buttons[this.mode].imgLocation)}if(this.mode=="measure"&&c!="measure"){for(var b=0,a=this.measureDivs.length;b<a;b++){if(this.measureDivs[b]){this.map.layerContainerDiv.removeChild(this.measureDivs[b])}}this.measureDivs=[];this.measureStart=null}this.mode=c;if(this.buttons[c]){OpenLayers.Util.modifyAlphaImageDiv(this.buttons[c],null,null,null,this.buttons[c].activeImgLocation)}switch(this.mode){case"zoombox":this.map.div.style.cursor="crosshair";break;default:this.map.div.style.cursor="";break}}},leaveMode:function(){this.switchModeTo("pan")},defaultMouseMove:function(e){if(this.mouseDragStart!=null){switch(this.mode){case"zoombox":var d=Math.abs(this.mouseDragStart.x-e.xy.x);var b=Math.abs(this.mouseDragStart.y-e.xy.y);this.zoomBox.style.width=Math.max(1,d)+"px";this.zoomBox.style.height=Math.max(1,b)+"px";if(e.xy.x<this.mouseDragStart.x){this.zoomBox.style.left=e.xy.x+"px"}if(e.xy.y<this.mouseDragStart.y){this.zoomBox.style.top=e.xy.y+"px"}break;default:var d=this.mouseDragStart.x-e.xy.x;var b=this.mouseDragStart.y-e.xy.y;var f=this.map.getSize();var a=new OpenLayers.Pixel(f.w/2+d,f.h/2+b);var c=this.map.getLonLatFromViewPortPx(a);this.map.setCenter(c,null,true);this.mouseDragStart=e.xy.clone()}this.performedDrag=true}},defaultMouseUp:function(a){if(!OpenLayers.Event.isLeftClick(a)){return}switch(this.mode){case"zoombox":this.zoomBoxEnd(a);if(this.startViaKeyboard){this.leaveMode()}break;case"pan":if(this.performedDrag){this.map.setCenter(this.map.center)}}document.onselectstart=null;this.mouseDragStart=null;this.map.div.style.cursor="default"},defaultMouseOut:function(a){if(this.mouseDragStart!=null&&OpenLayers.Util.mouseLeft(a,this.map.eventsDiv)){if(this.zoomBox){this.removeZoomBox();if(this.startViaKeyboard){this.leaveMode()}}this.mouseDragStart=null;this.map.div.style.cursor="default"}},defaultClick:function(a){if(this.performedDrag){this.performedDrag=false;return false}},CLASS_NAME:"OpenLayers.Control.MouseToolbar"});OpenLayers.Control.MouseToolbar.X=6;OpenLayers.Control.MouseToolbar.Y=300;OpenLayers.Protocol.WFS.v1_0_0=OpenLayers.Class(OpenLayers.Protocol.WFS.v1,{version:"1.0.0",CLASS_NAME:"OpenLayers.Protocol.WFS.v1_0_0"});OpenLayers.Control.WMTSGetFeatureInfo=OpenLayers.Class(OpenLayers.Control,{hover:false,requestEncoding:"KVP",drillDown:false,maxFeatures:10,clickCallback:"click",layers:null,queryVisible:true,infoFormat:"text/html",vendorParams:{},format:null,formatOptions:null,handlerOptions:null,handler:null,hoverRequest:null,EVENT_TYPES:["beforegetfeatureinfo","getfeatureinfo","exception"],pending:0,initialize:function(a){this.EVENT_TYPES=OpenLayers.Control.WMTSGetFeatureInfo.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);a=a||{};a.handlerOptions=a.handlerOptions||{};OpenLayers.Control.prototype.initialize.apply(this,[a]);if(!this.format){this.format=new OpenLayers.Format.WMSGetFeatureInfo(a.formatOptions)}if(this.drillDown===true){this.hover=false}if(this.hover){this.handler=new OpenLayers.Handler.Hover(this,{move:this.cancelHover,pause:this.getInfoForHover},OpenLayers.Util.extend(this.handlerOptions.hover||{},{delay:250}))}else{var b={};b[this.clickCallback]=this.getInfoForClick;this.handler=new OpenLayers.Handler.Click(this,b,this.handlerOptions.click||{})}},getInfoForClick:function(a){this.request(a.xy,{})},getInfoForHover:function(a){this.request(a.xy,{hover:true})},cancelHover:function(){if(this.hoverRequest){--this.pending;if(this.pending<=0){OpenLayers.Element.removeClass(this.map.viewPortDiv,"olCursorWait");this.pending=0}this.hoverRequest.abort();this.hoverRequest=null}},findLayers:function(){var c=this.layers||this.map.layers;var d=[];var b;for(var a=c.length-1;a>=0;--a){b=c[a];if(b instanceof OpenLayers.Layer.WMTS&&b.requestEncoding===this.requestEncoding&&(!this.queryVisible||b.getVisibility())){d.push(b);if(!this.drillDown||this.hover){break}}}return d},buildRequestOptions:function(b,c){var f=this.map.getLonLatFromPixel(c);var e=b.getURL(new OpenLayers.Bounds(f.lon,f.lat,f.lon,f.lat));var d=OpenLayers.Util.getParameters(e);var a=b.getTileInfo(f);OpenLayers.Util.extend(d,{service:"WMTS",version:b.version,request:"GetFeatureInfo",infoFormat:this.infoFormat,i:a.i,j:a.j});OpenLayers.Util.applyDefaults(d,this.vendorParams);return{url:OpenLayers.Util.isArray(b.url)?b.url[0]:b.url,params:OpenLayers.Util.upperCaseObject(d),callback:function(g){this.handleResponse(c,g,b)},scope:this}},request:function(h,j){j=j||{};var c=this.findLayers();if(c.length>0){var g,e;for(var d=0,f=c.length;d<f;d++){e=c[d];g=this.events.triggerEvent("beforegetfeatureinfo",{xy:h,layer:e});if(g!==false){++this.pending;var a=this.buildRequestOptions(e,h);var b=OpenLayers.Request.GET(a);if(j.hover===true){this.hoverRequest=b}}}if(this.pending>0){OpenLayers.Element.addClass(this.map.viewPortDiv,"olCursorWait")}}},handleResponse:function(g,e,b){--this.pending;if(this.pending<=0){OpenLayers.Element.removeClass(this.map.viewPortDiv,"olCursorWait");this.pending=0}if(e.status&&(e.status<200||e.status>=300)){this.events.triggerEvent("exception",{xy:g,request:e,layer:b})}else{var f=e.responseXML;if(!f||!f.documentElement){f=e.responseText}var d,c;try{d=this.format.read(f)}catch(a){c=true;this.events.triggerEvent("exception",{xy:g,request:e,error:a,layer:b})}if(!c){this.events.triggerEvent("getfeatureinfo",{text:e.responseText,features:d,request:e,xy:g,layer:b})}}},CLASS_NAME:"OpenLayers.Control.WMTSGetFeatureInfo"});OpenLayers.Control.SLDSelect=OpenLayers.Class(OpenLayers.Control,{EVENT_TYPES:["selected"],clearOnDeactivate:false,layers:null,callbacks:null,selectionSymbolizer:{Polygon:{fillColor:"#FF0000",stroke:false},Line:{strokeColor:"#FF0000",strokeWidth:2},Point:{graphicName:"square",fillColor:"#FF0000",pointRadius:5}},layerOptions:null,handlerOptions:null,sketchStyle:null,wfsCache:{},layerCache:{},initialize:function(b,a){this.EVENT_TYPES=OpenLayers.Control.SLDSelect.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);OpenLayers.Control.prototype.initialize.apply(this,[a]);this.callbacks=OpenLayers.Util.extend({done:this.select,click:this.select},this.callbacks);this.handlerOptions=this.handlerOptions||{};this.layerOptions=OpenLayers.Util.applyDefaults(this.layerOptions,{displayInLayerSwitcher:false,tileOptions:{maxGetUrlLength:2048}});if(this.sketchStyle){this.handlerOptions.layerOptions=OpenLayers.Util.applyDefaults(this.handlerOptions.layerOptions,{styleMap:new OpenLayers.StyleMap({"default":this.sketchStyle})})}this.handler=new b(this,this.callbacks,this.handlerOptions)},destroy:function(){for(var a in this.layerCache){delete this.layerCache[a]}for(var a in this.wfsCache){delete this.wfsCache[a]}OpenLayers.Control.prototype.destroy.apply(this,arguments)},coupleLayerVisiblity:function(a){this.setVisibility(a.object.getVisibility())},createSelectionLayer:function(b){var a;if(!this.layerCache[b.id]){a=new OpenLayers.Layer.WMS(b.name,b.url,b.params,OpenLayers.Util.applyDefaults(this.layerOptions,b.getOptions()));this.layerCache[b.id]=a;if(this.layerOptions.displayInLayerSwitcher===false){b.events.on({visibilitychanged:this.coupleLayerVisiblity,scope:a})}this.map.addLayer(a)}else{a=this.layerCache[b.id]}return a},createSLD:function(f,d,g){var a={version:"1.0.0",namedLayers:{}};var j=[f.params.LAYERS].join(",").split(",");for(var e=0,h=j.length;e<h;e++){var b=j[e];a.namedLayers[b]={name:b,userStyles:[]};var l=this.selectionSymbolizer;var k=g[e];if(k.type.indexOf("Polygon")>=0){l={Polygon:this.selectionSymbolizer.Polygon}}else{if(k.type.indexOf("LineString")>=0){l={Line:this.selectionSymbolizer.Line}}else{if(k.type.indexOf("Point")>=0){l={Point:this.selectionSymbolizer.Point}}}}var c=d[e];a.namedLayers[b].userStyles.push({name:"default",rules:[new OpenLayers.Rule({symbolizer:l,filter:c,maxScaleDenominator:f.options.minScale})]})}return new OpenLayers.Format.SLD({srsName:this.map.getProjection()}).write(a)},parseDescribeLayer:function(c){var g=new OpenLayers.Format.WMSDescribeLayer();var h=c.responseXML;if(!h||!h.documentElement){h=c.responseText}var b=g.read(h);var f=[];var a=null;for(var d=0,e=b.length;d<e;d++){if(b[d].owsType=="WFS"){f.push(b[d].typeName);a=b[d].owsURL}}var j={url:a,params:{SERVICE:"WFS",TYPENAME:f.toString(),REQUEST:"DescribeFeatureType",VERSION:"1.0.0"},callback:function(k){var m=new OpenLayers.Format.WFSDescribeFeatureType();var l=k.responseXML;if(!l||!l.documentElement){l=k.responseText}var i=m.read(l);this.control.wfsCache[this.layer.id]=i;this.control._queue&&this.control.applySelection()},scope:this};OpenLayers.Request.GET(j)},getGeometryAttributes:function(d){var m=[];var a=this.wfsCache[d.id];for(var c=0,e=a.featureTypes.length;c<e;c++){var h=a.featureTypes[c];var f=h.properties;for(var b=0,l=f.length;b<l;b++){var k=f[b];var g=k.type;if((g.indexOf("LineString")>=0)||(g.indexOf("GeometryAssociationType")>=0)||(g.indexOf("GeometryPropertyType")>=0)||(g.indexOf("Point")>=0)||(g.indexOf("Polygon")>=0)){m.push(k)}}}return m},activate:function(){var b=OpenLayers.Control.prototype.activate.call(this);if(b){for(var e=0,a=this.layers.length;e<a;e++){var d=this.layers[e];if(d&&!this.wfsCache[d.id]){var c={url:d.url,params:{SERVICE:"WMS",VERSION:d.params.VERSION,LAYERS:d.params.LAYERS,REQUEST:"DescribeLayer"},callback:this.parseDescribeLayer,scope:{layer:d,control:this}};OpenLayers.Request.GET(c)}}}return b},deactivate:function(){var f=OpenLayers.Control.prototype.deactivate.call(this);if(f){for(var e=0,a=this.layers.length;e<a;e++){var d=this.layers[e];if(d&&this.clearOnDeactivate===true){var c=this.layerCache;var b=c[d.id];if(b){d.events.un({visibilitychanged:this.coupleLayerVisiblity,scope:b});b.destroy();delete c[d.id]}}}}return f},setLayers:function(a){if(this.active){this.deactivate();this.layers=a;this.activate()}else{this.layers=a}},createFilter:function(a,c){var b=null;if(this.handler instanceof OpenLayers.Handler.RegularPolygon){if(this.handler.irregular===true){b=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.BBOX,property:a.name,value:c.getBounds()})}else{b=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.INTERSECTS,property:a.name,value:c})}}else{if(this.handler instanceof OpenLayers.Handler.Polygon){b=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.INTERSECTS,property:a.name,value:c})}else{if(this.handler instanceof OpenLayers.Handler.Path){if(a.type.indexOf("Point")>=0){b=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.DWITHIN,property:a.name,distance:this.map.getExtent().getWidth()*0.01,distanceUnits:this.map.getUnits(),value:c})}else{b=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.INTERSECTS,property:a.name,value:c})}}else{if(this.handler instanceof OpenLayers.Handler.Click){if(a.type.indexOf("Polygon")>=0){b=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.INTERSECTS,property:a.name,value:c})}else{b=new OpenLayers.Filter.Spatial({type:OpenLayers.Filter.Spatial.DWITHIN,property:a.name,distance:this.map.getExtent().getWidth()*0.01,distanceUnits:this.map.getUnits(),value:c})}}}}}return b},select:function(a){this._queue=function(){for(var g=0,l=this.layers.length;g<l;g++){var h=this.layers[g];var k=this.getGeometryAttributes(h);var d=[];for(var f=0,n=k.length;f<n;f++){var o=k[f];if(o!==null){if(!(a instanceof OpenLayers.Geometry)){var m=this.map.getLonLatFromPixel(a.xy);a=new OpenLayers.Geometry.Point(m.lon,m.lat)}var c=this.createFilter(o,a);if(c!==null){d.push(c)}}}var e=this.createSelectionLayer(h);var b=this.createSLD(h,d,k);this.events.triggerEvent("selected",{layer:h,filters:d});e.mergeNewParams({SLD_BODY:b});delete this._queue}};this.applySelection()},applySelection:function(){var c=true;for(var b=0,a=this.layers.length;b<a;b++){if(!this.wfsCache[this.layers[b].id]){c=false;break}}c&&this._queue.call(this)},CLASS_NAME:"OpenLayers.Control.SLDSelect"});OpenLayers.Layer.Boxes=OpenLayers.Class(OpenLayers.Layer.Markers,{initialize:function(b,a){OpenLayers.Layer.Markers.prototype.initialize.apply(this,arguments)},drawMarker:function(a){var d=a.bounds;var f=this.map.getLayerPxFromLonLat(new OpenLayers.LonLat(d.left,d.top));var c=this.map.getLayerPxFromLonLat(new OpenLayers.LonLat(d.right,d.bottom));if(c==null||f==null){a.display(false)}else{var e=new OpenLayers.Size(Math.max(1,c.x-f.x),Math.max(1,c.y-f.y));var b=a.draw(f,e);if(!a.drawn){this.div.appendChild(b);a.drawn=true}}},removeMarker:function(a){OpenLayers.Util.removeItem(this.markers,a);if((a.div!=null)&&(a.div.parentNode==this.div)){this.div.removeChild(a.div)}},CLASS_NAME:"OpenLayers.Layer.Boxes"});OpenLayers.Control.Graticule=OpenLayers.Class(OpenLayers.Control,{autoActivate:true,intervals:[45,30,20,10,5,2,1,0.5,0.2,0.1,0.05,0.01,0.005,0.002,0.001],displayInLayerSwitcher:true,visible:true,numPoints:50,targetSize:200,layerName:null,labelled:true,labelFormat:"dm",lineSymbolizer:{strokeColor:"#333",strokeWidth:1,strokeOpacity:0.5},labelSymbolizer:{},gratLayer:null,initialize:function(a){a=a||{};a.layerName=a.layerName||OpenLayers.i18n("Graticule");OpenLayers.Control.prototype.initialize.apply(this,[a]);this.labelSymbolizer.stroke=false;this.labelSymbolizer.fill=false;this.labelSymbolizer.label="${label}";this.labelSymbolizer.labelAlign="${labelAlign}";this.labelSymbolizer.labelXOffset="${xOffset}";this.labelSymbolizer.labelYOffset="${yOffset}"},destroy:function(){this.deactivate();OpenLayers.Control.prototype.destroy.apply(this,arguments);if(this.gratLayer){this.gratLayer.destroy();this.gratLayer=null}},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);if(!this.gratLayer){var a=new OpenLayers.Style({},{rules:[new OpenLayers.Rule({symbolizer:{Point:this.labelSymbolizer,Line:this.lineSymbolizer}})]});this.gratLayer=new OpenLayers.Layer.Vector(this.layerName,{styleMap:new OpenLayers.StyleMap({"default":a}),visibility:this.visible,displayInLayerSwitcher:this.displayInLayerSwitcher})}return this.div},activate:function(){if(OpenLayers.Control.prototype.activate.apply(this,arguments)){this.map.addLayer(this.gratLayer);this.map.events.register("moveend",this,this.update);this.update();return true}else{return false}},deactivate:function(){if(OpenLayers.Control.prototype.deactivate.apply(this,arguments)){this.map.events.unregister("moveend",this,this.update);this.map.removeLayer(this.gratLayer);return true}else{return false}},update:function(){var k=this.map.getExtent();if(!k){return}this.gratLayer.destroyFeatures();var l=new OpenLayers.Projection("EPSG:4326");var G=this.map.getProjectionObject();var g=this.map.getResolution();if(G.proj&&G.proj.projName=="longlat"){this.numPoints=1}var J=this.map.getCenter();var C=new OpenLayers.Pixel(J.lon,J.lat);OpenLayers.Projection.transform(C,G,l);var x=this.targetSize*g;x*=x;var p;for(var B=0;B<this.intervals.length;++B){p=this.intervals[B];var H=p/2;var d=C.offset(new OpenLayers.Pixel(-H,-H));var b=C.offset(new OpenLayers.Pixel(H,H));OpenLayers.Projection.transform(d,l,G);OpenLayers.Projection.transform(b,l,G);var e=(d.x-b.x)*(d.x-b.x)+(d.y-b.y)*(d.y-b.y);if(e<=x){break}}C.x=Math.floor(C.x/p)*p;C.y=Math.floor(C.y/p)*p;var A=0;var q=[C.clone()];var o=C.clone();var y;do{o=o.offset(new OpenLayers.Pixel(0,p));y=OpenLayers.Projection.transform(o.clone(),l,G);q.unshift(o)}while(k.containsPixel(y)&&++A<1000);o=C.clone();do{o=o.offset(new OpenLayers.Pixel(0,-p));y=OpenLayers.Projection.transform(o.clone(),l,G);q.push(o)}while(k.containsPixel(y)&&++A<1000);A=0;var v=[C.clone()];o=C.clone();do{o=o.offset(new OpenLayers.Pixel(-p,0));y=OpenLayers.Projection.transform(o.clone(),l,G);v.unshift(o)}while(k.containsPixel(y)&&++A<1000);o=C.clone();do{o=o.offset(new OpenLayers.Pixel(p,0));y=OpenLayers.Projection.transform(o.clone(),l,G);v.push(o)}while(k.containsPixel(y)&&++A<1000);var a=[];for(var B=0;B<v.length;++B){var f=v[B].x;var u=[];var I=null;var D=Math.min(q[0].y,90);var n=Math.max(q[q.length-1].y,-90);var c=(D-n)/this.numPoints;var h=n;for(var z=0;z<=this.numPoints;++z){var E=new OpenLayers.Geometry.Point(f,h);E.transform(l,G);u.push(E);h+=c;if(E.y>=k.bottom&&!I){I=E}}if(this.labelled){var s=new OpenLayers.Geometry.Point(I.x,k.bottom);var F={value:f,label:this.labelled?OpenLayers.Util.getFormattedLonLat(f,"lon",this.labelFormat):"",labelAlign:"cb",xOffset:0,yOffset:2};this.gratLayer.addFeatures(new OpenLayers.Feature.Vector(s,F))}var t=new OpenLayers.Geometry.LineString(u);a.push(new OpenLayers.Feature.Vector(t))}for(var z=0;z<q.length;++z){h=q[z].y;if(h<-90||h>90){continue}var u=[];var w=v[0].x;var r=v[v.length-1].x;var m=(r-w)/this.numPoints;var f=w;var I=null;for(var B=0;B<=this.numPoints;++B){var E=new OpenLayers.Geometry.Point(f,h);E.transform(l,G);u.push(E);f+=m;if(E.x<k.right){I=E}}if(this.labelled){var s=new OpenLayers.Geometry.Point(k.right,I.y);var F={value:h,label:this.labelled?OpenLayers.Util.getFormattedLonLat(h,"lat",this.labelFormat):"",labelAlign:"rb",xOffset:-2,yOffset:2};this.gratLayer.addFeatures(new OpenLayers.Feature.Vector(s,F))}var t=new OpenLayers.Geometry.LineString(u);a.push(new OpenLayers.Feature.Vector(t))}this.gratLayer.addFeatures(a)},CLASS_NAME:"OpenLayers.Control.Graticule"});OpenLayers.Control.NavigationHistory=OpenLayers.Class(OpenLayers.Control,{type:OpenLayers.Control.TYPE_TOGGLE,previous:null,previousOptions:null,next:null,nextOptions:null,limit:50,autoActivate:true,clearOnDeactivate:false,registry:null,nextStack:null,previousStack:null,listeners:null,restoring:false,initialize:function(a){OpenLayers.Control.prototype.initialize.apply(this,[a]);this.registry=OpenLayers.Util.extend({moveend:this.getState},this.registry);var b={trigger:OpenLayers.Function.bind(this.previousTrigger,this),displayClass:this.displayClass+" "+this.displayClass+"Previous"};OpenLayers.Util.extend(b,this.previousOptions);this.previous=new OpenLayers.Control.Button(b);var c={trigger:OpenLayers.Function.bind(this.nextTrigger,this),displayClass:this.displayClass+" "+this.displayClass+"Next"};OpenLayers.Util.extend(c,this.nextOptions);this.next=new OpenLayers.Control.Button(c);this.clear()},onPreviousChange:function(b,a){if(b&&!this.previous.active){this.previous.activate()}else{if(!b&&this.previous.active){this.previous.deactivate()}}},onNextChange:function(b,a){if(b&&!this.next.active){this.next.activate()}else{if(!b&&this.next.active){this.next.deactivate()}}},destroy:function(){OpenLayers.Control.prototype.destroy.apply(this);this.previous.destroy();this.next.destroy();this.deactivate();for(var a in this){this[a]=null}},setMap:function(a){this.map=a;this.next.setMap(a);this.previous.setMap(a)},draw:function(){OpenLayers.Control.prototype.draw.apply(this,arguments);this.next.draw();this.previous.draw()},previousTrigger:function(){var b=this.previousStack.shift();var a=this.previousStack.shift();if(a!=undefined){this.nextStack.unshift(b);this.previousStack.unshift(a);this.restoring=true;this.restore(a);this.restoring=false;this.onNextChange(this.nextStack[0],this.nextStack.length);this.onPreviousChange(this.previousStack[1],this.previousStack.length-1)}else{this.previousStack.unshift(b)}return a},nextTrigger:function(){var a=this.nextStack.shift();if(a!=undefined){this.previousStack.unshift(a);this.restoring=true;this.restore(a);this.restoring=false;this.onNextChange(this.nextStack[0],this.nextStack.length);this.onPreviousChange(this.previousStack[1],this.previousStack.length-1)}return a},clear:function(){this.previousStack=[];this.previous.deactivate();this.nextStack=[];this.next.deactivate()},getState:function(){return{center:this.map.getCenter(),resolution:this.map.getResolution(),projection:this.map.getProjectionObject(),units:this.map.getProjectionObject().getUnits()||this.map.units||this.map.baseLayer.units}},restore:function(e){var a,d;if(this.map.getProjectionObject()==e.projection){d=this.map.getZoomForResolution(e.resolution);a=e.center}else{a=e.center.clone();a.transform(e.projection,this.map.getProjectionObject());var f=e.units;var b=this.map.getProjectionObject().getUnits()||this.map.units||this.map.baseLayer.units;var c=f&&b?OpenLayers.INCHES_PER_UNIT[f]/OpenLayers.INCHES_PER_UNIT[b]:1;d=this.map.getZoomForResolution(c*e.resolution)}this.map.setCenter(a,d)},setListeners:function(){this.listeners={};for(var a in this.registry){this.listeners[a]=OpenLayers.Function.bind(function(){if(!this.restoring){var b=this.registry[a].apply(this,arguments);this.previousStack.unshift(b);if(this.previousStack.length>1){this.onPreviousChange(this.previousStack[1],this.previousStack.length-1)}if(this.previousStack.length>(this.limit+1)){this.previousStack.pop()}if(this.nextStack.length>0){this.nextStack=[];this.onNextChange(null,0)}}return true},this)}},activate:function(){var a=false;if(this.map){if(OpenLayers.Control.prototype.activate.apply(this)){if(this.listeners==null){this.setListeners()}for(var b in this.listeners){this.map.events.register(b,this,this.listeners[b])}a=true;if(this.previousStack.length==0){this.initStack()}}}return a},initStack:function(){if(this.map.getCenter()){this.listeners.moveend()}},deactivate:function(){var b=false;if(this.map){if(OpenLayers.Control.prototype.deactivate.apply(this)){for(var a in this.listeners){this.map.events.unregister(a,this,this.listeners[a])}if(this.clearOnDeactivate){this.clear()}b=true}}return b},CLASS_NAME:"OpenLayers.Control.NavigationHistory"});OpenLayers.Format.GeoJSON=OpenLayers.Class(OpenLayers.Format.JSON,{ignoreExtraDims:false,read:function(j,g,a){g=(g)?g:"FeatureCollection";var d=null;var c=null;if(typeof j=="string"){c=OpenLayers.Format.JSON.prototype.read.apply(this,[j,a])}else{c=j}if(!c){OpenLayers.Console.error("Bad JSON: "+j)}else{if(typeof(c.type)!="string"){OpenLayers.Console.error("Bad GeoJSON - no type: "+j)}else{if(this.isValidType(c,g)){switch(g){case"Geometry":try{d=this.parseGeometry(c)}catch(b){OpenLayers.Console.error(b)}break;case"Feature":try{d=this.parseFeature(c);d.type="Feature"}catch(b){OpenLayers.Console.error(b)}break;case"FeatureCollection":d=[];switch(c.type){case"Feature":try{d.push(this.parseFeature(c))}catch(b){d=null;OpenLayers.Console.error(b)}break;case"FeatureCollection":for(var e=0,f=c.features.length;e<f;++e){try{d.push(this.parseFeature(c.features[e]))}catch(b){d=null;OpenLayers.Console.error(b)}}break;default:try{var h=this.parseGeometry(c);d.push(new OpenLayers.Feature.Vector(h))}catch(b){d=null;OpenLayers.Console.error(b)}}break}}}}return d},isValidType:function(c,a){var b=false;switch(a){case"Geometry":if(OpenLayers.Util.indexOf(["Point","MultiPoint","LineString","MultiLineString","Polygon","MultiPolygon","Box","GeometryCollection"],c.type)==-1){OpenLayers.Console.error("Unsupported geometry type: "+c.type)}else{b=true}break;case"FeatureCollection":b=true;break;default:if(c.type==a){b=true}else{OpenLayers.Console.error("Cannot convert types from "+c.type+" to "+a)}}return b},parseFeature:function(d){var b,f,a,e;a=(d.properties)?d.properties:{};e=(d.geometry&&d.geometry.bbox)||d.bbox;try{f=this.parseGeometry(d.geometry)}catch(c){throw c}b=new OpenLayers.Feature.Vector(f,a);if(e){b.bounds=OpenLayers.Bounds.fromArray(e)}if(d.id){b.fid=d.id}return b},parseGeometry:function(e){if(e==null){return null}var g,f=false;if(e.type=="GeometryCollection"){if(!(OpenLayers.Util.isArray(e.geometries))){throw"GeometryCollection must have geometries array: "+e}var b=e.geometries.length;var d=new Array(b);for(var a=0;a<b;++a){d[a]=this.parseGeometry.apply(this,[e.geometries[a]])}g=new OpenLayers.Geometry.Collection(d);f=true}else{if(!(OpenLayers.Util.isArray(e.coordinates))){throw"Geometry must have coordinates array: "+e}if(!this.parseCoords[e.type.toLowerCase()]){throw"Unsupported geometry type: "+e.type}try{g=this.parseCoords[e.type.toLowerCase()].apply(this,[e.coordinates])}catch(c){throw c}}if(this.internalProjection&&this.externalProjection&&!f){g.transform(this.externalProjection,this.internalProjection)}return g},parseCoords:{point:function(a){if(this.ignoreExtraDims==false&&a.length!=2){throw"Only 2D points are supported: "+a}return new OpenLayers.Geometry.Point(a[0],a[1])},multipoint:function(f){var c=[];var e=null;for(var b=0,a=f.length;b<a;++b){try{e=this.parseCoords.point.apply(this,[f[b]])}catch(d){throw d}c.push(e)}return new OpenLayers.Geometry.MultiPoint(c)},linestring:function(f){var c=[];var e=null;for(var b=0,a=f.length;b<a;++b){try{e=this.parseCoords.point.apply(this,[f[b]])}catch(d){throw d}c.push(e)}return new OpenLayers.Geometry.LineString(c)},multilinestring:function(f){var c=[];var b=null;for(var d=0,a=f.length;d<a;++d){try{b=this.parseCoords.linestring.apply(this,[f[d]])}catch(e){throw e}c.push(b)}return new OpenLayers.Geometry.MultiLineString(c)},polygon:function(g){var f=[];var e,b;for(var c=0,a=g.length;c<a;++c){try{b=this.parseCoords.linestring.apply(this,[g[c]])}catch(d){throw d}e=new OpenLayers.Geometry.LinearRing(b.components);f.push(e)}return new OpenLayers.Geometry.Polygon(f)},multipolygon:function(f){var b=[];var e=null;for(var c=0,a=f.length;c<a;++c){try{e=this.parseCoords.polygon.apply(this,[f[c]])}catch(d){throw d}b.push(e)}return new OpenLayers.Geometry.MultiPolygon(b)},box:function(a){if(a.length!=2){throw"GeoJSON box coordinates must have 2 elements"}return new OpenLayers.Geometry.Polygon([new OpenLayers.Geometry.LinearRing([new OpenLayers.Geometry.Point(a[0][0],a[0][1]),new OpenLayers.Geometry.Point(a[1][0],a[0][1]),new OpenLayers.Geometry.Point(a[1][0],a[1][1]),new OpenLayers.Geometry.Point(a[0][0],a[1][1]),new OpenLayers.Geometry.Point(a[0][0],a[0][1])])])}},write:function(e,d){var a={type:null};if(OpenLayers.Util.isArray(e)){a.type="FeatureCollection";var g=e.length;a.features=new Array(g);for(var c=0;c<g;++c){var b=e[c];if(!b instanceof OpenLayers.Feature.Vector){var f="FeatureCollection only supports collections of features: "+b;throw f}a.features[c]=this.extract.feature.apply(this,[b])}}else{if(e.CLASS_NAME.indexOf("OpenLayers.Geometry")==0){a=this.extract.geometry.apply(this,[e])}else{if(e instanceof OpenLayers.Feature.Vector){a=this.extract.feature.apply(this,[e]);if(e.layer&&e.layer.projection){a.crs=this.createCRSObject(e)}}}}return OpenLayers.Format.JSON.prototype.write.apply(this,[a,d])},createCRSObject:function(b){var c=b.layer.projection.toString();var a={};if(c.match(/epsg:/i)){var d=parseInt(c.substring(c.indexOf(":")+1));if(d==4326){a={type:"name",properties:{name:"urn:ogc:def:crs:OGC:1.3:CRS84"}}}else{a={type:"name",properties:{name:"EPSG:"+d}}}}return a},extract:{feature:function(c){var b=this.extract.geometry.apply(this,[c.geometry]);var a={type:"Feature",properties:c.attributes,geometry:b};if(c.fid!=null){a.id=c.fid}return a},geometry:function(d){if(d==null){return null}if(this.internalProjection&&this.externalProjection){d=d.clone();d.transform(this.internalProjection,this.externalProjection)}var a=d.CLASS_NAME.split(".")[2];var c=this.extract[a.toLowerCase()].apply(this,[d]);var b;if(a=="Collection"){b={type:"GeometryCollection",geometries:c}}else{b={type:a,coordinates:c}}return b},point:function(a){return[a.x,a.y]},multipoint:function(c){var d=[];for(var b=0,a=c.components.length;b<a;++b){d.push(this.extract.point.apply(this,[c.components[b]]))}return d},linestring:function(b){var d=[];for(var c=0,a=b.components.length;c<a;++c){d.push(this.extract.point.apply(this,[b.components[c]]))}return d},multilinestring:function(c){var d=[];for(var b=0,a=c.components.length;b<a;++b){d.push(this.extract.linestring.apply(this,[c.components[b]]))}return d},polygon:function(c){var d=[];for(var b=0,a=c.components.length;b<a;++b){d.push(this.extract.linestring.apply(this,[c.components[b]]))}return d},multipolygon:function(d){var c=[];for(var b=0,a=d.components.length;b<a;++b){c.push(this.extract.polygon.apply(this,[d.components[b]]))}return c},collection:function(c){var a=c.components.length;var d=new Array(a);for(var b=0;b<a;++b){d[b]=this.extract.geometry.apply(this,[c.components[b]])}return d}},CLASS_NAME:"OpenLayers.Format.GeoJSON"});OpenLayers.Protocol.Script=OpenLayers.Class(OpenLayers.Protocol,{url:null,params:null,callback:null,scope:null,format:null,callbackKey:"callback",callbackPrefix:"",pendingRequests:null,srsInBBOX:false,initialize:function(a){a=a||{};this.params={};this.pendingRequests={};OpenLayers.Protocol.prototype.initialize.apply(this,arguments);if(!this.format){this.format=new OpenLayers.Format.GeoJSON()}if(!this.filterToParams&&OpenLayers.Format.QueryStringFilter){var b=new OpenLayers.Format.QueryStringFilter({srsInBBOX:this.srsInBBOX});this.filterToParams=function(c,d){return b.write(c,d)}}},read:function(b){OpenLayers.Protocol.prototype.read.apply(this,arguments);b=OpenLayers.Util.applyDefaults(b,this.options);b.params=OpenLayers.Util.applyDefaults(b.params,this.options.params);if(b.filter&&this.filterToParams){b.params=this.filterToParams(b.filter,b.params)}var a=new OpenLayers.Protocol.Response({requestType:"read"});var c=this.createRequest(b.url,b.params,OpenLayers.Function.bind(function(d){a.data=d;this.handleRead(a,b)},this));a.priv=c;return a},createRequest:function(c,e,g){var f=OpenLayers.Protocol.Script.register(g);var b="OpenLayers.Protocol.Script.registry["+f+"]";e=OpenLayers.Util.extend({},e);e[this.callbackKey]=this.callbackPrefix+b;c=OpenLayers.Util.urlAppend(c,OpenLayers.Util.getParameterString(e));var a=document.createElement("script");a.type="text/javascript";a.src=c;a.id="OpenLayers_Protocol_Script_"+f;this.pendingRequests[a.id]=a;var d=document.getElementsByTagName("head")[0];d.appendChild(a);return a},destroyRequest:function(a){OpenLayers.Protocol.Script.unregister(a.id.split("_").pop());delete this.pendingRequests[a.id];if(a.parentNode){a.parentNode.removeChild(a)}},handleRead:function(a,b){this.handleResponse(a,b)},handleResponse:function(a,b){if(b.callback){if(a.data){a.features=this.parseFeatures(a.data);a.code=OpenLayers.Protocol.Response.SUCCESS}else{a.code=OpenLayers.Protocol.Response.FAILURE}this.destroyRequest(a.priv);b.callback.call(b.scope,a)}},parseFeatures:function(a){return this.format.read(a)},abort:function(a){if(a){this.destroyRequest(a.priv)}else{for(var b in this.pendingRequests){this.destroyRequest(this.pendingRequests[b])}}},destroy:function(){this.abort();delete this.params;delete this.format;OpenLayers.Protocol.prototype.destroy.apply(this)},CLASS_NAME:"OpenLayers.Protocol.Script"});(function(){var b=OpenLayers.Protocol.Script;var a=0;b.registry=[];b.register=function(d){var c=++a;b.registry[c]=function(){b.unregister(c);d.apply(this,arguments)};return c};b.unregister=function(c){delete b.registry[c]}})();OpenLayers.Tile.Image.IFrame={useIFrame:null,clear:function(){if(this.useIFrame){if(this.imgDiv){var a=this.imgDiv.firstChild;OpenLayers.Event.stopObservingElement(a);this.imgDiv.removeChild(a);delete a}}else{OpenLayers.Tile.Image.prototype.clear.apply(this,arguments)}},renderTile:function(){if(OpenLayers.Tile.Image.prototype.renderTile.apply(this,arguments)&&this.useIFrame){var a=this.createRequestForm();this.imgDiv.appendChild(a);a.submit();this.imgDiv.removeChild(a);delete a}return true},initImgDiv:function(){this.useIFrame=this.maxGetUrlLength!==null&&!this.layer.async&&this.url.length>this.maxGetUrlLength;if(this.imgDiv!=null){var b=this.imgDiv.nodeName.toLowerCase();if((this.useIFrame&&b=="img")||(!this.useIFrame&&b=="div")){this.removeImgDiv();this.imgDiv=null}}if(this.useIFrame){if(this.imgDiv==null){var a=document.createElement("div");if(OpenLayers.BROWSER_NAME=="msie"){a.style.backgroundColor="#FFFFFF";a.style.filter="chroma(color=#FFFFFF)"}OpenLayers.Util.modifyDOMElement(a,null,new OpenLayers.Pixel(0,0),this.layer.getImageSize(),"absolute");this.imgDiv=document.createElement("div");this.imgDiv.appendChild(a);OpenLayers.Util.modifyDOMElement(this.imgDiv,this.id,null,this.layer.getImageSize(),"relative");this.imgDiv.className="olTileImage";this.frame.appendChild(this.imgDiv);this.layer.div.appendChild(this.frame);if(this.layer.opacity!=null){OpenLayers.Util.modifyDOMElement(this.imgDiv,null,null,null,null,null,null,this.layer.opacity)}this.imgDiv.map=this.layer.map}this.imgDiv.viewRequestID=this.layer.map.viewRequestID}else{OpenLayers.Tile.Image.prototype.initImgDiv.apply(this,arguments)}},createIFrame:function(){var c=this.id+"_iFrame";var a;if(OpenLayers.BROWSER_NAME=="msie"){a=document.createElement('<iframe name="'+c+'">');a.style.backgroundColor="#FFFFFF";a.style.filter="chroma(color=#FFFFFF)"}else{a=document.createElement("iframe");a.style.backgroundColor="transparent";a.name=c}a.id=c;a.scrolling="no";a.marginWidth="0px";a.marginHeight="0px";a.frameBorder="0";OpenLayers.Util.modifyDOMElement(a,c,new OpenLayers.Pixel(0,0),this.layer.getImageSize(),"absolute");var b=function(){if(this.isLoading){this.isLoading=false;this.events.triggerEvent("loadend")}};OpenLayers.Event.observe(a,"load",OpenLayers.Function.bind(b,this));return a},createRequestForm:function(){var b=document.createElement("form");b.method="POST";var f=this.layer.params._OLSALT;f=(f?f+"_":"")+this.bounds.toBBOX();b.action=OpenLayers.Util.urlAppend(this.layer.url,f);this.imgDiv.insertBefore(this.createIFrame(),this.imgDiv.firstChild);b.target=this.id+"_iFrame";var c=this.layer.getImageSize();var e=OpenLayers.Util.getParameters(this.url);for(var a in e){var d=document.createElement("input");d.type="hidden";d.name=a;d.value=e[a];b.appendChild(d)}return b}};OpenLayers.Layer.WMS.Post=OpenLayers.Class(OpenLayers.Layer.WMS,{unsupportedBrowsers:["mozilla","firefox","opera"],SUPPORTED_TRANSITIONS:[],usePost:null,initialize:function(d,c,e,b){var a=[];a.push(d,c,e,b);OpenLayers.Layer.WMS.prototype.initialize.apply(this,a);this.usePost=OpenLayers.Util.indexOf(this.unsupportedBrowsers,OpenLayers.BROWSER_NAME)==-1},addTile:function(b,a){return new OpenLayers.Tile.Image(this,a,b,null,this.tileSize,{maxGetUrlLength:this.usePost?0:null})},CLASS_NAME:"OpenLayers.Layer.WMS.Post"});OpenLayers.Control.TransformFeature=OpenLayers.Class(OpenLayers.Control,{EVENT_TYPES:["beforesetfeature","setfeature","beforetransform","transform","transformcomplete"],geometryTypes:null,layer:null,preserveAspectRatio:false,rotate:true,feature:null,renderIntent:"temporary",rotationHandleSymbolizer:null,box:null,center:null,scale:1,ratio:1,rotation:0,handles:null,rotationHandles:null,dragControl:null,initialize:function(b,a){this.EVENT_TYPES=OpenLayers.Control.TransformFeature.prototype.EVENT_TYPES.concat(OpenLayers.Control.prototype.EVENT_TYPES);OpenLayers.Control.prototype.initialize.apply(this,[a]);this.layer=b;if(!this.rotationHandleSymbolizer){this.rotationHandleSymbolizer={stroke:false,pointRadius:10,fillOpacity:0,cursor:"pointer"}}this.createBox();this.createControl()},activate:function(){var a=false;if(OpenLayers.Control.prototype.activate.apply(this,arguments)){this.dragControl.activate();this.layer.addFeatures([this.box]);this.rotate&&this.layer.addFeatures(this.rotationHandles);this.layer.addFeatures(this.handles);a=true}return a},deactivate:function(){var a=false;if(OpenLayers.Control.prototype.deactivate.apply(this,arguments)){this.layer.removeFeatures(this.handles);this.rotate&&this.layer.removeFeatures(this.rotationHandles);this.layer.removeFeatures([this.box]);this.dragControl.deactivate();a=true}if(a){this.unsetFeature()}return a},setMap:function(a){this.dragControl.setMap(a);OpenLayers.Control.prototype.setMap.apply(this,arguments)},setFeature:function(i,c){c=OpenLayers.Util.applyDefaults(c,{rotation:0,scale:1,ratio:1});var e=this.rotation;var a=this.center;OpenLayers.Util.extend(this,c);var j=this.events.triggerEvent("beforesetfeature",{feature:i});if(j===false){return}this.feature=i;this.activate();this._setfeature=true;var b=this.feature.geometry.getBounds();this.box.move(b.getCenterLonLat());this.box.geometry.rotate(-e,a);this._angle=0;var f;if(this.rotation){var g=i.geometry.clone();g.rotate(-this.rotation,this.center);var d=new OpenLayers.Feature.Vector(g.getBounds().toGeometry());d.geometry.rotate(this.rotation,this.center);this.box.geometry.rotate(this.rotation,this.center);this.box.move(d.geometry.getBounds().getCenterLonLat());var h=d.geometry.components[0].components[0];f=h.getBounds().getCenterLonLat()}else{f=new OpenLayers.LonLat(b.left,b.bottom)}this.handles[0].move(f);delete this._setfeature;this.events.triggerEvent("setfeature",{feature:i})},unsetFeature:function(){if(this.active){this.deactivate()}else{this.feature=null;this.rotation=0;this.scale=1;this.ratio=1}},createBox:function(){var e=this;this.center=new OpenLayers.Geometry.Point(0,0);var f=new OpenLayers.Feature.Vector(new OpenLayers.Geometry.LineString([new OpenLayers.Geometry.Point(-1,-1),new OpenLayers.Geometry.Point(0,-1),new OpenLayers.Geometry.Point(1,-1),new OpenLayers.Geometry.Point(1,0),new OpenLayers.Geometry.Point(1,1),new OpenLayers.Geometry.Point(0,1),new OpenLayers.Geometry.Point(-1,1),new OpenLayers.Geometry.Point(-1,0),new OpenLayers.Geometry.Point(-1,-1)]),null,typeof this.renderIntent=="string"?null:this.renderIntent);f.geometry.move=function(i,o){e._moving=true;OpenLayers.Geometry.LineString.prototype.move.apply(this,arguments);e.center.move(i,o);delete e._moving};var a=function(i,o){OpenLayers.Geometry.Point.prototype.move.apply(this,arguments);this._rotationHandle&&this._rotationHandle.geometry.move(i,o);this._handle.geometry.move(i,o)};var n=function(p,i,o){OpenLayers.Geometry.Point.prototype.resize.apply(this,arguments);this._rotationHandle&&this._rotationHandle.geometry.resize(p,i,o);this._handle.geometry.resize(p,i,o)};var l=function(o,i){OpenLayers.Geometry.Point.prototype.rotate.apply(this,arguments);this._rotationHandle&&this._rotationHandle.geometry.rotate(o,i);this._handle.geometry.rotate(o,i)};var h=function(A,w){var F=this.x,C=this.y;OpenLayers.Geometry.Point.prototype.move.call(this,A,w);if(e._moving){return}var D=e.dragControl.handlers.drag.evt;var i=!e._setfeature&&e.preserveAspectRatio;var r=!i&&!(D&&D.shiftKey);var z=new OpenLayers.Geometry.Point(F,C);var u=e.center;this.rotate(-e.rotation,u);z.rotate(-e.rotation,u);var B=this.x-u.x;var s=this.y-u.y;var E=B-(this.x-z.x);var t=s-(this.y-z.y);this.x=F;this.y=C;var p,v=1;if(r){p=Math.abs(t)<0.00001?1:s/t;v=(Math.abs(E)<0.00001?1:(B/E))/p}else{var q=Math.sqrt((E*E)+(t*t));var o=Math.sqrt((B*B)+(s*s));p=o/q}e._moving=true;e.box.geometry.rotate(-e.rotation,u);delete e._moving;e.box.geometry.resize(p,u,v);e.box.geometry.rotate(e.rotation,u);e.transformFeature({scale:p,ratio:v})};var c=function(v,t){var D=this.x,A=this.y;OpenLayers.Geometry.Point.prototype.move.call(this,v,t);if(e._moving){return}var B=e.dragControl.handlers.drag.evt;var u=(B&&B.shiftKey)?45:1;var s=e.center;var z=this.x-s.x;var q=this.y-s.y;var C=z-v;var r=q-t;this.x=D;this.y=A;var o=Math.atan2(r,C);var i=Math.atan2(q,z);var p=i-o;p*=180/Math.PI;e._angle=(e._angle+p)%360;var w=e.rotation%u;if(Math.abs(e._angle)>=u||w!==0){p=Math.round(e._angle/u)*u-w;e._angle=0;e.box.geometry.rotate(p,s);e.transformFeature({rotation:p})}};var m=new Array(8);var j=new Array(4);var k,g,b;for(var d=0;d<8;++d){k=f.geometry.components[d];g=new OpenLayers.Feature.Vector(k.clone(),null,typeof this.renderIntent=="string"?null:this.renderIntent);if(d%2==0){b=new OpenLayers.Feature.Vector(k.clone(),null,typeof this.rotationHandleSymbolizer=="string"?null:this.rotationHandleSymbolizer);b.geometry.move=c;k._rotationHandle=b;j[d/2]=b}k.move=a;k.resize=n;k.rotate=l;g.geometry.move=h;k._handle=g;m[d]=g}this.box=f;this.rotationHandles=j;this.handles=m},createControl:function(){var a=this;this.dragControl=new OpenLayers.Control.DragFeature(this.layer,{documentDrag:true,moveFeature:function(b){if(this.feature===a.feature){this.feature=a.box}OpenLayers.Control.DragFeature.prototype.moveFeature.apply(this,arguments)},onDrag:function(c,b){if(c===a.box){a.transformFeature({center:a.center});a.drawHandles()}},onStart:function(e,c){var b=!a.geometryTypes||OpenLayers.Util.indexOf(a.geometryTypes,e.geometry.CLASS_NAME)!==-1;var d=OpenLayers.Util.indexOf(a.handles,e);d+=OpenLayers.Util.indexOf(a.rotationHandles,e);if(e!==a.feature&&e!==a.box&&d==-2&&b){a.setFeature(e)}},onComplete:function(c,b){a.events.triggerEvent("transformcomplete",{feature:a.feature})}})},drawHandles:function(){var b=this.layer;for(var a=0;a<8;++a){if(this.rotate&&a%2===0){b.drawFeature(this.rotationHandles[a/2],this.rotationHandleSymbolizer)}b.drawFeature(this.handles[a],this.renderIntent)}},transformFeature:function(e){if(!this._setfeature){this.scale*=(e.scale||1);this.ratio*=(e.ratio||1);var b=this.rotation;this.rotation=(this.rotation+(e.rotation||0))%360;if(this.events.triggerEvent("beforetransform",e)!==false){var d=this.feature;var c=d.geometry;var a=this.center;c.rotate(-b,a);if(e.scale||e.ratio){c.resize(e.scale,a,e.ratio)}else{if(e.center){d.move(e.center.getBounds().getCenterLonLat())}}c.rotate(this.rotation,a);this.layer.drawFeature(d);d.toState(OpenLayers.State.UPDATE);this.events.triggerEvent("transform",e)}}this.layer.drawFeature(this.box,this.renderIntent);this.drawHandles()},destroy:function(){var b;for(var a=0;a<8;++a){b=this.box.geometry.components[a];b._handle.destroy();b._handle=null;b._rotationHandle&&b._rotationHandle.destroy();b._rotationHandle=null}this.box.destroy();this.box=null;this.layer=null;this.dragControl.destroy();OpenLayers.Control.prototype.destroy.apply(this,arguments)},CLASS_NAME:"OpenLayers.Control.TransformFeature"});OpenLayers.Layer.ArcGISCache=OpenLayers.Class(OpenLayers.Layer.XYZ,{url:null,tileOrigin:null,tileSize:new OpenLayers.Size(256,256),useArcGISServer:true,type:"png",useScales:false,overrideDPI:false,initialize:function(b,c,k){OpenLayers.Layer.XYZ.prototype.initialize.apply(this,arguments);if(this.resolutions){this.serverResolutions=this.resolutions;this.maxExtent=this.getMaxExtentForResolution(this.resolutions[0])}if(this.layerInfo){var e=this.layerInfo;var g=new OpenLayers.Bounds(e.fullExtent.xmin,e.fullExtent.ymin,e.fullExtent.xmax,e.fullExtent.ymax);this.projection="EPSG:"+e.spatialReference.wkid;this.sphericalMercator=(e.spatialReference.wkid==102100);this.units=(e.units=="esriFeet")?"ft":"m";if(!!e.tileInfo){this.tileSize=new OpenLayers.Size(e.tileInfo.width||e.tileInfo.cols,e.tileInfo.height||e.tileInfo.rows);this.tileOrigin=new OpenLayers.LonLat(e.tileInfo.origin.x,e.tileInfo.origin.y);var a=new OpenLayers.Geometry.Point(g.left,g.top);var i=new OpenLayers.Geometry.Point(g.right,g.bottom);if(this.useScales){this.scales=[]}else{this.resolutions=[]}this.lods=[];for(var j in e.tileInfo.lods){if(e.tileInfo.lods.hasOwnProperty(j)){var h=e.tileInfo.lods[j];if(this.useScales){this.scales.push(h.scale)}else{this.resolutions.push(h.resolution)}var d=this.getContainingTileCoords(a,h.resolution);h.startTileCol=d.x;h.startTileRow=d.y;var f=this.getContainingTileCoords(i,h.resolution);h.endTileCol=f.x;h.endTileRow=f.y;this.lods.push(h)}}this.maxExtent=this.calculateMaxExtentWithLOD(this.lods[0]);this.serverResolutions=this.resolutions;if(this.overrideDPI&&e.tileInfo.dpi){OpenLayers.DOTS_PER_INCH=e.tileInfo.dpi}}}},getContainingTileCoords:function(a,b){return new OpenLayers.Pixel(Math.max(Math.floor((a.x-this.tileOrigin.lon)/(this.tileSize.w*b)),0),Math.max(Math.floor((this.tileOrigin.lat-a.y)/(this.tileSize.h*b)),0))},calculateMaxExtentWithLOD:function(f){var c=(f.endTileCol-f.startTileCol)+1;var b=(f.endTileRow-f.startTileRow)+1;var a=this.tileOrigin.lon+(f.startTileCol*this.tileSize.w*f.resolution);var e=a+(c*this.tileSize.w*f.resolution);var d=this.tileOrigin.lat-(f.startTileRow*this.tileSize.h*f.resolution);var g=d-(b*this.tileSize.h*f.resolution);return new OpenLayers.Bounds(a,g,e,d)},calculateMaxExtentWithExtent:function(e,d){var c=new OpenLayers.Geometry.Point(e.left,e.top);var b=new OpenLayers.Geometry.Point(e.right,e.bottom);var g=this.getContainingTileCoords(c,d);var a=this.getContainingTileCoords(b,d);var f={resolution:d,startTileCol:g.x,startTileRow:g.y,endTileCol:a.x,endTileRow:a.y};return this.calculateMaxExtentWithLOD(f)},getUpperLeftTileCoord:function(b){var a=new OpenLayers.Geometry.Point(this.maxExtent.left,this.maxExtent.top);return this.getContainingTileCoords(a,b)},getLowerRightTileCoord:function(b){var a=new OpenLayers.Geometry.Point(this.maxExtent.right,this.maxExtent.bottom);return this.getContainingTileCoords(a,b)},getMaxExtentForResolution:function(g){var c=this.getUpperLeftTileCoord(g);var f=this.getLowerRightTileCoord(g);var h=(f.x-c.x)+1;var i=(f.y-c.y)+1;var e=this.tileOrigin.lon+(c.x*this.tileSize.w*g);var b=e+(h*this.tileSize.w*g);var a=this.tileOrigin.lat-(c.y*this.tileSize.h*g);var d=a-(i*this.tileSize.h*g);return new OpenLayers.Bounds(e,d,b,a)},clone:function(a){if(a==null){a=new OpenLayers.Layer.ArcGISCache(this.name,this.url,this.options)}return OpenLayers.Layer.XYZ.prototype.clone.apply(this,[a])},getMaxExtent:function(){var a=this.map.getResolution();return this.maxExtent=this.getMaxExtentForResolution(a)},getTileOrigin:function(){var a=this.getMaxExtent();return new OpenLayers.LonLat(a.left,a.bottom)},getURL:function(a){var i=this.getResolution();var f=(this.tileOrigin.lon+(i*this.tileSize.w/2));var e=(this.tileOrigin.lat-(i*this.tileSize.h/2));var b=a.getCenterLonLat();var m={x:b.lon,y:b.lat};var l=(Math.round(Math.abs((b.lon-f)/(i*this.tileSize.w))));var k=(Math.round(Math.abs((e-b.lat)/(i*this.tileSize.h))));var j=this.map.getZoom();if(this.lods){var h=this.lods[this.map.getZoom()];if((l<h.startTileCol||l>h.endTileCol)||(k<h.startTileRow||k>h.endTileRow)){return null}}else{var d=this.getUpperLeftTileCoord(i);var g=this.getLowerRightTileCoord(i);if((l<d.x||l>=g.x)||(k<d.y||k>=g.y)){return null}}var c=this.url;var n=""+l+k+j;if(OpenLayers.Util.isArray(c)){c=this.selectUrl(n,c)}if(this.useArcGISServer){c=c+"/tile/${z}/${y}/${x}"}else{l="C"+this.zeroPad(l,8,16);k="R"+this.zeroPad(k,8,16);j="L"+this.zeroPad(j,2,16);c=c+"/${z}/${y}/${x}."+this.type}c=OpenLayers.String.format(c,{x:l,y:k,z:j});return c},zeroPad:function(b,a,c){var d=b.toString(c||10);while(d.length<a){d="0"+d}return d},CLASS_NAME:"OpenLayers.Layer.ArcGISCache"});OpenLayers.Format.WMSCapabilities.v1_3_0=OpenLayers.Class(OpenLayers.Format.WMSCapabilities.v1_3,{version:"1.3.0",CLASS_NAME:"OpenLayers.Format.WMSCapabilities.v1_3_0"});OpenLayers.Control.Split=OpenLayers.Class(OpenLayers.Control,{EVENT_TYPES:["beforesplit","split","aftersplit"],layer:null,source:null,sourceOptions:null,tolerance:null,edge:true,deferDelete:false,mutual:true,targetFilter:null,sourceFilter:null,handler:null,initialize:function(a){Array.prototype.push.apply(this.EVENT_TYPES,OpenLayers.Control.prototype.EVENT_TYPES);OpenLayers.Control.prototype.initialize.apply(this,[a]);this.options=a||{};if(this.options.source){this.setSource(this.options.source)}},setSource:function(a){if(this.active){this.deactivate();if(this.handler){this.handler.destroy();delete this.handler}this.source=a;this.activate()}else{this.source=a}},activate:function(){var a=OpenLayers.Control.prototype.activate.call(this);if(a){if(!this.source){if(!this.handler){this.handler=new OpenLayers.Handler.Path(this,{done:function(b){this.onSketchComplete({feature:new OpenLayers.Feature.Vector(b)})}},{layerOptions:this.sourceOptions})}this.handler.activate()}else{if(this.source.events){this.source.events.on({sketchcomplete:this.onSketchComplete,afterfeaturemodified:this.afterFeatureModified,scope:this})}}}return a},deactivate:function(){var a=OpenLayers.Control.prototype.deactivate.call(this);if(a){if(this.source&&this.source.events){this.layer.events.un({sketchcomplete:this.onSketchComplete,afterfeaturemodified:this.afterFeatureModified,scope:this})}}return a},onSketchComplete:function(a){this.feature=null;return !this.considerSplit(a.feature)},afterFeatureModified:function(b){if(b.modified){var a=b.feature;if(a.geometry instanceof OpenLayers.Geometry.LineString||a.geometry instanceof OpenLayers.Geometry.MultiLineString){this.feature=b.feature;this.considerSplit(b.feature)}}},removeByGeometry:function(c,d){for(var b=0,a=c.length;b<a;++b){if(c[b].geometry===d){c.splice(b,1);break}}},isEligible:function(a){return(a.state!==OpenLayers.State.DELETE)&&(a.geometry instanceof OpenLayers.Geometry.LineString||a.geometry instanceof OpenLayers.Geometry.MultiLineString)&&(this.feature!==a)&&(!this.targetFilter||this.targetFilter.evaluate(a.attributes))},considerSplit:function(c){var h=false;var f=false;if(!this.sourceFilter||this.sourceFilter.evaluate(c.attributes)){var g=this.layer&&this.layer.features||[];var y,p,a;var m=[],x=[];var d=(this.layer===this.source)&&this.mutual;var b={edge:this.edge,tolerance:this.tolerance,mutual:d};var l=[c.geometry];var o,e;var r,q;for(var v=0,w=g.length;v<w;++v){o=g[v];if(this.isEligible(o)){e=[o.geometry];for(var u=0;u<l.length;++u){r=l[u];for(var s=0;s<e.length;++s){y=e[s];if(r.getBounds().intersectsBounds(y.getBounds())){p=r.split(y,b);if(p){a=this.events.triggerEvent("beforesplit",{source:c,target:o});if(a!==false){if(d){q=p[0];if(q.length>1){q.unshift(u,1);Array.prototype.splice.apply(l,q);u+=q.length-3}p=p[1]}if(p.length>1){p.unshift(s,1);Array.prototype.splice.apply(e,p);s+=p.length-3}}}}}}if(e&&e.length>1){this.geomsToFeatures(o,e);this.events.triggerEvent("split",{original:o,features:e});Array.prototype.push.apply(m,e);x.push(o);f=true}}}if(l&&l.length>1){this.geomsToFeatures(c,l);this.events.triggerEvent("split",{original:c,features:l});Array.prototype.push.apply(m,l);x.push(c);h=true}if(h||f){if(this.deferDelete){var n,t=[];for(var v=0,w=x.length;v<w;++v){n=x[v];if(n.state===OpenLayers.State.INSERT){t.push(n)}else{n.state=OpenLayers.State.DELETE;this.layer.drawFeature(n)}}this.layer.destroyFeatures(t,{silent:true});for(var v=0,w=m.length;v<w;++v){m[v].state=OpenLayers.State.INSERT}}else{this.layer.destroyFeatures(x,{silent:true})}this.layer.addFeatures(m,{silent:true});this.events.triggerEvent("aftersplit",{source:c,features:m})}}return h},geomsToFeatures:function(c,d){var f=c.clone();delete f.geometry;var e;for(var b=0,a=d.length;b<a;++b){e=f.clone();e.geometry=d[b];e.state=OpenLayers.State.INSERT;d[b]=e}},destroy:function(){if(this.active){this.deactivate()}OpenLayers.Control.prototype.destroy.call(this)},CLASS_NAME:"OpenLayers.Control.Split"});OpenLayers.Layer.KaMapCache=OpenLayers.Class(OpenLayers.Layer.KaMap,{IMAGE_EXTENSIONS:{jpeg:"jpg",gif:"gif",png:"png",png8:"png",png24:"png",dithered:"png"},DEFAULT_FORMAT:"jpeg",initialize:function(c,b,d,a){OpenLayers.Layer.KaMap.prototype.initialize.apply(this,arguments);this.extension=this.IMAGE_EXTENSIONS[this.params.i.toLowerCase()||DEFAULT_FORMAT]},getURL:function(a){a=this.adjustBounds(a);var f=this.map.getResolution();var e=Math.round((this.map.getScale()*10000))/10000;var d=Math.round(a.left/f);var c=-Math.round(a.top/f);var i=Math.floor(d/this.tileSize.w/this.params.metaTileSize.w)*this.tileSize.w*this.params.metaTileSize.w;var h=Math.floor(c/this.tileSize.h/this.params.metaTileSize.h)*this.tileSize.h*this.params.metaTileSize.h;var b=this.url;if(OpenLayers.Util.isArray(b)){b=this.selectUrl(paramsString,b)}var g=[b,"/",this.params.map,"/",e,"/",this.params.g.replace(/\s/g,"_"),"/def/t",h,"/l",i,"/t",c,"l",d,".",this.extension];return g.join("")},CLASS_NAME:"OpenLayers.Layer.KaMapCache"});OpenLayers.Feature.WFS=OpenLayers.Class(OpenLayers.Feature,{initialize:function(c,b){var a=arguments;var d=this.processXMLNode(b);a=new Array(c,d.lonlat,d);OpenLayers.Feature.prototype.initialize.apply(this,a);this.createMarker();this.layer.addMarker(this.marker)},destroy:function(){if(this.marker!=null){this.layer.removeMarker(this.marker)}OpenLayers.Feature.prototype.destroy.apply(this,arguments)},processXMLNode:function(b){var a=OpenLayers.Ajax.getElementsByTagNameNS(b,"http://www.opengis.net/gml","gml","Point");var d=OpenLayers.Util.getXmlNodeValue(OpenLayers.Ajax.getElementsByTagNameNS(a[0],"http://www.opengis.net/gml","gml","coordinates")[0]);var c=d.split(",");return{lonlat:new OpenLayers.LonLat(parseFloat(c[0]),parseFloat(c[1])),id:null}},CLASS_NAME:"OpenLayers.Feature.WFS"});OpenLayers.Layer.TileCache=OpenLayers.Class(OpenLayers.Layer.Grid,{isBaseLayer:true,format:"image/png",serverResolutions:null,initialize:function(c,b,d,a){this.layername=d;OpenLayers.Layer.Grid.prototype.initialize.apply(this,[c,b,{},a]);this.extension=this.format.split("/")[1].toLowerCase();this.extension=(this.extension=="jpg")?"jpeg":this.extension},clone:function(a){if(a==null){a=new OpenLayers.Layer.TileCache(this.name,this.url,this.layername,this.getOptions())}a=OpenLayers.Layer.Grid.prototype.clone.apply(this,[a]);return a},getURL:function(b){var f=this.map.getResolution();var g=this.maxExtent;var k=this.tileSize;var a=Math.round((b.left-g.left)/(f*k.w));var j=Math.round((b.bottom-g.bottom)/(f*k.h));var h=this.serverResolutions!=null?OpenLayers.Util.indexOf(this.serverResolutions,f):this.map.getZoom();function e(o,n){o=String(o);var l=[];for(var m=0;m<n;++m){l.push("0")}return l.join("").substring(0,n-o.length)+o}var d=[this.layername,e(h,2),e(parseInt(a/1000000),3),e((parseInt(a/1000)%1000),3),e((parseInt(a)%1000),3),e(parseInt(j/1000000),3),e((parseInt(j/1000)%1000),3),e((parseInt(j)%1000),3)+"."+this.extension];var i=d.join("/");var c=this.url;if(OpenLayers.Util.isArray(c)){c=this.selectUrl(i,c)}c=(c.charAt(c.length-1)=="/")?c:c+"/";return c+i},CLASS_NAME:"OpenLayers.Layer.TileCache"});OpenLayers.Format.WMSCapabilities.v1_1_1=OpenLayers.Class(OpenLayers.Format.WMSCapabilities.v1_1,{version:"1.1.1",initialize:function(a){OpenLayers.Format.WMSCapabilities.v1_1.prototype.initialize.apply(this,[a])},readers:{wms:OpenLayers.Util.applyDefaults({SRS:function(a,b){b.srs[this.getChildValue(a)]=true}},OpenLayers.Format.WMSCapabilities.v1_1.prototype.readers.wms)},CLASS_NAME:"OpenLayers.Format.WMSCapabilities.v1_1_1"});OpenLayers.Format.WMSCapabilities.v1_1_1_WMSC=OpenLayers.Class(OpenLayers.Format.WMSCapabilities.v1_1_1,{version:"1.1.1",profile:"WMSC",initialize:function(a){OpenLayers.Format.WMSCapabilities.v1_1_1.prototype.initialize.apply(this,[a])},readers:{wms:OpenLayers.Util.applyDefaults({VendorSpecificCapabilities:function(a,b){b.vendorSpecific={tileSets:[]};this.readChildNodes(a,b.vendorSpecific)},TileSet:function(b,a){var c={srs:{},bbox:{},resolutions:[]};this.readChildNodes(b,c);a.tileSets.push(c)},Resolutions:function(d,e){var c=this.getChildValue(d).split(" ");for(var b=0,a=c.length;b<a;b++){if(c[b]!=""){e.resolutions.push(parseFloat(c[b]))}}},Width:function(a,b){b.width=parseInt(this.getChildValue(a))},Height:function(a,b){b.height=parseInt(this.getChildValue(a))},Layers:function(a,b){b.layers=this.getChildValue(a)},Styles:function(a,b){b.styles=this.getChildValue(a)}},OpenLayers.Format.WMSCapabilities.v1_1_1.prototype.readers.wms)},CLASS_NAME:"OpenLayers.Format.WMSCapabilities.v1_1_1_WMSC"});OpenLayers.Layer.WFS=OpenLayers.Class(OpenLayers.Layer.Vector,OpenLayers.Layer.Markers,{isBaseLayer:false,tile:null,ratio:2,DEFAULT_PARAMS:{service:"WFS",version:"1.0.0",request:"GetFeature"},featureClass:null,format:null,formatObject:null,formatOptions:null,vectorMode:true,encodeBBOX:false,extractAttributes:false,initialize:function(d,c,e,b){if(b==undefined){b={}}if(b.featureClass||!OpenLayers.Layer.Vector||!OpenLayers.Feature.Vector){this.vectorMode=false}e=OpenLayers.Util.upperCaseObject(e);OpenLayers.Util.extend(b,{reportError:false});var a=[];a.push(d,b);OpenLayers.Layer.Vector.prototype.initialize.apply(this,a);if(!this.renderer||!this.vectorMode){this.vectorMode=false;if(!b.featureClass){b.featureClass=OpenLayers.Feature.WFS}OpenLayers.Layer.Markers.prototype.initialize.apply(this,a)}if(this.params&&this.params.typename&&!this.options.typename){this.options.typename=this.params.typename}if(!this.options.geometry_column){this.options.geometry_column="the_geom"}this.params=OpenLayers.Util.applyDefaults(e,OpenLayers.Util.upperCaseObject(this.DEFAULT_PARAMS));this.url=c},destroy:function(){if(this.vectorMode){OpenLayers.Layer.Vector.prototype.destroy.apply(this,arguments)}else{OpenLayers.Layer.Markers.prototype.destroy.apply(this,arguments)}if(this.tile){this.tile.destroy()}this.tile=null;this.ratio=null;this.featureClass=null;this.format=null;if(this.formatObject&&this.formatObject.destroy){this.formatObject.destroy()}this.formatObject=null;this.formatOptions=null;this.vectorMode=null;this.encodeBBOX=null;this.extractAttributes=null},setMap:function(b){if(this.vectorMode){OpenLayers.Layer.Vector.prototype.setMap.apply(this,arguments);var a={extractAttributes:this.extractAttributes};OpenLayers.Util.extend(a,this.formatOptions);if(this.map&&!this.projection.equals(this.map.getProjectionObject())){a.externalProjection=this.projection;a.internalProjection=this.map.getProjectionObject()}this.formatObject=this.format?new this.format(a):new OpenLayers.Format.GML(a)}else{OpenLayers.Layer.Markers.prototype.setMap.apply(this,arguments)}},moveTo:function(a,b,n){if(this.vectorMode){OpenLayers.Layer.Vector.prototype.moveTo.apply(this,arguments)}else{OpenLayers.Layer.Markers.prototype.moveTo.apply(this,arguments)}if(n){return false}if(b){if(this.vectorMode){this.renderer.clear()}}if(this.options.minZoomLevel){OpenLayers.Console.warn(OpenLayers.i18n("minZoomLevelError"));if(this.map.getZoom()<this.options.minZoomLevel){return null}}if(a==null){a=this.map.getExtent()}var m=(this.tile==null);var g=(!m&&!this.tile.bounds.containsBounds(a));if(b||m||(!n&&g)){var c=a.getCenterLonLat();var l=a.getWidth()*this.ratio;var h=a.getHeight()*this.ratio;var j=new OpenLayers.Bounds(c.lon-(l/2),c.lat-(h/2),c.lon+(l/2),c.lat+(h/2));var o=this.map.getSize();o.w=o.w*this.ratio;o.h=o.h*this.ratio;var i=new OpenLayers.LonLat(j.left,j.top);var k=this.map.getLayerPxFromLonLat(i);var d=this.getFullRequestString();var f=null;var e=this.params.filter||this.params.FILTER;if(e){f={FILTER:e}}else{f={BBOX:this.encodeBBOX?j.toBBOX():j.toArray()}}if(this.map&&!this.projection.equals(this.map.getProjectionObject())){var p=j.clone();p.transform(this.map.getProjectionObject(),this.projection);if(!e){f.BBOX=this.encodeBBOX?p.toBBOX():p.toArray()}}d+="&"+OpenLayers.Util.getParameterString(f);if(!this.tile){this.tile=new OpenLayers.Tile.WFS(this,k,j,d,o);this.addTileMonitoringHooks(this.tile);this.tile.draw()}else{if(this.vectorMode){this.destroyFeatures();this.renderer.clear()}else{this.clearMarkers()}this.removeTileMonitoringHooks(this.tile);this.tile.destroy();this.tile=null;this.tile=new OpenLayers.Tile.WFS(this,k,j,d,o);this.addTileMonitoringHooks(this.tile);this.tile.draw()}}},addTileMonitoringHooks:function(a){a.onLoadStart=function(){if(this==this.layer.tile){this.layer.events.triggerEvent("loadstart")}};a.events.register("loadstart",a,a.onLoadStart);a.onLoadEnd=function(){if(this==this.layer.tile){this.layer.events.triggerEvent("tileloaded");this.layer.events.triggerEvent("loadend")}};a.events.register("loadend",a,a.onLoadEnd);a.events.register("unload",a,a.onLoadEnd)},removeTileMonitoringHooks:function(a){a.unload();a.events.un({loadstart:a.onLoadStart,loadend:a.onLoadEnd,unload:a.onLoadEnd,scope:a})},onMapResize:function(){if(this.vectorMode){OpenLayers.Layer.Vector.prototype.onMapResize.apply(this,arguments)}else{OpenLayers.Layer.Markers.prototype.onMapResize.apply(this,arguments)}},display:function(){if(this.vectorMode){OpenLayers.Layer.Vector.prototype.display.apply(this,arguments)}else{OpenLayers.Layer.Markers.prototype.display.apply(this,arguments)}},mergeNewParams:function(c){var b=OpenLayers.Util.upperCaseObject(c);var a=[b];return OpenLayers.Layer.HTTPRequest.prototype.mergeNewParams.apply(this,a)},clone:function(a){if(a==null){a=new OpenLayers.Layer.WFS(this.name,this.url,this.params,this.getOptions())}if(this.vectorMode){a=OpenLayers.Layer.Vector.prototype.clone.apply(this,[a])}else{a=OpenLayers.Layer.Markers.prototype.clone.apply(this,[a])}return a},getFullRequestString:function(c,b){var a=this.projection.getCode()||this.map.getProjection();this.params.SRS=(a=="none")?null:a;return OpenLayers.Layer.Grid.prototype.getFullRequestString.apply(this,arguments)},commit:function(){if(!this.writer){var a={};if(this.map&&!this.projection.equals(this.map.getProjectionObject())){a.externalProjection=this.projection;a.internalProjection=this.map.getProjectionObject()}this.writer=new OpenLayers.Format.WFS(a,this)}var b=this.writer.write(this.features);OpenLayers.Request.POST({url:this.url,data:b,success:this.commitSuccess,failure:this.commitFailure,scope:this})},commitSuccess:function(c){var a=c.responseText;if(a.indexOf("SUCCESS")!=-1){this.commitReport(OpenLayers.i18n("commitSuccess",{response:a}));for(var b=0;b<this.features.length;b++){this.features[b].state=null}}else{if(a.indexOf("FAILED")!=-1||a.indexOf("Exception")!=-1){this.commitReport(OpenLayers.i18n("commitFailed",{response:a}))}}},commitFailure:function(a){},commitReport:function(b,a){OpenLayers.Console.userError(b)},refresh:function(){if(this.tile){if(this.vectorMode){this.renderer.clear();this.features.length=0}else{this.clearMarkers();this.markers.length=0}this.tile.draw()}},getDataExtent:function(){var a;if(this.vectorMode){a=OpenLayers.Layer.Vector.prototype.getDataExtent.apply(this)}else{a=OpenLayers.Layer.Markers.prototype.getDataExtent.apply(this)}return a},setOpacity:function(a){if(this.vectorMode){OpenLayers.Layer.Vector.prototype.setOpacity.apply(this,[a])}else{OpenLayers.Layer.Markers.prototype.setOpacity.apply(this,[a])}},CLASS_NAME:"OpenLayers.Layer.WFS"});OpenLayers.Control.LayerSwitcher=OpenLayers.Class(OpenLayers.Control,{roundedCorner:true,roundedCornerColor:"darkblue",layerStates:null,layersDiv:null,baseLayersDiv:null,baseLayers:null,dataLbl:null,dataLayersDiv:null,dataLayers:null,minimizeDiv:null,maximizeDiv:null,ascending:true,initialize:function(a){OpenLayers.Control.prototype.initialize.apply(this,arguments);this.layerStates=[]},destroy:function(){OpenLayers.Event.stopObservingElement(this.div);OpenLayers.Event.stopObservingElement(this.minimizeDiv);OpenLayers.Event.stopObservingElement(this.maximizeDiv);this.clearLayersArray("base");this.clearLayersArray("data");this.map.events.un({addlayer:this.redraw,changelayer:this.redraw,removelayer:this.redraw,changebaselayer:this.redraw,scope:this});OpenLayers.Control.prototype.destroy.apply(this,arguments)},setMap:function(a){OpenLayers.Control.prototype.setMap.apply(this,arguments);this.map.events.on({addlayer:this.redraw,changelayer:this.redraw,removelayer:this.redraw,changebaselayer:this.redraw,scope:this})},draw:function(){OpenLayers.Control.prototype.draw.apply(this);this.loadContents();if(!this.outsideViewport){this.minimizeControl()}this.redraw();return this.div},clearLayersArray:function(d){var e=this[d+"Layers"];if(e){for(var c=0,a=e.length;c<a;c++){var b=e[c];OpenLayers.Event.stopObservingElement(b.inputElem);OpenLayers.Event.stopObservingElement(b.labelSpan)}}this[d+"LayersDiv"].innerHTML="";this[d+"Layers"]=[]},checkRedraw:function(){var e=false;if(!this.layerStates.length||(this.map.layers.length!=this.layerStates.length)){e=true}else{for(var c=0,a=this.layerStates.length;c<a;c++){var d=this.layerStates[c];var b=this.map.layers[c];if((d.name!=b.name)||(d.inRange!=b.inRange)||(d.id!=b.id)||(d.visibility!=b.visibility)){e=true;break}}}return e},redraw:function(){if(!this.checkRedraw()){return this.div}this.clearLayersArray("base");this.clearLayersArray("data");var d=false;var m=false;var h=this.map.layers.length;this.layerStates=new Array(h);for(var f=0;f<h;f++){var g=this.map.layers[f];this.layerStates[f]={name:g.name,visibility:g.visibility,inRange:g.inRange,id:g.id}}var e=this.map.layers.slice();if(!this.ascending){e.reverse()}for(var f=0,h=e.length;f<h;f++){var g=e[f];var j=g.isBaseLayer;if(g.displayInLayerSwitcher){if(j){m=true}else{d=true}var l=(j)?(g==this.map.baseLayer):g.getVisibility();var k=document.createElement("input");k.id=this.id+"_input_"+g.name;k.name=(j)?this.id+"_baseLayers":g.name;k.type=(j)?"radio":"checkbox";k.value=g.name;k.checked=l;k.defaultChecked=l;if(!j&&!g.inRange){k.disabled=true}var a={inputElem:k,layer:g,layerSwitcher:this};OpenLayers.Event.observe(k,"mouseup",OpenLayers.Function.bindAsEventListener(this.onInputClick,a));var b=document.createElement("span");OpenLayers.Element.addClass(b,"labelSpan");if(!j&&!g.inRange){b.style.color="gray"}b.innerHTML=g.name;b.style.verticalAlign=(j)?"bottom":"baseline";OpenLayers.Event.observe(b,"click",OpenLayers.Function.bindAsEventListener(this.onInputClick,a));var o=document.createElement("br");var n=(j)?this.baseLayers:this.dataLayers;n.push({layer:g,inputElem:k,labelSpan:b});var c=(j)?this.baseLayersDiv:this.dataLayersDiv;c.appendChild(k);c.appendChild(b);c.appendChild(o)}}this.dataLbl.style.display=(d)?"":"none";this.baseLbl.style.display=(m)?"":"none";return this.div},onInputClick:function(a){if(!this.inputElem.disabled){if(this.inputElem.type=="radio"){this.inputElem.checked=true;this.layer.map.setBaseLayer(this.layer)}else{this.inputElem.checked=!this.inputElem.checked;this.layerSwitcher.updateMap()}}OpenLayers.Event.stop(a)},onLayerClick:function(a){this.updateMap()},updateMap:function(){for(var b=0,a=this.baseLayers.length;b<a;b++){var c=this.baseLayers[b];if(c.inputElem.checked){this.map.setBaseLayer(c.layer,false)}}for(var b=0,a=this.dataLayers.length;b<a;b++){var c=this.dataLayers[b];c.layer.setVisibility(c.inputElem.checked)}},maximizeControl:function(a){this.div.style.width="";this.div.style.height="";this.showControls(false);if(a!=null){OpenLayers.Event.stop(a)}},minimizeControl:function(a){this.div.style.width="0px";this.div.style.height="0px";this.showControls(true);if(a!=null){OpenLayers.Event.stop(a)}},showControls:function(a){this.maximizeDiv.style.display=a?"":"none";this.minimizeDiv.style.display=a?"none":"";this.layersDiv.style.display=a?"none":""},loadContents:function(){OpenLayers.Event.observe(this.div,"mouseup",OpenLayers.Function.bindAsEventListener(this.mouseUp,this));OpenLayers.Event.observe(this.div,"click",this.ignoreEvent);OpenLayers.Event.observe(this.div,"mousedown",OpenLayers.Function.bindAsEventListener(this.mouseDown,this));OpenLayers.Event.observe(this.div,"dblclick",this.ignoreEvent);this.layersDiv=document.createElement("div");this.layersDiv.id=this.id+"_layersDiv";OpenLayers.Element.addClass(this.layersDiv,"layersDiv");this.baseLbl=document.createElement("div");this.baseLbl.innerHTML=OpenLayers.i18n("Base Layer");OpenLayers.Element.addClass(this.baseLbl,"baseLbl");this.baseLayersDiv=document.createElement("div");OpenLayers.Element.addClass(this.baseLayersDiv,"baseLayersDiv");this.dataLbl=document.createElement("div");this.dataLbl.innerHTML=OpenLayers.i18n("Overlays");OpenLayers.Element.addClass(this.dataLbl,"dataLbl");this.dataLayersDiv=document.createElement("div");OpenLayers.Element.addClass(this.dataLayersDiv,"dataLayersDiv");if(this.ascending){this.layersDiv.appendChild(this.baseLbl);this.layersDiv.appendChild(this.baseLayersDiv);this.layersDiv.appendChild(this.dataLbl);this.layersDiv.appendChild(this.dataLayersDiv)}else{this.layersDiv.appendChild(this.dataLbl);this.layersDiv.appendChild(this.dataLayersDiv);this.layersDiv.appendChild(this.baseLbl);this.layersDiv.appendChild(this.baseLayersDiv)}this.div.appendChild(this.layersDiv);if(this.roundedCorner){OpenLayers.Rico.Corner.round(this.div,{corners:"tl bl",bgColor:"transparent",color:this.roundedCornerColor,blend:false});OpenLayers.Rico.Corner.changeOpacity(this.layersDiv,0.75)}var c=OpenLayers.Util.getImagesLocation();var b=new OpenLayers.Size(18,18);var a=c+"layer-switcher-maximize.png";this.maximizeDiv=OpenLayers.Util.createAlphaImageDiv("OpenLayers_Control_MaximizeDiv",null,b,a,"absolute");OpenLayers.Element.addClass(this.maximizeDiv,"maximizeDiv");this.maximizeDiv.style.display="none";OpenLayers.Event.observe(this.maximizeDiv,"click",OpenLayers.Function.bindAsEventListener(this.maximizeControl,this));this.div.appendChild(this.maximizeDiv);var a=c+"layer-switcher-minimize.png";var b=new OpenLayers.Size(18,18);this.minimizeDiv=OpenLayers.Util.createAlphaImageDiv("OpenLayers_Control_MinimizeDiv",null,b,a,"absolute");OpenLayers.Element.addClass(this.minimizeDiv,"minimizeDiv");this.minimizeDiv.style.display="none";OpenLayers.Event.observe(this.minimizeDiv,"click",OpenLayers.Function.bindAsEventListener(this.minimizeControl,this));this.div.appendChild(this.minimizeDiv)},ignoreEvent:function(a){OpenLayers.Event.stop(a)},mouseDown:function(a){this.isMouseDown=true;this.ignoreEvent(a)},mouseUp:function(a){if(this.isMouseDown){this.isMouseDown=false;this.ignoreEvent(a)}},CLASS_NAME:"OpenLayers.Control.LayerSwitcher"});OpenLayers.Format.Atom=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{atom:"http://www.w3.org/2005/Atom",georss:"http://www.georss.org/georss"},feedTitle:"untitled",defaultEntryTitle:"untitled",gmlParser:null,xy:false,read:function(a){if(typeof a=="string"){a=OpenLayers.Format.XML.prototype.read.apply(this,[a])}return this.parseFeatures(a)},write:function(c){var d;if(OpenLayers.Util.isArray(c)){d=this.createElementNSPlus("atom:feed");d.appendChild(this.createElementNSPlus("atom:title",{value:this.feedTitle}));for(var a=0,b=c.length;a<b;a++){d.appendChild(this.buildEntryNode(c[a]))}}else{d=this.buildEntryNode(c)}return OpenLayers.Format.XML.prototype.write.apply(this,[d])},buildContentNode:function(b){var a=this.createElementNSPlus("atom:content",{attributes:{type:b.type||null}});if(b.src){a.setAttribute("src",b.src)}else{if(b.type=="text"||b.type==null){a.appendChild(this.createTextNode(b.value))}else{if(b.type=="html"){if(typeof b.value!="string"){throw"HTML content must be in form of an escaped string"}a.appendChild(this.createTextNode(b.value))}else{if(b.type=="xhtml"){a.appendChild(b.value)}else{if(b.type=="xhtml"||b.type.match(/(\+|\/)xml$/)){a.appendChild(b.value)}else{a.appendChild(this.createTextNode(b.value))}}}}}return a},buildEntryNode:function(n){var c=n.attributes;var j=c.atom||{};var k=this.createElementNSPlus("atom:entry");if(j.authors){var h=OpenLayers.Util.isArray(j.authors)?j.authors:[j.authors];for(var d=0,m=h.length;d<m;d++){k.appendChild(this.buildPersonConstructNode("author",h[d]))}}if(j.categories){var e=OpenLayers.Util.isArray(j.categories)?j.categories:[j.categories];var a;for(var d=0,m=e.length;d<m;d++){a=e[d];k.appendChild(this.createElementNSPlus("atom:category",{attributes:{term:a.term,scheme:a.scheme||null,label:a.label||null}}))}}if(j.content){k.appendChild(this.buildContentNode(j.content))}if(j.contributors){var f=OpenLayers.Util.isArray(j.contributors)?j.contributors:[j.contributors];for(var d=0,m=f.length;d<m;d++){k.appendChild(this.buildPersonConstructNode("contributor",f[d]))}}if(n.fid){k.appendChild(this.createElementNSPlus("atom:id",{value:n.fid}))}if(j.links){var l=OpenLayers.Util.isArray(j.links)?j.links:[j.links];var g;for(var d=0,m=l.length;d<m;d++){g=l[d];k.appendChild(this.createElementNSPlus("atom:link",{attributes:{href:g.href,rel:g.rel||null,type:g.type||null,hreflang:g.hreflang||null,title:g.title||null,length:g.length||null}}))}}if(j.published){k.appendChild(this.createElementNSPlus("atom:published",{value:j.published}))}if(j.rights){k.appendChild(this.createElementNSPlus("atom:rights",{value:j.rights}))}if(j.summary||c.description){k.appendChild(this.createElementNSPlus("atom:summary",{value:j.summary||c.description}))}k.appendChild(this.createElementNSPlus("atom:title",{value:j.title||c.title||this.defaultEntryTitle}));if(j.updated){k.appendChild(this.createElementNSPlus("atom:updated",{value:j.updated}))}if(n.geometry){var b=this.createElementNSPlus("georss:where");b.appendChild(this.buildGeometryNode(n.geometry));k.appendChild(b)}return k},initGmlParser:function(){this.gmlParser=new OpenLayers.Format.GML.v3({xy:this.xy,featureNS:"http://example.com#feature",internalProjection:this.internalProjection,externalProjection:this.externalProjection})},buildGeometryNode:function(b){if(!this.gmlParser){this.initGmlParser()}var a=this.gmlParser.writeNode("feature:_geometry",b);return a.firstChild},buildPersonConstructNode:function(b,f){var d=["uri","email"];var a=this.createElementNSPlus("atom:"+b);a.appendChild(this.createElementNSPlus("atom:name",{value:f.name}));for(var c=0,e=d.length;c<e;c++){if(f[d[c]]){a.appendChild(this.createElementNSPlus("atom:"+d[c],{value:f[d[c]]}))}}return a},getFirstChildValue:function(d,b,c,f){var e;var a=this.getElementsByTagNameNS(d,b,c);if(a&&a.length>0){e=this.getChildValue(a[0],f)}else{e=f}return e},parseFeature:function(d){var m={};var n=null;var a=null;var k=null;var b=this.namespaces.atom;this.parsePersonConstructs(d,"author",m);a=this.getElementsByTagNameNS(d,b,"category");if(a.length>0){m.categories=[]}for(var g=0,o=a.length;g<o;g++){n={};n.term=a[g].getAttribute("term");k=a[g].getAttribute("scheme");if(k){n.scheme=k}k=a[g].getAttribute("label");if(k){n.label=k}m.categories.push(n)}a=this.getElementsByTagNameNS(d,b,"content");if(a.length>0){n={};k=a[0].getAttribute("type");if(k){n.type=k}k=a[0].getAttribute("src");if(k){n.src=k}else{if(n.type=="text"||n.type=="html"||n.type==null){n.value=this.getFirstChildValue(d,b,"content",null)}else{if(n.type=="xhtml"||n.type.match(/(\+|\/)xml$/)){n.value=this.getChildEl(a[0])}else{n.value=this.getFirstChildValue(d,b,"content",null)}}m.content=n}}this.parsePersonConstructs(d,"contributor",m);m.id=this.getFirstChildValue(d,b,"id",null);a=this.getElementsByTagNameNS(d,b,"link");if(a.length>0){m.links=new Array(a.length)}var c=["rel","type","hreflang","title","length"];for(var g=0,o=a.length;g<o;g++){n={};n.href=a[g].getAttribute("href");for(var e=0,h=c.length;e<h;e++){k=a[g].getAttribute(c[e]);if(k){n[c[e]]=k}}m.links[g]=n}n=this.getFirstChildValue(d,b,"published",null);if(n){m.published=n}n=this.getFirstChildValue(d,b,"rights",null);if(n){m.rights=n}n=this.getFirstChildValue(d,b,"summary",null);if(n){m.summary=n}m.title=this.getFirstChildValue(d,b,"title",null);m.updated=this.getFirstChildValue(d,b,"updated",null);var f={title:m.title,description:m.summary,atom:m};var l=this.parseLocations(d)[0];var p=new OpenLayers.Feature.Vector(l,f);p.fid=m.id;return p},parseFeatures:function(e){var d=[];var a=this.getElementsByTagNameNS(e,this.namespaces.atom,"entry");if(a.length==0){a=[e]}for(var b=0,c=a.length;b<c;b++){d.push(this.parseFeature(a[b]))}return d},parseLocations:function(c){var a=this.namespaces.georss;var k={components:[]};var f=this.getElementsByTagNameNS(c,a,"where");if(f&&f.length>0){if(!this.gmlParser){this.initGmlParser()}for(var e=0,q=f.length;e<q;e++){this.gmlParser.readChildNodes(f[e],k)}}var h=k.components;var n=this.getElementsByTagNameNS(c,a,"point");if(n&&n.length>0){for(var e=0,q=n.length;e<q;e++){var s=OpenLayers.String.trim(n[e].firstChild.nodeValue).split(/\s+/);if(s.length!=2){s=OpenLayers.String.trim(n[e].firstChild.nodeValue).split(/\s*,\s*/)}h.push(new OpenLayers.Geometry.Point(parseFloat(s[1]),parseFloat(s[0])))}}var r=this.getElementsByTagNameNS(c,a,"line");if(r&&r.length>0){var m;var b;var o;for(var e=0,q=r.length;e<q;e++){m=OpenLayers.String.trim(r[e].firstChild.nodeValue).split(/\s+/);o=[];for(var d=0,g=m.length;d<g;d+=2){b=new OpenLayers.Geometry.Point(parseFloat(m[d+1]),parseFloat(m[d]));o.push(b)}h.push(new OpenLayers.Geometry.LineString(o))}}var l=this.getElementsByTagNameNS(c,a,"polygon");if(l&&l.length>0){var m;var b;var o;for(var e=0,q=l.length;e<q;e++){m=OpenLayers.String.trim(l[e].firstChild.nodeValue).split(/\s+/);o=[];for(var d=0,g=m.length;d<g;d+=2){b=new OpenLayers.Geometry.Point(parseFloat(m[d+1]),parseFloat(m[d]));o.push(b)}h.push(new OpenLayers.Geometry.Polygon([new OpenLayers.Geometry.LinearRing(h)]))}}if(this.internalProjection&&this.externalProjection){for(var e=0,q=h.length;e<q;e++){if(h[e]){h[e].transform(this.externalProjection,this.internalProjection)}}}return h},parsePersonConstructs:function(d,a,g){var m=[];var c=this.namespaces.atom;var b=this.getElementsByTagNameNS(d,c,a);var e=["uri","email"];for(var h=0,o=b.length;h<o;h++){var n={};n.name=this.getFirstChildValue(b[h],c,"name",null);for(var f=0,k=e.length;f<k;f++){var l=this.getFirstChildValue(b[h],c,e[f],null);if(l){n[e[f]]=l}}m.push(n)}if(m.length>0){g[a+"s"]=m}},CLASS_NAME:"OpenLayers.Format.Atom"});OpenLayers.Control.KeyboardDefaults=OpenLayers.Class(OpenLayers.Control,{autoActivate:true,slideFactor:75,draw:function(){this.handler=new OpenLayers.Handler.Keyboard(this,{keydown:this.defaultKeyPress})},defaultKeyPress:function(a){switch(a.keyCode){case OpenLayers.Event.KEY_LEFT:this.map.pan(-this.slideFactor,0);break;case OpenLayers.Event.KEY_RIGHT:this.map.pan(this.slideFactor,0);break;case OpenLayers.Event.KEY_UP:this.map.pan(0,-this.slideFactor);break;case OpenLayers.Event.KEY_DOWN:this.map.pan(0,this.slideFactor);break;case 33:var b=this.map.getSize();this.map.pan(0,-0.75*b.h);break;case 34:var b=this.map.getSize();this.map.pan(0,0.75*b.h);break;case 35:var b=this.map.getSize();this.map.pan(0.75*b.w,0);break;case 36:var b=this.map.getSize();this.map.pan(-0.75*b.w,0);break;case 43:case 61:case 187:case 107:this.map.zoomIn();break;case 45:case 109:case 189:case 95:this.map.zoomOut();break}},CLASS_NAME:"OpenLayers.Control.KeyboardDefaults"});